The Acoustic ToolBox includes four acoustic models:

   BELLHOP: A beam/ray trace code

   KRAKEN:  A normal mode code

   SCOOTER: A finite element FFP code

   SPARC:   A time domain FFP code

A common input structure has been used throughout so that only minor
modifications are needed to switch from one program to another.

All the models produce shade files which can be processed
using a common set of plotting routines to plot transmission loss
vs. range or vs. range and depth.  These plotting routines
are contained in the GLOBAL directory.

A few things to know about porting the code:

(1) You can speed things up on an SGI by using the -lfpe switch
to have underflows replaced by zeros. This speeds up the execution
significantly by preventing the propagation of underflows. See
your SGI manuals ...

(2) Fortran compilers differ in whether record lengths
should be declared as bytes or words. To ensure the programs
run, I declare lengths in bytes. If your compiler uses words
as the default, look for a compiler switch to override that so
that your files are not unnecessarily large. (On SGI's that's
-bytereclen).

(3) The RAN random number routine does not exist in all FORTRANs
(used by covar to simulate noise, and krakenc to generate random
restarts for the root finder). To get around this, I've added
the subroutine ran.f (from lapack). You can remove it, if your
Fortran has a handy substitute.

(4) The mathieu.f routines needs to be compiled
with a switch to initialize all variables to zero.
Most compilers have some such switch. On the SGI
machines it's -static.

(5) The Twersky-scatter option is problematic because it calls mathieu.f
and slbessel.f which don't adhere to a rigorous Fortran standard. If you
have problems compiling those routines then don't. Remove all references
in the Makefiles to them and copy twerskfuse.f to twersk.f and your problem
is solved (except that you won't be able to use that scatter option).

(6) The plot routines have all been re-written to produce an
ascii file containing the data that needs to be plotted.
The UNIX scripts that run those routines automatically initiate
a particular graphics package called ACE/gr (which has particular
versions xvgr for Sun's and xmgr for other workstations). It is
available on the web but you'll have to search for it.

(7) If you use Matlab, you'll find a set up m-scripts in at/Matlab
that can also be used for most plotting functions.

(8) time.f is called by all the programs just to produce an
output of the cpu time used. If you don't have an easy way
to get cpu time, just edit time.f to return 0.0.

(9) Some of the programs in this package use direct access
i/o and need to know a record length. UNIX does not maintain
this information as part of the file info so the code writes
that information directly into the file. Then the file
is opened twice: first with a dummy record length to read
the actual record length from the file. Then it is re-opened
with the correct record length. On other machines that do know
the correct record length, that first open should be removed.
The RECL specifier should then also be removed from the
second open.

(10) Porting to Fortran 90:
In Fortran 77, DIMAG is used to take the imaginary part of
a double precision variable. In f90 DIMAG does not exists
and the generic function AIMAG is the replacement.
AIMAG exists in f77 but is a specific function requiring a
single-precision argument. So, you will have to change
3 instances of DIMAG to AIMAG. You'll see where they are
because they'll generate error messages.



*************************************************

Warranty: The sale of this product is `as is' and
without any express warranties. Liability, if any, is limited to refund
of purchase price only upon return of product and package to manufacturer.

Pound ratings are subject to variable conditions and are for comparison
only.

Do not eat.

12/97 Minor changes have been made to the package for improved
      f77 to f90 portability. Fortran 90 seems to
      treat parameters differently in terms of precision so
      some of those changes are important for the most accurate
      results.

The programs in this directory are used to do broadband
calculations.

In most cases the starting point is to produce
a *.fft file containing the spectrum of the
waveform. The *.fft file has a simple format
consisting of frequency-amplitude pairs.
The amplitude is a complex number.

`makets'
synthesizes such a file.
It requires an input file *.inp containing parameters
which define certain canned wavelets.

'makespec'
is a short fortran program that produces a uniform
spectrum. It provides an alternative to `makets' when
the spectrum is simple.

`stack'
reads a file *.tim indicating the times
when results are needed and whether a
depth-stack, range-stack or snapshot result is
desired. It then reads the *.fft file and uses
it to weight the corresponding *.shd files to produce
the results. Each *.shd file is presumed to contain
the complex pressure field for a frequency in the
*.fft file.

Data from the first range contained in the SHD files
is used for depth stacks.

Similarly, data from the first depth contained in the
SHD files is used for range stacks.

UPDATES:

 4/20/92  The linear system solver (FACTOR/BACSUB) used by
          SCOOTER was not initializing one of the variables
          to 0.  Causing sporadic NaN/Infinity problems when
          using IEEE arithmetic.  A similar problem occured
          with the axis length specification for plots in
          FIELDS.

 9/25/92  The option of putting an acousto-elastic halfspace
          on the top was not working properly. (It took the
          density from the lower halfspace.)

10/28/92  FIELDS produced erroneous results when the
          number of wavenumber points exceeded the
          dimension limit of 10000.  A test has been
          added to flag this error and the dimension
          has been increased to 50000.

12/ 7/92  SPARC modified so that if the parameters are
          such that the time integration is fully explicit
          (ALPHA=BETA=0.0) then the linear solver is
          bypassed.  This gives some improvement in
          performance.

 1/18/93  FIELDS was writing an extra vector at zero range
          in cases where subsampling was required.  This caused
          PLOTSLICE to have problems plotting TL.

 2/17/93  Error in PLOTTS fixed.  The FLOW and FHIGH numbers were
          always used for bandpass filtering even when the
          option 'N' (no filtering) was selected.  If the
          bandpass filter were wider than the signal bandwidth
          you effectively disabled filtering.  If, however,
          you had a narrow bandpass filter then it was always
          applied to the signal and might have produced confusing
          results.

 3/16/93  Error in SOURCE fixed.  When the time-reversal
          option was used, SOURCE reversed the time coordinates
          as many times as there were sources.  As a result,
          the time series was reversed but the times associated
          with the data were not.

 6/10/93  Error in FIELDS fixed. Occasionally it would
          reference an array index that was one point
          beyond the last calculated value. This had
          no significant effect on the TL field but
          caused a floating point exception on machines
          that trap references to an undefined value.

          Error in SCOOTER fixed. SCOOTER was extracting
          the density at the source incorrectly: it took
          a density at a nearby point. When the nearby
          point was outside the grid, an undefined
          density was returned.

12/29/93  FIELDS modified so that the specified ranges of
          receivers are not changed.

 3/17/95  The plot option in FIELDS has been removed to make
          SCOOTER structurally similar to KRAKEN. Similarly,
          the input file to fields should now be called fields.flp
          rather than fields.plp.

 6/10/95  In SPARC the option for producing a time-series on a
          horizontal array was not working properly. The array
          a variable RTSTRR was being loaded instead of RTSRR.

 1/98 FIELDS automatically increases the minimum range, RMIN, to
      ensure that we don't try to calculate a field value right on
      the source. Previously RMIN was bumped to 1 m which caused
      problems for ultrasonic applications. Now it is bumped
      to RMAX / 100000. 

UPDATES:

 1/30/86  New versions of KRAKEN and KRAKENC correct a bug in
          eigenvector computations which probably did not affect
          you unless you saw the error message "failure to
          converge in SINVIT" 

 2/18/86  Bug in KRAKENC corrected which affected eigenvector
          accuracy for strongly attenuated modes.  When
          significant, this error would have been flagged as
          "SINVIT FAILED TO CONVERGE". The field computation has
          been made a common subroutine called EVAL for use by
          PLOTTLR, PLOTTLD, FIELD, ... to assure consistency and
          simplify any changes to the field computation. The
          modified version stores the field matrix in a fashion
          which allows for up to 50000 field points essentially
          independent of whether the matrix is 50000x1 or
          1x50000, etc. With EVAL a common routine, the X,R or S
          parameter which indicates cartesian, cylindrical or
          scaled cylindrical field computations has been
          incorporated in all the field computing routines. 

 3/12/86  TILT and DISPLACE merged into the FIELD program so that
          one routine is used for vertical, tilted or displaced
          arrays. Also, a blank line for last record in '.RED',
          '.SOD' and '.RER' files is no longer needed. 

 4/8/86   CLOW parameter added for compatibility with SCOOTER FFP
          program. At some later date KRAKEN will be modified to
          allow the mode calculation to be restricted to the
          [CLOW,CHIGH] phase speed interval, but for now CLOW is
          a dummy parameter. 

 4/23/86  KRAKEN and KRAKENC modified to allow one or more
          elastic media above the water column.  Thus an elastic
          ice model may be used. Additionally 'KRAKEN- ' or
          'KRAKENC- ' is now inserted before the user supplied
          title.  With several programs now producing shade files
          it is desireable to have this indicator on plotted
          output. 

 5/22/86  FIELD and PLOTTLR modified to treat range dependent
          environments by adiabatic mode theory. 

 6/1/86   Surface scatter options modified to accomodate Twersky
          ice scatter as an amplitude only effect.  Hard surface
          backing option removed since it seemed more a hazard
          (of accidental use) than a benefit.  Some unit numbers
          changed: most input is now done from unit 5 rather than
          1 which makes it simpler to run the program
          interactively since unit=5 is the default input unit;
          the unit numbers for '.VEC' and '.WNO' have been
          changed so that with adiabatic mode runs a series of
          such files can be allocated to sequential unit numbers. 

 6/15/86  FIELD3D module added which generalizes adiabatic mode
          theory to 3-dimensional problems. 

 11/1/86  Environmental file closed promptly after data is read for
          user convenience. START module added to provide a start-up
          field for PE programs. 

 11/30/86 Spline option fixed.  This had apparently not been used
          by anybody and was not properly updated when the input
          file format was changed.  Also, added check to
          gracefully abort the program when the problem is too
          big for dimensioned storage. 

 1/8/87   Slight changes in format statements on input to avoid
          the problem of neglected decimal points causing
          disasters. 

 2/13/87  KRAKENC modified to gracefully handle problems where
          the user requests more modes than KRAKENC is
          dimensioned to handle. Both KRAKEN and KRAKENC modified
          to narrow a user specified phase speed interval which
          is unnecessarily large. (Eliminates the problem of a
          user specifying a CLOW which is so low as to cause a
          failure to converge in the root finder.) Dimensions
          increased to allow for up to 1000 modes. 

 3/20/87  All modules modified to use a single mode file instead
          of separate files for eigenvalues and eigenvectors. 
          Thus '.WNO' and '.VEC' are now '.MOD'.  This simplifies
          the command files, especially for 3D runs which employ
          numerous mode files. Adiabatic versions of PLOTTLR and
          FIELD have been made the only versions.  Thus PLOTTLRAD
          replaces PLOTTLR.  This is a step in the direction of
          reducing the proliferation of new modules with minor
          variations over existing modules. SCOOTER FFP program
          integrated into the package. 

 6/1/87   Options for different kinds of boundary conditions
          added. Allows free, rigid and homogeneous half-spaces
          at top and bottom. Environmental file format changed
          slightly to accomodate same. 

 8/10/87  Bug in section which scales to avoid under/over flow
          corrected. Caused an overflow error to occur in the
          special case where a mode became exactly 0.0 at one of
          the finite difference points. 

 2/1/88   Errors in line-source represention corrected. The line
          source is of virtually no relevance in underwater
          acoustics so this probably doesn't affect you.  Coupled
          mode solution implemented but density variations and
          half-space contributions are ignored. 

 6/29/88  Inefficiencies in mode reading removed. Source,
          receiver depth files eliminated.  ( Use of the /
          command to terminate records combined with an
          interpolation routine made the '.SOD' and '.RED' files
          an unnecessary incumberance. ) KRAKEN input structure
          modified so that all lines are now read in using list
          directed I/O. 

 8/1/88   Some problems in tabulated bottom refl. coeff.
          corrected. Also corrections to FIELDS which made it
          necessary to use more k-space points than it should
          have needed. Interfacial scatter finally implemented
          correctly. 

 10/5/88  Modified to allow up to 301 SSP pts.  Changes to
          internal structures to do this efficiently.   

 6/10/89  Addition of source/receiver depth line.  This allows
          the user to specify the depths at which modes are
          written to the mode file.  Changes to various plotting
          routines to allow the user to specify the axis lengths. 
          Change to SSP input structure: in the old version the
          user had to provide a count of the number of SSP points
          in each layer.  In the new version you simply provide
          the depth at the bottom of each layer.  The program
          keeps reading SSP points till it reaches that depth.

 9/19/89  Several structural changes to the codes have been made.
          A subroutine READIN replaces the previous INCLUDE for
          reading the environmental file and a routine BCIMP has
          been written which combines TOPIMP and BOTIMP routines
          for the boundary conditions.  BCIMP has been written so
          that there are no differences between the options
          available for top and bottom boundaries. (Actually,
          that's not entirely true since the internal reflection
          coefficient option is still only implemented for the
          lower boundary.)  The interfacial roughness calculation
          has been separated from the mode normalization code to
          improve readability. 

 10/30/89 The option 'M' for attenuation in dB/m has been
          implemented. This is a one-line formula in the routine
          CRCI which, despite appearing in earlier documentation,
          seems to have gone unimplemented till now.

 11/20/89 Changes in FIELD3D calculations.  In the original
          version the receiver was located at the origin and the
          source moved out in range.  The present version is
          consistent with the other field calculation routines in
          that the source is fixed at the origin and the
          receivers move out in range.  In addition, the option
          for multiple source depths is now implemented.

 12/11/89 KRAKEN/KRAKENC modified to produce a MODFIL even when
          there are no propagating modes.  This eliminates the
          need to introduce DUMMY nodes in a FIELD3D run.

 2/2/90   Changes to mode file format. The new
          format is much more compact for problems with lots of
          modes. In addition, it includes the density and
          half-space properties so that the field can be
          calculated in a half-space.  Also FIELD now allows a
          title to be specified.

          Error in FIELD removed. In range-dependent calculations
          the number of modes, M, may sometimes be reduced in
          propagating out in range.  The error in FIELD was to
          not reset M for subsequent sources, possibly causing
          erroneous results.  This error would only have affected
          range-dependent problems with multiple sources.

          Changes to KRAKEN and KRAKENC to reduce storage.

          Small change in adiabatic calculations (routines EVALAD
          and EVAL3D.  The denominator in the adiabatic
          expression involves sqrt(k(r)r).  In the previous
          version (as in certain other modal codes the mean value
          of k(r) was used instead.  In practice, you'll be
          hard pressed to spot the difference in TL calculations.

 3/30/90  Errors in PROFIL routine corrected.  The LOC variable
          was not being saved between calls and there was also an
          illegal reference to LOC(0).  On a VAX the former
          problem is a non-issue because VMS Fortran
          automatically saves variables.  The latter is only a
          problem when LOC(0) accesses a non-zero value or a
          protected memory location.

          Also, if you ever used the Thorp attenuation option you
          know that it wasn't working right.  A missing factor
          was causing attenuation values about 10,000 times too
          large!

 6/20/90  Bug in FIELD3D corrected which caused errors when the
          step size between points where TL was calculated was
          large enough that there was not at least one TL point
          in each triangle. An analogous problem was also
          corrected in FIELD for adiabatic calculations.  PDQ
          option added to FIELD3D for quicker but less accurate
          3D calculations.  Finally, FIELD3D has been modified to
          allow radials to pass directly over nodes of the
          triangulation.  Similarly, the source can now lie
          anywhere in the plane (on a node or even outside the
          triangles).

 12/10/90 Extensions to coupled mode routine.  Density and halfspace
          contributions are now included.  This has necessitated
          some modifications to the MODFIL format.

          A program BOUNCE has been created to compute a reflection
          coefficient for a multilayered domain.  This reflection
          coefficient can be passed to KRAKENC to provide a boundary
          condition or plotted using the new routine PLOTRTH.

          NEW IMPROVED KRAKENC! Up to 3 times slower than the old
          version!  I've added an option which causes KRAKENC to
          perform a very careful root search.  In certain elastic
          problems the old root finder was found to miss modes.
          Unfortunately making the root finder more robust entails
          slowing the code down.  As a compromise, I've introduced
          the slow/robust root-finder as an option.  For more
          information see TOPOPT as described in KRAKEN.HLP.

  1/26/91 The XL and XR arrays were erroneously dimensioned one
          element too small.  This caused an error in the special
          case when the number of modes was exactly equal
          to MAXM, the maximum number of modes KRAKEN is dimensioned
          to calculate.

          Modifications to the adiabatic mode calculation routine
          EVALAD.  With a very coarse distribution of receivers in
          range the results differed from the convergent answer
          obtained with say 500 range points.  Basically, there was
          some sloppy handling of the phase integral in range
          which assumed you had a dense sampling of points in
          range.  (Practically the inaccuracy introduced was
          probably less than that due to the adiabatic
          approximation itself.)


  5/15/91 Error corrected in READIN.  The vectors CP and CS were
          dimensioned to a length of one element.  When the analytic
          profile option is used this is not sufficient.

  5/20/92 Common blocks reshuffled to avoid alignment errors on
          various UNIX systems during compilation.  Double opens
          implemented to get record lengths from files on UNIX
          systems.  A missing EXTERNAL statement has been added to
          the SLATECBESSEL package.  On SGI systems this was flagged
          at compilation time and subsequently led to erratic
          results.

          An error has been corrected in KRAKEN which
          caused minor discrepancies with the KRAKENC result.
          KRAKEN was taking the single precision part of the SSP
          rather than the full double precision available.  Since
          the models write the mode files in single precision, this
          error only shows up on the print-out where the full precision
          is shown.  Also, it did not affect results on VAX machines.

          An error in the 'Q' type attenuation has been fixed.  The
          error caused any attenuation to be ignored when using this
          option.

 9/25/92  The option of putting an acousto-elastic halfspace
          on the top was not working properly. (It took the
          density from the lower halfspace.)

 11/9/92  Error corrected in coupled-mode calculations (subroutine
          EVALCM).  The program multiplied the profile ranges
          by a factor of 1000 to convert km to m every time it
          was called. The error was that the scaling was repeated
          for sources after the first.  This had the effect of
          stretching the environment so much that it was effectively
          range-independent for subsequent sources.

 1/20/93  Form feeds removed.  TYPE and ACCEPT statements removed.
          Routine COVAR written to generate a covariance matrix
          for matched-field processing with colored or white
          noise. BART and CAPON implemented to compute
          ambiguity surfaces.  A few other minor changes were
          made to accomodate the more sensitive AIX (IBM) and
          AbSoft (NeXT) compilers.

 6/ 5/93  KRAKEN and KRAKENC have been modified to discard
          any eigenvalue returned by the root finder if
          an error occurred during the search. This fixes
          a problem that occurred in some elastic cases
          where extra modes were returned. Also, the e(i pi/4)
          factor has been added to the pressure calculations.
          Since this phase does not affect TL or standard
          beamformers, it had never been included.

 8/20/93  KRAKENC has been modified to zero out the imaginary
          part of an eigenvalue if it's positive.  A positive
          imaginary part may occur when the true root is just
          below the real axis. For such roots the root-finder
          can give a very accurate approximation to the root
          that just happens to be on the positive side of
          the axis.

          A check has been added in COVAR for zero eigenvalues.
          The colored noise model will always fail in such
          cases since without attenuation the noise sheet
          leads to infinite intensities.

12/26/93  Unix version was not creating empty mode files
          correctly for the case when no modes were present.

 4/ 9/94  Adiabatic calculations were showing excessive
          round-off error when many (>1000) receiver
          ranges were used.  The offending variable has
          been converted to double precision in EVALAD.F and
          EVALD3D.F

          KRAKENC was not setting the value for the
          last calculated mode when it aborted the
          run because the mesh was too coarse.

          All programs have been set up to open Fortran files
          by name rather than unit number. This gets around
          the problem that different vendors use different
          default names for files causing the scripts to
          need to be modified for each machine.

 6/23/94  Bug fix in KRAKEN: a variable was not properly initialized
          in the special case where a mode cutoff on the 3rd
          or subsequent meshes. To fix it, FUNCT has been modified
          to return 0 and zsecx.f has been modified to quit immediately
          when f(x) = 0 (identically).

 3/13/95  Various routines for calculating the acoustic pressure
          were missing a factor of i (eval.f, eval3d.f, evalcm.f, ...
          This has no effect on TL but leads to a Hilbert transform
          in time-series calculations.

 3/15/96  The logical record length used in opening the mode files
          was too small in the case of many layers and few receivers.

 4/19/96  getmod.f was testing the proximity of the receiver depth
          to the tabulation grid using points above and below the
          receiver. This is not valid when there is only one tabulation
          point ... The code has been modified to bypass linear
          interpolation for this case.

 5/27/96  An option has been added to calculate the finite difference
          grid (NMESH) automatically.

10/29/96  For adiabatic field calculations, erroneous results are
          obtained if the first profile does not start at zero range.
          A test has been added to field.f to enforce this.

10/14/97  FIELD3D failed without explanation in a case where there were
          more modes than allocated storage (MAXM). A test has been added
          to flag this error in all routines.

11/30/97  MODBIN/MODASC have been modified so that the ascii file format
          is easier to read into matlab programs. LAPACK implementation
          of RAN() included to aid portability. Bug in BOUNCE ...
          it was accessing (but not using) LOC( 0 ) in calculating the
          reflection coefficient for a stack of elastic layers with no
          acoustic layer.

 1/98 PLOTRTH has been modified to include new display options.

12/94
Added option for reading tabulated reflection coefficient.

 1/95
Added eigenray option which produces a ray plot but only
for those rays which connect the source and receiver(s).

 3/95
Sign changed on pressure field to make BELLHOP consistent
with the other models.

 9/97
Option to propagate time series directly in BELLHOP has
been removed and replaced with the option of writing
a arrivals file containing delays and amplitudes for each
arrival. Phase changes have been pulled from the delay
vector into a complex amplitude. Matlab script stackarr.m
written to stack up the arrivals taking into account all
phase changes.

11/97
The ray file is now written in ASCII rather than unformatted
binary. This makes it easier to for external programs to read ...

12/97
The option of including bottom bathymetry has been added.

The various programs in this directory perform operations on 'SHD' files
(complex pressure files) in the NRL format.  Such files are generated by
a number of programs including KRAKEN, BELLHOP, FSTFLD, SCOOTER and SPARC. 

You will find,

PLOTFIELD produces planar slices of the transmission loss surfaces
          (exists in versions for UNIRAS and DISSPLA
          plotting packages.)

PLOTSLICE extracts a linear slices from one or more 'SHD' files and
          overlays the results. 
      
POD       converts a 'SHD' file to a probability-of-detection file.

RADIUS    converts a 'POD' file to a radius of detection.

TOASC     converts a binary '.SHD' file to an ASCII format '.SHD' file
TOBIN     reverse of TOASC

TOSAC     converts NRL format '.SHD' file to SACLANT format.
TONRL     converts SACLANT format         to NRL format '.SHD' file.

BART      computes a Bartlett ambiguity surface
CAPON     computes a Capon    ambiguity surface

SWITCHSR  switches the sources and receivers in a 'SHD' file.


UPDATES:


 3/20/93  Error in transit.f fixed.  The code assumed
          variables would be saved from one call to
          the next.  This is true on VAX machines but
          not guaranteed on other machines.  This
          affects POD and RADIUS since they call transit.f

 8/ 1/93  An option has been added to PLOTFIELD for the
          user to specify titles for the axes and plot.
          PLOTSLICE has been modified to include the
          names of the shade files in the plp file.

 1/18/94  An error was fixed in CHOLESKIC that caused
          the Capon estimator program (CAPON) to
          give wrong results. In effect, the covariance
          matrix was being diagonally loaded. This
          increased the background level of the ambiguity
          surface.

      PROGRAM COVAR

C     Takes replica shade files and computes synthesized
C     data vectors with Gaussian random noise added
C     Averages data vector to from covariance matrix

C     Data vectors are produced for the phone positions in
C     the shade file (not those of the mode file).

      INTEGER PRTFIL, SHDFIL, DATFIL, COVFIL

      PARAMETER ( INPFIL = 5, PRTFIL = 6, SHDFIL = 20, DATFIL = 21,
     &   COVFIL = 22, MAXM = 1500,
     &   MAXNSD = 4094, MAXNRD = 4094, MAXNR = 4094,
     &   MXPHONES = 101, PI = 3.141592 )

      INTEGER   ISEED( 4 )
      REAL      R( MAXNR ), SD( MAXNSD ), RD( MAXNRD ),
     &          COVISO( MXPHONES, MXPHONES )
      COMPLEX   P( MAXNR ), D( MAXNRD ), DNOISY( MAXNRD ),
     &          PHIS( MAXM ), PHIR( MAXM, MXPHONES ), CK( MAXM ),
     &          NOISE( MAXNRD ), COV( MXPHONES, MXPHONES )
      CHARACTER TITLE*80, TITLE2*80, PLTTYP*10, NOISETYPE*1

      SAVE ISEED
      DATA ISEED /2301, 4562, 3219, 1823/

C     *** Read data file header ***

      CALL RDHEAD( SHDFIL, ' ', MAXNR, MAXNSD, MAXNRD,
     &   FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &   SD, NSD, RD, NRD, TITLE )

      OPEN ( FILE = 'DATFIL', UNIT = DATFIL, STATUS = 'NEW' )
      OPEN ( FILE = 'COVFIL', UNIT = COVFIL, STATUS = 'NEW' )

C     Read user specification for source position and compute indices

      READ( INPFIL, * ) TITLE
      READ( INPFIL, * ) SDEPTH, SRANGE
      READ( INPFIL, * ) NOISETYPE, SNRDB
      READ( INPFIL, * ) NTIMES, ISEED( 4 )
C     NTIMES = 30000  ! **********************************
C     SNRDB  = 200.0   ! **********************************
      SRANGE = 1000.0 * SRANGE          ! Convert km to meters
      SNR    = 10.0 ** ( SNRDB / 10.0 )

C     *** Calculate source depth index ***

      ISDEP = NEIGH( SDEPTH, SD, NSD )

C     --- Check to see if within tolerance

      IF ( FREQ .EQ. 0.0 ) THEN
         TOL = 0.001
      ELSE
         TOL = 1500.0 / ( 6.0 * FREQ )  ! one wavelength
      END IF

      IF ( ABS( SD( ISDEP ) - SDEPTH ) .GT. TOL ) THEN
         WRITE( PRTFIL, * ) 'Sources exist at the following depths:'
         WRITE( PRTFIL, * ) ( SD( I ), I = 1, NSD )
         CALL ERROUT( PRTFIL, 'F', 'COVAR',
     &                'No source at specified depth' )
      END IF

C     *** Calculate source range index ***

      ISRAN = NEIGH( SRANGE, R, NR )

C     --- Check to see if within tolerance

      IF ( ABS( R( ISRAN ) - SRANGE ) .GT. TOL ) THEN
         WRITE( PRTFIL, * ) 'Sources exist at the following ranges:'
         WRITE( PRTFIL, * ) ( R( IR ), IR = 1, NR )
         CALL ERROUT( PRTFIL, 'F', 'COVAR',
     &                'No source at specified range' )
      END IF

C     --- extract data vector

      WRITE( PRTFIL, * ) 'Data vector being extracted for SDEP, SRAN',
     &   SD( ISDEP), R( ISRAN )

      IREC = ( ISDEP - 1 ) * NRD + 6
      DO IRD = 1, NRD
         IREC = IREC + 1
         READ ( SHDFIL, REC = IREC ) ( P( IR ), IR = 1, NR )
         D( IRD ) = P( ISRAN )
      END DO

C     --- Normalize data vector so that array power = 1

      SUM = 0.0
      DO IRD = 1, NRD
         SUM = SUM + CONJG( D( IRD ) ) * D( IRD )
      END DO

      DO IRD = 1, NRD
         D( IRD ) = D( IRD ) / SQRT( SUM )
      END DO

      PHNPOWER = 1.0 / NRD

C     --- Zero out covariance matrix

      DO I = 1, NRD
         NOISE( IRD ) = 0.0
         DO J = 1, NRD
            COV( I, J ) = 0.0
         END DO
      END DO

C     *** If making colored noise, need modal data ***

      IF ( NOISETYPE .EQ. 'C' ) THEN
         IPROF   = 1
         SD( 1 ) = 1.0       ! noise sources are at 1 m
         NSD     = 1
      
         CALL GETMOD( IPROF, ' ', MAXM, SD, NSD, 'N',
     &      CK, PHIS, M, FREQ, TITLE2 )
         CALL GETMOD( IPROF, ' ', MAXM, RD, NRD, 'N',
     &      CK, PHIR, M, FREQ, TITLE2 )

C        --- Construct PHI and POWER
         POWER = 0.0
         DO MODE = 1, M
            DO IRD = 1, NRD
               IF ( AIMAG( CK( MODE ) ) .GE. 0.0 ) THEN
                  CALL ERROUT( PRTFIL, 'F', 'COVAR',
     &       'Modes present with no loss: Noise field is infinite ' )
               END IF

               PHIR( MODE, IRD ) = PHIS( MODE ) * PHIR( MODE, IRD ) /
     &            SQRT( -REAL( CK( MODE ) ) * AIMAG( CK( MODE ) ) )
               POWER = POWER +
     &            PHIR( MODE, IRD ) * CONJG( PHIR( MODE, IRD ) )
            END DO
         END DO
      END IF

C     --- header for data vector file

      WRITE( DATFIL, * ) '''', TITLE(1:60), ''''
      WRITE( DATFIL, * ) FREQ
      WRITE( DATFIL, * ) NTIMES, NRD

      DO IRD = 1, NRD
         WRITE( DATFIL, * ) RD( IRD )
      END DO

C     *** Main loop: generate realizations of noise field ***

      AVGSIGNAL = 0.0
      AVGNOISE  = 0.0

      SIGMA = SQRT( PHNPOWER / SNR )   ! Noise level on a phone

      DO ITIME = 1, NTIMES

         IF ( NOISETYPE .EQ. 'W' ) THEN
            CALL WHITE( ISEED, SIGMA, NOISE, NRD )
         ELSE IF ( NOISETYPE .EQ. 'C' ) THEN
            CALL COLOR( ISEED, PHIR, M, NRD, SIGMA, POWER, NOISE )
         ELSE
            STOP 'Unknown noise type'
         END IF

         DO IRD = 1, NRD    ! loop over receiver depths

            DNOISY( IRD ) = D( IRD ) + NOISE( IRD )

            AVGSIGNAL = AVGSIGNAL + ABS(     D( IRD ) ) ** 2
            AVGNOISE  = AVGNOISE  + ABS( NOISE( IRD ) ) ** 2
         END DO             ! next receiver depth

C        --- write noise vector to DATFIL
C         WRITE( DATFIL, 1000 )
C     &      ( ITIME, IRD, DNOISY( IRD ) , IRD = 1, NRD )
 1000    FORMAT( I3, I3, ' (', F11.7, ',', F11.7, ' )' )

C        --- Compute cross-sensor correlation matrix R

         DO I = 1, NRD
            DO J = 1, NRD
               COV( I, J ) = COV( I, J ) +
     &              DNOISY( I ) * CONJG( DNOISY( J ) )
            END DO
          END DO

      END DO

      AVGSIGNAL = AVGSIGNAL / ( NTIMES * NRD )
      AVGNOISE  = AVGNOISE  / ( NTIMES * NRD )

      WRITE( PRTFIL, * ) 'AVGSIGNAL = ', AVGSIGNAL
      WRITE( PRTFIL, * ) 'AVGNOISE  = ', AVGNOISE

      WRITE( PRTFIL, * ) 'Average signal (dB) = ',
     &   10.0 * LOG10( AVGSIGNAL )
      WRITE( PRTFIL, * ) 'Average noise  (dB) = ',
     &   10.0 * LOG10( AVGNOISE  )
      WRITE( PRTFIL, * ) 'Average SNR    (dB) = ',
     &   10.0 * LOG10( AVGSIGNAL / AVGNOISE )

C     *** Analytic formula for covariance matrix in isovelocity ocean
      DO I = 1, NRD
         DO J = 1, NRD
            COVISO( I, J ) = 0.0
            DEPTH = 100.0
            DO MODE = 1, M
               GAMMA = ( MODE - .5 ) * PI / DEPTH
               COVISO( I, J ) = COVISO( I, J ) +
     &             SIN( GAMMA * SD( 1 ) ) ** 2 *
     &             SIN( GAMMA * RD( I ) ) * SIN( GAMMA * RD( J ) )
            END DO
         END DO
      END DO

C     *** Write normalized cross-sensor correlation matrix column-wise

      WRITE( COVFIL, * ) '''', TITLE(1:60), ''''
      WRITE( COVFIL, * ) FREQ
      WRITE( COVFIL, * ) NRD
      DO IRD = 1, NRD
         WRITE( COVFIL, * ) RD( IRD )
      END DO

      DO I = 1, NRD
         DO J = 1, NRD
            COV( I, J ) = NRD * COV( I,J ) /
     &              ( ( 1.0 + SIGMA**2 ) * NTIMES )
            WRITE( COVFIL, 1000 ) I, J, COV( I, J )
C     &            ABS( COVISO( I, J ) * COV( 1, 1 ) / COVISO( 1, 1 ) )
         END DO
      END DO

      STOP
      END

C----------------------------------------------------------------------C

      SUBROUTINE WHITE( ISEED, SIGMA, NOISE, NRD )

C     Generates Gaussian random white noise

      COMPLEX CI
      PARAMETER ( CI = (0.0, 1.0), PI = 3.1415926 )

      INTEGER   ISEED( 4 )
      COMPLEX   NOISE( * )

      DO IRD = 1, NRD
         X = RAN( ISEED ) + 0.000001
         Y = RAN( ISEED )

         NOISE( IRD ) = SIGMA *
     &      SQRT( -LOG( X ) ) * EXP( CI * 2.0 * PI * Y )

      END DO

C     --- Note power = NRD * SIGMA ** 2

      RETURN
      END

C----------------------------------------------------------------------C

      SUBROUTINE COLOR( ISEED, PHI, M, NRD, SIGMA, POWER, NOISE )

C     Generates colored noise vector

      COMPLEX CI
      PARAMETER ( MAXM = 1500, CI = (0.0, 1.0), PI = 3.1415926 )

      INTEGER   ISEED( 4 )
      COMPLEX PHI( MAXM, * ), NOISE( * ), COEF

C     *** Zero out noise vector ***

      DO IRD = 1, NRD
         NOISE( IRD ) = 0.0
      END DO

C     --- loop over modes
      DO MODE = 1, M

C        --- compute the random coefficient
         X = RAN( ISEED ) + 0.000001
         Y = RAN( ISEED )
         COEF = SQRT( -LOG( X ) ) * EXP( CI * 2.0 * PI * Y )

C        --- loop over receivers
         DO IRD = 1, NRD
            NOISE( IRD ) = NOISE( IRD ) + COEF * PHI( MODE, IRD)
         END DO
      END DO

C     *** Normalize so that power = NRD * SIGMA**2

      DO IRD = 1, NRD
         NOISE( IRD ) = SIGMA * NOISE( IRD ) * SQRT( NRD / POWER )
      END DO

      RETURN
      END

      PROGRAM INTERP

C     Interpolates two produce the intermediate
C     profiles for slope.

      PARAMETER ( NR = 51, RSTART =   0.0, REND = 4.0,
     &                     DSTART = 200.0, DEND = 0.0 )

      DELR = ( REND - RSTART ) / ( NR - 1 )
      DELD = ( DEND - DSTART ) / ( NR - 1 )

      DO IR = 1, NR

         R    = RSTART + ( IR - 1 ) * DELR
         D    = DSTART + ( IR - 1 ) * DELD

         WRITE( *, * ) 'sedslope', IR, MAX( 1.0, D )

      END DO

      STOP
      END

      program makespec

c     produce a uniform spectrum over 280 - 380 Hz

      complex spec

      nfreq = 101
      fmin  = 280.0
      fmax  = 380.0
      deltaf = ( fmax - fmin ) / ( nfreq - 1 )

      do i = 1, nfreq
         freq = fmin + ( i - 1 ) * deltaf
         spec = 1.0
         write( *, * ) freq, spec
      end do

      stop
      end

      PROGRAM BELLHOP

C     Beam tracing in cylindrical coordinates
C     Michael B. Porter and Homer P. Bucker

      INCLUDE 'COMBM.FOR'

      PARAMETER ( MXNSD = 51, MXNRZ = 201000, MXNBEAMS = 30001 )

C     The following can be changed to reduce storage:
C
C     MXNSD   max # of Source Depths
C     MXNRD            range-depths coords. for TL calculation
C                      (also used to limit number of arrivals)
C     MXNBEAMS         beams

      INTEGER     NARR( MXNRZ )
      REAL      DELARR( MXNRZ )
      COMPLEX     AARR( MXNRZ )

      REAL      SD( MXNSD ), ALPHA( MXNBEAMS )
      REAL*8    TEND
      COMPLEX   U( MXNRZ ), EPS, PICKEPS
      CHARACTER TITLE*80, BOTOPT*2, RUNTYP*2, BEAMTYP*2
      EQUIVALENCE ( U, AARR )

C     *** Begin by reading in control data ***

      CALL CLTIME   ! clear the time counter

      CALL READIN( TITLE, FREQ, ALPHA, NBEAMS, MXNBEAMS, ISINGL,
     &   NIMAGE, IBWIN, DELTAS, MXN, ZBOX, RBOX, EPMULT, RLOOP,
     &   SD, NSD, MXNSD, RD, NRD, MXNRD, R, NR, MXNR,
     &   RNG, DEP, TBR, TBZ, NBTYPTS, MXBTY,
     &   THETATOP, RTOP, PHITOP, NTOPPTS,
     &   THETABOT, RBOT, PHIBOT, NBOTPTS, MXREF,
     &   TOPOPT, DEPTHT, CPT, RHOT,
     &   BOTOPT, DEPTHB, CPB, RHOB, RUNTYP, BEAMTYP )

      IF ( NR * NRD .GT. MXNRZ ) THEN
         WRITE( PRTFIL, * ) 'NRZ*NRD, MXNRZ = ', NR * NRD, MXNRZ
         CALL ERROUT( PRTFIL, 'F', 'READIN', 'Too many field points'  )
      ENDIF

      MXNARR = MXNRZ / ( NRD * NR )
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) '( Maximum number of arrivals = ', MXNARR, ')'

      OMEGA  = 2.0 * PI * FREQ
      IBWIN2 = IBWIN **2

      IF ( NR .GE. 2 ) THEN
         DELTAR = R( NR ) - R( NR - 1 )
      ELSE
         DELTAR = 0.0
      ENDIF

C     Beam angle stuff

      DALPHA = 0.0
      IF ( NBEAMS .NE. 1 )
     &   DALPHA = ( ALPHA( NBEAMS ) - ALPHA( 1 ) ) / ( NBEAMS - 1 )

C     *** Loop over source depths ***

      DO IS = 1, NSD
         RS = 0.0
         ZS = SD( IS )

C        --- Zero out field vector
         DO I = 1, NR * NRD
            U( I ) = 0.0
         END DO

C        --- Zero out arrival data
         IF( RUNTYP(1:1) .EQ. 'A' ) THEN
           DO I = 1, NRD * NR
             NARR( I ) = 0
           ENDDO
           DO J = 1, MXNRZ
             AARR(   J ) = 0.0
             DELARR( J ) = 0.0
           END DO              
         END IF

         CALL SSP( RS, ZS, C, CR, CZ, CRR, CRZ, CZZ, TOPOPT, 'TAB' )

         RADMAX = 10 * C / FREQ  ! 10 wavelength max radius

C        --- Check that there are enough beams

         DALPHAOPT = SQRT( C / ( 6.0 * FREQ * R( NR ) ) )
         NBEAMSOPT = 2 + ( ALPHA( NBEAMS ) - ALPHA( 1 ) ) / DALPHAOPT

         IF ( RUNTYP(1:1) .EQ. 'C' .AND. NBEAMS .LT. NBEAMSOPT ) THEN
            CALL ERROUT( PRTFIL, 'W', 'BELLHOP', 'Too few beams' )
            WRITE( PRTFIL, * ) 'NBEAMS should be at least = ', NBEAMSOPT
         ENDIF

C        *** Trace successive beams ***

         DO IBEAM = 1, NBEAMS
            WRITE( *, * ) 'Tracing beam ', IBEAM,
     &         ALPHA( IBEAM ) * 180.0 / PI

C           --- Single beam run?
            IF ( ISINGL .EQ. 0 .OR. IBEAM .EQ. ISINGL ) THEN

C           *** Trace a ray ***
            CALL TRACE( DELTAS, RS, ZS, ALPHA( IBEAM ),
     &         BEAMTYP, ZBOX, RBOX, BOTOPT )

            IF ( RUNTYP(1:1) .EQ. 'R' ) THEN
C              *** Write the ray trajectory to RAYFIL ***
               CALL WRTRAY( RV, ZV, NSTEPS, DEPTHT, DEPTHB )
            ELSE
C              *** Compute the contribution to the field ***

C              --- Compute 'optimal' beam constant:
               EPS = PICKEPS( BEAMTYP(1:1), OMEGA, C, CZ,
     &                  ALPHA( IBEAM ), DALPHA, RLOOP, EPMULT )

               IF ( RUNTYP(2:2) .EQ. 'R' ) THEN
                  CALL INFLUR( U, DELTAR, EPS, ALPHA( IBEAM ), NIMAGE,
     &               IBWIN2, RUNTYP, RADMAX, BEAMTYP )
               ELSE IF ( RUNTYP(2:2) .EQ. 'C' ) THEN
                  CALL INFLUC( U, DELTAR, EPS, ALPHA( IBEAM ), NIMAGE,
     &               IBWIN2, RUNTYP, RADMAX, BEAMTYP )
               ELSE
                  CALL INFLUG( U, ZS, ALPHA( IBEAM ), RUNTYP,
     &               DALPHA, NSD, NARR, DELARR, AARR, MXNARR )
               ENDIF
            ENDIF
            ENDIF
         END DO      ! Next beam

C        *** Scale pressure and write to disk ***

         IF ( RUNTYP(1:1) .EQ. 'C' .OR.
     &        RUNTYP(1:1) .EQ. 'I' .OR.
     &        RUNTYP(1:1) .EQ. 'S' ) THEN
            CALL SCALEP( DALPHA, CV, R, U, NRD, NR,
     &                   RUNTYP, TOPOPT, FREQ )
            IREC  = 6 + NRD * ( IS - 1 )
            CALL WRTFLD( U, NRD, NR, IREC )
         ELSE IF ( RUNTYP(1:1) .EQ. 'A' ) THEN
C           --- Write out arrival data
            CALL WRTARR( NARR, AARR, DELARR, R, NRD, NR )
         END IF

      END DO    ! Next source depth

C     *** Display run time ***

      CALL RDTIME( TEND )
      WRITE( PRTFIL, 9500 ) TEND
 9500 FORMAT( /, ' CPU Time = ', G15.3 )

      STOP
      END
C**********************************************************************C
      FUNCTION PICKEPS( BEAMTYP, OMEGA, C, CZ,
     &                  ALPHA, DALPHA, RLOOP, EPMULT )

C     Picks the optimum value for epsilon

      INTEGER PRTFIL
      COMPLEX CI
      PARAMETER ( PRTFIL = 6, CI = ( 0.0, 1.0 ) )

      LOGICAL   INIFLG
      COMPLEX   PICKEPS, EPSOPT
      CHARACTER BEAMTYP*2, TAG*40

      SAVE INIFLG
      DATA INIFLG /.TRUE./

      IF ( BEAMTYP(1:1) .EQ. 'F' ) THEN
         TAG    = 'Space filling beams'
         HWIDTH = 2.0 / ( ( OMEGA / C ) * DALPHA )
         EPSOPT = CI * 0.5 * OMEGA * HWIDTH ** 2

      ELSE IF ( BEAMTYP(1:1) .EQ. 'M' ) THEN
         TAG    = 'Minimum width beams'
         HWIDTH = SQRT( 2.0 * C * 1000.0 * RLOOP / OMEGA )
         EPSOPT = CI * 0.5 * OMEGA * HWIDTH ** 2

      ELSE IF ( BEAMTYP(1:1) .EQ. 'W' ) THEN
         TAG    = 'WKB beams'
         IF ( CZ .EQ. 0.0 ) THEN
            EPSOPT = 1.0E10
         ELSE
            EPSOPT = ( -SIN( ALPHA ) / COS( ALPHA ** 2 ) ) * C * C / CZ
         ENDIF

      ELSE IF ( BEAMTYP(1:1) .EQ. 'C' ) THEN
         TAG    = 'Cerveny style beam'
      END IF

      PICKEPS = EPMULT * EPSOPT

C     *** On first call write info to prt file ***

      IF ( INIFLG ) THEN
         WRITE( PRTFIL, * ) TAG
         WRITE( PRTFIL, * ) 'HWIDTH = ', HWIDTH
         WRITE( PRTFIL, * ) 'EPSOPT = ', EPSOPT
         WRITE( PRTFIL, * ) 'EPMULT = ', EPMULT
         INIFLG = .FALSE.
      END IF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE TRACE( DELTAS, RS, ZS, ALPHA,
     &                  BEAMTYP, ZBOX, RBOX, BOTOPT )

C     Traces the beam corresponding to a particular take-off angle

      INCLUDE 'COMBM.FOR'

      CHARACTER BOTOPT*2, BEAMTYP*2, BC*1

C     *** Initial conditions ***

      CALL SSP( RS, ZS, C, CR, CZ, CRR, CRZ, CZZ, TOPOPT, 'TAB' )

      CV(    1 ) = C

      RV(    1 ) = RS
      ZV(    1 ) = ZS
      RHOV(  1 ) = COS( ALPHA ) / C
      ZETAV( 1 ) = SIN( ALPHA ) / C

      P1V(   1 ) = 1.0
      Q1V(   1 ) = 0.0
      P2V(   1 ) = 0.0
      Q2V(   1 ) = 1.0

      TAUV(  1 ) = 0.0
      RFA(   1 ) = 1.0

C     *** Trace the beam ***
C     (note that REFLECT alters the step index I)

      ISEG = 1
      I = 0
      DO ISTEP = 1, MXN - 1
         I = I + 1

         CALL STEP(
     &      RV(   I   ),  ZV( I   ), RHOV( I   ), ZETAV( I   ),
     &      P1V(  I   ), Q1V( I   ),  P2V( I   ),   Q2V( I   ),
     &      TAUV( I   ), RFA( I   ),   CV( I   ),
     &      RV(   I+1 ),  ZV( I+1 ), RHOV( I+1 ), ZETAV( I+1 ),
     &      P1V(  I+1 ), Q1V( I+1 ),  P2V( I+1 ),   Q2V( I+1 ),
     &      TAUV( I+1 ), RFA( I+1 ),
     &      DELTAS, DEPTHT, DEPTHB, TOPOPT,
     &      RNG( ISEG ), DEP( ISEG ), TBR( ISEG ), TBZ( ISEG ) )

C        *** Reflections? ***

         D1 = RV( I + 1 ) - RNG( ISEG )      ! tangent pointing between bottom and ray term.
         D2 = ZV( I + 1 ) - DEP( ISEG )

         IF (      ZV( I + 1 ) .LE. 0.0    ) THEN   ! Surface reflection
            BC(1:1) = TOPOPT(2:2)
            CALL REFLECT( DEPTHT, I, BEAMTYP, BC,    CPT, RHOT, 'TOP',
     &      RNG( ISEG ), DEP( ISEG), TBR( ISEG ), TBZ( ISEG ) )
         ELSE IF ( TBR( ISEG ) * D2 - TBZ( ISEG ) * D1 .GE. 0.0 ) THEN   ! Bottom reflection
            CALL REFLECT( DEPTHB, I, BEAMTYP, BOTOPT, CPB, RHOB, 'BOT',
     &      RNG( ISEG ), DEP( ISEG), TBR( ISEG ), TBZ( ISEG ) )
         ENDIF

C        *** New bathymetry segment? ***

         IF ( RV( I + 1 ) .GT. RNG( ISEG + 1 ) .AND.
     &        ISEG .LT. NBTYPTS - 1 ) ISEG = ISEG + 1

C        *** Has the ray left the box, loss its energy,
C            or exceeded storage limit? ***
         IF ( RV( I + 1 ) .GT. RBOX .OR.
     &        ZV( I + 1 ) .GT. ZBOX .OR.
     &        RV( I + 1 ) .LT. 0.0  .OR.
     &        ABS( RFA( I + 1 ) ) .LT. 0.001  ) THEN
            NSTEPS = I + 1
            RETURN
         ELSE IF ( I .GE. MXN - 3 ) THEN
            CALL ERROUT( PRTFIL, 'W', 'TRACE',
     &             'Insufficient storage for ray trajectory' )
            NSTEPS = I
            RETURN
         END IF

      END DO   ! Next step

      RETURN
      END

C**********************************************************************C

      SUBROUTINE STEP(
     &   R0,   Z0, RHO0, ZETA0,
     &   P10, Q10,  P20,   Q20, TAU0, RFA0, C0,
     &   R2,   Z2, RHO2, ZETA2,
     &   P12, Q12,  P22,   Q22, TAU2, RFA2,
     &   DELTAS, DEPTHT, DEPTHB, TOPOPT,
     &   RNG1, DEP1, TBR, TBZ )

C     Does a single step along the ray

      REAL*8 R0, Z0, RHO0, ZETA0, P10, Q10, P20, Q20, TAU0,
     &       R1, Z1, RHO1, ZETA1, P11, Q11, P21, Q21,
     &       R2, Z2, RHO2, ZETA2, P12, Q12, P22, Q22, TAU2,
     &       RNG1, DEP1, TBR, TBZ
      COMPLEX*16 RFA0, RFA2
      CHARACTER TOPOPT*4

C     *** Phase 1 of modified polygon method (an Euler step) ***

      CALL SSP( SNGL( R0 ), SNGL( Z0 ), C0, CR0, CZ0, CRR0, CRZ0, CZZ0,
     &          TOPOPT, 'TAB' )

      CSQ0 = C0 * C0
      CNN0 = CSQ0 * ( CRR0 * ZETA0**2 -
     &          2.0 * CRZ0 * RHO0 * ZETA0 + CZZ0 * RHO0**2 )

      H = DELTAS

C     --- If crossing surface or bottom, reduce step to hit interface

      Z = Z0 + H * C0 * ZETA0
      R = R0 + H * C0 * RHO0

      IF ( Z .LT. DEPTHT ) H = 1.001 * ( DEPTHT - Z0 ) / ( ZETA0 * C0 )

      D1 = R - RNG1      ! tangent pointing between bottom and ray term.
      D2 = Z - DEP1
      IF ( TBR * D2 - TBZ * D1 .GT. 0.00001 ) THEN
         A1 = -C0 * RHO0   ! ray tangent
         A2 = -C0 * ZETA0
         E1 = R0 - RNG1    ! tangent between bottom and ray org.
         E2 = Z0 - DEP1
         H = 1.001 * ( E1 * TBZ - E2 * TBR ) / ( A1 * TBZ - A2 * TBR )
      ENDIF

      HH = 0.5 * H

      R1    = R0    + HH * C0 *  RHO0
      Z1    = Z0    + HH * C0 * ZETA0
      RHO1  = RHO0  - HH * CR0 / CSQ0
      ZETA1 = ZETA0 - HH * CZ0 / CSQ0
      P11   = P10   - HH * CNN0 / CSQ0 * Q10
      Q11   = Q10   + HH * C0          * P10
      P21   = P20   - HH * CNN0 / CSQ0 * Q20
      Q21   = Q20   + HH * C0          * P20

C     *** Phase 2 of modified polygon method ***

      CALL SSP( SNGL( R1 ), SNGL( Z1 ), C1, CR1, CZ1, CRR1, CRZ1, CZZ1,
     &          TOPOPT, 'TAB' )

      CSQ1 = C1 * C1
      CNN1 = CSQ1 * ( CRR1 * ZETA1**2 -
     &               2.0 * CRZ1 * RHO1 * ZETA1 + CZZ1 * RHO1**2 )

C     --- If crossing surface or bottom, reduce step to hit interface

      Z = Z0 + H * C1 * ZETA1
      R = R0 + H * C1 * RHO1

      IF ( Z .LE. DEPTHT )  H = 1.001 * ( DEPTHT - Z0 ) / ( ZETA1 * C1 )

      D1 = R - RNG1
      D2 = Z - DEP1
      IF ( TBR * D2 - TBZ * D1 .GT. 0.00001 ) THEN
         A1 = -C1 * RHO0
         A2 = -C1 * ZETA0
         E1 = R0 - RNG1
         E2 = Z0 - DEP1
         H = 1.001 * ( E1 * TBZ - E2 * TBR ) / ( A1 * TBZ - A2 * TBR )
      ENDIF

      R2    = R0    + H * C1 *  RHO1
      Z2    = Z0    + H * C1 * ZETA1
      RHO2  = RHO0  - H * CR1 / CSQ1
      ZETA2 = ZETA0 - H * CZ1 / CSQ1
      P12   = P10   - H * CNN1 / CSQ1 * Q11
      Q12   = Q10   + H * C1          * P11
      P22   = P20   - H * CNN1 / CSQ1 * Q21
      Q22   = Q20   + H * C1          * P21
      TAU2  = TAU0  + H / C1
      RFA2  = RFA0

      RETURN
      END
C**********************************************************************C
      SUBROUTINE REFLECT( ZREFL, I, BEAMTYP, BC, CHS, RHOHS, BOTTOP,
     &   RNG1, DEP1, TBR1, TBZ1 )

      INCLUDE 'COMBM.FOR'
      REAL*8 RHOHS, THEINT, RINT, PHIINT, RNG1, DEP1, TBR1, TBZ1
      COMPLEX GAMMA1, GAMMA2, GAMMA1SQ, GAMMA2SQ, GK, REFL
      COMPLEX*16 CHS
      CHARACTER BEAMTYP*2, BC*1, BOTTOP*3

      I = I + 1

C     *** here's the geometric part, changing the ray direction ***

      RV(    I+1 ) = RV( I )
      ZV(    I+1 ) = ZV( I )

      IF ( BOTTOP .EQ. 'BOT' ) THEN
C        --- component of ray tangent normal to bottom.
C            normal vector is ( -TBZ, TBR ) in ( r, z) coords.
         BETA = -RHOV( I ) * TBZ1 + ZETAV( I ) * TBR1 
         RHOV(  I+1 ) =  RHOV( I ) + 2.0 * BETA * TBZ1
         ZETAV( I+1 ) = ZETAV( I ) - 2.0 * BETA * TBR1
      ELSE
         RHOV(  I+1 ) =   RHOV( I )
         ZETAV( I+1 ) = -ZETAV( I )
      ENDIF

      CALL SSP( SNGL( RV( I + 1 ) ), SNGL( ZV( I + 1 ) ), C, CR, CZ,
     &                  CRR, CRZ, CZZ, TOPOPT, 'TAB' )

      CV( I ) = C

C     --- Following needs updating for c(r,z) problem

      RN = -2.0 * RHOV( I + 1 )**2 / ZETAV( I + 1 ) * CZ / C

      IF ( BEAMTYP(2:2) .EQ. 'D' ) RN = 2.0 * RN
      IF ( BEAMTYP(2:2) .EQ. 'Z' ) RN = 0.0

      P1V( I + 1 ) = P1V( I ) + Q1V( I ) * RN
      Q1V( I + 1 ) = Q1V( I )
      P2V( I + 1 ) = P2V( I ) + Q2V( I ) * RN
      Q2V( I + 1 ) = Q2V( I )

C     --- account for phase change

      IF ( BC .EQ. 'R' ) THEN                  ! rigid
         TAUV( I + 1 ) = TAUV( I )
         RFA(  I + 1 ) = RFA(  I )
      ELSE  IF ( BC .EQ. 'V' ) THEN            ! vacuum
	 TAUV( I + 1 ) =  TAUV( I )
         RFA(  I + 1 ) = -RFA(  I )
      ELSE  IF ( BC .EQ. 'F' ) THEN            ! file
         RADDEG = 180.0 / PI
 	 THEINT = RADDEG * ATAN2( ZETAV( I ), RHOV( I ) )   ! angle of incidence
C        --- Evaluate R(THEINT)
         IF ( BOTTOP(1:3) .EQ. 'TOP' ) THEN
            CALL REFCO( THEINT, RINT, PHIINT,
     &                  THETATOP, RTOP, PHITOP, NTOPPTS )
         ELSE
            CALL REFCO( THEINT, RINT, PHIINT,
     &                  THETABOT, RBOT, PHIBOT, NBOTPTS )
         ENDIF

         TAUV( I + 1 ) = TAUV( I )
         RFA(  I + 1 ) = RFA(  I ) * RINT * EXP( CI * PHIINT )

      ELSE  IF ( BC .EQ. 'A' ) THEN            ! half-space
	 GK     = OMEGA * RHOV( I )   ! hor. wavenumber
	 GAMMA1SQ = ( OMEGA / C   ) ** 2 - GK ** 2
	 GAMMA2SQ = ( OMEGA / CHS ) ** 2 - GK ** 2
	 GAMMA1 = SQRT( GAMMA1SQ )
	 GAMMA2 = SQRT( GAMMA2SQ )

         REFL = ( RHOHS * GAMMA1 - GAMMA2 ) /
     &	        ( RHOHS * GAMMA1 + GAMMA2 )

         IF ( ABS( REFL ) .LE. 1.0E-5 ) THEN
C           --- kill a ray that has lost its energy in reflection
            TAUV( I + 1 ) = TAUV( I )
            RFA(  I + 1 ) = 0.0
         ELSE
            TAUV( I + 1 ) = TAUV( I )
            RFA(  I + 1 ) = REFL * RFA(  I )
C           --- compute beam-displacement Tindle, Eq. (14)
C           --- needs a correction to beam-width as well ...
C            IF ( REAL( GAMMA2SQ ) .LT. 0.0 ) THEN
C               RHOW   = 1.0   ! density of water
C               RHOWSQ  = RHOW  * RHOW
C               RHOHSSQ = RHOHS * RHOHS
C               DELTA = 2 * GK * RHOW * RHOHS * ( GAMMA1SQ - GAMMA2SQ ) /
C     &            ( GAMMA1 * CI * GAMMA2 *
C     &            ( -RHOWSQ * GAMMA2SQ + RHOHSSQ * GAMMA1SQ ) )
C               RV( I + 1 ) = RV( I + 1 ) + DELTA
C            END IF
	 ENDIF
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE INFLUR( U, DELTAR, EPS, ALPHA, NIMAGE,
     &   IBWIN2, RUNTYP, RADMAX, BEAMTYP )

C     Computes the beam influence, i.e. 
C     the contribution of a single beam to the complex pressure

      INCLUDE 'COMBM.FOR'

      LOGICAL IOK
      INTEGER KMAHV( MXN )
      REAL    NA, NB, NSQ
      COMPLEX PV( MXN ), QV( MXN ), P, Q, EPS, CONTRI, U( NRD, NR ),
     &        GAMMAV( MXN ), GAMMA
      CHARACTER RUNTYP*2, BEAMTYP*2

C     Note that during reflection imag(q) is constant and
C     adjacent normals cannot bracket a segment of the TL
C     line, so no special treatment is necessary

C     ------ Lloyd mirror pattern:

      DS = 2.0*( SIN( OMEGA * ZV( 1 ) * ZETAV( 1 ) ) )**2

C     *** BEGIN BY FORMING (P, Q) AND KMAH INDEX ***

C     Note treatment of KMAH index is incorrect for 'Cerveny'
C     style beam width RUNTYP

      IF ( BEAMTYP(1:1) .EQ. 'C' ) EPS = CI * ABS( Q1V( 1 ) / Q2V( 1 ) )

      PV( 1 ) = P1V( 1 ) + EPS * P2V( 1 )
      QV( 1 ) = Q1V( 1 ) + EPS * Q2V( 1 )

C     ------ Following is sloppy

      GAMMAV( 1 ) = 0.0
      IF ( QV( 1 ) .NE. 0 ) GAMMAV( 1 ) = PV( 1 ) / QV( 1 )
      KMAHV( 1 ) = 1

      DO 1000 I = 2, NSTEPS
         IF ( BEAMTYP(1:1) .EQ. 'C' ) EPS = CI * ABS( Q1V(I) / Q2V(I) )

         PV( I ) = P1V( I ) + EPS * P2V( I )
         QV( I ) = Q1V( I ) + EPS * Q2V( I )

         GAMMAV( I ) = PV( I ) / QV( I )
         KMAHV(  I ) = KMAHV( I - 1 )

         CALL BRCUT( QV( I - 1 ), QV( I ), BEAMTYP, KMAHV( I ) )

 1000 CONTINUE

C     Loop over receivers

      DO 9000 IRD = 1, NRD
      ZR = RD( IRD )

C     *** Loop over images ***

      DO 8000 IMAGE = 1, NIMAGE
         IR1 = 9999

C        Loop over steps

         DO 5000 I = 1, NSTEPS

C           *** Compute ray-centered coordinates, (ZNV, RNV) ***

            ZNV = -RHOV( I ) * CV( I )
C           ------ Check for normal parallel to TL-line
            IF ( ABS( ZNV ) .LT. 1.0E-5 ) THEN
               IOK = .FALSE.
               GOTO 5000
            ENDIF

C           Images of beams

            IF ( IMAGE .EQ. 1 ) THEN
C              ------ True beam
               RNV = ZETAV( I ) * CV( I )
               NB  = ( ZR - ZV( I ) ) / ZNV

            ELSE IF ( IMAGE .EQ. 2 ) THEN
C              ------ Surface reflected beam
               RNV = -ZETAV( I ) * CV( I )
               NB  = ( ZR - ( 2.0 * DEPTHT - ZV( I ) ) ) / ZNV

            ELSE IF ( IMAGE .EQ. 3 ) THEN
C              ------ Bottom reflected beam
               RNV = -ZETAV( I ) * CV( I )
               NB  = ( ZR - ( 2.0 * DEPTHB - ZV( I ) ) ) / ZNV
            ENDIF

            RB = RV( I ) + NB * RNV

C           *** Compute influence for each rcvr ***

            IF ( RB .GT. R( 1 ) ) THEN
               IR2 = MIN( INT( ( RB - R( 1 ) ) / DELTAR ) + 1, NR )
            ELSE
               IR2 = MIN( INT( ( RB - R( 1 ) ) / DELTAR ), NR )
            ENDIF

            IF ( ( IR2 .GT. IR1 ) .AND. ( RV( I ) .NE. RV( I - 1 ) )
     &         .AND. IOK ) THEN
               DO 2000 IR = IR1 + 1, IR2
                  W = ( R( IR ) - RA ) / ( RB - RA )

                  P     =     PV(I-1) + W * (     PV(I) -     PV(I-1) )
                  Q     =     QV(I-1) + W * (     QV(I) -     QV(I-1) )
                  GAMMA = GAMMAV(I-1) + W * ( GAMMAV(I) - GAMMAV(I-1) )

                  NSQ = ( NA + W * ( NB - NA ) )**2

                  IF ( AIMAG( GAMMA ) .GT. 0 ) THEN
                     WRITE( PRTFIL, * ) 'Unbounded beam'
                     WRITE( PRTFIL, * ) PV(I-1),QV(I-1),PV(I-1)/QV(I-1)
                     WRITE( PRTFIL, * ) PV(I), QV(I), PV(I) / QV(I)
                     WRITE( PRTFIL, * ) GAMMA, W
                  ENDIF

C                 ------ Within beam window?
                  IF ( -0.5*OMEGA*AIMAG(GAMMA)*NSQ .LT. IBWIN2 ) THEN

                     C   =   CV( I-1 ) + W * (   CV( I ) -   CV( I-1 ) )
                     TAU = TAUV( I-1 ) + W * ( TAUV( I ) - TAUV( I-1 ) )

                     IF ( RUNTYP(2:2) .EQ. 'C' )
     &                  EPS = CI * ABS( Q1V( I ) / Q2V( I ) )

                     CONTRI = SQRT( C * ABS( EPS ) / Q * COS( ALPHA ) )*
     &                  EXP( -CI * OMEGA * ( TAU + 0.5 * GAMMA * NSQ ) )

C                    ------ Get correct branch of SQRT
                     KMAH = KMAHV( I - 1 )
                     CALL BRCUT( QV( I - 1 ), Q, BEAMTYP, KMAH )

                     IF ( KMAH  .LT. 0 ) CONTRI = -CONTRI
                     IF ( IMAGE .EQ. 2 ) CONTRI = -CONTRI

C                    ------ Coherent, semi-coherent, or incoherent TL:

                     IF ( RUNTYP(1:1) .EQ. 'I' ) CONTRI =    ABS(CONTRI)
                     IF ( RUNTYP(1:1) .EQ. 'S' ) CONTRI = DS*ABS(CONTRI)

                     U( IRD, IR ) = U( IRD, IR ) +
     &                   HERMIT( NA, RADMAX, 2.0 * RADMAX ) * CONTRI

                  ENDIF
 2000          CONTINUE
            ELSE
C              ------ Next step maybe ok
               IOK = .TRUE.
            ENDIF
            RA  = RB
            NA  = NB
            IR1 = MAX( IR2, 0 )
 5000    CONTINUE       ! Next step

 8000 CONTINUE      ! Next image

 9000 CONTINUE      ! Next receiver depth

      RETURN
      END
C**********************************************************************C
      SUBROUTINE INFLUC( U, DELTAR, EPS, ALPHA, NIMAGE,
     &   IBWIN2, RUNTYP, RADMAX, BEAMTYP )

C     Computes the beam influence, i.e. 
C     the contribution of a single beam to the complex pressure
C     This version uses a beam representation in Cartesian coordinates

      INCLUDE 'COMBM.FOR'

      INTEGER   KMAHV( MXN )
      COMPLEX   PV( MXN ), QV( MXN ), Q, EPS, CONTRI, U( NRD, NR ),
     &          GAMMAV( MXN ), GAMMA, CONST
      CHARACTER RUNTYP*2, BEAMTYP*2

C     Note that during reflection imag(q) is constant and
C     adjacent normals cannot bracket a segment of the TL
C     line, so no special treatment is necessary

C     ------ Lloyd mirror pattern:
      DS = 2.0 * ( SIN( OMEGA * ZV(1) * ZETAV( 1 ) ) )**2

C     *** Begin by forming (p, q) and KMAH index ***

C     Note treatment of KMAH index is incorrect for 'Cerveny'
C     style beam width BEAMTYP

      DO 1000 I = 1, NSTEPS
         IF ( BEAMTYP(1:1) .EQ. 'C' ) EPS = CI * ABS( Q1V(I) / Q2V(I) )

         PV( I ) = P1V( I ) + EPS * P2V( I )
         QV( I ) = Q1V( I ) + EPS * Q2V( I )

C         RLTEMP = SQRT( -2.0 / ( OMEGA * AIMAG( PV( I ) / QV( I ) ) ) )
C         RKTEMP = -CV( I ) * REAL( PV( I ) / QV( I ) )

C         WRITE( PRTFIL, * ) RLTEMP, RKTEMP

C         IF ( BEAMTYP(2:2) .EQ. 'D' ) THEN
C            PV( I ) = REAL( PV( I ) )
C            P = PV( I )
C            L = 30.0 * 1500.0 / OMEGA
C            QV( I ) = ( CI * OMEGA * L**2 / 2.0) * P
C         ENDIF

         TR =  RHOV( I ) * CV(I)
         TZ = ZETAV( I ) * CV(I)

         CALL SSP( SNGL( RV( I ) ), SNGL( ZV( I ) ), C, CR, CZ,
     &             CRR, CRZ, CZZ, TOPOPT, 'TAB')

         CSQ = C * C
         CS = CR * TR + CZ * TZ
         CN = CR * TZ - CZ * TR 

         GAMMAV( I ) = 0.0
         IF ( QV( I ) .NE. 0.0 )
     &      GAMMAV( I ) = 0.5 * ( PV(I) / QV(I) * TR**2 +
     &                    2.0 * CN / CSQ * TZ * TR - CS / CSQ * TZ**2 )

         IF ( I .EQ. 1 ) THEN
            KMAHV( 1 ) = 1
         ELSE
            KMAHV( I ) = KMAHV( I - 1 )
            CALL BRCUT( QV( I - 1 ), QV( I ), BEAMTYP, KMAHV( I ) )
         ENDIF

 1000 CONTINUE

C     *** Loop over steps ***

      DO 5000 I = 3, NSTEPS
         IF ( RV( I ) .GT. R( NR ) ) RETURN
         RA = RV( I-1 )
         RB = RV( I )
         IF ( RA .EQ. RB ) GOTO 5000

C        ------ Compute upper index on rcvr line
         IR1 = MAX( MIN( INT( ( RA - R(1) ) / DELTAR ) + 1, NR ), 1 )
         IR2 = MAX( MIN( INT( ( RB - R(1) ) / DELTAR ) + 1, NR ), 1 )

C        ------ Following for projecting back reflected beams
C         IF ( RV( I-2 ) .EQ. RV( I-1 ) ) IR1 = 1
C         IF ( RV( I )   .EQ. RV( I+1 ) ) IR2 = NR

         IF ( IR2 .GT. IR1 ) THEN
            DO 2000 IR = IR1 + 1, IR2
               W = ( R( IR ) - RA ) / ( RB - RA )

               Z     =     ZV(I-1) + W * (     ZV(I) -     ZV(I-1) )
               C     =     CV(I-1) + W * (     CV(I) -     CV(I-1) )
               Q     =     QV(I-1) + W * (     QV(I) -     QV(I-1) )
               TAU   =   TAUV(I-1) + W * (   TAUV(I) -   TAUV(I-1) )
               ZETA  =  ZETAV(I-1) + W * (  ZETAV(I) -  ZETAV(I-1) )
               GAMMA = GAMMAV(I-1) + W * ( GAMMAV(I) - GAMMAV(I-1) )

               IF ( AIMAG( GAMMA ) .GT. 0 ) THEN
                  WRITE( PRTFIL, * ) 'Unbounded beam'
                  WRITE( PRTFIL, * ) GAMMAV(I-1), GAMMAV(I), GAMMA
               ENDIF

               IF ( BEAMTYP(1:1) .EQ. 'C' )
     &             EPS = CI * ABS( Q1V( I ) / Q2V( I ) )

               CONST = SQRT( C * ABS(   EPS   ) / Q * COS( ALPHA ) )

C              ------ Get correct branch of SQRT
               KMAH = KMAHV( I - 1 )

               CALL BRCUT( QV( I - 1 ), Q, BEAMTYP, KMAH )

               IF ( KMAH .LT. 0 ) CONST = -CONST

C              *** Loop over receivers ***

               DO 9000 IRD = 1, NRD
                  ZR = RD( IRD )

C                 ------ True beam
                  DELTAZ = ZR - Z
C                  IF ( OMEGA * AIMAG( GAMMA )*DELTAZ**2 .LT. IBWIN2 )
                   CONTRI = HERMIT( DELTAZ, 0.0, RADMAX ) *
     &                EXP( -CI * OMEGA *
     &                ( TAU + ZETA * DELTAZ + GAMMA * DELTAZ**2) )

C                 ------ Surface reflected beam
                  IF ( NIMAGE .GE. 2 ) THEN
                     DELTAZ = -ZR + 2.0 * DEPTHT - Z
                     IF ( OMEGA * AIMAG( GAMMA )*DELTAZ**2 .LT. IBWIN2 )
     &                  CONTRI =  CONTRI -
     &                     HERMIT( DELTAZ, 0.0, RADMAX ) *
     &                     EXP( -CI * OMEGA *
     &                     ( TAU + ZETA * DELTAZ + GAMMA * DELTAZ**2) )
                  ENDIF

C                 ------ Bottom reflected beam
                  IF ( NIMAGE .GE. 3 ) THEN
                     DELTAZ = -ZR + 2.0 * DEPTHB - Z
                     IF ( OMEGA * AIMAG( GAMMA )*DELTAZ**2 .LT. IBWIN2 )
     &                  CONTRI =  CONTRI + 
     &                     HERMIT( DELTAZ, 0.0, RADMAX ) *
     &                     EXP( -CI * OMEGA *
     &                     ( TAU + ZETA * DELTAZ + GAMMA * DELTAZ**2) )
                  ENDIF

C                 ------ Coherent, semi-coherent, or incoherent TL:

                  CONTRI = CONST * CONTRI

                  IF ( RUNTYP(1:1) .EQ. 'I' ) THEN
                     CONTRI =      ABS( CONTRI )
                  ELSE IF ( RUNTYP(1:1) .EQ. 'S' ) THEN
                     CONTRI = DS * ABS( CONTRI )
                  ENDIF

                  U( IRD, IR ) = U( IRD, IR ) + CONTRI

 9000          CONTINUE      ! Next receiver depth
 2000       CONTINUE      ! Next receiver range
         ENDIF
 5000 CONTINUE      ! Next step along the ray

      RETURN
      END
C**********************************************************************C
      SUBROUTINE INFLUG( U, ZS, ALPHA, RUNTYP, DALPHA, NSD,
     &   NARR, DELARR, AARR, MXNARR )

C     Computes the beam influence, i.e. 
C     the contribution of a single beam to the complex pressure
C     This version uses a beam representation in Cartesian coordinates

      INCLUDE 'COMBM.FOR'

      LOGICAL   NEWRAY
      INTEGER     NARR( NRD, NR )
      REAL      DELARR( NRD, NR, * )
      COMPLEX     AARR( NRD, NR, * )

      REAL*8    QV( MXN )
      COMPLEX   U( NRD, NR ), CONST, CONTRI, CAUSTIC
      CHARACTER RUNTYP*2

      EQUIVALENCE ( QV, Q1V )

C     --- Lloyd mirror pattern (pressure form):
      DS = SQRT( 2.0 ) * SIN( OMEGA * ZS * ZETAV( 1 ) )
      Q0 = CV( 1 ) / DALPHA   ! Reference for J = Q0 / Q

      CAUSTIC = 1   ! CAUSTIC is multiplied by i after each caustic
      QOLD    = 1.0
      Q1METER = CV( 1 )
      RAT1    = SQRT( Q1METER / CV ( 1 ) * COS( ALPHA ) )

C     *** Loop over steps ***

      RA = RV( 1 )
      IR = 1

      DO I = 2, NSTEPS

         RB = RV( I )

C        ------ Loop over bracketted receiver ranges

1000     CONTINUE

         IF ( RB .NE. RA .AND. RB .GT. R( IR ) ) THEN

            W = ( R( IR ) - RA ) / ( RB - RA )

            Z     =     ZV(I-1) + W * (     ZV(I) -     ZV(I-1) )
            C     =     CV(I-1) + W * (     CV(I) -     CV(I-1) )
            Q     =     QV(I-1) + W * (     QV(I) -     QV(I-1) )
            RHO   =   RHOV(I-1) + W * (   RHOV(I) -   RHOV(I-1) )
            ZETA  =  ZETAV(I-1) + W * (  ZETAV(I) -  ZETAV(I-1) )
            TAU   =   TAUV(I-1) + W * (   TAUV(I) -   TAUV(I-1) )

            TR = RHO * C
            A  = ABS( TR * Q0 / Q )
            RADMAX = 1.0 / A

            IF ( Q .LT. 0.0 .AND. QOLD .GE. 0.0 .OR.
     &           Q .GT. 0.0 .AND. QOLD .LE. 0.0 )
     &                                   CAUSTIC = CI * CAUSTIC

C           --- Coherent, semi-coherent, or incoherent TL:
            CONST = RAT1 * SQRT( C / ABS( Q ) )
            IF ( RUNTYP(1:1) .EQ. 'S' ) CONST = DS * CONST

C           *** Loop over receiver depths ***

            DO IRD = 1, NRD
               DELTAZ =  RD( IRD ) - Z   ! ray to rcvr distance 
               ADZ    = ABS( DELTAZ )

               IF ( ADZ .LT. RADMAX ) THEN
                 IF ( RUNTYP(1:1) .EQ. 'E' ) THEN
C                  *** Write the eigenray trajectory to RAYFIL ***
                   CALL WRTRAY( RV, ZV, NSTEPS, DEPTHT, DEPTHB )

                 ELSE IF ( RUNTYP(1:1) .EQ. 'A' ) THEN
C                  *** arrivals ***
                   CONTRI = CONST * A * ( RADMAX - ADZ )
                   DELAY  = TAU + ZETA * DELTAZ

C                  --- Is this the second bracketting ray of a pair?
                   NT =  NARR( IRD, IR )    ! # of arrivals
                   NEWRAY = .TRUE.
                   IF ( NT .GE. 1 ) THEN
                     IF( OMEGA * ABS( DELAY - DELARR( IRD, IR, NT ) )
     &                  .LT. 1.0 ) NEWRAY = .FALSE.
                   ENDIF

                   IF ( NEWRAY ) THEN
                     NT =  NT + 1   ! # of arrivals
                     IF ( NT .LE. MXNARR ) THEN
                       NARR( IRD, IR     ) = NT
                       AARR( IRD, IR, NT ) = CONTRI * CAUSTIC * RFA( I )
                       DELARR( IRD, IR, NT ) = DELAY
                     ENDIF
                   ELSE
                     AARR(   IRD, IR, NT ) = AARR( IRD, IR, NT ) +
     &                  CONTRI * CAUSTIC * RFA( I )
                     DELARR( IRD, IR, NT ) =
     &                   0.5 * ( DELARR( IRD, IR, NT ) + DELAY )
                   ENDIF
                 ELSE IF ( RUNTYP(1:1) .EQ. 'C'  ) THEN
                   CONTRI = CONST * A * ( RADMAX - ADZ )
                   DELAY  = TAU + ZETA * DELTAZ
                   CONTRI = CAUSTIC * CONTRI * RFA( I ) *
     &                  EXP( -CI * OMEGA * DELAY )
                    U( IRD, IR ) = U( IRD, IR ) + CONTRI
                 ELSE
C                  *** incoherent field calculation ***
                   CONTRI = CONST ** 2 * A * ( RADMAX - ADZ )
     &                        * ABS( RFA( I ) )
                   U( IRD, IR ) = U( IRD, IR ) + CONTRI
                 ENDIF
               ENDIF
            END DO      ! Next receiver depth

            QOLD = Q
            IR = IR + 1
            IF ( IR .GT. NR ) RETURN
            GOTO 1000     ! Next receiver range
         ENDIF

         RA = RB
      END DO      ! Next step along the ray

      RETURN
      END
C**********************************************************************C
      SUBROUTINE BRCUT( Q1C, Q2C, BEAMTYP, KMAH )

C     Checks for a branch cut crossing

      COMPLEX   Q1C, Q2C
      CHARACTER BEAMTYP*2

      IF ( BEAMTYP(1:1) .EQ. 'W' ) THEN
C        ------ WKBeams:
         Q1 = REAL( Q1C )
         Q2 = REAL( Q2C )
         IF ( ( Q1 .LT. 0.0 .AND. Q2 .GE. 0.0 ) .OR.
     &        ( Q1 .GT. 0.0 .AND. Q2 .LE. 0.0 ) ) KMAH = -KMAH
      ELSE
C        ------ All other beam types
         IF ( REAL( Q2C ) .LT. 0.0 ) THEN
            Q1 = AIMAG( Q1C )
            Q2 = AIMAG( Q2C )
            IF ( ( Q1 .LT. 0.0 .AND. Q2 .GE. 0.0 ) .OR.
     &           ( Q1 .GT. 0.0 .AND. Q2 .LE. 0.0 ) ) KMAH = -KMAH
         ENDIF
      ENDIF

      RETURN
      END
C**********************************************************************C
      FUNCTION HERMIT( X, X1, X2 )

C     Calculates a smoothing function based on the h0 hermite cubic

      AX  = ABS( X  )
      AX1 = ABS( X1 )
      AX2 = ABS( X2 )

      IF ( AX .LE. AX1 ) THEN
         HERMIT = 1.0
      ELSE IF ( AX .GE. AX2 ) THEN
         HERMIT = 0.0
      ELSE
         U = ( AX - AX1 ) / ( AX2 - AX1 )
         HERMIT = ( 1.0 + 2.0 * U ) * ( 1.0 - U )**2
      ENDIF

      hermit = 1.0
C      hermit = hermit / ( 0.5 * ( x1 + x2 ) )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SCALEP( DALPHA, C, R, U, NRD, NR,
     &                   RUNTYP, TOPOPT, FREQ )

C     Scale the pressure field

      REAL      R( NR )
      COMPLEX   U( NRD, NR )
      CHARACTER TOPOPT*4, RUNTYP*2

C     --- Compute scale factor for field
      IF ( RUNTYP(2:2) .NE. 'G' ) THEN
         CONST = -DALPHA * SQRT( FREQ ) / C
      ELSE
         CONST = -1.0
      ENDIF

C     *** Thorpe attenuation? ***

      IF ( TOPOPT(3:3) .EQ. 'T' ) THEN
         F2 = ( FREQ / 1000.0 ) ** 2
         ALPHA = 40.0 * F2 / ( 4100.0 + F2 ) + 0.1 * F2 / ( 1.0 + F2 )
         ALPHA = ALPHA / 914.4                 ! dB / m
         ALPHA = ALPHA / 8.6858896             ! Nepers / m
      ELSE
         ALPHA = 0.0
      ENDIF

C     *** Loop over range ***

      DO IR = 1, NR

         FACTOR = CONST * EXP( -ALPHA * R( IR ) ) / SQRT( R( IR ) )

C        *** Loop over depth ***

         DO IRD = 1, NRD
C           --- For incoherent RUNTYP, convert intensity to pressure
            IF ( RUNTYP(1:1) .NE. 'C' )
     &         U( IRD, IR ) = SQRT( REAL( U( IRD, IR ) ) )
            
            U( IRD, IR ) = FACTOR * U( IRD, IR )
         END DO

      END DO

      RETURN
      END

C**********************************************************************C

      SUBROUTINE WRTRAY( RV, ZV, NSTEPS, DEPTHT, DEPTHB )

C     Compress the ray data keeping every ISKIP point,
C     points near surface or bottom, and last point.
C     Write to RAYFIL.

      INTEGER RAYFIL
      PARAMETER ( RAYFIL = 21 )

      REAL*8 RV( * ), ZV( * )

C     --- compression
      N2 = 1
      ISKIP = MAX( NSTEPS / 5000, 1 )   ! max #pts written is 500

      DO I = 2, NSTEPS
         IF ( MIN( DEPTHB - ZV( I ),  ZV( I ) - DEPTHT ) .LT. 0.2 .OR.
     &        MOD( I, ISKIP ) .EQ. 0 .OR. I .EQ. NSTEPS ) THEN
             N2 = N2 + 1
             RV( N2 ) = RV( I )
             ZV( N2 ) = ZV( I )
         END IF
      END DO

C     --- write to ray file
      WRITE( RAYFIL, * ) N2
      DO I = 1, N2
         WRITE( RAYFIL, * ) SNGL( RV( I ) ), SNGL( ZV( I ) )
      ENDDO

      RETURN
      END

C**********************************************************************C

      SUBROUTINE WRTARR( NARR, AARR, DELARR, R, NRD, NR )

C     Writes the arrival data (amplitude, delay for each eigenray)

      INTEGER ARRFIL
      PARAMETER ( ARRFIL = 36 )

      INTEGER     NARR( NRD, NR )
      REAL      DELARR( NRD, NR, * ), R( NR )
      COMPLEX     AARR( NRD, NR, * ), AARRT

      DO IRD = 1, NRD
        DO IR = 1, NR
          WRITE( ARRFIL, * ) NARR( IRD, IR )
          DO JJ = 1, NARR( IRD, IR )
            AARRT = AARR( IRD, IR, JJ ) / SQRT( R( IR ) )   ! cylindrical spreading
            WRITE( ARRFIL, * )
     &         REAL( AARRT ), AIMAG( AARRT ),
     &         DELARR( IRD, IR, JJ )
          END DO   ! next arrival
        END DO   ! next receiver depth
      END DO   ! next range

      RETURN
      END

      SUBROUTINE HTS( NT, WKMIN, WKDEL, STABIL,
     &                RMIN, NR, RDEL, X, Y, Z, INIFLG, OPTION )

C     Hankel Transform by series approximation - Currently first term only.
C     Formulas from Abramowitz and Stegun, Eqs. 9.2.5-9.2.10

C     X contains input k space spectra, NT points.
C     Z contains output transmission loss, NR points.
C     NT = number of points in transform.
C     WKMIN = minimum wavenumber of input series.
C     WKDEL = spacing of input series.
C     STABIL = amount integration has been moved off of the real axis.
C     NR = number of output transmission loss points.(WITH NR .LE. 2*NT)
C     RDEL = spacing of transmission loss points.
C     RMIN = STARTING POINT FOR TL

C     Adapted from Steve Wales' original program

C     This version uses the FPS library FFT.
C     To revert to original:
C        allocate WSPACE
C        take the commented set of FFT calls

      COMPLEX AI, AIPID4
      PARAMETER ( AI = (0.0, 1.0), PI = 3.141592653589793,
     &            TWOPI = 2. * PI )

      LOGICAL  INIFLG
C     REAL     WSPACE( 4 * MAXNT + 5 )
      COMPLEX  X( * ), Y( * ), Z( * ), CK, AISTAB, AIRMIN, Z2
      CHARACTER OPTION*80

C     ------ Initialization

      AIPID4 = AI * PI / 4.0
      AISTAB = AI * STABIL
      AIRMIN = AI * RMIN
      SQRT2P = 1.0 / SQRT ( TWOPI )
      FACTOR = WKDEL * SQRT2P

C      IF ( INIFLG ) CALL CFFTI ( NT, WSPACE )

C     *** First term, lower-half of cosine transform ***

      IF ( WKMIN .GT. 0.5 * WKDEL )  THEN
         X( 1 ) = FACTOR * SQRT( WKMIN + AISTAB ) * X( 1 )
      ELSE
         X( 1 ) = 0.5 * ( AISTAB + WKDEL ) * SQRT2P
     &                   * SQRT(         AISTAB ) * X( 1 )
      END IF

      Y( 1 ) = X( 1 ) * EXP( AIPID4 )

      DO IS = 2, NT
         WKDIF = ( IS - 1 ) * WKDEL
         X( IS ) = FACTOR * SQRT( WKMIN + WKDIF + AISTAB ) * X( IS )
         Y( IS ) = X( IS ) * EXP( -AIRMIN * WKDIF + AIPID4 )
      END DO

C     ------ (P)ositive or (B)oth positive and negative spectrum

      IF ( OPTION(3:3) .EQ. 'P' .OR. OPTION(3:3) .EQ. 'B' ) THEN
         CALL CFFT( Y, NT, 1 )                 ! EXP (-IKX) transform
C        CALL CFFTF( NT, Y, WSPACE )

         CK = CMPLX ( +STABIL, -WKMIN )
         DO IR = 1, NR
            R = RMIN + ( IR - 1 ) * RDEL
            Z( IR ) = Y( IR ) * EXP ( CK * R )
         END DO
      ENDIF

C     *** Second term, second-half of cosine transform ***

C     ------ (N)egative or (B)oth positive and negative spectrum

      IF ( OPTION(3:3) .EQ. 'N' .OR. OPTION(3:3) .EQ. 'B' ) THEN
         Y( 1 ) = X( 1 ) * EXP( -AIPID4 )
         DO IS = 1, NT
            WKDIF   = ( IS - 1 ) * WKDEL
            Y( IS ) = X( IS ) * EXP( +AIRMIN * WKDIF - AIPID4 )
         END DO

         CALL CFFT( Y, NT, -1 )                  ! EXP (+IKX) transform
C        CALL CFFTB( NT, Y, WSPACE )
      ENDIF

      DO IR = 1, NR
         R  = RMIN + ( IR - 1 ) * RDEL
         Z2 = Y( IR ) * EXP ( -CK * R )

         IF ( OPTION(3:3) .EQ. 'B' ) THEN
            Z( IR ) = Z( IR ) + Z2
         ELSE IF ( OPTION(3:3) .EQ. 'N' ) THEN         
            Z( IR ) = Z2
         ENDIF

         IF ( OPTION(1:1) .EQ. 'R' ) Z( IR ) = Z( IR ) / SQRT( R )
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE FTS ( NT, WKMIN, WKDEL, STABIL,
     &                RMIN, NR, RDEL, X, Y, Z, INIFLG )

C     Fourier Transform

C     X contains input k space spectra, NT points.
C     Z contains output transmission loss, NR points.
C     NT = number of points in transform.
C     WKMIN = minimum wavenumber of input series.
C     WKDEL = spacing of input series.
C     STABIL = amount integration has been moved off of the real axis.
C     NR = number of output transmission loss points.(WITH NR .LE. 2*NT)
C     RDEL = spacing of transmission loss points.
C     RMIN = STARTING POINT FOR TL

C     Adapted from Steve Wales' original program

      COMPLEX AI
      PARAMETER ( AI = (0.0, 1.0), PI = 3.141592653589793,
     &   TWOPI = 2.*PI )

      LOGICAL INIFLG
      COMPLEX  X( * ), Y( * ), Z( * ), CK, AISTAB, AIRMIN, Z2

C     ------ Initialization
      AISTAB = AI * STABIL
      AIRMIN = AI * RMIN
      SQRT2P = 1. / SQRT ( TWOPI )
      FACTOR = WKDEL * SQRT2P

C     *** First term, lower-half of cosine transform ***

      IF ( WKMIN .GT. 0.5 * WKDEL )  THEN
         X( 1 ) = FACTOR * X( 1 )
      ELSE
         X( 1 ) = ( AISTAB + WKDEL ) / 2.0 * SQRT2P * X( 1 )
      END IF

      Y( 1 ) = X( 1 )

      DO IS = 2, NT
         WKDIF = ( IS - 1 ) * WKDEL
         X( IS ) = FACTOR * X( IS )
         Y( IS ) = X( IS ) * EXP( -AIRMIN * WKDIF )
      END DO

      CALL CFFT (Y, NT, 1)                      ! EXP (-IKX) transform
      CALL CFFTSC ( Y, NT )                     ! Scale
      CK = CMPLX( +STABIL, -WKMIN )

      DO IR = 1, NR
         R = RMIN + ( IR - 1 ) * RDEL
         Z( IR ) = Y( IR ) * EXP ( CK * R )
      END DO

C     *** Second term, second-half of cosine transform ***

      Y( 1 ) = X( 1 )

      DO IS = 1, NT
         WKDIF = ( IS - 1 ) * WKDEL
         Y( IS ) = X( IS ) * EXP( +AIRMIN * WKDIF )
      END DO

      CALL CFFT( Y, NT, -1 )                     ! EXP (+IKX) transform

      DO IR = 1, NR
         R  = RMIN + (IR-1) * RDEL
         Z2 = Y( IR ) * EXP ( -CK * R )
         Z( IR ) = Z( IR ) + Z2
      END DO

      RETURN
      END

      PROGRAM RADIUS

C     Converts complex pressure to a detection radius

      INTEGER INPFIL, PRTFIL, SHDFIL, FOMFIL
      PARAMETER ( INPFIL = 5, PRTFIL = 6, SHDFIL = 26, FOMFIL = 25,
     &   MAXNSD = 4094, MAXNRD = 4094, MAXNR = 4094, MXNFOM = 501 )

      REAL R( MAXNR ), SD( MAXNSD ), RD( MAXNRD ), TL( MAXNR ),
     &     FOM( MXNFOM ), RAD( MXNFOM )
      COMPLEX P( MAXNR )
      CHARACTER TITLE*80, PLTTYP*10

      WRITE( PRTFIL, * ) 'SIGMA?'
      READ(  INPFIL, * ) SIGMA
      SIGMA  = ABS( SIGMA )

      WRITE( PRTFIL, * ) 'NFOM, FOMMIN, FOMMAX'
      READ(  INPFIL, * )  NFOM, FOMMIN, FOMMAX

      DELFOM = ( FOMMAX - FOMMIN ) / ( NFOM - 1 )
      DO 1000 IFOM = 1, NFOM
         FOM( IFOM ) = FOMMIN + ( IFOM - 1 ) * DELFOM
 1000 CONTINUE

C     *** Read/write header ***

      CALL RDHEAD( SHDFIL, SHDFILIN, MAXNR, MAXNSD, MAXNRD,
     &   FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &   SD, NSD, RD, NRD, TITLE )

      CALL HEADER( TITLE, SD, NSD, RD, NRD,
     &   FOM, NFOM, FREQ, ATTEN, PLTTYP, XS, YS, THETA )

C     Read in pressure field and convert to transmission loss

      DO 9000 ISR = 1, NSD * NRD
         IREC =  ISR + 6
         READ ( SHDFIL, REC = IREC )
     &      SRCD, RCVRD, ( P( IR ), IR = 1, NR )

C        --- convert pressure to TL

         DO IR = 1, NR
            PSQ = P( IR ) * CONJG( P( IR ) )
            TL( IR ) = 200.0
            IF ( PSQ .GT. 1.0E-20 ) TL( IR ) = -10.0 * ALOG10( PSQ )
         END DO

C        --- For each FOM, compute detection radius

         DO IFOM = 1, NFOM
            RAD( IFOM ) = 0.0
            DO IR = 2, NR
               RAD( IFOM ) = RAD( IFOM ) + ( R( IR ) - R( IR - 1 ) )
     &             * TRANSIT( FOM( IFOM ) - TL( IR ), SIGMA )

C              --- Glimpse range:
C               IF ( TRANSIT( FOM( IFOM ) - TL( IR ), SIGMA ) .GE. 0.5 )
C     &            RAD( IFOM ) = R( IR )
            END DO
         END DO

C        --- Write out the radius
         WRITE( FOMFIL, REC = IREC ) SRCD, RCVRD,
     &      ( RAD( IFOM ) / 1000.0, 0.0, IFOM = 1, NFOM )
 9000 CONTINUE

      STOP
      END

      FUNCTION PEKRTZ( Z, CENT, RK )

C     PEKERIS BRANCH OF THE SQUARE ROOT
C     THIS EXPOSES LEAKY MODES

      COMPLEX*16 PEKRT, Z, A
      REAL*8 CENT, RK, B

      IF ( CENT .GT. RK ) THEN
         PEKRTZ = CDSQRT(Z)
      ELSE
         A = CDSQRT( Z ) 
         B = DIMAG( A )
         B = SIGN( 1.0D0, B )      
         PEKRTZ =  B * A
      ENDIF
     
      RETURN
      END

      PROGRAM FIELDMO

C     Generate file of replica vectors

      INTEGER PRTFIL, FLPFIL
      PARAMETER ( FLPFIL = 5, PRTFIL = 6, 
     &   MXM = 1500, MXNW = 4094, MXNWZ = 210000, 
     &   MXNSD = 51, MXNRD = 201, MXNOC = 9 )

      INTEGER CTR( MXNOC )
      REAL      SD( MXNSD ), RD( MXNRD ),
     &          W( MXNW ), ALPHA( MXNOC )
      COMPLEX   CK( MXNOC, MXM ), CKTEMP( MXM), PHITEMP( MXM, MXNRD ),
     &          CKA( MXM ), CKB( MXM ),
     &          PHIS( MXNOC, MXM, MXNSD ),
     &          PHIR( MXNOC, MXM, MXNRD ),
     &          PHISA( MXM, MXNRD ), PHISB( MXM, MXNRD ),
     &          PHIRA( MXM, MXNRD ), PHIRB( MXM, MXNRD ),
     &          P( MXNWZ )
      CHARACTER OPT*50, SHTITL*80, TITLE*80, COMP*1

C     Read source, rcvr depths and rcvr displacements

      SHTITL(1:1) = '$'
      READ( FLPFIL, * ) SHTITL

      READ( FLPFIL, * ) OPT
C      CALL STR$UPCASE( OPT, OPT )
      COMP = OPT( 3:3 )

      READ( FLPFIL, * ) MLIMIT
      MLIMIT = MIN( MXM, MLIMIT )

      READ( FLPFIL, * ) NOC

C     *** Read ocean weights ***

      NW = 0
      W( 3 ) = -999.9
      READ( FLPFIL, * ) NW, ( W( IA ), IA = 1, NW )

      CALL SUBTAB( W, NW )
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Number of ocean weights = ', NW
      IF ( NW .GE. 1 )
     &   WRITE( PRTFIL, * ) ( W( IA ), IA = 1, MIN( NW, 51 ) )

      WRITE( PRTFIL, * )

C     *** Read source/receiver depths ***

      ZMIN = -1.0E10
      ZMAX = +1.0E10

      CALL SDRD( FLPFIL, PRTFIL, ZMIN, ZMAX,
     &   MXNSD, NSD, SD,
     &   MXNRD, NRD, RD )

      WRITE( PRTFIL, * )

      IF ( NW * NRD .GT. MXNWZ )
     &   CALL ERROUT( PRTFIL, 'F', 'FIELD',
     &                'Number of oceans x Depths too large' )

      READ( FLPFIL, * ) R
      R = 1000.0 * R

C     *** Read in modes ***

      M = MLIMIT

      DO 2000 IOC = 1, NOC

         CALL GETMOD( IOC, ' ', MXM, SD, NSD, 'N',
     &      CKTEMP, PHITEMP, MNEW, FREQ, TITLE )

C        --- copy into the big matrix
         DO 1000 MODE = 1, MNEW
            DO 500 ISD = 1, NSD
               PHIS( IOC, MODE, ISD ) = PHITEMP( MODE, ISD )
  500       CONTINUE
 1000    CONTINUE

         CALL GETMOD( IOC, ' ', MXM, RD, NRD, COMP,
     &      CKTEMP, PHITEMP, MNEW, FREQ, TITLE )

C        --- copy into the big matrix
         DO 1800 MODE = 1, MNEW
            DO 1500 IRD = 1, NRD
               PHIR( IOC, MODE, IRD ) = PHITEMP( MODE, IRD )
 1500       CONTINUE
            CK( IOC, MODE ) = CKTEMP( MODE )
 1800    CONTINUE

         M = MIN( M, MNEW )
 2000 CONTINUE   ! Next ocean

C     ------ Generate header
      IF ( SHTITL(1:1) .EQ. '$' ) SHTITL = TITLE
      CALL HEADER( SHTITL, SD, NSD, RD, NRD,
     &   W, NW, FREQ, ATTEN, '     ', 0.0, 0.0, 0.0 )
      IREC = 6

C     *** MAIN LOOP: For each source evaluate and write the field ***

      DO 8000 J = 1, NSD

C        --- Initialize counter
         DO 3700 IOC = 1, NOC
            CTR( IOC ) = 0
 3700    CONTINUE

         DO 7000 I = 1, NW ** ( NOC - 2 )

C           --- increment the counter and assign the weight
            IF ( NOC .GE. 3 ) THEN
            DO 6500 IOC = 3, NOC
               IF ( CTR( IOC ) .GT. NW ) THEN
                  CTR( IOC ) = 1
               ELSE
                  CTR( IOC ) = CTR( IOC ) + 1
               ENDIF
               ALPHA( IOC ) = W( CTR( IOC ) )
 6500       CONTINUE
            ENDIF

C           ****** Interpolate the modes ******

            DO 6000 MODE = 1, M

C              --- initialize
               CKA( MODE ) = CK( 1, MODE )
               CKB( MODE ) = CK( 2, MODE )

               DO 2600 ISD = 1, NSD
                  PHISA( MODE, ISD ) = PHIS( 1, MODE, ISD )
                  PHISB( MODE, ISD ) = PHIS( 2, MODE, ISD )
 2600          CONTINUE

               DO 2700 IRD = 1, NRD
                  PHIRA( MODE, IRD ) = PHIR( 1, MODE, IRD )
                  PHIRB( MODE, IRD ) = PHIR( 2, MODE, IRD )

 2700          CONTINUE

C              --- add in weighted data from other oceans

               IF ( NOC .GE. 3 ) THEN
               DO 4000 IOC = 3, NOC
C                 --- following can be done more efficiently but ...
                  CKA( MODE ) = CKA( MODE )
     &                  + ALPHA( IOC ) * CK( IOC, MODE )
                  CKB( MODE ) = CKB( MODE )
     &                  + ALPHA( IOC ) * CK( IOC, MODE )

                  DO 3600 ISD = 1, NSD
                     PHISA( MODE, ISD ) = PHISA( MODE, ISD )
     &                  + ALPHA( IOC ) * PHIS( IOC, MODE, ISD )
                     PHISB( MODE, ISD ) = PHISB( MODE, ISD )
     &                  + ALPHA( IOC ) * PHIS( IOC, MODE, ISD )
 3600             CONTINUE

                  DO 3800 IRD = 1, NRD
                     PHIRA( MODE, IRD ) = PHIRA( MODE, IRD )
     &                  + ALPHA( IOC ) * PHIR( IOC, MODE, IRD )
                     PHIRB( MODE, IRD ) = PHIRB( MODE, IRD )
     &                  + ALPHA( IOC ) * PHIR( IOC, MODE, IRD )
 3800             CONTINUE

 4000          CONTINUE  ! Next ocean
               ENDIF

 6000       CONTINUE  ! Next mode

            CALL EVALMO( PHISA( 1, J ), PHISB( 1, J ),
     &         CKA, CKB, PHIRA, PHIRB, M,
     &         RD, NRD, W, NW,
     &         R, OPT, P )

            CALL WRTFLD( P, NRD, NW, IREC )
 7000    CONTINUE   ! Next weight

 8000 CONTINUE  ! Next source depth

      STOP
      END

      PROGRAM SPARC

C     Finite element time domain fast-field program
C     Michael B. Porter   10/87

      INCLUDE 'COMSPA.FOR'

      REAL*8 TEND
      COMPLEX GREEN( 300000 )
      REAL RTSRD( 300000 ), RTSRR( 300000 )
      EQUIVALENCE ( GREEN, RTSRD, RTSRR )

      CALL CLTIME

      CALL GETPAR

      DO MED = 1, NMEDIA
         H( MED ) = ( DEPTH( MED + 1 ) - DEPTH( MED ) ) / N( MED )
      END DO

      CALL INIT
      CALL WRTHED
      CALL KERNEL( GREEN, RTSRD, RTSRR )

      CALL RDTIME( TEND )
      WRITE( PRTFIL, 5000) TEND
 5000 FORMAT(' CPU TIME: ', G15.5)

      STOP
      END
C**********************************************************************C
      SUBROUTINE GETPAR

C     Read in the ENVFIL data

      INCLUDE 'COMSPA.FOR'

      REAL*8 FREQ, RHOTD, RHOBD, BUMDEN, ETA, XI
      COMPLEX*16 CPTD, CSTD, CPBD, CSBD

C     *** Call READIN to get most of the environmental data ***

      TITLE = 'SPARC-   '
      CALL READIN( TITLE, FREQ, MXMED, NMEDIA,
     &   TOPOPT, CPTD, CSTD, RHOTD, BUMDEN, ETA, XI, N, SIGMA, DEPTH, 
     &   BOTOPT, CPBD, CSBD, RHOBD,
     &   ENVFIL, PRTFIL )

C     *** Spectral limits ***

      READ(  ENVFIL, *    ) CLOW, CHIGH
      WRITE( PRTFIL, 6000 ) CLOW, CHIGH
 6000 FORMAT( /, ' CLOW = ', G12.5, '  CHIGH = ', G12.5 )

C     *** Maximum range for calculations ***

      READ(  ENVFIL, * ) RMAX
      WRITE( PRTFIL, * ) 'RMAX = ', RMAX

C     *** Read source/receiver depths ***

      ZMIN = DEPTH( 1 )
      ZMAX = DEPTH( NMEDIA + 1 )

      CALL SDRD( ENVFIL, PRTFIL, ZMIN, ZMAX,
     &   MAXNSD, NSD, SD,
     &   MAXNRD, NRD, RD )

      OMEGA2 = ( 2.0 * PI * FREQ ) ** 2

      CPT  = CPTD
      CST  = CSTD
      RHOT = RHOTD
      CPB  = CPBD
      CSB  = CSBD
      RHOB = RHOBD

C     *  Upper and lower frequency limits *

      READ( ENVFIL, * ) PULSE, FMIN, FMAX

C     ------ integration parameters
      RKMIN = 2.0 * PI * FMIN / CHIGH
      RKMAX = 2.0 * PI * FMAX / CLOW
      IF ( CHIGH .GE. 1.0E6 ) RKMIN = 0.0

      NKPTS = 1000.0 * RMAX * ( RKMAX - RKMIN ) / ( 2.0 * PI )

      IF ( NKPTS .GT. MXNK ) THEN
         WRITE( PRTFIL, * ) 'NKPTS, MXNK = ', NKPTS, MXNK
         CALL ERROUT( PRTFIL, 'F', 'GETPAR',
     &      'Too many pts in k-space'  )
      ENDIF

      WRITE( PRTFIL, * ) 'NKPTS = ', NKPTS

      DELTAK = ( RKMAX - RKMIN ) / ( NKPTS - 1 )
      DO IK = 1, NKPTS
         RK( IK ) = RKMIN + ( IK - 1 ) * DELTAK
      END DO

      IF ( PULSE(1:1) .EQ. 'P' ) THEN
         WRITE( PRTFIL, * ) 'Pseudo-gaussian pulse'
      ELSE IF ( PULSE(1:1) .EQ. 'R' ) THEN
         WRITE( PRTFIL, * ) 'Ricker wavelet'
      ELSE IF ( PULSE(1:1) .EQ. 'A' ) THEN
         WRITE( PRTFIL, * ) 'Approximate Ricker wavelet'
      ELSE IF ( PULSE(1:1) .EQ. 'S' ) THEN
         WRITE( PRTFIL, * ) 'Single sine source'
      ELSE IF ( PULSE(1:1) .EQ. 'H' ) THEN
         WRITE( PRTFIL, * ) 'Hanning weighted four sine pulse'
      ELSE IF ( PULSE(1:1) .EQ. 'N' ) THEN
         WRITE( PRTFIL, * ) 'N-wave pulse'
      ELSE IF ( PULSE(1:1) .EQ. 'M' ) THEN
         WRITE( PRTFIL, * ) 'Miracle-wave pulse'
      ELSE IF ( PULSE(1:1) .EQ. 'G' ) THEN
         WRITE( PRTFIL, * ) 'Gaussian pulse'
      ELSE IF ( PULSE(1:1) .EQ. 'F' ) THEN
         WRITE( PRTFIL, * ) 'Source time series from File'
      ELSE IF ( PULSE(1:1) .EQ. 'B' ) THEN
         WRITE( PRTFIL, * ) 'Source time series reversed from file'
      ELSE
         CALL ERROUT( PRTFIL, 'F', 'GETPAR',
     &      'Unknown source type'  )
      ENDIF

C     *** Read receiver ranges ***

      RR( 3 ) = -999.9
      READ( ENVFIL, * ) NRR, ( RR( IRR ), IRR = 1, NRR )

      IF ( NRR .GT. MXNRR ) THEN
         WRITE( PRTFIL, * ) 'NRR, MXNRR = ', NRR, MXNRR
         CALL ERROUT( PRTFIL, 'F', 'GETPAR',
     &      'Too many receiver ranges'  )
      ENDIF

      CALL SUBTAB( RR, NRR )
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Number of receiver ranges = ', NRR
      WRITE( PRTFIL, * ) ( RR( IRR ), IRR = 1, MIN( NRR, 51 ) )

C     *** Read in the output times ***

      TOUT( 3 ) = -999.9
      READ( ENVFIL, * ) NTOUT, ( TOUT( ITOUT ), ITOUT = 1, NTOUT )

      IF ( NTOUT .GT. MXNTOUT ) THEN
         WRITE( PRTFIL, * ) 'NTOUT, MXNTOUT = ', NTOUT, MXNTOUT
         CALL ERROUT( PRTFIL, 'F', 'GETPAR',
     &      'Too many output times'  )
      ENDIF

      CALL SUBTAB( TOUT, NTOUT )
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Number of output times = ', NTOUT
      WRITE( PRTFIL, * ) ( TOUT( ITOUT ), ITOUT = 1, MIN( NTOUT, 51 ) )

C     *** Integration parameters ***
C     ALPHA = 0.0  lumped mass matrix,
C             1.0  consistent mass matrix
C     BETA = 0.0  standard explicit,
C            0.25 standard implicit 
 
      READ(  ENVFIL, * ) TSTART, TMULT, ALPHA, BETA, V
      WRITE( PRTFIL, * ) 'TSTART = ', TSTART
      WRITE( PRTFIL, * ) 'TMULT  = ', TMULT
      WRITE( PRTFIL, * ) 'ALPHA  = ', ALPHA
      WRITE( PRTFIL, * ) 'BETA   = ', BETA
      WRITE( PRTFIL, * ) 'V      = ', V

      CLOSE ( ENVFIL )
      RETURN
      END
C**********************************************************************C
      SUBROUTINE INIT

C     Initializes arrays defining difference equations

      INCLUDE 'COMSPA.FOR'

      REAL*8 FREQ
      COMPLEX*16 CP( MXN ), CS( MXN )

      CMIN   =  1.0E6
      CMAX   = -1.0E6
      CROSST =  1.0E6
      LOC( 1 ) = 0
      J = 0

C     *** Loop over successive media ***

      DO MED = 1, NMEDIA

         IF ( SIGMA( MED ) .NE. 0.0 ) THEN
            CALL ERROUT( PRTFIL, 'F', 'INIT',
     &         'Rough interfaces not allowed'  )
         ENDIF

         IF ( MED .NE. 1 ) LOC(MED) = LOC(MED-1) + N(MED-1) + 1
         N1 = N( MED ) + 1

         CALL PROFIL( DEPTH, CP, CS, RHO( LOC( MED ) + 1 ),
     &      MED, N1, FREQ, TOPOPT(1:1), TOPOPT(3:3), 'TAB',
     &      ENVFIL, PRTFIL )

         DO I = 1, N1
            CPR  = REAL( CP( I ) )
            CMIN = MIN( CPR, CMIN )
            CMAX = MAX( CPR, CMAX )

            CROSST1 = REAL( H( MED ) / CP( I ) )
            CROSST  = AMIN1( CROSST1, CROSST )

            J = J + 1
            CPT = CP( I )   ! convert to single precision
            C2R( J ) =  REAL( CPT**2 )  ! CHECK THIS
            C2I( J ) = AIMAG( CPT**2 ) / SQRT( OMEGA2 ) / C2R( J )
         END DO

      END DO

C     *** Tabulate z-coordinates ***

      J = 1
      Z( 1 ) = DEPTH( 1 )
      NTOT = 0

      DO MED = 1, NMEDIA
         DO I = 1, N( MED )
            J = J + 1
            Z( J ) = Z( J - 1 ) + H( MED )
         END DO
         NTOT = NTOT + N( MED )
      END DO

      NTOT1 = NTOT + 1

C     * Compute weights for source/rcvr depth interpolation *

      CALL WEIGHT( Z, NTOT1, SD, NSD, WS, ISD )
      CALL WEIGHT( Z, NTOT1, RD, NRD, WR, IRD )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE KERNEL( GREEN, RTSRD, RTSRR )

C     Solve system for a sequence of k-values

      INCLUDE 'COMSPA.FOR'

      REAL RTSRD( NRD, * ), RTSRR( NRR, * )
      COMPLEX GREEN( NTOUT, NRD, * )

C     ------ Clear RTS

      IF ( TOPOPT(4:4) .EQ. 'D' ) THEN
         DO ITOUT = 1, NTOUT
            DO IR = 1, NRD
               RTSRD( IR, ITOUT ) = 0.0
            END DO
         END DO
      END IF

      IF ( TOPOPT(4:4) .EQ. 'R' ) THEN
         DO ITOUT = 1, NTOUT
            DO IR = 1, NRR
               RTSRR( IR, ITOUT ) = 0.0
            END DO
         END DO
      END IF

C     * Courant condition to set time step *

      DELT = TMULT /
     &       SQRT( 1.0 / CROSST**2 + ( 0.5 * CMAX * RK(NKPTS) ) **2 )

      WRITE( PRTFIL, * ) 'Time step = ', DELT
      WRITE( PRTFIL, * ) 'Estimated fl. pt. ops (millions) = ',
     &   ( TOUT( NTOUT ) / DELT ) * NKPTS * NTOT1 / 25000

C     *** Loop over spectral components ***

      IKCORE = 0
      IFLUSH = 0      ! Keeps track of number of records flushed

      DO IK = 1, NKPTS
         IKCORE = IKCORE + 1
         X = RK( IK ) ** 2
C         DELT = TMULT /
C     &             SQRT( 1.0 / CROSST**2 + ( 0.5 * CMAX * X ) **2 )
C         IF ( 10*(IK/10) .EQ. IK ) WRITE( 6, * ) 'IK, NKPTS', IK, NKPTS
         WRITE( 6, * ) 'IK, NKPTS', IK, NKPTS

C        *** March that component for all time ***

         CALL MARCH( X, GREEN, IKCORE, RTSRD, RTSRR )

C        *** Snapshot: need to flush buffer?  ***

         IF ( TOPOPT(4:4) .EQ. 'S' ) THEN
         IF ( IKCORE .EQ. NKCORE .OR. IK .EQ. NKPTS ) THEN
C           ------ number of records per S/R combo:
            NRECSR = ( NKPTS - 1 ) / NKCORE + 1

            DO ITOUT = 1, NTOUT
               DO IR = 1, NRD
C                 ------ Index of source/rcvr combo
                  IG = ( ITOUT - 1 ) * NRD + IR
                  IREC = 6 + IG * NRECSR + IFLUSH
                  WRITE( GRNFIL, REC = IREC)
     &               ( GREEN( ITOUT, IR, IKCORE ), IKCORE = 1, NKCORE )
               END DO
            END DO

            IKCORE = 0
            IFLUSH = IFLUSH + 1
         ENDIF
         ENDIF
      END DO

C     *** Write out RTS (vertical array) *

      IF ( TOPOPT(4:4) .EQ. 'D' ) THEN
         SCALE = 1.0 / SQRT( PI * 1000.0 * RR( 1 ) )
         DO ITOUT = 1, NTOUT
            WRITE( RTSFIL, * ) TOUT( ITOUT ),
     &         ( SCALE * RTSRD( IR, ITOUT ), IR = 1, NRD )
 5500       FORMAT( 12G15.6 )
         END DO
      ENDIF

C     *** Write out RTS (horizontal array) ***

      IF ( TOPOPT(4:4) .EQ. 'R' ) THEN
         DO ITOUT = 1, NTOUT
            WRITE( RTSFIL, * ) TOUT( ITOUT ),
     &         ( RTSRR( IRR, ITOUT ), IRR = 1, NRR )
         END DO
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE WRTHED

C     Writes headers for disk files

      INCLUDE 'COMSPA.FOR'
      REAL*8 FREQ

      IF ( TOPOPT(4:4) .EQ. 'S' ) THEN

C        *** Case of a snapshot ***

         NSR    = NTOUT * NRD
         NKCORE = MIN( 300000 / NSR, NKPTS, 4094 )
         FREQ   = 0.0
         CALL HEADER( FREQ )

      ELSE IF ( TOPOPT(4:4) .EQ. 'R' ) THEN

C        *** Horizontal array ***

         OPEN ( FILE = 'RTSFIL', UNIT = RTSFIL, STATUS = 'NEW',
     &          FORM = 'FORMATTED' )

         WRITE( RTSFIL, * ) '''' // TITLE(1:75) // ''''
         WRITE( RTSFIL, * ) NRR, ( RR( IRR ), IRR = 1, NRR )
 5500    FORMAT( I5, 11G15.6 )

      ELSE IF ( TOPOPT(4:4) .EQ. 'D' ) THEN

C        *** Vertical array ***

         OPEN ( FILE = 'RTSFIL', UNIT = RTSFIL, STATUS = 'NEW',
     &          FORM = 'FORMATTED' )

         WRITE( RTSFIL, * ) '''' // TITLE(1:75) // ''''
         WRITE( RTSFIL, * ) NRD, ( RD( IR ), IR = 1, NRD )
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE HEADER( FREQ )

C     Routine to write header to disk file

      INCLUDE 'COMSPA.FOR'

      REAL*8 FREQ
      CHARACTER PLTTYP*10

      LRECL  = MAX( 40, 2 * NKCORE, NTOUT + 1, NRD + 1 )
      NRECSR = ( NKPTS - 1 ) / NKCORE + 1
      ATTEN  = 0.0
      PLTTYP = 'GREEN'
      XS = 0.0
      YS = 0.0
      THETA = 0.0

      OPEN ( FILE = 'GRNFIL', UNIT = GRNFIL, STATUS = 'NEW',
     &   ACCESS = 'DIRECT', RECL = 4 * LRECL, FORM = 'UNFORMATTED')

      WRITE( GRNFIL, REC = 1 ) LRECL, TITLE
      WRITE( GRNFIL, REC = 2 ) PLTTYP, XS, YS, THETA
      WRITE( GRNFIL, REC = 3 ) REAL( FREQ ), NTOUT, NRD, NKPTS,
     &   NKCORE, DELTAK, ATTEN, NRECSR
      WRITE( GRNFIL, REC = 4 ) ( TOUT( I ), I = 1, NTOUT )
      WRITE( GRNFIL, REC = 5 ) ( RD(   I ), I = 1, NRD )

      DO IREC = 1, NRECSR
         ISTART = ( IREC - 1 ) * NKCORE
         WRITE( GRNFIL, REC = 5 + IREC)
     &      ( RK( ISTART + I ), I = 1, NKCORE)
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE MARCH( X, GREEN, IKCORE, RTSRD, RTSRR )

C     March a single spectral component forward in time

      INCLUDE 'COMSPA.FOR'

      REAL RTSRD( NRD, * ), RTSRR( NRR, * )
      COMPLEX AD2( MXN ), AE2( MXN ), AD1( MXN ), AE1( MXN ),
     &        AD0( MXN ), AE0( MXN ),
     &   RV1( MXN ), RV2( MXN ), RV3( MXN ), RV4( MXN ),
     &   U0( MXN ), U1( MXN ), U2( MXN ), GREEN( NTOUT, NRD, * )

C     *** Assemble mass and stiffness matrices ***

      RKT  = SQRT( X )
      NODE = 1
      L    = LOC( 1 ) + 1

      AD2( 1 ) = 0.0
      AD1( 1 ) = 0.0
      AD0( 1 ) = 0.0

      DO MED = 1, NMEDIA
         HELT = H( MED )

         DO I = 1, N(MED)
            RHOELT = ( RHO( L ) + RHO( L + 1 ) ) / 2.0
            C2RELT = ( C2R( L ) + C2R( L + 1 ) ) / 2.0
            C2IELT = ( C2I( L ) + C2I( L + 1 ) ) / 2.0

            CALL CONTRIB( NODE, X, RKT, V, RHOELT, C2RELT, C2IELT,
     &         HELT, DELT, AD2, AE2, AD1, AE1, AD0, AE0, ALPHA, BETA )

            NODE = NODE + 1
            L    = L    + 1
         END DO

         L = L + 1
      END DO

C     * Factor A2 *

      CALL FACTOR( NTOT1, AD2, AE2, IERR, RV1, RV2, RV3, RV4 )

C     * Initialize pressure vectors *

      DO NODE = 1, NTOT1
         U0( NODE ) = 0.0
         U1( NODE ) = 0.0
         U2( NODE ) = 0.0
      END DO

C     *** Some initialization ***

      IF ( PULSE(4:4) .EQ. 'L' .OR. PULSE(4:4) .EQ. 'B' ) THEN
         FLOCUT = RKT * CLOW / ( 2.0 * PI )
      ELSE
         FLOCUT = 0.0
      ENDIF

      IF ( PULSE(4:4) .EQ. 'H' .OR. PULSE(4:4) .EQ. 'B' ) THEN
         FHICUT = RKT * CHIGH / ( 2.0 * PI )
      ELSE
         FHICUT = 10.0 * FMAX
      ENDIF

      TIME   = 0.0

C     *** Begin forward march ***

      ITOUT = 1
      DO ITIME = 1, MXIT
         TIME = TSTART + ( ITIME - 1 ) * DELT

C        * Take a step forward in time *

         CALL STEP( AD0, AE0, AD1, AE1, AD2, AE2, RV1, RV2, RV3, RV4,
     &      U0, U1, U2, TIME, RKT, FLOCUT, FHICUT )

C        * Extract soln for desired receivers *

         CALL EXTRACT( U0, U1, GREEN, IKCORE, RTSRD, RTSRR,
     &      TIME, ITOUT, RKT )

         IF ( ITOUT .GT. NTOUT ) RETURN
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE CONTRIB( NODE, X, RKT, V, RHOELT, C2RELT, C2IELT,
     &   HELT, DELT, AD2, AE2, AD1, AE1, AD0, AE0, ALPHA, BETA )

C     Computes the contribution for the given element

      COMPLEX AD2( * ), AE2( * ), AD1( * ), AE1( * ), AD0( * ),
     &   AE0( * ), KE( 2, 2 ), CE( 2, 2 ), ME( 2, 2 ), Y, Z, CI
      PARAMETER ( CI = ( 0.0, 1.0 ) )

C     ALPHA controls lumping and BETA controls implicitness

      DELT2 = DELT ** 2
      RHOH  = RHOELT * HELT

C     * Elemental stiffness matrix ( +k2 term ) *

      Y = 1.0 + CI * RKT * V * C2IELT
      Z = X * ( Y - V * V / C2RELT )
      KE( 1, 1 ) =  Y / RHOH + (3.0-ALPHA) * HELT * Z / RHOELT / 6.0
      KE( 1, 2 ) = -Y / RHOH +      ALPHA  * HELT * Z / RHOELT / 6.0
      KE( 2, 2 ) =  Y / RHOH + (3.0-ALPHA) * HELT * Z / RHOELT / 6.0

C     * Elemental damping matrix *

      Z = 2.0*CI*RKT*V/C2RELT
      CE( 1, 1 ) = C2IELT * ( 1.0/RHOH + (3.0-ALPHA)*HELT*X/RHOELT/6.0)
     &                                 + (3.0-ALPHA)*HELT*Z/RHOELT/6.0
      CE( 1, 2 ) = C2IELT * (-1.0/RHOH +      ALPHA *HELT*X/RHOELT/6.0)
     &                                 +      ALPHA *HELT*Z/RHOELT/6.0
      CE( 2, 2 ) = C2IELT * ( 1.0/RHOH + (3.0-ALPHA)*HELT*X/RHOELT/6.0)
     &                                 + (3.0-ALPHA)*HELT*Z/RHOELT/6.0

C     * Elemental mass matrix *

      ME( 1, 1 ) = (3.0-ALPHA) * HELT / ( RHOELT * C2RELT ) / 6.0
      ME( 1, 2 ) =      ALPHA  * HELT / ( RHOELT * C2RELT ) / 6.0
      ME( 2, 2 ) = (3.0-ALPHA) * HELT / ( RHOELT * C2RELT ) / 6.0

C     * A2 matrix *

      AD2( NODE   ) = AD2( NODE ) +
     &                ME(1,1) + 0.5*DELT*CE(1,1) + BETA*DELT2*KE(1,1)
      AE2( NODE+1 ) = ME(1,2) + 0.5*DELT*CE(1,2) + BETA*DELT2*KE(1,2)
      AD2( NODE+1 ) = ME(2,2) + 0.5*DELT*CE(2,2) + BETA*DELT2*KE(2,2)

C     * A1 matrix *

      AD1( NODE   ) = AD1( NODE ) +
     &                2.0*ME(1,1) - ( 1.0 - 2.0*BETA )*DELT2*KE(1,1)
      AE1( NODE+1 ) = 2.0*ME(1,2) - ( 1.0 - 2.0*BETA )*DELT2*KE(1,2)
      AD1( NODE+1 ) = 2.0*ME(2,2) - ( 1.0 - 2.0*BETA )*DELT2*KE(2,2)

C     * A0 matrix *

      AD0( NODE   ) = AD0( NODE )
     &                -ME(1,1) + 0.5*DELT*CE(1,1) - BETA*DELT2*KE(1,1)
      AE0( NODE+1 ) = -ME(1,2) + 0.5*DELT*CE(1,2) - BETA*DELT2*KE(1,2)
      AD0( NODE+1 ) = -ME(2,2) + 0.5*DELT*CE(2,2) - BETA*DELT2*KE(2,2)

      RETURN
      END
C**********************************************************************C
      SUBROUTINE STEP( AD0, AE0, AD1, AE1, AD2, AE2,
     &   RV1, RV2, RV3, RV4, U0, U1, U2, TIME, RKT, FLOCUT, FHICUT )

C     Take a time step

C     This is the inner loop.  Note that a significant speed-up can
C     be obtained by using real arithmetic and eliminating the
C     tridiagonal solver if the Hilbert transform is bypassed and the
C     explicit solver is used.

      INCLUDE 'COMSPA.FOR'

      COMPLEX AD2( * ), AE2( * ), AD1( * ), AE1( * ), AD0( * ),
     &   AE0( * ),      RV1( * ), RV2( * ), RV3( * ), RV4( * ),
     &   U0( * ), U1( * ), U2( * ), ST( MAXNSD )
      CHARACTER PULSTITL*60

      OMEGA = SQRT( OMEGA2 )
      DELT2 = DELT ** 2

C     *** Form U2TEMP = A1*U1 + A0*U0 + S ***

C     ------ Surface point
      J = 1
      U2(J) = AD1(J) * U1(J) + AE1(J+1) * U1(J+1) +
     &        AD0(J) * U0(J) + AE0(J+1) * U0(J+1)

C     ------ Interior points
      DO J = 2, NTOT1 - 1
         U2(J) = AD1(J) * U1(J) + AE1(J) * U1(J-1) + AE1(J+1) * U1(J+1)
     &         + AD0(J) * U0(J) + AE0(J) * U0(J-1) + AE0(J+1) * U0(J+1)
      END DO

C     ------ Bottom point
      J = NTOT1
      U2(J) = AD1(J) * U1(J) + AE1(J) * U1(J-1) + 
     &        AD0(J) * U0(J) + AE0(J) * U0(J-1)

C     *** Source terms ***

      NTPTS = 1
      CALL SOURCE( TIME, ST, SD, NSD, NTPTS,
     &             OMEGA, FLOCUT, FHICUT, PULSE, PULSTITL )

      MED = 1	  ! Assumes source in first medium

      DO IS = 1, NSD
         ISDT = ISD( IS )
         JS   = LOC( 1 ) + ISDT + ( MED - 1 )

         ST( IS ) = DELT2 * ST( IS ) * EXP( -CI * RKT * V * TIME )

         U2( JS   ) = U2( JS   ) + ( 1.0 - WS( IS ) ) * ST( IS )
         U2( JS+1 ) = U2( JS+1 ) +         WS( IS )   * ST( IS )
      END DO

C     *** Solve A2*U2 = U2TEMP ***

C     --- Implicit or explicit solver?

      IF ( ALPHA .EQ. 0.0 .AND. BETA .EQ. 0.0 ) THEN
         DO I = 1, NTOT1
            U2( I ) = U2( I ) / AD2( I )
         END DO
      ELSE
         CALL BACKSB( NTOT1, AD2, AE2, IERR, RV1, RV2, RV3, RV4, U2 )
      ENDIF

C     Do a roll

      DO J = 1, NTOT1
         U0( J ) = U1( J )
         U1( J ) = U2( J )
      END DO

C     * Boundary conditions (natural is natural) *

      IF ( TOPOPT(2:2) .EQ. 'V' ) U1( 1 )     = 0.0
      IF ( BOTOPT(1:1) .EQ. 'V' ) U1( NTOT1 ) = 0.0

      RETURN
      END
C**********************************************************************C
      SUBROUTINE EXTRACT( U0, U1, GREEN, IKCORE, RTSRD, RTSRR,
     &   TIME, ITOUT, RKT )

C     Extract solution (snapshot, vertical or horizontal array)

      INCLUDE 'COMSPA.FOR'

      REAL RTSRD( NRD, * ), RTSRR( NRR, * )
      COMPLEX U0( * ), U1( * ), UT1, UT2, U, CONST, REST,
     &   GREEN( NTOUT, NRD, * )

C     *** Three cases: snapshot, vertical, horizontal time series ***

C     simulate:
C     DO WHILE ( TIME + DELT .GE. TOUT( ITOUT ) .AND. ITOUT .LE. NTOUT )

      DO IDUM = 1, 1000
         IF ( TIME + DELT .LT. TOUT( ITOUT ) .OR.
     &      ITOUT .GT. NTOUT ) RETURN

C        ------ Weight for temporal interpolation:
         WT = ( TOUT( ITOUT ) - TIME ) / DELT

         IF ( TOPOPT(4:4) .EQ. 'S' ) THEN

C           *** Case of a snapshot ***

            CONST = EXP( CI * RKT * V * TOUT( ITOUT ) )

            DO IR = 1, NRD
C              ------ Linear interpolation in depth
               I = IRD( IR )
               UT1 = U0( I ) + WR( IR ) * ( U0( I+1 ) - U0( I ) )
               UT2 = U1( I ) + WR( IR ) * ( U1( I+1 ) - U1( I ) )
C              ------ Linear interpolation in time
               GREEN( ITOUT, IR, IKCORE ) = CONST*(UT1 + WT*(UT2-UT1))
            END DO

         ELSE IF ( TOPOPT(4:4) .EQ. 'D' ) THEN

C           *** Case of an RTS (vertical array) ***

            RM = 1000.0 * RR( 1 )     ! Range (in meters)
C           CONST = -SQRT(2.0) * DELTAK * SQRT(RKT) * COS(RKT*RM-PI/4.0)
            CONST = SQRT( 2.0 ) * DELTAK * SQRT( RKT ) *
     &         EXP( CI*( RKT * ( V * TOUT( ITOUT ) - RM ) + PI / 4.0 ) )

            DO IR = 1, NRD
C              ------ Linear interpolation in depth
               I = IRD( IR )

               UT1 = U0( I ) + WR( IR ) * ( U0( I+1 ) - U0( I ) )
               UT2 = U1( I ) + WR( IR ) * ( U1( I+1 ) - U1( I ) )

C              ------ Linear interpolation in time
               U = UT1 + WT * ( UT2 - UT1 )

               RTSRD( IR, ITOUT ) = RTSRD( IR, ITOUT ) + CONST * U
            END DO

         ELSE IF ( TOPOPT(4:4) .EQ. 'R' .AND. TIME .GE. TOUT(1) ) THEN

C           *** Case of an RTS (horizontal array) ***

C           ------ Linear interpolation in depth
            I = IRD( 1 )
            T = ( RD( 1 ) - Z( I ) ) / ( Z( I + 1 ) - Z( I ) )

            UT1 = U0( I ) + T * ( U0( I+1 ) - U0( I ) )
            UT2 = U1( I ) + T * ( U1( I+1 ) - U1( I ) )

C           ------ Linear interpolation in time
            U = UT1 + WT * ( UT2 - UT1 )

            CONST = SQRT( 2.0 ) * EXP( CI * RKT * V * TIME )

            DO IRNG = 1, NRR
               RM = 1000.0 * RR( IRNG )     ! Range in meters
C              REST = -SQRT(2.0) * COS( RKT*RM-PI/4.0 ) * SQRT(RKT/RM)
               REST = CONST * EXP( CI * ( -RKT * RM + PI / 4.0 ) ) *
     &                              SQRT( RKT / RM )
               RTSRR( IRNG, ITOUT ) =
     &            RTSRR( IRNG, ITOUT ) + DELTAK * U * REST
            END DO

         ENDIF
         ITOUT = ITOUT + 1

      END DO

      RETURN
      END

      PROGRAM PLOTRTH

C     Plots the reflection coefficient

      INTEGER IRCFIL, PLPFIL, PRTFIL
      COMPLEX CI
      PARAMETER( PLPFIL = 1, PRTFIL = 6, IRCFIL = 10,
     &   PI = 3.141592, CI = ( 0.0, 1.0 ),
     &   RADDEG = 180.0 / PI, MXNKPTS = 30000 )

      INTEGER ITAB( MXNKPTS )
      REAL R( MXNKPTS ), TH( MXNKPTS ), PHASE( MXNKPTS ), K0, KX, KZ
      REAL*8 XTAB( MXNKPTS )
      COMPLEX Z, RCMPLX
      COMPLEX*16 FTAB( MXNKPTS ), GTAB( MXNKPTS )
      CHARACTER TITLE*80, TITLEY*80, OPT*5

C     Note: we assume unit density in the upper medium

C     Read user parameters

      OPEN( FILE = 'PLPFIL', UNIT = PLPFIL, STATUS = 'OLD' )
      READ( PLPFIL, * ) OPT
      READ( PLPFIL, * ) C0

      THMIN =  0.0
      THMAX = 90.0

      READ( PLPFIL, * ) THMIN, THMAX

C     Initialize plotting

      TITLEY = 'Refl. coef.$'
      IF ( OPT(1:1) .EQ. 'D' ) TITLEY = 'Refl. loss (dB)$'

C     *** Read IRCFIL and convert to R( theta ) ***

      OPEN( FILE = 'IRCFIL', UNIT = IRCFIL, STATUS = 'OLD' )
      READ( IRCFIL, * ) TITLE, FREQ
      READ( IRCFIL, * ) NKPTS, ( XTAB( IK ), FTAB( IK ), GTAB( IK ), 
     &                                     ITAB( IK ), IK = 1, NKPTS )

      OMEGA = 2.0 * PI * FREQ
      K0 = OMEGA / C0

C     *** Convert to impedance and plot ***

      DO IK = 1, NKPTS

C        --- compute the impedance Z = G / F
         IF ( ABS( FTAB( IK ) ) .LT. 1.0E-25 ) THEN
            Z = 0.0
         ELSE
            Z = GTAB( IK ) / FTAB( IK )
         ENDIF

         C  = OMEGA / SQRT( XTAB( IK ) )
         KX = SQRT( XTAB( IK ) )

C        --- compute the vertical wavenumber kz
         IF ( K0 ** 2 .LT. KX ** 2 ) THEN
            KZ = 0.0
         ELSE
            KZ = SQRT( K0 ** 2 - KX ** 2 )
         ENDIF

C        --- convert wavenumbers (kx, kz) to angles
C         IF ( KZ .GT. 1.0E6 * KX ) THEN
C            TH( IK ) = 0.0
C         ELSE
            TH( IK ) = RADDEG * ATAN( KZ / KX )
C         ENDIF

C        --- convert impedance Z to reflection coef. R

         RCMPLX =  - ( 1.0 - CI * KZ * Z )
     &             / ( 1.0 + CI * KZ * Z )

         R(     IK ) = ABS( RCMPLX )
         PHASE( IK ) = ATAN2( AIMAG( RCMPLX ), REAL( RCMPLX ) )

C        --- dB, degrees for units?
         IF ( OPT(1:1) .EQ. 'D' ) R( IK ) = -20.0 * ALOG10( R( IK ) )
         IF ( OPT(2:2) .EQ. 'D' ) PHASE( IK ) = RADDEG * PHASE( IK )

      END DO   ! next k-point

C     *** Write data ***

      LAST = INDEX( TITLE, '    ' ) - 1
      WRITE( PRTFIL, 1000 ) TITLE(1:LAST)
 1000 FORMAT( '@ title "', A, '"' )

      WRITE( PRTFIL, 2000 ) NINT( FREQ )
 2000 FORMAT(  '@ subtitle "',
     &         'F  =', I4, ' Hz"' )
 
      WRITE( *, 5000 )
 5000 FORMAT( '@WITH G1', /,
     &        '@G1 ON', /,
     &        '@TYPE xy' )

      DO IK = 1, NKPTS
         WRITE( PRTFIL, * ) TH( IK ), R( IK )
      END DO
      WRITE( PRTFIL, * ) '&'

      WRITE( *, 6000 )
 6000 FORMAT( '@WITH G0', /,
     &        '@G0 ON', /,
     &        '@TYPE xy' )
 
      DO IK = 1, NKPTS
         WRITE( PRTFIL, * ) TH( IK ), PHASE( IK )
      END DO

C     *** produce a reflection coefficient file in the BELLHOP format

      IF( OPT(3:3) .EQ. 'F' ) THEN
         WRITE( PRTFIL, * ) NKPTS
         DO IK = NKPTS, 1, -1
            IF ( PHASE( IK ) .LT. 0.0 ) PHASE( IK ) = PHASE( IK ) + 360.0
            WRITE( PRTFIL, * ) TH( IK ), R( IK ), PHASE( IK )
         END DO
      END IF

      STOP
      END

      PROGRAM PLTTLR

C     Plot the propagation loss along a specified track

      INTEGER PLPFIL, PRTFIL
      PARAMETER ( PLPFIL = 1, PRTFIL = 6, MAXM = 1500, MAXN = 5000,
     &   MAXNR = 5000, MAXNPROF = 51 )

      REAL      R( MAXNR ), RM( MAXNR), TLRAW( MAXNR ),
     &          TL( MAXNR ), RPROF( MAXNPROF ), RR( 1 )
      COMPLEX   CK( MAXM ), PHIS( MAXM ), PHIR( MAXM ), P( MAXNR )
      CHARACTER OPT*50, TITLE*80, COMP*1

      DATA RMIN, RMAX, TLMIN, TLMAX / 0.0, 100.0, 40.0, 120.0 /

C     Read in control data

      OPEN( FILE = 'PLPFIL', UNIT = PLPFIL, STATUS = 'OLD' )
      READ( PLPFIL, * ) OPT
      COMP = OPT(3:3)

      M = 99999
      READ( PLPFIL, * ) M

C     ------ Read profile ranges
      RPROF( 3 ) = -999.9
      READ( PLPFIL, * ) NPROF, ( RPROF( I ), I = 1, NPROF )

      IF ( NPROF .GT. MAXNPROF ) THEN
         WRITE( PRTFIL, * ) 'NPROF, MAXNPROF = ', NPROF, MAXNPROF
         CALL ERROUT( PRTFIL, 'F', 'PLOTTLR', 'Too many profiles' )
      ENDIF

      CALL SUBTAB( RPROF, NPROF )

      READ( PLPFIL, * ) SRCD, RCVRD
      READ( PLPFIL, * ) RMIN, RMAX, NR

      NSD = 1
      NRD = 1
      RR( 1 ) = 0.0

C     Compute range vector

      DELTAR = ( RMAX - RMIN ) / ( NR - 1 )
      DO J = 1, NR
         R(  J ) = RMIN + ( J - 1 ) * DELTAR
         RM( J ) = 1000.0 * R( J )
      END DO

      IF ( RM( 1 ) .LE. 0.0 ) RM( 1 ) = MIN( 1.0, RM( 2 ) )
 
C     Read in modes

      IPROF = 1

      CALL GETMOD( IPROF, ' ', MAXM, SRCD,  NSD,  'N',
     &   CK, PHIS, MSRC, FREQ, TITLE )

      CALL GETMOD( IPROF, ' ', MAXM, RCVRD, NRD, COMP,
     &   CK, PHIR, MSRC, FREQ, TITLE )

      M = MIN( M, MSRC )

C     *** Evaluate the field ***

      IF ( NPROF .EQ. 1 ) THEN                  ! Range independent
         CALL EVAL( PHIS, PHIR, NRD,
     &                 RM, NR, RR, CK, M, OPT, P )
      ELSE IF ( OPT(2:2) .EQ. 'C' ) THEN        ! Coupled mode theory
         CALL EVALCM( RPROF, NPROF, PHIS, PHIR, RCVRD, NRD,
     &                     RM, NR, CK, M, OPT, P )
      ELSE                                      !Adiabatic mode theory
         CALL EVALAD( RPROF, NPROF, PHIS, PHIR, RCVRD, NRD, 
     &                     RM, NR, M, OPT, P )
      ENDIF

C     *** Compute scales for TL axis ***

      TLMINT = +1.0E9
      TLMAXT = -1.0E9

      DO J = 1, NR
         PSQ = P( J ) * CONJG( P( J ) )
         TLRAW( J ) = 200.0
         IF ( PSQ .GT. 1.0E-20 ) TLRAW( J ) = -10.0 * ALOG10( PSQ )
         TLMINT = MIN( TLMINT, TLRAW( J ) )
         TLMAXT = MAX( TLMAXT, TLRAW( J ) )
      END DO

      READ( PLPFIL, * ) TLMIN, TLMAX

C     --- Compute max, min automatically?
      IF ( TLMIN .EQ. TLMAX ) THEN
        TLMIN = 10.0 * INT( TLMINT / 10.0 )
        TLMAX = 10.0 * INT( TLMAXT / 10.0 ) + 10.0
      END IF

C     Smooth

      READ( PLPFIL, * ) DR3DB
      DELTAR = 1000.0 * DELTAR
      NROWS = 1
      CALL SMOOTH( TLRAW, TL, NROWS, NRD, NR, DELTAR, DR3DB )

C     *** Write data ***

      LAST = INDEX( TITLE, '    ' ) - 1
      WRITE( PRTFIL, 1000 ) TITLE(1:LAST)
 1000 FORMAT( '@ title "', A, '"' )

      WRITE( PRTFIL, 2000 ) NINT( FREQ ), NINT( SRCD ), NINT( RCVRD )
 2000 FORMAT(  '@ subtitle "',
     &         'F  =', I4, ' Hz, ',
     &         'Sd =', I4, ' m,  ',
     &         'Rd =', I4, ' m"' )
 
      WRITE( PRTFIL, 3000 ) INT( RMIN  ), INT( RMAX  ),
     &                      INT( TLMIN ), INT( TLMAX )
 3000 FORMAT( '@ world xmin ', I5, /,
     &        '@ world xmax ', I5, /,
     &        '@ world ymin ', I5, /,
     &        '@ world ymax ', I5 )

      DO IR = 1, NR
         WRITE( PRTFIL, * ) R( IR ), TL( IR )
      END DO

      STOP

      END

      PROGRAM PLTTRI

C     Plot the triangulation

      INTEGER PRTFIL, FLPFIL
      PARAMETER ( PRTFIL = 6, FLPFIL = 5,
     &   MAXNSD = 21, MAXNRD = 51, MAXNT = 101,
     &   MXNODE = 10000, PI = 3.141592, DEGRAD = PI / 180.0 )

      REAL THETA( MAXNT ), SD( MAXNSD ), RD( MAXNRD ),
     &   X( MXNODE ), Y( MXNODE ), XV( 4 ), YV( 4 )
      CHARACTER OPT*50, TITLE*80, FILNAM( MXNODE )*50

C     *** Read FLPFIL header information ***

      READ( FLPFIL, * ) TITLE
      READ( FLPFIL, * ) OPT
      READ( FLPFIL, * ) M

C     --- Read source/receiver coordinates
      READ( FLPFIL, * ) XS, YS

C     --- Read source/rcvr depths
      CALL SDRD( FLPFIL, PRTFIL, 0.0, 1.0E6,
     &   MAXNSD, NSD, SD,
     &   MAXNRD, NRD, RD )

C     --- Radii of receivers
      READ( FLPFIL, * ) RMIN, RMAX, NR

C     --- Read angles for radials
      THETA( 3 ) = -999.9
      READ( FLPFIL, * ) NTHETA, ( THETA( ITH ), ITH = 1, NTHETA )
      CALL SUBTAB( THETA, NTHETA )
      IF ( NRD .GT. 1 ) NTHETA = 1

C     *** Nodal coordinates ***

      XMIN =  1.0E9
      XMAX = -1.0E9
      YMIN =  1.0E9
      YMAX = -1.0E9

      READ( FLPFIL, * ) NNODES
C     WRITE( *, * ) ' Number of Nodes', NNODES

      DO I = 1, NNODES
         READ( FLPFIL, * ) X( I ), Y( I ), FILNAM( I )
C        WRITE( *, * ) X(I), Y(I), FILNAM(I)
         X(I) = X( I )
         Y(I) = Y( I )
         XMIN = MIN( X( I ), XMIN )
         XMAX = MAX( X( I ), XMAX )
         YMIN = MIN( Y( I ), YMIN )
         YMAX = MAX( Y( I ), YMAX )
      END DO

      LAST = INDEX( TITLE, '    ' ) - 1
      WRITE( PRTFIL, 1000 ) TITLE(1:LAST)
 1000 FORMAT( '@ title "', A, '"' )

      WRITE( PRTFIL, 2000 ) INT( XMIN ), INT( XMAX ),
     &                      INT( YMIN ), INT( YMAX )
 2000 FORMAT( '@ world xmin ', I5, /,
     &        '@ world xmax ', I5, /,
     &        '@ world ymin ', I5, /,
     &        '@ world ymax ', I5 )

C     ------ Element definition
      READ( FLPFIL, * ) NELTS
C      WRITE( *, * ) 'NELTS = ', NELTS

      DO IELT = 1, NELTS
         READ( FLPFIL, * ) NODE1, NODE2, NODE3
C        WRITE( *, * ) 'NODE1, NODE2, NODE3 = ', NODE1, NODE2, NODE3
         XV( 1 ) = X( NODE1 )
         YV( 1 ) = Y( NODE1 )
         XV( 2 ) = X( NODE2 )
         YV( 2 ) = Y( NODE2 )
         XV( 3 ) = X( NODE3 )
         YV( 3 ) = Y( NODE3 )
         XV( 4 ) = X( NODE1 )
         YV( 4 ) = Y( NODE1 )

         DO INODE = 1, 4
            WRITE( *, * ) XV( INODE ), YV( INODE )
         END DO

C         IF ( FILNAM( NODE1 ) .EQ. FILNAM( NODE2 ) ) THEN
C            CALL SETCLR( 'BLACK' )
C         ELSE
C            CALL SETCLR( 'RED' )
C         ENDIF
C         CALL CURVE( XV( 1 ), YV( 1 ), 2, 1 )

C         IF ( FILNAM( NODE2 ) .EQ. FILNAM( NODE3 ) ) THEN
C            CALL SETCLR( 'BLACK' )
C         ELSE
C            CALL SETCLR( 'RED' )
C         ENDIF
C         CALL CURVE( XV( 2 ), YV( 2 ), 2, 1 )

C         IF ( FILNAM( NODE3 ) .EQ. FILNAM( NODE1 ) ) THEN
C            CALL SETCLR( 'BLACK' )
C         ELSE
C            CALL SETCLR( 'RED' )
C         ENDIF
C         CALL CURVE( XV( 3 ), YV( 3 ), 2, 1 )

C        ------ Label the element
         XMID = ( X( NODE1 ) + X( NODE2 ) + X( NODE3 ) ) / 3.0
         YMID = ( Y( NODE1 ) + Y( NODE2 ) + Y( NODE3 ) ) / 3.0
C         CALL RLMESS( '.$', 100, XMID, YMID )
C         CALL RLINT( IELT, XMID, YMID )
      END DO   ! next element

      WRITE( *, * ) '&'

C     Label the nodes

C      DO INODE = 1, NNODES
C         CALL RLINT( INODE, X( INODE ), Y( INODE ) )
C      END DO

C     Plot the bearing lines

      DO ITH = 1, NTHETA
         XV( 1 ) = XS + RMIN * COS( DEGRAD * THETA( ITH ) )
         YV( 1 ) = YS + RMIN * SIN( DEGRAD * THETA( ITH ) )

         XV( 2 ) = XS + RMAX * COS( DEGRAD * THETA( ITH ) )
         YV( 2 ) = YS + RMAX * SIN( DEGRAD * THETA( ITH ) )

         WRITE( *, * ) XV( 1 ), YV( 1)
         WRITE( *, * ) XV( 2 ), YV( 2)
      END DO
      WRITE( *, * ) '&'

      STOP
      END

      SUBROUTINE ZSECX( X2, TOL, IT, MAXIT, ERRMSG )

      IMPLICIT REAL*8 (A-H, O-Z)
      CHARACTER*80 ERRMSG

C     Secant method

      ERRMSG = ' '
      TEN = 10.0
      X1 = X2 + 10.0 * TOL

      CALL FUNCT( X1, F1, IPOW1 )

      DO IT = 1, MAXIT
         X0    = X1
         F0    = F1
         IPOW0 = IPOW1
         X1    = X2

         CALL FUNCT( X1, F1, IPOW1 )

         IF ( F1 .EQ. 0.0 ) THEN
            SHIFT = 0.0
         ELSE
            SHIFT = ( X1 - X0 ) / ( 1.0 - F0/F1*TEN**(IPOW0-IPOW1) )
         ENDIF

         X2 = X1 - SHIFT
         IF ( ABS( X2 - X1 ) .LT. TOL ) GOTO 3000
         IF ( ABS( X2 - X0 ) .LT. TOL ) GOTO 3000
      END DO

      ERRMSG = ' *** FAILURE TO CONVERGE IN SECANT'

 3000 RETURN
      END

        FUNCTION NEIGH( X0, X, NX )

C       Find the index of the nearest neighbor to a point X0
C       in a vector X with NX elements.

        REAL X( NX )

        NEIGH = 1
        DIST  = 1.0E20

        DO IX = 1, NX
           IF ( ABS( X( IX ) - X0 ) .LT. DIST ) THEN
              NEIGH = IX
              DIST = ABS( X( IX ) - X0 )
           ENDIF
        END DO
 
        RETURN
        END

      INTEGER ENVFIL, PRTFIL, GRNFIL, RTSFIL
      COMPLEX CI
      PARAMETER ( ENVFIL = 5, PRTFIL = 6, GRNFIL = 20, RTSFIL = 35,
     &   MXN = 1700,  MXNK = 4001,  MXMED = 50, MXIT = 1000000,
     &   MXNTOUT = 1001, MAXNRD = 101, MAXNSD = 11, MXNRR = 501,
     &   CI = ( 0.0, 1.0 ), PI = 3.1415926535898D0 )

      REAL*8 DEPTH, RHO, SIGMA
      COMPLEX CPT, CST, CPB, CSB
      COMMON /SHARE/ CPT, CST,  CPB, CSB,
     &   C2R( MXN ), C2I( MXN ), Z( MXN ),
     &   RHO( MXN ), RHOT, RHOB, LOC( MXMED ),
     &   DEPTH( MXMED ), N( MXMED ), H( MXMED ), CMIN, CLOW, CHIGH,
     &   OMEGA2, NMEDIA, NSIG, TOUT( MXNTOUT ), NTOUT, DELTAK,
     &   SD( MAXNSD ), ISD( MAXNSD ), WS( MAXNSD ), NSD,
     &   RD( MAXNRD ), IRD( MAXNRD ), WR( MAXNRD ), NRD,
     &   RR( MXNRR ), NRR, RK( MXNK ), NKPTS, NKCORE, SIGMA( MXMED ),
     &   NTOT1, DELT, CROSST, CMAX, TSTART, V, TMULT,
     &   ALPHA, BETA, FMIN, FMAX

      CHARACTER MATER( MXMED )*8, TOPOPT*8, BOTOPT*8, PULSE*4, TITLE*80
      COMMON /SHARE1/ MATER, TOPOPT, BOTOPT, PULSE, TITLE

      COMPLEX FUNCTION PADE( X0, X, F, N, ERRMSG )

C     COMPUTES THE [MU, NU] PADE APPROXIMANT AT X0, WHERE
C        MU = [M/2], NU = M - MU AND M = N - 1

C     FORMULAS TAKEN FROM BURLISCH AND STOER
C        NUMERISCHE MATHEMATIK 8:1-13(1966)

C     LIMITED TO N = 10 (OR SO)

C     N IS THE NUMBER OF POINTS USED.
C     X CONTAINS THE INDEPENDENT VARIABLE
C     F CONTAINS THE FUNCTIONAL VALUES AT EACH X
C     X0 IS THE POINT AT WHICH THE APPROXIMATION IS TO BE CALCULATED

C     NOTE MUCH WASTED SPACE IN THIS IMPLEMENTATION

C     MICHAEL PORTER, 11 SEPT 1985

      PARAMETER ( MAXN = 10, PREC = 1.0E-7 )
      COMPLEX X0, X( N ), F( N ), RDT, WDEN, CNUM, CDEN, 
     &    DT( MAXN, MAXN ), C( MAXN, MAXN ), H( MAXN ), XINT
      CHARACTER*80 ERRMSG

      ERRMSG = ' '

C     ------ Initialize arrays
      NEARST = 1
      HSMALL = 1.0E9

      DO K = 1, N
         H( K ) = X( K ) - X0

C        ------ Check for nearest abscissa
         IF ( ABS( H( K ) ) .LT. HSMALL ) THEN
            HSMALL = ABS( H( K ) )
            NEARST = K

C           ------ Compute x-interval size
            IF ( K .EQ. 1 ) THEN
               XINT = X( 2 ) - X( 1 )
            ELSE IF ( K .EQ. N ) THEN
               XINT = X( N ) - X( N - 1 )
            ELSE
               XINT = ( X( K + 1 ) - X( K - 1 ) ) / 2.0
            ENDIF

C           ------ Quick return if x lies "on" a data point
            IF ( HSMALL .LT. PREC * ABS( XINT ) ) THEN
               PADE = F( K )
               RETURN
            ENDIF
         ENDIF
      END DO

C     *** Recursion for solution ***

      DO M = 1, N
         DT( 1, M ) = F( M )
         C(  1, M ) = F( M )

         IF ( M .GE. 2 ) THEN

            DO K = 1, M - 1
               RDT  = H( M - K ) / H( M ) * DT( K, M - K )
               CNUM = C( K, M - K + 1 ) - DT( K, M - K )
               CDEN = RDT - C( K, M - K + 1 )

               IF ( ABS( CNUM ) .GE. 1.0E10 * ABS( CDEN ) ) THEN
C                  ERRMSG = 'ERROR: NEARLY-SINGULAR MATRIX IN PADE'
                  PADE = F( NEARST )
                  RETURN
               ENDIF

               WDEN = CNUM / CDEN
               DT( K + 1, M - K ) = C( K, M - K + 1 ) * WDEN
               C(  K + 1, M - K ) = RDT * WDEN
            END DO
         ENDIF
      END DO

C     ------ Sum side elts to get interpolate
      PADE = 0.0
      DO K = 1, N
         PADE = PADE + DT( K, N - K + 1 )
      END DO

      RETURN
      END

      IMPLICIT REAL*8 (A-H, O-Z)

      INTEGER ENVFIL, PRTFIL, MODFIL, EVMFIL
      REAL*8  MACHEP
      COMPLEX CI

      PARAMETER ( ENVFIL = 5, PRTFIL = 6, MODFIL = 20, EVMFIL = 22,
     &   MAXN = 200001, MAXM = 1500, MAXMED = 50, NSETS = 5,
     &   MAXNSD = 4095, MAXNRD = 4095, MAXNZT = 4095,
     &   CI = ( 0.0, 1.0 ), PI = 3.1415926535898D0, MACHEP = 1.0D-13 )

      REAL SD, RD
      COMPLEX*16 CK, CPT, CST, CPB, CSB
      COMMON /SHARE/ CK( MAXM ), CPT, CST, CPB, CSB,
     &   B1( MAXN ), B1C( MAXN ), B2( MAXN ), B3( MAXN ), B4( MAXN ),
     &   EVMAT( NSETS, MAXM ), EXTRAP( NSETS, MAXM ), ET( NSETS ),
     &   RHO( MAXN ), DEPTH( MAXMED ), H( MAXMED ), HV( NSETS ),
     &   RHOT, RHOB, CMIN, CLOW, CHIGH, FREQ, OMEGA2, RMAX,
     &   SIGMA( MAXMED ), BUMDEN, ETA, XI,
     &   SD( MAXNSD ), RD( MAXNRD ), NSD, NRD,
     &   LOC( MAXMED ), NFACT, NLACT, NMEDIA,
     &   NG( MAXMED ), N( MAXMED ), NV( NSETS ),
     &   ISET, M, LRECL, MODECT, MODE

      CHARACTER MATER( MAXMED )*8, TOPOPT*8, BOTOPT*8, TITLE*80
      COMMON /SHARE1/ MATER, TOPOPT, BOTOPT, TITLE

      SUBROUTINE REVI( X, NX )

C     Reverse the INTEGER elements in vector X

      INTEGER X( * )

      DO 1000 I = 1, NX / 2
         TEMP            = X( I )
         X( I )          = X( NX - I + 1 )
         X( NX - I + 1 ) = TEMP
 1000 CONTINUE

      RETURN
      END
C**********************************************************************C
      SUBROUTINE REVR( X, NX )

C     Reverse the REAL elements in vector X

      REAL X( * )

      DO 1000 I = 1, NX / 2
         TEMP            = X( I )
         X( I )          = X( NX - I + 1 )
         X( NX - I + 1 ) = TEMP
 1000 CONTINUE

      RETURN
      END
C**********************************************************************C
      SUBROUTINE REVC( X, NX )

C     Reverse the COMPLEX elements in vector X

      COMPLEX X( * )

      DO 1000 I = 1, NX / 2
         TEMP            = X( I )
         X( I )          = X( NX - I + 1 )
         X( NX - I + 1 ) = TEMP
 1000 CONTINUE

      RETURN
      END

C***********************************************************************
      SUBROUTINE LOGANA( X, Y ,NY )

C     Calculus of the logarithm by unwrapping the phase

      INTEGER*4 NY, NPI, K
      COMPLEX*16 X( NY ), Y( NY )
      REAL*8 YR( NY ), YI( NY ), PI
      PARAMETER( PI = 3.14159265358979323846264D0 )


      YR( 1 ) = DLOG( CDABS( X( 1 ) ) )
      YI( 1 ) = DATAN2( DIMAG( X( 1 ) ), DREAL( X( 1 ) ) )

      Y( 1 ) = DCMPLX( YR( 1 ), YI( 1 ) ) 

      NPI = 0

      DO K = 2, NY

         YR( K ) = DLOG( CDABS( X( K ) ) )
         YI( K ) = ATAN2( DIMAG( X( K ) ), DREAL( X( K ) ) )

         IF ((YI(K) + NPI * 2.0D0 * PI  - YI(K-1)) .GT. PI) THEN
            NPI = NPI - 1
         ENDIF 

         IF ((YI(K) + NPI * 2.0D0 * PI - YI(K-1)) .LT. - PI) THEN
            NPI = NPI + 1
         ENDIF 

         YI( K ) = YI( K ) + NPI * 2.0D0 * PI

         Y( K ) = DCMPLX( YR( K ), YI( K ) ) 

      END DO
c           write(*,*) 'NPI :',NPI

      RETURN
      END
C*********************************************************************
      SUBROUTINE FNBZEROS( NBZ, FY, NRECT)

C     Calculus of the number of zeros inside the contour

      INTEGER K
      COMPLEX*16 FY( NRECT ), NBZR, Y( NRECT ), CI
      INTEGER*4 NBZ, NRECT
      REAL*8 PI
      PARAMETER( PI = 3.14159265358979323846264D0 )
      PARAMETER( CI = ( 0.0D0 , 1.0D0 ) )

      CALL LOGANA( FY, Y, NRECT )

      NBZR = ( Y( NRECT  ) - Y( 1 ) )/ 2.0D0 / PI / CI
c      write(*,*) 'Nreel:', NBZR
      NBZ = INT( REAL( NBZR ) )
 
      RETURN 
      END
C*********************************************************************
      SUBROUTINE FNBZEROSC( NBZ, FY, NCER )

C     Calculus of the number of zeros inside the contour

      INTEGER K
      COMPLEX*16 FY( NCER ), FYY(50000), NBZP, Y(50000), CI
      INTEGER*4 NBZ, NCER, NCER1
      REAL*8 PI
      PARAMETER( PI = 3.14159265358979323846264D0 )
      PARAMETER( CI = ( 0.0D0 , 1.0D0 ) )

      FYY( 1 ) = FY( NCER )

      DO K = 1, NCER
        FYY( K+1) = FY( K )
      END DO

      NCER1 = NCER + 1

      CALL LOGANA( FYY, Y, NCER1 )

      NBZP = ( Y( NCER1  ) - Y( 1 ) )/ 2.0D0 / PI / CI

      NBZ = INT( REAL( NBZP ) )
 
      RETURN 
      END
C**********************************************************************
      SUBROUTINE RECT( T, REP, DR, CENT, U, V, NCER )

C     Design of the rectangle used as contour
C      U is the horizontal size   V the vertical size

      COMPLEX*16 T( 20000 ), CENT, CI
      REAL*8 RAY, A1, A2, U, V, DR( 2 ), DR1, DR2, DRM
      INTEGER*4  NCER, NCER1, NCER2, REP( 5 ), K
      PARAMETER( CI = ( 0.0D0 , 1.0D0 ) )

      NCER1 = NCER

      A1   = DREAL( CENT ) - U / 2.0D0
      A2   = DIMAG( CENT ) + V / 2.0D0
      
c      write(*,*)'A1 :',A1,A1+U
c      write(*,*)'A2 :',A2,A2-V

c      DR1   = V / DBLE( NCER1 )
c      DR2   = U / DBLE( NCER1 )

c      DRM = MAX( DR1, DR2 )

      DRM = 2.0 * ( U + V ) / DBLE( NCER )
      NCER1 = NINT( V / DRM )
      DR1 = V / DBLE( NCER1 )

      NCER2 = NINT( U / DRM )
      DR2 = U / DBLE( NCER2 )

c      write(*,*) 'CENT  ', CENT
c      write(*,*) 'U  V : ', U, V
c      write(*,*) 'DR1  DR2 : ', DR1, DR2

      REP( 1 ) = 1

      DO K = 1, NCER1 + 1
        T( K ) = A1 + CI * ( A2 - ( K - 1 ) * DR1 )
      END DO
       
      REP( 2 ) = NCER1 + 1

      DO K = 1, NCER2
        T( K + REP( 2 ) ) = A1 + K * DR2 + CI * ( A2 - V )
      END DO

      REP( 3 ) = NCER1 + NCER2 + 1

      DO K = 1, NCER1
        T( K + REP( 3 ) ) = A1 + U + CI * ( A2 - V + K * DR1 )
      END DO

      REP( 4 ) = NCER1 * 2 + NCER2 + 1

      DO K = 1, NCER2
         T( K + REP( 4) ) = A1 + U - K * DR2 + CI * A2
      END DO

      REP( 5 ) = 2 * ( NCER1 + NCER2 ) + 1

      DR( 1 ) = DR1

      DR( 2 ) = DR2

      RETURN
      END
      
C**********************************************************************
      SUBROUTINE FSOLANA( SOL, T, FY, RAY, CENT, NBZ, NCER )

C     Solution in the complex plane

      COMPLEX*16 FY( NCER ), SOL(1:50), A(1:50), AI(1:50), CENT
      COMPLEX*16 FY1(50000), Y(50000), Y1, Y2, SY, S(1:50), SM, CI
      REAL*8 RAY, DT, PI, T( NCER )
      INTEGER*4 NBZ, NCER
      INTEGER I, J, K
      LOGICAL POLISH
      PARAMETER( PI = 3.14159265358979323846264D0 )
      PARAMETER( CI = ( 0.0D0 , 1.0D0 ) )

      DT = 2.0D0 * PI / ( T( 2 ) - T( 1 ) )

      DO I = 1, NCER
         FY1( I ) = EXP( - CI * NBZ * T( I ) ) * FY( I )
      END DO

      CALL LOGANA( FY1, Y, NCER )

      DO J = 1, NBZ
         SY = 0.0D0
         DO K = 1, NCER/2 
            Y1 = Y( 2 * K - 1 ) * EXP( CI * DBLE( J ) * T( 2 * K - 1 ) )
            Y2 = Y( 2 * K     ) * EXP( CI * DBLE( J ) * T( 2 * K     ) )
            SY = SY + 4.0D0 * Y1 + 2.0D0 * Y2
         END DO
         SY = SY / 3.0D0
         S( J ) = - DBLE( J ) / DT * SY  * RAY ** J
      END DO

C     Calculus of the polynomial coefficients

      AI( 1 ) = 1.0D0
      AI( 2 ) = - S( 1 )
      
      DO K = 2, NBZ
         SM = 0.0D0
         DO  J = 1, K - 1
             SM = SM + S( J ) * AI( K - J + 1 )
         END DO
         AI( K + 1 ) = - ( SM + S( K ) ) / DBLE( K )
      END DO

      DO K = 1, NBZ + 1
         A( K ) = AI( NBZ + 2 - K )
      END DO

      POLISH = .FALSE.

      CALL ZROOTS( A, NBZ, SOL, POLISH )

      DO K = 1, NBZ
         SOL( K ) = SOL( K ) + CENT
c         write(*,*) 'Sol C :', SOL(K)
      END DO

      RETURN
      END
C**********************************************************************
      SUBROUTINE FSOLREC( SOL, T, FY, REP, CENT, NBZ, NRECT, DR )

C     Solution in the complex plane

      COMPLEX*16 FY( NRECT ), SOL(1:30), A(1:30), AI(1:30), CENT
      COMPLEX*16 T1( NRECT ), Y1, Y2, S(1:50), SM, CI, Y( NRECT )
      COMPLEX*16 YZ( NRECT ), SY( 4 ), T( NRECT ), SYY
      REAL*8 RAY, PI, DR( 2 )
      INTEGER*4 NBZ, NRECT, REP( 5 ), I, J, K
      LOGICAL POLISH
      PARAMETER( PI = 3.14159265358979323846264D0 )
      PARAMETER( CI = ( 0.0D0 , 1.0D0 ) )

      DO K = 1, NRECT
         T1( K ) = T( K ) - CENT
         YZ( K ) =  T1( K ) **( -NBZ ) * FY( K )
      END DO

      CALL LOGANA( YZ, Y, NRECT )

c      Extended rule

      DO J = 1, NBZ
         DO I = 1, 4
           I1 = REP( I )
           I2 = REP( I + 1 ) 
           SYY = 3.0D0/8.0D0 * Y( I1 ) + 7.0D0/6.0D0 * Y( I1 + 1 )
     &             + 23.0D0/24.0D0 * Y( I1 + 2 )
           DO K = I1 + 3, I2 - 3
              SYY  = SYY + Y( K )
           END DO 
           SYY = SYY + 3.0D0/8.0D0 * Y( I2 ) + 7.0D0/6.0D0 * Y( I2 - 1 )
     &              + 23.0D0/24.0D0 * Y( I2 - 2 )
           SY( I ) = SYY
         END DO
         S( J ) = CI * ( SY( 3 ) - SY( 1 ) ) * DR( 1 )
     &                + ( SY( 2 ) - SY( 4 ) ) * DR( 2 )
         S( J ) =  - DBLE( J ) / 2.0D0 / PI / CI * S( J )
         
         IF ( J .NE. NBZ ) THEN
            DO K = 1, NRECT
              Y( K ) = Y( K ) * T1( K )
            END DO
          ENDIF         
      END DO

C     Calculus of the polynomial coefficients

      AI( 1 ) = 1.0D0
      AI( 2 ) = - S( 1 )

c      write(*,*) 'S : ', S(1:NBZ)

      DO K = 2, NBZ
         SM = 0.0D0
         DO  J = 1, K - 1
             SM = SM + S( J ) * AI( K - J + 1 )
         END DO
         AI( K + 1 ) = - ( SM + S( K ) ) / DBLE( K )
      END DO

      DO K = 1, NBZ + 1
         A( K ) = AI( NBZ + 2 - K )
      END DO

      POLISH = .TRUE.

      CALL ZROOTS( A, NBZ, SOL, POLISH )

      DO K = 1, NBZ
         SOL( K ) = SOL( K ) + CENT
c         write(*,*) 'Sol :', SOL(K)
      END DO

      RETURN
      END
C**********************************************************************
      SUBROUTINE PKSORT(n,arr)
      INTEGER*4 n
      REAL*8 arr(n)
      INTEGER*4 i,j
      REAL*8 a
      do 12 j=2,n
        a=arr(j)
        do 11 i=j-1,1,-1
          if(arr(i).le.a)goto 10
          arr(i+1)=arr(i)
11      continue
        i=0
10      arr(i+1)=a
12    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software #ksV).
C**********************************************************************
      SUBROUTINE ZPKSORT(n,arr)
      INTEGER*4 n
      COMPLEX*16 arr(n)
      INTEGER*4 i,j
      COMPLEX*16 a
      do 12 j=2,n
        a=arr(j)
        do 11 i=j-1,1,-1
          if(dreal(arr(i)).ge.dreal(a))goto 10
          arr(i+1)=arr(i)
11      continue
        i=0
10      arr(i+1)=a
12    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software #ksV).
C**********************************************************************C
      SUBROUTINE  GETMINFO( CWAT, CMINI, HEAU, HENS, CIMX ,
     &   CSMIN, CMAXI )

C     Get informations on the structure of the medium

      INCLUDE 'comc1.f'

      LOGICAL ELFLAG
      REAL*8 CWAT, CMINI, HEAU, HENS, AT, OMEGA, CSMIN, CIMX, CMAXI
      COMPLEX*16 CP( MAXN ), CS( MAXN ), CP2, CS2

      COMMON /SPACE/ CP, CS, DUMMY( 4 * MAXN )
      COMMON /CPREV/ ALPHAR, BETAR, RHOR, ALPHAI, BETAI
      
      ELFLAG   = .FALSE.
      CSMIN    = 1.0E6
      CMIN      = 1.0E6
      CMAXI    = 0.0D0
      CIMX      = 0.0D0
      NFACT    = 0
      LOC( 1 ) = 0
      
      OMEGA = 2* PI * FREQ

C     *** Loop over media ***

      DO MED = 1, NMEDIA
         IF ( MED .NE. 1 ) LOC( MED ) = LOC( MED-1 ) + N( MED-1 ) + 1
         N1 = N(   MED ) + 1
         I  = LOC( MED ) + 1

C        *** Load diagonals of the finite-difference equations ***

         IF ( CS( I ) .EQ. ( 0.0, 0.0 ) ) THEN

C           --- Case of an acoustic medium ---

            MATER( MED ) = 'ACOUSTIC'
            IF ( NFACT .EQ. 0 ) NFACT = MED
            NLACT = MED

            DO J = I, I + N( MED )
               CMIN   = MIN( CICR( CP( J ) ), CMIN )
               CMAXI  = MAX( CICR( CP( J ) ), CMAXI )
               CIMX   = MAX( ATCI( CP( J ), OMEGA ) , CIMX )
            END DO
C
            IF ( NFACT .EQ. MED ) THEN
              CWAT  = CMIN
              HEAU  = DEPTH( MED + 1 )
            ENDIF

         ELSE

C           --- Case of an elastic medium ---

            MATER( MED ) = 'ELASTIC'
            ELFLAG = .TRUE.
            TWOH   = 2.0 * H( MED )

            DO J = I, I + N( MED )
               CMIN    = MIN( CICR( CS( J ) ), CMIN   )
               CMAXI   = MAX( CICR( CS( J ) ), CMAXI )
               CMAXI   = MAX( CICR( CP( J ) ), CMAXI )
               CSMIN   = MIN( CICR( CS( J ) ), CSMIN )
               CIMX    = MAX( ATCI( CP( J ), OMEGA ), CIMX )
               CIMX    = MAX( ATCI( CS( J ), OMEGA ), CIMX )
            END DO

         ENDIF
C        ------ Next MED:
      END DO

C     *** Bottom properties ***

      IF ( BOTOPT(1:1) .EQ. 'A' ) THEN
         IF ( CSB .NE. ( 0.0, 0.0 ) ) THEN
C           ------ Elastic bottom:
            ELFLAG = .TRUE.
            CMIN   = MIN( CMIN, CICR( CSB ) )
            CMAXI = MAX( CICR( CSB ), CMAXI )
            CMAXI = MAX( CICR( CPB ), CMAXI )
            CSMIN = MIN(CICR( CSB ), CSMIN )
            CIMX   = MAX( CIMX, ATCI( CSB, OMEGA ) )
            CIMX   = MAX( CIMX, ATCI( CPB, OMEGA ) )
         ELSE
C           ------ Acoustic bottom:
            CMIN   = MIN( CMIN, CICR( CPB ) )
            CMAXI = MAX( CICR( CPB ), CMAXI )
            CIMX   = MAX( CIMX, ATCI( CPB, OMEGA ) )
         ENDIF
      ENDIF

C     *** Top properties ***

      IF ( TOPOPT(2:2) .EQ. 'A' ) THEN
         IF ( CST .NE. ( 0.0, 0.0 ) ) THEN
C           ------ Elastic top:
            ELFLAG = .TRUE.
            CMIN = MIN( CMIN, CICR( CST ) )
            CMAXI = MAX( CICR( CST ), CMAXI )
            CSMIN = MIN(CICR( CST ), CSMIN )
            CIMX = MAX( CIMX, ATCI( CST, OMEGA ) )
            CIMX = MAX( CIMX, ATCI( CPT, OMEGA ) )
         ELSE
C           ------ Acoustic top:
            CMIN = MIN( CMIN, CICR( CPT ) )
            CMAXI = MAX( CICR( CPT ), CMAXI )
            CIMX = MAX( CIMX, ATCI( CPT, OMEGA ) )
         ENDIF
      ENDIF

      CMINI = CMIN
      HENS  = DEPTH (NMEDIA + 1)
      IF ( CSMIN .EQ. 1.0E6 ) CSMIN = 0.0

      IF ( ELFLAG ) CMIN = 0.9 * CMIN

      RETURN
      END
C**************************************************************
      FUNCTION CICR( C )
      
      REAL*8 CICR
      COMPLEX*16 C
      
      IF ( C .EQ. ( 0.0D0,0.0D0 ) ) THEN
         CICR = 0.0D0
      ELSE
         CICR = C * DCONJG( C ) / DREAL( C )
      ENDIF
      
      RETURN
      END
C**************************************************************
      FUNCTION ATCI( C, OMEGA )
      
      REAL*8 ATCI, OMEGA
      COMPLEX*16 C
      
      IF ( C .EQ. ( 0.0,0.0 ) ) THEN
         ATCI = 0.0
      ELSE
         ATCI = OMEGA * DIMAG( C ) / C / DCONJG( C ) 
      ENDIF
      
      RETURN
      END
C**************************************************************      
      SUBROUTINE zroots(a,m,roots,polish)
      INTEGER m,MAXM
      DOUBLE PRECISION EPS
      COMPLEX*16 a(m+1),roots(m)
      LOGICAL polish
      PARAMETER (EPS=1.d-20,MAXM=101)
CU    USES laguer
      INTEGER i,j,jj,its
      COMPLEX*16 ad(MAXM),x,b,c
      do 11 j=1,m+1
        ad(j)=a(j)
11    continue
      do 13 j=m,1,-1
        x=dcmplx(0.d0,0.d0)
        call laguer(ad,j,x,its)
        if(abs(dimag(x)).le.2.d0*EPS**2*abs(dreal(x))) x=dcmplx(dreal(x)
     *,0.d0)
        roots(j)=x
        b=ad(j+1)
        do 12 jj=j,1,-1
          c=ad(jj)
          ad(jj)=b
          b=x*b+c
12      continue
13    continue
      if (polish) then
        do 14 j=1,m
          call laguer(a,m,roots(j),its)
14      continue
      endif
      do 16 j=2,m
        x=roots(j)
        do 15 i=j-1,1,-1
          if(dreal(roots(i)).le.dreal(x))goto 10
          roots(i+1)=roots(i)
15      continue
        i=0
10      roots(i+1)=x
16    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software #ksV).
C******************************************************
      SUBROUTINE laguer(a,m,x,its)
      INTEGER m,its,MAXIT,MR,MT
      DOUBLE PRECISION EPSS
      COMPLEX*16 a(m+1),x
      PARAMETER (EPSS=3.d-16,MR=8,MT=10,MAXIT=MT*MR)
      INTEGER iter,j
      DOUBLE PRECISION abx,abp,abm,err,frac(MR)
      COMPLEX*16 dx,x1,b,d,f,g,h,sq,gp,gm,g2
      SAVE frac
      DATA frac /.5d0,.25d0,.75d0,.13d0,.38d0,.62d0,.88d0,1.d0/
      do 12 iter=1,MAXIT
        its=iter
        b=a(m+1)
        err=abs(b)
        d=dcmplx(0.d0,0.d0)
        f=dcmplx(0.d0,0.d0)
        abx=abs(x)
        do 11 j=m,1,-1
          f=x*f+d
          d=x*d+b
          b=x*b+a(j)
          err=abs(b)+abx*err
11      continue
        err=EPSS*err
        if(abs(b).le.err) then
          return
        else
          g=d/b
          g2=g*g
          h=g2-2.d0*f/b
          sq=sqrt((m-1)*(m*h-g2))
          gp=g+sq
          gm=g-sq
          abp=abs(gp)
          abm=abs(gm)
          if(abp.lt.abm) gp=gm
          if (max(abp,abm).gt.0.d0) then
            dx=m/gp
          else
            dx=exp(dcmplx(log(1.d0+abx),dble(iter)))
          endif
        endif
        x1=x-dx
        if(x.eq.x1)return
        if (mod(iter,MT).ne.0) then
          x=x1
        else
          x=x-dx*frac(iter/MT)
        endif
12    continue
      pause 'too many iterations in laguer'
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software #ksV).

      SUBROUTINE MERGEV( X, NX, Y, NY, Z, NZ )

C     Merge two vectors X, Y into Z (duplicates are removed)

      REAL X(*), Y(*), Z(*)

      IX = 1
      IY = 1
      IZ = 1

C     *** Loop to successively take values from vector X or Y ***

 1000 CONTINUE

         IF ( IY .GT. NY ) THEN 
C           --- No more in vector Y, take from X
            Z( IZ ) = X( IX )
            IX = IX + 1
            IZ = IZ + 1
         ELSE IF ( IX .GT. NX ) THEN
C           --- No more in vector X, take from Y
            Z( IZ ) = Y( IY )
            IY = IY + 1
            IZ = IZ + 1
         ELSE IF ( X( IX ) .LE. Y( IY ) ) THEN
C           --- Vector X has the next largest
            Z( IZ ) = X( IX )
            IX = IX + 1
            IZ = IZ + 1
         ELSE
C           --- Vector Y has the next largest
            Z( IZ ) = Y( IY )
            IZ = IZ + 1
            IY = IY + 1
         ENDIF

C        --- Check that we didn't just add a duplicate
         IF ( IZ .GT. 2 .AND. Z( IZ-1 ) .EQ. Z( IZ-2) ) THEN
            IZ = IZ - 1
         ENDIF

C        --- More in vector X or Y?
         IF ( IX .LE. NX .OR. IY .LE. NY ) GOTO 1000

      NZ = IZ - 1

      RETURN
      END

      SUBROUTINE RFT(A, B, N, ISN)       
C    C, 10 / 11 / 80.V1 RTD <PN> :FFT LIBRARY      
C    IF ISN = 1, THIS SUBROUTINE COMPLETES THE FOURIER TRANSFORM   
C     OF 2 * N REAL DATA VALUES, WHERE THE ORIGINAL DATA VALUES ARE
C    STORED ALTERNATELY IN ARRAYS A AND B, AND ARE FIRST
C    TRANSFORMED BY A COMPLEX FOURIER TRANSFORM OF DIMENSION N. 
C    THE COSINE COEFFICIENTS ARE IN A(1), A(2), ...A(N + 1) AND     
C     THE SINE COEFFICIENTS ARE IN B(1), B(2), ...B(N + 1). 
C    A TYPICAL CALLING SEQUENCE IS    
C         CALL FFT(A, B, N, N, N, 1)       
C         CALL RFT(A, B, N, 1) 
C    THE RESULTS SHOULD BE MULTIPLIED BY 0.5  / N TO GIVE THE 
C    USUAL SCALING OF COEFFICIENTS.         
C    IF ISN = -1, THE INVERSE TRANSFORMATION IS DONE, THE FIRST         
C    STEP IN EVALUATING A REAL FOURIER SERIES.        
C    A TYPICAL CALLING SEQUENCE IS
C         CALL RFT(A, B, N,  - 1)
C         CALL FFT(A, B, N, N, N,  - 1)  
C    THE RESULTS SHOULD BE MULTIPLIED BY 0.5 TO GIVE THE USUAL        
C    SCALING , AND THE TIME DOMAIN RESULTS ALTERNATE IN ARRAYS        
C     A AND B, I.E., A(1), B(1), A(2), B(2), ...A(N), B(N). 
C    THE DATA MAY ALTERNATIVELY BE STORED IN A SINGLE COMPLEX         
C     ARRAY A, THEN THE MAGNITUDE OF ISN CHANGED TO TWO TO  
C    GIVE THE CORRECT INDEXING INCREMENT AND A(2) USED TO PASS        
C    THE INITIAL ADDRESS FOR THE SEQUENCE OF IMAGINARY
C    VALUES, E.G.  
C          CALL FFT(A, A(2), N, N, N, 2)         
C          CALL RFT(A, A(2), N, 2)   
C    IN THIS CASE, THE COSINE AND SINE COEFFICIENTS ALTERNATE IN      
C    A,  BY R.C. SINGLETON, STANFORD RESEARCH INSTITUTE, OCT. 1968    
C 
C NOTE FROM THE USERS:      
C 
C     BUGS WERE FOUND IN THIS VERSION OF RFT, WHICH HAS BEEN USED IN  
C    BASIC I, II, AND III.   THESE ARE:       
C 
C      1)  TWO VALUES OUTSIDE THE USER'S BUFFER, X(N + 1) AND X(N + 2) FOR
C     A TRANSFORM OF N DATA POINTS, ARE CLOBBERED IN AN ATTEMPT AT
C     SCRATCH STORAGE.  THIS HAS BEEN CORRECTED IN THE LATER VERSION, AN
C     THE OLD PROGRAM, IDENTICAL IN EXECUTION, BUT WHICH DID NOT CONTAIN
C     CORREKT THINKING IN ITS NONUSE OF COMMENTS, HAS BEEN DESTROYED.
C
C     2)  THE INVERSE TRANSFORM STATEMENTS SHOULD BE CHANGED, SO THAT 
C     A(K), A(K + 1) (BETWEEN STATEMENTS 5 & 10) IS DEFINED.   
C 
C     3)   ROUNDED ARITHMETIC SHOULD BE USED.         
C 
      DIMENSION A(1), B(1)  
      INC = IABS(ISN)        
      NK = N * INC + 2 
      NH = NK / 2    
      SD = -2.0 * ATAN(1.0) / FLOAT(N) 
      CD = 2.0 * SIN(SD) **2    
      SD = SIN(SD + SD)        
      IF ( ISN .LT. 0 ) GOTO 30   
      CN = 1.       
C     DO FIRST LOOP  
C     STORING NYQUIST REAL IN IMAGINARY 0 SAMPLE & VICEVERSA   
      AA   = 2. * (A(1) + B(1))   
      B(1) = 2. * (A(1) - B(1))   
C 
12    A(1) = AA     
C INCREMENT SIN & COSINE    
      SN = SD * CN    
      CN = CN * (1. - CD)         
      L = 1 + INC

C     *** MAIN LOOP ***       

      DO J = L, NH, INC      
C        OK, FROM HERE ON IT'S ALMOST THE SAME.    
         K = NK - J    
         AA = A(J) + A(K)         
         AB = A(J) - A(K)         
         BA = B(J) + B(K)         
         BB = B(J) - B(K)         
         RE = CN * BA + SN * AB      
         FIM = SN * BA - CN * AB      
         B(K) = FIM - BB
         B(J) = FIM + BB         
         A(K) = AA - RE 
         A(J) = AA + RE 
         AA = CN - (CD * CN + SD * SN)  
         SN = (SD * CN - CD * SN) + SN  
C        THE FOLLOWING THREE STATEMENTS COMPENSATE FOR TRUNCATION         
C        ERROR.  IF ROUNDED ARITHMETIC IS USED, SUBSTITUTE     
         CN = AA
       END DO     
C      CN = 0.5 / (AA**2 + SN**2) + 0.5  
C      SN = CN * SN   
C      CN = CN * AA   

       RETURN

C      *** INVERSE TRANSFORM ***         
 30    CN = -1.0    
       SD = -SD     
       AA   = A(1) + B(1)       
       B(1) = A(1) - B(1)       
       GO TO 12
   
       END        
C**********************************************************************C
      SUBROUTINE RFFT(A, NX, IFORW)
      DIMENSION A(NX)
      IF (IFORW.GT.0) THEN
         CALL CFFT(A, NX / 2, 1)
         CALL RFT(A(1), A(2), NX / 2, 2)
      ELSE
         CALL RFT(A(1), A(2), NX / 2,  - 2)
         CALL CFFT(A, NX / 2,  - 1)
      END IF
      RETURN
      END
C**********************************************************************C
      SUBROUTINE RFFTSC(A, NX, IPACK, IFAC)
      DIMENSION A(*)

      IF (IFAC.EQ.1) THEN
         FAC = .5 / NX
      ELSE IF (IFAC.EQ. - 1) THEN
         FAC = 0.25 / NX
      ELSE
         FAC = 1E0
      END IF

      IF (IPACK.EQ.2) THEN
         A(2) = 0E0
      ELSE IF (IPACK.EQ.3) THEN
         A(NX + 1) = A(2)
         A(NX + 2) = 0E0
         A(2) = 0E0
      ELSE IF (IPACK.EQ. - 3) THEN
         A(2) = A(NX + 1)
      ELSE IF (IPACK.EQ. - 2) THEN
         A(2) = 0E0
      END IF

      IF (IFAC.NE.0) THEN
        DO I = 1, NX
           A(I) = A(I) * FAC
        END DO
      END IF

      RETURN
      END

      SUBROUTINE BCIMP( X, BCTYPE, BOTTOP, CPHS, CSHS, RHOHS,
     &   F, G, IPOW )

C     Compute Boundary Condition IMPedance

      INCLUDE 'comc.f'

      COMPLEX*16 X, F, G, KX, KZ, TWERSK,
     &   GAMS2, GAMP2, GAMS, GAMP, RMU, YV( 5 ),
     &   PEKRT, RCMPLX
      COMPLEX*16 CPHS, CSHS, CINS
      CHARACTER BCTYPE*1, BOTTOP*3

      IPOW = 0

C     *** Get RHO, C just INSide the boundary ***
C     (There is at least one acoustic layer in the problem, except
C     in the case where BOUNCE is used to get the refl. coef. for
C     a purely elastic stack of layers.

      IF ( BOTTOP(1:3) .EQ. 'TOP' ) THEN
        IF ( NFACT .GT. 0 ) THEN
          I = LOC( NFACT ) + N( NFACT ) + 1
          RHOINS = RHO( I )
          CINS = PEKRT( OMEGA2 * H( NFACT ) **2 /
     &                  ( 2.0 + B1( NFACT ) ) )
        ENDIF
      ELSE
        IF ( NLACT .GT. 0 ) THEN
          I = LOC( NLACT ) + N( NLACT ) + 1
          RHOINS = RHO( I )
          CINS = PEKRT( OMEGA2 * H( NLACT ) **2 /
     &                  ( 2.0 + B1( NLACT ) ) )
        ENDIF
      ENDIF

C     *** Vacuum ***

      IF ( BCTYPE(1:1) .EQ. 'V' ) THEN
         F = 1.0
C         G = -CI * PEKRT( OMEGA2 / CINS ** 2 - X ) * SIGMA( 1 ) ** 2
         G = 0.0
      ENDIF

C     *** Vacuum with Twersky scatter model ***

      IF ( BCTYPE(1:1) .EQ. 'S' .OR. BCTYPE(1:1) .EQ. 'H' .OR.
     &     BCTYPE(1:1) .EQ. 'T' .OR. BCTYPE(1:1) .EQ. 'I' ) THEN

         OMEGA = SQRT( OMEGA2 )
         KX = SQRT( X )
         F = 1.0
         G = TWERSK( BCTYPE, OMEGA, BUMDEN, XI, ETA, KX, RHOINS, CINS )
         G = G / ( CI * OMEGA * RHOINS )
      ENDIF

C     *** Rigid ***
      IF ( BCTYPE(1:1) .EQ. 'R' ) THEN
         F = 0.0
         G = 1.0
      ENDIF

      YV( 1 ) = F
      YV( 2 ) = G
      YV( 3 ) = 0.0
      YV( 4 ) = 0.0
      YV( 5 ) = 0.0

C     *** Acousto-elastic half-space ***

      IF ( BCTYPE(1:1) .EQ. 'A' ) THEN
         IF ( REAL( CSHS ) .GT. 0.0 ) THEN
            GAMS2 = X - OMEGA2 / CSHS ** 2
            GAMP2 = X - OMEGA2 / CPHS ** 2

            GAMS = PEKRT( GAMS2 )
            GAMP = PEKRT( GAMP2 )

            RMU = RHOHS * CSHS ** 2

            YV( 1 ) = ( GAMS*GAMP - X ) / RMU
            YV( 2 ) = ( ( GAMS2 + X ) ** 2 - 4.0*GAMS * GAMP * X ) * RMU
            YV( 3 ) = 2.0 * GAMS * GAMP - GAMS2 - X
            YV( 4 ) = GAMP * ( X - GAMS2 )
            YV( 5 ) = GAMS * ( GAMS2 - X )

            F = OMEGA2 * YV( 4 )
            G = YV( 2 )
         ELSE
            GAMP = PEKRT( X - OMEGA2 / CPHS ** 2 )
            F = 1.0
            G = RHOHS / GAMP
         ENDIF
      ENDIF

C     *** Tabulated reflection coefficient ***

      IF ( BCTYPE(1:1) .EQ. 'F' ) THEN
C        --- Compute the grazing angle THETA
         KX = SQRT( X )
         KZ = SQRT( OMEGA2 / CINS ** 2 - KX ** 2 )
         RADDEG = 360.0 / ( 2.0 * PI )
         THEINT = RADDEG * DATAN2( DBLE( KZ ), DBLE( KX ) )

C        --- Evaluate R( THEINT )
         IF ( BOTTOP(1:3) .EQ. 'TOP' ) THEN
            CALL REFCO( THEINT, RINT, PHIINT, THETAT, RT, PHIT, NTPTS )
         ELSE
            CALL REFCO( THEINT, RINT, PHIINT, THETAB, RB, PHIB, NBPTS )
         ENDIF

C        --- Convert R(THETA) to (f,g) in Robin BC
         RCMPLX = RINT * EXP( -CI * PHIINT )
         F = 1.0
         G = ( 1.0 + RCMPLX ) / ( CI * KZ * ( 1.0 - RCMPLX ) )
      ENDIF

C     *** A top BC has the sign flipped relative to a bottom BC ***

      IF ( BOTTOP(1:3) .EQ. 'TOP' ) G = -G

C     *** Precalculated reflection coef ***

      IF ( BCTYPE(1:1) .EQ. 'P' ) THEN
         CALL IRCINT( X, F, G, IPOW, XTAB, FTAB, GTAB, ITAB, NKPTS )
      ENDIF

C     *** Shoot through elastic layers ***

      IF ( BOTTOP(1:3) .EQ. 'TOP' ) THEN

C        --- Shoot down from top
         IF ( NFACT. GT. 1 ) THEN

            DO MED = 1, NFACT - 1
               CALL ELASDN( X, YV, IPOW, MED )
            END DO

            F = OMEGA2 * YV( 4 )
            G = YV( 2 )
         ENDIF
      ELSE

C        --- Shoot up from bottom
         IF ( NLACT. LT. NMEDIA ) THEN

            DO MED = NMEDIA, NLACT + 1, -1
               CALL ELASUP( X, YV, IPOW, MED )
            END DO

            F = OMEGA2 * YV( 4 )
            G = YV( 2 )
         ENDIF
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE ELASUP( X, YV, IPOW, MED )

C     Propagates through an elastic layer using 
C     compound matrix formulation

      INCLUDE 'comc.f'

      COMPLEX*16 X, XV( 5 ), YV( 5 ), ZV( 5 ), TWOX, XB3, FOURHX
      PARAMETER ( ROOF = 1.0E5, FLOOR = 1.0E-5, IPOWR = 5, IPOWF = -5 )

C     Euler's method for first step

      TWOX   = 2.0 * X
      TWOH   = 2.0 * H( MED )
      FOURHX = 4.0 * H( MED ) * X
      J = LOC( MED ) + N( MED ) + 1
      XB3 = X * B3( J ) - RHO( J )

      ZV(1) = YV(1) - 0.5*(   B1( J ) * YV( 4 ) - B2( J ) * YV( 5 ) )
      ZV(2) = YV(2) - 0.5*( -RHO( J ) * YV( 4 ) -     XB3 * YV( 5 ) )
      ZV(3) = YV(3) - 0.5*(      TWOH * YV( 4 ) + B4( J ) * YV( 5 ) )
      ZV(4) = YV(4) - 0.5*(   XB3*YV(1) + B2(J)*YV(2) -TWOX*B4(J)*YV(3))
      ZV(5) = YV(5) - 0.5*(RHO(J)*YV(1) - B1(J)*YV(2) -    FOURHX*YV(3))

C     Modified midpoint method

      DO I = N( MED ), 1, -1
         J = J - 1

         DO L = 1, 5
            XV( L ) = YV( L )
            YV( L ) = ZV( L )
         END DO

         XB3 = X * B3( J ) - RHO( J )

         ZV(1) = XV(1) - (   B1( J ) * YV( 4 ) - B2( J ) * YV( 5 ) )
         ZV(2) = XV(2) - ( -RHO( J ) * YV( 4 ) -     XB3 * YV( 5 ) )
         ZV(3) = XV(3) - (      TWOH * YV( 4 ) + B4( J ) * YV( 5 ) )
         ZV(4) = XV(4) - (   XB3*YV(1) + B2(J)*YV(2) - TWOX*B4(J)*YV(3))
         ZV(5) = XV(5) - (RHO(J)*YV(1) - B1(J)*YV(2) -     FOURHX*YV(3))

C        *** Scale if necessary ***

         IF ( I .NE. 1 ) THEN
            IF ( ABS( DBLE( ZV( 2 ) ) ) .LT. FLOOR ) THEN
               DO L = 1, 5
                  ZV( L ) = ROOF * ZV( L )
                  YV( L ) = ROOF * YV( L )
               END DO
               IPOW = IPOW - IPOWR
            ENDIF

            IF ( ABS( DBLE( ZV( 2 ) ) ) .GE. ROOF  ) THEN
               DO L = 1, 5
                  ZV( L ) = FLOOR * ZV( L )
                  YV( L ) = FLOOR * YV( L )
               END DO
               IPOW = IPOW - IPOWF
            ENDIF
         ENDIF
      END DO

C     Apply the standard filter at the terminal point

      DO J = 1, 5
         YV( J ) = ( XV( J ) + 2.0 * YV( J ) + ZV( J ) ) / 4.0
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE ELASDN( X, YV, IPOW, MED )

C     Propagates through an elastic layer using 
C     compound matrix formulation

      INCLUDE 'comc.f'

      COMPLEX*16 X, XV( 5 ), YV( 5 ), ZV( 5 ), TWOX, XB3, FOURHX
      PARAMETER ( ROOF = 1.0E5, FLOOR = 1.0E-5, IPOWR = 5, IPOWF = -5 )

C     Euler's method for first step

      TWOX   = 2.0 * X
      TWOH   = 2.0 * H( MED )
      FOURHX = 4.0 * H( MED ) * X
      J = LOC( MED ) + 1
      XB3 = X * B3( J ) - RHO( J )

      ZV(1) = YV(1) + 0.5*(   B1( J ) * YV( 4 ) - B2( J ) * YV( 5 ) )
      ZV(2) = YV(2) + 0.5*( -RHO( J ) * YV( 4 ) -     XB3 * YV( 5 ) )
      ZV(3) = YV(3) + 0.5*(      TWOH * YV( 4 ) + B4( J ) * YV( 5 ) )
      ZV(4) = YV(4) + 0.5*(   XB3*YV(1) + B2(J)*YV(2) -TWOX*B4(J)*YV(3))
      ZV(5) = YV(5) + 0.5*(RHO(J)*YV(1) - B1(J)*YV(2) -    FOURHX*YV(3))

C     Modified midpoint method

      DO I = 1, N( MED )
         J = J + 1

         DO L = 1, 5
            XV( L ) = YV( L )
            YV( L ) = ZV( L )
         END DO

         XB3 = X * B3( J ) - RHO( J )

         ZV(1) = XV(1) + (   B1( J ) * YV( 4 ) - B2( J ) * YV( 5 ) )
         ZV(2) = XV(2) + ( -RHO( J ) * YV( 4 ) -     XB3 * YV( 5 ) )
         ZV(3) = XV(3) + (      TWOH * YV( 4 ) + B4( J ) * YV( 5 ) )
         ZV(4) = XV(4) + (   XB3*YV(1) + B2(J)*YV(2) - TWOX*B4(J)*YV(3))
         ZV(5) = XV(5) + (RHO(J)*YV(1) - B1(J)*YV(2) -     FOURHX*YV(3))

C        *** Scale if necessary ***

         IF ( I .NE. N( MED ) ) THEN
            IF ( ABS( DBLE( ZV( 2 ) ) ) .LT. FLOOR ) THEN

               DO L = 1, 5
                  ZV( L ) = ROOF * ZV( L )
                  YV( L ) = ROOF * YV( L )
               END DO

               IPOW = IPOW - IPOWR
            ENDIF

            IF ( ABS( DBLE( ZV( 2 ) ) ) .GE. ROOF  ) THEN

               DO L = 1, 5
                  ZV( L ) = FLOOR * ZV( L )
                  YV( L ) = FLOOR * YV( L )
               END DO

               IPOW = IPOW - IPOWF
            ENDIF
         ENDIF
      END DO

C     Apply the standard filter at the terminal point

      DO J = 1, 5
         YV( J ) = ( XV( J ) + 2.0 * YV( J ) + ZV( J ) ) / 4.0
      END DO

      RETURN
      END

      PROGRAM SWITCHSR

C     Switches the sources and receivers in a file

      INTEGER INFIL, OUTFIL 
      PARAMETER ( INFIL = 26,  OUTFIL = 25,
     &   MAXNSD = 4094, MAXNRD = 4094, MAXNR = 4094 )

      REAL    R( MAXNR ), SD( MAXNSD ), RD( MAXNRD )
      COMPLEX P( MAXNR )
      CHARACTER TITLE*80, PLTTYP*10

C     *** Read replica file header ***

      CALL RDHEAD( INFIL, 'INFIL', MAXNR, MAXNSD, MAXNRD,
     &   FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &   SD, NSD, RD, NRD, TITLE )

C     *** Write new header with SD, RD interchanged ***

      CALL HEADER( TITLE, RD, NRD, SD, NSD,
     &   R, NR, FREQ, ATTEN, PLTTYP, XS, YS, THETA )

C     *** Loop to read successive slices ***

      DO ISD = 1, NSD

         DO IRD = 1, NRD
C           --- read in pressure for a particular source/rcvr
            IRECIN  = 6 + NRD * ( ISD - 1 ) + IRD
            READ (  INFIL, REC = IRECIN ) ( P( IR ), IR = 1, NR )
            WRITE( *, * ) 'SD = ', SD( ISD ), 'RD = ', RD( IRD )

C           --- Write it out in a new record position
            IRECOUT = 6 + NSD * ( IRD - 1 ) + ISD
            WRITE( OUTFIL, REC = IRECOUT ) ( P( IR ), IR = 1, NR )
         END DO

      END DO

      CLOSE( OUTFIL )

      STOP
      END

      FUNCTION KUPING( SIGMA, ETA1SQ, RHO1, ETA2SQ, RHO2, P, U )

C     Evalutates the imaginary perturbation due to interfacial roughness
C     using the Kuperman-Ingenito formulation

C     P is the pressure at the interface
C     U is P'/RHO       "   "      "

      REAL*8 SIGMA, RHO1, RHO2
      COMPLEX*16 KUPING, CI, DEL, P, U,
     &   ETA1, ETA2, ETA1SQ, ETA2SQ, SCATRT, A11, A12, A21, A22

      PARAMETER ( CI = (0.0, 1.0) )

      KUPING = 0.0
      IF ( SIGMA .EQ. 0.0 ) RETURN

      ETA1 = SCATRT( ETA1SQ )
      ETA2 = SCATRT( ETA2SQ )

      DEL = RHO1 * ETA2 + RHO2 * ETA1

      IF ( DEL .NE. 0.0 ) THEN

         A11 = 0.5 * ( ETA1SQ - ETA2SQ ) -
     &      ( RHO2 * ETA1SQ - RHO1 * ETA2SQ ) * ( ETA1 + ETA2 ) / DEL
         A12 =  CI * ( RHO2 - RHO1 )**2 * ETA1 * ETA2 / DEL
         A21 = -CI * ( RHO2 * ETA1SQ - RHO1 * ETA2SQ )**2 /
     &      ( RHO1*RHO2*DEL)
         A22 = 0.5 * ( ETA1SQ - ETA2SQ ) + ( RHO2 - RHO1 )*ETA1*ETA2*
     &      ( ETA1 + ETA2 ) / DEL

         KUPING = -SIGMA**2 * ( -A21 * P**2
     &      + ( A11 - A22 ) * P * U + A12 * U**2 )
      ENDIF

      RETURN
      END
C**********************************************************************C
      FUNCTION SCATRT( Z )

C     Root for interfacial scatter

      COMPLEX*16 SCATRT, Z
     
      IF ( REAL( Z ) .GE. 0.0 ) THEN
         SCATRT = SQRT( Z )
      ELSE
         SCATRT = -( 0.0, 1.0 ) * SQRT( -Z )
      ENDIF

      RETURN
      END

      SUBROUTINE RANGES( ENVFIL, PRTFIL, MAXNR, NR, R )

C     *** Read receiver ranges ***

      IMPLICIT NONE
      INTEGER ENVFIL, PRTFIL, MAXNR, NR, IR
      REAL R( * )

      NR = 0
      R( 2 ) = 0.0
      R( 3 ) = -999.9
      READ( ENVFIL, * ) NR, ( R( IR ), IR = 1, NR )

      IF ( NR .GT. MAXNR ) THEN
         WRITE( PRTFIL, * ) 'NR, MAXNR = ', NR, MAXNR
         CALL ERROUT( PRTFIL, 'F', 'RANGES', 'Too many range points' )
      ENDIF

      CALL SUBTAB( R, NR )
      CALL SORT(   R, NR )

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Number of ranges   = ', NR
      WRITE( PRTFIL, * ) ( R( IR ), IR = 1, MIN( NR, 51 ) )

C     ------ Convert ranges to meters
      DO IR = 1, NR
         R( IR ) = 1000.0 * R( IR )
      END DO      

C     ------ For a point source can't have receiver at origin
C      IF ( OPT(1:1) .EQ. 'R' .AND. R( 1 ) .LE. 0.0 ) 
      IF ( R( 1 ) .LE. 0.0 ) R( 1 ) = MIN( 1.0, R( 2 ) )

      RETURN
      END

      PROGRAM PLOTXY

C     Plots central rays of beams generated by FIELD3D

      INTEGER RAYFIL, PRTFIL
      PARAMETER ( PRTFIL = 6, RAYFIL = 5 )

      REAL*4 X(10000), Y(10000), XV(10000), YV(10000)

      OPEN( FILE = 'RAYFIL', UNIT = RAYFIL, STATUS = 'OLD' )

      NBEAMS = 10000

C     *** Write data ***

      DO I = 1, NBEAMS
         READ( RAYFIL, *, END = 9000 ) NSTEPS

         DO ISTEP = 1, NSTEPS
           READ( RAYFIL, *, END = 9000 ) XV( ISTEP ), YV( ISTEP )
         ENDDO

         DO ISTEP = 1, NSTEPS
            X( ISTEP ) = XV( ISTEP ) / 1000.0
            Y( ISTEP ) = YV( ISTEP ) / 1000.0
            WRITE( PRTFIL, * ) X( ISTEP ), Y( ISTEP )
         END DO

         WRITE( PRTFIL, * ) X( NSTEPS ), Y( 1 )
         WRITE( PRTFIL, * ) X( 1      ), Y( 1 )

      END DO

 9000 STOP
      END

      PROGRAM FIELDS

C     Compute pressure from Green's function.

C     The transform parameters are chosen to satisfy certain sampling
C     requirements.

C     It is assumed that the user chose the maximum possible 
C     spacing in computing g(k) and so deltak is not
C     allowed to be any larger.

C     The other part of the kernel is the exp(ikr) term.
C     this must be sampled on the k-axis finely enough to have
C     about 6 pts per wavelength.

C     DELTAR implies KMAX. KMAX is the upper limit of integration
C     and beyond the last point computed.  This assumes
C     the user had chosen KMAX as small as possible while still
C     covering the support of G(k).

C     Note 'WNO' is used for original data and 'K' for interpolated data

      INTEGER FLPFIL, PRTFIL
      PARAMETER ( FLPFIL = 5, PRTFIL = 6, 
     &   PI = 3.14159265, MAXNT = 500000, MAXNWN =  50000,
     &   MAXNSD = 501, MAXNRD = 101 )

      REAL WNO( MAXNWN ), R( MAXNT ),
     &   WNOIN( MAXNT ), RD( MAXNRD ), SD( MAXNSD ), ATTEN, FREQ
      COMPLEX G( MAXNWN ), GIN( MAXNT ), P( MAXNT ), TEMP( 2 * MAXNT )
      CHARACTER PLTITL*80, OPTION*80

C     *** Begin by reading in the data ***

      OPTION = 'RLPA'            ! default option
      READ( FLPFIL, * ) OPTION
      READ( FLPFIL, * ) RMINKM, RMAXKM, NR

      RMIN = 1000.0 * RMINKM
      RMAX = 1000.0 * RMAXKM

C     --- for a point source, take us a bit away from the source
      IF ( OPTION(1:1) .EQ. 'R' .AND. RMIN .LE. RMAX / 100000 ) THEN
         RMIN = RMAX / 100000
         WRITE( PRTFIL, * ) 'RMIN bumped to ', RMIN
      END IF

      DELTAR = ( RMAX - RMIN ) / ( NR - 1 )

C     *** Read the header records from GRNFIL ***

      CALL RDHEAD( PLTITL, SD, NSD, MAXNSD, RD, NRD, MAXNRD, 
     &   WNO, NWNO, MAXNWN, NKCORE, DELTAK, ATTEN, FREQ, NRECSR )

C     Set up for transform: need DELWNO, NT
C     DELTAK is what scooter used; DELWNO is for interpolation

C     --- If DELTAR is too big, take submultiple

      WNOMAX = WNO( 1 ) + 2.0 * PI / DELTAR

      IF ( WNOMAX .LT. WNO( NWNO ) ) THEN
         IRATIO = ( WNO( NWNO ) - WNO( 1 ) ) / ( WNOMAX - WNO( 1 ) ) + 1
         DELTAR = DELTAR / IRATIO
         NR     = IRATIO * ( NR - 1 ) + 1
         WNOMAX = WNO( 1 ) + 2.0 * PI / DELTAR
         WRITE( PRTFIL, * ) 'NR bumped to ', NR
      END IF

      NT = NR

C     Compute NT based on DELTAK (= 1/RMAX) sampling requirement

      NT2 = RMAX * ( WNOMAX - WNO( 1 ) )       ! DELTAK limit

      IF ( NT2 .GT. NT ) WRITE( PRTFIL, * ) 'NT bumped', NT, NT2
      NT = MAX( NT, NT2 )

C     Parameters when N must be a power of 2

      NT = 2 **( INT( LOG10( REAL( NT ) ) / 0.301 ) + 1 )
      DELWNO = 2.0 * PI / ( NT * DELTAR )

      WRITE( PRTFIL, * ) 'NT  used               = ', NT
      WRITE( PRTFIL, * ) 'NR  used               = ', NR
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'DELTAK = ', DELTAK
      WRITE( PRTFIL, * ) 'DELWNO = ', DELWNO
      WRITE( PRTFIL, * ) 'DELTAR = ', DELTAR
      WRITE( PRTFIL, * )

      IF ( NT .GT. MAXNT ) THEN
         CALL ERROUT( PRTFIL, 'F', 'FIELDS',
     &             'Size of tranform exceeds array size' )
      ENDIF

C     Compute optimal stabilizing attenuation.
C     ATTEN is the value used by SCOOTER
C     ATTINT is the optimal value for the interpolated k-values

      ATTINT = ATTEN

      IF ( PLTITL(1:5) .EQ. 'SPARC' ) THEN
         WRITE( PRTFIL, * ) 'SPARC RUN: ATTINT SET TO ZERO'
         ATTINT = 0.0
         IF ( ATTEN .NE. 0.0 ) THEN
            CALL ERROUT( PRTFIL, 'F', 'FIELDS',
     &             'Stabilizing attenuation must vanish' )
         ENDIF
      ENDIF

C     --- Set up vector of range points
      DO J = 1, NR
         R( J ) = RMIN + ( J - 1 ) * DELTAR
      END DO

C     Construct shade file

      CALL SHADE( WNO, DELWNO, ATTEN, NWNO, G, NT, WNOIN, GIN,
     &      R, NR, RMIN, DELTAR, SD, NSD, RD, NRD, 
     &      PLTITL, FREQ, ATTINT, NRECSR, NKCORE,
     &      OPTION, P, TEMP )

      STOP
      END
C**********************************************************************C
      SUBROUTINE RDHEAD( PLTITL, SD, NSD, MAXNSD,
     &   RD, NRD, MAXNRD, 
     &   RK, NKPTS, MAXNWN, NKCORE, DELTAK, ATTEN, FREQ, NRECSR )

C     Routine to read header from disk file

      INTEGER GRNFIL, PRTFIL
      PARAMETER ( GRNFIL = 20, PRTFIL = 6 )

      REAL RK( * ), RD( * ), SD( * )
      CHARACTER PLTITL*80, PLTTYP*10

C     Double open to get record length

      OPEN( FILE = 'GRNFIL', UNIT = GRNFIL, STATUS = 'OLD',
     &      RECL = 20, ACCESS = 'DIRECT', FORM = 'UNFORMATTED' )
      READ( GRNFIL, REC = 1 ) LRECL
      CLOSE( GRNFIL )

      OPEN( FILE = 'GRNFIL', UNIT = GRNFIL, STATUS = 'OLD',
     &   RECL = 4 * LRECL, ACCESS = 'DIRECT', FORM = 'UNFORMATTED' )

C     Read data

      READ( GRNFIL, REC = 1 ) LRECL, PLTITL
      READ( GRNFIL, REC = 2 ) PLTTYP, XS, YS, THETA
      READ( GRNFIL, REC = 3 ) FREQ, NSD, NRD, NKPTS, NKCORE,
     &                        DELTAK, ATTEN, NRECSR

      IF ( NSD .GT. MAXNSD ) CALL ERROUT( PRTFIL, 'F', 'FIELDS:RDHEAD',
     &             'Too many source depths' )

      IF ( NRD .GT. MAXNRD ) CALL ERROUT( PRTFIL, 'F', 'FIELDS:RDHEAD',
     &             'Too many receiver depths' )
 
      READ( GRNFIL, REC = 4 ) ( SD( I ), I = 1, NSD )
      READ( GRNFIL, REC = 5 ) ( RD( J ), J = 1, NRD )

C     Read in the vector of k-space points

      IF ( NRECSR * NKCORE .GT. MAXNWN )
     &   CALL ERROUT( PRTFIL, 'F', 'FIELDS:RDHEAD',
     &             'Too many k-space points' )

      DO IREC = 1, NRECSR
         ISTART = ( IREC - 1 ) * NKCORE
         READ( GRNFIL, REC = 5 + IREC )
     &      ( RK( ISTART + I ), I = 1, NKCORE )
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SHADE( WNO, DELWNO, ATTEN, NWNO, G, NT, WNOIN, GIN,
     &   R, NR, RMIN, DELTAR, SD, NSD, RD, NRD, 
     &   PLTITL, FREQ, ATTINT, NRECSR, NKCORE,
     &   OPTION,  P, TEMP )

C     Performs the transforms to convert the Green's function file
C     to a shade file

C     Expects
C        WNO, NWNO: The wavenumber data
C        SD, RD: Source depth, receiver depth data
C     Returns
C        Nothing

      INTEGER PRTFIL, GRNFIL
      PARAMETER ( PRTFIL = 6, GRNFIL = 20, MAXNR = 2045 )

      LOGICAL INIFLG
      REAL R( * ), WNOIN( * ), SD( * ), RD( * ), WNO( * )
      COMPLEX G( * ), GIN( * ), P( * ), TEMP( * )
      CHARACTER*80 PLTITL, OPTION

C     Construct the shade file header

      INIFLG = .TRUE.
      IRECOU = 6

C     If necessary, reduce range sampling to fit in the record

      NRSMPL = NR

      IF ( NR .GT. MAXNR ) THEN

         WRITE( PRTFIL, * )
     &      'Range axis subsampled to fit max record size'

         IRSKIP = NR / ( MAXNR + 1 ) + 1
         NRSMPL = NR / IRSKIP

         DO IR = 1, NRSMPL
            R( IR ) = R( ( IR - 1 ) * IRSKIP + 1 )
         END DO
         WRITE( PRTFIL, * ) 'DELTAR = ', IRSKIP * DELTAR
         WRITE( PRTFIL, * )
      ENDIF
         
      CALL HEADER( PLTITL, SD, NSD, RD, NRD, 
     &   R, NRSMPL, FREQ, ATTEN, '     ', 0.0, 0.0, 0.0 )

C     *** Loop over all source/rcvr combos ***

      DO ISD = 1, NSD

         DO IRD  = 1, NRD

            ISR    = ( ISD - 1 ) * NRD + IRD   ! Index of source/receiver
            IRECIN = 5 + ISR * NRECSR

            DO IREC = 1, NRECSR
               ISTART = ( IREC - 1 ) * NKCORE
               READ( GRNFIL, REC = IRECIN + IREC )
     &                       ( G( ISTART + I ), I = 1, NKCORE )
            END DO

            WRITE( PRTFIL, * ) 'SD, RD = ', SD( ISD ), RD( IRD )

C           *** Interpolate ***

            CALL INTERP( WNO, DELWNO, ATTEN, ATTINT, G, NWNO,
     &                   WNOIN, GIN, NT, OPTION )

C           *** Evaluate either Fourier or Hankel transform ***

            IF ( OPTION(1:1) .EQ. 'X' ) THEN
               CALL FTS( NT, WNOIN( 1 ), DELWNO, ATTINT, 
     &            RMIN, NR, DELTAR, GIN, TEMP, P, INIFLG )
            ELSE
               CALL HTS( NT, WNOIN( 1 ), DELWNO, ATTINT, 
     &            RMIN, NR, DELTAR, GIN, TEMP, P, INIFLG, OPTION )
            ENDIF

            INIFLG = .FALSE.

C           If necessary, reduce range sampling to fit in the record

            IF ( NR .GT. MAXNR ) THEN
               DO IR = 1, NRSMPL
                  P( IR ) = P( IRSKIP * IR + 1 )
               END DO
            ENDIF

C           *** Write out the field ***

            CALL WRTFLD( P, 1, NRSMPL, IRECOU )

         END DO   ! next receiver depth
      END DO   ! next source depth

      RETURN
      END
C**********************************************************************C
      SUBROUTINE INTERP( WNO, DELWNO, ATTEN, ATTINT, G, NWNO,
     &   WNOIN, GIN, NT, OPTION )

C     Produces an evenly sampled kernel from input G

      INTEGER PRTFIL
      COMPLEX CI
      PARAMETER ( PRTFIL = 6, CI = ( 0.0, 1.0 ) )

      REAL WNO( * ), WNOIN( * )
      COMPLEX G( * ), GIN( * ), WNOT2, X( 9 ), F( 9 ), PADE
      CHARACTER ERRMSG*80, OPTION*80

C     ------ Initialize interpolation data
      ISIZE  = 3
      ICTR   = 2
      IRIGHT = 3
      NEW    = ISIZE

      DO I = 1, ISIZE
         X( I ) = ( WNO( I ) + CI * ATTEN )**2
         F( I ) = G( I )
      END DO

C     *** Main loop: take steps of delwno along the k-axis ***

      DO I = 1, NT
         WNOIN( I ) = WNO( 1 ) + ( I - 1 ) * DELWNO

C        --- Desirable/possible to advance interpolation window?
 5000    IF ( WNOIN( I ) .GT. WNO( ICTR ) ) THEN
            IF ( IRIGHT .LT. NWNO ) THEN
               ICTR   = ICTR   + 1
               IRIGHT = IRIGHT + 1
               NEW    = MOD( NEW, ISIZE ) + 1

               X( NEW ) = ( WNO( IRIGHT ) + CI * ATTEN )**2
               F( NEW ) = G( IRIGHT )
C              ------ Check again
               GOTO 5000
            ENDIF
         ENDIF

C        --- Interpolate or zero fill
         IF ( WNOIN( I ) .LE. WNO( NWNO ) ) THEN
            WNOT2 = ( WNOIN( I ) + CI * ATTINT )**2
            IF ( OPTION(4:4) .EQ. 'O' ) THEN
               GIN( I ) = PC(   WNOT2, X, F, ISIZE, ERRMSG )   ! polynomial
            ELSE
               GIN( I ) = PADE( WNOT2, X, F, ISIZE, ERRMSG )   ! Pade
            ENDIF

            IF ( ERRMSG .NE. ' ' ) WRITE( PRTFIL, * ) ERRMSG
         ELSE
            GIN( I ) = 0.0
         ENDIF

      END DO

      RETURN
      END

      PROGRAM TOASC

C     Converts shade file to ASCII format

      INTEGER SHDFIL, ASCFIL
      PARAMETER ( SHDFIL = 25, ASCFIL = 26, 
     &   MAXNSD = 500, MAXNRD = 5000, MAXNR = 4094 )

      REAL    R( MAXNR ), SD( MAXNSD ), RD( MAXNRD )
      COMPLEX P( MAXNR )
      CHARACTER TITLE*80, PLTTYP*10

C     *** Read header ***

      CALL RDHEAD( SHDFIL, ' ', MAXNR, MAXNSD, MAXNRD,
     &   FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &   SD, NSD, RD, NRD, TITLE )

C     *** Write header ***

      OPEN ( FILE = 'ASCFIL', UNIT = ASCFIL, STATUS = 'UNKNOWN',
     &       FORM = 'FORMATTED' )

      WRITE( ASCFIL, 500 ) TITLE
  500 FORMAT( A80 )

      WRITE( ASCFIL, * ) '''', PLTTYP, '''', XS, YS, THETA
      WRITE( ASCFIL, * ) FREQ, NSD, NRD, NR

      WRITE( ASCFIL, 200 ) ( SD( I ), I = 1, NSD )
      WRITE( ASCFIL, 200 ) ( RD( I ), I = 1, NRD )
      WRITE( ASCFIL, 200 ) ( R(  I ), I = 1, NR )
  200 FORMAT( 6E13.5 )

C     *** Main loop: convert pressure surfaces for each s/r combo ***

      DO ISD = 1, NSD
         IREC = 6 + ( ISD - 1 ) * NRD

         DO IRD = 1, NRD
            IREC = IREC + 1
            READ( SHDFIL, REC = IREC ) ( P( J ), J = 1, NR)
            WRITE( *, * ) ISD, IRD, SD( ISD ), RD( IRD )
            WRITE( ASCFIL, 600 ) ( P( J ), J = 1, NR)
  600       FORMAT( 6E13.5 )
         END DO

      END DO

      CLOSE( ASCFIL )

      STOP
      END

        SUBROUTINE SMOOTH( TLRAW, TL, NROWS, NTHETA, NR, DR, DR3DB )

C       Smooth out T.L. curve using Gaussian averaging ---
C          2*J3DB is the number of points averaged in
C          SIG    is the 'sharpness' coefficient

        PARAMETER ( MXNP = 500, LG3DB = .345388 )
        REAL TLRAW(NROWS, NR), TL(NROWS, NR), NORM, GCOEF(0:MXNP)

        J3DB = INT( DR3DB / ( 2.0 * DR ) )
        NJ = 2 * J3DB
        IF ( NJ .GT. MXNP ) THEN
           WRITE( *, * )
     &          'FATAL ERROR: Too many points in smoothing window'
           WRITE( *, * ) ' NP = ', NJ, ' MXNP = ', MXNP
           STOP 'FATAL ERROR: Too many points in smoothing window'
        ENDIF

C       *** If no smoothing then do a simple copy ***

        IF ( NJ .EQ. 0 ) THEN
           DO 700 JTH = 1, NTHETA
              DO 500 IR = 1, NR
                 TL( JTH, IR ) = TLRAW( JTH, IR )
  500         CONTINUE
  700      CONTINUE
           RETURN
        END IF

C       *** Compute the filter coefficients ***

        SHRPCF = LG3DB / FLOAT( J3DB **2 )
        DO 1000 JR = 0, NJ
           JSQ = ( J3DB - JR ) **2
           GCOEF( JR ) = EXP( -SHRPCF * FLOAT( JSQ ) )
 1000   CONTINUE

C       *** Apply the filter ***

        DO 4000 JTH = 1, NTHETA
           DO 3000 IR = 1, NR
              TLSUM = 0.0
              NORM  = 0.0
              DO 2000 JR = -J3DB, J3DB
                 K1 = IR + JR
                 IF ( K1 .GT. 0 .AND. K1 .LE. NR ) THEN
                    TLSUM = TLSUM + TLRAW( JTH, K1 ) * GCOEF( J3DB + JR)
                    NORM = NORM + GCOEF( J3DB + JR )
                 ENDIF
 2000         CONTINUE
              TL( JTH, IR ) = TLSUM / NORM
 3000      CONTINUE
 4000     CONTINUE

        RETURN
        END

      SUBROUTINE ERROUT( PRTFIL, SEVRTY, WHERE, ERRMSG )

C     Outputs an error message

C     PRTFIL unit number for print-out
C     SEVRTY:
C        'W' Warning
C        'F' Fatal
C     WHERE  in which program or subroutine
C     ERRMSG error message

      IMPLICIT NONE
      INTEGER PRTFIL, LAST
      CHARACTER SEVRTY *1, WHERE *(*), ERRMSG *(*)

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * )

C     *** Severity ***

      IF( SEVRTY(1:1) .EQ. 'W' ) THEN
         WRITE( PRTFIL, * ) '*** WARNING ***'
      ELSE IF( SEVRTY(1:1) .EQ. 'F' ) THEN
         WRITE( PRTFIL, * ) '*** FATAL ERROR ***'
      ELSE
         WRITE( PRTFIL, * ) '*** FATAL ERROR ***'
         WRITE( PRTFIL, * )
     &      'The error handler (ERROUT) has been called ',
     &      'with an unknown severity level: ', SEVRTY(1:1)
      ENDIF

      WRITE( PRTFIL, * )

C     *** Where did it happen? ***

      LAST = LEN( WHERE )
      WRITE( PRTFIL, * ) 'Error detected in program or subroutine: ',
     &                   WHERE( 1:LAST )

C     *** What is the error? ***

      LAST = LEN( ERRMSG )
      WRITE( PRTFIL, * ) ERRMSG(1:LAST)

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * )

C     ******

      IF ( SEVRTY(1:1) .EQ. 'W' ) THEN
         RETURN
      ELSE
         STOP 'Fatal Error: See print file for details about '
      ENDIF

      END

      PROGRAM BOUNCE

C     Program for computing the reflection coefficient, R(theta)

C     Michael B. Porter

      INCLUDE 'comc.f'

C     *** Read in environmental info ***

      TITLE = 'BOUNCE-'

      CALL READIN( TITLE, FREQ, MAXMED, NMEDIA,
     &   TOPOPT, CPT, CST, RHOT, BUMDEN, ETA, XI, NG, SIGMA, DEPTH, 
     &   BOTOPT, CPB, CSB, RHOB,
     &   ENVFIL, PRTFIL )

C     *** Spectral limits ***

      READ(  ENVFIL, *    ) CLOW, CHIGH
      WRITE( PRTFIL, 500  ) CLOW, CHIGH
  500 FORMAT( /, ' CLOW = ', G12.5, '  CHIGH = ', G12.5 )

C     *** Maximum range for calculations ***

      READ(  ENVFIL, * ) RMAX
      WRITE( PRTFIL, * ) 'RMAX = ', RMAX

      OMEGA2 = ( 2.0 * PI * FREQ ) ** 2

C     *** Optionally read in bottom reflection coefficient data ***

      DEGRAD = PI / 180.0

      IF ( BOTOPT(1:1) .EQ. 'F' ) THEN
         WRITE( PRTFIL, * )
     &      'Using tabulated bottom reflection coefficient'
         READ( BRCFIL, * )
     &      NBPTS, ( THETAB( I ), RB( I ), PHIB( I ), I = 1, NBPTS )

         DO I = 1, NBPTS
            PHIB( I ) = DEGRAD * PHIB( I )
         END DO
      ENDIF

C     *** Optionally read in internal reflection coefficient data ***

      IF ( BOTOPT(1:1) .EQ. 'P' ) THEN
         WRITE( PRTFIL, * ) 'Reading precalculated refl. coeff. table'
         OPEN( FILE = 'IRCFIL', UNIT = IRCFIL, STATUS = 'OLD' )

         READ( IRCFIL, * ) NKPTS, ( XTAB( IK ), FTAB( IK ),
     &                 GTAB( IK ), ITAB( IK ), IK = 1, NKPTS )
         IF ( NKPTS .GT. MXREF ) THEN
            WRITE( PRTFIL, * ) 'Too many k-points in IRC file'
            WRITE( PRTFIL, * ) 'NKPTS, MXREF = ', NKPTS, MXREF
            STOP 'FATAL ERROR: Too many k-points in IRC file'
         ENDIF
      ENDIF

      CLOSE( ENVFIL )

C     *** Write internal reflection coefficient data ***

      WRITE( PRTFIL, * ) 'Writing internal refl. coeff. table'
C     --- Compute NKPTS
      IF ( CLOW .EQ. 0.0 ) THEN
         WRITE( PRTFIL, * )
     &         'FATAL ERROR: CLOW must be greater than zero'
         STOP  'FATAL ERROR: CLOW must be greater than zero'
      ENDIF

      RKMIN = SQRT( OMEGA2 ) / CHIGH
      RKMAX = SQRT( OMEGA2 ) / CLOW
      IF ( CHIGH .GE. 1.0E6 ) RKMIN = 0.0
      NKPTS = 1000.0 * RMAX * ( RKMAX - RKMIN ) / ( 2.0 * PI )
      WRITE( PRTFIL, * ) 'NKPTS = ', NKPTS

      IF ( NKPTS .GT. MXREF ) THEN
         WRITE( PRTFIL, * ) 'FATAL ERROR: Too many k-points'
         WRITE( PRTFIL, * ) 'NKPTS, MXREF = ', NKPTS, MXREF
         STOP               'FATAL ERROR: Too many k-points'
      ENDIF

      CALL COMPR( RKMIN, RKMAX )

      STOP
      END
C**********************************************************************C
      SUBROUTINE INIT

C     Initializes arrays defining difference equations

      INCLUDE 'comc.f'

      LOGICAL ELFLAG
      COMPLEX*16 CP( MAXN ), CS( MAXN ), CP2, CS2

      COMMON /SPACE/ CP, CS

      ELFLAG   = .FALSE.
      CMIN     = 1.0E6
      NFACT    = 0
      LOC( 1 ) = 0

C     *** Loop over media ***

      DO MED = 1, NMEDIA
         IF ( MED .NE. 1 ) LOC( MED ) = LOC( MED-1 ) + N( MED-1 ) + 1
         N1 = N(   MED ) + 1
         I  = LOC( MED ) + 1

         IF ( LOC( MED ) + N1 .GT. MAXN ) THEN
            WRITE( PRTFIL, * )
     &           'FATAL ERROR: Insufficient storage for mesh'
            STOP 'FATAL ERROR: Insufficient storage for mesh'
         ENDIF

C        *** PROFIL reads in the data for a medium ***

         CALL PROFIL( DEPTH, CP( I ), CS( I ), RHO( I ),
     &      MED, N1, FREQ, TOPOPT(1:1), TOPOPT(3:3), 'TAB',
     &      ENVFIL, PRTFIL )

C        *** Load diagonals of the finite-difference equations ***

         IF ( CS( I ) .EQ. ( 0.0, 0.0 ) ) THEN

C           --- Case of an acoustic medium ---

            MATER( MED ) = 'ACOUSTIC'
            IF ( NFACT .EQ. 0 ) NFACT = MED
            NLACT = MED

            DO J = I, I + N( MED )
               CMIN = MIN( DBLE( CP( J ) ), CMIN )
               B1( J ) = -2.0 +  H( MED ) ** 2 * OMEGA2 / CP( J ) ** 2
            END DO
         ELSE

C           --- Case of an elastic medium ---

            IF ( SIGMA( MED ) .NE. 0.0 ) THEN
               WRITE( PRTFIL, * ) 'Rough elastic interface not allowed'
               WRITE( PRTFIL, * ) 'PROGRAM ABORTING'
               STOP
     &         'ERROR IN KRAKENC: Rough elastic interface not allowed'
            ENDIF

            MATER( MED ) = 'ELASTIC'
            ELFLAG = .TRUE.
            TWOH   = 2.0 * H( MED )

            DO J = I, I + N( MED )
               CMIN = MIN( DBLE( CS( J ) ), CMIN )

               CP2 = CP( J ) ** 2
               CS2 = CS( J ) ** 2

               B1( J ) = TWOH / ( RHO( J ) * CS2 )
               B2( J ) = TWOH / ( RHO( J ) * CP2 )
               B3( J ) = 4.0 * TWOH * RHO(J) * CS2 * ( CP2 - CS2 ) / CP2
               B4( J ) = TWOH * ( CP2 - 2.0*CS2 ) / CP2

               RHO( J ) = TWOH * OMEGA2 * RHO( J )
            END DO

         ENDIF
      END DO   ! Next MED

C     *** Bottom properties ***

      IF ( BOTOPT(1:1) .EQ. 'A' ) THEN
         IF ( CSB .NE. ( 0.0, 0.0 ) ) THEN
C           --- Elastic bottom:
            ELFLAG = .TRUE.
            CMIN = MIN( CMIN, DBLE( CSB ) )
         ELSE
C           --- Acoustic bottom:
            CMIN = MIN( CMIN, DBLE( CPB ) )
         ENDIF
      ENDIF

C     *** Top properties ***

      IF ( TOPOPT(2:2) .EQ. 'A' ) THEN
         IF ( CST .NE. ( 0.0, 0.0 ) ) THEN
C           --- Elastic top:
            ELFLAG = .TRUE.
            CMIN = MIN( CMIN, DBLE( CST ) )
         ELSE
C           --- Acoustic top:
            CMIN = MIN( CMIN, DBLE( CPT ) )
         ENDIF
      ENDIF

      IF ( ELFLAG ) CMIN = 0.9 * CMIN
      CLOW = MAX( CLOW, 0.99 * CMIN )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE COMPR( RKMIN, RKMAX )

C     Computes the reflection coefficient for k in [RKMIN, RKMAX]

      INCLUDE 'comc.f'

      COMPLEX*16 X, F, G
      CHARACTER BCTYPE*1

      DO MED = 1, NMEDIA
         N( MED ) = NG( MED )
         H( MED ) = ( DEPTH( MED + 1 ) - DEPTH( MED ) ) / N( MED )
      END DO

      HV( 1 ) = H( 1 )
      CALL INIT

      DELTAK = ( RKMAX - RKMIN ) / ( NKPTS - 1 )

      DO IK = 1, NKPTS
         RK = RKMIN + ( IK - 1 ) * DELTAK
         X = RK ** 2

C        --- Bottom impedance
         BCTYPE(1:1) = BOTOPT(1:1)
         CALL BCIMP( X, BCTYPE, 'BOT', CPB, CSB, RHOB, F, G, IPOW )

C        --- Shoot through acoustic layers
         CALL ACOUST( X, F, G, IPOW  )

         XTAB( IK ) = X
         FTAB( IK ) = F
         GTAB( IK ) = G
         ITAB( IK ) = IPOW
      END DO

      OPEN( FILE = 'IRCFIL', UNIT = IRCFIL )
      WRITE( IRCFIL, * ) '''', TITLE, '''', FREQ
      WRITE( IRCFIL, * ) NKPTS, ( XTAB( IK ),
     &           FTAB( IK ), GTAB( IK ), ITAB( IK ), IK = 1, NKPTS )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE ACOUST( X, F, G, IPOW )

C     Shoot through acoustic layers

      INCLUDE 'comc.f'

      COMPLEX*16 X, F, G, P0, P1, P2, H2K2
      PARAMETER ( ROOF = 1.0E5, FLOOR = 1.0E-5, IPOWR = 5, IPOWF = -5 )

      IF ( NFACT .EQ. 0 ) RETURN 

C     *** Loop over successive acoustic media ***

      DO MED = NLACT, NFACT, -1
         H2K2 = H( MED ) ** 2 * X
         I = LOC( MED ) + N( MED ) + 1
         RHOM = RHO( I )
         P1 = -2.0 * G
         P2 = ( B1( I ) - H2K2 ) * G - 2.0 * H( MED ) * F * RHOM

C        *** Shoot through a single medium ***

         DO I = LOC( MED ) + N( MED ), LOC( MED ) + 1, -1

            P0 = P1
            P1 = P2
            P2 = ( H2K2 - B1( I ) ) * P1 - P0

   60       IF ( ABS( DBLE( P2 ) ) .GE. ROOF ) THEN
               P0 = FLOOR * P0
               P1 = FLOOR * P1
               P2 = FLOOR * P2
               IPOW = IPOW - IPOWF
               GOTO 60
            ENDIF
         END DO

C        --- F = P'/RHO and G = -P since FP+GP'/RHO = 0
         F = -( P2 - P0 ) / ( 2.0 * H( MED ) ) / RHOM
         G = -P1
      END DO

      RETURN
      END

      PROGRAM MAKETS

C     Makes the time series file for a particular wavelet

      INTEGER PRTFIL
      PARAMETER ( PRTFIL = 6, MAXNT = 20000, NSD = 1,
     &            PI = 3.141592 )

      REAL TV( MAXNT )
      COMPLEX SF( MAXNT )
      CHARACTER PULSE*4, PULSTITL*80

C     *** Read in data ***

C     WRITE( PRTFIL, * ) 'Pulse type = '
      READ( *, * ) PULSE(1:1)

C     WRITE( PRTFIL, * ) 'Nominal frequency = '
      READ( *, * ) FREQ
      OMEGA  = 2.0 * PI * FREQ

C     WRITE( PRTFIL, * ) 'NT, TMIN, TMAX'
      READ( *, * ) NT, TMIN, TMAX
      DELTAT = ( TMAX - TMIN ) / ( NT - 1 )

      IT0 = 1

C     *** step through time, evaluating waveform ***

      DO IT = 1, NT
         TV( IT ) = TMIN + ( IT - 1 ) * DELTAT

         CALL CANS( TV( IT ), OMEGA, PULSE,
     &              SF( IT ), NSD, IT0, PULSTITL )

         WRITE( PRTFIL, * ) TV( IT ), REAL( SF( IT ) )
      END DO

      STOP
      END

      SUBROUTINE FACTOR( N, A, IERR, RV, RVU )
C
C     MICHAEL B. PORTER 7/1/85
C
C     THIS SUBROUTINE IS BASED ON TINVIT IN EISPACK
C     USES GAUSSIAN ELIMINATION WITH PIVOTING TO FACTOR A
C        SYMMETRIC TRIDIAGONAL LINEAR SYSTEM
C     
C     ON INPUT
C
C        N IS THE ORDER OF THE MATRIX.
C        A CONTAINS THE INPUT MATRIX.
C
C
C     ON OUTPUT
C
C        RV1, RV2, RV3 AND RV4 CONTAIN THE FACTORED MATRIX
C
      COMPLEX U, XU, A(2, N), RV(2, N), RVU(2, N)

C     LU DECOMPOSITION WITHOUT INTERCHANGES

      XU = 1.0
      U = A(1,1)

      IF ( N .GT. 1 ) THEN
      DO 580 I = 2, N-1
         XU = A( 2, I ) / U
         RV( 2, I   ) = XU
         RVU( 1, I-1 ) = 1.0 / U
         RVU( 2, I-1 ) = A( 2, I )
         U = A( 1, I   ) - XU * A( 2, I )
  580 CONTINUE
      ENDIF

      XU = A( 2, N ) / U
      RV( 2, N   ) = XU
      RVU( 1, N-1 ) = 1.0 / U
      RVU( 2, N-1 ) = A( 2, N )
      U = A( 1, N ) - XU * A( 2, N )

      IF( U .EQ. 0.0 ) WRITE( *, * ) 'SINGULAR MATRIX'
      RVU(1,N) = 1.0 / U
      RVU(2,N) = 0.0

      RETURN
      END

      SUBROUTINE BACKSB(N,A,IERR,RV,RVU,B)
C
C     MICHAEL B. PORTER 7/1/85
C
C     THIS SUBROUTINE IS BASED ON TINVIT IN EISPACK
C     PERFORMS BACK-SUBSTITUTION FOR A
C        SYMMETRIC TRIDIAGONAL LINEAR SYSTEM
C     
C     ON INPUT
C
C        N IS THE ORDER OF THE MATRIX.
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX.
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE INPUT MATRIX
C          IN ITS LAST N-1 POSITIONS.  E(1) IS ARBITRARY.
C        B CONTAINS THE RIGHT HAND SIDE (AX=B)
C
C     ON OUTPUT
C
C        ALL INPUT ARRAYS ARE UNALTERED EXCEPT
C        B WHICH CONTAINS THE SOLUTION
C
C     RV IS A TEMPORARY STORAGE ARRAY.

      COMPLEX U,V,A(2,N),RV(2,N), RVU(2,N), B(N)

C     *** FORWARD ELIMINATION ***

      DO 820 I = 2, N
         B( I ) = B( I ) - RV( 2, I ) * B( I-1 )

  820 CONTINUE

C     *** BACK SUBSTITUTION (RESULT IN B) ***

      B( N ) = B( N ) * RV( 1, N )

      IF ( N .GT. 1 ) THEN
      V = RVU( 2, N-1 ) * B( N )
      DO 620 I = N-1, 1, -1


C         B( I ) = ( B( I ) - B( I + 1 ) * RVU( 2, I ) ) * RVU( 1, I )
         B( I ) = ( B( I ) - B( I + 1 ) * RVU( 2, I ) )
C         B( I ) = ( B( I ) - V ) * RVU( 1, I )
C         B( I ) = ( RVU( 2, I ) - V ) * RVU( 1, I )
C         V = RVU( 2, I - 1 ) * B( I )

  620 CONTINUE
      ENDIF

      RETURN
      END

      SUBROUTINE BNDPAS( X, N, DELTAT, FMIN, FMAX )

C     BAND-PASS FILTER OF A COMPLEX TIME SERIES
C     This version assumes time series was real and therefore
C     filters symmetically

      PARAMETER ( PI = 3.141592, ALPHA = 0.54 )
      COMPLEX X( * )

C     *** Compute indices for frequency band ***

      DELTAF = 1.0 / ( N * DELTAT )
      IMIN   = FMIN / DELTAF
      IMAX   = FMAX / DELTAF

C     ------ Quick exit if full band is passed:
      IF ( IMIN .LE. 1 .AND. IMAX .GE. N / 2 + 1 ) RETURN

C     *** Check N is a power of 2 ***

      IF ( N .LE. 0 )
     &   STOP 'FATAL ERROR in BNDPAS: N must be positive'

      NT = 2**( INT( LOG10( REAL( N ) ) / 0.30104 ) +1 )
      IF ( NT .NE. N )
     &   STOP 'FATAL ERROR in BNDPAS: N must be a power of 2'

C     *** Forward transform ***

      CALL CFFT( X, N, 1 )
      CALL CFFTSC( X, N )

C     *** Zero out-of-band components (Hanning window) ***

      DO I = 1, N/2 + 1

         IF ( I .GE. IMIN .AND. I .LE. IMAX ) THEN
            WEIGHT = ALPHA +
     &         ( 1.0 - ALPHA ) * COS( PI * ( I - 1 ) / ( IMAX - 1 ) )
            WEIGHT = 1.0   ! disable windowing
         ELSE
            WEIGHT = 0.0
         ENDIF

         X( I ) = WEIGHT * X( I )

         IF ( I .GT. 1 .AND. I .LT. N/2+1 )
     &                     X( N+2-I ) = WEIGHT * X( N+2-I )
      END DO

C     *** Transform back ***

      CALL CFFT( X, N, -1 )

      RETURN
      END

      PROGRAM TABSSP

C     Tabulate the sound speed profile for use by another program

      IMPLICIT REAL*4 ( A-H, O-Z )

C      OPEN( UNIT = 27, FILE = 'tabssp.prt', STATUS = 'UNKNOWN',
C     &      CARRIAGECONTROL = 'LIST' )

      WRITE( *, * ) 'Depth, N, RMIN, RMAX, NR ='
      READ( *, * ) D, N, RMIN, RMAX, NR

      IF ( NR .EQ. 1 ) THEN
         DELTAR = 0.0
      ELSE
         DELTAR = ( RMAX - RMIN ) / ( NR - 1 )
      ENDIF

      DO IR = 1, NR
         R  = RMIN + ( IR - 1 ) * DELTAR
         RM = 1000.0 * R
         WRITE( 27, * ) R

         DO I = 1, N
            Z = ( I - 1 ) * D / ( N - 1 )
            CALL ANALYT( RM, Z, C, CR, CZ, CRR, CRZ, CZZ, 'TAB' )
C           WRITE( *, 500 ) Z, C, 0.0, 1.0, 0.0, 0.0
  500       FORMAT( 6( F9.2, ', ') )
            WRITE( *, 1500 ) Z, C
 1500       FORMAT( F9.2, F9.2 )
         END DO

      END DO

      STOP
      END

      PROGRAM KRAKEN

C     Program for solving for ocean acoustic normal modes

C     Michael B. Porter

      INCLUDE 'common.f'

      REAL*4 ZMIN, ZMAX

      NV( 1 ) = 1
      NV( 2 ) = 2
      NV( 3 ) = 4
      NV( 4 ) = 8
      NV( 5 ) = 16

C     *** Read in environmental info ***

      TITLE = 'KRAKEN- '

      CALL READIN( TITLE, FREQ, MAXMED, NMEDIA,
     &   TOPOPT, CPT, CST, RHOT, BUMDEN, ETA, XI, NG, SIGMA, DEPTH, 
     &   BOTOPT, CPB, CSB, RHOB,
     &   ENVFIL, PRTFIL )

C     *** Spectral limits ***

      READ(  ENVFIL, *    ) CLOW, CHIGH
      WRITE( PRTFIL, 500  ) CLOW, CHIGH
  500 FORMAT( /, ' CLOW = ', G12.5, '  CHIGH = ', G12.5 )

C     *** Maximum range for calculations ***

      READ(  ENVFIL, * ) RMAX
      WRITE( PRTFIL, * ) 'RMAX = ', RMAX

C     *** Read source/receiver depths ***

      ZMIN = DEPTH( 1 )
      ZMAX = DEPTH( NMEDIA + 1 )

      CALL SDRD( ENVFIL, PRTFIL, ZMIN, ZMAX,
     &   MAXNSD, NSD, SD,
     &   MAXNRD, NRD, RD )

      OMEGA2 = ( 2.0 * PI * FREQ ) ** 2
      CLOSE( ENVFIL )

      M = MAXM

C     *** Main loop: solve the problem for a sequence of meshes ***

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Mesh multiplier   CPU seconds'

      DO ISET = 1, NSETS

         DO MED = 1, NMEDIA
            N( MED ) = NG( MED ) * NV( ISET )
            H( MED ) = ( DEPTH( MED + 1 ) - DEPTH( MED ) ) / N( MED )
         END DO

         HV( ISET ) = H( 1 )
         CALL SOLVE( ERROR )
         IF ( RMAX .EQ. 0.0 ) GOTO 3000
         IF ( ERROR .LT. 1.0 / ( 1000.0 * RMAX ) ) GOTO 3000
      END DO

C     ------ Fall through indicates failure to converge
      CALL ERROUT( PRTFIL, 'W', 'KRAKEN',
     &             'Too many meshes needed: check convergence' )

C     Solution complete: discard modes with phase velocity above CHIGH

 3000 OMEGA = SQRT( OMEGA2 )

      DO MODE = M, 1, -1
         IF ( EXTRAP( 1, MODE ) .GT. OMEGA2 / CHIGH ** 2 ) GOTO 5000
      END DO

 5000 M = MODE

C     *** Write eigenvalues to PRTFIL and MODFIL ***

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * )
     &   '   I           K                ALPHA         PHASE SPEED'

      DO MODE = 1, M
         CK( MODE ) = SQRT( EXTRAP( 1, MODE ) + CK( MODE ) )
         WRITE( PRTFIL, 6000 ) MODE,
     &                         CK( MODE ), OMEGA / DBLE( CK( MODE ) )
 6000    FORMAT( I5, 3G19.10 )
      END DO

      WRITE( MODFIL, REC = 5 ) M, LRECL

      IFIRST = 1
      DO IREC = 1, 1 + ( 2 * M - 1 ) / LRECL

         ILAST  = MIN( M, IFIRST + LRECL / 2 - 1 )
         WRITE( MODFIL, REC = 6 + M + IREC )
     &      ( CMPLX( CK( MODE ) ), MODE = IFIRST, ILAST )

         IFIRST = ILAST + 1
      END DO

      STOP
      END
C**********************************************************************C
      SUBROUTINE INIT

C     Initializes arrays defining difference equations

      INCLUDE 'common.f'

      LOGICAL ELFLAG
      REAL*8 CP2, CS2
      COMPLEX*16 CP( MAXN ), CS( MAXN )

      COMMON /SPACE/ CP, CS

      ELFLAG   = .FALSE.
      CMIN     = 1.0E6
      NFACT    = 0
      LOC( 1 ) = 0

C     *** Loop over media ***

      DO MED = 1, NMEDIA
         IF ( MED .NE. 1 ) LOC( MED ) = LOC( MED-1 ) + N( MED-1 ) + 1
         N1 = N(   MED ) + 1
         I  = LOC( MED ) + 1

         IF ( LOC( MED ) + N1 .GT. MAXN )
     &      CALL ERROUT( PRTFIL, 'F', 'KRAKEN',
     &             'Insufficient storage for mesh: '//
     &             'Reduce mesh size or change program dimensions' )

C        *** PROFIL reads in the data for a medium ***

         CALL PROFIL( DEPTH, CP( I ), CS( I ), RHO( I ),
     &      MED, N1, FREQ, TOPOPT(1:1), TOPOPT(3:3), 'TAB',
     &      ENVFIL, PRTFIL )

C        *** Load diagonals of the finite-difference equations ***

         IF ( REAL( CS( I ) ) .EQ. 0.0 ) THEN

C           --- Case of an acoustic medium ---

            MATER( MED ) = 'ACOUSTIC'
            IF ( NFACT .EQ. 0 ) NFACT = MED
            NLACT = MED

            DO J = I, I + N( MED )
               CMIN = MIN( DBLE( CP( J ) ), CMIN )
               B1(  J ) = -2.0 + H( MED ) ** 2
     &                   * DBLE( OMEGA2 / CP( J ) ** 2 )
               B1C( J ) = DIMAG( OMEGA2 / CP( J ) ** 2 )
C              --- use DIMAG in f77, AIMAG in f90
            END DO

         ELSE

C           --- Case of an elastic medium ---

            IF ( SIGMA( MED ) .NE. 0.0 )
     &         CALL ERROUT( PRTFIL, 'F', 'KRAKEN',
     &               'Rough elastic interfaces are not allowed' )

            MATER( MED ) = 'ELASTIC'
            ELFLAG = .TRUE.
            TWOH   = 2.0 * H( MED )

            DO J = I, I + N( MED )
               CMIN = MIN( DBLE( CS( J ) ), CMIN )

               CP2 = CP( J ) ** 2
               CS2 = CS( J ) ** 2

               B1( J ) = TWOH / ( RHO( J ) * CS2 )
               B2( J ) = TWOH / ( RHO( J ) * CP2 )
               B3( J ) = 4.0 * TWOH * RHO(J) * CS2 * ( CP2 - CS2 ) / CP2
               B4( J ) = TWOH * ( CP2 - 2.0*CS2 ) / CP2

               RHO( J ) = TWOH * OMEGA2 * RHO( J )
            END DO

         ENDIF
C        ------ Next MED:
      END DO

C     (CLOW, CHIGH) = phase speed interval for the mode search
C     user specified interval is reduced if it exceeds domain
C     of possible mode phase speeds

C     *** Bottom properties ***

      IF ( BOTOPT(1:1) .EQ. 'A' ) THEN
         IF ( REAL( CSB ) .GT. 0.0 ) THEN
C           --- Elastic bottom:
            ELFLAG = .TRUE.
            CMIN  = MIN( CMIN,  DBLE( CSB ) )
            CHIGH = MIN( CHIGH, DBLE( CSB ) )
         ELSE
C           --- Acoustic bottom:
            CMIN  = MIN( CMIN,  DBLE( CPB ) )
            CHIGH = MIN( CHIGH, DBLE( CPB ) )
         ENDIF
      ENDIF

C     *** Top properties ***

      IF ( TOPOPT(2:2) .EQ. 'A' ) THEN
         IF ( REAL( CST ) .GT. 0.0 ) THEN
C           --- Elastic top half-space:
            ELFLAG = .TRUE.
            CMIN =  MIN( CMIN,  DBLE( CST ) )
            CHIGH = MIN( CHIGH, DBLE( CST ) )
         ELSE
C           --- Acoustic top half-space:
            CMIN  = MIN( CMIN,  DBLE( CPT ) )
            CHIGH = MIN( CHIGH, DBLE( CPT ) )
         ENDIF
      ENDIF

C     --- If elastic medium then reduce CMIN for Scholte wave
      IF ( ELFLAG ) CMIN = 0.85 * CMIN
      CLOW = MAX( CLOW, CMIN )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SOLVE( ERROR )

C     Solves the eigenvalue problem at the current mesh
C     and produces a new extrapolation

      INCLUDE 'common.f'

      CALL CLTIME
      CALL INIT

C     Choose a solver ...
C     Use bisection if this is the 1st or 2nd set and
C     there are no internal elastic media.

      IF ( ( ISET .LE. 2 ) .AND. ( NMEDIA .LE. NLACT-NFACT+1 ) ) THEN
         CALL SOLVE1
      ELSE
         CALL SOLVE2
      ENDIF

      DO MODE = 1, M
         EXTRAP( ISET, MODE ) = EVMAT( ISET, MODE )
      END DO

C     *** If this is the first mesh, compute the eigenvectors ***

      IF ( ISET .EQ. 1 ) CALL VECTOR

C     *** Now do the Richardson extrapolation ***

      ERROR = 10            ! initialize error to a large number
      KEY = 2 * M / 3 + 1   ! KEY value used to check convergence

      IF ( ISET .GT. 1 ) THEN
         T1 = EXTRAP( 1, KEY )

         DO J = ISET - 1, 1, -1
            DO MODE = 1, M
               X1 = NV( J    ) ** 2
               X2 = NV( ISET ) ** 2
               F1 = EXTRAP( J,     MODE )
               F2 = EXTRAP( J + 1, MODE )
               EXTRAP( J, MODE ) = F2 - ( F1 - F2 ) / ( X2 / X1 - 1.0 )
            END DO
         END DO

         T2 = EXTRAP( 1, KEY )
         ERROR = ABS( T2 - T1 )
      ENDIF

      CALL RDTIME( TEND )
      ET( ISET ) = TEND
      WRITE( PRTFIL, 5000 ) NV( ISET ), ET( ISET )
 5000 FORMAT( 1X, I8, 6X, G15.3 )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SOLVE2

C     Provides initial guess to root finder for each EVMAT(I)

      INCLUDE 'common.f'

      REAL*8 P( 10 )
      CHARACTER*80 ERRMSG

      X = OMEGA2 / CLOW ** 2
      MAXIT = 500

      DO MODE = 1, M

C        For first or second meshes, use a high guess
C        Otherwise use extrapolation to produce an initial guess

         X = 1.00001 * X
 
         IF ( ISET .GE. 2 ) THEN

            DO I = 1, ISET - 1
               P( I ) = EVMAT( I, MODE )
            END DO

            IF ( ISET .GE. 3 ) THEN
               DO I = 1, ISET - 2
                  DO J = 1, ISET - I - 1
                     X1 = HV( J     ) ** 2
                     X2 = HV( J + I ) ** 2

                     P( J ) = ( ( HV( ISET ) ** 2 - X2 ) * P( J     ) -
     &                          ( HV( ISET ) ** 2 - X1 ) * P( J + 1 ) )
     &                                  / ( X1 - X2 )
                  END DO
               END DO
               X = P( 1 )
            ENDIF

         ENDIF

C        *** Use the secant method to refine the eigenvalue ***

         TOL = 100.0 * MACHEP * ABS( X )
         CALL ZSECX( X, TOL, IT, MAXIT, ERRMSG )

         IF ( ERRMSG .NE. ' ' ) THEN
            WRITE( PRTFIL, * ) 'ISET, MODE = ', ISET, MODE
            CALL ERROUT( PRTFIL, 'W', 'KRAKEN-ZSECX', ERRMSG )
            X = 1.0E-9   ! make sure value is discarded
         ENDIF

         EVMAT( ISET, MODE ) = X

C        --- Toss out modes outside user specified spectrum
         IF ( OMEGA2 / X .GT. CHIGH ** 2 ) THEN
            M = MODE - 1
            RETURN
         ENDIF

      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE FUNCT( X, DELTA, IPOW )

C     FUNCT( X ) = 0 is the dispersion relation

      INCLUDE 'common.f'

      PARAMETER ( ROOF = 1.0E5, FLOOR = 1.0E-5, IPOWR = 5, IPOWF = -5 )
      CHARACTER BCTYPE*1 

C     For a k below the cts spectrum limit, force a zero

      IF ( X .LE. OMEGA2 / CHIGH ** 2 ) THEN
         DELTA = 0.0
         IPOW  = 0
         RETURN
      ENDIF

      MODECT = 0

C     --- Bottom impedance
      BCTYPE(1:1) = BOTOPT(1:1)
      CALL BCIMP( X, BCTYPE, 'BOT', CPB, CSB, RHOB, F, G, IPOW )

C     --- Shoot through acoustic layers
      CALL ACOUST( X, F,  G,  IPOW  )

C     --- Top impedance
      BCTYPE(1:1) = TOPOPT(2:2)
      CALL BCIMP( X, BCTYPE, 'TOP', CPT, CST, RHOT, F1, G1, IPOW1 )

      DELTA = F * G1 - G * F1
      IF ( G * DELTA .GT. 0.0 ) MODECT = MODECT + 1
      IPOW = IPOW + IPOW1

C     *** Deflate previous roots ***

      IF ( ( MODE .GT. 1 ) .AND. ( NMEDIA .GT. NLACT - NFACT+1 ) ) THEN
         DELTA = DELTA / ( X - EVMAT( ISET, MODE-1 ) )

         IF ( MODE .GT. 2 ) THEN
            DO J = 1, MODE - 2
               DELTA = DELTA / ( X - EVMAT(ISET, J) )

C              ------ Scale if necessary
   50          IF ( ABS( DELTA ) .LT. FLOOR .AND.
     &                     ABS( DELTA )   .GT. 0.0) THEN
                  DELTA = ROOF * DELTA
                  IPOW  = IPOW - IPOWR
                  GOTO 50
               ENDIF

   60          IF ( ABS( DELTA ) .GE. ROOF ) THEN
                  DELTA = FLOOR * DELTA
                  IPOW  = IPOW - IPOWF
                  GOTO 60
               ENDIF

            END DO
         ENDIF
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE ACOUST( X, F, G, IPOW )

C     Shoot through acoustic layers

      INCLUDE 'common.f'

      PARAMETER ( ROOF = 1.0E5, FLOOR = 1.0E-5, IPOWR = 5, IPOWF = -5 )

      IF ( NFACT .EQ. 0 ) RETURN

C     *** Loop over successive acoustic media ***

      DO MED = NLACT, NFACT, -1
         H2K2 = H( MED ) ** 2 * X
         I = LOC( MED ) + N( MED ) + 1
         RHOM = RHO( I )
         P1 = -2.0 * G
         P2 = ( B1( I ) - H2K2 ) * G - 2.0 * H( MED ) * F * RHOM

C        *** Shoot through a single medium ***

         DO I = LOC( MED ) + N( MED ), LOC( MED ) + 1, -1

            P0 = P1
            P1 = P2
            P2 = ( H2K2 - B1( I ) ) * P1 - P0

            IF( P0 * P1 .LE. 0.0 ) MODECT = MODECT + 1
C            IF ( ( P0 .GT. 0.0 ) .AND. (P1 .LT. 0.0) ) MODECT = MODECT+1
C            IF ( ( P0 .LT. 0.0 ) .AND. (P1 .GT. 0.0) ) MODECT = MODECT+1
C            IF (   P1 .EQ. 0.0 )                       MODECT = MODECT+1

C           ------ Scale if necessary
   60       IF ( ABS( P2 ) .GE. ROOF ) THEN
               P0 = FLOOR * P0
               P1 = FLOOR * P1
               P2 = FLOOR * P2
               IPOW = IPOW - IPOWF
               GOTO 60
            ENDIF

         END DO

C        ------ F = P'/RHO and G = -P since FP+GP'/RHO = 0
         RHOM = RHO( LOC( MED ) + 1 )
         F = -( P2 - P0 ) / ( 2.0 * H( MED ) ) / RHOM
         G = -P1

      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE VECTOR

C     Do inverse iteration to compute each of the eigenvectors
C     and write these to the disk file

      INCLUDE 'common.f'

      INTEGER IZTAB( MAXNZT )
      REAL Z( MAXN ), ZTAB( MAXNZT ), PHITAB( MAXNZT ), WTS( MAXNZT )
      REAL*8 PHI( MAXN ), D( MAXN ), E( MAXN ), W
      CHARACTER BCTOP*1, BCBOT*1

      COMMON /SPACE/ RV1( MAXN ), RV2( MAXN ), RV3( MAXN ), RV4( MAXN )

      EQUIVALENCE ( Z, D, PHI )

      BCTOP(1:1) = TOPOPT(2:2)
      BCBOT(1:1) = BOTOPT(1:1)

C     *** Tabulate z-coordinates and off-diagonals of matrix ***

      NTOT = 0
      J    = 1
      Z( 1 ) = DEPTH( NFACT )

      DO MED = NFACT, NLACT

         HRHO = H( MED ) * RHO( LOC( MED ) + 1 )

         DO I = 1, N( MED )
            J = J + 1
            Z( J ) = Z( J - 1 ) + H( MED )
            E( J ) = 1.0 / HRHO
         END DO

         NTOT = NTOT + N( MED )
      END DO

      NTOT1 = NTOT + 1

C     Calculate the indices, weights, ... for mode interpolation

      CALL MERGEV( SD, NSD, RD, NRD, ZTAB, NZTAB )
      CALL WEIGHT( Z, NTOT1, ZTAB, NZTAB, WTS, IZTAB )

C     Open MODFIL and write header

C     ------ Logical record length in `longwords' (4 bytes)
      LRECL = MAX( 2 * NZTAB, 32, 3 * ( NLACT - NFACT + 1 ) )

      OPEN ( FILE = 'MODFIL', UNIT = MODFIL, STATUS = 'NEW',
     &   ACCESS = 'DIRECT', RECL = 4 * LRECL, FORM = 'UNFORMATTED' )

      WRITE( MODFIL, REC = 1 ) LRECL, TITLE, REAL( FREQ ),
     &   NLACT - NFACT + 1, NZTAB, NZTAB
      WRITE( MODFIL, REC = 2 )
     &   ( N( MED ), MATER( MED ), MED = NFACT, NLACT )
      WRITE( MODFIL, REC = 3 )
     &   BCTOP(1:1), CMPLX( CPT ), CMPLX( CST ),
     &     REAL( RHOT ), REAL( DEPTH( 1          ) ),
     &   BCBOT(1:1), CMPLX( CPB ), CMPLX( CSB ),
     &     REAL( RHOB ), REAL( DEPTH( NMEDIA + 1 ) )
      WRITE( MODFIL, REC = 4 ) ( REAL( DEPTH( MED ) ),
     &   REAL( RHO( LOC( MED ) + 1 ) ), MED = NFACT, NLACT )
      WRITE( MODFIL, REC = 6 ) ( ZTAB( IZ ), IZ = 1, NZTAB )

C     *** Main loop: for each eigenvalue call SINVIT to get eigenvector

      DO MODE = 1, M
         W = 0.0
         X = EVMAT( 1, MODE )

C        *** Corner elt requires top impedance ***

         CALL BCIMP( X, BCTOP, 'TOP', CPT, CST, RHOT, F, G, IPOW )

         IF ( G .EQ. 0.0 ) THEN
            D( 1 ) = 1.0
            E( 2 ) = 0.0
         ELSE
            L = LOC( NFACT ) + 1
            XH2    = X * H( NFACT ) * H( NFACT )
            HRHO   = H( NFACT ) * RHO( L )
            D( 1 ) = ( B1( L ) - XH2 ) / HRHO / 2.0 + F / G
         ENDIF

C        *** Set up the diagonal ***

         ITP = NTOT
         J   = 1
         L   = LOC( NFACT ) + 1

         DO MED = NFACT, NLACT
            XH2  = X * H( MED ) ** 2
            HRHO = H( MED ) * RHO( LOC( MED ) + 1 )

            IF ( MED .GE. NFACT + 1 ) THEN
               L = L + 1
               D( J ) = ( D( J ) + ( B1( L ) - XH2 ) / HRHO ) / 2.0
            ENDIF

            DO I = 1, N( MED )
               J = J + 1
               L = L + 1
               D( J ) = ( B1( L ) - XH2 ) / HRHO
C              ------ Locate index of turning point nearest top
               IF ( B1( L ) - XH2 + 2.0 .GT. 0.0 ) THEN
                  ITP = MIN( J, ITP )
               ENDIF
            END DO

         END DO

C        *** Corner elt requires bottom impedance ***

         CALL BCIMP( X, BCBOT, 'BOT', CPB, CSB, RHOB, F, G, IPOW )

         IF ( G .EQ. 0.0 ) THEN
            D( NTOT1 ) = 1.0
            E( NTOT1 ) = 0.0
         ELSE
            D( NTOT1 ) =  D( NTOT1 ) / 2.0 - F / G
         ENDIF

C        *** Use inverse iteration to compute eigenvector ***

         CALL SINVIT( NTOT1, D, E, W, PHI, IERR,
     &      RV1, RV2, RV3, RV4, PHI )

         IF ( IERR .NE. 0 ) THEN
            WRITE( PRTFIL, * ) 'MODE = ', MODE
            CALL ERROUT( PRTFIL, 'W', 'KRAKEN-SINVIT',
     &                   'Inverse iteration failed to converge' )
         ENDIF

C        *** Normalize the eigenvector ***

         CALL NORMIZ( PHI, ITP, NTOT1, X )

C        Tabulate the modes at the source depths and write to disk

         DO IZ = 1, NZTAB
            I = IZTAB( IZ )
            PHITAB( IZ ) = PHI( I ) +
     &         WTS(IZ) * ( PHI( I + 1 ) - PHI( I ) )
         END DO

         WRITE( MODFIL, REC = 6 + MODE )
     &      ( PHITAB( IZ ), 0.0, IZ = 1, NZTAB )

      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE NORMIZ( PHI, ITP, NTOT1, X )

C     Normalize the eigenvector:
C        SQNRM = Integral(PHI ** 2) by the trapezoidal rule:
C        Integral(F) = H*( F(1)+...+F(N-1) + 0.5*(F(0)+F(N)) )

C     Compute perturbation due to material absorption
C     Call SCAT to figure interfacial scatter loss

      INCLUDE 'common.f'

      REAL*8 PHI( * )
      COMPLEX*16 PERK, DEL
      CHARACTER BCTYPE*1

      SQNRM = 0.0
      PERK  = 0.0

C     *** Compute perturbation due to loss in top half-space ***

      IF ( TOPOPT(2:2) .EQ. 'A' ) THEN
         DEL = -0.5*( OMEGA2 / CPT ** 2 - DBLE( OMEGA2 / CPT ** 2 ) ) /
     &          SQRT( X                 - DBLE( OMEGA2 / CPT ** 2 ) )
         PERK = PERK - DEL * PHI( 1 ) ** 2 / RHOT
      ENDIF

C     *** Compute norm and pertubation due to material absorption ***

      L = LOC( NFACT )
      J = 1

      DO MED = NFACT, NLACT
         L = L + 1
         RHOM = RHO( L )

         SQNRM = SQNRM + 0.5*H( MED ) *             PHI( J ) ** 2 / RHOM
         PERK  = PERK  + 0.5*H( MED ) * CI*B1C(L) * PHI( J ) ** 2 / RHOM

         DO I = 1, N( MED ) - 1
            L = L + 1
            J = J + 1

            SQNRM = SQNRM +  H( MED ) *             PHI( J ) ** 2 / RHOM
            PERK  = PERK  +  H( MED ) * CI*B1C(L) * PHI( J ) ** 2 / RHOM

         END DO

         L = L + 1
         J = J + 1

         SQNRM = SQNRM + 0.5*H( MED ) *             PHI( J ) ** 2 / RHOM
         PERK  = PERK  + 0.5*H( MED ) * CI*B1C(L) * PHI( J ) ** 2 / RHOM

      END DO

C     *** Compute perturbation due to loss in bottom half-space ***

      IF ( BOTOPT(1:1) .EQ. 'A' ) THEN
         DEL = -0.5*( OMEGA2 / CPB ** 2 - DBLE( OMEGA2 / CPB ** 2 ) ) /
     &          SQRT( X                 - DBLE( OMEGA2 / CPB ** 2 ) )
         PERK = PERK - DEL * PHI( J ) ** 2 / RHOB
      ENDIF

C     *** Compute derivative of top admitance ***

      X1 = 0.9999999D0 * X
      X2 = 1.0000001D0 * X

      BCTYPE(1:1) = TOPOPT(2:2)

      CALL BCIMP( X1, BCTYPE, 'TOP', CPT, CST, RHOT, F1, G1, IPOW )
      CALL BCIMP( X2, BCTYPE, 'TOP', CPT, CST, RHOT, F2, G2, IPOW )

      DRHODX = 0.0
      IF ( G1 .NE. 0.0 ) THEN
         DRHODX = -( F2 / G2 - F1 / G1 ) / ( X2 - X1 )
      ENDIF

C     *** Compute derivative of bottom admitance ***

      BCTYPE(1:1) = BOTOPT(1:1)

      CALL BCIMP( X1, BCTYPE, 'BOT', CPB, CSB, RHOB, F1, G1, IPOW )
      CALL BCIMP( X2, BCTYPE, 'BOT', CPB, CSB, RHOB, F2, G2, IPOW )

      DETADX = 0.0
      IF ( G1 .NE. 0.0 ) THEN
         DETADX = -( F2 / G2 - F1 / G1 ) / ( X2 - X1 )
      ENDIF

C     *** Scale the mode ***

      RN = SQNRM + DRHODX * PHI( 1 ) ** 2 - DETADX * PHI( NTOT1 ) ** 2

      IF ( RN .LE. 0.0 ) THEN
         RN = -RN
         WRITE( PRTFIL, * ) 'MODE = ', MODE
         CALL ERROUT( PRTFIL, 'W', 'KRAKEN',
     &      'Normalization constant non-positive' )
      ENDIF

      SCALE = 1.0 / SQRT( RN )
      IF ( PHI( ITP ) .LT. 0.0 ) SCALE = -SCALE

      DO J = 1, NTOT1
         PHI( J ) = SCALE * PHI( J )
      END DO

      PERK = SCALE ** 2 * PERK

C     *** Compute interfacial scatter loss ***

      CALL SCAT( PERK, PHI, X )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SCAT( PERK, PHI, X )

C     Figure scatter loss

      INCLUDE 'common.f'

      REAL*8 PHI( * )
      COMPLEX*16 CIMPED, KX, TWERSK, PERK,
     &   ETA1SQ, ETA2SQ, KUPING, U, PHIC
      CHARACTER BCTYPE*1

      OMEGA = SQRT( OMEGA2 )
      KX    = SQRT( X )

C     *** Top Twersky roughness ***

      BCTYPE(1:1) = TOPOPT(2:2)
      IF ( BCTYPE(1:1) .EQ. 'S' .OR. BCTYPE(1:1) .EQ. 'H' .OR.
     &     BCTYPE(1:1) .EQ. 'T' .OR. BCTYPE(1:1) .EQ. 'I' ) THEN

         I = LOC( NFACT ) + N( NFACT ) + 1
         RHOINS = RHO( I )
         CINS = SQRT( OMEGA2 * H( NFACT ) ** 2 / ( 2.0 + B1( NFACT ) ) )

         CIMPED = TWERSK( BCTYPE(1:1), OMEGA,
     &                       BUMDEN, XI, ETA, KX, RHOINS, CINS )

         CIMPED = CIMPED / ( -CI * OMEGA * RHOINS )
         DPHIDZ = PHI( 2 ) / H( NFACT )
         PERK   = PERK - CIMPED * DPHIDZ ** 2
      ENDIF

C     *** Bottom Twersky roughness ***

      BCTYPE(1:1) = BOTOPT(1:1)
      IF ( BCTYPE(1:1) .EQ. 'S' .OR. BCTYPE(1:1) .EQ. 'H' .OR.
     &     BCTYPE(1:1) .EQ. 'T' .OR. BCTYPE(1:1) .EQ. 'I' ) THEN

         I = LOC( NLACT ) + N( NLACT ) + 1
         RHOINS = RHO( I )
         CINS   = SQRT( OMEGA2 * H(NLACT) ** 2 / ( 2.0 + B1(NLACT) ) )

         CIMPED = TWERSK( BCTYPE(1:1), OMEGA,
     &                       BUMDEN, XI, ETA, KX, RHOINS, CINS )

         CIMPED = CIMPED / ( -CI * OMEGA * RHOINS )
         DPHIDZ = PHI( 2 ) / H( NFACT )
         PERK   = PERK - CIMPED * DPHIDZ ** 2
      ENDIF

      J = 1
      L = LOC( NFACT )

C     *** Loop over media ***

      DO MED = NFACT - 1, NLACT

C        *** Calculate RHO1, ETA1SQ, PHI, U ***

         IF ( MED .EQ. NFACT - 1 ) THEN
C           *** Top properties ***

            BCTYPE(1:1) = TOPOPT(2:2)

            IF ( BCTYPE(1:1) .EQ. 'A' ) THEN
C              ------ Acousto-elastic
               RHO1   = RHOT
               ETA1SQ = X - OMEGA2 / CPT ** 2
               U = SQRT( ETA1SQ ) * PHI( 1 ) / RHOT

            ELSE IF ( BCTYPE(1:1) .EQ. 'V' ) THEN
C              ------ Vacuum
               RHO1   = 1.0E-9
               ETA1SQ = 1.0
               RHOINS = RHO( LOC( NFACT ) + 1 )
               U      = PHI( 2 ) / H( NFACT ) / RHOINS

            ELSE IF ( BCTYPE(1:1) .EQ. 'R' ) THEN
C              ------ Rigid
               RHO1   = 1.0E+9
               ETA1SQ = 1.0
               U      = 0.0
            ENDIF
         ELSE
            H2 = H( MED ) ** 2
            J  = J + N( MED )
            L  = LOC( MED ) + N( MED ) + 1

            RHO1   = RHO( L )
            ETA1SQ = ( 2.0 + B1( L ) ) / H2 - X
            U = ( -PHI( J-1 ) - 0.5 * ( B1(L) - H2*X ) * PHI( J ) )
     &               / ( H( MED ) * RHO1 )
         ENDIF

C        *** Calculate RHO2, ETA2 ***

         IF ( MED .EQ. NLACT ) THEN
C           *** Bottom properties ***

            BCTYPE(1:1) = BOTOPT(1:1)

            IF ( BCTYPE(1:1) .EQ. 'A' ) THEN
C              ------ Acousto-elastic
               RHO2   = RHOB
               ETA2SQ = OMEGA2 / CPB ** 2 - X

            ELSE IF ( BCTYPE(1:1) .EQ. 'V' ) THEN
C              ------ Vacuum
               RHO2   = 1.0E-9
               ETA2SQ = 1.0

            ELSE IF ( BCTYPE(1:1) .EQ. 'R' ) THEN
C              ------ Rigid
               RHO2   = 1.0E+9
               ETA2SQ = 1.0
            ENDIF
         ELSE
            RHO2   = RHO( L + 1 )
            ETA2SQ = ( 2.0 + B1( L + 1 ) ) / H( MED + 1 ) ** 2 - X
         ENDIF

         PHIC = PHI( J )   ! convert to complex*16
         PERK = PERK + KUPING( SIGMA( MED + 1 ), ETA1SQ, RHO1,
     &                         ETA2SQ, RHO2, PHIC, U )

      END DO

      CK( MODE ) = PERK

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SOLVE1

C     Uses Sturm sequences to isolate the eigenvalues
C     and Brent's method to refine them

      INCLUDE 'common.f'

      REAL*8 XL( MAXM + 1 ), XR( MAXM + 1 )
      CHARACTER*80 ERRMSG

C     *** Determine number of modes ***

      XMIN = 1.00001D0 * OMEGA2 / CHIGH ** 2

      CALL FUNCT( XMIN, DELTA, IPOW )
      M = MODECT

      XMAX = OMEGA2 / CLOW ** 2
      CALL FUNCT( XMAX, DELTA, IPOW )
      M = M - MODECT

      IF ( M .EQ. 0 ) THEN

C        Open a dummy MODFIL for possible use by FIELD3D

         LRECL = 32
         NZTAB = 0
         OPEN ( FILE = 'MODFIL', UNIT = MODFIL, STATUS = 'NEW',
     &          ACCESS = 'DIRECT', RECL = 4 * LRECL,
     &          FORM = 'UNFORMATTED' )
         WRITE( MODFIL, REC = 1 )
     &          LRECL, TITLE, REAL( FREQ ), 1, NZTAB, NZTAB
         WRITE( MODFIL, REC = 5 ) M, LRECL

         CALL ERROUT( PRTFIL, 'F', 'KRAKEN',
     &                'No modes for given phase speed interval' )

      ENDIF

      IF( M .GT. MAXM ) THEN
         WRITE( PRTFIL, * ) 'Number of modes = ', M
         WRITE( PRTFIL, * ) 'Number of modes allowable = ', MAXM
         CALL ERROUT( PRTFIL, 'F', 'KRAKEN',
     &     'Too many modes'//
     &     'Reduce phase speed interval or increase dimension MAXM' )
      ENDIF

      NTOT = 0
      DO MED = NFACT, NLACT
         NTOT = NTOT + N( MED )
      END DO

      IF ( M .GT. NTOT / 3 ) THEN
         WRITE( PRTFIL, * ) 'Approximate number of modes =', M
         CALL ERROUT( PRTFIL, 'W', 'KRAKEN',
     &     'Mesh too coarse to sample the modes adequately' )
      ENDIF

C     *** Initialize upper and lower bounds ***

      CALL BISECT( XMIN, XMAX, XL, XR )

C     *** Call ZBRENT to refine each eigenvalue in turn ***

      DO MODE = 1, M
         X1  = XL( MODE )
         X2  = XR( MODE )
         EPS = 100.0 * MACHEP * X2

         CALL ZBRENTX( X, X1, X2, EPS, ERRMSG )

         IF ( ERRMSG .NE. ' ' ) THEN
            WRITE( PRTFIL, * ) 'ISET, MODE = ', ISET, MODE
            CALL ERROUT( PRTFIL, 'W', 'KRAKEN-ZBRENTX', ERRMSG )
         ENDIF

         EVMAT( ISET, MODE ) = X
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE BISECT( XMIN, XMAX, XL, XR )

C     Returns an isolating interval (XL, XR) for each eigenvalue

      PARAMETER( MXBIS = 50 )
      INCLUDE 'common.f'

      REAL*8 XL( * ), XR( * )

      DO I = 1, M + 1
         XL( I ) = XMIN
         XR( I ) = XMAX
      END DO

      CALL FUNCT( XMAX, DELTA, IPOW )
      NZER1 = MODECT

C     *** For each eigenvalue, do: ***

      IF ( M .EQ. 1 ) RETURN

      DO 5000 MODE = 1, M - 1

C        Obtain initial guesses for X1 and X2

         IF ( XL( MODE ) .EQ. XMIN ) THEN
            X2 = XR( MODE )
            DO J = MODE + 1, M
               IF ( XL( J ) .GT. XMIN ) GOTO 3000
            END DO
 3000       X1 = XL( J )

C           Begin bisection (assuming we will never
C           need more than MXBIS bisections per mode)

            DO J = 1, MXBIS
               X = X1 + ( X2 - X1 ) / 2
               CALL FUNCT( X, DELTA, IPOW )
               NZEROS = MODECT - NZER1

               IF ( NZEROS .LT. MODE ) THEN
                  X2 = X
                  XR( MODE ) = X
               ELSE
                  X1 = X
                  IF ( XR( NZEROS + 1 ) .GE. X ) XR( NZEROS + 1 ) = X
                  IF ( XL( NZEROS     ) .LE. X ) XL( NZEROS     ) = X
               ENDIF

               IF ( XL( MODE ) .NE. XMIN ) GOTO 5000
            END DO
         ENDIF
 5000 CONTINUE

      RETURN
      END

      PROGRAM PLTTRAN

C     Plot the transition curve

      INTEGER PLPFIL
      REAL SE( 1001 ), PD( 1001 )

C     Compute SE vector

      SIGMA = 8.0
      NPTS = 101

      SEMIN = -30.0
      SEMAX =  30.0
      DELTA = ( SEMAX - SEMIN ) / ( NPTS - 1 )

      DO 2000 J = 1, NPTS
         SE(J) = SEMIN + ( J - 1 ) * DELTA
         PD(J) = TRANSIT( SE( J ), SIGMA )
 2000 CONTINUE

C     PLOT

      CALL PLOTTR( SEMIN, SEMAX, 0.0, 0.0, 1.0, 0.5, 
     &   'Signal Excess (dB)$', 100,
     &   'Prob. of Detection$', 100, XAXIS, YAXIS )

      CALL CURVE( SE, PD, NPTS, 0 )
      CALL ENDPL( 0 )
      CALL DONEPL

      STOP
      END

      SUBROUTINE SOURCE( T, S, SD, NSD, NTOUT, OMEGA, FMIN, FMAX,
     &       PULSE, PULSTITL )

C     Evaluate the source time series

C     STEMP is a temporary workspace
C     Assumes that the filter parameters will not change on
C     subsequent calls. (The time series is only filtered
C     when it's first read.)

      PARAMETER ( MAXNT = 1000000, MAXNSD = 11,
     &            MAXNST = 1000000 )

      LOGICAL INIFLG
      REAL T( * ), TF( MAXNT ), SD( MAXNSD ), STEMPR( MAXNT )
      COMPLEX S( NSD, * ), SF( MAXNST ), STEMP( MAXNT )
      CHARACTER PULSE*( * ), PULSTITL*( * )
      EQUIVALENCE ( STEMPR, STEMP )

      SAVE INIFLG, TF, SF, NT
      DATA INIFLG /.TRUE./

C     *** If first call, tabulate the time series ***

      IF ( INIFLG ) THEN
         IF ( PULSE(1:1) .EQ. 'F' .OR. PULSE(1:1) .EQ. 'B' ) THEN
C           ------ From a file
            CALL STSHDR( PULSTITL, SD, NSD, MAXNSD )
            CALL SFILE( PULSE, PULSTITL, NSD, TF,
     &                  STEMPR, SF, NT, MAXNT, MAXNST )
            DELTAT = TF( 2 ) - TF( 1 )
         ELSE
C           ------ Use one of the canned wavelets
            NSD = 1
            DELTAT = 0.2 / OMEGA
            TSTART = -200.0 * DELTAT
            NT = 1024
            DO IT = 1, NT
               TF( IT ) = TSTART + ( IT - 1 ) * DELTAT
               CALL CANS( TF( IT ), OMEGA, PULSE,
     &                    SF, NSD, IT, PULSTITL )
            END DO
         ENDIF

C        *** Filter the time series ***
         CALL FILTER( PULSE, DELTAT, STEMP, SF, NSD, NT, FMIN, FMAX )

         INIFLG = .FALSE.
      ENDIF

      CALL EVALU( T, PULSE, TF, SF, NSD, NT, S, NTOUT )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE STSHDR( PULSTITL, SD, NSD, MAXNSD )

C     Read header from time series file


      INTEGER PRTFIL, STSFIL
      PARAMETER ( PRTFIL = 6, STSFIL = 10 )

      REAL SD( * )
      CHARACTER PULSTITL*( * )

C     *** Read in time series data ***

      OPEN( FILE = 'STSFIL', UNIT = STSFIL, STATUS = 'OLD',
     &       FORM = 'FORMATTED' )

      READ( STSFIL, * ) PULSTITL

C     --- SD is used by PLOTTS
      READ( STSFIL, * ) NSD, ( SD( IS ), IS = 1, NSD )

      IF ( NSD .GT. MAXNSD )
     &   CALL ERROUT( PRTFIL, 'F', 'SOURCE:SFILE',
     &             'Max. number of sources exceeded' )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SFILE( PULSE, PULSTITL, NSD, TF,
     &    STEMP, SF, NT, MAXNT, MAXNST )

C     Time series from file

C     STEMP is used to hold a temporary real vector

      INTEGER PRTFIL, STSFIL
      PARAMETER ( PRTFIL = 6, STSFIL = 10 )

      REAL    STEMP( * ), TF( * )
      COMPLEX SF( NSD, * )
      CHARACTER PULSE*( * ), PULSTITL*( * )

C     *** Read in time series data ***

      NT = 0
      DO IT = 1, MAXNT

         READ( STSFIL, *, END = 2000 )
     &      TF(IT), ( STEMP( IS ), IS = 1, NSD )

         IF ( IT .GT. 1 ) THEN
            IF ( TF( IT ) .LT. TF( IT - 1 ) )
     &         CALL ERROUT( PRTFIL, 'F', 'SOURCE:SFILE',
     &             'Time series not ordered in time' )
         ENDIF

         DO IS = 1, NSD
            SF( IS, IT ) = STEMP( IS )
         END DO

         NT = NT + 1

         IF ( NT * NSD .GT. MAXNST ) 
     &        CALL ERROUT( PRTFIL, 'F', 'SOURCE:SFILE',
     &                     'Too many time series points' )
      END DO

C     --- normal exit is by EOF in file, not by falling through loop
      CALL ERROUT( PRTFIL, 'F', 'SOURCE:SFILE',
     &             'Too many time series points' )

C     *** Time reversal ***
C     note if NT is odd, middle point doesn't move

 2000 IF ( PULSE(1:1) .EQ. 'B' ) THEN
         TMAX = TF( NT )
         DO IT = 1, NT / 2

            DO IS = 1, NSD
               TEMP                  = SF( IS, IT )
               SF( IS, IT )          = SF( IS, NT - IT + 1 )
               SF( IS, NT - IT + 1 ) = TEMP
            END DO

            TEMP                  = TMAX - TF( IT )
            TF( IT )              = TMAX - TF( NT - IT + 1 )
            TF( NT - IT + 1 )     = TEMP

         END DO
      ENDIF

      CLOSE( STSFIL )

      RETURN
      END
C**********************************************************************C

      SUBROUTINE EVALU( T, PULSE, TF, SF, NSD, NT, S, NTOUT )

C     *** Evaluate the source function ***

      REAL T( * ), TF( * )
      COMPLEX S( NSD, * ), SF( NSD, * )
      CHARACTER PULSE*( * )

      SAVE IT
      DATA IT /1/

      DO ITOUT = 1, NTOUT

C        Necessary to advance time window?

C        ------ Case of T reset to origin for new march
         IF ( T( ITOUT ) .LT. TF( IT ) ) IT = 1
 5000    IF ( T( ITOUT ) .GT. TF( IT + 1 ) .AND. IT .LT. NT - 1 ) THEN
            IT = IT + 1
            GO TO 5000
         ENDIF

C        Linear interpolation in time

         DO IS = 1, NSD
            S( IS, ITOUT ) = 0.0   ! in case T outside time window
         END DO

         IF ( T( ITOUT ) .GE. TF( 1  ) .AND.
     &        T( ITOUT ) .LE. TF( NT ) ) THEN
            W = ( T( ITOUT ) - TF( IT ) ) / ( TF( IT + 1 ) - TF( IT ) )
            DO IS = 1, NSD
               S( IS, ITOUT ) = SF( IS, IT )
     &            + W * ( SF( IS, IT+1 ) - SF(IS, IT) )
               IF ( PULSE(3:3) .EQ. '-' )
     &                 S( IS, ITOUT ) = -S( IS, ITOUT )
            END DO
         ENDIF

      END DO   ! next ITOUT

      RETURN
      END
C**********************************************************************C

      SUBROUTINE FILTER( PULSE, DELTAT, STEMP, SF, NSD, NT, FMIN, FMAX )

C     *** Evaluate the source function ***

      COMPLEX STEMP( * ), SF( NSD, * )
      CHARACTER PULSE*( * )

C     NOTE: program will abort if NT is not a power of 2

      DO IS = 1, NSD
         DO I = 1, NT   ! Copy time series into STEMP
            STEMP( I ) = SF( IS, I ) 
         END DO

C        --- Band-pass filter
         IF ( PULSE(4:4) .NE. 'N' )
     &      CALL BNDPAS( STEMP, NT, DELTAT, FMIN, FMAX )

C        --- Form the pre-envelope
         IF ( PULSE(2:2) .EQ. 'H' ) CALL PREENV(  STEMP, NT )

C        --- Hilbert transform
         IF ( PULSE(2:2) .EQ. 'Q' ) CALL HILBERT( STEMP, NT )

         DO I = 1, NT   ! Copy time series back
            SF( IS, I ) = STEMP( I )
         END DO
      END DO

      RETURN
      END

      PROGRAM PLOTRAY

C     Plots central rays of beams generated by BELLHOP
C     Basically, all this does is change the file format to
C       one useable by the xmgr/xvgr plot package

      INTEGER RAYFIL, PRTFIL
      PARAMETER ( RAYFIL = 5, PRTFIL = 6, MAXNR = 100000 )

      LOGICAL     SURBNC, BOTBNC, NEWSET, SURBNCOLD, BOTBNCOLD
      REAL*4      R( MAXNR ), Z( MAXNR ), RV( MAXNR ), ZV( MAXNR )
      CHARACTER   TITLE*80

C      OPEN ( FILE = 'RAYFIL', UNIT = RAYFIL, STATUS = 'OLD',
C     &       FORM = 'FORMATTED' )

      READ( RAYFIL, * ) TITLE
      READ( RAYFIL, * ) FREQ
      READ( RAYFIL, * ) NBEAMS
      READ( RAYFIL, * ) DEPTHT
      READ( RAYFIL, * ) DEPTHB

C     *** Write data ***

      LAST = INDEX( TITLE, '    ' ) - 1
      WRITE( PRTFIL, 1000 ) TITLE(1:LAST)
 1000 FORMAT( '@ title "', A, '"' )

C    *** Read rays ***

      NEWSET = .FALSE.
      SURBNCOLD = .FALSE.
      BOTBNCOLD = .FALSE.

      DO I = 1, NBEAMS
         SURBNC = .FALSE.
         BOTBNC = .FALSE.

C        --- read in a ray trajectory
         READ( RAYFIL, *, END = 3000 ) NSTEPS
         DO ISTEP = 1, NSTEPS
            READ( RAYFIL, * ) RV( ISTEP ), ZV( ISTEP )
         ENDDO

         R( 1 ) = RV( 1 ) / 1000.0
         Z( 1 ) = ZV( 1 )

         DO ISTEP = 2, NSTEPS
            R( ISTEP ) = RV( ISTEP ) / 1000.0
            Z( ISTEP ) = ZV( ISTEP )

C           --- Check ray lies within plot window
C            IF ( R( ISTEP - 1 ) .LT. RMAX .AND.
C     &           Z( ISTEP - 1 ) .LT. ZMAX ) N = ISTEP

C           --- Make note of ray type
            IF      ( ZV( ISTEP ) .LE. DEPTHT ) THEN
               SURBNC = .TRUE.
            ELSE IF ( ZV( ISTEP ) .GE. DEPTHB ) THEN
               BOTBNC = .TRUE.
            ENDIF
         END DO

C        --- is this a new ray type?
         IF ( SURBNC .NEQV. SURBNCOLD ) NEWSET = .TRUE.
         IF ( BOTBNC .NEQV. BOTBNCOLD ) NEWSET = .TRUE.

C        --- store ray type
         SURBNCOLD = SURBNC
         BOTBNCOLD = BOTBNC

C        *** Plot ***

C        --- separate ray families by '&' to mark a new 'set'
         IF ( NEWSET .AND. I .NE. 1 ) THEN
            WRITE( PRTFIL, * ) '&'
            NEWSET = .FALSE.
         END IF

         DO ISTEP = 1, NSTEPS
            WRITE( PRTFIL, * ) R( ISTEP ), Z( ISTEP )
         END DO

         WRITE( PRTFIL, * ) R( NSTEPS ), Z( 1 )
         WRITE( PRTFIL, * ) R( 1      ), Z( 1 )

      END DO

 3000 CONTINUE
      WRITE( PRTFIL, 2000 ) NINT( Z( 1 ) )
 2000 FORMAT(  '@ subtitle "',
     &         'Sd =', I4, ' m"' )

      RMIN = 0.0
      RMAX = R( NSTEPS )
      WRITE( PRTFIL, 4000 ) INT( RMIN   ), INT( RMAX   ),
     &                      INT( DEPTHT ), INT( DEPTHB )
 4000 FORMAT( '@ world xmin ', I5, /,
     &        '@ world xmax ', I5, /,
     &        '@ world ymin ', I5, /,
     &        '@ world ymax ', I5 )

      STOP
      END

      SUBROUTINE MTHU (Q, IORD, IRA, IEO, INORM, MAXORD)

C     *********************************************************************
C     *                                                                   *
C     *     This set of routines is based on N. Toyama and K. Shogen,     *
C     *     "Computation of the value of the even and odd Mathieu         *
C     *     functions of order N for a given parameter S and an           *
C     *     argument X," IRE Transactions on Antennas and Propagation     *
C     *     Vol. Ap-32(5), 537-539 (1984).  However, my implementation    *
C     *     differs in several significant aspects, particularily in      *
C     *     calling method, the normalization options provided, the       *
C     *     calculation of the series coefficients, D, the use of         *
C     *     expansions for large and small Q, the method of calculating   *
C     *     the continued fraction poynomial for finding the roots and    *
C     *     other points were attempts have been made to improve          *
C     *     stability.                                                    *
C     *                               Stephen C. Wales, November 1984     *
C     *                                                                   *
C     *********************************************************************

C     This routine initializes the various parameters and calls the zero and 
C     series calculating subroutines if needed.  The arguments are:
C     Q the parameter (must be geater than 0)
C     IORD the order (must be geater than 0)
C     IRA = 1 Radial functions of the third type (= first + i x second)
C         = 2 Angular functions
C     IEO = Even-odd switch, even if even, odd if odd
C     INORM is the normalization switch.  The normalization may be specified
C           by type if negative or zero, or by author if positive.  See
C           subroutine DNORM for a detailed explanation of the possible options.
C     MAXORD causes the zeros to be located up to MAXORD the first time,
C         thereby saving computation time.  MAXORD will be updated if IORD
C         is greater, but this is a terrible waste of computation time since
C         finding the zeros is 90 % of the battle and the routine must find
C         each one up to the one you're using. Eg. If the user doesn't set
C         this parameter and works up to N zeros, the program will have to do
C         N*(N+1)/2 zero searches instead of N.

C     Two subroutines are called:
C     ABCALC to calculate the zeros of the continued fraction.
C     DCALC to calculate the series coefficients.

      IMPLICIT REAL*8 (A-G,O-Z)

      COMMON /MPARMS/ QP, IORDP, IRAP, IEOP, INORMP, MAXORDP
      COMMON /MCOEFS/ ICOEF, MAXZ, AB(0:200,4), QOLD(4), 
     1                                     D(0:300), ND, NDMAX, MZ(4)

C   * TEST FOR LEGAL VALUES *
                                                  ! LEGAL VALUES OF ORDER
      IF (IORD.LT.MOD(IEO,2) .OR. IORD.GT.300)  THEN
          WRITE (6,111)
111       FORMAT (' ILLEGAL ORDER FOR MATHIEU FUNCTION')
          IF (IORD.LT.0)  THEN
              WRITE (6,112) IORD
112       FORMAT (' ORDER IS LESS THAN ZERO, IORD =',I5)
          ELSE IF (IORD.EQ.0)  THEN
              WRITE (6,113)
113       FORMAT (' ORDER = 0 FOR AN ODD FUNCTION')
          ELSE IF (IORD.GT.300)  THEN
              WRITE (6,114)
114       FORMAT (' ORDER > 300 !')
          END IF
          STOP '* ERROR IN MATHIEU FUNCTION CALL - ORDER *'

      ELSE IF (Q.LT.0)  THEN                      ! LEGAL VALUES OF Q
          WRITE (6,115)
115       FORMAT (' ILLEGAL VALUE OF Q FOR MATHIEU FUNCTION')
          WRITE (6,116) Q
116       FORMAT (' Q = ',1PE17.10,' (< 0)')
          STOP '* ERROR IN MATHIEU FUNCTION CALL - Q *'

      ELSE IF (X.LT.0)  THEN                      ! LEGAL VALUES OF X
          WRITE (6,117)
117       FORMAT (' ILLEGAL VALUE OF X FOR MATHIEU FUNCTION')
          WRITE (6,118) X
118       FORMAT (' X = ',1PE17.10, '(< 0)')
          STOP '* ERROR IN MATHIEU FUNCTION CALL - X *'
      END IF

C   * LOAD PARAMETERS IN MPARMS COMMON *
C     (AN ADDITIONAL P IS ADDED TO PARAMETERS SO THEY MAY PASSED THROUGH
C      THROUGH THE MPARMS COMMON)
                                                  ! * MPARMS COMMON *
      QP = Q
      IORDP = IORD
      IRAP = IRA
      IEOP = MOD (IEO,2)
      INORMP = INORM
      MAXORDP = MAXORD
C                         ! *> use of maxord gives sysaccviol err <*
      IF (MAXORDP.LT.IORD)  MAXORDP = IORD 
                                                  ! * ABPARM COMMON *
      MAXZ = MAXORDP/2 + 1                        ! MAX. NUM. OF ZEROS TO FIND
      ICOEF = 2*IEOP + 1 + MOD(IORD,2)            ! 1 = EVEN FUNC, EVEN ORDER
                                                  ! 2 = EVEN FUNC, ODD ORDER
                                                  ! 3 = ODD FUNC, EVEN ORDER
                                                  ! 4 = ODD FUNC, ODD ORDER
      ITYPE = (1-2*IEOP) * IORD                   ! = IORD IF EVEN FUNCTION
                                                  ! = -IORD IF ODD FUNCTION

      IF (IFIRST.EQ.0)  THEN                      ! INITIALIZE OLD Q ARRAY
          DO 10 I = 1,4
   10     QOLD(I) = -1.D0
          QDOLD = -1.D0
          IFIRST = 1
      END IF

C   * * * CALCULATE ZEROS AND THE COEFFICIENTS FOR THE SERIES EXPANSION * * *

C     (RECALCULATE ZEROS AND COEFFICIENTS IF Q HAS CHANGED)
C     (RECALCULATE COEFFICIENTS IF ZERO, A/B, BEING USED IS NO LONGER
C      THE SAME FOR ANY REASON, DIFF. Q, CHANGE OF ORDER OR FUNCTION TYPE)

      IF (ABS(Q-QOLD(ICOEF)).GT.1.D-10 .OR. MAXZ.GT.MZ(ICOEF))  THEN
          CALL ABCALC
      END IF

      IF (ABS(Q-QDOLD).GT.1.D-10 .OR. ITYPE.NE.ITOLD)  THEN
          CALL DCALC
          QDOLD = Q
          ITOLD = ITYPE
      END IF
      RETURN
      END


C**********************************************************************C
      FUNCTION RMTHU( X, Q, IORD, IEO, IDER, INORM, MAXORD )

C     This is essentially a dummy function for convenience purposes.
C     Most of the parameters are defined in Mathieu above, the ones that
C     aren't are X the argument and Q the parameter of the Matheiu function.
C     and IDER the derivative to be calculated, eg. IDER = 0, no derivatve,
C     IDER = 1, first derivative, etc.  In the acoustic case,
C     Q = K**2 (A**2-B**2) / 4, and X = LN ((A+B)/(A-B)) / 2, where A
C     and B are the semi-major and semi-minor axes of the ellipse and K the
C     acoustic wavenumber, 2*pi/wavelength.  The quantity 2 sqrt(Q) cosh(X)
C     is merely KA.

      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 RMTHU, RMTHUV

      U = SQRT(Q) * EXP ( X)
      V = SQRT(Q) * EXP (-X)
      RMTHU = RMTHUV (U, V, IORD, IEO, IDER, INORM, MAXORD)
      RETURN
      END



      FUNCTION RMTHUV( U, V, IORD, IEO, IDER, INORM, MAXORD )

C     Calculate the radial Mathieu functions. All the parameters are
C     described in MTHU or RMTHU above except U and V.  U and V
C     are an optional set of parameters/arguments to be used instead of
C     X and Q normally used, they are related to X and Q as defined in
C     RMTHU above.  In the acoustic case, U = K * (A+B) / 2 and
C     V = K * (A-B) / 2.  Conversely Q = U * V and X = LN (U/V) / 2.
C     The last formula presents the poblem with the X,Q formulation
C     since X approaches infinity as A approaches B for the circular
C     cylinder.

      IMPLICIT REAL*8 (A-G,O-Z)
      IMPLICIT COMPLEX*16 (H)
      COMPLEX*16 AI
      PARAMETER (PI=3.1415926535897933D0, PIO2=PI/2.D0,
     &           AI=(0.0D0,1.D0) )
      REAL*8 BJU(0:500), BJV(0:500), BYU(0:500), D1BJV(0:500)

      COMPLEX*16 RMTHUV, HJU(0:500), D1HJU(0:500), D1HJU1, DRMTHU

      COMMON /MCOEFS/ ICOEF, MAXZ, AB(0:200,4), QOLD(4), 
     1                                     D(0:300), ND, NDMAX, MZ(4)

C   * INTIALIZE FOR CALCULATIONS *

      Q = U * V
      CALL MTHU (Q, IORD, 1, IEO, INORM, MAXORD)

C   * GET BESSEL FUNCTIONS, THESE CALLS ARE TO SLATEC LIBRARY *

      NDX = ND + NDMAX + 3                        ! MAX. ORDER OF BESSEL FUNC.

      IF (V.NE.VOLD .OR. NDX.GT.NDVOLD)  THEN     ! BESSEL FUNCS. FOR V TERMS
          IF (V.NE.VOLD)  THEN
              CALL DBESJ (V, 0.D0, NDX, BJV(0), NZJ)
          ELSE
              NS = NDVOLD                         ! LAST POINT IS RECALCULATED
              NT = NDX - NDVOLD + 1
              ALPHA = DBLE (NS)
              CALL DBESJ (V, ALPHA, NT, BJV(NS), NZJ)
          END IF
          D1BJV(0) = V * BJV(1)                   ! CALC. FIRST DERIVATIVE
          DO 5 I = 1,NDX-1
    5     D1BJV(I) = -V * (BJV(I-1) - BJV(I+1)) / 2.D0
          VOLD = V
          NDVOLD = NDX
      END IF

      IF (U.NE.UOLD .OR. NDX.GT.NDUOLD)  THEN     ! BESSEL FUNCS. FOR U TERMS
          IF (U.NE.UOLD)  THEN
              CALL DBESJ (U, 0.D0, NDX, BJU(0), NZJ)
              CALL DBESY (U, 0.D0, NDX, BYU(0))
          ELSE
              NS = NDUOLD                         ! LAST POINT IS RECALCULATED
              NT = NDX - NDUOLD + 1
              ALPHA = DBLE (NS)
              CALL DBESJ (U, ALPHA, NT, BJU(NS), NZJ)
              CALL DBESY (U, ALPHA, NT, BYU(NS))
          END IF
          DO 10 I = 0,NDX                         ! FORM HANKEL FUNCTION
   10     HJU(I) = DCMPLX (BJU(I), BYU(I))
          D1HJU(0) = -U * HJU(1)                  ! CALC. FIRST DERIVATIVE
          DO 15 I = 1,NDX-1
   15     D1HJU(I) = U * (HJU(I-1) - HJU(I+1)) / 2.D0
CD         WRITE (6,119) NT, NS
C119       FORMAT (I5,' BESSEL FUNCTIONS CALCULATED BEGINING AT',I5)
CD         IF (NDZ.GT.0)  WRITE (6,1110) NDZ
C1110        FORMAT ('   LAST',I5,
C     1                   ' ELEMENTS OF BESSEL FUNCTION WERE ZERO')
          UOLD = U
          NDUOLD = NDX
          DO 20 II = 0,NDX-2                      ! WRONSKIAN TEST
          WTEST = DBLE(HJU(II)) * DIMAG(D1HJU(II))
     1                              - DIMAG(HJU(II)) * DBLE(D1HJU(II))
          WTEST = WTEST*PIO2 - 1.D0
          IF (ABS(WTEST).GT.1.D-8 .AND. IHERCT.LT.20)  THEN
              IHERCT = IHERCT + 1
              WRITE (6,1111) II, WTEST, HJU(II),DIMAG(D1HJU(II)),
     1                       DIMAG(HJU(II)), D1HJU(II)
1111          FORMAT (' ERROR IN HANKEL FUNCTIONS, ',
     1                                 'WTEST(',I5,') =',1PE17.10,/
     2            ' = ', E17.10,' * ',E17.10,' - ',E17.10,' * ',E17.10)
          END IF
   20     CONTINUE
      END IF


C   * * * COMPLEX RADIAL FUNCTIONS * * *

      RMTHUV = (0.0D0, 0.0D0)
      MIEO2 = MOD (IEO,2)
      DO 100 K = 0,ND
      K1 = K - NDMAX
      K2 = K + NDMAX + MOD(IORD,2)
      IF (K1.LT.0)  THEN
          K1 = IABS (K1)
          BJV1 = (-1.D0)**K1 * BJV(K1)
          HJU1 = (-1.D0)**K1 * HJU(K1)
      ELSE
          BJV1 = BJV(K1)
          HJU1 = HJU(K1)
      END IF
      IF (MIEO2.EQ.1)  HJU1 = - HJU1
      HFACT = (-1.D0)**K * D(K) * (BJV1*HJU(K2) + BJV(K2)*HJU1)
  100 RMTHUV = RMTHUV + HFACT

C   * FIRST DERIVATIVE OF THE COMPLEX RADIAL FUNCTIONS *

      DRMTHU = (0.0D0, 0.0D0)
      DO 120 K = 0,ND
      K1 = K - NDMAX
      K2 = K + NDMAX + MOD(IORD,2)
      IF (K1.LT.0)  THEN
          K1 = IABS (K1)
          BJV1 = (-1.D0)**K1 * BJV(K1)
          HJU1 = (-1.D0)**K1 * HJU(K1)
          D1BJV1 = (-1.D0)**K1 * D1BJV(K1)
          D1HJU1 = (-1.D0)**K1 * D1HJU(K1)
      ELSE
          BJV1 = BJV(K1)
          HJU1 = HJU(K1)
          D1BJV1 = D1BJV(K1)
          D1HJU1 = D1HJU(K1)
      END IF
      IF (MIEO2.EQ.1)  THEN
          HJU1 = -HJU1
          D1HJU1 = -D1HJU1
      END IF
  120 DRMTHU = DRMTHU + (-1)**K * D(K) *
     1                       (BJV1*D1HJU(K2) + D1BJV1*HJU(K2)
     2                               + D1BJV(K2)*HJU1 + BJV(K2)*D1HJU1)

C   * SECOND DERIVATIVE OF THE COMPLEX RADIAL FUNCTIONS *

      IF (IDER.GE.2)  THEN
        WRITE (6,1114)
1114    FORMAT (' **************************************************',/
     1          ' *  SECOND AND HIGHER DERIVATIVES OF THE COMPLEX  *',/
     2          ' * RADIAL FUNCTIONS HAVE NOT YET BEEN IMPLEMENTED *',/
     3          ' **************************************************')
          STOP 'ERROR IN RMTHUV FUNCTION ROUTINE'
      END IF

C   * FINAL NORMALIZATION AND SIGN *

      IF (NDMAX+MOD(IORD,2).EQ.0)  THEN
          RMTHUV = RMTHUV / 2.D0
          DRMTHU = DRMTHU / 2.D0
      END IF
      RMTHUV = (-1.D0)**(IORD/2) * RMTHUV
      DRMTHU = (-1.D0)**(IORD/2) * DRMTHU
      CALL DNORM (RMTHUV)
      CALL DNORM (DRMTHU)

C   * CHECK ANSWER FOR VALIDITY BY FORMING WRONSKIAN

      IF (INORM.NE.3)  THEN
          WTEST = DBLE(RMTHUV) * DIMAG(DRMTHU)
     1                   - DIMAG(RMTHUV) * DBLE(DRMTHU)
          WTEST = WTEST * PIO2 - 1.D0
          IF (ABS(WTEST).GT.1.D-8 .AND. IMERCT.LT.20) THEN
              IMERCT = IMERCT + 1
              WRITE (6,1118) WTEST, RMTHUV, DRMTHUV, IORD,
     1                       IEO, Q, U, V
1118          FORMAT (' RMTHUV ERROR - ERROR IN WRONSKIAN ',
     1                                   'CALCULATION IS',1PE17.10,/
     2                ' RM, DRM:', 1PE17.10,', ', E17.10,/
     3                ' IORD, IEO, Q:', 0PI5, ', ', I5, 1PE17.10,/
     4                ' U, V:', E17.10, ', ',E17.10)
          END IF
          IF (ABS(WTEST).GT.1.D-2)  STOP 'RMTHUV FUNCTION ERROR'
      END IF

C   * IF DERIVATIVE REQUIRED SET RMTHUV TO DRMTHU *

      IF (IDER.EQ.1)  RMTHUV = DRMTHU

      RETURN
      END


C**********************************************************************C
      FUNCTION AMTHU( X, Q, IORD, IEO, IDER, INORM, MAXORD )

C     All of the parameters have been expalined elsewhere.  The argument
C     X is now interpreted as the angle in radians.

      IMPLICIT REAL*8 (A-G,O-Z)
      COMPLEX*16 FMTHU

      COMMON /MCOEFS/ ICOEF, MAXZ, AB(0:200,4), QOLD(4), 
     1                                     D(0:300), ND, NDMAX, MZ(4)

      CALL MTHU (Q, IORD, 2, IEO, INORM, MAXORD)
      AMTHU = 0.0D0

C   * ANGULAR FUNCTIONS *

      IF (IDER.EQ.0)  THEN
          IF (ICOEF.EQ.1)  THEN                   ! EVEN FUNC, EVEN ORDER
              DO 210 K = 0,ND
  210         AMTHU = AMTHU + D(K) * COS ((2*K)*X)

          ELSE IF (ICOEF.EQ.2)  THEN              ! EVEN FUNC, ODD ORDER
              DO 220 K = 0,ND
  220         AMTHU = AMTHU + D(K) * COS ((2*K+1)*X)

          ELSE IF (ICOEF.EQ.3)  THEN              ! ODD FUNC, EVEN ORDER
              DO 230 K = 1,ND
  230         AMTHU = AMTHU + D(K) * SIN ((2*K)*X)

          ELSE IF (ICOEF.EQ.4)  THEN              ! ODD FUNC, ODD ORDER
              DO 240 K = 0,ND
  240         AMTHU = AMTHU + D(K) * SIN ((2*K+1)*X)
          END IF

C   * FIRST DERIVATIVE OF THE ANGULAR FUNCTIONS *

      ELSE IF (IDER.EQ.1)  THEN
          IF (ICOEF.EQ.1)  THEN                   ! EVEN FUNC, EVEN ORDER
              DO 410 K = 0,ND
  410         AMTHU = AMTHU - (2*K) * D(K) * SIN ((2*K)*X)

          ELSE IF (ICOEF.EQ.2)  THEN              ! EVEN FUNC, ODD ORDER
              DO 420 K = 0,ND
  420         AMTHU = AMTHU - (2*K+1) * D(K) * SIN ((2*K+1)*X)

          ELSE IF (ICOEF.EQ.3)  THEN              ! ODD FUNC, EVEN ORDER
              DO 430 K = 1,ND
  430         AMTHU = AMTHU + (2*K) * D(K) * COS ((2*K)*X)

          ELSE IF (ICOEF.EQ.4)  THEN              ! ODD FUNC, ODD ORDER
              DO 440 K = 0,ND
  440         AMTHU = AMTHU + (2*K+1) * D(K) * COS ((2*K+1)*X)
          END IF

C   * SECOND DERIVATIVE OF THE ANGULAR FUNCTIONS *

      ELSE IF (IDER.EQ.2)  THEN
          IF (ICOEF.EQ.1)  THEN                   ! EVEN FUNC, EVEN ORDER
              DO 610 K = 0,ND
  610         AMTHU = AMTHU - (2*K)**2 * D(K) * COS ((2*K)*X)

          ELSE IF (ICOEF.EQ.2)  THEN              ! EVEN FUNC, ODD ORDER
              DO 620 K = 0,ND
  620         AMTHU = AMTHU - (2*K+1)**2 * D(K) * COS ((2*K+1)*X)

          ELSE IF (ICOEF.EQ.3)  THEN              ! ODD FUNC, EVEN ORDER
              DO 630 K = 1,ND
  630         AMTHU = AMTHU - (2*K)**2 * D(K) * SIN ((2*K)*X)

          ELSE IF (ICOEF.EQ.4)  THEN              ! ODD FUNC, ODD ORDER
              DO 640 K = 0,ND
  640         AMTHU = AMTHU - (2*K+1)**2 * D(K) * SIN ((2*K+1)*X)
          END IF

C   * THIRD DERIVATIVE OF THE ANGULAR FUNCTIONS *

      ELSE IF (IDER.GE.3)  THEN
          WRITE (6,1122)
1122      FORMAT (' *********************************************',/
     1            ' * THIRD & HIGHER DERIVATIVES OF THE ANGULAR *',/
     2            ' * FUNCTIONS HAVE NOT YET BEEN IMPLEMENTED.  *',/
     3            ' *********************************************')
          STOP 'ERROR IN AMTHU FUNCTION ROUTINE'
      END IF

C   * DO FINAL NORMALIZATION *

      FMTHU = (1.D0, 0.0D0)
      CALL DNORM (FMTHU)
      AMTHU = AMTHU * FMTHU
      RETURN
      END


C**********************************************************************C
      SUBROUTINE DCALC

C     This routine calculates the coefficients for the expansions of the
C     Mathieu functions.  The method used differs substantially from Toyama 
C     and Shogen.  The continued fraction representations for the ratios of 
C     the amplitudes of the coefficients found in Abramowitz and Stegun,
C     National Bureau of Standards, AMS-55, p. 723, 20.2.5 to 20.2.20.
C     are used.  Both the up and down representaitons are used.  Beginning 
C     in the center with a value of 1, the down representation, GDN, 
C     eq. 20.2.20, is used to obtain the lower half, and the up representation,
C     eq. 20.2.19,  is used to calculate the upper half.
C     THE RESULTING COEFFICIENTS ARE NOT NORMALIZED, THIS IS DONE BY DNORM.

      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (PI=3.141592653589793D0, PRECR=1.D-16)
      REAL*8  GUP(400), GDN(300)

      COMMON /MPARMS/ Q, IORD, IRA, IEO, INORM, MAXORD      
      COMMON /MCOEFS/ ICOEF, MAXZ, AB(0:200,4), QOLD(4), 
     1                                     D(0:300), ND, NDMAX, MZ(4)

      IR = IORD / 2
      A = AB(IR,ICOEF)
CD     WRITE (6,1) A, IR, ICOEF
CD   1 FORMAT (' CHAR.VALUE =',1PE17.10,'(IR=',0PI5,', ICOEF=',I5,')')


C   * * * SPECIAL CASE FOR Q VERY SMALL, < 1.D-8 * * *

      IF (Q.LT.1.D-8)  THEN
          ND = IR + 4
          NDMAX = IR
          D(IR) = 1.D0
          Q4 = Q / 4.D0
          J = 0
          DO 5 I = IR-1,0,-1                      ! BELOW D(IR)
          J = J + 1
    5     D(I) = (Q4 / DBLE(J*(IORD-1))) * D(I+1)
          J = 0
          DO 7 I = IR+1,IR+4                      ! ABOVE D(IR)
          J = J + 1
    7     D(I) = -(Q4 / DBLE(J*(IORD+J))) * D(I-1)
          RETURN
      END IF


C   * * * NORMAL ROUTINE FOR CALCULATING THE SERIES COEFICIENTS D * * *

C   * SET UP CONSTANTS *

      IF (ICOEF.EQ.1)  THEN
          PHI0 =  2.0D0
          PHI1 =  0.0D0
      ELSE IF (ICOEF.EQ.2)  THEN
          PHI0 =  1.0D0
          PHI1 = -1.0D0
      ELSE IF (ICOEF.EQ.3)  THEN
          PHI0 =  0.0D0
          PHI1 =  1.0D37
      ELSE IF (ICOEF.EQ.4)  THEN
          PHI0 =  1.0D0
          PHI1 =  1.0D0
      END IF
      DAS = MOD (ICOEF-1,2)

C   * CALCULATE REASONABLE STARTING AND STOPPING POINTS *

      IF (A.GT.201.D0)  THEN                      ! NEAREST N**2
          M = NINT((SQRT(A)-DAS)/2.D0)
      ELSE
          M = 10
      END IF
      M2 = M**2
      ACC = 0.0D0
      
      DO 10 I = M,300
      ACC = ACC + LOG10(((2*I)**2-M2)/Q)
      IF (ACC.LE.35.D0) MSTOP = I                 ! STOPPING PT. FOR SERIES
      IF (ACC.GT.75.D0)  THEN
          MCF = I                                 ! ST.PT. FOR CONT. FRAC. CALC.
          GO TO 20
      END IF
   10 CONTINUE
      MCF = 300
 
C   * CALCULATE G'S *
C     COMMENT: THIS FORMULATION AND ALL OTHERS GETS INTO TROUBLE WHEN
C              A = (2*K+DAS)**2

   20 GDN(1) = (A - DAS**2)/Q + PHI1              ! RUNNING UP
      V = (A - (2.D0+DAS)**2) / Q
      GDN(2) = V - PHI0/GDN(1)

      DO 30 K = 3,MSTOP
      V = (A - (2.D0*DBLE(K-1)+DAS)**2) / Q
      GDN(K) = V - 1.D0/GDN(K-1)
   30 CONTINUE

      IF (ICOEF.EQ.3)  THEN
          KSIGN = 1
          KSTAR = 1
      ELSE
          KSIGN = 0
          KSTAR = 0
      END IF
      GUP(MCF+1) = 0.0D0                          ! RUNNING DOWN
      GMINER = 1.D0
      DO 40 K = MCF,2,-1
      VQ = A - (2.D0*DBLE(K)+DAS)**2
      GUP(K) = Q / (VQ - Q*GUP(K+1))
      IF (GUP(K).GT.0.0D0 .AND. KSIGN.EQ.KSTAR)  KSIGN = K
      GREL = ABS (GUP(K)-GDN(K)) / (ABS (GUP(K)) + PRECR)
      IF (GREL.LT.GMINER)  THEN
          GMINER = GREL
          KBEST = K
      END IF
   40 CONTINUE
      VQ = A - (2.D0+DAS)**2
      IF (ICOEF.NE.3) THEN
          GUP(1) = Q * PHI0 / (VQ - Q*GUP(2))
          IF (GUP(1).GT.0.0D0 .AND. KSIGN.EQ.KSTAR)  KSIGN = 1
          GREL = ABS (GUP(1)-GDN(1)) / (ABS (GUP(1)) + PRECR)
          IF (GREL.LT.GMINER)  THEN
              GMINER = GREL
              KBEST = 1
          END IF
      END IF

C   * CALCULATE UNNORMALIZED D'S AND LOCATE MAXIMUM VALUE *

      D(KBEST) = 1.0D0
      DO 50 K = KBEST,1,-1                        ! * LOW END *
      K1 = K - 1
   50 D(K1) = D(K) / GDN(K)
      DO 60 K = KBEST+1,MCF                       ! * HIGH END *
      D(K) = GUP(K) * D(K-1)
      IF (ABS(D(K)).LT.1.D-25)  THEN
          ND = K
          GO TO 100
      END IF
   60 CONTINUE
     
  100 WM = 0.D0
      D2 = 0.0D0
      DO 110 K = 0,ND
      WM = WM + K * D(K)**2
  110 D2 = D2 + D(K)**2
      WM = WM / D2
      NDMAX = NINT (WM)
CD     WRITE (6,120) KSIGN, KBEST, GMINER, NDMAX, D(NDMAX)
CD 120 FORMAT (' KSIGN =', I5,',  KBEST =', I5,/
CD    1        ' GMINER (QUALITY OF FIT) =',1PE17.10,/
CD    2        ' NDMAX, D:', 0PI5,', ', 1PE17.10 )
CD     WRITE (6,130) 0, REAL( D(0)/D(NDMAX) )
CD 130 FORMAT (' K, D          : ', I5,', ', 1PE17.10 )
CD     DO 140 K = 1,ND
CD 140 WRITE (6,150) K, REAL(D(K)/D(NDMAX)), REAL(GDN(K)), REAL(GUP(K))
CD 150 FORMAT (' K, D, GDN, GUP: ', I5, 3(', ',1PE17.10) )

C   * TEST FOR ACCEPTABLE MATCH BETWEEN THE TWO SERIES *

      IF (GMINER.GT.1.D-6)  THEN 
          WRITE (6,160) KBEST, GMINER
  160     FORMAT (' UNABLE TO OBTAIN GOOD FIT BETWEEN UP & DOWN G''S',
     1           ' IN DCALC',/
     2            ' KBEST =', I5,',    GMINER =', 1PE17.10 )
          STOP 'STOP - ERROR IN DCALC, BAD FIT'
      END IF
      RETURN
      END


C**********************************************************************C
      SUBROUTINE DNORM (FMTHU)

C     This routine normalizes the result to the requested normalization.
C     FMTHU is the unnormalized Mathieu function.
C     Several normalizations are possible as specified by the INORM parameter.
C     The JNORM parameter is the effective parameter internal to this 
C     subroutine.  If INORM is negative or zero it is set equal to JNORM,  
C     if positive then a lookup table is provided in JNORMS to convert INORM
C     to the proper representation.   The JNORMS table is as follows:
C                  JNORM   JNORM
C                 Radial  Angular      Authors
C     INORM =  1    -3      -2   Abramowitz and Stegun
C           =  2    -3      -1   Morse and Feshbach, Toyama and Shogen
C           =  3    -2      -2   McLachlin (Radial not implemented)
C           =  4    -3      -2   Abramowitz and Stegun
C           =  5    -3      -2   Normalized for plane wave expansions,
C                                A&S * sqrt(2), M&F * sqrt(2/M)
C           In addition certain of these need factors like SQRT (PI/2) etc.,
C           see SPECIAL CASES below.
C                 Normalized by ...
C     JNORM = -4, principle coefficient, IORD/2, 
C           = -3, the central coefficient, NDMAX = sum (n*Dn**2) / sum Dn**2
C           = -2, sum squared equal to one,
C           = -1, sum equal to one for even functions, unity value at X = 0,
C                 sum of order of coeff. times coeff., (2*K+IP)*D(K), equal to
C                 one for odd functions, unity slope at X = 0,
C           = 0,  lead coefficient equal to one

      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (PI=3.141592653589793D0)

      INTEGER JNORMS(2,5)
      COMPLEX*16  FMTHU

      COMMON /MPARMS/ Q, IORD, IRA, IEO, INORM, MAXORD      
      COMMON /MCOEFS/ ICOEF, MAXZ, AB(0:200,4), QOLD(4), 
     1                                     D(0:300), ND, NDMAX, MZ(4)

      DATA JNORMS/-3,-2,-3,-1,-2,-2,-3,-2,-3,-2/

      IR = IORD / 2

C   * DETERMINE TYPE OF NORMALIZATION TO BE USED *

      IF (INORM.LE.0)  THEN                       ! NORMALIZATION SPECIFIED
          JNORM = INORM
      ELSE IF (INORM.LE.5)  THEN                  ! TABLE LOOKUP FOR
          JNORM = JNORMS(IRA,INORM)               !      VARIOUS AUTHORS
      ELSE
          JNORM = 0
      END IF
CD     WRITE (6,1136) INORM, JNORM
C1136   FORMAT (' INORM, JNORM:', I5, I5 )

C   * CALCULATE NORMALIZATION FACTOR *

      IF (JNORM.EQ.-4)  THEN                      ! * NORM. BY PRINC. COEFF.*
          DNRML = D(IR)

      ELSE IF (JNORM.EQ.-3)  THEN                 ! * NORM. BY LARGEST COEFF.*
          DNRML = D(NDMAX)

      ELSE IF (JNORM.EQ.-2)  THEN                 ! * NORM. BY SUM SQUARED *
          IF (ICOEF.EQ.1)  THEN
              DNRML = D(0)**2
          ELSE
              DNRML = 0.0D0
          END IF
          DO 110 K = 0,ND
  110     DNRML = DNRML + D(K)**2
          DNRML = SQRT (DNRML)
          IF (ICOEF.EQ.3)  THEN                   ! CORRECT FOR POSS. SIGN ERR.
              DNRML = DNRML * SIGN (1.D0,D(1))
          ELSE
              DNRML = DNRML * SIGN (1.D0,D(0))
          END IF

      ELSE IF (JNORM.EQ.-1)  THEN                 ! * NORMALIZE TO UNITY SUM *
          DNRML = 0.0D0
          IF (IEO.EQ.0)  THEN                     ! EVEN SOLUTIONS
              DO 120 K = 0,ND
  120         DNRML = DNRML + D(K)
          ELSE                                    ! ODD SOLUTIONS
              IP = MOD (IORD,2)
              DO 130 K = 0,ND
  130         DNRML = DNRML + DBLE (2*K+IP) * D(K)
          END IF

      ELSE                                        ! * NORMALIZE BY LEAD COEFF.*
          IF (ICOEF.EQ.3)  THEN
              DNRML = D(1)
          ELSE
              DNRML = D(0)
          END IF
      END IF

      IF (ABS(DNRML).LE.1.D-35)  THEN
          WRITE (6,1137) DNRML, INORM, JNORM
1137      FORMAT (' *** WARNING - NORMALIZATION ERROR ***',/
     1            '     DNRML =', 1PE17.10,/
     2            '     INORM =', E17.10,/
     3            '     JNORM =', E17.10,/
     4            '     USING DNRML = 1.D0')
          DNRML = 1.0D0
          WRITE (6,1142) IORD, NDMAX, REAL(D(NDMAX))
1142      FORMAT ('  IORD, NDMAX, D(NDMAX):', 2(I5,', '), 1PE17.10 )
      END IF

C   * SPECIAL CASES *

      IF (INORM.EQ.2)  THEN                       ! MORSE & FESH., TOY.& SHOGEN
          IF (IRA.EQ.1)  DNRML = SQRT (2.D0/PI) * DNRML        
      ELSE IF (INORM.EQ.3)  THEN                  ! MCLACHLIN
          IF (IRA.EQ.1)  STOP ' MCLACHLIN RADIAL NOT IMPLEMENTED'
      ELSE IF (INORM.EQ.5)  THEN
          IF (IRA.EQ.2)  DNRML = DNRML / SQRT(2.D0)
      END IF
CD     WRITE (6,1143) DNRML
C1143   FORMAT (' DNRML =', 1PE17.10 )

C   * DO NORMALIZATION *

      FMTHU = FMTHU / DNRML

      RETURN
      END


C**********************************************************************C
      SUBROUTINE ABCALC

C     This routine finds the Nth zero of the continued fraction defining the
C     characteristic values for the parameter Q.  It is similar to Toyama and
C     Shogen in that it uses a step search to find all of the zeros up to the 
C     one desired, but that is about it.  It calculates the first zero using
C     a call to AINIT and then improves on it by searching if needed.  Other
C     zeros are found by stepping through at a step size that depends on the
C     zero being located.  Large and small Q approximations are used wherever
C     possible and improved on by seach if needed.

      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (PRECR=1.D-16, PRECA=1.D-32)

      COMMON /MPARMS/ Q, IORD, IRA, IEO, INORM, MAXORD
      COMMON /MCOEFS/ ICOEF, MAXZ, AB(0:200,4), QOLD(4), 
     1                                     D(0:300), ND, NDMAX, MZ(4)

      EXTERNAL ABFUNC

C   * FIND INITIAL VALUE OF A/B *

      AR = AINIT (Q, ICOEF)
      AZ = ABFUNC (AR, Q, ICOEF)
CD     WRITE (6,10) AR, AZ
CD  10 FORMAT (' INITIAL A/B ESTIMATE & ACCURACY: ',1PE17.10,',',E18.10)
      IF (ABS(AZ).GT.PRECR*ABS(AR)+PRECA)  THEN
          XDEL = 0.1D0
          CALL SEARCH (ABFUNC, AR, Q, ICOEF, XDEL, 1)
      END IF

C   * PLACE IN PROPER POSITION & SET INITIAL LOOP PARAMETER *

      IF (ICOEF.NE.3)  THEN
          AB(0,ICOEF) = AR
CD         WRITE (6,20) AR
CD  20     FORMAT (' AB(0,ICOEF) = ', 1PE17.10)
          IR1 = 1
      ELSE
          AB(0,ICOEF) = 0.0D0
          AB(1,ICOEF) = AR
CD         WRITE (6,30) 0.0D0, AR
CD  30     FORMAT (' AB(0,ICOEF) = ', 1PE17.10,/,
CD    1            ' AB(1,ICOEF) = ', 1PE17.10)
          IR1 = 2
      END IF

C   * SET EVEN-ODD SWITCH PARAMETER *

      IC1 = MOD (ICOEF-1,2)                       ! 0 = EVEN, 1 = ODD

C   * LOOP OVER K FINDING THE FIRST MAXZ ZEROS OF A (OR B) *

CD     WRITE (6,40) IR1, MAXZ
CD  40 FORMAT (' IR LOOP FROM', I5,' TO', I5 )
      DO 100 IR = IR1,MAXZ
      IOR = 2*IR + IC1
      XDEL = (IOR**2 - (IOR-2)**2) / 2.D0

      IF (IOR.LE.7)  THEN                         ! DETERMINE LIMIT FOR SMALL Q
          QTEST = 5.D-2 + 8.D-5 * IOR**4
      ELSE
          QTEST = 10.D0** ((-15.D0+14.D0*LOG10(DBLE(IOR)))/8.D0)
      END IF
CD     WRITE (6,50) QTEST, IOR
CD  50 FORMAT (' QTEST, IOR:', 1PE17.10,', ',0PI5 )

      IF (Q.GT.10.D0*QTEST)  THEN                 ! MEDIUM AND LARGE Q'S
CD         WRITE (6,60)
CD  60     FORMAT (' A FOUND BY SEARCH')
          AR = AR + XDEL
          CALL SEARCH (ABFUNC, AR, Q, ICOEF, XDEL, 0)
      ELSE                                        ! SMALL Q'S
          IF (ICOEF.LE.2)  THEN                   ! FOR A'S        
              AR = ASMALLQ (Q, IOR)
          ELSE
              AR = ASMALLQ (Q,-IOR)               ! FOR B'S
          END IF
          AZ = ABFUNC (AR, Q, ICOEF)
CD         WRITE (6,70) AZ
CD  70     FORMAT (' A FOUND BY SMALL A FORMULA ACC. = ',1PE17.10)
          IF (ABS(AZ).GT.PRECR*ABS(AR)+PRECA .AND.
     1                                    Q.GT.QTEST*1.D-3)  THEN
              XDEL = XDEL / 100.D0
              CALL SEARCH (ABFUNC, AR, Q, ICOEF, XDEL, 1)
CD             WRITE (6,80) ABFUNC (AR, Q, ICOEF)
CD  80         FORMAT (' A IMPROVED BY SEARCH, ACC. = ',1PE17.10)
          END IF
      END IF
CD     WRITE (6,90) IR, AR
CD  90 FORMAT (' AB(', I5, ',ICOEF) =', E17.10)
  100 AB(IR,ICOEF) = AR

      QOLD(ICOEF) = Q
      MZ(ICOEF) = MAXZ
CD     WRITE (6,110) ICOEF, QOLD(ICOEF), ICOEF, MZ(ICOEF)
CD 110 FORMAT ('QOLD(',I5,') =', 1PE17.10,',  MZ(',I5,') = ',I5)
      RETURN
      END



C**********************************************************************C
      FUNCTION ABFUNC (A, Q, ICOEF)

C     THIS ROUTINE CALCULATES THE CONTINUED FRACTION FOR GIVEN VALUES
C     OF A AND Q. THE CONTINUED FRACTION USED IS DETERMINED BY ICOEF.
C     NTERM IS THE NUMBER OF TERMS CALCULATED.
C     This routine claculates the continued fraction for the given values of
C     A and Q according to the parameter ICOEF.  It follows Toyama and Shogen
C     in that it finds the zeros by a polymomial expansion of the numerator
C     (AN here).  It differs in that it figures out how many terms are needed,
C     normalizes the polynomial to prevent overflow, and uses an iterative
C     method to calculate the polynomial to any order.

      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (PRECR=1.D-16,PRECA=1.D-32)

C   * BEGIN BY CALCULATING NUMBER OF TERMS NEEDED *

      IF (A.LE.0.0D0)  THEN
          AA = 0
      ELSE
          AA = A
      END IF
      NTERM = NINT (SQRT (Q+AA)) + 10

C   * ABFUNC CALCULATIONS *

      IF (ICOEF.EQ.1)  THEN                       ! EVEN FUNCTION, EVEN ORDER
          AN = A
          BN = 2.D0
          DIP = 0.D0

      ELSE IF (ICOEF.EQ.2)  THEN                  ! EVEN FUNCTION, ODD ORDER
          AN = A - 1.D0 - Q
          BN = 1.D0
          DIP = 1.D0

      ELSE IF (ICOEF.EQ.3)  THEN                  ! ODD FUNCTION, EVEN ORDER
          AN = A - 4.D0
          BN = 1.D0
          DIP = 2.D0

      ELSE IF (ICOEF.EQ.4)  THEN                  ! ODD FUNCTION, ODD ORDER
          AN = A - 1.D0 + Q
          BN = 1.D0
          DIP = 1.D0

      ELSE
          WRITE (6,1155) ICOEF
1155      FORMAT (' * * * ILLEGAL VALUE FOR ICOEF (',I5, ') * * *' )
          STOP '   ICOEF ERROR'
      END IF

C   * CALCULATE THE CONTINUED FRACTION FOR MATHIEU FUNCTIONS *
C     CURRENTLY ONLY CALCULATES THE NUMERATOR TO FIND THE ZEROS,
C     REMOVE THE COMMENTS TO CACULATE THE CONTINUED FRACTION.

C     CN = 1.D0
C     DN = 0.D0
      ABSA = ABS (A)
      QSQ = Q**2

      DO 100 I = 1,NTERM
      SQ = (2.D0*DBLE(I) + DIP)**2
      FN = A - SQ
      DIV = - MAX (1.D0, Q, SQ)
      AOLD = AN
      AN = (FN*AN - QSQ*BN) / DIV
      BN = AOLD / DIV
C     COLD = CN
C     CN = (FN*CN - QSQ*DN) / DIV
C     DN = CN / DIV
      CFOLD = ABFUNC
      ABFUNC = AN                                              ! / CN 
C      IF (ABS(ABFUNC-CFOLD).LT.(PRECR*MAX(ABS(ABFUNC),ABSA)+PRECA)
C     1                                             .AND. I.GT.2)  THEN
C          NTERM = I
CD         WRITE (6,1157) A, ABFUNC, NTERM
C          RETURN
C      END IF
  100 CONTINUE
CD     WRITE (6,1157) A, ABFUNC, NTERM
C1157   FORMAT ( ' A, ABFUNC, MAX NTERM:',1PE17.10,', ',E17.10,', ',0PI5)

      RETURN
      END


C**********************************************************************C
      FUNCTION ASMALLQ (Q, IR)

C     This function calculates a zero in the continued frqction equations
C     for small Q.  IR is the zero number, even solutions are indicated by 
C     IR >= 0 and odd solutions by IR < 0.  The equations are from Abramowitz
C     and Stegun, N.B.S. AMS-55, eqs. 20.2.25

      IMPLICIT REAL*8 (A-H,O-Z)

      Q2 = Q**2
      Q4 = Q2**2
      IF (IR.GE.0)  THEN
          QP = -Q
      ELSE
          QP = Q
      END IF

      IF (IR.EQ.0)  THEN                          ! A0(Q)
          ASMALLQ = -Q2 * (1.D0/2.D0 - Q2 * (7.D0/128.D0 - Q2 
     1                    * (29.D0/2304.D0 - Q2*68687.D0/18874368.D0)))

      ELSE IF (ABS(IR).EQ.1)  THEN                ! A1(-Q), B1(Q)
          ASMALLQ = 1.D0 - QP - Q2/8.D0 + Q2*QP/64.D0 - Q4/1536.D0 
     1              - 11.D0*Q4*QP/36864.D0 + 49.D0*Q4*Q2/589824.D0
     2            - 55.D0*Q4*Q2*QP/9437184.D0 - 83.D0*Q4*Q4/35389440.D0

      ELSE IF (IR.EQ.2)  THEN                     ! A2(Q)    
          ASMALLQ = 4.D0 + Q2 * (5.D0/12.D0 - Q2 * (763.D0/13824.D0
     1                - Q2 * (1002401.D0/79626240.D0
     2                - Q2 * 1669068401.D0/458647142400.D0)))

      ELSE IF (IR.EQ.-2)  THEN                    ! B2(Q)
          ASMALLQ = 4.D0 - Q2 * (1.D0/12.D0 - Q2 * (5.D0/13824.D0
     1                - Q2 * (289.D0/79626240.D0
     2                - Q2 * 21391.D0/458647142400.D0)))
    
      ELSE IF (ABS(IR).EQ.3)  THEN                ! A3(-Q), B3(Q)
          ASMALLQ = 9.D0 + Q2/16.D0 - Q2*QP/64.D0 + 13.D0*Q4/20480.D0
     1                + 5.D0*Q4*QP/16384.D0 - 1961.D0*Q4*Q2/23592960.D0
     2                + 609.D0*Q4*Q2*QP/104857600.D0

      ELSE IF (IR.EQ.4)  THEN                     ! A4(Q)
          ASMALLQ = 16.D0 + Q2/30.D0 - 317.D0*Q4/864000.D0
     1                + 5701.D0*Q4*Q2/2.7216D9

      ELSE IF (IR.EQ.-4)  THEN                    ! B4(Q)
          ASMALLQ = 16.D0 + Q2/30.D0 + 433.D0*Q4/864000.D0
     1                + 10049.D0*Q4*Q2/2.7216D9

      ELSE IF (ABS(IR).EQ.5)  THEN                ! A5(-Q), B5(Q)
          ASMALLQ = 25.D0 + Q2/48.D0 + 11.D0*Q4/774144.D0
     1                - Q4*QP/1474456.D0 + 37.D0*Q4*Q2/891813888.D0

      ELSE IF (IR.EQ.6)  THEN                     ! A6(Q)
          ASMALLQ = 36.D0 + Q2/70.D0 + 187.D0*Q4/43904000.D0
     1                + 6743617.D0*Q4*Q2/9.29359872D13

      ELSE IF (IR.EQ.-6)  THEN                    ! B6(Q)
          ASMALLQ = 36.D0 + Q2/70.D0 + 187.D0*Q4/43904000.D0
     1                + 5861633.D0*Q4*Q2/9.29359872D13


      ELSE IF (ABS(IR).GE.7)  THEN                ! ALL OTHER AR(Q), BR(Q)
          R2 = DBLE(IR**2)
          R212 = (R2-1.D0)**2
          D1 = 2.D0 * (R2-1.D0)
          D2 = 16.D0 * (R2-4.D0) * R212 * D1
          D3 = 2.D0 * (R2-9.D0) * R212 * D2
          ASMALLQ = R2 + Q2/D1 + (5.D0*R2+7.D0)*Q4/D2
     1                         + (9.D0*R2**2+58.D0*R2+29.D0)*Q4*Q2/D3

      END IF
      RETURN
      END


C**********************************************************************C
      FUNCTION ALARGEQ (Q, IR)

C     This function calculates a zero in the continued fraction equations
C     for large Q.  IR is the zero number for even solutions and the zero
C     number minus one for odd solutions.  The equations are from Abramowitz
C     and Stegun, N.B.S. AMS-55, eqs. 20.3.30.

C     THIS FUNCTION GIVES AN APPROXIMATION FOR LARGE VALUES OF Q
C     FROM ABRAMOWITZ AND STEGUN, N.B.S. AMS-55 EQ. 20.3.30

      REAL*8 ALARGEQ

      W = 2.D0*IR + 1.D0
      W2 = W**2
      W4 = W2*W2
      W6 = W4*W2
      D0 = (W2 + 3.D0) / (4.D0*W)
      D1 = (5.D0 + 34.D0/W2 + 9.D0/W4) / 4.D0
      D2 = (33.D0 + 410.D0/W2 + 405.D0/W4) / (4.D0*W)
      D3 = (63.D0 + 1260.D0/W2 + 2943.D0/W4 + 486.D0/W6) / W2
      D4 = (527.D0 + 15617.D0/W2 + 69001.D0/W4 + 41607.D0/W6) / (W*W2)
      T5SQRTP = 32.D0 * SQRT(Q) / W2

      ALARGEQ = -2.D0*Q + 2.D0*W*SQRT(Q) - (W2+1.D0)/8.D0
     1         - D0/T5SQRTP - D1/T5SQRTP**2
     2         - D2/T5SQRTP**3 - D3/T5SQRTP**4 - D4/T5SQRTP**5

      RETURN
      END


C**********************************************************************C
      FUNCTION AINIT (Q, ICOEF)

C     This function calculates the first zero in the continued fraction
C     equations.  These are A0, A1, B2, and B1 for ICOEF = 1 to 4 respectively.
C     It calls ASMALLQ or ALARGEQ according to the size of Q.  Its principal
C     contribution is to figure out which one to call.

      IMPLICIT REAL*8 (A-H,O-Z)

      Q2 = Q**2
      IF (ICOEF.EQ.1)  THEN                       ! CALCULATE A0
          IF (Q.LT.1.75D0)  THEN
              AINIT = ASMALLQ (Q, 0)
          ELSE
              AINIT = ALARGEQ (Q, 0)
          END IF

      ELSE IF (ICOEF.EQ.2)  THEN                  ! CALCULATE A1
          IF (Q.LT.4.D0)  THEN
              AINIT = ASMALLQ (Q, 1)
          ELSE
              AINIT = ALARGEQ (Q, 1)
          END IF

      ELSE IF (ICOEF.EQ.3)  THEN                  ! CALCULATE B2
          IF (Q.LT.6.D0)  THEN
              AINIT = ASMALLQ (Q,-2)
          ELSE
              AINIT = ALARGEQ (Q, 1)
          END IF

      ELSE IF (ICOEF.EQ.4)  THEN                  ! CALCULATE B1
          IF (Q.LT.4.D0)  THEN
              AINIT = ASMALLQ (Q ,-1)
          ELSE
              AINIT = ALARGEQ (Q,0)
          END IF
      END IF
      RETURN
      END


C**********************************************************************C
      SUBROUTINE SEARCH (Y, X, Q, IC, XDEL, IFLIP)

C     ZERO CROSSING ROUTINE, SEARCH FOR A ZERO CROSSING FIRST BY STEPPING
C     UNTIL THE ZERO IS BRACKETED AND THEN USE A COMBINATION OF STEPPING 
C     AND REGULA-FALSI METHOD TO FIND THE ZERO.   
C     Modified zero crossing routine.  It begins by seaching for the next
C     zero using a simple step search.  When the zero has been bracketed it
C     uses a regula-falsi followed by an "accelerator" in alteration.  The
C     acclerator consists of dividing the remaining interval by a 10 from
C     the point just found by regula-falsi, it should take care of functions
C     which are ill conditioned for regula-falsi.
C     Parameters in the call:
C         Y is the external function to be evalueated.
C         X is the initial estimate of the zero location, returned as the
C           location of the zero.
C         Q and IC are parameters of the function Y.
C         XDEL is the step size, it may be changed by this routine.
C         IFLIP if equal to one means the direction of the search may be 
C           in the step search.

      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (PRECR=1.D-15, PRECA=1.D-35)
      EXTERNAL Y

      X0 = X
      X  = X + XDEL
      Y0 = Y (X0, Q, IC)
      Y1 = Y (X, Q, IC)
      IF (ABS(Y1).GT.ABS(Y0) .AND. IFLIP.EQ.1)  THEN
          XT = X0
          X0 = X
          X  = XT
          YT = Y0
          Y0 = Y1
          Y1 = YT
          XDEL = -XDEL
      END IF

C   * SEARCH FOR ZERO CROSSING LOOP *

      DO 10 I = 1,1000
      IF (Y1*Y0.LE.0.0D0)  GO TO 15
      X0 = X
      Y0 = Y1
      X = X0 + XDEL
      Y1 = Y (X, Q, IC)
   10 CONTINUE

C   * SEARCH FAILED *

      WRITE (6,12) X0, Y0, X, Y1, XDEL
   12   FORMAT ( ' SEARCH ROUTINE FAILED AFTER 1000 ITERATIONS', /
     1           ' X0, Y0 =', 1PE17.10, ', ',E17.10, /
     2           ' X1, Y1 =', E17.10, ', ',E17.10, /
     3           ' XDEL =', E17.10)
      STOP 'SEARCH FAILURE'

C   * CROSSED A ZERO - USE REGULA FALSI AND AN ACCELERATOR 
C                                                 THE REST OF THE WAY *

   15 YZ = Y1
      DO 20 ICOUNT = 1, 100
      IF ((ABS(X-X0).LE.ABS(X0)*PRECR) .OR.
     1                         (ABS(YZ).LE.PRECA))  GO TO 30
      XZ = X0 - (X-X0) * Y0 / (Y1-Y0)             ! REGULA FALSI
      YZ = Y (XZ, Q, IC)
      IF (SIGN(1.D0,YZ).EQ.SIGN(1.D0,Y1))  THEN
          X = XZ
          Y1 = YZ
      ELSE
          X0 = XZ
          Y0 = YZ
      END IF

      XDEL = (X - X0) / 2.D0                      ! DIVIDE INTERVAL IN HALF
      X2 = (X + X0) / 2.D0
      IF (X2.EQ.X0 .OR. X2.EQ.X)  GO TO 30
      Y2 = Y (X2, Q, IC)

      IF (SIGN(1.D0,Y2).EQ.SIGN(1.D0,Y1))  THEN
          X  = X2
          Y1 = Y2
      ELSE
          X0 = X2
          Y0 = Y2
      END IF
   20 CONTINUE
      IF ((ABS(X-X0).LE.ABS(X0)*PRECR) .OR.
     1                         (ABS(YZ).LE.PRECA))  GO TO 30

      WRITE (6,25) X0, X, Y0, Y1, ICOUNT
   25    FORMAT ('    X0, X1:', 1PE17.10, ', ',E17.10, /
     1           '    Y0, Y1:', E17.10, ', ',E17.10, /
     1           '    ICOUNT =', I5 )
      STOP 'SEARCH FAILURE'

   30 CONTINUE
CD     WRITE (6,35) X, X0, Y1, Y0, ICOUNT
CD  35    FORMAT ('       X, X0:', 1PE17.10, ', ',E17.10, /
CD    1           '       Y, Y0:', E17.10, ', ',E17.10, /
CD    2           '       ICOUNT =', I5 )
      IF (ABS(Y0).LT.ABS(Y1))  THEN
          X = X0
          Y1 = Y0
      END IF
      RETURN
      END

      PROGRAM PLOTFIELD

C     Produces a shade plot
C     Use the option 'RF' for a FOM plot

#include "fgl.h"

      INTEGER SHDFIL, PRTFIL
      PARAMETER ( PLPFIL = 1, PRTFIL = 6, SHDFIL = 35,
     &   MAXNSD = 501, MAXNRD = 4096, MAXNR = 4094, MAXNRZ = 500000 )

      LOGICAL SEG, SMOOTHFL, GRIDFL, COLFL, FINAL, PEAKFL, SNAPFL
      INTEGER WINIDENT
      REAL    R( MAXNR ), SD( MAXNSD), RD( MAXNRD ), TL( MAXNRZ ),
     &        CVEC( 2 * MAXNRZ)
      CHARACTER TITLE*80, TITLEX*80, TITLEY*80, TITLEZ*80,
     &        OPTION*80, COORD*10, FILNAM*80,
     &        DEVCOL*9, PLTTYP*10

      DATA GRIDFL, COLFL, SMOOTHFL, FINAL, PEAKFL, BARFL, SNAPFL
     &     / 7 * .FALSE. /

C     *** Read in user input ***

      OPEN( FILE = 'PLPFIL', UNIT = PLPFIL, STATUS = 'OLD' )

      READ( PLPFIL, * ) OPTION
      READ( PLPFIL, * ) COORD
      READ( PLPFIL, * ) DEVCOL
      READ( PLPFIL, * ) ISEG
      READ( PLPFIL, * ) DR3DB
      READ( PLPFIL, * ) NPLOTS

      IF (  COORD(3:3) .EQ. 'G' )   GRIDFL = .TRUE. ! Plot grid
      IF ( DEVCOL(4:4) .EQ. 'C' )    COLFL = .TRUE. ! Color flag
      IF ( DEVCOL(5:5) .EQ. 'S' ) SMOOTHFL = .TRUE. ! Smooth color cell
      IF ( DEVCOL(6:6) .EQ. 'F' )    FINAL = .TRUE. ! Final labels
      IF ( DEVCOL(7:7) .EQ. 'P' )   PEAKFL = .TRUE. ! Box around peak
      IF ( DEVCOL(8:8) .NE. 'N' )    BARFL = .TRUE. ! Draw color bar
      IF ( DEVCOL(9:9) .EQ. 'S' )   SNAPFL = .TRUE. ! Take snapshot

C     *** Window size ***

      IF      ( NPLOTS .EQ. 1 ) THEN
         CALL PREFPO( 0,  850, 5,  900 )
C        CALL PREFPO( 0,  650, 5,  350 )
      ELSE IF ( NPLOTS .EQ. 2 ) THEN
         CALL PREFPO( 0,  850, 5,  900 )
      ELSE IF ( NPLOTS .EQ. 3 ) THEN
         CALL PREFPO( 0,  750, 5,  988 )
      ELSE IF ( NPLOTS .EQ. 4 ) THEN
         CALL PREFPO( 0, 1260, 5,  988 )
      ELSE IF ( NPLOTS .EQ. 5 ) THEN
         CALL PREFPO( 0, 1260, 5,  988 )
      ELSE
         CALL PREFPO( 0, 1260, 5,  988 )
      END IF

      CALL FOREGR()
      WINIDENT = WINOPE( 'PLOTFIELD', 9 )
C     CALL RGBMOD()      ! Use RGB mode instead of default (map)

      CALL ONEMAP()
      CALL CMODE()
      CALL GCONFI()
      CALL WINSET( WINIDENT )
      CALL GFLUSH()

C     --- set foreground/background
C      READ( 78, * ) ICOL, IRED, IGREEN, IBLUE
C      CALL MAPCOL(  ICOL, IRED, IGREEN, IBLUE )
C      READ( 78, * ) ICOL, IRED, IGREEN, IBLUE
C      CALL MAPCOL(  ICOL, IRED, IGREEN, IBLUE )
C      CALL SYSTEM( "makemap" )  ! ensure color table loaded

      CALL COLOR( BLACK )
      CALL COLOR( WHITE )

      CALL CLEAR()

C     *** Axis labels ***

      IF ( OPTION(2:2) .EQ. 'F' ) THEN
         TITLEX = 'Figure of Merit (dB)$'
         TITLEY = 'Depth (m)$'
         TITLEZ = 'Radius (km)$'
      ELSE
         TITLEX = 'r (km)$'
         TITLEY = 'z (m)$'
         IF ( OPTION(2:2) .EQ. 'L' ) THEN
            TITLEZ = ' $'
         ELSE
            TITLEZ = 'dB$'
         END IF
      END IF

C     *** Loop over plot number ***

      DO IPLOT = 1, NPLOTS

C     ------ Get source depth and plot window info
      READ( PLPFIL, *, END = 9500 ) FILNAM, SRCD
C     --- Append the extension '.shd' to the filename
      JJ = INDEX( FILNAM, ' ' )
      FILNAM( JJ:JJ+3 ) = '.shd'

      XAXL = 0.0
      YAXL = 0.0
      READ( PLPFIL, * ) XMIN, XMAX, XINC, XAXL, TITLEX
      READ( PLPFIL, * ) YMIN, YMAX, YINC, YAXL, TITLEY

C     *** Read header ***

      CALL RDHEAD( SHDFIL, FILNAM, MAXNR, MAXNSD, MAXNRD,
     &   FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &   SD, NSD, RD, NRD, TITLE )

      IF ( NRD .LE. 1 ) CALL ERROUT( PRTFIL, 'F', 'PLOTFIELD',
     &                  'The number of receiver depths must be > 1' )

C     ------ FOM plots don't need conversion to km
      IF ( OPTION(2:2) .NE. 'F' ) THEN
         DO J = 1, NR
            R( J ) = R( J ) / 1000.0
         END DO
      ENDIF

C     *** Calculate source depth index ***

      ISD = NEIGH( SRCD, SD, NSD )

C     --- Check to see if within tolerance

      IF ( FREQ .EQ. 0.0 ) THEN
         TOL = 0.001
      ELSE
         TOL = 1500.0 / ( 6.0 * FREQ )  ! one wavelength
      ENDIF

      IF ( ABS( SD( ISD ) - SRCD ) .GT. TOL ) THEN
         WRITE( PRTFIL, * ) 'Sources exist at the following depths:'
         WRITE( PRTFIL, * ) ( SD( I ), I = 1, NSD )
         CALL ERROUT( PRTFIL, 'F', 'PLOTFIELD',
     &                'No source at specified depth' )
      ENDIF

C     Check program has enough space for the field

      NRZ = NRD * NR
      IF ( NRZ .GT. MAXNRZ ) THEN
         WRITE( PRTFIL, * ) 'NRZ = ', NRZ, '  MAXNRZ = ', MAXNRZ
         CALL ERROUT( PRTFIL, 'F', 'PLOTFIELD',
     &                'Too many field points' )
      ENDIF

C     *** Read and smooth the surface ********************************

      CALL READSURF( XMIN, XMAX, YMIN, YMAX,
     &   RD, NRD, R, NR, DELTAR, ISD, OPTION, DR3DB,
     &   TL, RMINT, ZMINT, TLMINT, RMAXT, ZMAXT, TLMAXT )

C     For snapshot, scale the field to have unit maximum

      IF ( SNAPFL ) THEN
        TLT = MAX( ABS( TLMINT ), ABS( TLMAXT ) )

        SCALE = 1.0
        IF ( TLT .GT. 0.0 ) SCALE = 1.0 / TLT

        DO JJ = 1, NRD * NR
           TL( JJ ) = SCALE * TL( JJ )
        END DO

        TLMINT = -0.9
        TLMAXT =  0.9
      ENDIF

      TLMIN = 0.0
      TLMAX = 0.0
      READ( PLPFIL, * ) TLMIN, TLMAX, DELTL, TITLEZ

C     Autoscale?

      IF ( TLMIN .EQ. 0.0 .AND. TLMAX .EQ. 0.0 ) THEN
         TLMIN = TLMAXT
         TLMAX = TLMINT
        tlmax = tlmin - 5.0
      ENDIF

C     *** Plot one of the subplots ***

      CALL PLOTONE( R, RD, TL, TITLE,
     &   COORD, IPLOT, NPLOTS,
     &   CVEC, NR, NRD,
     &   XMIN, XMAX, XINC, XAXL, XOR, TITLEX,
     &   YMIN, YMAX, YINC, YAXL, YOR, TITLEY,
     &   TLMIN, TLMAX, TLINC, TITLEZ,
     &   SMOOTHFL, GRIDFL, COLFL, FINAL, PEAKFL, BARFL, SNAPFL,
     &   SRCD, TLT, FREQ, PLTTYP, XS, YS, THETA,
     &   RMAXT, ZMAXT )

      END DO    ! Next plot

 9500 CONTINUE

      CALL GFLUSH()   ! flush graphics buffer

      IF ( DEVCOL(1:1) .EQ. 'S' ) THEN
C        CALL SYSTEM( "scrsave plotfield.rgb 40, 680,  50,  530" )
C        CALL SYSTEM( "scrsave plotfield.rgb 40, 360,  50,  290" )
C        CALL SYSTEM( "scrsave plotfield.rgb 0, 650,  5,  350" )
C        CALL SYSTEM( "scrsave plotfield.rgb 30, 620, 15,  795" )
         CALL SYSTEM( "scrsave plotfield.rgb 10, 1060, 55,  950" )
C        CALL SYSTEM( "scrsave plotfield.rgb 10, 600,  65,  800" )

      ELSE
         WRITE( *, * ) 'Type return to continue'
         READ( *, 9999 ) JUNK
 9999    FORMAT( A1 )
      END IF

      END

C-----------------------------------------------------------------------

      SUBROUTINE READSURF( XMIN, XMAX, YMIN, YMAX,
     &   RD, NRD, R, NR, DELTAR, ISD, OPTION, DR3DB,
     &   TL, RMINT, ZMINT, TLMINT, RMAXT, ZMAXT, TLMAXT )

C     *** Read pressure surfaces and convert to smoothed TL ***

      INTEGER SHDFIL, PRTFIL
      PARAMETER ( PRTFIL = 6, SHDFIL = 35, MAXNR = 4094 )

      REAL    RD( * ), R( * ), TL( * ), TLRAW( MAXNR ), TLSM( MAXNR )
      COMPLEX P( MAXNR )
      CHARACTER OPTION*80

      TLMINT =  1.0E9
      TLMAXT = -1.0E9

      IREC =  6 + NRD * ( ISD - 1 )

      DO I = 1, NRD
         IREC = IREC + 1
         READ( SHDFIL, REC = IREC ) ( P( J ), J = 1, NR )

         DO J = 1, NR

            IF ( OPTION(2:2) .EQ. 'L' .OR. OPTION(2:2) .EQ. 'F' ) THEN
C              ------ Linear scale
               PSQ = REAL( P( J ) )
               IF ( OPTION(1:1) .EQ. 'S' ) THEN
                  TLRAW( J ) = SQRT( 1000.0 * R( J ) ) * PSQ
               ELSE
                  TLRAW( J ) = PSQ
               ENDIF
            ELSE
C              ------ dB scale
               PSQ = P( J ) * CONJG( P( J ) )
               IF ( OPTION(1:1) .EQ. 'S' ) PSQ = 1000.0 * R( J ) * PSQ

               TLRAW( J ) = 200.0
               IF ( PSQ .GT. 1.0E-20 ) TLRAW( J ) = -10.0 *ALOG10( PSQ )
            ENDIF

         END DO   ! Next range

C        *** Smooth ***

         NROWS = 1
         CALL SMOOTH( TLRAW, TLSM, NROWS, 1, NR, DELTAR, DR3DB )

C        ------ Copy smoothed data in matrix
         DO J = 1, NR
            JJ = ( I - 1 ) * NR + J
            TL( JJ ) = TLSM( J )

C           --- check point is in plot window
            IF ( ABS( R(  J ) - XMIN ) + ABS( R(  J ) - XMAX )
     &       .LE. 1.001 * ABS( XMAX - XMIN ) .AND.
     &           ABS( RD( I ) - YMIN ) + ABS( RD( I ) - YMAX )
     &       .LE. 1.001 * ABS( YMAX - YMIN ) ) THEN

            IF ( TL( JJ ) .GT. TLMAXT ) THEN   ! log maximum
               TLMAXT = TL( JJ )
               RMAXT  = R(   J )
               ZMAXT  = RD(  I )
            END IF

            IF ( TL( JJ ) .LT. TLMINT ) THEN   ! log minimum
               TLMINT = TL( JJ )
               RMINT  = R(   J )
               ZMINT  = RD(  I )
            END IF
            END IF

         END DO   ! next range J

      END DO   ! Next depth IRD

      CLOSE( SHDFIL )

      WRITE( *, * ) 'R, Z, MAX = ', RMAXT, ZMAXT, TLMAXT
      WRITE( *, * ) 'R, Z, MIN = ', RMINT, ZMINT, TLMINT
      WRITE( *, * )

      RETURN
      END

C-----------------------------------------------------------------------

      SUBROUTINE PLOTONE( R, RD, TL, TITLE,
     &   COORD, IPLOT, NPLOTS,
     &   CVEC, NR, NRD,
     &   XMIN, XMAX, XINC, XAXL, XOR, TITLEX,
     &   YMIN, YMAX, YINC, YAXL, YOR, TITLEY,
     &   ZMIN, ZMAX, ZINC, TITLEZ,
     &   SMOOTHFL, GRIDFL, COLFL, FINAL, PEAKFL, BARFL, SNAPFL,
     &   SRCD, TLT, FREQ, PLTTYP, XS, YS, THETA,
     &   XMAXPOS, YMAXPOS )

C     Plots one of the subplots on a page

#include "fgl.h"

      PARAMETER ( NPLT = 10 )

      LOGICAL SMOOTHFL, GRIDFL, COLFL, FIRST, FINAL, PEAKFL, BARFL,
     &   SNAPFL
      REAL R( * ), RD( * ), TL( * )
      REAL XORM( NPLT ), YORM( NPLT ), XAXLM( NPLT ), YAXLM( NPLT )
      CHARACTER TITLE*80, TITLEX*80, TITLEY*80, TITLEZ*80, TITLE2*80,
     &          COORD*10, PLTTYP*10
      CHARACTER ABC*10

      SAVE FIRST
      DATA FIRST /.TRUE./
      DATA ABC /'abcdefghij'/

C     Default size in cm

C      DATA XORM  /  1.0,  1.0,  1.0,  1.0, 0.2,  0.2 /  ! X origin
C      DATA YORM  /  1.0,  1.0,  1.0,  0.0, 1.0,  1.0 /  ! Y origin
C      DATA XAXLM / 20.0, 20.0, 14.0, 12.0,15.0, 15.0 /  ! x-size
C      DATA YAXLM / 10.0, 10.0,  6.0,  6.0, 7.5,  7.5 /  ! y-size

      DATA XORM  /  1.0,  1.0,  1.0,  1.0,  1.0, 5*0.2 /       ! X origin
      DATA YORM  /  1.0,  1.0,  1.0,  0.0,  1.0,  1.0, 4*0.2 / ! Y origin
      DATA XAXLM / 20.0, 20.0, 14.0, 12.0, 15.0, 15.0, 4*8.0 / ! x-size
      DATA YAXLM / 10.0, 10.0,  6.0,  6.0,  7.5,  7.5, 4*5.0 / ! y-size

C     Calculate size of plot

      IF ( XAXL .EQ. 0.0 ) XAXL = XAXLM( NPLOTS )
      IF ( YAXL .EQ. 0.0 ) YAXL = YAXLM( NPLOTS )

C     Convert to pixels

      PIXCM = 40.0       ! Roughly 40 pixels/cm (98 pixels/inch)

      NFULL = NPLOTS - MOD( NPLOTS, 3 )   ! # plots in full columns

      XOR = PIXCM * ( XORM( NPLOTS ) +
     &               ( IPLOT - 1 ) / 3 * XAXL )

      IF ( IPLOT .LE. NFULL ) THEN
         YOR = PIXCM * ( YORM( NPLOTS ) +
     &          (2 - MOD( IPLOT - 1, 3 ) ) * YAXL )
      ELSE
         YOR = PIXCM * ( YORM( NPLOTS ) +
     &          ( NPLOTS - IPLOT ) * YAXL )
      ENDIF

      XAXL = PIXCM * XAXL
      YAXL = PIXCM * YAXL

      IF ( NPLOTS .GE. 5 .AND. IPLOT .GE. 4 ) THEN
C        XOR = 2.0 * XOR + XAXL
         XOR = XOR - PIXCM * 3.0   ! shift left
      ENDIF

C      IF ( NPLOTS .GE. 5 .AND. IPLOT .LE. 3 ) THEN
C         YOR = PIXCM * YORM( NPLOTS ) + ( 3 - IPLOT ) * YAXL
C      ENDIF

C     *** Titles ***

         IF ( SNAPFL ) THEN
C            WRITE( TITLE2, 8000 ) SRCD, TLT
C 8000       FORMAT( 'Time = ', F6.4, '  Max = ', F4.2, '$' )
            WRITE( TITLE2, 8000 ) SRCD
 8000       FORMAT( 'Time = ', F5.3, '$' )

         ELSE IF ( PLTTYP(1:5) .EQ. 'POLAR' ) THEN
            WRITE( TITLE2, 9001 ) FREQ, SRCD, THETA
 9001       FORMAT( 'FREQ = ', F4.0, '    Sd = ', F4.0,
     &              '   Rd = ', F4.0, '$' )

         ELSE IF ( PLTTYP(1:5) .EQ. 'CARTE' ) THEN
            WRITE( TITLE2, 9002 ) FREQ, SRCD, THETA
 9002       FORMAT( 'FREQ = ', F4.0, '    Sd = ', F4.0,
     &              '   Bearing = ', F4.0, '$' )
         ELSE IF ( PLTTYP(1:5) .EQ. 'OCEAN' ) THEN
            WRITE( TITLE2, 9003 ) SRCD
 9003       FORMAT( 'Depth = ', F4.0, '$' )
         ELSE
            WRITE( TITLE2, 9004 ) FREQ, SRCD
 9004       FORMAT( 'FREQ = ', G9.4, '    Sd = ', G9.4, '$' )
            TITLE2 = ' $'   ! suppress label
         ENDIF

      IF ( FINAL ) THEN
         IF ( NPLOTS .GT. 1 ) THEN
            TITLE = '  '
C            WRITE( TITLE, 7000 ) ABC( IPLOT:IPLOT )
 7000       FORMAT( '(', A1, ')' )
         ENDIF
      END IF

      FIRST = .FALSE.

C     *** Do the plot ***

      IF ( COORD(1:2) .EQ. 'PO' ) THEN
C        --- polar coordinates

         TITLEX = 'X (km)$'
         TITLEY = 'Y (km)$'

         CALL PLOTPO( CVEC, TL, R, NR, RD, NRD,
     &      XMIN, XMAX, XINC, XAXL, XOR, TITLEX,
     &      YMIN, YMAX, YINC, YAXL, YOR, TITLEY,
     &      XS, YS, ZMIN, ZMAX, TITLE, TITLE2 )
      ELSE
C        --- cartesian coordinates
         CALL PLOTCA( CVEC, TL, R, NR, RD, NRD,
     &      XMIN, XMAX, XINC, XAXL, XOR, TITLEX,
     &      YMIN, YMAX, YINC, YAXL, YOR, TITLEY,
     &      ZMIN, ZMAX, TITLE, TITLE2, TITLEZ,
     &      XMAXPOS, YMAXPOS, PEAKFL, BARFL )
      ENDIF

      RETURN
      END

C-----------------------------------------------------------------------

      SUBROUTINE PLOTCA( CVEC, F, X, NX, Y, NY,
     &   XMIN, XMAX, XINC, XAXL, XOR, TITLEX,
     &   YMIN, YMAX, YINC, YAXL, YOR, TITLEY,
     &   FMIN, FMAX, TITLE1, TITLE2, TITLEZ,
     &   XMAXPOS, YMAXPOS, PEAKFL, BARFL )

C     Routine to plot a rectangular grid of numbers
C     Note F is loaded as F( NX, NY )

#include "fgl.h"

      LOGICAL PEAKFL, BARFL
      INTEGER FIRST, LAST
      REAL F( NX, * ), CVEC( 2, NX, * ), X( * ), Y( * ), XY( 2 )
      CHARACTER ALABEL*10, TITLEX*80, TITLEY*80, TITLE1*80, TITLE2*80,
     &          TITLEZ*80

C     Viewport size

      IX1P = XOR
      IX2P = XOR + XAXL
      IY1P = YOR
      IY2P = YOR + YAXL

      CALL VIEWPO( IX1P, IX2P, IY1P, IY2P )

      BORDERXL = 0.15 * ( XMAX - XMIN ) * ( 600.0 / XAXL )
      BORDERXR = 0.40 * ( XMAX - XMIN ) * ( 600.0 / XAXL )
      BORDERY  = 0.20 * ( YMAX - YMIN ) * ( 320.0 / YAXL )

      CALL ORTHO2( XMIN - BORDERXL, XMAX + BORDERXR,
     &             YMAX + BORDERY , YMIN - BORDERY ) ! flip vertically

      CALL READMAP( FIRST, LAST, NCOLS )   ! *** Read the color map ***
C     CALL SHADEM( FLAT )   ! not Gouraud shading

C     *** Construct vectors with xy-coordinates ***

      DO IY = 1, NY
         DO IX = 1, NX
            CVEC( 1, IX, IY ) = X( IX  )
            CVEC( 2, IX, IY ) = Y( IY  )
         END DO
      END DO

      DO IX = 1, NX - 1

C        --- check X( IX ) in [XMIN, XMAX]
         IF ( ABS( X( IX ) - XMIN ) + ABS( X( IX ) - XMAX )
     &       .LE. 1.001 * ABS( XMAX - XMIN ) ) THEN

         CALL BGNTME()    ! Vertices of a triangular mesh
         DO IY = 1, NY

C        --- check Y( IY ) in [YMIN, YMAX]
         IF ( ABS( Y( IY ) - YMIN ) + ABS( Y( IY ) - YMAX )
     &       .LE. 1.001 * ABS( YMAX - YMIN ) ) THEN

            ICOL = FIRST + 0.5 +
     &        ( F( IX, IY )   - FMIN ) * ( NCOLS - 1 ) / ( FMAX - FMIN )
            ICOL = MAX( FIRST, ICOL )
            ICOL = MIN( LAST,  ICOL )

            CALL COLOR( ICOL )
            CALL V2F( CVEC( 1, IX,     IY    ) )

            ICOL = FIRST + 0.5 +
     &        ( F( IX+1, IY ) - FMIN ) * ( NCOLS - 1 ) / ( FMAX - FMIN )
            ICOL = MAX( FIRST, ICOL )
            ICOL = MIN( LAST,  ICOL )

            CALL COLOR( ICOL )
            CALL V2F( CVEC( 1, IX + 1, IY    ) )
         END IF

         END DO
         CALL ENDTME()
         END IF
      END DO

C     *** Draw rectangle around peak ***

      IF ( PEAKFL ) THEN
         SIZEX = ABS( XMAX - XMIN ) / 20.0
         SIZEY = ABS( YMAX - YMIN ) / 20.0

         CALL LINEWI( 3 )
         CALL COLOR( BLACK )
         CALL RECT( XMAXPOS - SIZEX, YMAXPOS - SIZEY,
     &              XMAXPOS + SIZEX, YMAXPOS + SIZEY )
         CALL LINEWI( 1 )
      END IF

C     *** Frame ***

      CALL COLOR( BLACK )

      CALL BGNLIN()
      CALL V2FXY( XMIN, YMIN )
      CALL V2FXY( XMAX, YMIN )
      CALL V2FXY( XMAX, YMAX )
      CALL V2FXY( XMIN, YMAX )
      CALL V2FXY( XMIN, YMIN )
      CALL ENDLIN()
 
C     *** X-axis ***

      WRITE( ALABEL, 9001 ) XMIN   ! NINT( XMIN )
      CALL CMOV2( XMIN, YMAX + 0.5 * BORDERY )
      CALL CHARST( ALABEL, 9 )

      WRITE( ALABEL, 9001 ) XMAX   ! NINT( XMAX )
      CALL CMOV2( XMAX - 0.5 * BORDERXL, YMAX + 0.5 * BORDERY )
      CALL CHARST( ALABEL, 9 )

      ILEN = INDEX( TITLEX, '$' ) - 1
      CALL CMOV2( XMIN + 0.4 * ( XMAX - XMIN ),
     &            YMAX + 0.5 * BORDERY )
      CALL CHARST( TITLEX, ILEN )

C     *** Y-axis ***

      WRITE( ALABEL, 9002 ) NINT( YMIN )
      CALL CMOV2( XMIN - 0.7 * BORDERXL, YMIN )
      CALL CHARST( ALABEL, 9 )

      WRITE( ALABEL, 9002 ) NINT( YMAX )
      CALL CMOV2( XMIN - 0.7 * BORDERXL, YMAX )
      CALL CHARST( ALABEL, 9 )

      ILEN = INDEX( TITLEY, '$' ) - 1
      CALL CMOV2( XMIN - BORDERXL, 0.5 * ( YMIN + YMAX ) )
      CALL CHARST( TITLEY, ILEN )

 9001 FORMAT( F4.2 )
 9002 FORMAT( I4 )

C     *** Plot title ***

      ILEN = 80
      CALL CMOV2( XMIN, YMIN - 0.5 * BORDERY )
      CALL CHARST( TITLE1, ILEN )

      ILEN = INDEX( TITLE2, '$' ) - 1
      CALL CMOV2( XMIN, YMIN - 0.1 * BORDERY )
      CALL CHARST( TITLE2, ILEN )

C     *** Draw color bar ***

      IF ( BARFL )
     &   CALL COLORBAR( XMIN, YMIN, XMAX, YMAX, NCOLS, FIRST, LAST,
     &              BORDERXR, FMIN, FMAX, TITLEZ )

      RETURN
      END

C**********************************************************************C

      SUBROUTINE PLOTPO( CVEC, F, X, NX, Y, NY,
     &   XMIN, XMAX, XINC, XAXL, XOR, TITLEX,
     &   YMIN, YMAX, YINC, YAXL, YOR, TITLEY,
     &   XS, YS, FMIN, FMAX, TITLE1, TITLE2 )

C     Routine to plot a rectangular grid of numbers
C     Note F is loaded as F( NX, NY )

#include "fgl.h"

      PARAMETER( DEGRAD = 3.141592 / 180.0 )

      INTEGER FIRST, LAST
      REAL F( NX, * ), CVEC( 2, NX, * ), X( * ), Y( * ), XY( 2 )
      CHARACTER ALABEL*10, TITLEX*80, TITLEY*80, TITLE1*80, TITLE2*80

C     Viewport size

      IX1P = XOR
      IX2P = XOR + XAXL
      IY1P = YOR
      IY2P = YOR + YAXL

      CALL VIEWPO( IX1P, IX2P, IY1P, IY2P )

      BORDERX = 0.30 * ABS( XMAX - XMIN )
      BORDERY = 0.25 * ABS( YMAX - YMIN )

      CALL ORTHO2( XMIN - BORDERX, XMAX + BORDERX,
     &             YMIN - BORDERY, YMAX + BORDERY ) ! flip vertically

      CALL READMAP( FIRST, LAST, NCOLS )   ! *** Read the color map ***
      CALL COLOR( WHITE )

C     *** Construct vectors with xy-coordinates ***
C     ( X is a range and Y is an angle )

      DO IY = 1, NY
         DO IX = 1, NX
            XT = XS + X( IX ) * COS( DEGRAD * Y( IY ) )
            YT = YS + X( IX ) * SIN( DEGRAD * Y( IY ) )

            XT = MIN( XT, XMAX )
            CVEC( 1, IX, IY ) = MAX( XT, XMIN )

            YT = MIN( YT, YMAX )
            CVEC( 2, IX, IY ) = MAX( YT, YMIN )
         END DO
      END DO

      DO IX = 1, NX - 1

         CALL BGNTME()    ! Vertices of a triangular mesh

         DO IY = 1, NY


            ICOL = FIRST + 0.5 +
     &        ( F( IX, IY )   - FMIN ) * ( NCOLS - 1 ) / ( FMAX - FMIN )
            ICOL = MAX( FIRST, ICOL )
            ICOL = MIN( LAST,  ICOL )

            CALL COLOR( ICOL )
            CALL V2F( CVEC( 1, IX    , IY ) )

            ICOL = FIRST + 0.5 +
     &        ( F( IX+1, IY ) - FMIN ) * ( NCOLS - 1 ) / ( FMAX - FMIN )
            ICOL = MAX( FIRST, ICOL )
            ICOL = MIN( LAST,  ICOL )

            CALL COLOR( ICOL )
            CALL V2F( CVEC( 1, IX + 1, IY ) )

         END DO
         CALL ENDTME()
      END DO

C     *** Frame ***

C     CALL COLOR( WHITE )
      CALL COLOR( BLACK )

      CALL BGNLIN()
         CALL V2FXY( XMIN, YMIN )
         CALL V2FXY( XMAX, YMIN )
         CALL V2FXY( XMAX, YMAX )
         CALL V2FXY( XMIN, YMAX )
         CALL V2FXY( XMIN, YMIN )
      CALL ENDLIN()
 
C     *** X-axis ***

      WRITE( ALABEL, 9001 ) XMIN
      CALL CMOV2( XMIN, YMIN - 0.5 * BORDERY )
      CALL CHARST( ALABEL, 9 )

      WRITE( ALABEL, 9001 ) XMAX
      CALL CMOV2( XMAX - 0.5 * BORDERX, YMIN - 0.5 * BORDERY )
      CALL CHARST( ALABEL, 9 )

      ILEN = INDEX( TITLEX, '$' ) - 1
      CALL CMOV2( 0.5 * ( XMIN + XMAX ), YMIN - 0.5 * BORDERY )
      CALL CHARST( TITLEX, ILEN )

C     *** Y-axis ***

      WRITE( ALABEL, 9001 ) YMIN
      CALL CMOV2( XMIN - 0.7 * BORDERX, YMIN )
      CALL CHARST( ALABEL, 9 )

      WRITE( ALABEL, 9001 ) YMAX
      CALL CMOV2( XMIN - 0.7 * BORDERX, YMAX )
      CALL CHARST( ALABEL, 9 )

      ILEN = INDEX( TITLEY, '$' ) - 1
      CALL CMOV2( XMIN - BORDERX, 0.5 * ( YMIN + YMAX ) )
      CALL CHARST( TITLEY, ILEN )

 9001 FORMAT( F5.0 )

C     *** Plot title ***

      ILEN = 80
      CALL CMOV2( XMIN, YMAX + 0.5 * BORDERY )
      CALL CHARST( TITLE1, ILEN )

      ILEN = INDEX( TITLE2, '$' ) - 1
      CALL CMOV2( XMIN, YMAX + 0.1 * BORDERY )
      CALL CHARST( TITLE2, ILEN )

C     *** Color bar ***

      CALL BGNTME()    ! Vertices of a triangular mesh

      DO ICOL = FIRST, LAST
         CALL COLOR( ICOL )

         XY( 1 ) = XMAX + 0.3 * BORDERX
         XY( 2 ) = YMAX - ( ICOL - FIRST + 1 ) * ( YMAX - YMIN ) / NCOLS
         CALL V2F( XY )

         XY( 1 ) = XMAX + 0.6 * BORDERX
         XY( 2 ) = YMAX - ( ICOL - FIRST + 1 ) * ( YMAX - YMIN ) / NCOLS
         CALL V2F( XY )
      END DO

      CALL ENDTME()

C     *** Labels for color bar ***

C     CALL COLOR( WHITE )
      CALL COLOR( BLACK )

      WRITE( ALABEL, 9002 ) FMIN
      CALL CMOV2( XMAX + 0.7 * BORDERX, YMAX  )
      CALL CHARST( ALABEL, 9 )

      WRITE( ALABEL, 9002 ) FMAX
      CALL CMOV2( XMAX + 0.7 * BORDERX, YMIN  )
      CALL CHARST( ALABEL, 9 )

 9002 FORMAT( F4.0 )

      CALL CMOV2( XMAX + 0.7 * BORDERX, 0.5 * ( YMIN + YMAX ) )
      CALL CHARST( ' dB', 3 )

      RETURN
      END


C**********************************************************************C

      SUBROUTINE COLORBAR( XMIN, YMIN, XMAX, YMAX, NCOLS, FIRST, LAST,
     &   BORDERXR, FMIN, FMAX, TITLEZ )

C     Draws the color bar

#include "fgl.h"

      INTEGER FIRST, LAST
      REAL XY( 2 )
      CHARACTER ALABEL*10, TITLEZ*80

      DATA ICOUNT / 0 /

      ICOUNT = ICOUNT + 1
C     IF ( ICOUNT .LT. 4 ) RETURN   ! color bar for last figure only

      CALL BGNTME()    ! Vertices of a triangular mesh

      DO ICOL = FIRST, LAST
         CALL COLOR( ICOL )

         XY( 1 ) = XMAX + 0.2 * BORDERXR
         XY( 2 ) = YMIN + ( ICOL - FIRST + 1 ) * ( YMAX - YMIN ) / NCOLS
         CALL V2F( XY )

         XY( 1 ) = XMAX + 0.4 * BORDERXR
         XY( 2 ) = YMIN + ( ICOL - FIRST + 1 ) * ( YMAX - YMIN ) / NCOLS
         CALL V2F( XY )
      END DO

      CALL ENDTME()

C     *** Labels for color bar ***

      CALL COLOR( WHITE )
      CALL COLOR( BLACK )

      WRITE( ALABEL, 9002 ) NINT( FMIN )
      IF ( FMIN .EQ. 0.0 ) ALABEL = ' 0'
      CALL CMOV2( XMAX + 0.5 * BORDERXR, YMIN  )
      CALL CHARST( ALABEL, 9 )

      WRITE( ALABEL, 9002 ) NINT( FMAX )
      IF ( FMAX .EQ. 0.0 ) ALABEL = ' 0'
      CALL CMOV2( XMAX + 0.5 * BORDERXR, YMAX  )
      CALL CHARST( ALABEL, 9 )

 9001 FORMAT( G8.3 )  ! ***
 9002 FORMAT( I4 ) ! G9.3  ! ***

      ILEN = INDEX( TITLEZ, '$' ) - 1
      CALL CMOV2( XMAX + 0.5 * BORDERXR, 0.5 * ( YMIN + YMAX ) )
      CALL CHARST( TITLEZ, ILEN )

      RETURN
      END

C**********************************************************************C

     SUBROUTINE V2FXY( X, Y )

C     Calls V2F for a point (x,y)

      REAL CVEC( 2)

      CVEC( 1 ) = X
      CVEC( 2 ) = Y

      CALL V2F( CVEC )

      RETURN
      END

C**********************************************************************C

      SUBROUTINE READMAP( FIRST, LAST, NCOLS )

C     *** Read and load the color map ***

      PARAMETER( MAPFIL = 77 )

      INTEGER FIRST, LAST

      FIRST = 9999
      LAST  = 1

      OPEN( FILE = 'MAPFIL', UNIT = MAPFIL, STATUS = 'OLD' )
      DO I = 1, 9999
         READ( MAPFIL, *, END = 700 ) ICOL, IRED, IGREEN, IBLUE
         CALL MAPCOL( ICOL, IRED, IGREEN, IBLUE )
         FIRST = MIN( ICOL, FIRST )
         LAST  = MAX( ICOL, LAST  )
      END DO

  700 CLOSE( MAPFIL )
      NCOLS = LAST - FIRST + 1

      CALL SYSTEM( "makemap" )  ! ensure color table loaded

      RETURN
      END

      PROGRAM PLANEWAVE

C     Makes a planewave covariance matrix

      INTEGER COVFIL
      COMPLEX CI
      PARAMETER ( COVFIL = 6, MAXNRD = 4094, MXPHONES = 50,
     &   PI = 3.141592, CI = ( 0.0, 1.0 ), DEGRAD = PI / 180.0 )

      REAL    RD( MAXNRD ), K0
      COMPLEX D( MXPHONES ), COV( MXPHONES, MXPHONES )
      CHARACTER TITLE*80

C     *** Read covariance matrix ***

      C0    = 1500.0

      WRITE( *, * ) ' Frequency? '
      READ( *, * ) FREQ

      WRITE( *, * ) 'Declination angle?'
      READ( *, * ) THETA

      RD( 3 ) = -999.9
      WRITE( *, * ) 'NRD, RD( 1), ...'
      READ( *, * ) NRD, ( RD( IRD ) , IRD = 1, NRD )
      CALL SUBTAB( RD, NRD )

      WRITE( TITLE, 1000 ) INT( FREQ ), INT( THETA )
 1000 FORMAT( '''Planewave,  ', I2, ' Hz, ', I3, ' degrees''' )

      K0    = 2.0 * PI * FREQ / C0
      THETA = THETA * DEGRAD

      WRITE( COVFIL, * ) TITLE(1:60)
      WRITE( COVFIL, * ) FREQ
      WRITE( COVFIL, * ) NRD

      IF ( NRD .GT. MXPHONES ) STOP "NRD > MXPHONES"

      NORMD = 0.0
      DO IRD = 1, NRD
         WRITE( COVFIL, * ) RD( IRD )
         D( IRD ) = EXP( CI * K0 * RD( IRD ) * SIN( THETA ) )
         NORMD = NORMD + D( IRD ) * CONJG( D( IRD ) )
      END DO

      DO I = 1, NRD
         DO J = 1, NRD
            COV( I, J ) = NRD * D( I ) * CONJG( D( J ) ) / NORMD
            WRITE( COVFIL, * ) I, J, COV( I, J )
         END DO
      END DO

      STOP
      END

      SUBROUTINE PREENV( X, N )

C     Forms the pre-envelope of the function
C     Real( X( N ) ) is the input time series
C     The output vector is complex
C     N must be a power of 2 and <16384

      COMPLEX X( * )

C     Check N is a power of 2

      IF ( N .LE. 0 )
     &   STOP 'FATAL ERROR in BNDPAS: N must be positive'

      NT = 2**( INT( LOG10(REAL(N)) / 0.30104 ) +1 )
      IF ( NT .NE. N )
     &   STOP 'FATAL ERROR in BNDPAS: N must be a power of 2'

C     *** Fourier transform ***

      CALL CFFT( X, N, 1 )
      CALL CFFTSC( X, N )

C     *** Zero-out the negative spectrum (the upper N/2 positions) ***

      DO I = N/2+1, N
         X( I ) = 0.0
      END DO

C      CALL VCLR( X(N/2+1), 1, N )  ! VCLR expects a real vector

C     *** Inverse Fourier transform ***

      CALL CFFT( X, N, -1 )

      RETURN
      END

      SUBROUTINE READIN( TITLE, FREQ, MAXMED, NMEDIA,
     &   TOPOPT, CPT, CST, RHOT, BUMDEN, ETA, XI, NG, SIGMA, DEPTH, 
     &   BOTOPT, CPB, CSB, RHOB,
     &   ENVFIL, PRTFIL )

C     Reads in the info in ENVFIL

      IMPLICIT NONE

      INTEGER MAXSSP

      PARAMETER ( MAXSSP = 2001 )

      INTEGER ENVFIL, PRTFIL, NMEDIA, NG( * ), MAXMED,
     &   NELTS, MED
      REAL*8 ALPHAR, BETAR, ALPHAI, BETAI, RHOR, FREQ, RHOT, RHOB,
     &   SIGMA( * ), DEPTH( * ),
     &   BUMDEN, ETA, XI, RHO( 1 ), C, DELTAZ
      COMPLEX*16 CPT, CST, CPB, CSB, CP( MAXSSP ), CS( MAXSSP )
      CHARACTER TOPOPT*( * ), BOTOPT*( * ), TITLE*( * ),
     &   SSPTYP*1, ATUNIT*1, BCTYPE*1

      COMMON /CPREV/ ALPHAR, BETAR, RHOR, ALPHAI, BETAI

C     OPEN ( FILE = 'ENVFIL', UNIT = ENVFIL, STATUS = 'OLD',
C    &       FORM = 'FORMATTED' )

      ALPHAR = 1500.0
      BETAR  = 0.0
      RHOR   = 1.0
      ALPHAI = 0.0
      BETAI  = 0.0

C     *** Title, Freq, Nmedia ***

      READ(  ENVFIL, * ) TITLE(9:80)
      WRITE( PRTFIL, * ) TITLE

      READ( ENVFIL, * ) FREQ
      READ( ENVFIL, * ) NMEDIA

      WRITE( PRTFIL, 1000 ) FREQ, NMEDIA
 1000 FORMAT( ' Frequency = ', G11.4, ' NMEDIA = ', I3, // )

      IF ( NMEDIA .GT. MAXMED ) THEN
         WRITE( PRTFIL, * ) 'MAXMED = ', MAXMED
         CALL ERROUT( PRTFIL, 'F', 'READIN', 'Too many media' )
      ENDIF

C     ******** TOP OPTIONS ********

      READ( ENVFIL, * ) TOPOPT(1:8)
C      CALL STR$UPCASE( TOPOPT, TOPOPT )

      SSPTYP(1:1) = TOPOPT(1:1)
      BCTYPE(1:1) = TOPOPT(2:2)
      ATUNIT(1:1) = TOPOPT(3:3)

C     *** SSP approximation options ***

      IF ( TOPOPT(1:1) .EQ. 'N' ) THEN 
         WRITE( PRTFIL, * ) '    N2-LINEAR approximation to SSP'

      ELSE IF ( TOPOPT(1:1) .EQ. 'C' ) THEN 
         WRITE( PRTFIL, * ) '    C-LINEAR approximation to SSP'

      ELSE IF ( TOPOPT(1:1) .EQ. 'S' ) THEN 
         WRITE( PRTFIL, * ) '    SPLINE approximation to SSP'

      ELSE IF ( TOPOPT(1:1) .EQ. 'A' ) THEN 
         WRITE( PRTFIL, * ) '    ANALYTIC SSP option'

      ELSE
         CALL ERROUT( PRTFIL, 'F', 'READIN',
     &                'Unknown option for SSP approximation' )
      ENDIF

C     *** Attenuation options ***

      IF ( TOPOPT(3:3) .EQ. 'N' ) THEN 
         WRITE( PRTFIL, * ) '    Attenuation units: nepers/m'

      ELSE IF ( TOPOPT(3:3) .EQ. 'F' ) THEN 
         WRITE( PRTFIL, * ) '    Attenuation units: dB/mkHz'

      ELSE IF ( TOPOPT(3:3) .EQ. 'M' ) THEN 
         WRITE( PRTFIL, * ) '    Attenuation units: dB/m'

      ELSE IF ( TOPOPT(3:3) .EQ. 'W' ) THEN 
         WRITE( PRTFIL, * ) '    Attenuation units: dB/wavelength'

      ELSE IF ( TOPOPT(3:3) .EQ. 'Q' ) THEN 
         WRITE( PRTFIL, * ) '    Attenuation units: Q'

      ELSE IF ( TOPOPT(3:3) .EQ. 'T' ) THEN 
         WRITE( PRTFIL, * ) '    THORP attenuation added'

      ELSE
         CALL ERROUT( PRTFIL, 'F', 'READIN',
     &                'Unknown attenuation units' )
      ENDIF

C     *** CALL TOPBOT  to read top BC ***

      IF ( BCTYPE(1:1) .EQ. 'A' ) WRITE( PRTFIL, 2000 )
 2000 FORMAT( //, '      Z          ',
     &      'ALPHAR     BETAR      RHO       ALPHAI     BETAI', / )

      CALL TOPBOT( ENVFIL, PRTFIL, FREQ, BCTYPE, ATUNIT,
     &   CPT, CST, RHOT, BUMDEN, ETA, XI )

C     ****** Internal media ******

      IF ( BCTYPE(1:1) .NE. 'A' ) WRITE( PRTFIL, 2000 )

      DO MED = 1, NMEDIA
         READ(  ENVFIL, *    ) NG( MED ), SIGMA( MED ), DEPTH( MED + 1 )
         WRITE( PRTFIL, 3000 ) NG( MED ), SIGMA( MED )
 3000    FORMAT( /, '          ( Number of pts = ', I5, 
     &                  '  RMS roughness = ', G10.3, ' )')

C        *** Call PROFIL to read in SSP ***

         CALL PROFIL( DEPTH, CP, CS, RHO, MED, NELTS,
     &      FREQ, SSPTYP, ATUNIT, 'INIT', ENVFIL, PRTFIL  )

C        *** automatic calculation of f.d. mesh (10 pts/wavelength) ***
         IF ( NG( MED ) .EQ. 0 ) THEN
            C = alphar
            IF ( betar .GT. 0.0 ) C = betar ! shear?

            DELTAZ = 0.02 * C / FREQ
            NG( MED ) = ( DEPTH( MED + 1 ) - DEPTH( MED ) ) / DELTAZ
            WRITE( PRTFIL, * ) 'Number of pts = ', NG( MED )
         ENDIF

      END DO   ! next MED

C     ****** Bottom properties ******

      READ( ENVFIL, * ) BOTOPT(1:8), SIGMA( NMEDIA + 1 )
C      CALL STR$UPCASE( BOTOPT, BOTOPT )
      BCTYPE(1:1) = BOTOPT(1:1)

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, 5000 ) SIGMA( NMEDIA + 1 )
 5000 FORMAT( 33X, '( RMS roughness = ', G10.3, ' )' )

C     *** CALL TOPBOT  to read bottom BC ***

      CALL TOPBOT( ENVFIL, PRTFIL, FREQ, BCTYPE, ATUNIT,
     &    CPB, CSB, RHOB, BUMDEN, ETA, XI )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE TOPBOT( ENVFIL, PRTFIL, FREQ, BCTYPE, ATUNIT,
     &   CPHS, CSHS, RHOHS, BUMDEN, ETA, XI )

C     Handles top and bottom boundary conditions
C
C     Input:
C         ENVFIL: Environmental file
C         PRTFIL: Print file
C         FREQ:   Frequency
C         BCTYPE: Boundary condition type
C
C     Output:
C        CPHS:    P-wave speed in halfspace
C        CSHS:    S-wave speed in halfspace
C        RHOHS:   density in halfspace
C
C        BUMDEN:  Bump density
C        ETA:     Principal radius 1
C        XI:      Principal radius 2

      IMPLICIT NONE

      INTEGER ENVFIL, PRTFIL
      REAL*8 ALPHAR, BETAR, ALPHAI, BETAI, RHOR, FREQ, RHOHS,
     &   BUMDEN, ETA, XI, ZTMP
      COMPLEX*16 CPHS, CSHS, CRCI
      CHARACTER BCTYPE*1, ATUNIT*1

      COMMON /CPREV/ ALPHAR, BETAR, RHOR, ALPHAI, BETAI

C     *** Echo to PRTFIL user's choice of boundary condition ***

      IF ( BCTYPE(1:1) .EQ. 'S' ) THEN
         WRITE( PRTFIL, * ) '    Twersky SOFT BOSS scatter model'

      ELSE IF ( BCTYPE(1:1) .EQ. 'H' ) THEN 
         WRITE( PRTFIL, * ) '    Twersky HARD BOSS scatter model'

      ELSE IF ( BCTYPE(1:1) .EQ. 'T' ) THEN 
         WRITE( PRTFIL, * ) '    Twersky (amplitude only) SOFT BOSS ', 
     &                                       'scatter model'

      ELSE IF ( BCTYPE(1:1) .EQ. 'I' ) THEN 
         WRITE( PRTFIL, * ) '    Twersky (amplitude only) HARD BOSS ', 
     &                                       'scatter model'

      ELSE IF ( BCTYPE(1:1) .EQ. 'V' ) THEN 
         WRITE( PRTFIL, * ) '    VACUUM'

      ELSE IF ( BCTYPE(1:1) .EQ. 'R' ) THEN 
         WRITE( PRTFIL, * ) '    Perfectly RIGID'

      ELSE IF ( BCTYPE(1:1) .EQ. 'A' ) THEN
         WRITE( PRTFIL, * ) '    ACOUSTO-ELASTIC half-space'

      ELSE IF ( BCTYPE(1:1) .EQ. 'F' ) THEN 
         WRITE( PRTFIL, * ) '    FILE used for reflection loss'

      ELSE IF ( BCTYPE(1:1) .EQ. 'W' ) THEN 
         WRITE( PRTFIL, * ) '    Writing an IRC file'

      ELSE IF ( BCTYPE(1:1) .EQ. 'P' ) THEN
         WRITE( PRTFIL, * ) '    reading PRECALCULATED IRC'

      ELSE
         CALL ERROUT( PRTFIL, 'F', 'TOPBOT',
     &                'Unknown boundary condition type' )
      ENDIF

C     ****** Read in BC parameters depending on particular choice ******

      CPHS  = 0.0
      CSHS  = 0.0
      RHOHS = 0.0

C     *** Twersky ice model parameters ***

      IF ( BCTYPE(1:1) .EQ. 'S' .OR. BCTYPE(1:1) .EQ. 'H' .OR.
     &     BCTYPE(1:1) .EQ. 'T' .OR. BCTYPE(1:1) .EQ. 'I' ) THEN

         READ(  ENVFIL, *    ) BUMDEN, ETA, XI
         WRITE( PRTFIL, 1000 ) BUMDEN, ETA, XI
 1000    FORMAT( /, ' Twersky ice model parameters:', /, 
     &   ' Bumden = ', G15.6, '  Eta = ', G11.3, '  Xi = ', G11.3, /)
      ENDIF

C     *** Half-space properties ***

      IF ( BCTYPE(1:1) .EQ. 'A' ) THEN

         READ(  ENVFIL, *    ) ZTMP, ALPHAR, BETAR, RHOR, ALPHAI, BETAI
         WRITE( PRTFIL, 2000 ) ZTMP, ALPHAR, BETAR, RHOR, ALPHAI, BETAI
 2000    FORMAT( F10.2, 3X, 2F10.2, 3X, F6.2, 3X, 2F10.4 )

         CPHS = CRCI( ALPHAR, ALPHAI, FREQ, ATUNIT )
         CSHS = CRCI( BETAR,  BETAI,  FREQ, ATUNIT )
         RHOHS = RHOR

      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE PROFIL( DEPTH, CP, CS, RHOT, MED, N1,
     &   FREQ, SSPTYP, ATUNIT, TASK, ENVFIL, PRTFIL  )

C     Call the particular SSP routine specified by SSPTYP

C     PROFIL is expected to perform two tasks:
C        TASK = 'TAB'  then tabulate CP, CS, RHOT 
C        TASK = 'INIT' then initialize

C     Note that FREQ is only need if TASK = 'INIT'

      IMPLICIT REAL*8 (A-H, O-Z)
      INTEGER ENVFIL, PRTFIL

      REAL*8     RHOT( * ), DEPTH( * )
      COMPLEX*8  CPT, CST
      COMPLEX*16 CP( * ), CS( * )
      CHARACTER  SSPTYP*1, ATUNIT*1, TASK*8

      IF ( SSPTYP(1:1) .EQ. 'A' ) THEN

C        *** Analytic profile option ***
         IF ( TASK(1:4) .EQ. 'INIT' ) THEN
            N1 = 21
            CALL ANALYT( DEPTH, CP, CS, RHOT,
     &                                     MED, N1, FREQ, ATUNIT, TASK )
            H = ( DEPTH( MED+1 ) - DEPTH( MED ) ) / ( N1 - 1 )

            DO I = 1, N1
               Z = DEPTH( MED ) + ( I - 1 ) * H
C              --- for f77/f90 compatibility in AIMAG/DIMAG:
               CPT =  CP( I )
               CST =  CS( I )
               WRITE( PRTFIL, 2000 ) Z,  REAL( CPT ),  REAL( CST ),
     &                         RHOT(I), AIMAG( CPT ), AIMAG( CST )
 2000          FORMAT( F10.2, 3X, 2F10.2, 3X, F6.2, 3X, 2F10.4 )
            END DO
         ELSE
            CALL ANALYT( DEPTH, CP, CS, RHOT,
     &                                     MED, N1, FREQ, ATUNIT, TASK )
         ENDIF

      ELSEIF ( SSPTYP(1:1) .EQ. 'N' ) THEN
C        *** N2-linear profile option ***
         CALL N2LIN(  DEPTH, CP, CS, RHOT, MED, N1,
     &                FREQ, ATUNIT, TASK, ENVFIL, PRTFIL )

      ELSEIF ( SSPTYP(1:1) .EQ. 'C' ) THEN
C        *** C-linear profile option ***
         CALL CLIN(   DEPTH, CP, CS, RHOT, MED, N1,
     &                FREQ, ATUNIT, TASK, ENVFIL, PRTFIL )

      ELSEIF ( SSPTYP(1:1) .EQ. 'S' ) THEN
C        *** Cubic spline profile option ***
         CALL CCUBIC( DEPTH, CP, CS, RHOT, MED, N1,
     &                FREQ, ATUNIT, TASK, ENVFIL, PRTFIL )

      ELSE
C        *** Non-existent profile option ***
         WRITE( PRTFIL, * ) 'Profile option: ', SSPTYP(1:1)
         CALL ERROUT( PRTFIL, 'F', 'PROFIL',
     &                'Unknown profile option' )

      ENDIF

      RETURN
      END
C**********************************************************************C
      FUNCTION CRCI( C, ALPHA, FREQ, ATUNIT )

C     Converts real wave speed and attenuation to a single
C     complex wave speed (with positive imaginary part)

C     6 CASES:    N for Nepers/meter
C                 M for dB/meter      (M for Meters)
C                 F for dB/m-kHZ      (F for Frequency dependent)
C                 W for dB/wavelength (W for Wavelength)
C                 Q for Q
C                 T for Thorp

      IMPLICIT REAL*8 (A-H, O-Z)
      COMPLEX*16 CRCI
      CHARACTER ATUNIT*1

      OMEGA = 2.0 * 3.1415926535897932D0 * FREQ

C     *** Convert to Nepers/m ***

      ALPHAT = 0.0

      IF ( ATUNIT(1:1) .EQ. 'N' ) THEN
         ALPHAT = ALPHA

      ELSE IF ( ATUNIT(1:1) .EQ. 'M' ) THEN
         ALPHAT = ALPHA / 8.6858896D0

      ELSE IF ( ATUNIT(1:1) .EQ. 'F' ) THEN
         ALPHAT = ALPHA * FREQ / 8685.8896D0

      ELSE IF ( ATUNIT(1:1) .EQ. 'W' ) THEN
         IF ( C .NE. 0.0 ) ALPHAT = ALPHA * FREQ / ( 8.6858896D0 * C )

C        --- the following lines give f^1.25 frequency dependence
C        FAC = SQRT( SQRT( FREQ / 50.0 ) )
C        IF ( C .NE. 0.0 )
C     &      ALPHAT = FAC * ALPHA * FREQ / ( 8.6858896D0 * C )

      ELSE IF ( ATUNIT(1:1) .EQ. 'Q' ) THEN
         IF( C * ALPHA .NE. 0.0 ) ALPHAT = OMEGA / ( 2.0 * C * ALPHA )

      ELSE IF ( ATUNIT(1:1) .EQ. 'T' ) THEN
         F2 = ( FREQ / 1000.0 ) **2
         ALPHAT = 40.0 * F2 / ( 4100.0 + F2 ) + 0.1*F2 / ( 1.0 + F2 )

         ALPHAT = ALPHAT / 914.4D0                 ! dB / m
         ALPHAT = ALPHAT / 8.6858896D0             ! Nepers / m

      ENDIF

C     *** Convert Nepers/m to equivalent imaginary sound speed ***

      ALPHAT = ALPHAT * C**2 / OMEGA
      CRCI = CMPLX( C, ALPHAT )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE N2LIN( DEPTH, CP, CS, RHOT,
     &                  MED, N1, FREQ, ATUNIT, TASK, ENVFIL, PRTFIL )

C     Tabulate CP, CS, RHO for specified MED

C     Uses N2-linear segments for P and S-wave speeds
C     Uses rho-linear segments for density

      IMPLICIT REAL*8 (A-H, O-Z)
      INTEGER ENVFIL, PRTFIL
      PARAMETER ( MAXMED = 51, MAXSSP = 2001, PREC = 1.0E-6 )

      INTEGER LOC( MAXMED ), NPTS( MAXMED )
      REAL*8 DEPTH( * ), RHOT( * ), Z( MAXSSP ), RHO( MAXSSP )
      COMPLEX*16 CP( * ), CS( * ), ALPHA( MAXSSP ), BETA( MAXSSP ),
     &   N2BOT, N2TOP, CRCI
      CHARACTER ATUNIT*1, TASK*8

      SAVE Z, ALPHA, BETA, RHO, LOC, NPTS
      COMMON /CPREV/ ALPHAR, BETAR, RHOR, ALPHAI, BETAI

C     If TASK = 'INIT' then this is the first call and SSP is read.
C     Any other call is a request for SSP subtabulation.

      IF ( TASK(1:4) .EQ. 'INIT' ) THEN
C        ------ TASK 'INIT' for initialization

C        The variable LOC( MED ) points to the starting point for the
C        data in the arrays Z, ALPHA, BETA and RHO

         IF ( MED .EQ. 1 ) THEN
            LOC( MED ) = 0
         ELSE
            LOC( MED ) = LOC( MED - 1 ) + NPTS( MED - 1 )
         ENDIF
         ILOC = LOC( MED )

C        *** Read in data and convert attenuation to Nepers/m ***

         N1 = 1
         DO I = 1, MAXSSP
            READ( ENVFIL, *)      Z( ILOC + I ), ALPHAR, BETAR,
     &         RHOR, ALPHAI, BETAI
            WRITE( PRTFIL, 2000 ) Z( ILOC + I ), ALPHAR, BETAR,
     &         RHOR, ALPHAI, BETAI
 2000       FORMAT(F10.2, 3X, 2F10.2, 3X, F6.2, 3X, 2F10.4)

            ALPHA(ILOC + I) = CRCI( ALPHAR, ALPHAI, FREQ, ATUNIT )
            BETA( ILOC + I) = CRCI( BETAR,  BETAI,  FREQ, ATUNIT )
            RHO(  ILOC + I) = RHOR

C           ------ Did we read the last point?
            IF ( ABS( Z( ILOC + I ) - DEPTH( MED+1 ) ) .LT. PREC ) THEN
               NPTS( MED ) = N1
               IF ( MED .EQ. 1 ) DEPTH( 1 ) = Z( 1 )
               RETURN
            ENDIF

            N1 = N1 + 1
         END DO

C        ------ Fall through means too many points in the profile

         WRITE( PRTFIL, * ) 'Max. #SSP points: ', MAXSSP
         CALL ERROUT( PRTFIL, 'F', 'N2LIN',
     &                'Number of SSP points exceeds limit' )

      ELSE
C        ------ TASK = 'TABULATE'
         ILOC = LOC( MED )
         N    = N1 - 1
         H    = ( Z( ILOC + NPTS( MED ) ) - Z( ILOC + 1 ) ) / N
         LAY  = 1

         DO I = 1, N1
            ZT = Z( ILOC + 1 ) + ( I - 1 ) * H
C           ------ Make sure no overshoot
            IF ( I .EQ. N1 ) ZT = Z( ILOC + NPTS( MED ) )

 7000       IF ( ZT .GT. Z( ILOC + LAY + 1 ) ) THEN
               LAY = LAY + 1
               GO TO 7000
            ENDIF

            R = ( ZT - Z( ILOC + LAY ) ) / 
     &         ( Z( ILOC + LAY+1 ) - Z( ILOC + LAY ) )

C           ------ P-wave
            N2TOP   = 1.0 / ALPHA( ILOC + LAY     )**2
            N2BOT   = 1.0 / ALPHA( ILOC + LAY + 1 )**2
            CP( I ) = 1.0 / SQRT( ( 1.0 - R ) * N2TOP + R * N2BOT )

C           ------ S-wave
            IF ( BETA(ILOC + LAY) .NE. 0.0 ) THEN
               N2TOP   = 1.0 / BETA( ILOC + LAY     )**2
               N2BOT   = 1.0 / BETA( ILOC + LAY + 1 )**2
               CS( I ) = 1.0 / SQRT( ( 1.0 - R ) * N2TOP + R * N2BOT )
            ELSE
               CS( I ) = 0.0
            ENDIF

            RHOT( I ) = ( 1.0 - R ) * RHO( ILOC + LAY ) +
     &                            R * RHO( ILOC + LAY + 1 )
         END DO

      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE CLIN( DEPTH, CP, CS, RHOT,
     &                 MED, N1, FREQ, ATUNIT, TASK, ENVFIL, PRTFIL  )

C     Tabulate CP, CS, RHO for specified MED

C     Uses c-linear segments for P and S-wave speeds
C     Uses rho-linear segments for density

      IMPLICIT REAL*8 (A-H, O-Z)
      INTEGER ENVFIL, PRTFIL
      PARAMETER ( MAXMED = 51, MAXSSP = 2001, PREC = 1.0E-6 )

      INTEGER LOC( MAXMED ), NPTS( MAXMED )
      REAL*8 DEPTH( * ), RHOT( * ), Z( MAXSSP ), RHO( MAXSSP )
      COMPLEX*16 CP( * ), CS( * ), ALPHA( MAXSSP ), BETA( MAXSSP ), CRCI
      CHARACTER ATUNIT*1, TASK*8

      SAVE Z, ALPHA, BETA, RHO, LOC, NPTS
      COMMON /CPREV/ ALPHAR, BETAR, RHOR, ALPHAI, BETAI

C     If TASK = 'INIT' then this is the first call and SSP is read.
C     Any other call is a request for SSP subtabulation.

      IF ( TASK(1:4) .EQ. 'INIT' ) THEN
C        ------ TASK 'INIT' FOR INITIALIZATION
         NPTS( MED ) = N1

C        The variable LOC(MED) points to the starting point for the
C        data in the arrays Z, ALPHA, BETA and RHO

         IF ( MED .EQ. 1 ) THEN
            LOC( MED ) = 0
         ELSE
            LOC( MED ) = LOC( MED - 1 ) + NPTS( MED - 1 )
         ENDIF
         ILOC = LOC( MED )

C        *** Read in data and convert attenuation to Nepers/m ***

         N1 = 1
         DO I = 1, MAXSSP
            READ( ENVFIL, * )     Z( ILOC + I ), ALPHAR, BETAR,
     &         RHOR, ALPHAI, BETAI
            WRITE( PRTFIL, 2000 ) Z( ILOC + I ), ALPHAR, BETAR,
     &         RHOR, ALPHAI, BETAI
 2000       FORMAT( F10.2, 3X, 2F10.2, 3X, F6.2, 3X, 2F10.4 )

            ALPHA(ILOC + I) = CRCI( ALPHAR, ALPHAI, FREQ, ATUNIT )
            BETA( ILOC + I) = CRCI( BETAR,  BETAI,  FREQ, ATUNIT )
            RHO(  ILOC + I) = RHOR

C           ------ Did we read the last point?
            IF ( ABS( Z( ILOC + I ) - DEPTH( MED+1 ) ) .LT. PREC ) THEN
               NPTS( MED ) = N1
               IF ( MED .EQ. 1 ) DEPTH( 1 ) = Z( 1 )
               RETURN
            ENDIF

            N1 = N1 + 1
         END DO

C        ------ Fall through means too many points in the profile

         WRITE( PRTFIL, * ) 'Max. #SSP points: ', MAXSSP
         CALL ERROUT( PRTFIL, 'F', 'CLIN',
     &                'Number of SSP points exceeds limit' )

      ELSE
C        ------ TASK = 'TABULATE'
         ILOC = LOC( MED )
         N    = N1 - 1
         H    = ( Z( ILOC + NPTS( MED ) ) - Z( ILOC + 1 ) ) / N
         LAY  = 1

         DO I = 1, N1
            ZT = Z( ILOC + 1 ) + ( I - 1 ) * H
C           ------ Make sure no overshoot
            IF ( I .EQ. N1 ) ZT = Z( ILOC + NPTS( MED ) )

 7000       IF ( ZT .GT. Z( ILOC + LAY + 1 ) ) THEN
               LAY = LAY + 1
               GO TO 7000
            ENDIF

            R = ( ZT - Z( ILOC + LAY ) ) /
     &         ( Z( ILOC + LAY + 1 ) - Z( ILOC + LAY ) )
            CP(I)   = (1.0-R)*ALPHA(ILOC + LAY) + R*ALPHA(ILOC + LAY+1)
            CS(I)   = (1.0-R)* BETA(ILOC + LAY) + R* BETA(ILOC + LAY+1)
            RHOT(I) = (1.0-R)*  RHO(ILOC + LAY) + R*  RHO(ILOC + LAY+1)
         END DO
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE CCUBIC( DEPTH, CP, CS, RHOT,
     &                   MED, N1, FREQ, ATUNIT, TASK, ENVFIL, PRTFIL  )

C     Tabulate CP, CS, RHO for specified MED
C     using cubic spline interpolation

      IMPLICIT REAL*8 (A-H, O-Z)
      INTEGER ENVFIL, PRTFIL
      PARAMETER ( MAXMED = 51, MAXSSP = 2001, PREC = 1.0E-6 )

      INTEGER LOC( MAXMED ), NPTS( MAXMED )
      REAL*8 DEPTH( * ), Z( MAXSSP ), RHOT( * )
      COMPLEX*16 CP( * ), CS( * ), ESPLINE, CRCI,
     &    ALPHA( 4, MAXSSP ), BETA( 4, MAXSSP ), RHO( 4, MAXSSP )
      CHARACTER ATUNIT*1, TASK*8

      SAVE Z, ALPHA, BETA, RHO, LOC, NPTS
      COMMON /CPREV/ ALPHAR, BETAR, RHOR, ALPHAI, BETAI

C     If TASK = 'INIT' then this is the first call and SSP is read.
C     Any other call is a request for SSP subtabulation.

      IF ( TASK(1:4) .EQ. 'INIT' ) THEN
C        ------ Task 'INIT' for initialization
         NPTS( MED ) = N1

C        The variable LOC(MED) points to the starting point for the
C        data in the arrays Z, ALPHA, BETA and RHO

         IF ( MED .EQ. 1 ) THEN
            LOC( MED ) = 0
         ELSE
            LOC( MED ) = LOC( MED - 1 ) + NPTS( MED - 1 )
         ENDIF
         ILOC = LOC( MED )

C        *** Read in data and convert attenuation to Nepers/m ***

         N1 = 1

         DO I = 1, MAXSSP
            READ( ENVFIL, *)      Z( ILOC + I ), ALPHAR, BETAR,
     &         RHOR, ALPHAI, BETAI
            WRITE( PRTFIL, 2000 ) Z( ILOC + I ), ALPHAR, BETAR,
     &         RHOR, ALPHAI, BETAI
 2000       FORMAT(F10.2, 3X, 2F10.2, 3X, F6.2, 3X, 2F10.4)

            ALPHA(1, ILOC + I) = CRCI( ALPHAR, ALPHAI, FREQ, ATUNIT )
            BETA( 1, ILOC + I) = CRCI( BETAR,  BETAI,  FREQ, ATUNIT )
            RHO(  1, ILOC + I) = RHOR

C           ------ Did we read the last point?
            IF ( ABS( Z( ILOC + I ) - DEPTH(MED+1) ) .LT. PREC ) THEN
               NPTS( MED ) = N1
               IF ( MED .EQ. 1 ) DEPTH( 1 ) = Z( 1 )

C              *** Compute spline coefs ***

               IBCBEG = 0
               IBCEND = 0
               CALL CSPLINE( Z( ILOC + 1 ), ALPHA(1, ILOC + 1),
     &                       NPTS( MED ), IBCBEG, IBCEND, NPTS( MED ) )
               CALL CSPLINE( Z( ILOC + 1 ),  BETA( 1, ILOC + 1 ),
     &                       NPTS( MED ), IBCBEG, IBCEND, NPTS( MED ) )
               CALL CSPLINE( Z( ILOC + 1 ),   RHO( 1, ILOC + 1 ),
     &                       NPTS( MED ), IBCBEG, IBCEND, NPTS( MED ) )

               RETURN
            ENDIF

            N1 = N1 + 1
         END DO

C        ------ Fall through means too many points in the profile

         WRITE( PRTFIL, * ) 'Max. #SSP points: ', MAXSSP
         CALL ERROUT( PRTFIL, 'F', 'CCUBIC',
     &                'Number of SSP points exceeds limit' )

      ELSE
C        ------ Task = 'TABULATE'
         ILOC = LOC( MED )
         N    = N1 - 1
         H    = ( Z( ILOC + NPTS( MED ) ) - Z( ILOC + 1 ) ) / N
         LAY  = 1
         DO I = 1, N1
            ZT = Z( ILOC + 1 ) + ( I - 1 ) * H
C           ------ Make sure no overshoot
            IF ( I .EQ. N1 ) ZT = Z( ILOC + NPTS( MED ) )
 7000       IF ( ZT .GT. Z( ILOC + LAY + 1 ) ) THEN
               LAY = LAY + 1
               GO TO 7000
            ENDIF

            HSPLNE = ZT - Z( ILOC + LAY )

            CP(   I ) =        ESPLINE( ALPHA(1, ILOC + LAY), HSPLNE )
            CS(   I ) =        ESPLINE(  BETA(1, ILOC + LAY), HSPLNE )
            RHOT( I ) = DBLE( ESPLINE(   RHO(1, ILOC + LAY), HSPLNE ) )

         END DO
      ENDIF

      RETURN
      END

      PROGRAM BEAM3D

C     Gaussian beam tracing in three dimensions
C     Michael B. Porter

      IMPLICIT REAL ( A-H, O-Z )
      INTEGER BTPFIL, PRTFIL, RAYFIL
      COMPLEX CI
      PARAMETER ( BTPFIL = 5, PRTFIL = 6, RAYFIL = 21,
     &   PI = 3.14159265, CI = (0.0, 1.0), DEGRAD = PI / 180.0, 
     &   MAXNR = 1000, MAXNT = 50, MAXNRT = 50000 )

      REAL*4 R( MAXNR ), THETA( MAXNT )
      COMPLEX EPS1, EPS2
      COMPLEX*8 P( MAXNRT )
      CHARACTER TITLE*80, OPTION*8, OPT2*4

C     *** Begin by reading in control data ***

C      CALL SYS$GETTIME( TSTART, WTIME1 )
      READ( BTPFIL, * ) TITLE
      READ( BTPFIL, * ) OPTION
      READ( BTPFIL, * ) FREQ
      READ( BTPFIL, * ) ALPHA0, ALPHA1, NALPHA
      READ( BTPFIL, * ) BETA0, BETA1, NBETA
      READ( BTPFIL, * ) IBWIN
      READ( BTPFIL, * ) NSTEPS, DELTAS
      READ( BTPFIL, * ) EPMULT
      READ( BTPFIL, * ) ZS, ZR
      READ( BTPFIL, * ) THETA0, THETA1, NTHETA
      READ( BTPFIL, * ) R0, R1, NR
      READ( BTPFIL, * ) OPT2

C     ------ For Nx2D run beams must lie on rcvr radial
      IF ( OPT2 .EQ. 'NX2D' ) THEN
         BETA0 = THETA0
         BETA1 = THETA1
         NBETA = NTHETA
      ENDIF

      TITLE = 'BEAM'//OPT2//'- '//TITLE

C     *** Echo to print file ***

      WRITE( PRTFIL, 2000 ) TITLE, FREQ, ALPHA0, ALPHA1, NALPHA, 
     &   BETA0, BETA1, NBETA, IBWIN, 
     &   NSTEPS, DELTAS, EPMULT, ZS, ZR, 
     &   THETA0, THETA1, NTHETA, R0, R1, NR

 2000 FORMAT( ' ', A80, //, ' FREQ = ', G14.6, //, 
     &   ' BEAM FAN PARAMETERS:', /, 
     &   ' ALPHA0 = ', G14.6, ' ALPHA1 = ', G14.6, ' NALPHA = ', I5, /,
     & '  BETA0 = ', G14.6, '  BETA1 = ', G14.6, '  NBETA = ', I5, ///,
     &   ' IBWIN = ', I5, ///,
     &   ' NSTEPS = ', I5, ' DELTAS = ', G14.6, //,
     &  ' EPMULT = ', G14.6, //, ' ZS = ', G14.6, ' ZR = ', G14.6, ///,
     &   ' RECEIVER LINES:', /,
     &   ' THETA0 = ', G14.6, ' THETA1 = ', G14.6, ' NTHETA = ', I5, /
     &   '     R0 = ', G14.6, '     R1 = ', G14.6, ' NR = ', I5, /// )
      WRITE( PRTFIL, * ) 'SOLUTION TECHNIQUE:', OPT2

      IF ( OPTION( 1:1 ) .EQ. 'R' ) THEN
         WRITE( PRTFIL, * ) 'RAY FILE OPTION INVOKED'
         WRITE( RAYFIL ) TITLE, FREQ, NALPHA, NSTEPS
      ENDIF

      IF ( OPTION( 3:3 ) .EQ. 'D' ) THEN
         WRITE( PRTFIL, * ) '****** CURVATURE DOUBLING INVOKED'
      ENDIF
      WRITE( PRTFIL, * )

      R0 = 1000.0 * R0
      R1 = 1000.0 * R1
      IF ( R0 .EQ. 0.0 ) R0 = 1.0

      ALPHA0 = DEGRAD * ALPHA0
      ALPHA1 = DEGRAD * ALPHA1
      DALPHA = ( ALPHA1 - ALPHA0 ) / ( NALPHA - 1 )

      BETA0 = DEGRAD * BETA0
      BETA1 = DEGRAD * BETA1
      DBETA = 0.0
      IF ( NBETA .NE. 1 ) DBETA = ( BETA1 - BETA0 ) / ( NBETA - 1 )

      XS = 0.0
      YS = 0.0

C     *** Compute 'optimal' beam constant ***

      CALL SSP(XS, YS, ZS, C0, CX, CY, CZ, CXX, CYY, CZZ, CXY, CXZ, CYZ)
      OMEGA = 2.0 * PI * FREQ

C     ------ Space filling in far field:
      IF ( OPTION( 2:2 ) .EQ. 'F' ) THEN
         WRITE( PRTFIL, * ) 'SPACE FILLING BEAMS'
         HWIDTH1 = 2.0 / ( ( OMEGA / C0 ) * DALPHA )
         EPSOPT1 = PI * FREQ * HWIDTH1 **2
         IF ( NBETA .GT. 1 ) HWIDTH2 = 2.0/( ( OMEGA/C0 ) * DBETA )
         EPSOPT2 = PI*FREQ*HWIDTH2**2
      ENDIF

C     ------ Minimum width at R1
      IF ( OPTION( 2:2 ) .EQ. 'M' ) THEN
         WRITE( PRTFIL, * ) 'MINIMUM WIDTH BEAMS'
         HWIDTH = SQRT( 2.0 * C0 * R1 / OMEGA )
         EPSOPT1 =  PI * FREQ * HWIDTH **2
         EPSOPT2 =  EPSOPT1
      ENDIF

      EPS1 = EPMULT * CI * EPSOPT1
      EPS2 = EPMULT * CI * EPSOPT2

      WRITE( PRTFIL, * ) 'HWIDTH1 = ', HWIDTH1, 'HWIDTH2 = ', HWIDTH2
      WRITE( PRTFIL, * ) 'EPSOPT1 = ', EPSOPT1, 'EPSOPT2 = ', EPSOPT2
      WRITE( PRTFIL, * ) 'EPMULT = ', EPMULT

      DELTAR = ( R1 - R0 ) / ( NR - 1 )
      DO 5000 IR = 1, NR
         R( IR ) = R0 + ( IR - 1 ) * DELTAR
 5000 CONTINUE

      DTHETA = 0.0
      IF ( NTHETA .NE. 1 ) DTHETA = ( THETA1-THETA0 ) / ( NTHETA-1 )
      DO 6000 ITHETA = 1, NTHETA
         THETA( ITHETA ) = THETA0 + ( ITHETA - 1 ) * DTHETA
 6000 CONTINUE

      NSD = 1
      CALL HEADER( TITLE, ZS, NSD, THETA, NTHETA,
     &   R, NR, FREQ, ATTEN, 'POLAR', XS, YS, ZR )

C     *** Construct a fan of beams and their influence ***

      CALL FAN( ALPHA0, DALPHA, NALPHA, BETA0, DBETA, NBETA, IBWIN,
     &   THETA, NTHETA, R, NR, DELTAR, DELTAS, NSTEPS, XS, YS, ZS, 
     &   ZR, EPS1, EPS2, OMEGA, C0, OPTION, OPT2, P )

C      CALL SYS$GETTIME( TEND, WTIME2 )
      WRITE( PRTFIL, 9500 ) TEND - TSTART
 9500 FORMAT( /, ' CPU Time = ', G15.3 )

      STOP
      END
C**********************************************************************C
      SUBROUTINE FAN( ALPHA0, DALPHA, NALPHA, BETA0, DBETA, NBETA,
     &  IBWIN, THETA, NTHETA, R, NR, DELTAR, DELTAS, NSTEPS, XS, YS, ZS,
     &   ZR, EPS1, EPS2, OMEGA, C0, OPTION, OPT2, P )

C     Computes a fan of beams from the source and writes the shade file

      IMPLICIT REAL ( A-H, O-Z )
      PARAMETER ( PI = 3.14159265 )

      REAL THETA( * ), R( * )
      COMPLEX P( NTHETA, * ), CONST, EPS1, EPS2
      CHARACTER TITLE*80, OPTION*8, OPT2*4

C     ------ Zero out field matrix
      DO ITHETA = 1, NTHETA
         DO IR = 1, NR
            P( ITHETA, IR ) = 0.0
         END DO
      END DO

C     *** Trace successive beams ***

      DO 8000 IBETA = 1, NBETA

         DO 7000 IALPHA = 1, NALPHA
            ALPHA = ALPHA0 + ( IALPHA - 1 ) * DALPHA
            BETA  = BETA0  + ( IBETA  - 1 ) * DBETA

C           ------ 3D or Nx2D computation
            IF ( OPT2 .EQ. '3D' ) THEN
               CALL TRACE( XS, YS, ZS, ALPHA, BETA, EPS1, EPS2, 
     &            OMEGA, DELTAS, NSTEPS, OPTION )
            ELSE
               CALL TRACE2D( XS, YS, ZS, ALPHA, BETA, EPS1, EPS2, 
     &            OMEGA, DELTAS, NSTEPS, OPTION )
            ENDIF

C           ------ Optionally dump rays to a disk file
            IF ( OPTION( 1:1 ) .EQ. 'R' .AND. IBETA .EQ. 1 ) THEN
C               WRITE( RAYFIL ) ( XV( I ), ZV( I ), XIV( I ), ZETAV( I ), 
C     &            FV( I ), GV( I ), I = 1, NSTEPS )
            ENDIF

C           *** Compute contribution to field ***

            IF ( OPT2 .EQ. '3D' ) THEN
               CALL INFLU( ALPHA, IBWIN, ZR, THETA, NTHETA, R, NR, 
     &            DELTAR, P, NSTEPS, OMEGA )
            ELSE
               CALL INFLU2D( ALPHA, IBWIN, ZR, BETA, IBETA, NTHETA,
     &            R, NR, DELTAR, P, NSTEPS, OMEGA, EPS1, OPTION )
            ENDIF

 7000    CONTINUE
 8000 CONTINUE

C     *** Scale the complex pressure field ***

      IF ( OPT2 .EQ. '3D' ) THEN
         CONST = SQRT( EPS1 * EPS2 ) * OMEGA * DBETA * DALPHA/
     &      ( 2.0 * PI* ( SQRT( C0 ) ) **3 )
      ELSE
         CONST = SQRT( ABS( EPS1 ) * OMEGA * DALPHA**2/
     &      ( 2.0 * PI * C0 **2 ) )
      ENDIF

      DO ITHETA = 1, NTHETA
         DO IR = 1, NR
            IF ( OPT2 .EQ. '3D' ) THEN
               P( ITHETA, IR ) = CONST * P( ITHETA, IR )
            ELSE
               P( ITHETA, IR ) = CONST * P( ITHETA, IR )/SQRT( R( IR ) )
            ENDIF
         END DO
      END DO

C     *** Write the field to the shade file ***

      IREC = 6
      CALL WRTFLD( P, NTHETA, NR, IREC )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE TRACE( XS, YS, ZS, ALPHA, BETA, EPS1, EPS2,
     &   OMEGA, DELTAS, NSTEPS, OPTION )

C     Traces the beam corresponding to a particular take off angle

      IMPLICIT REAL ( A-H, O-Z )
      PARAMETER ( MAXN = 10003 , PI = 3.14159265 )

      COMMON /BEAM/XV, YV, ZV, XIV, ETAV, ZETAV, FV, GV, HV, DETQV,
     &   PHIV, TAUV, CV

      REAL    XV( MAXN ),    YV( MAXN ),    ZV( MAXN ),
     &       XIV( MAXN ),  ETAV( MAXN ), ZETAV( MAXN ),
     &      PHIV( MAXN ),  TAUV( MAXN ),    CV( MAXN )
      COMPLEX FV( MAXN ),    GV( MAXN ),    HV( MAXN ),
     &     DETPV( MAXN ), DETQV( MAXN ),
     &   F, G, H, DETP, DETQ, EPS1, EPS2
      CHARACTER OPTION*80

C     *** Initial conditions ***

      XV( 1 ) = XS
      YV( 1 ) = YS
      ZV( 1 ) = ZS

      CALL SSP( XV( 1 ), YV( 1 ), ZV( 1 ), C, CX, CY, CZ,
     &   CXX, CYY, CZZ, CXY, CXZ, CYZ )

      XIV(   1 ) = COS( ALPHA ) * COS( BETA ) / C
      ETAV(  1 ) = COS( ALPHA ) * SIN( BETA ) / C
      ZETAV( 1 ) = SIN( ALPHA ) / C

      FV( 1 ) = EPS2
      GV( 1 ) = EPS1
      HV( 1 ) = 0.0

      DETPV( 1 ) = 1.0
      DETQV( 1 ) = EPS1 * EPS2

      PHIV( 1 ) = 0.0
      TAUV( 1 ) = 0.0

C     *** Trace the beam ***

      I = 0
      DO 3000 ISTEP = 1, NSTEPS
         I = I + 1

C        *** Phase 1 of modified polygon method ( an Euler step ) ***

         CALL SSP( XV( I ), YV( I ), ZV( I ), C, CX, CY, CZ,
     &      CXX, CYY, CZZ, CXY, CXZ, CYZ )
         CV( I ) = C
         C2 = C * C

C        ------ Compute ray normals E1 and E2
         CALL RAYNOR( XIV( I ), ETAV( I ), ZETAV( I ), PHIV( I ), C, 
     &      E1X, E1Y, E1Z, E2X, E2Y, E2Z )

C        ------ Compute second partials of c along ray normals
         CALL VCALC( CXX, CXY, CXZ, CYY, CYZ, CZZ, E1X, E1Y, E1Z,
     &      E2X, E2Y, E2Z, CNN, CNM, CMM )

         STEP = DELTAS

C        ------ If crossing surface reduce step to land at surface
         Z = ZV( I ) + STEP * C * ZETAV( I )
         IF ( Z .LT. 0.0 ) STEP = -ZV( I ) / ( ZETAV( I ) * C )
         HSTEP = 0.5 * STEP

         X = XV( I ) + HSTEP * C *   XIV( I )
         Y = YV( I ) + HSTEP * C *  ETAV( I )
         Z = ZV( I ) + HSTEP * C * ZETAV( I )

         XI   = XIV( I )   - HSTEP * CX / C2
         ETA  = ETAV( I )  - HSTEP * CY / C2
         ZETA = ZETAV( I ) - HSTEP * CZ / C2

         F = FV( I ) + HSTEP * ( C*DETPV( I ) - ( CNN/C2 )*DETQV( I ) )
         G = GV( I ) + HSTEP * ( C*DETPV( I ) - ( CMM/C2 )*DETQV( I ) )
         H = HV( I ) + HSTEP * ( - ( CNM/C2 )*DETQV( I ) )

         DETP = DETPV( I ) + HSTEP / C2 * 
     &      ( -CMM*FV( I ) - CNN*GV( I ) + 2.0*CNM*HV( I ) )
         DETQ = DETQV( I ) + HSTEP * C * ( FV( I ) + GV( I ) )

         PHI = PHIV( I ) + HSTEP *( 1.0 / C ) * ZETAV( I )*
     &      ( ETAV( I )*CX-XIV( I )*CY )/( XIV( I )**2+ETAV( I )**2 )

C        *** Phase 2 of modified polygon method ***

         CALL SSP( X, Y, Z, C, CX, CY, CZ, CXX, CYY, CZZ, CXY, CXZ, CYZ)

         C2 = C * C

C        ------ Compute ray normals E1 and E2
         CALL RAYNOR( XI, ETA, ZETA, PHI, C, 
     &      E1X, E1Y, E1Z, E2X, E2Y, E2Z )

C        ------ Compute second partials of c along ray normals
         CALL VCALC( CXX, CXY, CXZ, CYY, CYZ, CZZ, E1X, E1Y, E1Z,
     &      E2X, E2Y, E2Z, CNN, CNM, CMM )

C        ------ If crossing surface reduce step to land at surface
         Z = ZV( I ) + STEP*C*ZETAV( I )
         IF ( Z .LE. 0.0 ) STEP = -1.00000001*ZV( I )/( ZETAV( I )*C )

         XV( I+1 ) = XV( I ) + STEP * C * XI
         YV( I+1 ) = YV( I ) + STEP * C * ETA
         ZV( I+1 ) = ZV( I ) + STEP * C * ZETA

         XIV( I+1 )   = XIV( I )   - STEP * CX / C2
         ETAV( I+1 )  = ETAV( I )  - STEP * CY / C2
         ZETAV( I+1 ) = ZETAV( I ) - STEP * CZ / C2

         FV( I+1 ) = FV( I ) + STEP * ( C*DETP - ( CNN/C2 )*DETQ )
         GV( I+1 ) = GV( I ) + STEP * ( C*DETP - ( CMM/C2 )*DETQ )
         HV( I+1 ) = HV( I ) + STEP * ( - ( CNM/C2 )*DETQ )

         DETPV( I+1 ) = DETPV( I ) + STEP / C2 * 
     &           ( -CMM*F - CNN*G + 2.0*CNM*H )
         DETQV( I+1 ) = DETQV( I ) + STEP * C * ( F + G )

         PHIV( I+1 ) = PHIV( I ) + STEP * ( 1.0 / C )*
     &      ZETA * ( ETA * CX - XI * CY ) / ( XI**2 + ETA**2 )

         TAUV( I+1 ) = TAUV( I ) + STEP / C

C        *** If reflecting off surface need jump conditions ***

         IF ( ZV( I+1 ) .LE. 0.0 ) THEN
            I = I + 1

               XV( I+1 ) =  XV( I )
               YV( I+1 ) =  YV( I )
               ZV( I+1 ) = -ZV( I )

              XIV( I+1 ) =    XIV( I )
             ETAV( I+1 ) =   ETAV( I )
            ZETAV( I+1 ) = -ZETAV( I )

            CALL SSP( XV( I+1 ), YV( I+1 ), ZV( I+1 ), C, CX, CY, CZ, 
     &         CXX, CYY, CZZ, CXY, CXZ, CYZ )
            CV( I ) = C

C           ------ Following is suspect
            RN1 = 0.0
            RN2 = 0.0
C            RN1 = -2.0*XIV(  I+1 )**2 / ZETAV( I+1 ) * CZ / C
C            RN2 = -2.0*ETAV( I+1 )**2 / ZETAV( I+1 ) * CZ / C

            IF ( OPTION( 3:3 ) .EQ. 'D' ) THEN
               RN1 = 2.0 * RN1
               RN2 = 2.0 * RN2
            ENDIF

            FV( I+1 ) = FV( I ) + DETQV( I ) * RN1
            GV( I+1 ) = GV( I ) + DETQV( I ) * RN1
            HV( I+1 ) = HV( I ) + DETQV( I ) * RN2

            DETPV( I+1 ) = DETPV( I )
            DETQV( I+1 ) = DETQV( I )

C           ------ What happens to torsion?
            PHIV( I+1 ) = PHIV( I )
            TAUV( I+1 ) = TAUV( I ) - PI / OMEGA
         ENDIF

 3000 CONTINUE

      RETURN
      END
C**********************************************************************C
      SUBROUTINE INFLU( ALPHA, IBWIN, ZR, THETA, NTHETA, R, NR, DELTAR,
     &   P, NSTEPS, OMEGA )

C     Computes the beam influence, i.e. 
C     the contribution of a single beam to the complex pressure

      IMPLICIT REAL ( A-H, O-Z )
      COMPLEX CI
      PARAMETER ( MAXN = 10003 , PI = 3.14159265, CI = ( 0.0, 1.0 ), 
     &   DEGRAD = PI / 180.0 )
      COMMON /BEAM/XV, YV, ZV, XIV, ETAV, ZETAV, FV, GV, HV, DETQV,
     &   PHIV, TAUV, CV

      INTEGER KMAHV( MAXN )

      REAL XV( MAXN ),   YV( MAXN ),    ZV( MAXN ),
     &    XIV( MAXN ), ETAV( MAXN ), ZETAV( MAXN ),
     &   PHIV( MAXN ), TAUV( MAXN ),    CV( MAXN ), R( * ),
     &   THETA( * ), NA, NB, NSQ, LSQ1,
     &               MA, MB, MSQ, LSQ2, NM

      COMPLEX FV( MAXN ), GV( MAXN ), HV( MAXN ), DETQV( MAXN ),
     &   F, G, H, DETQ, CONTRI, P( NTHETA, * )

      IBWIN2 = IBWIN

C     Note that during reflection imag( q ) is constant and
C     adjacent normals cannot bracket a segment of the TL
C     line, so no special treatment is necessary

C     *** Begin by forming KMAH index ***

      KMAHV( 1 ) = 1
      DO 1000 I = 2, NSTEPS
         KMAHV( I ) = KMAHV( I - 1 )

         IF ( REAL( DETQV( I ) ) .LT. 0.0 ) THEN
            QL = AIMAG( DETQV( I - 1 ) )
            QR = AIMAG( DETQV( I ) )
            IF ( ( QL .LT. 0.0 .AND. QR .GE. 0.0 ) .OR.
     &           ( QL .GT. 0.0 .AND. QR .LE. 0.0 ) )
     &         KMAHV( I ) = -KMAHV( I )
         ENDIF

 1000 CONTINUE

C     *** Loop over radials of receiver line ***

      DO 9500 ITHETA = 1, NTHETA
      TH = DEGRAD * THETA( ITHETA )
C     DO 9000 IMAGE = 1, 1
         IMAGE = 1
         IR1   = 9999
         DO 5000 I = 1, NSTEPS

C           ------ Compute ray normals E1 and E2
            CALL RAYNOR( XIV( I ), ETAV( I ), ZETAV( I ),
     &         PHIV( I ), CV( I ), E1X, E1Y, E1Z, E2X, E2Y, E2Z )

C           ------ Compute coordinates of intercept: NB, MB, RB
            ZT = ZV( I ) - ZR
            CT = COS( TH )
            ST = SIN( TH )

            DELTA = -CT * ( E1Y * E2Z - E1Z * E2Y ) +
     &               ST * ( E1X * E2Z - E1Z * E2X )

C           ------ Check for ray normal || radial of rcvr line
            IF ( ABS( DELTA ) .LT. 1.0E-10 ) GOTO  9500
            NB =   ( -CT * ( YV( I ) * E2Z - ZT * E2Y ) +
     &                ST * ( XV( I ) * E2Z - ZT * E2X ) ) / DELTA
            MB =   ( -CT * ( E1Y * ZT - E1Z * YV( I ) ) +
     &                ST * ( E1X * ZT - E1Z * XV( I ) ) ) / DELTA
            RB = ( -XV( I )* ( E1Y * E2Z - E1Z * E2Y )
     &             +YV( I )* ( E1X * E2Z - E1Z * E2X )
     &               -ZT   * ( E1X * E2Y - E1Y * E2X ) ) / DELTA

C           ------ Compute nearest rcvr before normal ( avoiding intovfl )
            IF ( RB .GT. R( NR ) + DELTAR ) THEN
               IR2 = NR
            ELSE IF ( RB .LT. R( 1 ) ) THEN
               IR2 = 0
            ELSE
               IR2 = IFIX( REAL( ( RB - R( 1 ) ) / DELTAR ) ) + 1
            ENDIF

C           *** Compute contributions to bracketted receivers ***

            IF ( (IR2 .GT. IR1) .AND. (XV( I ) .NE. XV( I-1 )) ) THEN
               DO 2000 IR = IR1 + 1, IR2
                  W = ( R( IR )-RA ) / ( RB-RA )
                  NSQ = ( NA + W * ( NB-NA ) )**2
                  MSQ = ( MA + W * ( MB-MA ) )**2

C                 ------ Within beam window?
                  LSQ1 = -2.0/( OMEGA * AIMAG( FV( I )/DETQV( I ) ) )
                  LSQ2 = -2.0/( OMEGA * AIMAG( GV( I )/DETQV( I ) ) )

                  IF ( NSQ .LT. IBWIN2 * LSQ1 .AND.
     &                 MSQ .LT. IBWIN2 * LSQ2  ) THEN

                     F = FV( I-1 ) + W * ( FV( I ) - FV( I-1 ) )
                     G = GV( I-1 ) + W * ( GV( I ) - GV( I-1 ) )
                     H = HV( I-1 ) + W * ( HV( I ) - HV( I-1 ) )

                     DETQ = DETQV( I-1 ) + W*( DETQV( I )-DETQV( I-1 ) )
                     C    = CV(    I-1 ) + W*(    CV( I )-CV(    I-1 ) )
                     TAU  = TAUV(  I-1 ) + W*(  TAUV( I )-TAUV(  I-1 ) )
                     KMAH = KMAHV( I-1 )

                     IF ( REAL( DETQ ) .LT. 0.0 ) THEN
                        QL = AIMAG( DETQV( I - 1 ) )
                        QR = AIMAG( DETQ )
                        IF ( ( QL .LT. 0.0 .AND. QR .GE. 0.0 ) .OR.
     &                       ( QL .GT. 0.0 .AND. QR .LE. 0.0 ) )
     &                     KMAH = -KMAH
                     ENDIF

                     NM = SQRT( NSQ * MSQ )
                     CONTRI = COS( ALPHA )*SQRT( C / DETQ ) *
     &                  EXP( -CI * OMEGA *( TAU +
     &                     0.5*( F*NSQ + 2.0*H*NM + G*MSQ ) / DETQ ) )

                     IF ( KMAH  .LT. 0 ) CONTRI = -CONTRI
                     IF ( IMAGE .EQ. 2 ) CONTRI = -CONTRI

                     P( ITHETA, IR ) = P( ITHETA, IR ) + CONTRI
                  ENDIF
 2000          CONTINUE
            ENDIF

            NA = NB
            MA = MB
            RA = RB

            IR1 = IR2
C           ------ Next step
 5000    CONTINUE
C      ------ Next image
C 9000 CONTINUE
C     ------ Next radial
 9500 CONTINUE

      RETURN
      END
C**********************************************************************C
      SUBROUTINE RAYNOR( XI, ETA, ZETA, PHI, C, 
     &   E1X, E1Y, E1Z, E2X, E2Y, E2Z )

C     Computes the ray normals, E1 and E2
C     following error involving XIV existed until April 95:
C     E1Y = ( C * ETA * ZETA * COS( PHI ) -
C    &                        XIV * SIN( PHI ) ) / RL

      IMPLICIT REAL ( A-H, O-Z )

      RL = SQRT( XI**2 + ETA**2 )

C     ------ E1
      E1X = ( C * XI  * ZETA * COS( PHI ) +
     &                        ETA * SIN( PHI ) ) / RL
      E1Y = ( C * ETA * ZETA * COS( PHI ) -
     &                        XI  * SIN( PHI ) ) / RL
      E1Z = -C * RL * COS( PHI )

C     ------ E2
      E2X = ( C * XI  * ZETA * SIN( PHI ) -
     &                        ETA * COS( PHI ) ) / RL
      E2Y = ( C * ETA * ZETA * SIN( PHI ) +
     &                        XI  * COS( PHI ) ) / RL
      E2Z = -C * RL * SIN( PHI )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE VCALC( CXX, CXY, CXZ, CYY, CYZ, CZZ, E1X, E1Y, E1Z,
     &   E2X, E2Y, E2Z, CNN, CNM, CMM )

C     Computes the second partials of c along ray normals

      IMPLICIT REAL ( A-H, O-Z )

      CNN = CXX * E1X**2 + CYY * E1Y**2 + CZZ * E1Z**2 +
     &   2.0*CXY * E1X*E1Y + 2.0*CXZ * E1X*E1Z + 2.0*CYZ * E1Y*E1Z

      CNM = CXX * E1X*E2X + CYY * E1Y*E2Y + CZZ * E1Z*E2Z +
     &   CXY * ( E1X*E2Y + E2X*E1Y ) + CXZ * ( E1X*E2Z + E2X*E1Z ) + 
     &   CYZ * ( E1Y*E2Z+E2Y*E1Z )

      CMM = CXX * E2X**2 + CYY * E2Y**2 + CZZ * E2Z**2 +
     &   2.0*CXY * E2X*E2Y + 2.0*CXZ * E2X*E2Z + 2.0*CYZ * E2Y*E2Z

      RETURN
      END
C**********************************************************************C
      SUBROUTINE TRACE2D( XS, YS, ZS, ALPHA, BETA, EPS1, EPS2, 
     &   OMEGA, DELTAS, NSTEPS, OPTION )

C     Traces the beam corresponding to a particular take off angle

      IMPLICIT REAL ( A-H, O-Z )

      PARAMETER ( MAXN = 10003 , PI = 3.14159265 )

      COMMON /BEAM/ XV, YV, ZV, XIV, ETAV, ZETAV, FV, GV, HV, DETQV,
     &   PHIV, TAUV, CV
      REAL XV( MAXN ),   YV( MAXN ),    ZV( MAXN ),
     &    XIV( MAXN ), ETAV( MAXN ), ZETAV( MAXN ),
     &   PHIV( MAXN ), TAUV( MAXN ),    CV( MAXN )
      COMPLEX FV( MAXN ), GV( MAXN ), HV( MAXN ),
     &   DETQV( MAXN ), EPS1, EPS2
      CHARACTER OPTION*80

      COMMON /BEAM2D/ RV, RHOV, P1V, Q1V, P2V, Q2V
      REAL*4 RV( MAXN ), RHOV( MAXN ), 
     &   P1V( MAXN ), Q1V( MAXN ), P2V( MAXN ), Q2V( MAXN )

C     *** Initial conditions ***

      DEPTH = 1.0E6
      RS = SQRT( XS**2 + YS**2 )
      RV( 1 ) = RS
      ZV( 1 ) = ZS

      CALL SSP2D( RV( 1 ), ZV( 1 ), C, CR, CZ, CRR, CRZ, CZZ, BETA )

      RHOV(  1 ) = COS( ALPHA ) / C
      ZETAV( 1 ) = SIN( ALPHA ) / C

      P1V( 1 ) = 1.0
      Q1V( 1 ) = 0.0
      P2V( 1 ) = 0.0
      Q2V( 1 ) = 1.0

      TAUV( 1 ) = 0.0

C     *** Trace the beam ***

      I = 0
      DO 3000 ISTEP = 1, NSTEPS
         I = I + 1

C        *** Phase 1 of modified polygon method ( an Euler step ) ***

         CALL SSP2D( RV( I ), ZV( I ), C, CR, CZ, CRR, CRZ, CZZ, BETA )

         CV( I ) = C
         C2 = C * C
         CNN = C2*( CRR*ZETAV( I )**2+2.0*CRZ*RHOV( I )*ZETAV( I )
     &             +CZZ*RHOV( I )**2 )
         STEP = DELTAS

C        ------ If crossing surface or bottom, reduce step to hit interface
         Z = ZV( I ) + STEP * C * ZETAV( I )
         IF ( Z .LT. 0.0   ) STEP =        -ZV( I )   / ( ZETAV( I )*C )
         IF ( Z .GT. DEPTH ) STEP = ( DEPTH-ZV( I ) ) / ( ZETAV( I )*C )

         R = RV( I ) + 0.5*STEP * C * RHOV(  I )
         Z = ZV( I ) + 0.5*STEP * C * ZETAV( I )

         RHO  = RHOV( I )  - 0.5 * STEP * CR/C2
         ZETA = ZETAV( I ) - 0.5 * STEP * CZ/C2

         P1 = P1V( I ) - 0.5*STEP * CNN / C2 * Q1V( I )
         Q1 = Q1V( I ) + 0.5*STEP * C * P1V( I )
         P2 = P2V( I ) - 0.5*STEP * CNN / C2 * Q2V( I )
         Q2 = Q2V( I ) + 0.5*STEP * C * P2V( I )

C        *** Phase 2 of modified polygon method ***

         CALL SSP2D( R, Z, C, CR, CZ, CRR, CRZ, CZZ, BETA )

         C2 = C * C
         CNN = CRR * ( ZETA * C )**2 +
     &      2.0 * CRZ * ( RHO * C * ZETA * C ) + CZZ * ( RHO * C )**2

C        ------ If crossing surface or bottom, reduce step to hit interface
         Z = ZV( I ) + STEP * C * ZETAV( I )
         IF ( Z .LE. 0.0 ) STEP = -1.00000001*ZV( I )/( ZETAV( I )*C )
         IF ( Z .GE. DEPTH )
     &      STEP = 1.0000001 * ( DEPTH - ZV( I ) ) / ( ZETAV( I ) * C )

         RV( I+1 ) = RV( I ) + STEP * C * RHO
         ZV( I+1 ) = ZV( I ) + STEP * C * ZETA

         RHOV(  I+1 ) = RHOV(  I ) - STEP * CR / C2
         ZETAV( I+1 ) = ZETAV( I ) - STEP * CZ / C2

         P1V( I+1 ) = P1V( I ) - STEP * CNN / C2 * Q1
         Q1V( I+1 ) = Q1V( I ) + STEP * C * P1
         P2V( I+1 ) = P2V( I ) - STEP * CNN / C2 * Q2
         Q2V( I+1 ) = Q2V( I ) + STEP * C * P2

         TAUV( I+1 ) = TAUV( I ) + STEP / C

C        *** If reflecting off surface, need jump conditions ***

         IF ( ZV( I+1 ) .LE. 0.0 ) THEN
            I = I + 1

            RV( I+1 ) =  RV( I )
            ZV( I+1 ) = -ZV( I )

             RHOV( I+1 ) =   RHOV( I )
            ZETAV( I+1 ) = -ZETAV( I )

            CALL SSP2D( RV( I+1 ), ZV( I+1 ), C, CR, CZ,
     &         CRR, CRZ, CZZ, BETA )

            CV( I ) = C

C           ------ Following needs updating for c( r, z ) problem!
            RN = -2.0 * RHOV( I+1 )**2 / ZETAV( I+1 ) * CZ / C
            IF ( OPTION( 3:3 ) .EQ. 'D' ) RN = 2.0 * RN

            P1V( I+1 )  =  P1V( I ) + Q1V( I ) * RN
            Q1V( I+1 )  =  Q1V( I )
            P2V( I+1 )  =  P2V( I ) + Q2V( I ) * RN
            Q2V( I+1 )  =  Q2V( I )
            TAUV( I+1 ) = TAUV( I ) - PI / OMEGA
         ENDIF

C        *** If reflecting off bottom, need jump conditions ***

         IF ( ZV( I+1 ) .GT. DEPTH ) THEN
            I = I + 1

            RV( I+1 ) = RV( I )
            ZV( I+1 ) = DEPTH - ( ZV( I ) - DEPTH )

            ZETAV( I+1 ) = -ZETAV( I )
            RHOV(  I+1 ) =  RHOV(  I )

            CALL SSP2D( RV( I+1 ), ZV( I+1 ), C, CR, CZ,
     &                                   CRR, CRZ, CZZ, BETA )
            CV( I ) = C

C           ------ Following needs updating for c( r, z ) problem!
            RN = -2.0 * RHOV( I+1 )**2 / ZETAV( I+1 ) * CZ / C
            IF ( OPTION( 3:3 ) .EQ. 'D' ) RN = 2.0 * RN

            P1V( I+1 ) = P1V( I ) + Q1V( I ) * RN
            Q1V( I+1 ) = Q1V( I )
            P2V( I+1 ) = P2V( I ) + Q2V( I ) * RN
            Q2V( I+1 ) = Q2V( I )

            TAUV( I+1 ) = TAUV( I )
         ENDIF
 3000 CONTINUE

      RETURN
      END
C**********************************************************************C
      SUBROUTINE INFLU2D( ALPHA, IBWIN, ZR, BETA, IBETA, NTHETA,
     &   R, NR, DELTAR, PRESS, NSTEPS, OMEGA, EPS, OPTION )

C     Computes the beam influence, i.e. 
C     the contribution of a single beam to the COMPLEX*8 pressure

      IMPLICIT REAL ( A-H, O-Z )
      COMPLEX CI
      PARAMETER ( MAXN = 10003, CI = ( 0.0, 1.0 ), NRD = 1 )
      COMMON /BEAM/XV, YV, ZV, XIV, ETAV, ZETAV, FV, GV, HV, DETQV,
     &   PHIV, TAUV, CV

      REAL XV( MAXN ),   YV( MAXN ),    ZV( MAXN ),
     &    XIV( MAXN ), ETAV( MAXN ), ZETAV( MAXN ),
     &   PHIV( MAXN ), TAUV( MAXN ), CV( MAXN ), R( * )

      COMPLEX FV( MAXN ), GV( MAXN ), HV( MAXN ), DETQV( MAXN ),
     &   PRESS( NTHETA, * )

      COMMON /BEAM2D/ RV, RHOV, P1V, Q1V, P2V, Q2V
      INTEGER KMAHV( MAXN )
      REAL*4 RV( MAXN ), RHOV( MAXN ), 
     &   P1V( MAXN ), Q1V( MAXN ), P2V( MAXN ), Q2V( MAXN ),
     &   NA, NB, NSQ, RD( NRD )
      COMPLEX*8 PV( MAXN ), QV( MAXN ), P, Q, EPS, CONTRI
      CHARACTER OPTION*80

      IBWIN2  = IBWIN**2
      DEPTH   = 1.0E6
      RD( 1 ) = ZR

C     Note that during reflection imag( q ) is constant and
C     adjacent normals cannot bracket a segment of the TL
C     line, so no special treatment is necessary

C     *** Begin by forming ( P, Q ) and KMAH index ***

      PV( 1 ) = P1V( 1 ) + EPS * P2V( 1 )
      QV( 1 ) = Q1V( 1 ) + EPS * Q2V( 1 )

      KMAHV( 1 ) = 1

      DO 1000 I = 2, NSTEPS
         PV( I ) = P1V( I ) + EPS * P2V( I )
         QV( I ) = Q1V( I ) + EPS * Q2V( I )
         KMAHV( I ) = KMAHV( I-1 )

         IF ( REAL( QV( I ) ) .LT. 0.0 ) THEN
            Q1 = AIMAG( QV( I-1 ) )
            Q2 = AIMAG( QV( I ) )
            IF ( ( Q1 .LT. 0.0 .AND. Q2 .GE. 0.0 ) .OR.
     &           ( Q1 .GT. 0.0 .AND. Q2 .LE. 0.0 ) )
     &                       KMAHV( I ) = -KMAHV( I )
         ENDIF
 1000 CONTINUE

C     *** Loop over receivers ***

      DO 9000 IRCVR = 1, NRD
      ZR = RD( IRCVR )

C     Loop over images

      IF ( OPTION( 4:4 ) .EQ. 'R' ) NIMAGE = 1
      IF ( OPTION( 4:4 ) .EQ. 'S' ) NIMAGE = 2
      IF ( OPTION( 4:4 ) .EQ. 'B' ) NIMAGE = 3

      DO 8000 IMAGE = 1, NIMAGE
         IR1 = 9999

C        *** Loop over steps ***

         DO 5000 I = 1, NSTEPS

C           Compute ray-centered coordinates

            ZNV = -RHOV( I ) * CV( I )

C           ------ True beam
            IF ( IMAGE .EQ. 1 ) THEN
               RNV = ZETAV( I ) * CV( I )
               NB = ( ZR - ZV( I ) ) / ZNV
            ENDIF

C           ------ Surface reflected beam
            IF ( IMAGE .EQ. 2 ) THEN
               RNV = -ZETAV( I ) * CV( I )
               NB = ( ZR + ZV( I ) ) / ZNV
            ENDIF

C           ------ Bottom reflected beam
            IF ( IMAGE .EQ. 3 ) THEN
               RNV = -ZETAV( I ) * CV( I )
               NB = ( ZR - ( 2.0 * DEPTH - ZV( I ) ) ) / ZNV
            ENDIF
            RB = RV( I ) + NB * RNV

C           *** Compute influence for each rcvr ***

            IR2 = MIN( IFIX( REAL( ( RB-R( 1 ) )/DELTAR ) ) + 1, NR )
            IF ( (IR2 .GT. IR1) .AND. (RV( I ) .NE. RV( I-1 )) ) THEN
               DO 2000 IR = IR1+1, IR2
                  W = ( R( IR ) - RA ) / ( RB - RA )
                  P = PV( I-1 ) + W * ( PV( I ) - PV( I-1 ) )
                  Q = QV( I-1 ) + W * ( QV( I ) - QV( I-1 ) )
                  NSQ = ( NA + W * ( NB-NA ) )**2

C                 ------ Within beam window?
                  IF ( -0.5*OMEGA*AIMAG( P/Q )*NSQ .LT. IBWIN2 ) THEN
                     C   =   CV( I-1 ) + W * (   CV( I ) -   CV( I-1 ) )
                     TAU = TAUV( I-1 ) + W * ( TAUV( I ) - TAUV( I-1 ) )

                     CONTRI = SQRT( C / Q * COS( ALPHA ) )*
     &                  EXP( -CI * OMEGA * ( TAU + 0.5 * P / Q * NSQ ) )

C                    ------ Get correct branch of sqrt
                     KMAH = KMAHV( I - 1 )
                     IF ( REAL( Q ) .LT. 0.0 ) THEN
                        Q1 = AIMAG( QV( I - 1 ) )
                        Q2 = AIMAG( Q )
                        IF ( ( Q1 .LT. 0.0 .AND. Q2 .GE. 0.0 ) .OR.
     &                       ( Q1 .GT. 0.0 .AND. Q2 .LE. 0.0 ) )
     &                                KMAH = -KMAH
                     ENDIF

                     IF ( KMAH  .LT. 0 ) CONTRI = -CONTRI
                     IF ( IMAGE .EQ. 2 ) CONTRI = -CONTRI

                     PRESS( IBETA, IR ) = PRESS( IBETA, IR ) + CONTRI

                  ENDIF
 2000          CONTINUE
            ENDIF

            RA  = RB
            NA  = NB
            IR1 = MAX( IR2, 0 )
C           ------ Next step
 5000    CONTINUE
C      ------ Next image
 8000 CONTINUE
C     ------ Next receiver
 9000 CONTINUE

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SSP2D( R, Z, C, CR, CZ, CRR, CRZ, CZZ, BETA )

C     Converts cartesian gradients to polar

      X = R * COS( BETA )
      Y = R * SIN( BETA )

      CALL SSP( X, Y, Z, C, CX, CY, CZ, CXX, CYY, CZZ, CXY, CXZ, CYZ )

      CR  = COS( BETA ) * CX  + SIN( BETA ) * CY
      CRZ = COS( BETA ) * CXZ + SIN( BETA ) * CYZ

      CRR =       CXX * ( COS( BETA ) )**2
     &    + 2.0 * CXY *   COS( BETA ) * SIN( BETA )
     &    +       CYY * ( SIN( BETA ) )**2

      RETURN
      END

      PROGRAM PLOTMODE

C     Plots a specified set of modes

      INTEGER PLPFIL
      PARAMETER ( PLPFIL = 5, MAXN = 16000, MAXMED = 51,
     &   MAXM = 3000 )

      INTEGER   N( MAXMED ), IRD( MAXN )
      REAL      Z( MAXN ), PHIR( MAXN ), PHII( MAXN ), RD( MAXN ),
     &          W( MAXN ), DEPTH( MAXMED ), RHO( MAXMED )
      COMPLEX   PHI( MAXN ), CK( MAXM ), KTOP2, KBOT2
      CHARACTER PLTITL*80, COCY*8, MATER( MAXMED )*8, BCTOP*1, BCBOT*1

      OPEN( FILE = 'PLPFIL', UNIT = PLPFIL, STATUS = 'OLD' )
      READ( PLPFIL, * ) COCY
      READ( PLPFIL, * ) ZMIN, ZMAX

C     *** Read the header data from the mode file ***

      IPROF = 1
      CALL MODHDR( IPROF, ' ',
     &   PLTITL, FREQ, NMEDIA, NTOT, NMAT,
     &   N, MATER, DEPTH, RHO,
     &   BCTOP, RHOT, DEPTHT,
     &   BCBOT, RHOB, DEPTHB,
     &   M, MAXM, Z, CK, KTOP2, KBOT2, MODFIL )

C     *** Set-up vector of depth points ***

      NRD     = 1001
      RD( 1 ) = ZMIN
      RD( 2 ) = ZMAX
      RD( 3 ) = -999.9
      CALL SUBTAB( RD, NRD )
      CALL WEIGHT( Z, NTOT, RD, NRD, W, IRD )

C     *** Read in the mode ***

      DO I = 1, 50
         READ( PLPFIL, *, END = 4000 ) MODE

C        --- Is the mode in the file?
         IF ( MODE .LE. 0 .OR. MODE .GT. M ) THEN
            WRITE( *, * ) 'ERROR for mode = ', MODE
            WRITE( *, * ) 'Highest order mode in file is = ', M
            STOP
         ELSE
C           --- Cycle through COCY string
            L = MOD( I, LEN(COCY) ) + 1

            CALL GETONE( MODE, MODFIL, NTOT, NMAT, W, IRD,
     &         N, MATER, NMEDIA, COCY(L:L),
     &         KTOP2, DEPTHT, BCTOP,
     &         KBOT2, DEPTHB, BCBOT,
     &         RD, NRD, CK, PHI )

C           --- Scale the mode

            T = 0.0
            DO J = 1, NRD
               T = AMAX1( T, ABS( PHI( J ) ) )
            END DO

            WRITE( *, 1000 ) I-1, I-1
 1000       FORMAT( '@WITH G', I1.1, /,
     &              '@G', I1.1, ' ON', /,
     &              '@TYPE xy' )

            WRITE( *, 2000 ) MODE
 2000       FORMAT( '@ subtitle "Mode ', I3, '"' )

            WRITE( *, 3000 ) INT( ZMIN  ), INT( ZMAX  )
 3000       FORMAT( '@ world xmin ', I5, /,
     &              '@ world xmax ', I5 )

            T = 1.0
            DO J = 1, NRD
               PHIR( J ) = REAL(  PHI( J ) ) / T
               PHII( J ) = AIMAG( PHI( J ) ) / T
               WRITE( *, * ) RD( J ), PHIR( J )
            END DO
            WRITE( *, * ) '&'

            DO J = 1, NRD
               WRITE( *, * ) RD( J ), PHII( J )
            END DO
            WRITE( *, * ) '&'
         END IF

      END DO   ! next plot

 4000 STOP
C            IF ( COCY(L:L) .EQ. 'H' ) CALL XNAME( 'Horiz. Displ.$', 100)
C            IF ( COCY(L:L) .EQ. 'V' ) CALL XNAME( 'Vert. Displ.$',  100)
C            IF ( COCY(L:L) .EQ. 'T' ) CALL XNAME( 'Shear Stress$',  100)
C            IF ( COCY(L:L) .EQ. 'N' ) CALL XNAME( 'Normal Stress$', 100)

      END

      PROGRAM MODASC

C     Converts mode file to ascii format

      INTEGER BINFIL, ASCFIL
      PARAMETER ( BINFIL = 20, ASCFIL = 6, MAXM = 1500, MAXMED = 51,
     &   MAXN = 16000 )

      INTEGER   N( MAXMED )
      REAL      DEPTH( MAXMED ), Z( MAXN ), RHO( MAXMED )
      COMPLEX   PHI( MAXN ), CK( MAXM ), CPT, CST, CPB, CSB
      CHARACTER TITLE*( 80 ), MATER( MAXMED )*8, BCTOP*1, BCBOT*1

C     *** Read header ***

C     --- get record length
      OPEN ( FILE = 'MODFIL', UNIT = BINFIL, STATUS = 'OLD', 
     &   ACCESS = 'DIRECT', FORM = 'UNFORMATTED', RECL = 20 )
      READ( BINFIL, REC = 1 ) LRECL
      CLOSE( BINFIL )

C     --- re-open file with the correct record length
      OPEN ( FILE = 'MODFIL', UNIT = BINFIL, STATUS = 'OLD', 
     &   ACCESS = 'DIRECT', FORM = 'UNFORMATTED', RECL = 4 * LRECL )


      READ( BINFIL, REC = 1 ) LRECL, TITLE(1:80),
     &                        FREQ, NMEDIA, NTOT, NMAT
      READ( BINFIL, REC = 2 )
     &   ( N( MED ), MATER( MED ), MED = 1, NMEDIA)
      READ( BINFIL, REC = 3 )
     &   BCTOP(1:1), CPT, CST, RHOT, DEPTHT,
     &   BCBOT(1:1), CPB, CSB, RHOB, DEPTHB
      READ( BINFIL, REC = 4 )
     &      ( DEPTH( MED ), RHO( MED ), MED = 1, NMEDIA )
      READ( BINFIL, REC = 5 ) M, LRECL
      READ( BINFIL, REC = 6 ) ( Z( IZ ), IZ = 1, NTOT )

C     *** Read in eigenvalues, CK( I ) ***

      IFIRST = 1
      DO IREC = 1, 1 + ( 2 * M - 1 ) / LRECL
         ILAST  = MIN( M, IFIRST + LRECL / 2 - 1 )

         READ( BINFIL, REC = 6 + M + IREC )
     &                        ( CK( MODE ), MODE = IFIRST, ILAST )

         IFIRST = ILAST + 1
      END DO

C     *** Write header ***

      WRITE( ASCFIL, * ) LRECL
      WRITE( ASCFIL, * ) '''', TITLE(1:70), ''''
      WRITE( ASCFIL, * ) FREQ, NMEDIA, NTOT, NMAT, M

      DO MED = 1, NMEDIA
         WRITE( ASCFIL, * ) N( MED ), DEPTH( MED ),
     &      RHO( MED ), '''', MATER( MED ), ''''
      ENDDO

      WRITE( ASCFIL, * ) '''', BCTOP(1:1), '''', CPT, CST, RHOT, DEPTHT
      WRITE( ASCFIL, * ) '''', BCBOT(1:1), '''', CPB, CSB, RHOB, DEPTHB

      WRITE( ASCFIL, * ) 
      DO IZ = 1, NTOT
         WRITE( ASCFIL, * ) Z( IZ )
      ENDDO

C     *** Write out eigenvalues ***

      WRITE( ASCFIL, * ) 
      DO MODE = 1, M
         WRITE( ASCFIL, * ) REAL( CK( MODE ) ), AIMAG( CK( MODE ) )
      ENDDO

c     *** Loop to read and write the modes ***

      DO MODE = 1, M
         READ(  BINFIL, REC = 6 + MODE ) ( PHI( IZ ), IZ = 1, NTOT )
         WRITE( ASCFIL, * )
         DO IZ = 1, NTOT
            WRITE( ASCFIL, * ) REAL( PHI( IZ ) ), AIMAG( PHI( IZ ) )
         ENDDO
      ENDDO

      STOP
      END

      SUBROUTINE EVALMO( CA, CB, CKA, CKB, PHIA, PHIB, M,
     &   RD, NRD, ALPHA, NALPHA,
     &   R, OPT, P )

C     Computes Multi-Ocean pressure field
C     Normalized to pressure of source at 1 meter

C     OPT = X     Cartesian   (x, z) coordinates
C     OPT = R     Cylindrical (r, z) coordinates
C     OPT = S     Scaled cylindrical coordinates
C                    ( 1/r fall-off removed for shade plotting )

C     ALPHA = vector of ocean weights

      COMPLEX CI
      PARAMETER ( MAXM = 1500, CI = ( 0.0, 1.0 ), PI = 3.1415926 )

      REAL RD( * ), ALPHA( * )
      COMPLEX CA( * ), CB( * ), PHIA( MAXM, * ), PHIB( MAXM, * ), 
     &   CONST( MAXM ), HANK( MAXM ), SUM, CKINT( MAXM ), PHIINT, 
     &   P( NRD, * ), CKA( MAXM ), CKB( MAXM )
      CHARACTER OPT*( * )

C     *** Step through oceans ***

      DO 5000 IALPHA = 1, NALPHA

C        ------ Compute weight W and interpolate

         W = ALPHA( IALPHA )

         DO 3000 L = 1, M

            CONST( L ) = SQRT( 2.0 * PI ) * EXP( CI * PI / 4.0 ) * 
     &                  ( CA( L ) + W * (  CB( L ) -  CA( L ) ) )
            CKINT( L ) = CKA( L ) + W * ( CKB( L ) - CKA( L ) )


            IF ( OPT(1:1) .EQ. 'R' ) THEN
C              ------ 'R' Cylindrical coordinates
               HANK( L ) = CONST( L ) * EXP( -CI * CKINT( L ) * R ) /
     &                                SQRT( CKINT( L ) * R )
            ELSE IF ( OPT(1:1) .EQ. 'X' ) THEN
C              ------ 'X' Cartesian coordinates
               HANK( L ) = CONST( L ) * EXP( -CI * CKINT( L ) * R ) /
     &                                CKINT( L )
            ELSE
C              ------ 'S' Scaled cylindrical coord
               HANK( L ) = CONST( L ) * EXP( -CI * CKINT( L ) * R ) /
     &                                SQRT( CKINT( L ) )
            ENDIF

 3000    CONTINUE

C        *** For each rcvr, add up modal contributions ***

         DO 4000 I = 1, NRD
            SUM = 0.0

            DO 2000 MODE = 1, M
               PHIINT = PHIA( MODE, I ) +
     &            W * ( PHIB( MODE, I ) - PHIA( MODE, I ) )
               SUM = SUM + PHIINT * HANK( MODE )
 2000       CONTINUE

            P( I, IALPHA ) = SUM

 4000    CONTINUE

 5000 CONTINUE   ! Next ALPHA

      RETURN
      END

      SUBROUTINE SORT( X, N )

C     Does an insertion sort on a vector of real numbers

C     At the Ith step, the first I-1 positions contain a sorted
C     vector.  We shall insert the Ith value into its place in that
C     vector shifting up to produce a new vector of length I.

      REAL X( * )

      IF ( N .EQ. 1 ) RETURN

      DO 2000 I = 2, N

         T = X( I )

         IF ( T .LT. X( 1 ) ) THEN
C           ------ Goes in the first position
            CALL SHIFTIN( X, T, 1, I - 1 )

         ELSE IF ( T .LT. X( I - 1 ) ) THEN

C           *** Binary search for its place ***

            IRIGHT = I - 1
            ILEFT  = 1

 1000       IMID = ( ILEFT + IRIGHT ) / 2

            IF ( T .LT. X(IMID) ) THEN
               IRIGHT = IMID
            ELSE
               ILEFT  = IMID
            ENDIF

            IF ( IRIGHT .GT. ILEFT + 1 ) GOTO 1000

C           ------ Shift and insert
            CALL SHIFTIN( X, T, IRIGHT, I - 1 )

         ENDIF

 2000 CONTINUE

      RETURN
      END

      SUBROUTINE SHIFTIN( X, T, I1, I2 )

C     Shift values (I1, I2) one position to the right
C     and insert T at position I1

      REAL X( * )

      DO 1000 K = I2, I1, -1
         X( K + 1 ) = X( K )
 1000 CONTINUE

      X( I1 ) = T

      RETURN
      END

      PROGRAM PLOTSLIC

C     Plot the propagation loss along a specified track

      INTEGER PLPFIL, PRTFIL, SHDFIL
      PARAMETER ( PLPFIL = 1, PRTFIL = 6, 
     &   MAXNSD = 51,  MAXNRD = 4096, MAXNR = 5000 )

      REAL SD( MAXNSD ), RD( MAXNRD ), R( MAXNR ), TL( MAXNR ),
     &   RNEW( MAXNR ), TLNEW( MAXNR )
      COMPLEX P( MAXNR )
      CHARACTER TITLE*80, OPTION*8, TITLEY*80, PLTTYP*10,
     &   FILNAM*80

      DATA RINC, RAXL, TLMIN, TLMAX, TLINC, TLAXL /6* 0.0/

C     *** Read in plot parameters ***

      OPEN( FILE = 'PLPFIL', UNIT = PLPFIL, STATUS = 'OLD' )

      READ( PLPFIL, * ) OPTION
      READ( PLPFIL, * ) NCURVES
      READ( PLPFIL, * ) SRCD, RCVRD
      READ( PLPFIL, * )  RMIN,  RMAX,  RINC,  RAXL
      READ( PLPFIL, * ) TLMIN, TLMAX, TLINC, TLAXL
      READ( PLPFIL, * ) DR3DB

      WRITE( PRTFIL, 100 )
  100 FORMAT( '@   legend on' )

C     *** Loop over curve number ***

      SHDFIL = 0
      DO ICURVE = 1, NCURVES

C        *** Read in header information ***

         READ( PLPFIL, * ) FILNAM
C        --- Append the extension '.shd' to the filename
         JJ = INDEX( FILNAM, ' ' )
         FILNAM( JJ:JJ+3 ) = '.shd'

         CALL RDHEAD( SHDFIL, FILNAM, MAXNR, MAXNSD, MAXNRD,
     &      FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &      SD, NSD, RD, NRD, TITLE )

C        --- Info for legend

         WRITE( PRTFIL, 500 ) ICURVE -1, FILNAM(1:JJ-1)
  500    FORMAT( '@   legend string ', I1, ' "', A, '"' ) 

C        ------ Extract range interval in kilometers

         IFIRST = 1
         ILAST  = NR

         DO IR = 1, NR
            R( IR ) = R( IR ) / 1000.0
            IF ( R( IR ) .LE. RMAX ) ILAST  = IR
            IF ( RMIN .GE. R( IR ) ) IFIRST = IR
         END DO

         NRNEW = ILAST - IFIRST + 1

C        --- Caculate tolerance for accepting source/rcvr depth

         IF ( FREQ .EQ. 0.0 ) THEN
            TOL = 0.001
         ELSE
            TOL = 1500.0 / ( 6.0 * FREQ )  ! one wavelength
         ENDIF

C        *** Calculate source depth index ***

         ISD = NEIGH( SRCD, SD, NSD )

         IF ( ABS( SD( ISD ) - SRCD ) .GT. TOL ) THEN
            WRITE( PRTFIL, * ) 'Sources exist at the following depths:'
            WRITE( PRTFIL, * ) ( SD( I ), I = 1, NSD )
            CALL ERROUT( PRTFIL, 'F', 'PLOTSLICE',
     &                'No source at specified depth' )
         ENDIF

C        *** Calculate receiver depth index ***

         IRD = NEIGH( RCVRD, RD, NRD )

         IF ( ABS( RD( IRD ) - RCVRD ) .GT. TOL ) THEN
            WRITE( PRTFIL, * ) 'Rcvrs exist at the following depths:'
            WRITE( PRTFIL, * ) ( RD( I ), I = 1, NRD )
            CALL ERROUT( PRTFIL, 'F', 'PLOTSLICE',
     &                'No receiver at specified depth' )
         ENDIF

C        *** Read in pressure field and convert to transmission loss ***

         IREC =  6 + NRD * ( ISD - 1 ) + IRD
         READ( SHDFIL, REC = IREC ) ( P( IR ), IR = 1, NR )

         TLMINT =  200.0
         TLMAXT = -200.0

         DO IR = 1, NRNEW
            IRORG = IFIRST + IR - 1
            RNEW( IR ) = R( IRORG )

            IF (OPTION(2:2) .EQ. 'L' .OR. OPTION(2:2) .EQ. 'F') THEN
C              ------ Linear scale
               IF ( OPTION(1:1) .EQ. 'S' ) THEN
                  TL(IR) = 1000.0 * SQRT( R(IRORG) ) * REAL( P(IRORG) )
               ELSE
                  TL(IR) = REAL( P( IRORG ) )
               ENDIF
            ELSE
C              ------ dB scale
               PSQ = P( IRORG ) * CONJG( P( IRORG ) )
               IF ( OPTION(1:1) .EQ. 'S' )
     &            PSQ = 1000.0 * R( IRORG ) * PSQ

               TL(IR) = 200.0
               IF ( PSQ .GT. 1.0E-20 ) TL( IR ) = -10.0 * ALOG10( PSQ )
            ENDIF

            WRITE( PRTFIL, * ) RNEW( IR ), TL( IR )

            TLMAXT = MAX( TL( IR ), TLMAXT )
            TLMINT = MIN( TL( IR ), TLMINT )
         END DO

         WRITE( PRTFIL, * ) '&'

C        Compute limits for transmission loss axis

C         WRITE( PRTFIL, * )
C         WRITE( PRTFIL, * ) 'TLMIN = ', TLMINT, 'TLMAX = ', TLMAXT

         IF ( ICURVE .EQ. 1 ) THEN
            ITLMIN = TLMINT / 10
            ITLMAX = TLMAXT / 10 + 1

            IF ( TLMIN .EQ. TLMAX ) THEN   ! autoscaling?
               TLMIN = 10.0 * ITLMIN
               TLMAX = 10.0 * ITLMAX
            ENDIF

            IF ( OPTION(2:2) .EQ. 'L' ) THEN
               TITLEY = 'Intensity$'
            ELSE
               TITLEY = 'Loss (dB)$'
               TITLEY = 'Power (dB)$'
            ENDIF

         ENDIF

C        Smooth

         NROWS  = 1
         NTHETA = 1
         CALL SMOOTH( TL, TLNEW, NROWS, NTHETA, NRNEW, DELTAR, DR3DB )

         SHDFIL = SHDFIL + 1
      END DO

C     *** Labels ***

      IF ( NCURVES .EQ. 1 ) THEN
      WRITE( PRTFIL, 1000 ) TITLE
 1000 FORMAT( '@ title "', A, '"' )
      ENDIF

      WRITE( PRTFIL, 2000 ) NINT( FREQ ), NINT( SRCD ), NINT( RCVRD )
 2000 FORMAT(  '@ subtitle "',
     &         'F  =', I4, ' Hz, ',
     &         'Sd =', I4, ' m,  ',
     &         'Rd =', I4, ' m"' )
 
      WRITE( PRTFIL, 3000 ) INT( RMIN  ), INT( RMAX  ),
     &                      INT( TLMIN ), INT( TLMAX )
 3000 FORMAT( '@ world xmin ', I5, /,
     &        '@ world xmax ', I5, /,
     &        '@ world ymin ', I5, /,
     &        '@ world ymax ', I5 )

      STOP
      END

      PROGRAM PLOTIRC

C     Plots the internal reflection coefficient

      INTEGER PLPFIL
      PARAMETER( PLPFIL = 1, PI = 3.141592 )

      INTEGER ITAB( 5000 )
      REAL C( 5000 ), Z( 5000 ), PHIR( 5000 )
      REAL*8 XTAB( 5000 )
      COMPLEX*8 CK( 5000 )
      COMPLEX*16 FTAB( 5000 ), GTAB( 5000 )
      CHARACTER TITLE*80

C     User parameters

      CMIN = 1495.0
      CMAX = 1515.0
      CINC = 0.0

      OPEN( FILE = 'PLPFIL', UNIT = PLPFIL, STATUS = 'OLD' )
      READ( PLPFIL, * ) CMIN, CMAX

C     &   'Phase Speed (m/s)$', 100, 'Z$', 100, CAXL,  ZAXL )

C     *** Plot positions of eigenvalues ***

      CALL GETMOD( 1, ' ', MAXM, RD, 1, 'N',
     &   CK, PHIR, M, FREQ, TITLE )

      OMEGA = 2.0 * PI * FREQ

      DO MODE = 1, M
         C( MODE ) = OMEGA / REAL( CK( MODE ) )
      END DO

C     *** Plot the two IRC files ***

      DO IRCFIL = 10, 11
      READ( IRCFIL ) NKPTS, (XTAB( IK ), FTAB( IK ), GTAB( IK ), 
     &                                      ITAB(IK), IK = 1, NKPTS)

C     Search for maximum ITAB

      ITMAX = -99999
      ITMIN =  99999

      DO IK = 1, NKPTS
         ITAB( IK ) = 0
         ITMAX = MAX ( ITAB( IK ),  ITMAX )
         ITMIN = MIN ( ITAB( IK ),  ITMIN )
      END DO

C     Convert to impedance and plot

      ISTART = 1

      DO IK = 1, NKPTS

         C(IK) = OMEGA / SQRT( XTAB( IK ) )
         IF ( ABS( FTAB( IK ) ) .LT. 1.0E-25 ) THEN
            Z( IK ) = 0.0
         ELSE
            Z( IK ) = REAL( GTAB( IK ) / FTAB( IK ) )
         ENDIF

         IF ( IRCFIL .EQ. 11 ) Z( IK ) = -Z( IK )

         IF ( REAL( FTAB( IK ) ) * REAL( FTAB( IK + 1 ) ) .LT. 0.0 .OR.
     &                                   IK .GE. NKPTS ) THEN

            IF ( C( ISTART ) .GT. CMIN .AND. C( IK ) .LT. CMAX ) THEN
               DO I = ISTART, IK - ISTART + 1
                  WRITE( *, * ) C( I ), Z( I )
               END DO
            ENDIF

            ISTART = IK + 1     ! RESET LEFT SIDE OF WINDOW
         ENDIF

      END DO   ! next k-point

      WRITE( *, * ) '&'

      END DO   ! next IRCFIL

C     *** Write data ***

      LAST = INDEX( TITLE, '    ' ) - 1
      WRITE( *, 1000 ) TITLE(1:LAST)
 1000 FORMAT( '@ title "', A, '"' )

      WRITE( *, 2000 ) NINT( FREQ )
 2000 FORMAT(  '@ subtitle "',
     &         'F  =', I4, ' Hz"' )
 

      STOP
      END

      PROGRAM POD

C     Converts a complex pressure field into a prob. of detection

      INTEGER PRTFIL, SHDFIL, PODFIL
      PARAMETER ( INPFIL = 5, PRTFIL = 6, SHDFIL = 26, PODFIL = 25,
     &   MAXNSD = 4094, MAXNRD = 4094, MAXNR = 4094 )

      REAL    R( MAXNR ), SD( MAXNSD ), RD( MAXNRD ), TL( MAXNR )
      COMPLEX P( MAXNR )
      CHARACTER TITLE*80, PLTTYP*10
C
      WRITE( PRTFIL, * ) 'FOM, SIGMA?'
      READ(  INPFIL, * )  FOM, SIGMA

C     *** Read/write header ***

      CALL RDHEAD( SHDFIL, 'SHDFILIN', MAXNR, MAXNSD, MAXNRD,
     &   FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &   SD, NSD, RD, NRD, TITLE )

      CALL HEADER( TITLE, SD, NSD, RD, NRD,
     &   R, NR, FREQ, ATTEN, PLTTYP, XS, YS, THETA )

C     Read in pressure field and convert to transmission loss

      DO ISR = 1, NSD * NRD
         IREC =  ISR + 6
         READ ( SHDFIL, REC = IREC ) ( P( J ), J = 1, NR )

C        ------ Convert to probability of detection
         DO J = 1, NR
            PSQ = P( J ) * CONJG( P( J ) )
            TL( J ) = 200.0
            IF ( PSQ .GT. 1.0E-20 ) TL( J ) = -10.0 * ALOG10( PSQ )
            P( J ) = TRANSIT( FOM - TL( J ), SIGMA )
         END DO

C        ------ Write out the POD
         WRITE( PODFIL, REC = IREC ) ( P( J ), J = 1, NR )
      END DO

      STOP
      END

      INTEGER PRTFIL
      COMPLEX CI
      PARAMETER ( PRTFIL = 6, MXN = 1500003, MXNRD = 201, MXREF = 2001,
     &   MXBTY = 100, MXNR = 2001, CI = (0.0, 1.0), PI = 3.14159265 )

C     The following can be changed to reduce storage:
C
C     MXN     max # of steps along a ray
C     MXNRD            Receiver Depths
C     MXREF            REFlection coefficient points
C     MXBTY            BaThYmetry points
C     MXNR             receiver ranges

      REAL*8 RHOB, RHOT
      REAL*8 RV, ZV, RHOV, ZETAV, P1V, Q1V, P2V, Q2V, TAUV
      COMPLEX*16 CPT, CPB, RFA
      CHARACTER TOPOPT*4

      COMMON /BEAM/ CPT, CPB, RHOT, RHOB,
     &   RV(   MXN ), ZV(  MXN ), RHOV( MXN ), ZETAV( MXN ),
     &   P1V(  MXN ), Q1V( MXN ), P2V(  MXN ), Q2V(   MXN ),
     &   TAUV( MXN ), RFA( MXN ), CV(   MXN ),
     &   RD( MXNRD ), R( MXNR ),
     &   OMEGA, TOPOPT, DEPTHT, DEPTHB, NSTEPS, NRD, NR

C     *** bottom, top reflection coefficients

      REAL*8 THETABOT, RBOT, PHIBOT, THETATOP, RTOP, PHITOP
      COMMON /REFLEC/ THETABOT( MXREF ), RBOT( MXREF ), PHIBOT( MXREF),
     &                THETATOP( MXREF ), RTOP( MXREF ), PHITOP( MXREF),
     &                NBOTPTS, NTOPPTS

C     *** bottom topography (coordinates and tangent)

      REAL*8 RNG, DEP, TBR, TBZ
      COMMON /BATHY/ RNG( MXBTY ), DEP( MXBTY ),
     &               TBR( MXBTY ), TBZ( MXBTY ), NBTYPTS

      PROGRAM ISO

C     Generates the time series for an isovelocity problem

      INTEGER STKFIL
      PARAMETER ( STKFIL = 6, PI = 3.141592 )

      REAL    RD( 51 ), STACK( 51, 1001 )
      COMPLEX ST
      CHARACTER PULSE*4, PULTIT*80

      C0    = 1500.0   ! REFERENCE SOUND SPEED
      PULSE = 'P   '   ! PULSE TYPE
      FREQ  = 50.0
      FMIN  =   0.0
      FMAX  =  10.0 * FREQ
      OMEGA =   2.0 * PI * FREQ
      R     =  200.0   ! RANGE IN METERS

      TMIN = 0.0
      TMAX = 1.0
      NT   = 512
      DELT = TMAX / ( NT - 1 )

C     Generate the vector of receiver depths

      NRD = 1
      DO IR = 1, NRD
         RD( IR ) = ( IR - 1 ) * 10.0
      END DO

C     Construct the time series

      DO IR = 1, NRD
         SLANTR = SQRT( RD( IR ) ** 2 + R ** 2 )
         DO IT = 1, NT
            TIME = TMIN + ( IT - 1 ) * DELT
            T = TIME - SLANTR / C0    ! THIS IS REDUCED TIME

C           --- calculate the source time series
            CALL SOURCE( T, OMEGA, FMIN, FMAX, PULSE, ST, PULTIT )

            STACK( IR, IT ) = -ST / SLANTR
         END DO   ! NEXT TIME
      END DO  ! NEXT DEPTH

C     Write out the stack

      WRITE( STKFIL, * ) ''''//'Analytic- '//PULTIT(1:69)//''''
      WRITE( STKFIL, * ) NRD, ( RD( IR ), IR = 1, NRD )

      DO IT = 1, NT
         TIME = TMIN + ( IT - 1 ) * DELT
         WRITE( STKFIL, * ) TIME, ( STACK( IR, IT ), IR = 1, NRD )
      END DO

      STOP
      END

      PROGRAM RAW

C     Convert time series file to raw integer format

      INTEGER RAWFIL
      PARAMETER ( RAWFIL = 10, MAXNRD = 1, MAXNT = 1000000 )

      INTEGER*2 IR( MAXNT )
      REAL RD( MAXNRD ), TOUT( MAXNT ), R( MAXNT )
      CHARACTER TITLE*80


      READ( *, * ) TITLE
      READ( *, * ) NRD, ( RD( IRD ), IRD = 1, NRD )

      RMAX = 0.0
      NT = 0

      DO IT = 1, MAXNT
         READ( *, *, END = 1000 ) TOUT( IT ), R( IT )
         RMAX = MAX( RMAX, ABS( R( IT ) ) )
         NT = IT
      END DO

C     *** Write it out ***

 1000 OPEN( FILE = 'RAWFIL', UNIT = RAWFIL,
     &      FORM = 'UNFORMATTED', STATUS = 'UNKNOWN' )

      DO IT = 1, NT
         IR( IT ) = 32000 * R( IT ) / RMAX
      END DO

      WRITE( RAWFIL ) ( IR( IT ), IT = 1, NT )

      STOP
      END

      SUBROUTINE REFCO( THEINT, RINT, PHIINT, THETA, R, PHI, NPTS )

C     Given an angle THEINT, REFCO returns the magnitude and
C     phase of the reflection coefficient (RINT, PHIINT).

C     Uses linear interpolation using the two nearest abscissas 

      IMPLICIT REAL*8 (A-H, O-Z)
      REAL*8 THETA( * ), R( * ), PHI( * )

      ILEFT  = 1
      IRIGHT = NPTS

C     Three cases: THEINT left, in, or right of tabulated interval

      IF ( THEINT .LT. THETA( ILEFT ) ) THEN
         RINT   = R(   ILEFT )
         PHIINT = PHI( ILEFT )
      ELSE IF( THEINT .GT. THETA( IRIGHT ) ) THEN
         RINT   = R(   IRIGHT )
         PHIINT = PHI( IRIGHT )
      ELSE 

C        Search for bracketting abscissas:
C        Log base 2 (NPTS) stabs required for a bracket

C        ------ DO WHILE ...
 1000    IF ( ILEFT .NE. IRIGHT - 1 ) THEN
            IMID = ( ILEFT + IRIGHT ) / 2
            IF ( THETA( IMID ) .GT. THEINT ) THEN
               IRIGHT = IMID
            ELSE
               ILEFT  = IMID
            ENDIF
         GOTO 1000
         ENDIF

C        Linear interpolation for reflection coef

         ALPHA = ( THEINT          - THETA( ILEFT ) ) /
     &           ( THETA( IRIGHT ) - THETA( ILEFT ) )
         RINT   = ( 1 - ALPHA ) * R(   ILEFT ) + ALPHA * R(   IRIGHT )
         PHIINT = ( 1 - ALPHA ) * PHI( ILEFT ) + ALPHA * PHI( IRIGHT )
C        ------ Problem: PHI may change discontinuously ...
      ENDIF

      RETURN
      END

      SUBROUTINE ZSECCX( X2, TOL, IT, MAXIT, ERRMSG )
      IMPLICIT REAL*8 (A-H, O-Z)
      COMPLEX*16 X0, X1, X2, SHIFT, F0, F1
      CHARACTER*80 ERRMSG

C     Secant method

      ERRMSG = ' '
      IF ( TOL .LE. 0.0 ) THEN
         ERRMSG = 'Non-positive tolerance specified'
         STOP
      ENDIF

      TEN    = 10.0
      X1     = X2 + 100.0 * TOL
c       X1 = X2 - 10.0*TOL
c       X2 = X2 +10.0*TOL
      CALL FUNCT( X1, F1, IPOW1)

      DO 1000 IT = 1, MAXIT
         X0 = X1
         F0 = F1
         IPOW0 = IPOW1

         X1 = X2
         CALL FUNCT( X1, F1, IPOW1)
         SHIFT = F1 * ( X1 - X0 ) / ( F1 - F0 * TEN ** (IPOW0-IPOW1) )
c         SHIFT = SHIFT / 10.0
         X2 = X1 - SHIFT

         IF ( ABS( X2 - X1 ) .LT. TOL ) GOTO 3000
         IF ( ABS( X2 - X0 ) .LT. TOL ) GOTO 3000
 1000 CONTINUE

      ERRMSG = ' *** FAILURE TO CONVERGE IN SECANT'

 3000 RETURN
      END

      SUBROUTINE EVALPDQ( CK, PHIR, PHIS, M, IELTSC, ADJELT, ISET,
     &   X, Y, NNODES, NODE, NELTS, XS, YS, THETA, NTHETA,
     &   RMINM, RMAXM, NR, MACT, OPT, P )

C     Computes 3-D pressure field using adiabatic mode theory
C     Normalized to pressure of point source at 1 meter

C     Note RMINM must be zero

      COMPLEX CI
      PARAMETER ( PI = 3.141592, DEGRAD = PI/180.0, CI = ( 0.0, 1.0 ),
     &   MAXM = 100 )

      INTEGER M( * ), NODE( 3, * ), ADJELT( 3, * ), ISET( * ), OUTSIDE
      REAL    X( * ), Y( * ), THETA( * )
      COMPLEX PHIR( MAXM, * ), PHIIN( MAXM ), PHIOUT( MAXM ),
     &        PHIS( MAXM, * ), COEF( MAXM ),
     &        CK(   MAXM, * ), CKIN( MAXM ), CKOUT( MAXM ),
     &        P( NTHETA, * ), PHASEINC( MAXM ), T, CKAVG
      CHARACTER OPT*( * )

C     *** Loop over angle ***

      DELTAR = ( RMAXM - RMINM ) / ( NR - 1 )

      DO ITHETA = 1, NTHETA
         TSX = COS( DEGRAD * THETA( ITHETA ) )
         TSY = SIN( DEGRAD * THETA( ITHETA ) )

C        --- Get modal values
         IELT = IELTSC
         WRITE( *, * )
         WRITE( *, * ) 'ITHETA, TSX, TSY', ITHETA, TSX, TSY

         CALL FIRST( IELT, OUTSIDE, RIN, ROUT, XS, YS, TSX, TSY,
     &      X, Y, MPROP, M, MAXM, CK, PHIR, PHIS, COEF, NODE,
     &      ISET, CKIN, PHIIN, CKOUT, PHIOUT )

         MPROP = MIN( MACT, MPROP )

         DO MODE = 1, MPROP
            COEF( MODE ) = SQRT( 2.0 * PI ) * EXP( CI * PI / 4.0 )
     &                     * COEF( MODE )
            CKAVG = 0.5 * ( CKIN( MODE ) + CKOUT( MODE ) )
            PHASEINC( MODE ) = EXP( -CI * CKAVG * DELTAR )
         END DO

C        *** March forward in range ***

         DO IR = 1, NR
            RM = RMINM + ( IR - 1 ) * DELTAR
            IF ( RM .EQ. 0.0 ) RM = DELTAR

C           Crossing into new element?

  100       CONTINUE
            IF ( RM .GT. ROUT ) THEN

C              --- Copy outside info to inside
               NEWELT = ADJELT( OUTSIDE, IELT )
               RIN = ROUT

               DO MODE = 1, MPROP
                  CKIN(  MODE ) =  CKOUT( MODE )
                  PHIIN( MODE ) = PHIOUT( MODE )
                  CKAVG = 0.5 * ( CKIN( MODE ) + CKOUT( MODE ) )
                  PHASEINC( MODE ) = EXP( -CI * CKAVG * DELTAR )
               END DO

C              --- Get new outside info
               CALL OUT( IELT, NEWELT, OUTSIDE, ROUT, ADJELT, ISET,
     &            XS, YS, TSX, TSY, X, Y, NODE,
     &            MPROP, M, MAXM, CK, PHIR, CKOUT, PHIOUT )
               IELT = NEWELT

               GOTO 100   ! Check again

            END IF

C           *** Compute modal contribution at this range ***

            T = 0.0
            DO L = 1, MPROP
               COEF( L ) = COEF( L ) * PHASEINC( L )
               T = T + COEF( L ) * PHIIN( L )
            END DO

            P( ITHETA, IR ) = T / SQRT( RM * CKIN( 1 ) )

         END DO   ! next range

      END DO   ! next bearing

      RETURN
      END

      SUBROUTINE SUBTAB( X, NX )

C     If X(3) = -999.9 then subtabulation is performed
C     i.e, a vector is generated with NX points in [X(1),X(2)]

      REAL X( * )

C     --- testing for equality here is dangerous

      IF ( NX .GE. 3 .AND. X(3) .EQ. -999.9 ) THEN
         XMIN = X( 1 )
         XMAX = X( 2 )
         DELTAX = ( XMAX - XMIN ) / ( NX - 1 )

         DO I = 1, NX
            X( I ) = XMIN + ( I - 1 ) * DELTAX
         END DO

      ENDIF

      RETURN
      END

      PROGRAM FIELD

C     Generate file of replica vectors

      INTEGER PRTFIL, FLPFIL
      PARAMETER ( FLPFIL = 5, PRTFIL = 6,
     &   MAXM = 1500, MAXNR = 9000, MAXNRZ = 210000, 
     &   MAXNSD = 51, MAXNRD = 201, MAXNPROF = 502 )

      REAL      SD( MAXNSD ), RD( MAXNRD ), RR( MAXNRD ),
     &          R( MAXNR ), RPROF( MAXNPROF )
      COMPLEX   CK( MAXM ), PHIS( MAXM, MAXNSD ),
     &          PHIR( MAXM, MAXNRD ), P( MAXNRZ )
      CHARACTER OPT*50, SHTITL*80, TITLE*80, COMP*1

C     Read source, rcvr depths and rcvr displacements

      SHTITL(1:1) = '$'

      READ( FLPFIL, * ) SHTITL
      READ( FLPFIL, * ) OPT
      READ( FLPFIL, * ) MLIMIT

      COMP   = OPT( 3:3 )
      MLIMIT = MIN( MAXM, MLIMIT )

C     *** Read profile ranges ***

      RPROF( 3 ) = -999.9
      READ( FLPFIL, * ) NPROF, ( RPROF( I ), I = 1, NPROF )

C     ( an extra profile is used at `infinite' range )
      IF ( NPROF .GT. MAXNPROF - 1 ) THEN
         WRITE( PRTFIL, * ) 'NPROF, MAXNPROF = ', NPROF, MAXNPROF
         CALL ERROUT( PRTFIL, 'F', 'FIELD', 'Too many profiles' )
      ENDIF

C     EVALAD needs a profile at zero range

      IF ( RPROF( 1 ) .NE. 0.0 )
     &   CALL ERROUT( PRTFIL, 'F', 'FIELD',
     &   'The first profile must be at 0 km' )

      CALL SUBTAB( RPROF, NPROF )

C     *** Read receiver ranges ***

      CALL RANGES( FLPFIL, PRTFIL, MAXNR, NR, R )

C     *** Read source/receiver depths ***

      ZMIN = -1.0E10
      ZMAX = +1.0E10

      CALL SDRD( FLPFIL, PRTFIL, ZMIN, ZMAX,
     &   MAXNSD, NSD, SD,
     &   MAXNRD, NRD, RD )

C     *** Read receiver ranges ***

      NRR     = 0
      RR( 2 ) = 0.0
      RR( 3 ) = -999.9
      READ( FLPFIL, * ) NRR, ( RR( IR ), IR = 1, NRR )

      IF ( NRR .NE. NRD ) THEN
         WRITE( PRTFIL, * ) 'NRR, NRD = ', NRR, NRD
         CALL ERROUT( PRTFIL, 'W', 'FIELD', 'NRR being set to NRD' )
         NRR = NRD
      ENDIF

      CALL SUBTAB( RR, NRD )
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Number of receivers = ', NRD
      IF ( NRD .GE. 1 )
     &   WRITE( PRTFIL, * ) ( RR( IR ), IR = 1, MIN( NRD, 51 ) )

      WRITE( PRTFIL, * )

      IF ( NR * NRD .GT. MAXNRZ )
     &   CALL ERROUT( PRTFIL, 'F', 'FIELD',
     &                'Number of ranges x Depths too large' )

C     *** Read in modes ***

      IPROF = 1
      CALL GETMOD( IPROF, ' ', MAXM, SD, NSD, 'N',
     &   CK, PHIS, MSRC, FREQ, TITLE )
      CALL GETMOD( IPROF, ' ', MAXM, RD, NRD, COMP,
     &   CK, PHIR, MSRC, FREQ, TITLE )

C     ------ Generate header
      IF ( SHTITL(1:1) .EQ. '$' ) SHTITL = TITLE
      CALL HEADER( SHTITL, SD, NSD, RD, NRD,
     &   R, NR, FREQ, ATTEN, '     ', 0.0, 0.0, 0.0 )
      IREC = 6

C     *** MAIN LOOP: For each source evaluate and write the field ***

      DO J = 1, NSD
         M = MIN( MLIMIT, MSRC )   ! Set number of propagating modes

         IF    ( NPROF .EQ. 1      ) THEN   ! Range-independent case
               CALL EVAL( PHIS( 1, J ), PHIR, NRD, 
     &            R, NR, RR, CK, M, OPT, P )
         ELSE
            IF ( OPT(2:2) .EQ. 'C' ) THEN   ! Range-dependent case
C              --- Coupled mode theory
               CALL EVALCM( RPROF, NPROF, PHIS( 1, J ), PHIR, RD, NRD, 
     &            R, NR, CK, M, OPT, P )
            ELSE
C              --- Adiabatic mode theory
               CALL EVALAD( RPROF, NPROF, PHIS( 1, J ), PHIR, RD, NRD, 
     &            R, NR, M, OPT, P )
            ENDIF
         ENDIF

         CALL WRTFLD( P, NRD, NR, IREC )

      END DO   ! next source depth

      STOP
      END

      SUBROUTINE HEADER( TITLE, SD, NSD, RD, NRD,
     &   R, NR, FREQ, ATTEN, PLTTYP, XS, YS, THETA )

C     Routine to write header to disk file

C     TITLE  is an arbitrary title
C     SD     is a vector of source   depths, SD(1:NSD)
C     RD     is a vector of receiver depths, RD(1:NRD)
C     R      is a vector of receiver ranges, R(1:NR)
C     FREQ   is the frequency
C     ATTEN  is the stabilizing attenuation (which is only
C        important for FFP runs. Use zero for other cases.)

      INTEGER SHDFIL
      PARAMETER ( SHDFIL = 25, MXRECL = 200000 ) ! MXRECL=4095 for VAX

      REAL*4 R( * ), RD( * ), SD( * )
      CHARACTER TITLE*( * ), PLTTYP*10

      LRECL = MAX( 40, NSD, NRD, 2 * NR )   ! words/record

      IF ( LRECL .GT. MXRECL ) THEN
         STOP 'FATAL ERROR: Record is too large'
      ENDIF

      OPEN ( FILE = 'SHDFIL', UNIT = SHDFIL, STATUS = 'UNKNOWN',
     &   ACCESS = 'DIRECT', RECL = 4 * LRECL, FORM = 'UNFORMATTED')

      WRITE( SHDFIL, REC = 1 ) LRECL, TITLE(1:80)
      WRITE( SHDFIL, REC = 2 ) PLTTYP, XS, YS, THETA
      WRITE( SHDFIL, REC = 3 ) FREQ, NSD, NRD, NR
      WRITE( SHDFIL, REC = 4 ) ( SD( I ), I = 1, NSD )
      WRITE( SHDFIL, REC = 5 ) ( RD( I ), I = 1, NRD )
      WRITE( SHDFIL, REC = 6 ) ( R(  I ), I = 1, NR  )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE WRTFLD( P, NRD, NR, IREC )

C     Write the field to disk

      INTEGER SHDFIL
      PARAMETER ( SHDFIL = 25 )

      COMPLEX P( NRD, * )

      DO I = 1, NRD
         IREC = IREC + 1
         WRITE( SHDFIL, REC = IREC ) ( P( I, J ), J = 1, NR )
      END DO

      RETURN
      END

      PROGRAM PLOTGRN

C     Plot the Green's function

      INTEGER PLPFIL, PRTFIL
      COMPLEX CI
      
      PARAMETER ( PLPFIL = 1, PRTFIL = 6, CI = ( 0.0, 1.0 ),
     &            MAXM = 1500, MAXNK = 10000 )

      REAL RK( MAXNK ), GMAG( MAXNK ), KMIN, KMAX
      COMPLEX CK( MAXM ), PHIS( MAXM ), PHIR( MAXM ),
     &        G( MAXNK ), WNO2
      CHARACTER TITLE*80

C     Read in various parameters

      OPEN( FILE = 'PLPFIL', UNIT = PLPFIL, STATUS = 'OLD' )
      READ( PLPFIL, * ) SRCD, RCVRD
      READ( PLPFIL, * ) NKPTS, STABIL
      READ( PLPFIL, * ) KMIN, KMAX

C     Get modal values

      CALL GETMOD( 1, ' ', MAXM, SRCD,  1, 'N',
     &                        CK, PHIS, M, FREQ, TITLE )
      CALL GETMOD( 1, ' ', MAXM, RCVRD, 1, 'N',
     &                        CK, PHIR, M, FREQ, TITLE )

C     Compute vector of k-values

      DELK = ( KMAX - KMIN ) / ( NKPTS - 1 )

      DO J = 1, NKPTS
         RK( J ) = KMIN + ( J - 1 ) * DELK
      END DO

C     *** Evaluate Green's function ***

      DO J = 1, NKPTS
         G( J ) = 0.0
         WNO2 = ( RK( J ) + CI * STABIL ) ** 2

         DO L = 1, M
            G( J ) = G( J ) + PHIS( L ) * PHIR( L ) /
     &                         ( WNO2 - CK( L ) **2 )
         END DO

         G( J )    = 2.0 * G( J )
         GMAG( J ) = ABS( G( J ) )
      END DO ! next k-point

C     *** Write data ***

      LAST = INDEX( TITLE, '    ' ) - 1
      WRITE( PRTFIL, 1000 ) TITLE(1:LAST)
 1000 FORMAT( '@ title "', A, '"' )

      WRITE( PRTFIL, 2000 ) NINT( FREQ ), NINT( SRCD ), NINT( RCVRD )
 2000 FORMAT(  '@ subtitle "',
     &         'F  =', I4, ' Hz, ',
     &         'Sd =', I4, ' m,  ',
     &         'Rd =', I4, ' m"' )
 
      DO IK = 1, NKPTS
         WRITE( PRTFIL, * ) RK( IK ), GMAG( IK )
      END DO

      STOP
      END

      PROGRAM BART

C     Takes covariance matrix and replica shade file and computes a Bartlett
C     surface

      INTEGER REPFIL, COVFIL, AMSFIL
      PARAMETER ( REPFIL = 20, COVFIL = 21, AMSFIL = 25,
     &   MAXNSD = 4094, MAXNRD = 4094, MAXNR = 4094,
     &   MXPHONES = 50, TOL = 0.0001 )

      INTEGER IRDREP( MAXNRD )
      REAL    R( MAXNR ), SD( MAXNSD ), RD( MAXNRD ), SURF( 1 ),
     &        RDREP( MAXNRD )
      COMPLEX P( MXPHONES, MAXNR ), PB( MAXNR ),
     &        COV( MXPHONES, MXPHONES )
      CHARACTER TITLE*80, TITLEREP*80, PLTTYP*10

      POWERMAX = 0.0
      ISDMAX   = 0
      IRMAX    = 0

C     *** Read covariance matrix ***

      OPEN ( FILE = 'COVFIL', UNIT = COVFIL, STATUS = 'OLD' )

      READ( COVFIL, * ) TITLE
      READ( COVFIL, * ) FREQ
      READ( COVFIL, * ) NRD

      IF ( NRD .GT. MXPHONES ) STOP "NRD > MXPHONES"

      DO IRD = 1, NRD
         READ( COVFIL, * ) RD( IRD )
      END DO

      DO I = 1, NRD
         DO J = 1, NRD
            READ( COVFIL, * ) I1, J1, COV( I, J )
         END DO
      END DO

C     *** Form power field (SURF = 1.0) ***

C     *** Read replica file header ***

      CALL RDHEAD( REPFIL, 'REPFIL', MAXNR, MAXNSD, MAXNRD,
     &   FREQREP, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &   SD, NSD, RDREP, NRDREP, TITLEREP )

      IF ( FREQ .NE. FREQREP ) THEN
         WRITE( *, * ) 'Mismatch in frequencies'
         STOP
      ENDIF

C     --- Find pointers to receiver depths in replica file

      DO IRD = 1, NRD
         IRDREP( IRD ) = NEIGH( RD( IRD ), RDREP, NRDREP )
         IF ( ABS( RDREP( IRDREP( IRD ) ) - RD( IRD ) ) .GT. TOL )
     &      STOP "No matching depth in replica file"
      END DO

C     *** Form header for power field (SURF = 1.0)

      SURF( 1 )  = 1.0
      NSURF = 1

      CALL HEADER( TITLE, SURF, NSURF, SD, NSD,
     &   R, NR, FREQ, ATTEN, PLTTYP, XS, YS, THETA )

      IRECOUT = 6

C     *** Loop over trial source depths ***

      DO ISD = 1, NSD

         DO IRD = 1, NRD
C           --- read in replica vector
            IRECIN = 6 + NRD * ( ISD - 1 ) + IRDREP( IRD )
            READ ( REPFIL, REC = IRECIN ) ( P( IRD, IR ), IR = 1, NR )
         END DO

C        *** Loop over source ranges ***

         DO IR = 1, NR

C           *** form Pb = e* R e taking advantage of symmetry ***

            POWER  = 0.0
            SUMREP = 0.0
            DO I = 1, NRD

               IF ( I .LT. NRD ) THEN
               DO J = I+1, NRD
                  POWER = POWER + 2.0 * REAL( 
     &            CONJG( P( I, IR ) ) * COV( I, J ) * P( J, IR ) )
               END DO
               END IF

C              --- diagonal terms
               POWER = POWER +
     &            CONJG( P( I, IR ) ) * COV( I, I ) * P( I, IR )

C              --- sum for norm of replica vector
               SUMREP = SUMREP + CONJG( P( I, IR ) ) * P( I, IR )
            END DO

C           --- Normalize
            IF( SUMREP .NE. 0.0 ) THEN
C              --- take sqrt to go from power back to amplitude
C              --- take reciprocal to get proper sign in plot

               IF ( TITLE(1:12) .NE. 'Unnormalized' ) 
     &            POWER = POWER / SUMREP

C              --- make note of peak location
               IF ( POWER .GT. POWERMAX ) THEN
                  POWERMAX = POWER
                  ISDMAX   = ISD
                  IRMAX    = IR
               ENDIF

               PB( IR ) = 1.0 / SQRT( POWER )
            ELSE
               PB( IR ) = 0.0
            ENDIF
         END DO        ! next source range

C        --- Write out Bartlett power vector
         IRECOUT = IRECOUT + 1
         WRITE( AMSFIL, REC = IRECOUT ) ( PB( IR ), IR = 1, NR )

      END DO        ! next source depth

C      WRITE( *, * ) 'Peak power   = ', POWERMAX
C      WRITE( *, * ) 'Source depth = ', SD( ISDMAX )
C      WRITE( *, * ) 'Source range = ', R(   IRMAX )

      WRITE( *, * ) R( IRMAX ), SD( ISDMAX )

      STOP
      END

      COMPLEX FUNCTION PC( X0, X, F, N, ERRMSG)

C     Polynomial approximant at X0
C     Limited to N = 10 (or so)

      PARAMETER ( MAXN = 10 )

      COMPLEX X0, X( N ), F( N ), FT( MAXN ), H( MAXN )
      CHARACTER*80 ERRMSG

      ERRMSG = ' '

C     ------ Initialize arrays
      DO K = 1, N
         H(  K ) = X( K ) - X0
         FT( K ) = F( K )
      END DO

C     ------ Recursion for solution
      IF ( N .GE. 2) THEN
         DO I = 1, N-1
            DO J = 1, N-I
               FT(J) = ( H(J+I) * FT(J) - H(J) * FT(J+1) ) /
     &                         ( H(J+I) - H(J) )
            END DO
         END DO
      ENDIF

      PC = FT( 1 )

      RETURN
      END

      PROGRAM KRAKENC

C     Program for solving for ocean acoustic normal modes

C     Michael B. Porter

      INCLUDE 'comc.f'

      REAL*4 ZMIN, ZMAX

      NV( 1 ) = 1
      NV( 2 ) = 2
      NV( 3 ) = 4
      NV( 4 ) = 8
      NV( 5 ) = 16

C     *** Read in environmental info ***

      TITLE = 'KRAKENC-'

      CALL READIN( TITLE, FREQ, MAXMED, NMEDIA,
     &   TOPOPT, CPT, CST, RHOT, BUMDEN, ETA, XI, NG, SIGMA, DEPTH, 
     &   BOTOPT, CPB, CSB, RHOB,
     &   ENVFIL, PRTFIL )

C     *** Spectral limits ***

      READ(  ENVFIL, *    ) CLOW, CHIGH
      WRITE( PRTFIL, 500  ) CLOW, CHIGH
  500 FORMAT( /, ' CLOW = ', G12.5, '  CHIGH = ', G12.5 )

C     *** Maximum range for calculations ***

      READ(  ENVFIL, * ) RMAX
      WRITE( PRTFIL, * ) 'RMAX = ', RMAX

C     *** Read source/receiver depths ***

      ZMIN = DEPTH( 1 )
      ZMAX = DEPTH( NMEDIA + 1 )

      CALL SDRD( ENVFIL, PRTFIL, ZMIN, ZMAX,
     &   MAXNSD, NSD, SD,
     &   MAXNRD, NRD, RD )

      OMEGA2 = ( 2.0 * PI * FREQ ) ** 2

C     *** Optionally read in bottom reflection coefficient data ***

      DEGRAD = PI / 180.0

      IF ( BOTOPT(1:1) .EQ. 'F' ) THEN
         WRITE( PRTFIL, * )
     &      'Using tabulated bottom reflection coefficient'
         OPEN( FILE = 'BRCFIL', UNIT = BRCFIL )
         READ( BRCFIL, * )
     &      NBPTS, ( THETAB( I ), RB( I ), PHIB( I ), I = 1, NBPTS )

         DO I = 1, NBPTS
            PHIB( I ) = -DEGRAD * PHIB( I )
         END DO
      ENDIF

C     *** Optionally read in top reflection coefficient data ***

      IF ( TOPOPT(2:2) .EQ. 'F' ) THEN
         OPEN( FILE = 'TRCFIL', UNIT = TRCFIL )
         WRITE( PRTFIL, * ) 'Using tabulated top reflection coefficient'
         READ( TRCFIL, * )
     &      NTPTS, ( THETAT( I ), RT( I ), PHIT( I ), I = 1, NTPTS )

         DO I = 1, NTPTS
            PHIT( I ) = DEGRAD * PHIT( I )
         END DO
      ENDIF

C     *** Optionally read in internal reflection coefficient data ***

      IF ( BOTOPT(1:1) .EQ. 'P' ) THEN
         OPEN( FILE = 'IRCFIL', UNIT = IRCFIL )
         WRITE( PRTFIL, * ) 'Reading precalculated refl. coeff. table'
         READ( IRCFIL, * ) NKPTS,
     &      ( XTAB(IK), FTAB(IK), GTAB(IK), ITAB(IK), IK = 1, NKPTS )
         IF ( NKPTS .GT. MXREF ) THEN
            WRITE( PRTFIL, * ) 'NKPTS, MXREF = ', NKPTS, MXREF
            CALL ERROUT( PRTFIL, 'F', 'KRAKENC',
     &             'Too many k-points in IRC file' )
         ENDIF
      ENDIF

      CLOSE( ENVFIL )

      M = MAXM

C     *** Main loop: solve the problem for a sequence of meshes ***

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Mesh multiplier   CPU seconds'

      DO ISET = 1, NSETS

         DO MED = 1, NMEDIA
            N( MED ) = NG( MED ) * NV( ISET )
            H( MED ) = ( DEPTH( MED + 1 ) - DEPTH( MED ) ) / N( MED )
         END DO

         HV( ISET ) = H( 1 )

         CALL SOLVE( ERROR )

         IF ( RMAX .EQ. 0.0 ) GOTO 3000
         IF ( ERROR .LT. 1.0 / ( 1000.0 * RMAX ) ) GOTO 3000
      END DO

C     --- Fall through indicates failure to converge
      CALL ERROUT( PRTFIL, 'W', 'KRAKENC',
     &             'Too many meshes needed: check convergence' )

C     Solution complete: discard modes with phase velocity above CHIGH

 3000 OMEGA = SQRT( OMEGA2 )
      DO MODE = M, 1, -1
         IF ( OMEGA / DBLE( SQRT( EXTRAP( 1, MODE ) ) ) .LT. CHIGH )
     &                            GOTO 5000
      END DO
 5000 M = MODE

C     *** Write eigenvalues to PRTFIL and MODFIL ***

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * )
     &   '   I           K                ALPHA         PHASE SPEED'

      DO MODE = 1, M
         CK( MODE ) = SQRT( EXTRAP( 1, MODE ) + CK( MODE ) )
         WRITE( PRTFIL, 6000 ) MODE,
     &                         CK( MODE ), OMEGA / DBLE( CK( MODE ) )
 6000    FORMAT( I5, 3G19.10 )

C        Zero out positive imaginary part which would cause
C        growth in range. Should be a small number.

C        --- use DIMAG for f77, AIMAG for f90 below
         IF ( DIMAG( CK( MODE ) ) .GT. 0.0 )
     &               CK( MODE ) = REAL( CK( MODE ) )
      END DO

      WRITE( MODFIL, REC = 5 ) M, LRECL

      IFIRST = 1
      DO IREC = 1, 1 + ( 2 * M - 1 ) / LRECL

         ILAST  = MIN( M, IFIRST + LRECL / 2 - 1 )
         WRITE( MODFIL, REC = 6 + M + IREC )
     &         ( CMPLX( CK( MODE ) ), MODE = IFIRST, ILAST )

         IFIRST = ILAST + 1
      END DO

      STOP
      END
C**********************************************************************C
      SUBROUTINE INIT

C     Initializes arrays defining difference equations

      INCLUDE 'comc.f'

      LOGICAL ELFLAG
      COMPLEX*16 CP( MAXN ), CS( MAXN ), CP2, CS2

      COMMON /SPACE/ CP, CS, DUMMY( 4 * MAXN )

      ELFLAG   = .FALSE.
      CMIN     = 1.0E6
      NFACT    = 0
      LOC( 1 ) = 0

C     *** Loop over media ***

      DO MED = 1, NMEDIA
         IF ( MED .NE. 1 ) LOC( MED ) = LOC( MED-1 ) + N( MED-1 ) + 1
         N1 = N(   MED ) + 1
         I  = LOC( MED ) + 1

         IF ( LOC( MED ) + N1 .GT. MAXN )
     &      CALL ERROUT( PRTFIL, 'F', 'KRAKENC',
     &             'Insufficient storage for mesh: '//
     &             'Reduce mesh size or change program dimensions' )

C        *** PROFIL reads in the data for a medium ***

         CALL PROFIL( DEPTH, CP( I ), CS( I ), RHO( I ),
     &      MED, N1, FREQ, TOPOPT(1:1), TOPOPT(3:3), 'TAB' )

C        *** Load diagonals of the finite-difference equations ***

         IF ( CS( I ) .EQ. ( 0.0, 0.0 ) ) THEN

C           --- Case of an acoustic medium ---

            MATER( MED ) = 'ACOUSTIC'
            IF ( NFACT .EQ. 0 ) NFACT = MED
            NLACT = MED

            DO J = I, I + N( MED )
               CMIN = MIN( DBLE( CP( J ) ), CMIN )
               B1( J ) = -2.0 +  H( MED ) ** 2 * OMEGA2 / CP( J ) ** 2
            END DO
         ELSE

C           --- Case of an elastic medium ---

            IF ( SIGMA( MED ) .NE. 0.0 )
     &         CALL ERROUT( PRTFIL, 'F', 'KRAKENC',
     &               'Rough elastic interfaces are not allowed' )

            MATER( MED ) = 'ELASTIC'
            ELFLAG = .TRUE.
            TWOH   = 2.0 * H( MED )

            DO J = I, I + N( MED )
               CMIN = MIN( DBLE( CS( J ) ), CMIN )

               CP2 = CP( J ) ** 2
               CS2 = CS( J ) ** 2

               B1( J ) = TWOH / ( RHO( J ) * CS2 )
               B2( J ) = TWOH / ( RHO( J ) * CP2 )
               B3( J ) = 4.0 * TWOH * RHO(J) * CS2 * ( CP2 - CS2 ) / CP2
               B4( J ) = TWOH * ( CP2 - 2.0*CS2 ) / CP2

               RHO( J ) = TWOH * OMEGA2 * RHO( J )
            END DO

         ENDIF
C        --- Next MED:
      END DO

C     *** Bottom properties ***

      IF ( BOTOPT(1:1) .EQ. 'A' ) THEN
         IF ( CSB .NE. ( 0.0, 0.0 ) ) THEN
C           --- Elastic bottom:
            ELFLAG = .TRUE.
            CMIN = MIN( CMIN, DBLE( CSB ) )
         ELSE
C           --- Acoustic bottom:
            CMIN = MIN( CMIN, DBLE( CPB ) )
         ENDIF
      ENDIF

C     *** Top properties ***

      IF ( TOPOPT(2:2) .EQ. 'A' ) THEN
         IF ( CST .NE. ( 0.0, 0.0 ) ) THEN
C           --- Elastic top:
            ELFLAG = .TRUE.
            CMIN = MIN( CMIN, DBLE( CST ) )
         ELSE
C           --- Acoustic top:
            CMIN = MIN( CMIN, DBLE( CPT ) )
         ENDIF
      ENDIF

      IF ( ELFLAG ) CMIN = 0.85 * CMIN
      CLOW = MAX( CLOW, 0.99 * CMIN )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SOLVE( ERROR )

C     Solves the eigenvalue problem at the current mesh
C     and produces a new extrapolation

      INCLUDE 'comc.f'

      COMPLEX*16 T1, T2, F1, F2

      CALL CLTIME   ! clear the timer
      CALL INIT     ! set up the finite difference mesh
      CALL SOLVE2   ! solve for the eigenvalues

      DO MODE = 1, M
         EXTRAP( ISET, MODE ) = EVMAT( ISET, MODE )
      END DO

C     *** If this is the first mesh, compute the eigenvectors ***

      IF ( ISET .EQ. 1 ) CALL VECTOR

C     *** Richardson extrapolation to improve the accuracy ***

      ERROR = 10
      KEY = 2 * M / 3 + 1   ! index of element used to check convergence

      IF ( ISET .GT. 1 ) THEN
         T1 = EXTRAP( 1, KEY )

         DO J = ISET - 1, 1, -1
            DO MODE = 1, M
               X1 = NV( J    ) ** 2
               X2 = NV( ISET ) ** 2
               F1 = EXTRAP( J,     MODE )
               F2 = EXTRAP( J + 1, MODE )
               EXTRAP( J, MODE ) = F2 - ( F1 - F2 ) / ( X2 / X1 - 1.0 )
            END DO
         END DO

         T2 = EXTRAP( 1, KEY )
         ERROR = ABS( T2 - T1 )
      ENDIF

      CALL RDTIME( TEND )   ! check elapsed time
      ET( ISET ) = TEND
      WRITE( PRTFIL, 5000 ) NV( ISET ), ET( ISET )
 5000 FORMAT( 1X, I8, 6X, G15.3 )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SOLVE2

C     Provides initial guess to root finder for each EVMAT(I)

C     A sequence of restarts is done to compute a complete set of modes
C     for the first two sets (ISET=1,2).
C     'Complete' in this case means that all the modes in the
C     user-specified interval are found. However, if, for ISET=2,
C     the same number of modes is found as for ISET=1 then it is assumed
C     that the set is complete and no restarts are performed.

      INCLUDE 'comc.f'

      INTEGER ISEED( 4 )
      REAL*4 RAN
      COMPLEX*16 X, P( 10 ), XTEMP( MAXM ), CTRY
      CHARACTER*80 ERRMSG

      SAVE ISEED
      DATA ISEED /2301, 4562, 3219, 1823/

      X = ( 1.0, 0.0 ) * OMEGA2 / CLOW ** 2
      MAXIT = 5000   ! maximum # of iterations in root-finder

C     --- MXTRIES = # of restarts for the root finder
C     --- ITRY = counter that keeps track of # of tries

      IF ( TOPOPT(4:4) .EQ. '.' .AND. ISET .LE. 2 ) THEN
         MXTRIES = MAXM
      ELSE
         MXTRIES = 1
      ENDIF
      ITRY = 1

C     --- compute size of matrix (used to check grid is fine enough)
      NTOT = 0
      DO MED = NFACT, NLACT
         NTOT = NTOT + N( MED )
      END DO

      DO MODE = 1, M

C        For first or second meshes, use a high guess
C        Otherwise use extrapolation to produce an initial guess

 5500    CONTINUE
         X = 1.00001 * X

         IF ( ISET .GE. 2 ) THEN
            DO I = 1, ISET - 1
               P( I ) = EVMAT( I, MODE )
            END DO

            IF ( ISET .GE. 3 ) THEN
               DO I = 1, ISET - 2
                  DO J = 1, ISET - I - 1
                     X1 = HV( J     ) ** 2
                     X2 = HV( J + I ) ** 2
                     P( J ) = ( ( HV( ISET ) ** 2 - X2 ) * P( J     ) -
     &                          ( HV( ISET ) ** 2 - X1 ) * P( J + 1 ) )
     &                                  / (  X1 - X2)
                  END DO
               END DO
               X = P( 1 )
            ENDIF
         ENDIF

C        *** Use the secant method to refine the eigenvalue ***

         TOL = 10000.0 * MACHEP * ABS( X )
         CALL ZSECCX( X, TOL, IT, MAXIT, ERRMSG )

C        --- any problems in root finder?

         IF ( ERRMSG .NE. ' ' ) THEN
            WRITE( PRTFIL, * ) 'ISET = ', ISET, '   MODE = ', MODE
            CALL ERROUT( PRTFIL, 'W', 'KRAKENC-ZSECCX', ERRMSG )
            X = 1.0E-9   ! make sure value discarded later
         ENDIF

C        *** Is the mode inside the user specified spectral limits? ***

         IF ( SQRT( OMEGA2 ) / REAL( SQRT( X ) ) .GT. CHIGH ) THEN
C           --- Mode outside, restart at a random point
            CTRY = CLOW     + RAN( ISEED ) * ( CHIGH - CLOW )
     &      + ( 0.0, 0.01 ) * RAN( ISEED ) * CLOW
         
            X = ( 1.0, 0.0 ) * OMEGA2 / CTRY ** 2

            IF ( ITRY .LT. MXTRIES ) THEN
               MXTRIES = MAX( MXTRIES, 5 * MODE )
               ITRY = ITRY + 1
               WRITE( *, * ) 'Restart at phase speed = ', CTRY
               GOTO 5500
            ELSE
               M = MODE - 1
               GOTO 6000   ! done searching for modes
            ENDIF
         ENDIF

C        *** Are we getting too many modes for the grid? ***

         IF ( MODE .GT. NTOT / 5 ) THEN

            CALL ERROUT( PRTFIL, 'W', 'KRAKENC',
     &      'Mesh too coarse to compute all the modes in the spectrum: '
     &      //'Increase the mesh size' )
  
            M = MODE
            EVMAT( ISET, MODE ) = X
            XTEMP( MODE )       = X
            GOTO 6000   ! done searching for modes
         ENDIF

         EVMAT( ISET, MODE ) = X
         XTEMP( MODE )       = X

      END DO   ! next mode

C     --- If no modes, open a dummy MODFIL for use by FIELD3D

 6000 IF ( M .EQ. 0 ) THEN
         LRECL = 32
         NZTAB = 0
         OPEN ( FILE = 'MODFIL', UNIT = MODFIL, STATUS = 'NEW',
     &      ACCESS = 'DIRECT', RECL = 4 * LRECL,
     &      FORM = 'UNFORMATTED' )
         WRITE( MODFIL, REC = 1 ) LRECL, TITLE,
     &                            REAL( FREQ ), 1, NZTAB, NZTAB
         WRITE( MODFIL, REC = 5 ) M, LRECL

         CALL ERROUT( PRTFIL, 'F', 'KRAKENC',
     &                'No modes for given phase speed interval' )

      ENDIF

C     --- Check whether we have hit the ceiling on max # modes

      IF ( M .EQ. MAXM ) THEN
         WRITE( PRTFIL, * ) 'Number of modes = ', M
         WRITE( PRTFIL, * ) 'Number of modes allowable = ', MAXM
         CALL ERROUT( PRTFIL, 'W', 'KRAKENC',
     &     'Too many modes'//
     &     'Program will compute as many as it can' )
      ENDIF

      CALL ORDER( XTEMP, M )   ! order eigenvalues by real part

      DO MODE = 1, M
         EVMAT( ISET, MODE ) = XTEMP( MODE )
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE FUNCT( X, DELTA, IPOW )

C     FUNCT( X ) = 0 is the dispersion relation

      INCLUDE 'comc.f'

      PARAMETER ( ROOF = 1.0E5, FLOOR = 1.0E-5, IPOWR = 5, IPOWF = -5 )
      COMPLEX*16 X, DELTA, F, G, F1, G1
      CHARACTER BCTYPE*1

C     --- Bottom impedance
      BCTYPE(1:1) = BOTOPT(1:1)
      CALL BCIMP( X, BCTYPE, 'BOT', CPB, CSB, RHOB, F, G, IPOW )

C     --- Shoot through acoustic layers
      CALL ACOUST( X, F,  G,  IPOW  )

C     --- Top impedance
      BCTYPE(1:1) = TOPOPT(2:2)
      CALL BCIMP( X, BCTYPE, 'TOP', CPT, CST, RHOT, F1, G1, IPOW1 )

      DELTA = F * G1 - G * F1
      IPOW  = IPOW + IPOW1
C     --- squaring the dispersion reln. seems to make the
C         root-finder more robust
      delta = delta ** 2
      ipow  = 2 * ipow

C     *** Deflate previous roots ***

      IF ( MODE .GT. 1 ) THEN
         DELTA = DELTA / ( X - EVMAT( ISET, MODE-1 ) ) ** 2

         IF ( MODE .GT. 2 ) THEN
            DO J = 1, MODE-2
               DELTA = DELTA / ( X - EVMAT( ISET, J ) ) ** 2

C              --- Scale if necessary
   50          IF ( ABS( DBLE( DELTA ) ) .LT. FLOOR .AND.
     &                     ABS( DELTA )   .GT. 0.0) THEN
                  DELTA = ROOF * DELTA
                  IPOW  = IPOW - IPOWR
                  GOTO 50
               ENDIF

   60          IF ( ABS( DBLE( DELTA ) ) .GE. ROOF ) THEN
                  DELTA = FLOOR * DELTA
                  IPOW  = IPOW - IPOWF
                  GOTO 60
               ENDIF

            END DO
         ENDIF
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE ACOUST( X, F, G, IPOW )

C     Shoot through acoustic layers

      INCLUDE 'comc.f'

      COMPLEX*16 X, F, G, P0, P1, P2, H2K2
      PARAMETER ( ROOF = 1.0E5, FLOOR = 1.0E-5, IPOWR = 5, IPOWF = -5 )

      IF ( NFACT .EQ. 0 ) RETURN 

C     *** Loop over successive acoustic media ***

      DO MED = NLACT, NFACT, -1
         H2K2 = H( MED ) ** 2 * X
         I = LOC( MED ) + N( MED ) + 1
         RHOM = RHO( I )
         P1 = -2.0 * G
         P2 = ( B1( I ) - H2K2 ) * G - 2.0 * H( MED ) * F * RHOM

C        *** Shoot through a single medium ***

         DO I = LOC( MED ) + N( MED ), LOC( MED ) + 1, -1

            P0 = P1
            P1 = P2
            P2 = ( H2K2 - B1( I ) ) * P1 - P0

C           --- Scale if necessary
   60       IF ( ABS( DBLE( P2 ) ) .GE. ROOF ) THEN
               P0 = FLOOR * P0
               P1 = FLOOR * P1
               P2 = FLOOR * P2
               IPOW = IPOW - IPOWF
               GOTO 60
            ENDIF
         END DO

C        --- F = P'/RHO and G = -P since FP+GP'/RHO = 0
         RHOM = RHO( LOC( MED ) + 1 )
         F = -( P2 - P0 ) / ( 2.0 * H( MED ) ) / RHOM
         G = -P1
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE VECTOR

C     Do inverse iteration to compute each of the eigenvectors
C     and write these to the disk file

      INCLUDE 'comc.f'

      INTEGER IZTAB( MAXNZT )
      REAL Z( MAXN ), ZTAB( MAXNZT ), WTS( MAXNZT )
      COMPLEX PHITAB( MAXNZT )
      COMPLEX*16 RV1( MAXN ), RV2( MAXN ), RV3( MAXN ), RV4( MAXN ),
     &   PHI( MAXN ), D( MAXN ), E( MAXN ), W, XH2, X, F, G
      CHARACTER BCTOP*1, BCBOT*1

      COMMON /SPACE/ RV1, RV2, RV3, RV4

      EQUIVALENCE ( Z, D, PHI )

      BCTOP(1:1) = TOPOPT(2:2)
      BCBOT(1:1) = BOTOPT(1:1)

C     *** Tabulate z-coordinates and off-diagonals of matrix ***

      NTOT = 0
      J = 1
      Z( 1 ) = DEPTH( NFACT )

      DO MED = NFACT, NLACT
         HRHO = H( MED ) * RHO( LOC( MED ) + 1 )

         DO I = 1, N( MED )
            J = J + 1
            Z( J ) = Z( J - 1 ) + H( MED )
            E( J ) = 1.0 / HRHO
         END DO

         NTOT = NTOT + N( MED )
      END DO

      NTOT1 = NTOT + 1

C     Calculate the indices, weights, ... for mode interpolation

      CALL MERGEV( SD, NSD, RD, NRD, ZTAB, NZTAB )
      CALL WEIGHT( Z, NTOT1, ZTAB, NZTAB, WTS, IZTAB )

C     Open MODFIL and write header

C     --- Logical record length in `longwords' (4 bytes)
      LRECL = MAX( 2 * NZTAB, 32, 3 * ( NLACT - NFACT + 1 ) )

      OPEN ( FILE = 'MODFIL', UNIT = MODFIL, STATUS = 'NEW',
     &   ACCESS = 'DIRECT', RECL = 4 * LRECL, FORM = 'UNFORMATTED' )

      WRITE( MODFIL, REC = 1 ) LRECL, TITLE, REAL( FREQ ),
     &   NLACT - NFACT + 1, NZTAB, NZTAB
      WRITE( MODFIL, REC = 2 )
     &   ( N( MED ), MATER( MED ), MED = NFACT, NLACT )
      WRITE( MODFIL, REC = 3 )
     &   BCTOP(1:1), CMPLX( CPT ), CMPLX( CST ),
     &     REAL( RHOT ), REAL( DEPTH( 1          ) ),
     &   BCBOT(1:1), CMPLX( CPB ), CMPLX( CSB ),
     &     REAL( RHOB ), REAL( DEPTH( NMEDIA + 1 ) )
      WRITE( MODFIL, REC = 4 ) ( REAL( DEPTH( MED ) ),
     &   REAL( RHO( LOC( MED ) + 1 ) ), MED = NFACT, NLACT )
      WRITE( MODFIL, REC = 6 ) ( ZTAB( IZ ), IZ = 1, NZTAB )

C     *** Main loop: for each eigenvalue call SINVIT to get eigenvector

      DO MODE = 1, M
         W = 0.0
         X = EVMAT( 1, MODE )

C        *** Corner elt requires top impedance ***

         CALL BCIMP( X, BCTOP, 'TOP', CPT, CST, RHOT, F, G, IPOW )

         IF ( G .EQ. 0.0 ) THEN
            D( 1 ) = 1.0
            E( 2 ) = 0.0
         ELSE
            L = LOC( NFACT ) + 1
            XH2    = X * H( NFACT ) * H( NFACT )
            HRHO   = H( NFACT ) * RHO( L )
            D( 1 ) = ( B1( L ) - XH2 ) / HRHO / 2.0 + F / G
         ENDIF

C        *** Set up the diagonal ***

         ITP = NTOT
         J = 1
         L = LOC( NFACT ) + 1

         DO MED = NFACT, NLACT
            XH2  = X * H( MED ) ** 2
            HRHO = H( MED ) * RHO( LOC( MED ) + 1 )

            IF ( MED .GE. NFACT + 1 ) THEN
               L = L + 1
               D( J ) = ( D( J ) + ( B1( L ) - XH2 ) / HRHO ) / 2.0
            ENDIF

            DO I = 1, N( MED )
               J = J + 1
               L = L + 1
               D( J ) = ( B1( L ) - XH2 ) / HRHO
C              --- Locate index of turning point nearest top
               IF ( REAL( B1( L ) - XH2 ) + 2.0 .GT. 0.0 ) THEN
                  ITP = MIN( J, ITP )
               ENDIF
            END DO
         END DO

C        *** Corner elt requires bottom impedance ***

         CALL BCIMP( X, BCBOT, 'BOT', CPB, CSB, RHOB, F, G, IPOW )

         IF ( G .EQ. 0.0 ) THEN
            D( NTOT1 ) = 1.0
            E( NTOT1 ) = 0.0
         ELSE
            D( NTOT1 ) =  D( NTOT1 ) / 2.0 - F / G
         ENDIF

C        *** Use inverse iteration to compute eigenvector ***

         CALL SINVIT( NTOT1, D, E, W, PHI, IERR,
     &      RV1, RV2, RV3, RV4, PHI )

         IF ( IERR .NE. 0 ) THEN
            WRITE( PRTFIL, * ) 'MODE = ', MODE
            CALL ERROUT( PRTFIL, 'W', 'KRAKENC-SINVIT',
     &                   'Inverse iteration failed to converge' )
         ENDIF

C        *** Normalize the eigenvector ***

         CALL NORMIZ( PHI, ITP, NTOT1, X )

C        Tabulate the modes at the source depths and write to disk

         DO IZ = 1, NZTAB
            I = IZTAB( IZ )
            PHITAB( IZ ) = PHI( I ) +
     &         WTS(IZ) * ( PHI( I + 1 ) - PHI( I ) )
         END DO

         WRITE( MODFIL, REC = 6 + MODE )
     &      ( PHITAB( IZ ), IZ = 1, NZTAB )

      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE NORMIZ( PHI, ITP, NTOT1, X )

C     Normalize the eigenvector:
C        SQNRM = Integral(PHI ** 2) by the trapezoidal rule:
C        Integral(F) = H*( F(1)+...+F(N-1) + 0.5*(F(0)+F(N)) )

C     Compute perturbation due to material absorption
C     Call SCAT to figure interfacial scatter loss

      INCLUDE 'comc.f'

      COMPLEX*16 PHI(*), X, X1, F1, G1, X2, F2, G2,
     &   DRHODX, DETADX, SQNRM, RN, SCALE
      CHARACTER BCTYPE*1

      SQNRM = 0.0

C     *** Loop to compute norm of eigenvector ***

      J = 1

      DO MED = NFACT, NLACT
         RHOM = RHO( LOC( MED ) + 1 )

         SQNRM = SQNRM + 0.5 * H( MED ) * PHI( J ) ** 2 / RHOM

         DO I = 1, N( MED ) - 1
            J = J + 1
            SQNRM = SQNRM +    H( MED ) * PHI( J ) ** 2 / RHOM
         END DO

         J = J + 1
         SQNRM = SQNRM + 0.5 * H( MED ) * PHI( J ) ** 2 / RHOM

      END DO

C     *** Compute derivative of top admitance ***

      X1 = 0.9999999 * X
      X2 = 1.0000001 * X

      BCTYPE(1:1) = TOPOPT(2:2)

      CALL BCIMP( X1, BCTYPE, 'TOP', CPT, CST, RHOT, F1, G1, IPOW )
      CALL BCIMP( X2, BCTYPE, 'TOP', CPT, CST, RHOT, F2, G2, IPOW )

      DRHODX = 0.0
      IF ( G1 .NE. 0.0 ) THEN
         DRHODX = -( F2 / G2 - F1 / G1 ) / ( X2 - X1 )
      ENDIF

C     *** Compute derivative of bottom admitance ***

      BCTYPE(1:1) = BOTOPT(1:1)

      CALL BCIMP( X1, BCTYPE, 'BOT', CPB, CSB, RHOB, F1, G1, IPOW )
      CALL BCIMP( X2, BCTYPE, 'BOT', CPB, CSB, RHOB, F2, G2, IPOW )

      DETADX = 0.0
      IF ( G1 .NE. 0.0 ) THEN
         DETADX = -( F2 / G2 - F1 / G1 ) / ( X2 - X1 )
      ENDIF

C     *** Scale the mode ***

      RN = SQNRM + DRHODX * PHI( 1 ) ** 2 - DETADX * PHI( NTOT1 ) ** 2
      SCALE = 1.0 / SQRT( RN )
      IF ( REAL( PHI( ITP ) ) .LT. 0.0 ) SCALE = -SCALE

      DO J = 1, NTOT1
         PHI( J ) = SCALE * PHI( J )
      END DO

C     *** Compute interfacial scatter loss ***

      CALL SCAT( PHI, X )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SCAT( PHI, X )

C     Figure scatter loss

      INCLUDE 'comc.f'

      COMPLEX*16 PHI( * ), X, PERK, ETA1SQ, ETA2SQ,
     &   KUPING, U, PEKRT
      CHARACTER BCTYPE*1

      PERK = 0.0
      J = 1
      L = LOC( NFACT )

C     *** Loop over media ***

      DO MED = NFACT - 1, NLACT

C        *** Calculate RHO1, ETA1SQ, PHI, U ***

         IF ( MED .EQ. NFACT - 1 ) THEN
C           *** Top properties ***

            BCTYPE(1:1) = TOPOPT(2:2)

            IF ( BCTYPE(1:1) .EQ. 'A' ) THEN
C              --- Acousto-elastic
               RHO1   = RHOT
               ETA1SQ = X - OMEGA2 / CPT ** 2
               U      = PEKRT( ETA1SQ ) * PHI( 1 ) / RHOT

            ELSE IF ( BCTYPE(1:1) .EQ. 'V' ) THEN
C              --- Vacuum
               RHO1   = 1.0E-9
               ETA1SQ = 1.0
               RHOINS = RHO( LOC( NFACT ) + 1 )
               U      = PHI( 2 ) / H( NFACT ) / RHOINS

            ELSE IF ( BCTYPE(1:1) .EQ. 'R' ) THEN
C              --- Rigid
               RHO1   = 1.0E+9
               ETA1SQ = 1.0
               U      = 0.0
            ELSE
C              --- Tabulated
               RHO1   = 0.0
               ETA1SQ = 0.0
               U      = 0.0
            ENDIF
         ELSE
            H2 = H( MED ) ** 2
            J  = J + N( MED )
            L  = LOC( MED ) + N( MED ) + 1

            RHO1   = RHO( L )
            ETA1SQ = ( 2.0 + B1( L ) ) / H2 - X
            U      = ( -PHI( J-1 ) - 0.5 * ( B1(L)-H2*X ) * PHI( J ) )
     &                    / ( H( MED ) * RHO1 )
         ENDIF

C        *** Calculate RHO2, ETA2 ***

         IF ( MED .EQ. NLACT ) THEN
C           *** Bottom properties ***

            BCTYPE(1:1) = BOTOPT(1:1)

            IF ( BCTYPE(1:1) .EQ. 'A' ) THEN
C              --- Acousto-elastic
               RHO2   = RHOB
               ETA2SQ = OMEGA2 / CPB ** 2 - X

            ELSE IF ( BCTYPE(1:1) .EQ. 'V' ) THEN
C              --- Vacuum
               RHO2   = 1.0E-9
               ETA2SQ = 1.0

            ELSE IF ( BCTYPE(1:1) .EQ. 'R' ) THEN
C              --- Rigid
               RHO2   = 1.0E+9
               ETA2SQ = 1.0
            ELSE
C              --- Tabulated
               RHO2   = 0.0
               ETA2SQ = 0.0
            ENDIF
         ELSE
            RHO2   = RHO( L + 1 )
            ETA2SQ = ( 2.0 + B1( L + 1 ) ) / H( MED + 1 ) ** 2 - X
         ENDIF

         PERK = PERK + KUPING( SIGMA( MED + 1 ), ETA1SQ, RHO1,
     &                         ETA2SQ, RHO2, PHI( J ), U )

      END DO

      CK( MODE ) = PERK

      RETURN
      END
C**********************************************************************C
      SUBROUTINE ORDER( X, N )

C     Does an insertion sort of the complex vector X in order
C     of decreasing real part

C     At the Ith step, the first I-1 positions contain a sorted
C     vector.  We shall insert the Ith value into its place in that
C     vector shifting up to produce a new vector of length I.

      COMPLEX*16 X( * ), T

      IF ( N .EQ. 1 ) RETURN

      DO I = 2, N

         T = X( I )

         IF ( REAL( T ) .GT. REAL( X( 1 ) ) ) THEN
C           --- Goes in the first position
            CALL SHIFTINC( X, T, 1, I - 1 )

         ELSE IF ( REAL( T ) .GT. REAL( X( I - 1 ) ) ) THEN

C           *** Binary search for its place ***

            IRIGHT = I - 1
            ILEFT  = 1

 1000       IMID = ( ILEFT + IRIGHT ) / 2

            IF ( REAL( T ) .GT. REAL( X( IMID ) ) ) THEN
               IRIGHT = IMID
            ELSE
               ILEFT  = IMID
            ENDIF

            IF ( IRIGHT .GT. ILEFT + 1 ) GOTO 1000

C           --- Shift and insert
            CALL SHIFTINC( X, T, IRIGHT, I - 1 )

         ENDIF

      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SHIFTINC( X, T, I1, I2 )

C     Shift values (I1, I2) one position to the right
C     and insert T at position I1

      COMPLEX*16 X( * ), T

      DO K = I2, I1, -1
         X( K + 1 ) = X( K )
      END DO

      X( I1 ) = T

      RETURN
      END

      IMPLICIT REAL*8 (A-H, O-Z)

      INTEGER ENVFIL, PRTFIL, GRNFIL, BRCFIL, TRCFIL
      COMPLEX CI
      PARAMETER ( ENVFIL = 5, PRTFIL = 6, GRNFIL = 20,
     &   BRCFIL = 10, TRCFIL = 11, IRCFIL = 12,
     &   MAXN = 20001,  MXNK = 50001,  MAXMED = 50, MXREF = 5000,
     &   MAXNSD = 51, MAXNRD = 101,
     &   CI = ( 0.0, 1.0 ), PI = 3.1415926535898D0 )

      REAL SD, RD
      COMPLEX*16 B1, B2, B3, B4, CPT, CST, CPB, CSB
      COMMON /SHARE/ B1( MAXN ), B2( MAXN ), B3( MAXN ), B4( MAXN ),
     &   CPT, CST, CPB, CSB, RHOT, RHOB, RHO( MAXN ),
     &   CMIN, CLOW, CHIGH, OMEGA2,
     &   DEPTH( MAXMED ), H( MAXMED ), SIGMA( MAXMED ), RK( MXNK ),
     &   SD( MAXNSD ), RD( MAXNRD ),
     &   ATTEN, BUMDEN, ETA, XI, NSD, NRD,
     &   N( MAXMED ), LOC( MAXMED ),
     &   NFACT, NLACT, NMEDIA,
     &   NKPTS, NKCORE

      CHARACTER*8 MATER( MAXMED ), TOPOPT, BOTOPT
      COMMON /SHARE1/ MATER, TOPOPT, BOTOPT

      COMPLEX*16 FTAB, GTAB
      COMMON /REFLEC/ THETAB( MXREF ), RB( MXREF ), PHIB( MXREF),
     &                THETAT( MXREF ), RT( MXREF ), PHIT( MXREF),
     &                NBPTS, NTPTS
      COMMON /INTREF/ FTAB( MXREF ), GTAB( MXREF), XTAB( MXREF ),
     &                ITAB( MXREF ), NREF

      SUBROUTINE CFFT( DATA, N, IFORW )
      DIMENSION DATA( N )
      ISIGN = -IFORW
      IP0 = 2
      IP3 = IP0 * N
      I3REV = 1

      DO I3 = 1, IP3, IP0
         IF ( I3 .LT. I3REV ) THEN
            TEMPR = DATA(I3)
            TEMPI = DATA(I3 + 1)
            DATA(I3) = DATA(I3REV)
            DATA(I3 + 1) = DATA(I3REV + 1)
            DATA(I3REV) = TEMPR
            DATA(I3REV + 1) = TEMPI
         ENDIF
         IP1 = IP3 / 2
30       IF( I3REV .LE. IP1 ) GOTO 50
            I3REV = I3REV - IP1
            IP1 = IP1 / 2
            IF(IP1 .GE. IP0) GOTO 30
50       I3REV = I3REV + IP1
      END DO

      IP1 = IP0

60    IF(IP1 .GE. IP3) GOTO 100
      IP2 = IP1 * 2
      THETA = 6.283185307 / FLOAT(ISIGN * IP2 / IP0)  
      SINTH = SIN(THETA / 2.)
      WSTPR = -2. * SINTH * SINTH
      WSTPI = SIN(THETA)
      WR = 1.
      WI = 0.
      DO I1 = 1, IP1, IP0
         DO I3 = I1, IP3, IP2
            I2A = I3
            I2B = I2A + IP1
            TEMPR = WR * DATA(I2B) - WI * DATA(I2B + 1)
            TEMPI = WR * DATA(I2B + 1) + WI * DATA(I2B)
            DATA(I2B) = DATA(I2A) - TEMPR
            DATA(I2B + 1) = DATA(I2A + 1) - TEMPI
            DATA(I2A) = DATA(I2A) + TEMPR
            DATA(I2A + 1) = DATA(I2A + 1) + TEMPI
         END DO

         TEMPR = WR
         WR = WR * WSTPR - WI * WSTPI + WR
         WI = WI * WSTPR + TEMPR * WSTPI + WI
      END DO

      IP1 = IP2
      GO TO 60

100   RETURN
      END
C**********************************************************************C
      SUBROUTINE CFFTSC( C, N )

C     SCALE COMPLEX FORWARD FFT RESULTS

C     M. PORTER 4 / 1 / 88

      COMPLEX C( * )

      DO I  = 1, N
         C(I)  = C(I) / N
      ENDDO

      RETURN
      END

      SUBROUTINE READIN( TITLE, FREQ, ALPHA, NBEAMS, MXNBEAMS, ISINGL,
     &   NIMAGE, IBWIN, DELTAS, MXN, ZBOX, RBOX, EPMULT, RLOOP,
     &   SD, NSD, MXNSD, RD, NRD, MXNRD, R, NR, MXNR,
     &   RNG, DEP, TBR, TBZ, NBTYPTS, MXBTY,
     &   THETATOP, RTOP, PHITOP, NTOPPTS,
     &   THETABOT, RBOT, PHIBOT, NBOTPTS, MXREF,
     &   TOPOPT, DEPTHT, CPT, RHOT,
     &   BOTOPT,  DEPTHB, CPB, RHOB, RUNTYP, BEAMTYP )

C     Routine to read in and echo all the input data

C     Note that default values of SSP, DENSITY, Attenuation
C     will not work

      IMPLICIT REAL*4 ( A-H, O-Z )
      INTEGER ENVFIL, PRTFIL, BRCFIL, TRCFIL, BTYFIL, RAYFIL, ARRFIL
      PARAMETER ( ENVFIL =  5, PRTFIL =  6, BRCFIL = 31, TRCFIL = 32,
     &            BTYFIL = 41, RAYFIL = 21, ARRFIL = 36,
     &            PI = 3.14159265, DEGRAD = 2.0 * PI / 360.0 )

      REAL      SD( * ), RD( * ), R( * ), ALPHA( * ), LAMX10, LAMX66
      REAL*8    FREQD, RHOT, RHOB, BUMDEN, ETA, XI
      COMPLEX*16 CPT, CPB, CST, CSB
      CHARACTER TITLE*80, TOPOPT*4, BOTOPT*2, RUNTYP*2, BEAMTYP*2,
     &          SSPTYP*1, BCTYPE*1, ATUNIT*1

      REAL*8 RNG( * ), DEP( * ), TBR( * ), TBZ( * )
      REAL*8 THETABOT( * ), RBOT( * ), PHIBOT( * ),
     &       THETATOP( * ), RTOP( * ), PHITOP( * )

      REAL*8 ALPHAR, BETAR, ALPHAI, BETAI, RHOR
      COMMON /CPREV/ ALPHAR, BETAR, RHOR, ALPHAI, BETAI

      ALPHAR = 1500.0
      BETAR  = 0.0
      RHOR   = 1.0
      ALPHAI = 0.0
      BETAI  = 0.0
      ISINGL = 0

      TITLE(1:9) = 'BELLHOP- '
      READ(  ENVFIL, * ) TITLE(10:80)
      WRITE( PRTFIL, * ) TITLE

      READ(  ENVFIL, *    ) FREQ
      WRITE( PRTFIL, 1000 ) FREQ
 1000 FORMAT(' Frequency = ', G11.4, / )

      FREQD = FREQ

      READ(  ENVFIL, * ) NMEDIA
      WRITE( PRTFIL, * ) 'Dummy parameter NMEDIA = ', NMEDIA

C     ****** Read in SSP data ******

      READ(  ENVFIL, * ) TOPOPT
      WRITE( PRTFIL, * )

      SSPTYP(1:1) = TOPOPT(1:1)
      BCTYPE(1:1) = TOPOPT(2:2)
      ATUNIT(1:1) = TOPOPT(3:3)

C     *** Top BC ***

      IF ( BCTYPE(1:1) .EQ. 'A' ) WRITE( PRTFIL, 2000 )
 2000 FORMAT( //, '      Z          ',
     &      'ALPHAR     BETAR      RHO       ALPHAI     BETAI', / )

      CALL TOPBOT( ENVFIL, PRTFIL, FREQD, BCTYPE, ATUNIT,
     &   CPT, CST, RHOT, BUMDEN, ETA, XI )

      DEPTHT = 0.0   ! should be read in somewhere

C     *** Ocean SSP ***

      READ(  ENVFIL, * ) NPTS, SIGMA, DEPTHB
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Depth = ', DEPTHB

      IF ( TOPOPT(1:1) .EQ. 'A' ) THEN
         WRITE( PRTFIL, * ) 'Analytic SSP option'
      ELSE
         CALL SSP( RDUMMY, DEPTHB, C, CR, CZ, CRR, CRZ, CZZ,
     &             TOPOPT, 'INIT' )
      ENDIF

C     *** Bottom BC ***

      READ( ENVFIL, * ) BOTOPT, SIGMA

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, 3000 ) SIGMA
 3000 FORMAT( 33X, '( RMS roughness = ', G10.3, ' )' )

      CALL TOPBOT( ENVFIL, PRTFIL, FREQD, BOTOPT, ATUNIT,
     &    CPB, CSB, RHOB, BUMDEN, ETA, XI )

C     *** Read source/receiver depths ***

      CALL SDRD( ENVFIL, PRTFIL, DEPTHT, DEPTHB,
     &   MXNSD, NSD, SD,
     &   MXNRD, NRD, RD )

C     *** Read receiver ranges ***

      CALL RANGES( ENVFIL, PRTFIL, MXNR, NR, R )

C     *** Read run type ***

      READ(  ENVFIL, * ) RUNTYP(1:2)

      WRITE( PRTFIL, * )
      IF      ( RUNTYP(1:1) .EQ. 'R' ) THEN
         WRITE( PRTFIL, * ) 'Ray trace run'
      ELSE IF ( RUNTYP(1:1) .EQ. 'E' ) THEN
         WRITE( PRTFIL, * ) 'Eigenray trace run'
      ELSE IF ( RUNTYP(1:1) .EQ. 'I' ) THEN
         WRITE( PRTFIL, * ) 'Incoherent TL calculation'
      ELSE IF ( RUNTYP(1:1) .EQ. 'S' ) THEN
         WRITE( PRTFIL, * ) 'Semi-coherent TL calculation'
      ELSE IF ( RUNTYP(1:1) .EQ. 'C' ) THEN
         WRITE( PRTFIL, * ) 'Coherent TL calculation'
      ELSE IF ( RUNTYP(1:1) .EQ. 'A' ) THEN
         WRITE( PRTFIL, * ) 'Arrivals calculation'
      ELSE
         CALL ERROUT( PRTFIL, 'F', 'READIN',
     &                'Unknown RUNTYP selected' )
      ENDIF

      IF ( RUNTYP(2:2) .EQ. 'C' ) THEN
         WRITE( PRTFIL, * ) 'Cartesian beams'
      ELSE IF ( RUNTYP(2:2) .EQ. 'R' ) THEN
         WRITE( PRTFIL, * ) 'Ray centered beams'
      ELSE
         RUNTYP(2:2) = 'G'
         WRITE( PRTFIL, * ) 'Geometric beams'
      ENDIF

C     *** Read beam angles ***

      NBEAMS     = 0
      ALPHA( 3 ) = -999.9
      READ( ENVFIL, * ) NBEAMS, ( ALPHA( IBEAM ), IBEAM = 1, NBEAMS )

      IF ( NBEAMS .GT. MXNBEAMS ) THEN
         WRITE( PRTFIL, * ) 'NBEAMS, MXNBEAMS = ', NBEAMS, MXNBEAMS
         CALL ERROUT( PRTFIL, 'F', 'READIN', 'Too many beams'  )
      ENDIF

      CALL SUBTAB( ALPHA, NBEAMS )
      CALL SORT(   ALPHA, NBEAMS )

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Number of beams   = ', NBEAMS
      IF ( NBEAMS .GE. 1 ) WRITE( PRTFIL, * )
     &                ( ALPHA( IBEAM ), IBEAM = 1, MIN( NBEAMS, 51 ) )

C     --- convert to radians
      DO IBEAM = 1, NBEAMS
         ALPHA( IBEAM ) = DEGRAD * ALPHA( IBEAM )
      END DO

C     *** Limits for tracing beams ***

      READ(  ENVFIL, * ) DELTAS, ZBOX, RBOX

C     --- Automatic step size selection < 10 wavelengths

      IF ( DELTAS .EQ. 0.0 ) THEN

         LAMX10 =  15000.0 / FREQ               ! 10 wavelengths
         LAMX66 = 100000.0 / FREQ               ! 66 wavelengths
         DBY20  = ( DEPTHB - DEPTHT ) / 20.0
         IF      ( RUNTYP(1:1) .EQ. 'R' ) THEN
           DELTAS = MIN( LAMX66, DBY20 )
         ELSE IF ( RUNTYP(1:1) .EQ. 'E' ) THEN
           DELTAS = MIN( LAMX66, DBY20 )
         ELSE IF ( RUNTYP(1:1) .EQ. 'I' ) THEN
           DELTAS = MIN( LAMX66, DBY20 )
         ELSE IF ( RUNTYP(1:1) .EQ. 'S' ) THEN
           DELTAS = MIN( LAMX66, DBY20 )
         ELSE IF ( RUNTYP(1:1) .EQ. 'C' ) THEN
           DELTAS = MIN( LAMX10, DBY20 )
         ELSE IF ( RUNTYP(1:1) .EQ. 'A' ) THEN
           DELTAS = MIN( LAMX10, DBY20 )
         ENDIF

         DELTAS = MAX( DELTAS, RBOX / MXN )      ! at most do MXN steps
         DELTAS = MIN( DELTAS, DEPTHB - DEPTHT ) ! DELTAS < channel height 
      ENDIF

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Step length,     DELTAS = ', DELTAS
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Maximum ray depth, ZBOX = ', ZBOX
      WRITE( PRTFIL, * ) 'Maximum ray range, RBOX = ', RBOX

      RBOX = 1000.0 * RBOX

C     ****** Beam characteristics ******

C     note: curvature change can cause overflow in grazing case
C     suppress by setting BEAMTYP(2:2) = 'Z'
      IF ( RUNTYP(2:2) .EQ. 'G' ) THEN
         BEAMTYP(1:2) = 'MS'
         RLOOP        = 1.0
         EPMULT       = 1.0
      ELSE

         READ(  ENVFIL, * ) BEAMTYP(1:2), EPMULT, RLOOP, ISINGL
         WRITE( PRTFIL, * )
         WRITE( PRTFIL, * )
         WRITE( PRTFIL, * ) 'Type of beam = ', BEAMTYP(1:1)

         IF ( BEAMTYP(2:2) .EQ. 'D' ) THEN
            WRITE( PRTFIL, * ) 'Curvature doubling invoked'
         ELSE IF ( BEAMTYP(2:2) .EQ. 'Z' ) THEN
            WRITE( PRTFIL, * ) 'Curvature zeroing invoked'
         ELSE IF ( BEAMTYP(2:2) .EQ. 'S' ) THEN
            WRITE( PRTFIL, * ) 'Standard curvature condition'
         ELSE
            CALL ERROUT( PRTFIL, 'F', 'READIN',
     &                'Unknown curvature condition' )
         ENDIF

         WRITE( PRTFIL, * ) 'Epsilon multiplier', EPMULT
         WRITE( PRTFIL, * ) 'Range for choosing beam width', RLOOP
         WRITE( PRTFIL, * ) 'Index of beam to trace = ', ISINGL

C        ****** Images, windows ******

         READ(  ENVFIL, * ) NIMAGE, IBWIN
         WRITE( PRTFIL, * )
         WRITE( PRTFIL, * ) 'Number of images, NIMAGE = ', NIMAGE
         WRITE( PRTFIL, * ) 'Beam windowing parameter,  IBWIN = ', IBWIN

      ENDIF

      WRITE( PRTFIL, * )

C     *** Write appropriate header information ***

      IF ( RUNTYP(1:1) .EQ. 'R' .OR. RUNTYP(1:1) .EQ. 'E' ) THEN
         OPEN ( FILE = 'RAYFIL', UNIT = RAYFIL, FORM = 'FORMATTED' )
         WRITE( RAYFIL, * ) '''', TITLE(1:50), ''''
         WRITE( RAYFIL, * ) FREQ
         WRITE( RAYFIL, * ) NBEAMS
         WRITE( RAYFIL, * ) DEPTHT
         WRITE( RAYFIL, * ) DEPTHB
      ELSE IF ( RUNTYP(1:1) .EQ. 'A' ) THEN
         OPEN ( FILE = 'ARRFIL', UNIT = ARRFIL, FORM = 'FORMATTED' )
         WRITE( ARRFIL, * ) FREQ, NSD, NRD, NR
         WRITE( ARRFIL, * ) ( SD( I ), I = 1, NSD )
         WRITE( ARRFIL, * ) ( RD( I ), I = 1, NRD )
         WRITE( ARRFIL, * ) ( R( IR ), IR = 1, NR )
      ELSE
         CALL HEADER( TITLE, SD, NSD, RD, NRD,
     &               R, NR, FREQ, 0.0, '          ', 0.0, 0.0, 0.0 )
      END IF

      CLOSE( ENVFIL )

C     *** Optionally read in bottom bathymetry ***

      IF ( BOTOPT(2:2) .EQ. 'B' ) THEN
         WRITE( PRTFIL, * ) '*********************************'
         WRITE( PRTFIL, * )
     &      'Using bottom-bathymetry file'

         OPEN ( FILE = 'BTYFIL', UNIT = BTYFIL, STATUS = 'OLD' )
         READ(  BTYFIL, * ) NBTYPTS
         WRITE( PRTFIL, * ) 'Number of bathymetry points', NBTYPTS

         IF ( NBTYPTS .GT. MXBTY ) THEN
           WRITE( PRTFIL, * ) 'NBTYPTS, MXBTY = ', NBTYPTS, MXBTY
           CALL ERROUT( PRTFIL, 'F', 'READIN',
     &        'Too many bathymetry points'  )
         ENDIF

         WRITE( PRTFIL, * )
         WRITE( PRTFIL, * ) ' Range (km)  Depth (m)'
         DO I = 1, NBTYPTS
            READ(  BTYFIL, * ) RNG( I ), DEP( I )
            WRITE( PRTFIL, 4000 ) RNG( I ), DEP( I )
 4000       FORMAT( 2G11.3 )
            RNG( I ) = 1000.0 * RNG( I )   ! Convert km to m
         ENDDO

C        --- compute tangent to bottom
         DO I = 1, NBTYPTS - 1
            TBR( I ) = RNG( I + 1 ) - RNG( I )
            TBZ( I ) = DEP( I + 1 ) - DEP( I )
            RLEN = SQRT( TBR( I ) * TBR( I ) + TBZ( I ) * TBZ( I ) )
            TBR( I ) = TBR( I ) / RLEN
            TBZ( I ) = TBZ( I ) / RLEN
         END DO
      ELSE   ! no bathymetry give, use SSP depth for flat bottom
         NBTYPTS = 2
         RNG( 1 ) = 0.0
         DEP( 1 ) = DEPTHB
         RNG( 2 ) = RBOX
         DEP( 2 ) = DEPTHB
         TBR( 1 ) = 1.0
         TBZ( 1 ) = 0.0
      ENDIF

C     *** Optionally read in bottom reflection coefficient data ***

      IF ( BOTOPT(1:1) .EQ. 'F' ) THEN
         WRITE( PRTFIL, * )
     &      'Using tabulated bottom reflection coefficient'

         OPEN ( FILE = 'BRCFIL', UNIT = BRCFIL )
         READ( BRCFIL, * ) NBOTPTS,
     &      ( THETABOT( I ), RBOT( I ), PHIBOT( I ), I = 1, NBOTPTS )

         IF ( NBOTPTS .GT. MXREF ) THEN
           WRITE( PRTFIL, * ) 'NBOTPTS, MXREF = ', NBOTPTS, MXREF
           CALL ERROUT( PRTFIL, 'F', 'READIN',
     &        'Too many bottom reflection-coefficient points'  )
         ENDIF

         DO I = 1, NBOTPTS
            PHIBOT( I ) = DEGRAD * PHIBOT( I )
         END DO
      ENDIF

C     *** Optionally read in top reflection coefficient data ***

      IF ( TOPOPT(2:2) .EQ. 'F' ) THEN
         WRITE( PRTFIL, * ) 'Using tabulated top reflection coefficient'
         OPEN ( FILE = 'TRCFIL', UNIT = TRCFIL )
         READ( TRCFIL, * ) NTOPPTS,
     &      ( THETATOP( I ), RTOP( I ), PHITOP( I ), I = 1, NTOPPTS )

         IF ( NTOPPTS .GT. MXREF ) THEN
           WRITE( PRTFIL, * ) 'NTOPPTS, MXREF = ', NTOPPTS, MXREF
           CALL ERROUT( PRTFIL, 'F', 'READIN',
     &        'Too many top reflection-coefficient points'  )
         ENDIF

         DO I = 1, NTOPPTS
            PHITOP( I ) = DEGRAD * PHITOP( I )
         END DO
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SSP( R, Z, C, CR, CZ, CRR, CRZ, CZZ, OPT, TASK )

C     Call the particular profil routine based specified by TASK

C     SSP is expected to perform two tasks:
C        TASK = 'TAB'  then tabulate CP, CS, RHOT 
C        TASK = 'INIT' then initialize

      INTEGER PRTFIL
      PARAMETER ( PRTFIL = 6 )

      CHARACTER OPT*4, TASK*4

      IF      ( OPT(1:1) .EQ. 'N' ) THEN
         CALL N2LIN(  R, Z, C, CR, CZ, CRR, CRZ, CZZ, TASK )
      ELSE IF ( OPT(1:1) .EQ. 'C' ) THEN
         CALL CLIN(   R, Z, C, CR, CZ, CRR, CRZ, CZZ, TASK )
      ELSE IF ( OPT(1:1) .EQ. 'S' ) THEN
         CALL CCUBIC( R, Z, C, CR, CZ, CRR, CRZ, CZZ, TASK )
      ELSE IF ( OPT(1:1) .EQ. 'A' ) THEN
         CALL ANALYT( R, Z, C, CR, CZ, CRR, CRZ, CZZ, TASK )
      ELSE
         WRITE( PRTFIL, * ) 'Non-existent profile option: ', OPT(1:1)
         STOP
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE N2LIN( R, Z, C, CR, CZ, CRR, CRZ, CZZ, TASK )

C     N2-linear interpolation of SSP data

      INTEGER ENVFIL, PRTFIL
      PARAMETER ( ENVFIL = 5, PRTFIL = 6, MXSSP = 2001, PREC = 1.0E-6 )

      REAL ZV( MXSSP ), CV( MXSSP ), N2V( MXSSP ), N2ZV( MXSSP )
      CHARACTER TASK*4
      SAVE ZTMP, CTMP, ZV, CV, N2V, N2ZV, NSSP, LAYER

      IF ( TASK(1:4) .EQ. 'INIT' ) THEN

C        *** Section to read in SSP data ***

         WRITE( PRTFIL, * )
         WRITE( PRTFIL, * ) 'N2-Linear SSP option'
         WRITE( PRTFIL, * )
         WRITE( PRTFIL, * ) 'Sound speed profile:'

         DEPTH = Z
         NSSP  = 1

         DO IZ = 1, MXSSP

            READ(  ENVFIL, * ) ZTMP, CTMP
            ZV( IZ ) = ZTMP
            CV( IZ ) = CTMP
            WRITE( PRTFIL, * ) ZV( IZ ), CV( IZ )
            N2V( IZ ) = 1.0 / CV( IZ ) ** 2

            IF ( IZ .GT. 1 ) N2ZV( IZ - 1 )  = 
     &                ( N2V( IZ ) - N2V( IZ - 1 ) ) /
     &                (  ZV( IZ ) -  ZV( IZ - 1 ) )

C           ------ Have we read the last point?
            IF ( ABS( ZV( IZ ) - DEPTH ) .LT. PREC ) THEN
               LAYER = 1
               RETURN
            ENDIF

            NSSP = NSSP + 1

         END DO

C        ------ Fall through means too many points in the profile

         WRITE( PRTFIL, * ) 'Max. #SSP points: ', MXSSP
         CALL ERROUT( PRTFIL, 'F', 'N2LIN',
     &                'Number of SSP points exceeds limit' )

      ELSE

C        *** Section to return SSP info ***

         IF ( Z .LT. ZV( LAYER ) .OR. Z .GT. ZV( LAYER + 1 ) ) THEN

            DO IZ = 2, NSSP   ! Search for bracketting depths
               IF ( Z .LT. ZV( IZ ) ) THEN
                  LAYER = IZ - 1
                  GOTO 3000
               ENDIF
            END DO

         ENDIF


3000     CONTINUE

         W = ( Z - ZV( LAYER ) ) / ( ZV( LAYER + 1 ) - ZV( LAYER ) )

         C     = 1.0 / SQRT( ( 1.0 - W ) * N2V( LAYER )
     &                               + W * N2V( LAYER + 1 ) )
         CZ  = -0.5 * C * C * C * N2ZV( LAYER )
         CR  = 0.0
         CRR = 0.0
         CRZ = 0.0
         CRR = 0.0
         CZZ = 3.0 * CZ * CZ / C
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE CLIN( R, Z, C, CR, CZ, CRR, CRZ, CZZ, TASK )

C     C-linear interpolation of SSP data

      INTEGER ENVFIL, PRTFIL
      PARAMETER ( ENVFIL = 5, PRTFIL = 6, MXSSP = 2001, PREC = 1.0E-6 )

      REAL ZV( MXSSP ), CV( MXSSP ), CZV( MXSSP )
      CHARACTER TASK*4
      SAVE ZTMP, CTMP, ZV, CV, CZV, NSSP, LAYER

      IF ( TASK(1:4) .EQ. 'INIT' ) THEN

C        *** Section to read in SSP data ***

         WRITE( PRTFIL, * )
         WRITE( PRTFIL, * ) 'C-Linear SSP option'
         WRITE( PRTFIL, * )
         WRITE( PRTFIL, * ) 'Sound speed profile:'

         DEPTH = Z
         NSSP = 1

         DO IZ = 1, MXSSP

            READ(  ENVFIL, * ) ZTMP, CTMP
            ZV( IZ ) = ZTMP
            CV( IZ ) = CTMP
            WRITE( PRTFIL, * ) ZV( IZ ), CV( IZ )

            IF ( IZ .GT. 1 ) CZV( IZ - 1 )  = 
     &                ( CV( IZ ) - CV( IZ - 1 ) ) /
     &                ( ZV( IZ ) - ZV( IZ - 1 ) )

C           ------ Have we read the last point?
            IF ( ABS( ZV( IZ ) - DEPTH ) .LT. PREC ) THEN
               LAYER = 1
               RETURN
            ENDIF

            NSSP = NSSP + 1

         END DO

C        ------ Fall through means too many points in the profile

         WRITE( PRTFIL, * ) 'Max. #SSP points: ', MXSSP
         CALL ERROUT( PRTFIL, 'F', 'N2LIN',
     &                'Number of SSP points exceeds limit' )

      ELSE

C        *** Section to return SSP info ***

         IF ( Z .LT. ZV( LAYER ) .OR. Z .GT. ZV( LAYER + 1 ) ) THEN
            DO IZ = 2, NSSP   ! Search for bracketting depths
               IF ( Z .LT. ZV( IZ ) ) THEN
                  LAYER = IZ - 1
                  GOTO 3000
               ENDIF
            END DO

         ENDIF

 3000    CZ  = CZV( LAYER )
         C   = CV( LAYER ) + ( Z - ZV( LAYER ) ) * CZ
         CR  = 0.0
         CRR = 0.0
         CRZ = 0.0
         CRR = 0.0
         CZZ = 0.0
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE CCUBIC( R, Z, C, CR, CZ, CRR, CRZ, CZZ, TASK )

C     Cubic spline interpolation

      INTEGER ENVFIL, PRTFIL
      PARAMETER ( ENVFIL = 5, PRTFIL = 6, MXSSP = 2001, PREC = 1.E-6 )

      REAL ZV( MXSSP ), CV( MXSSP ), CVS( 4, MXSSP )
      CHARACTER TASK*4

      SAVE ZTMP, CTMP, ZV, CV, CVS, NSSP, LAYER

      IF ( TASK(1:4) .EQ. 'INIT' ) THEN

C        *** Task 'INIT' for initialization ***

         WRITE( PRTFIL, * )
         WRITE( PRTFIL, * ) 'Spline SSP option'
         WRITE( PRTFIL, * )
         WRITE( PRTFIL, * ) 'Sound speed profile:'

         DEPTH = Z
         NSSP  = 1

         DO IZ = 1, MXSSP

            READ(  ENVFIL, * ) ZTMP, CTMP
            ZV( IZ ) = ZTMP
            CV( IZ ) = CTMP
            WRITE( PRTFIL, * ) ZV( IZ ), CV( IZ )

            CVS( 1, IZ ) = CV( IZ )

            IF ( ABS( ZV( IZ ) - DEPTH ) .LT. PREC ) THEN
               LAYER = 1

C              ------ Compute spline coefs
               IBCBEG = 0
               IBCEND = 0
               CALL CSPLINE( ZV, CVS(1, 1), NSSP, IBCBEG, IBCEND, NSSP )

               RETURN
            ENDIF

            NSSP = NSSP + 1

         END DO

C        ------ Fall through means too many points in the profile

         WRITE( PRTFIL, * ) 'Max. #SSP points: ', MXSSP
         CALL ERROUT( PRTFIL, 'F', 'N2LIN',
     &                'Number of SSP points exceeds limit' )

      ELSE

C        *** Section to return SSP info ***

         IF ( Z .LT. ZV( LAYER ) .OR. Z .GT. ZV( LAYER+1 ) ) THEN
            DO IZ = 2, NSSP   ! Search for bracketting depths
               IF ( Z .LT. ZV( IZ ) ) THEN
                  LAYER = IZ - 1
                  GOTO 3000
               ENDIF
            END DO

         ENDIF

 3000    HSPLNE = Z - ZV( LAYER )

C         C   = SPLINE(   CVS( 1, LAYER ), HSPLNE )
C         CZ  = SPLINEX(  CVS( 1, LAYER ), HSPLNE )
C         CZZ = SPLINEXX( CVS( 1, LAYER ), HSPLNE )

         CALL SPLINEALL( CVS( 1, LAYER ), HSPLNE, C, CZ, CZZ )

         CR  = 0.0
         CRR = 0.0
         CRZ = 0.0
         CRR = 0.0
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE TOPBOT( ENVFIL, PRTFIL, FREQ, BCTYPE, ATUNIT,
     &   CPHS, CSHS, RHOHS, BUMDEN, ETA, XI )

C     Handles top and bottom boundary conditions
C
C     Input:
C         ENVFIL: Environmental file
C         PRTFIL: Print file
C         FREQ:   Frequency
C         BCTYPE: Boundary condition type
C
C     Output:
C        CPHS:    P-wave speed in halfspace
C        CSHS:    S-wave speed in halfspace
C        RHOHS:   density in halfspace
C
C        BUMDEN:  Bump density
C        ETA:     Principal radius 1
C        XI:      Principal radius 2

      IMPLICIT NONE

      INTEGER ENVFIL, PRTFIL
      REAL*8 ALPHAR, BETAR, ALPHAI, BETAI, RHOR, FREQ, RHOHS,
     &   BUMDEN, ETA, XI, ZTMP
      COMPLEX*16 CPHS, CSHS, CRCI
      CHARACTER BCTYPE*1, ATUNIT*1

      COMMON /CPREV/ ALPHAR, BETAR, RHOR, ALPHAI, BETAI

C     *** Echo to PRTFIL user's choice of boundary condition ***

      IF ( BCTYPE(1:1) .EQ. 'S' ) THEN
         WRITE( PRTFIL, * ) '    Twersky SOFT BOSS scatter model'

      ELSE IF ( BCTYPE(1:1) .EQ. 'H' ) THEN 
         WRITE( PRTFIL, * ) '    Twersky HARD BOSS scatter model'

      ELSE IF ( BCTYPE(1:1) .EQ. 'T' ) THEN 
         WRITE( PRTFIL, * ) '    Twersky (amplitude only) SOFT BOSS ', 
     &                                       'scatter model'

      ELSE IF ( BCTYPE(1:1) .EQ. 'I' ) THEN 
         WRITE( PRTFIL, * ) '    Twersky (amplitude only) HARD BOSS ', 
     &                                       'scatter model'

      ELSE IF ( BCTYPE(1:1) .EQ. 'V' ) THEN 
         WRITE( PRTFIL, * ) '    VACUUM'

      ELSE IF ( BCTYPE(1:1) .EQ. 'R' ) THEN 
         WRITE( PRTFIL, * ) '    Perfectly RIGID'

      ELSE IF ( BCTYPE(1:1) .EQ. 'A' ) THEN
         WRITE( PRTFIL, * ) '    ACOUSTO-ELASTIC half-space'

      ELSE IF ( BCTYPE(1:1) .EQ. 'F' ) THEN 
         WRITE( PRTFIL, * ) '    FILE used for reflection loss'

      ELSE IF ( BCTYPE(1:1) .EQ. 'W' ) THEN 
         WRITE( PRTFIL, * ) '    Writing an IRC file'

      ELSE IF ( BCTYPE(1:1) .EQ. 'P' ) THEN
         WRITE( PRTFIL, * ) '    reading PRECALCULATED IRC'

      ELSE
         CALL ERROUT( PRTFIL, 'F', 'TOPBOT',
     &                'Unknown boundary condition type' )
      ENDIF

C     ****** Read in BC parameters depending on particular choice ******

      CPHS  = 0.0
      CSHS  = 0.0
      RHOHS = 0.0

C     *** Twersky ice model parameters ***

      IF ( BCTYPE(1:1) .EQ. 'S' .OR. BCTYPE(1:1) .EQ. 'H' .OR.
     &     BCTYPE(1:1) .EQ. 'T' .OR. BCTYPE(1:1) .EQ. 'I' ) THEN

         READ(  ENVFIL, *    ) BUMDEN, ETA, XI
         WRITE( PRTFIL, 1000 ) BUMDEN, ETA, XI
 1000    FORMAT( /, ' Twersky ice model parameters:', /, 
     &   ' Bumden = ', G15.6, '  Eta = ', G11.3, '  Xi = ', G11.3, /)
      ENDIF

C     *** Half-space properties ***

      IF ( BCTYPE(1:1) .EQ. 'A' ) THEN

         READ(  ENVFIL, *    ) ZTMP, ALPHAR, BETAR, RHOR, ALPHAI, BETAI
         WRITE( PRTFIL, 2000 ) ZTMP, ALPHAR, BETAR, RHOR, ALPHAI, BETAI
 2000    FORMAT( F10.2, 3X, 2F10.2, 3X, F6.2, 3X, 2F10.4 )

         CPHS = CRCI( ALPHAR, ALPHAI, FREQ, ATUNIT )
         CSHS = CRCI( BETAR,  BETAI,  FREQ, ATUNIT )
         RHOHS = RHOR
      ENDIF

      RETURN
      END
C**********************************************************************C
      FUNCTION CRCI( C, ALPHA, FREQ, ATUNIT )

C     Converts real wave speed and attenuation to a single
C     complex wave speed

C     6 CASES:    N for Nepers/meter
C                 M for dB/meter      (M for Meters)
C                 F for dB/m-kHZ      (F for Frequency dependent)
C                 W for dB/wavelength (W for Wavelength)
C                 Q for Q
C                 T for Thorp

      IMPLICIT REAL*8 (A-H, O-Z)
      COMPLEX*16 CRCI
      CHARACTER ATUNIT*1

      OMEGA = 2.0 * 3.1415926535897932 * FREQ

C     *** Convert to Nepers/m ***

      ALPHAT = 0.0

      IF      ( ATUNIT(1:1) .EQ. 'N' ) THEN
         ALPHAT = ALPHA
      ELSE IF ( ATUNIT(1:1) .EQ. 'M' ) THEN
         ALPHAT = ALPHA / 8.6858896
      ELSE IF ( ATUNIT(1:1) .EQ. 'F' ) THEN
         ALPHAT = ALPHA * FREQ / 8685.8896
      ELSE IF ( ATUNIT(1:1) .EQ. 'W' ) THEN
         IF ( C .NE. 0.0 ) ALPHAT = ALPHA * FREQ / ( 8.6858896 * C )
      ELSE IF ( ATUNIT(1:1) .EQ. 'Q' ) THEN
         IF( C * ALPHA .NE. 0.0 ) ALPHAT = OMEGA / ( 2.0 * C * ALPHA )
      ELSE IF ( ATUNIT(1:1) .EQ. 'T' ) THEN
         F2     = ( FREQ / 1000.0 ) **2
         ALPHAT = 40.0 * F2 / ( 4100.0 + F2 ) + 0.1*F2 / ( 1.0 + F2 )
         ALPHAT = ALPHAT / 914.4                 ! dB / m
         ALPHAT = ALPHAT / 8.6858896             ! Nepers / m
      ENDIF

C     *** Convert Nepers/m to equivalent imaginary sound speed ***

      ALPHAT = ALPHAT * C**2 / OMEGA
      CRCI   = CMPLX( C, ALPHAT )

      RETURN
      END

      SUBROUTINE ANALYT( DEPTH, CP, CS, RHO,
     &                     MED, N1, FREQ, ATUNIT, TASK )

C     MUNK PROFILE

C     RETURNS
C        CS, CP, RHO
C           FOR FLUID MEDIA AT I*H I = 1, N
C           FOR ELASTIC MEDIA AT I*H I = 0, N
C        AND DEPTHS OF INTERFACES

      IMPLICIT REAL*8 (A-H, O-Z)

      PARAMETER ( EPS = 0.00737 )
      COMPLEX*16 CP( N1 ), CS( N1 )
      REAL*8     RHO( N1 )
      CHARACTER  ATUNIT*1, TASK*8

C     Initialization is only important for providing a print-out of
C     the SSP for the user.  Unfortunately it overruns the array
C     RHO( 1 ) so we suppress it:

      IF ( TASK(1:4) .EQ. 'INIT' ) RETURN

      N = N1 - 1

      GOTO ( 1, 2, 9 ) MED

C     -------- MED 1, THE OCEAN
    1    H = 5000.0 / N
         DO I = 1, N1
            Z = ( I - 1 ) * H
            X = 2.0 * ( Z - 1300.0 ) / 1300.0
            CP(  I ) = 1500.0 * ( 1.0 + EPS * ( X - 1.0 + EXP( -X ) ) )
            CS(  I ) = 0.0
            RHO( I ) = 1.0
         END DO
         RETURN

C        -------- MED 2, THE FLUID HALF-SPACE
    2    CP(  1 ) = 1551.91
         CS(  1 ) = 0.0
         RHO( 1 ) = 1.0E20
         RETURN

C        -------- MED 9, AN ELASTIC LAYER
    9    H = 1000.0 / N
         Z = 5000.0
         DO I = 1,N+1
            CP( I ) = 4700.0 + ( Z - 5000.0 ) / 10.0
            CS( I ) = 2000.0 + ( Z - 5000.0 ) / 10.0
            CP( I ) = 4700.0
            CS( I ) = 2000.0
            RHO( I ) = 2.0
            Z = Z + H
         END DO

      RETURN
      END

      FUNCTION PEKRT( Z )

C     At one time, this was used to return the 'Pekeris branch cut'
C     which is just a particular branch of the square root that
C     exposes many 'leaky' or 'virtual' modes.

C     The current version implements a particular branch which was
C     convenient

      COMPLEX*16 PEKRT, Z

      IF ( REAL( Z ) .GE. 0.0 ) THEN
         PEKRT = SQRT( Z )
      ELSE
         PEKRT = (0.0, 1.0) * SQRT( -Z )
      ENDIF

      RETURN
      END

      PROGRAM SCOOTER

C     Finite element fast-field program
C     Michael B. Porter   8/85

      INCLUDE 'COMSCO.FOR'

      COMPLEX GREEN( 300000 )

      CALL CLTIME
      CALL GETPAR

      DO MED = 1, NMEDIA
         H( MED ) = ( DEPTH( MED + 1 ) - DEPTH( MED ) ) / N( MED )
      END DO

      CALL INIT
      CALL KERNEL( GREEN )
      CLOSE( GRNFIL )

      CALL RDTIME( TEND )
      WRITE(PRTFIL, 5000) TEND
 5000 FORMAT(' CPU TIME: ', G15.5)

      STOP
      END
C**********************************************************************C
      SUBROUTINE GETPAR

C     Read in the ENVFIL data

      INCLUDE 'COMSCO.FOR'

      CHARACTER*80 TITLE
      REAL*4 ZMIN, ZMAX

      TITLE = 'SCOOTER- '
      CALL READIN( TITLE, FREQ, MAXMED, NMEDIA,
     &   TOPOPT, CPT, CST, RHOT, BUMDEN, ETA, XI, N, SIGMA, DEPTH, 
     &   BOTOPT, CPB, CSB, RHOB,
     &   ENVFIL, PRTFIL )

C     *** Spectral limits ***

      READ(  ENVFIL, *    ) CLOW, CHIGH
      WRITE( PRTFIL, 6000 ) CLOW, CHIGH
 6000 FORMAT( /, ' CLOW = ', G12.5, '  CHIGH = ', G12.5 )

C     *** Maximum range for calculations ***

      READ(  ENVFIL, * ) RMAX
      WRITE( PRTFIL, * ) 'RMAX = ', RMAX

      IF ( RMAX .LE. 0.0 ) THEN
         CALL ERROUT( PRTFIL, 'F', 'GETPAR',
     &      'RMAX must be positive'  )
      ENDIF

C     *** Read source/receiver depths ***

      ZMIN = DEPTH( 1 )
      ZMAX = DEPTH( NMEDIA + 1 )

      CALL SDRD( ENVFIL, PRTFIL, ZMIN, ZMAX,
     &   MAXNSD, NSD, SD,
     &   MAXNRD, NRD, RD )

      CLOSE ( ENVFIL )
      OMEGA2 = ( 2.0 * PI * FREQ ) ** 2

C     *** Integration parameters ***

      RKMIN = 0.0
      IF ( CHIGH .NE. 0.0   ) RKMIN = SQRT( OMEGA2 ) / CHIGH
      IF ( CHIGH .GE. 1.0E6 ) RKMIN = 0.0

      IF ( CLOW .LE. 0.0 ) THEN
         WRITE( PRTFIL, * ) 'CLOW = ', CLOW
         CALL ERROUT( PRTFIL, 'F', 'GETPAR',
     &      'CLOW must be positive'  )
      ENDIF

      RKMAX = SQRT( OMEGA2 ) / CLOW

      NKPTS = 1000.0 * RMAX * ( RKMAX - RKMIN ) / PI
      WRITE( PRTFIL, * ) 'NKPTS = ', NKPTS

      IF ( NKPTS .GT. MXNK ) THEN
         WRITE( PRTFIL, * ) 'MXNK = ', MXNK
         CALL ERROUT( PRTFIL, 'F', 'GETPAR',
     &      'Too many pts in k-space'  )
      ENDIF

C     --- Set-up the vector of k-space points
      DELTAK = ( RKMAX - RKMIN ) / ( NKPTS - 1 )
      ATTEN  = DELTAK
      DO IK = 1, NKPTS
         RK( IK ) = RKMIN + ( IK - 1 ) * DELTAK
      END DO

      NSR = NSD * NRD
      NKCORE = MIN( 300000 / NSR, NKPTS, 4094 )
C     --- Write header for Green's function file
      CALL HEADER( TITLE, DELTAK, FREQ )

C     Optionally read in bottom reflection coefficient data

      DEGRAD = PI / 180.0
      IF ( BOTOPT(1:1) .EQ. 'F' ) THEN
         WRITE( PRTFIL, * )
     &                   'Using tabulated bottom reflection coefficient'
         READ( BRCFIL, * )
     &      NBPTS, ( THETAB( I ), RB( I ), PHIB( I ), I = 1, NBPTS )
         DO I = 1, NBPTS
            PHIB(I) = DEGRAD * PHIB(I)
         END DO
      ENDIF

C     Optionally read in top reflection coefficient data

      IF ( TOPOPT(2:2) .EQ. 'F' ) THEN
         WRITE( PRTFIL, * ) 'Using tabulated top reflection coefficient'
         READ( TRCFIL, * )
     &      NTPTS, ( THETAT( I ), RT( I ), PHIT( I ), I = 1, NTPTS )
         DO I = 1, NTPTS
            PHIT( I ) = DEGRAD * PHIT( I )
         END DO
      ENDIF

C     Optionally read in internal reflection coefficient data

      IF ( BOTOPT(1:1) .EQ. 'P' ) THEN
         WRITE( PRTFIL, * ) 'Reading precalculated refl. coeff. table'
         READ( IRCFIL ) NREF,
     &      ( XTAB(IK), FTAB(IK), GTAB(IK), ITAB(IK), IK = 1, NREF )
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE HEADER( TITLE, DELTAK, FREQ )

C     Routine to write header to disk file

      INCLUDE 'COMSCO.FOR'

      CHARACTER TITLE*80, PLTTYP*10

      LRECL  = MAX( 40, 2 * NKCORE, NSD + 1, NRD + 1 )
      NRECSR = ( NKPTS - 1 ) / NKCORE + 1
      PLTTYP = 'GREEN'
      XS = 0.0
      YS = 0.0
      THETA = 0.0

      OPEN ( FILE = 'GRNFIL', UNIT = GRNFIL, STATUS = 'UNKNOWN',
     &   ACCESS = 'DIRECT', RECL = 4 * LRECL, FORM = 'UNFORMATTED')

      WRITE( GRNFIL, REC = 1 ) LRECL, TITLE
      WRITE( GRNFIL, REC = 2 ) PLTTYP, XS, YS, THETA
      WRITE( GRNFIL, REC = 3 ) REAL( FREQ ), NSD, NRD, NKPTS,
     &   NKCORE, REAL( DELTAK ), REAL( ATTEN ), NRECSR
      WRITE( GRNFIL, REC = 4 ) ( SD( I ), I = 1, NSD )
      WRITE( GRNFIL, REC = 5 ) ( RD( I ), I = 1, NRD )

      DO IREC = 1, NRECSR
         ISTART = ( IREC - 1 ) * NKCORE
         WRITE( GRNFIL, REC = 5 + IREC )
     &      ( REAL( RK( ISTART + I ) ), I = 1, NKCORE )
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE INIT

C     Initializes arrays defining difference equations

      INCLUDE 'COMSCO.FOR'

      COMPLEX*16 CP( MAXN ), CS( MAXN ), CP2, CS2

      COMMON /SPACE/ CP, CS

      CMIN     = 1.0E6
      NFACT    = 0
      LOC( 1 ) = 0

C     *** Loop over media ***

      DO MED = 1, NMEDIA

         IF ( MED .GT. 1 .AND. SIGMA( MED ) .NE. 0.0 ) THEN
            WRITE( PRTFIL, * )
     &           'FATAL ERROR: Rough interfaces not allowed'
            STOP 'FATAL ERROR: Rough interfaces not allowed'
         ENDIF

         IF ( MED .NE. 1 )
     &      LOC( MED ) = LOC( MED - 1 ) + N( MED - 1 ) + 1

         N1 = N(   MED ) + 1
         I  = LOC( MED ) + 1

         IF ( LOC( MED ) + N1 .GT. MAXN ) THEN
            WRITE( PRTFIL, * )
     &           'FATAL ERROR: Insufficient storage for mesh'
            STOP 'FATAL ERROR: Insufficient storage for mesh'
         ENDIF

         CALL PROFIL( DEPTH, CP( I ), CS( I ), RHO( I ),
     &      MED, N1, FREQ, TOPOPT(1:1), TOPOPT(3:3), 'TAB',
     &      ENVFIL, PRTFIL )

         IF ( CS( I ) .EQ. ( 0.0, 0.0 ) ) THEN

C           *** Case of an acoustic medium ***

            MATER( MED )  =  'ACOUSTIC'
            IF ( NFACT .EQ. 0 ) NFACT = MED
            NLACT = MED

            DO J = I, I + N( MED )
               CMIN = MIN( CMIN, DBLE( CP( J ) ) )
               B1( J ) = OMEGA2 / CP( J ) ** 2
            END DO
         ELSE

C           *** Case of an elastic medium ***

            MATER( MED ) = 'ELASTIC'
            TWOH = 2.0 * H( MED )

            DO J = I, I + N( MED )
               CMIN = MIN( DBLE( CS( J ) ), CMIN )

               CP2 = CP( J ) ** 2
               CS2 = CS( J ) ** 2

               B1( J ) = TWOH / ( RHO( J ) * CS2 )
               B2( J ) = TWOH / ( RHO( J ) * CP2 )
               B3( J ) = 4.0 * TWOH * RHO(J) * CS2 * ( CP2 - CS2 ) / CP2
               B4( J ) = TWOH * ( CP2 - 2.0 * CS2 ) / CP2

               RHO( J ) = TWOH * OMEGA2 * RHO( J )
            END DO

         ENDIF
      END DO   ! next MED

      RETURN
      END
C**********************************************************************C
      SUBROUTINE BCIMP( X, BCTYPE, BOTTOP, CPHS, CSHS, RHOHS,
     &   F, G, IPOW )

C     Compute Boundary Condition IMPedance
C     Same subroutine as in KRAKENC except
C        PEKRT is replaced by SQRT
C        COMC  is replaced by COMSCO
C        CINS  is related to B1 differently

      INCLUDE 'COMSCO.FOR'

      COMPLEX*16 X, F, G, KX, KZ, TWERSK,
     &   GAMS2, GAMP2, GAMS, GAMP, RMU, YV( 5 ), RCMPLX
      COMPLEX*16 CPHS, CSHS, CINS
      CHARACTER BCTYPE*1, BOTTOP*3

      IPOW = 0

C     *** Get RHO, C just INSide the boundary ***

      IF ( BOTTOP(1:3) .EQ. 'TOP' ) THEN
         I = 1
         RHOINS = RHO( I )
         CINS   = SQRT( OMEGA2 / B1( 1 ) )
      ELSE
         I = LOC( NLACT ) + N( NLACT ) + 1
         RHOINS = RHO( I )
         CINS   = SQRT( OMEGA2 / B1( NLACT ) )
      ENDIF

C     *** Vacuum with Kirchoff roughness ***

      IF ( BCTYPE(1:1) .EQ. 'V' ) THEN
         F = 1.0
         G = -CI * SQRT( OMEGA2 / CINS ** 2 - X ) * SIGMA( 1 ) ** 2
      ENDIF

C     *** Vacuum with Twersky scatter model ***

      IF ( BCTYPE(1:1) .EQ. 'S' .OR. BCTYPE(1:1) .EQ. 'H' .OR.
     &     BCTYPE(1:1) .EQ. 'T' .OR. BCTYPE(1:1) .EQ. 'I' ) THEN

         OMEGA = SQRT( OMEGA2 )
         KX = SQRT( X )
         F = 1.0
         G = TWERSK( BCTYPE, OMEGA, BUMDEN, XI, ETA, KX, RHOINS, CINS )
         G = G / ( CI * OMEGA * RHOINS )
      ENDIF

C     *** Rigid ***
      IF ( BCTYPE(1:1) .EQ. 'R' ) THEN
         F = 0.0
         G = 1.0
      ENDIF

      YV(1) = F
      YV(2) = G
      YV(3) = 0.0
      YV(4) = 0.0
      YV(5) = 0.0

C     *** Acousto-elastic half-space ***

      IF ( BCTYPE(1:1) .EQ. 'A' ) THEN
         IF ( REAL( CSHS ) .GT. 0.0 ) THEN
            GAMS2 = X - OMEGA2 / CSHS ** 2
            GAMP2 = X - OMEGA2 / CPHS ** 2
            GAMS = SQRT( GAMS2 )
            GAMP = SQRT( GAMP2 )
            RMU = RHOHS * CSHS ** 2

            YV(1) = ( GAMS*GAMP - X ) / RMU
            YV(2) = ( ( GAMS2 + X )**2 - 4.0*GAMS*GAMP*X )*RMU
            YV(3) = 2.0*GAMS*GAMP - GAMS2 - X
            YV(4) = GAMP * ( X - GAMS2 )
            YV(5) = GAMS * ( GAMS2 - X )

            F = OMEGA2*YV( 4 )
            G = YV( 2 )
         ELSE
            GAMP = SQRT( X - OMEGA2 / CPHS**2 )
            F = 1.0
            G = RHOHS / GAMP
         ENDIF
      ENDIF

C     *** Tabulated reflection coefficient ***

      IF ( BCTYPE(1:1) .EQ. 'F' ) THEN
C        --- Compute the grazing angle THETA
         KX = SQRT( X )
         KZ = SQRT( OMEGA2 / CINS**2 - KX**2 )
         RADDEG = 360.0 / ( 2.0 * PI )
         THEINT = RADDEG * DATAN2( DBLE( KZ ), DBLE( KX ) )

C        --- Evaluate R(THEINT)
         IF ( BOTTOP(1:3) .EQ. 'TOP' ) THEN
            CALL REFCO( THEINT, RINT, PHIINT, THETAT, RT, PHIT, NTPTS )
         ELSE
            CALL REFCO( THEINT, RINT, PHIINT, THETAB, RB, PHIB, NBPTS )
         ENDIF

C        --- Convert R(THETA) to (f,g) in Robin BC
         RCMPLX = RINT * EXP( CI * PHIINT )
         F = 1.0
         G = ( 1.0 + RCMPLX ) / ( CI * KZ * ( 1.0 - RCMPLX ) )
      ENDIF

C     *** A top BC has the sign flipped relative to a bottom BC ***

      IF ( BOTTOP(1:3) .EQ. 'TOP' ) G = -G

C     *** Precalculated reflection coef ***

      IF ( BCTYPE(1:1) .EQ. 'P' ) THEN
         CALL IRCINT( X, F, G, IPOW, XTAB, FTAB, GTAB, ITAB, NKPTS )
      ENDIF

C     *** Shoot through elastic layers ***

      IF ( BOTTOP(1:3) .EQ. 'TOP' ) THEN

C        --- Shooting down from top
         IF ( NFACT. GT. 1 ) THEN

            DO MED = 1, NFACT-1
               CALL ELASDN( X, YV, IPOW, MED )
            END DO

            F = OMEGA2 * YV( 4 )
            G = YV( 2 )
         ENDIF
      ELSE

C        --- Shooting up from bottom
         IF ( NLACT. LT. NMEDIA ) THEN

            DO MED = NMEDIA, NLACT+1, -1
               CALL ELASUP( X, YV, IPOW, MED )
            END DO

            F = OMEGA2 * YV( 4 )
            G = YV( 2 )
         ENDIF
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE ELASUP( X, YV, IPOW, MED )

C     Propagates through an elastic layer using 
C     compound matrix formulation

      INCLUDE 'COMSCO.FOR'

      COMPLEX*16 X, XV(5), YV(5), ZV(5), TWOX, XB3, FOURHX
      PARAMETER ( ROOF = 1.0E5, FLOOR = 1.0E-5, IPOWR = 5, IPOWF = -5 )

C     Euler's method for first step

      TWOX = 2.0*X
      TWOH = 2.0*H(MED)
      FOURHX = 4.0*H(MED)*X
      J = LOC(MED) + N(MED) + 1

      XB3 = X*B3(J) - RHO(J)

      ZV(1) = YV(1) - 0.5*(   B1( J ) * YV( 4 ) - B2( J ) * YV( 5 ) )
      ZV(2) = YV(2) - 0.5*( -RHO( J ) * YV( 4 ) -     XB3 * YV( 5 ) )
      ZV(3) = YV(3) - 0.5*(      TWOH * YV( 4 ) + B4( J ) * YV( 5 ) )
      ZV(4) = YV(4) - 0.5*(   XB3*YV(1) + B2(J)*YV(2) -TWOX*B4(J)*YV(3))
      ZV(5) = YV(5) - 0.5*(RHO(J)*YV(1) - B1(J)*YV(2) -    FOURHX*YV(3))

C     Modified midpoint method

      DO I = N( MED ), 1, -1
         J = J-1

         DO L = 1, 5
            XV(L) = YV(L)
            YV(L) = ZV(L)
         END DO

         XB3 = X * B3( J ) - RHO( J )

         ZV(1) = XV(1) - (   B1( J ) * YV( 4 ) - B2( J) * YV( 5 ) )
         ZV(2) = XV(2) - ( -RHO( J ) * YV( 4 ) -    XB3 * YV( 5 ) )
         ZV(3) = XV(3) - ( TWOH * YV( 4 ) + B4( J ) * YV( 5 ) )
         ZV(4) = XV(4) - (  XB3 *YV(1) + B2(J)*YV(2) - TWOX*B4(J)*YV(3))
         ZV(5) = XV(5) - (RHO(J)*YV(1) - B1(J)*YV(2) -     FOURHX*YV(3))

C        Scale if necessary

         IF ( I .NE. 1 ) THEN

            IF ( ABS( DBLE( ZV( 2 ) ) ) .LT. FLOOR ) THEN
               DO L = 1, 5
                  ZV(L) = ROOF * ZV( L )
                  YV(L) = ROOF * YV( L )
               END DO
               IPOW = IPOW-IPOWR
            ENDIF

            IF ( ABS( DBLE( ZV( 2 ) ) ) .GE. ROOF ) THEN
               DO L = 1, 5
                  ZV(L) = FLOOR * ZV( L )
                  YV(L) = FLOOR * YV( L )
               END DO
               IPOW = IPOW-IPOWF
            ENDIF
         ENDIF
      END DO

C     Apply the standard filter at the terminal point

      DO J = 1, 5
         YV( J ) = ( XV( J ) + 2.0*YV( J ) + ZV( J ) ) / 4.0
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE ELASDN( X, YV, IPOW, MED )

C     Propagates through an elastic layer using 
C     compound matrix formulation

      INCLUDE 'COMSCO.FOR'

      COMPLEX*16 X, XV(5), YV(5), ZV(5), TWOX, XB3, FOURHX
      PARAMETER ( ROOF = 1.0E5, FLOOR = 1.0E-5, IPOWR = 5, IPOWF = -5 )

C     Euler's method for first step

      TWOX   = 2.0 * X
      TWOH   = 2.0 * H( MED )
      FOURHX = 4.0 * H( MED ) * X
      J = LOC(MED)+1

      XB3 = X * B3(J) - RHO(J)

      ZV(1) = YV(1) + 0.5*(   B1( J ) * YV( 4 ) - B2( J ) * YV( 5 ) )
      ZV(2) = YV(2) + 0.5*( -RHO( J ) * YV( 4 ) -     XB3 * YV( 5 ) )
      ZV(3) = YV(3) + 0.5*(      TWOH * YV( 4 ) + B4( J ) * YV( 5 ) )
      ZV(4) = YV(4) + 0.5*(   XB3*YV(1) + B2(J)*YV(2) -TWOX*B4(J)*YV(3))
      ZV(5) = YV(5) + 0.5*(RHO(J)*YV(1) - B1(J)*YV(2) - FOURHX*YV(3))

C     Modified midpoint method

      DO I = 1, N( MED )
         J = J+1

         DO L = 1, 5
            XV(L) = YV(L)
            YV(L) = ZV(L)
         END DO

         XB3 = X*B3(J) - RHO(J)

         ZV(1) = XV(1) + (   B1( J ) * YV( 4 ) - B2( J ) * YV( 5 ) )
         ZV(2) = XV(2) + ( -RHO( J ) * YV( 4 ) -     XB3 * YV( 5 ) )
         ZV(3) = XV(3) + (      TWOH * YV( 4 ) + B4( J ) * YV( 5 ) )
         ZV(4) = XV(4) + (   XB3*YV(1) + B2(J)*YV(2) -TWOX*B4(J)*YV(3))
         ZV(5) = XV(5) + (RHO(J)*YV(1) - B1(J)*YV(2) -    FOURHX*YV(3))

C        Scale if necessary

         IF ( I .NE. N(MED) ) THEN

            IF ( ABS( DBLE( ZV( 2 ) ) ) .LT. FLOOR ) THEN
               DO L = 1, 5
                  ZV(L) = ROOF * ZV( L )
                  YV(L) = ROOF * YV( L )
               END DO
               IPOW = IPOW-IPOWR
            ENDIF

            IF ( ABS( DBLE( ZV( 2 ) ) ) .GE. ROOF ) THEN
               DO L = 1, 5
                  ZV(L) = FLOOR * ZV( L )
                  YV(L) = FLOOR * YV( L )
               END DO
               IPOW = IPOW - IPOWF
            ENDIF

         ENDIF
      END DO

C     Apply the standard filter at the terminal point

      DO J = 1, 5
         YV( J ) = ( XV( J ) + 2.0 * YV( J ) + ZV( J ) ) / 4.0
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE KERNEL( GREEN )

C     Solve system for a sequence of k-values

      INCLUDE 'COMSCO.FOR'

      INTEGER ISD( MAXNSD ), IRD( MAXNRD )
      REAL Z( MAXN ), RHOELT( MAXN ), WS( MAXNSD ), WR( MAXNRD )
      COMPLEX GREEN( NSD, NRD, * ), DF( MAXN ), EF( MAXN ), BELT
      COMPLEX*16 X

      IREC = 5
      NTOT = 0

C     --- Tabulate z-coordinates
      J = 1
      Z( 1 ) = DEPTH( NFACT )

      DO MED = NFACT, NLACT

         DO I = 1, N( MED )
            J = J + 1
            Z( J ) = Z( J - 1 ) + H( MED )
         END DO

         NTOT = NTOT + N( MED )
      END DO

      NTOT1 = NTOT + 1

C     * Compute weights for source/rcvr depth interpolation *

      CALL WEIGHT( Z, NTOT1, SD, NSD, WS, ISD )
      CALL WEIGHT( Z, NTOT1, RD, NRD, WR, IRD )

C     *** Main loop: solve system repeatedly ***

      IKCORE = 0
      IFLUSH = 0   ! number of records already flushed

C     --- NRECSR is number of records per S/R combo
      NRECSR = ( NKPTS - 1 ) / NKCORE + 1

C     *** Assemble matrix ***

      J = 1
      L = LOC( NFACT ) + 1
      DF( 1 ) = 0.0

      DO MED = NFACT, NLACT
         DO I = 1, N( MED )
            RHOELT( L ) = ( RHO( L ) + RHO( L + 1 ) ) / 2.0
            RHOH = RHOELT( L ) * H( MED )
            BELT = H( MED ) * ( ( B1( L ) + B1( L + 1 ) ) / 2.0 )
     &                          / ( 12.0 * RHOELT( L ) )

            DF( J     ) = DF( J ) - 1.0 / RHOH + 5.0 * BELT
            DF( J + 1 ) =         - 1.0 / RHOH + 5.0 * BELT
            EF( J + 1 ) =           1.0 / RHOH +       BELT

            J = J + 1
            L = L + 1
         END DO
         L = L + 1
      END DO

C     *** Step through each point in k-space ***

      DO IK = 1, NKPTS
C        WRITE( 6, * ) 'IK, NKPTS', IK, NKPTS
         IKCORE = IKCORE + 1
         X = ( RK( IK ) + CI * ATTEN ) ** 2

C        *** Solve for G(k) ***

         CALL SOLVE( NTOT1, IS, WS, ISD, WR, IRD, X, GREEN, IKCORE,
     &      DF, EF, RHOELT )

C        --- Flush buffer if necessary
         IF ( IKCORE .EQ. NKCORE .OR. IK .EQ. NKPTS ) THEN
            DO IS = 1, NSD

               DO IR = 1, NRD
C                 --- Index of source/receiver combo
                  ISR = ( IS - 1 ) * NRD + IR
                  IREC = 6 + ISR * NRECSR + IFLUSH
                  WRITE( GRNFIL, REC = IREC )
     &               ( GREEN( IS, IR, IKCORE ), IKCORE = 1, NKCORE )
               END DO
 
            END DO
            IKCORE = 0
            IFLUSH = IFLUSH + 1
         ENDIF

      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE SOLVE( NTOT1, IS, WS, ISD, WR, IRD, X,
     &   GREEN, IKCORE, DF, EF, RHOELT )

C     Set up the linear system and solve

      INCLUDE 'COMSCO.FOR'

      INTEGER ISD( * ), IRD( * )
      REAL RHOELT( * ), WS( * ), WR( * )
      COMPLEX GREEN( NSD, NRD, * ), D( MAXN ), E( MAXN ),
     &   B( MAXN ), RV1( MAXN ), RV2( MAXN ), RV3( MAXN ), RV4( MAXN ),
     &   DF( * ), EF( * ), BELT, XT
      COMPLEX*16 X, F, G
      CHARACTER BCTYPE*1

      COMMON /SPACE/ RV1, RV2, RV3, RV4

      EQUIVALENCE ( D, B )

C     *** Assemble matrix ***

      J = 1
      L = LOC( NFACT ) + 1
      D( 1 ) = DF( 1 )

      DO MED = NFACT, NLACT
         XT = -H( MED ) * X / 12.0

         DO I = 1, N( MED )
            BELT = XT / RHOELT( L )
            D( J    ) = D(  J     ) + 5.0 * BELT
            D( J + 1) = DF( J + 1 ) + 5.0 * BELT
            E( J + 1) = EF( J + 1 ) +       BELT
            J = J + 1
            L = L + 1
         END DO

         L = L + 1
      END DO

C     *** Corner elt requires top impedance ***

      BCTYPE(1:1) = TOPOPT(2:2)
      CALL BCIMP( X, BCTYPE, 'TOP', CPT, CST, RHOT, F, G, IPOW )

      IF ( G .EQ. 0.0 ) THEN
         D( 1 ) = 1.0
         E( 2 ) = 0.0
      ELSE
         D( 1 ) = D( 1 ) + F / G
      ENDIF

C     *** Corner elt requires bottom impedance ***

      BCTYPE(1:1) = BOTOPT(1:1)
      CALL BCIMP( X, BCTYPE, 'BOT', CPB, CSB, RHOB, F, G, IPOW )

      IF ( G .EQ. 0.0 ) THEN
         D( NTOT1 ) = 1.0
         E( NTOT1 ) = 0.0
      ELSE
         D( NTOT1 ) =  D( NTOT1 ) - F / G
      ENDIF

C     * Do LU decomposition *

      CALL FACTOR( NTOT1, D, E, IERR, RV1, RV2, RV3, RV4 )

C     *** Loop over all source positions ***

      DO IS = 1, NSD

C        --- Set up RHS
         DO J = 1, NTOT1
            B( J ) = 0.0
         END DO

         I = ISD( IS )

C        --- depending on the normalization, we may need rho(zs)
         RHOSD = 1.0

         B( I     ) = 2.0 * ( 1.0 - WS( IS ) ) / RHOSD
         B( I + 1 ) = 2.0 *     WS( IS )       / RHOSD

C        * Solve the system and extract soln for desired receivers *

         CALL BACKSB( NTOT1, D, E, IERR, RV1, RV2, RV3, RV4, B )

         DO IR = 1, NRD
            I = IRD( IR )
            GREEN( IS, IR, IKCORE ) =
     &                B( I ) + WR( IR ) * ( B( I + 1 ) - B( I ) )
         END DO

      END DO

      RETURN
      END

      FUNCTION TRANSIT( X, SIGMA )

C     Computes a value on the transition curve

      PARAMETER ( N = 500 )

      LOGICAL INIT
      REAL    A( N )
      SAVE INIT, A, XMIN, XMAX, DELTAX
      DATA INIT /.FALSE./

      IF ( .NOT. INIT ) THEN

C        *** Initialize ***

         XMAX   =  4.0 * SIGMA
         XMIN   = -4.0 * SIGMA
         DELTAX = ( XMAX - XMIN ) / ( N - 1 )

         A( 1 ) = 0.0
         DO I = 2, N
            XT     = XMIN + ( I - 1 ) * DELTAX
            A( I ) = A( I - 1 ) + DELTAX * GAUSS( XT, SIGMA )
         END DO

         INIT = .TRUE.
      ENDIF

C     *** Evaluate distribution at x ***

      IF ( X .LE. XMIN ) THEN
         TRANSIT = 0.0
      ELSE IF ( X .GE. XMAX ) THEN
         TRANSIT = 1.0
      ELSE
         I = ( X - XMIN ) / DELTAX + 1
         TRANSIT = A( I )
      ENDIF

      RETURN
      END

C**********************************************************************C

      FUNCTION GAUSS( X, SIGMA )

C     NORMAL DISTRIBUTION

      PARAMETER ( PI = 3.141592 )

      IF ( SIGMA .GT. 0.01 ) THEN
         GAUSS = EXP( -( X / SIGMA ) ** 2 / 2.0 ) /
     &           ( SIGMA * SQRT( 2.0 * PI ) )
      ELSE IF ( X .GT. 0.0 ) THEN
         GAUSS = 1.0
      ELSE
         GAUSS = 0.0
      ENDIF

      RETURN
      END

      FUNCTION TWERSK( OPT, OMEGA, BUMDEN, XI, ETA, KX, RHO0, C0 )

C     SURFACE IMPEDANCE MODEL COURTESY STEVE WALES WITH
C     MINOR MODIFICATIONS (MBP 9/23/85)

C     CALCULATES THE SURFACE IMPEDANCE USING TWERSKY SCATTER MODEL

C         OPT IS A MEMBER OF THE SET {'S','H','T','I'}
C            'S' MEANS SOFT PROTUBERANCES
C            'H' MEANS HARD PROTUBERANCES
C            'T' MEANS SOFT PROTUBERANCES, AMPLITUDE ONLY
C            'I' MEANS HARD PROTUBERANCES, AMPLITUDE ONLY

C         ( THE OPTIONS WITH A HARD BACKING HAVE BEEN REMOVED
C           SINCE THEY ARE IMPROPER FOR ICE )

C         BUMDEN = N, THE NUMBER OF PROTUBERANCES PER METER.
C                  ( BUMP DENSITY )
C         XI     = HEIGHT OF PROTUBERANCE FROM THE SURFACE
C         ETA    = HALF-WIDTH OF THE PROTUBERANCE.
C                  (ETA & XI ARE THE LENGTHS OF THE SEMI-MAJOR AND
C                   SEMI-MINOR AXES OF THE ELLIPSE)

      IMPLICIT REAL*8  (A-H, O-Z)
      PARAMETER ( AI=(0.0D0,1.0D0), PI=3.141592653589793D0,
     &          RADDEG=180.D0/PI )

      COMPLEX*16 FS, FM, TWERSK, KX, KZ, COSPHI, SINPHI
      REAL*8 K
      CHARACTER*1 OPT

C     ------ SURFACE IS ALWAYS SOFT:
      ISHS = 0
C     ------ SET PROTUBERANCE HARDNESS FLAG:
      IF ( OPT(1:1) .EQ. 'S' .OR. OPT .EQ. 'T' ) THEN
         ISHP = 0
      ELSE
         ISHP = 1
      ENDIF

      K  = OMEGA / C0
      KZ = SQRT( K**2 - KX**2 )
      SINPHI = KX / K
      COSPHI = KZ / K
      PHI = RADDEG * DATAN2( DBLE(SINPHI), DBLE(COSPHI) )
      FS = FM ( PHI, 180.D0-PHI, K, XI, ETA, ISHS, ISHP )

      IF ( ISHS .EQ. 1 )  THEN                     ! HARD SURFACE
         TWERSK = -RHO0 * C0 * K / (BUMDEN * FS)
      ELSE                                         ! SOFT SURFACE
         TWERSK = -RHO0 * C0 * BUMDEN * FS / ( COSPHI**2 * K)
      END IF

C     ------ FOR AMPLITUDE ONLY THROW-OUT IMAGINARY PART OF IMPEDANCE
      IF ( OPT .EQ. 'T' .OR. OPT .EQ. 'I' ) THEN
         TWERSK = DBLE( TWERSK )
      ENDIF

      RETURN
      END
C**********************************************************************C
      FUNCTION FM (PHI, OEPHI0, K, XI, ETA, ISHS, ISHP)

C     Burke and Twersky's F Function - based on direct Mathieu function
C     evaluation except for high frequencies.
C     This function calculates the F function for low and high frequencies
C     scattering from elliptical cylinders imbedded in a hard or 
C     or soft plane.  It first determines the appropriate routine to call
C     for the ellipse, high or low frequency, and then adds or subtracts
C     the result according to hard or soft surface.

C     Input parameters used are:
C         PHI - Scattered energy angle
C         OEPHI0 - Incident energy angle at 180 - PHI0
C         ISHS - Soft or hard surface [0 or 1]
C         ISHP - Soft or hard protuberance [0 or 1]
C         XI - Protuberance height (semi-axis) from plane
C         ETA - Protuberance half-width (semi-axis) in plane
C         K - Wavenumber

      IMPLICIT REAL*8 (A-F, O-Z)
      REAL*8 K
      COMPLEX*16 FM, GM, GBTM

      PHI0 = 180.D0 - OEPHI0		! RECALCULATE PHI0
      ISAS = 2*ISHS - 1			! -1, SOFT, CALC. ANTISYMETRIC MODES
					! +1, HARD, CALC. SYMETRIC MODES

C   * LOW FREQUENCY APPROXIMATION *

      IF (K*MAX(XI,ETA).LT.50.D0)  THEN
          FM = 2.D0 * GM (PHI, PHI0, K, XI, ETA, ISHP, ISAS)

C   * HIGH FREQUENCY APPROXIMATION *

      ELSE
          FM = GBTM (PHI, PHI0, PHI0, K, XI, ETA, ISHP)
     1             + ISAS * GBTM (PHI, OEPHI0, PHI0, K, XI, ETA, ISHP)
      END IF

      RETURN
      END
C**********************************************************************C

      FUNCTION GM (PHI, PHI0, K, XI, ETA, ISHP, ISAS)

C     Input parameters used are:
C         PHI - Scattered energy angle
C         PHI0 - Incident energy angle at PI - PHI0
C         K - Wavenumber of the waves 
C         XI - Semi-axis of the ellipse along the axis from which the
C              angles are measured.
C         ETA - Semi- axis of the ellipse perpendicular to the axis from
C               which the angles are measured.  The in-plane axis if the
C               ellipses are in a surface.
C         ISHP - Type of protuberance, 0 = soft, 1 = hard
C         ISAS - < 0 Antisymetric modes
C              - = 0 All modes
C                > 0 Symetric modes

      IMPLICIT REAL*8 (A-F,O-Z)
      PARAMETER ( DEGRAD=3.141592653589793D0/180.D0, PREC=1.D-8 )

      REAL*8 K
      COMPLEX*16 GM, RMTHUV, RM, FACTOR

      RMIN = 0.0    ! MBP 5/20/92 (previously uninitialized)

C   * ROTATE SO THAT COORDINATE SYSTEM IS ALONG MAJOR AXIS *
C     PICK OFF MODES WHICH ARE SYM/ANTISYM ABOUT 0 OR 90 DEGS.

      IF (XI.GE.ETA)  THEN		! WANT SYM/ANTISYM MODES ABOUT 90 DEGS
          PHIN = DEGRAD * PHI0
          POUT = DEGRAD * PHI
          A = XI
          B = ETA
          IF (ISAS.LT.0)  THEN		! ANTISYMETRIC MODES 
              IOP = 1
              IOD = 2
          ELSE IF (ISAS.EQ.0)  THEN	! ALL MODES
              IOP = 0
              IOD = 1
          ELSE IF (ISAS.GT.0)  THEN	! SYMETRIC MODES
              IOP = 0
              IOD = 2
          END IF
          IEO1 = 0
          IEO2 = 1

      ELSE				! WANT SYM/ANTISYM MODES ABOUT 0 DEGS
          PHIN = DEGRAD * (90.D0 + PHI0)
          POUT = DEGRAD * (90.D0 + PHI)
          A = ETA
          B = XI
          IF (ISAS.LT.0)  THEN		! ANTISYMETRIC MODES 
              IEO1 = 1
              IEO2 = 1
          ELSE IF (ISAS.EQ.0)  THEN	! ALL MODES
              IEO1 = 0
              IEO2 = 1
          ELSE IF (ISAS.GT.0)  THEN	! SYMETRIC MODES
              IEO1 = 0
              IEO2 = 0
          END IF
          IOP = 0
          IOD = 1
      END IF

C   * COORDINATES ETC *

      NORD = NINT (K*A + 10*(A+B)/A)
      U = K * (A+B) / 2.D0
      V = K * (A-B) / 2.D0
      Q = U * V

C   * FORM THE SUM *

      GM = (0.0D0, 0.0D0)
      ARMAX = 0.0D0

      DO 20 IEO = IEO1,IEO2			! * EVEN/ODD LOOP *

      DO 10 IORD = IEO+IOP,NORD,IOD		! * ORDER LOOP *
      RM  = RMTHUV (U, V, IORD, IEO, ISHP, 5, NORD)
      ABSR = ABS (RM)
      IF (ABSR.LT.RMIN .OR. IORD.EQ.IEO1+IOP)  RMIN = ABSR
      IF (ABSR*PREC.GE.RMIN)  GO TO 15		! NORMALLY PASSED WHEN BESSEL 
						! FUNC. OF 2ND TYPE (B2) BLOWS UP.
      SM1 = AMTHU (PHIN, Q, IORD, IEO, 0, 5, NORD)
      SM2 = AMTHU (POUT, Q, IORD, IEO, 0, 5, NORD)
      FACTOR = SM1 * SM2 * (-DBLE (RM) / RM)
      ABSRX = ABS (-DBLE (RM) / RM)
      IF (ABSRX.GT.ARMAX)  ARMAX = ABSR
C      IF (ABSRX.LE.PREC*ARMAX)  GO TO 15	! LESS SENSITIVE TEST OF RATIO,
						! CAN BE PASSED IF B1 IS SMALL.
   10 GM = GM + FACTOR

      IF (ABSRX/ARMAX.GT.1.D-12)  THEN
          WRITE (6,*) '     * * * ERROR IN GM * * *'
          WRITE (6,*) '       CONVERGENCE FAILURE'
          WRITE (6,*) '     ORDER OF APPROX.=', NORD
          WRITE (6,*) '     ABSRX/ARMAX =',ABSRX/ARMAX
      END IF

   15 CONTINUE
   20 CONTINUE

      RETURN
      END
C**********************************************************************C

      FUNCTION GBTM (PHI, PHI0, PHIZ, K, XI, ETA, ISHP)

      IMPLICIT INTEGER (I,J)
      IMPLICIT REAL*8  (A-E, H, K-Z)
      IMPLICIT COMPLEX*16 (F,G)
      COMPLEX*16 AI
      PARAMETER ( AI=(0.0D0,1.0D0), PI=3.141592653589793D0, PISQ=PI*PI,
     1          DEGRAD=PI/180.D0, RADDEG=180.D0/PI )

      REAL*8   FRAC, GAMMA


C   * * * * *  HIGH FREQUENCY APPROXIMATIONS  * * * * *
C             (ACCORDING TO BURKE & TWERSKY)

C   * PARAMETERS ALWAYS NEEDED *

C     REALLY SHOULD BE USING PHIZ FOR CALCULATION OF L, BUT WE CAN
C     USE PHI0 SINCE IF PHI0 = 180 - PHIZ, COT**2(PHI0) = COT**2(PHIZ)

      RPHI0 = DEGRAD * PHI0					! PHI0 IN RADIANS
      RHO = ETA / XI					! WIDTH TO HEIGHT RATIO
      RHOSQ = RHO**2					! RATIO SQUARED
      SINPHI0 = SIN (RPHI0)				! SIN OF INC. ANGLE
      COSPHI0 = COS (RPHI0)				! COS OF INC. ANGLE
      IF (ABS(SINPHI0).GT.1.D-10)  THEN			! COT OF INC. ANGLE
          COTSQPHI0 = (COSPHI0 / SINPHI0)**2
      ELSE
          COTSQPHI0 = 1.0D20
      END IF
      L = (1.0D0 + RHOSQ**2 * COTSQPHI0) /
     1                          (1.0D0 + RHOSQ * COTSQPHI0)
      L = XI * SQRT (L)					! A MESSY CONSTANT
      GAMMA = TAN (DEGRAD*PHIZ) / RHOSQ
      GAMMA = ATAN (GAMMA)				! ANOTHER ONE

C   * DIFFRACTION (SHADOW-FORMING) TERM CALCULATIONS *

      CPHI0 = (PHI-PHI0) * DEGRAD / 2.D0			! (SCAT-INC)/2
      CPHI1 = (PHI+PHI0) * DEGRAD / 2.D0			! (SCAT+INC)/2
      SINCPHI0 = SIN (CPHI0)				! SIN OF (SCAT-INC)/2
      COSCPHI0 = COS (CPHI0)				! COS OF (SCAT-INC)/2
      COSPHIGAM = COS (CPHI1-GAMMA)			! ANOTHER MESSY CONST.
      IF (ABS(SINCPHI0).GT.1.D-10)  THEN		! * DIFFRACTION TERM *
          COTCPHI0 = COSCPHI0 / SINCPHI0		! COTAN OF (SCAT-INC)/2
          GD = -COTCPHI0 * SIN (2.D0*K*L*COSPHIGAM*SINCPHI0) / 2.D0
      ELSE
          GD = -K * L * COSPHIGAM			! SPEC. CASE FOR SIN 0
      END IF

C   * SET UP SIGN FOR HARD OR SOFT PROTUBERANCES *

      ISIGNP = -1					! SOFT 
      IF (ISHP.EQ.1)  ISIGNP = 1			! HARD 

C   * REFLECTION TERM FOR SEPERATED ANGLES *

      SINCPHI1 = SIN (CPHI1)
      COSCPHI1 = COS (CPHI1)
      P1 = RHOSQ * COSCPHI1**2 + SINCPHI1**2
      EXPL = -2.D0 * K * XI * ABS(SINCPHI0) * SQRT(P1)
      GL = (RHO/2.D0) * SQRT (AI*PI*K*XI) * SQRT (ABS(SINCPHI0))
     1                                    * EXP (AI*EXPL) / P1**(0.75D0)

C   * ANGLES CLOSE TOGETHER - FORWARD DIRECTION *
C     NOTE: CPHI0 = B & T'S BETA

      FRAC  = ABS (K * CPHI0 * XI)
      IF (FRAC.LE.PI .AND. FRAC.GT.1.D-10)  THEN
          SINPG = SIN (RPHI0-GAMMA)			! MORE MESSY CONSTS.
          COSPG = COS (RPHI0-GAMMA)
          GLSA = K*L*CPHI0 * SINPG
     1            + K*(CPHI0**2) * (L*COSPG - AI*K*PI*XI*ETA/2.D0)
          FRAC = (1.D0 + COS(FRAC)) / 2.D0		! TRANS. PT. FRAC*PI/2
          GL = FRAC * GLSA + (1.D0-FRAC) * GL
      END IF

C   * FINAL CALCULATION *

      GBTM = GD + ISIGNP * GL

      RETURN
      END

      SUBROUTINE HILBERT( X, N )

C     Forms the Hilbert transform of the function
C     Real( X( N ) ) is the input time series
C     N must be a power of 2 and <16384

      COMPLEX CI
      PARAMETER ( CI = ( 0.0, 1.0 ) )

      COMPLEX X( * )

C     Check N is a power of 2

      IF ( N .LE. 0 )
     &   STOP 'FATAL ERROR in HILBERT: N must be positive'

      NT = 2**( INT( LOG10(REAL(N)) / 0.30104 ) +1 )
      IF ( NT .NE. N )
     &   STOP 'FATAL ERROR in HILBERT: N must be a power of 2'

C     *** Fourier transform ***

      CALL CFFT( X, N, 1 )
      CALL CFFTSC( X, N )

C     *** Multiply by i*sgn( f ) ***

C     --- positive spectrum ( lower N/2 positions)
      DO I = 1, N/2-1
         X( I ) =  CI * X( I )
      END DO

      X( N / 2 ) = 0.0      ! d.c. component

C     --- negative spectrum (upper N/2 positions)
      DO I = N/2+1, N
         X( I ) = -CI * X( I )
      END DO

C     *** Inverse Fourier transform ***

      CALL CFFT( X, N, -1 )

      RETURN
      END

      PROGRAM FFT

C     Do an FFT of a real time series
C     (Should be modfied to do a real FFT ...)

      PARAMETER ( MAXNT = 200000 )

      REAL    T( MAXNT )
      COMPLEX S( MAXNT )

C     *** Read in data ***

      DO IT = 1, MAXNT
         READ( *, *, END = 1000 ) T( IT ), STEMP
         S( IT ) = STEMP   ! real to complex
         NT = IT

         IF ( NT .GT. MAXNT ) STOP 'Too many points'
      END DO

 1000 TMAX = T( NT )

C     *** compute spectrum ***

C     *** Check NT is a power of 2 ***

      IF ( NT .LE. 0 )
     &   STOP 'FATAL ERROR: NT must be positive'

      N1 = 2**( INT( LOG10( REAL( NT ) ) / 0.30104 ) +1 )

      IF ( N1 .NE. NT ) THEN
         WRITE( *, * ) 'NT = ', NT
         STOP 'FATAL ERROR: NT must be a power of 2'
      END IF

      CALL CFFT( S, NT, 1 )
      CALL CFFTSC( S, NT )

C     *** write out the spectrum (w/out dc component) ***

      DO IT = 2, NT / 2 + 1
         DELTAF = 1.0 / TMAX
         F = ( IT - 1 ) * DELTAF
         WRITE( *, * ) F, S( IT )
      END DO

      STOP
      END

      SUBROUTINE GETMOD( IPROF, FILNAM, MAXM, RD, NRD, COMP,
     &   CK, PHIR, M, FREQ, TITLE )

C     Read in modes and extract values at rcvr depths

C     INPUT:
C        IPROF  unit number  for the mode set
C        FILNAM name of file for the mode set
C        MAXM   row dimension of PHIR in calling program
C        RD     vector of receiver depths where modes are to be evaluated
C        NRD number of such receivers
C        COMP   component (vertical, horizontal,...) for elastic problems
C               ignored for purely acoustic problems

C     OUTPUT:
C        CK     vector of eigenvalues
C        PHIR   matrix of tabulated modes
C        M      number of modes
C        FREQ   frequency
C        TITLE  title in mode file

C     If IPROF <> 0
C        we assume the mode file is assigned to unit
C        29 + IPROF and no open is necessary
C     else
C        we open a file with name FILNAM to read the modes

      INTEGER PRTFIL
      PARAMETER ( PRTFIL = 6, MAXN = 16001, MAXMED = 51, MAXNRD = 501 )

      INTEGER
     &   N( MAXMED ), IRD( MAXNRD )

      REAL
     &   RD( * ), Z( MAXN ), W( MAXNRD ), DEPTH( MAXMED ), RHO( MAXMED )

      COMPLEX
     &   PHIR( MAXM, * ), PHIT( MAXN ), CK( * ), KTOP2, KBOT2

      CHARACTER
     &   TITLE*( * ), FILNAM*( * ), MATER( MAXMED )*8,
     &   COMP*( *), BCTOP*1, BCBOT*1

C     ------ OK, Let's go. ------

      IF ( NRD .GT. MAXNRD ) THEN
         WRITE( PRTFIL, * ) 'NRD, MAXNRD = ', NRD, MAXNRD
         CALL ERROUT( PRTFIL, 'F', 'GETMOD', 'Too many receiver depths')
      ENDIF

C     *** Read the header data from the mode file ***

      CALL MODHDR( IPROF, FILNAM,
     &   TITLE, FREQ, NMEDIA, NTOT, NMAT,
     &   N, MATER, DEPTH, RHO,
     &   BCTOP, RHOT, DEPTHT,
     &   BCBOT, RHOB, DEPTHB,
     &   M, MAXM, Z, CK, KTOP2, KBOT2, MODFIL )

      IF ( M .LE. 0 ) RETURN

C     *** Locate indices of receiver points ***

      CALL WEIGHT( Z, NTOT, RD, NRD, W, IRD )

C     *** Loop over receiver depths to check for safe interpolation ***

C     Receivers must be within a fraction of a wavelength
C     of tabulated pts. We accept one wavelength a 1500 m/s

      TOL = 1500.0 / FREQ

      DO IR = 1, NRD

         IZ = IRD( IR )
         WT = ABS( MIN( W( IR ), 1.0 - W( IR ) ) )

         IF ( RD( IR ) .LT. DEPTHT ) THEN
C           ------ Rcvr in upper halfspace
            CST = 0.0 ! should be passed by MODHDR
            IF ( CST .NE. 0.0 .OR. BCTOP(1:1) .NE. 'A' ) THEN
               WRITE( PRTFIL, * ) 'Receiver depth: ', RD( IR )
               WRITE( PRTFIL, * ) 'Highest valid depth: ', DEPTHT
               CALL ERROUT( PRTFIL, 'F', 'GETMOD',
     &                                'Rcvr above highest valid depth' )
            ENDIF

         ELSE IF ( RD( IR ) .GT. DEPTHB ) THEN
C           ------ Rcvr in lower halfspace
            CSB = 0.0 ! should be passed by MODHDR
            IF ( CSB .NE. 0.0 .OR. BCBOT(1:1) .NE. 'A' ) THEN
               WRITE( PRTFIL, * ) 'Receiver depth: ', RD( IR )
               WRITE( PRTFIL, * ) 'Lowest valid depth: ', DEPTHB
               CALL ERROUT( PRTFIL, 'F', 'GETMOD',
     &                                 'Rcvr below lowest valid depth' )
            ENDIF

         ELSE IF ( NTOT .GT. 1 ) THEN
C           ------ Rcvr between two grid points
            IF ( WT * ( Z( IZ + 1 ) - Z( IZ ) ) .GT. TOL ) THEN
            WRITE( PRTFIL, * ) 'Nearest depths: ', Z( IZ ), Z( IZ + 1 )
            WRITE( PRTFIL, * ) 'Tolerance: ', TOL
            CALL ERROUT( PRTFIL, 'F', 'GETMOD',
     &                        'Modes not tabulated near requested pt.' )
            ENDIF
         ELSE
C           ------ Rcvr near a single grid point
            IF ( ABS( RD( IR ) - Z( IZ ) ) .GT. TOL ) THEN
            WRITE( PRTFIL, * ) 'Rd, Tabulation depth ', RD( IR), Z( IZ )
            WRITE( PRTFIL, * ) 'Tolerance: ', TOL
            CALL ERROUT( PRTFIL, 'F', 'GETMOD',
     &                        'Modes not tabulated near requested pt.' )
            ENDIF
         ENDIF

      END DO   ! next receiver depth

C     *** Read in the modes ***

      DO MODE = 1, M

         CALL GETONE( MODE, MODFIL, NTOT, NMAT, W, IRD,
     &      N, MATER, NMEDIA, COMP,
     &      KTOP2, DEPTHT, BCTOP,
     &      KBOT2, DEPTHB, BCBOT,
     &      RD, NRD, CK, PHIT )

         DO IZ = 1, NRD
            PHIR( MODE, IZ ) = PHIT( IZ )
         END DO

      END DO   ! next mode

      CLOSE( MODFIL )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE MODHDR( IPROF, FILNAM,
     &   TITLE, FREQ, NMEDIA, NTOT, NMAT,
     &   N, MATER, DEPTH, RHO,
     &   BCTOP, RHOT, DEPTHT,
     &   BCBOT, RHOB, DEPTHB,
     &   M, MAXM, Z, CK, KTOP2, KBOT2, MODFIL )

C     Reads the header information from MODFIL
C     Note T suffix means top
C          B suffix means bottom

C     The mode file may be specified either by a profile number (IPROF)
C        or a name FILNAM
C     If IPROF =  0 then we assume you provide FILNAM
C     If IPROF <> 0 then a file name of the form MODFILxxx is built

C     FILNAM is the user-provided file name
C     FILNAMT is the temporary name we build
C     These have to be two separate variables do ensure there
C     is space allocated to construct the file name even when
C     the user calls us with FILNAM = ' '


      INTEGER PRTFIL
      PARAMETER ( PRTFIL = 6, PI = 3.141592 )

      INTEGER   N( * )
      REAL      DEPTH( * ), Z( * ), RHO( * )
      COMPLEX   CK( * ), CPT, CST, CPB, CSB, KTOP2, KBOT2
      CHARACTER TITLE*( * ), FILNAM*( * ), MATER( * )*8,
     &          BCTOP*1, BCBOT*1, FILNAMT*80

C     *** open MODFIL ***

      IF ( IPROF .EQ. 0 ) THEN
         MODFIL = 30
         FILNAMT = FILNAM   ! copy filename
      ELSE
         MODFIL = 29 + IPROF
         IF ( IPROF .LE. 9 ) THEN
            WRITE( FILNAMT, 1000 ) IPROF
 1000       FORMAT( 'MODFIL', I1.1 )
         ELSE IF ( IPROF .LE. 99 ) THEN
            WRITE( FILNAMT, 2000 ) IPROF
 2000       FORMAT( 'MODFIL', I2.2 )
         ELSE IF ( IPROF .LE. 999 ) THEN
            WRITE( FILNAMT, 3000 ) IPROF
 3000       FORMAT( 'MODFIL', I3.3 )
         ELSE
            STOP "FATAL ERROR in GETMOD"
         END IF
      ENDIF

C     ------ get record length
      OPEN ( UNIT = MODFIL, FILE = FILNAMT, STATUS = 'OLD', 
     &   ACCESS = 'DIRECT', FORM = 'UNFORMATTED', RECL = 20 )
      READ( MODFIL, REC = 1 ) LRECL
      CLOSE( MODFIL )

C     ------ re-open file with the correct record length
      OPEN ( UNIT = MODFIL, FILE = FILNAMT, STATUS = 'OLD', 
     &   ACCESS = 'DIRECT', FORM = 'UNFORMATTED', RECL = 4 * LRECL )

C     *** Read header info ***

      READ( MODFIL, REC = 1 ) LRECL, TITLE(1:80),
     &                        FREQ, NMEDIA, NTOT, NMAT
      READ( MODFIL, REC = 2 ) ( N( MED ), MATER( MED ), MED = 1, NMEDIA)
      READ( MODFIL, REC = 3 ) BCTOP(1:1), CPT, CST, RHOT, DEPTHT,
     &                        BCBOT(1:1), CPB, CSB, RHOB, DEPTHB
      READ( MODFIL, REC = 4 )
     &      ( DEPTH( MED ), RHO( MED ), MED = 1, NMEDIA )
      READ( MODFIL, REC = 5 ) M, LRECL

      IF ( M .GT. MAXM ) THEN
         WRITE( PRTFIL, * ) 'M = ', M, '   MAXM = ', MAXM
         CALL ERROUT( PRTFIL, 'F', 'MODHDR',
     &   'Insufficient storage to read all the modes: increase MAXM' )
      ENDIF

      IF ( M .EQ. 0 ) RETURN
      READ( MODFIL, REC = 6 ) ( Z(   IZ ), IZ = 1, NTOT )

C     *** Read in eigenvalues, CK( I ) ***

      IFIRST = 1
      DO IREC = 1, 1 + ( 2 * M - 1 ) / LRECL
         ILAST  = MIN( M, IFIRST + LRECL / 2 - 1 )

         READ( MODFIL, REC = 6 + M + IREC )
     &                        ( CK( MODE ), MODE = IFIRST, ILAST )

         IFIRST = ILAST + 1
      END DO

      IF ( BCTOP(1:1) .EQ. 'A' ) KTOP2 = ( 2.0 * PI * FREQ / CPT ) **2
      IF ( BCBOT(1:1) .EQ. 'A' ) KBOT2 = ( 2.0 * PI * FREQ / CPB ) **2

      RETURN
      END

C**********************************************************************C

      SUBROUTINE GETONE( MODE, MODFIL, NTOT, NMAT, W, IRD,
     &   N, MATER, NMEDIA, COMP,
     &   KTOP2, DEPTHT, BCTOP,
     &   KBOT2, DEPTHB, BCBOT,
     &   RD, NRD, CK, PHIR )

C     Read in a single eigenfunction and extract receiver values
C     Results are returned in PHIR

      PARAMETER ( MAXN = 16001 )

      LOGICAL    TUFLUK
      INTEGER    N( * ), IRD( * )
      REAL       RD( * ), W( * )
      COMPLEX    PHIR( * ), CK( * ), PHI( MAXN ),
     &           GAMT, GAMB, KTOP2, KBOT2
      COMPLEX*16 PEKRT, GAMMA2
      CHARACTER  MATER( * )*8, COMP*( *), BCTOP*1, BCBOT*1

      READ( MODFIL, REC = 6 + MODE ) ( PHI( J ), J = 1, NMAT )

C     *** Is there an elastic medium in the problem? ***

      TUFLUK = .FALSE.

      DO MED = 1, NMEDIA
         IF ( MATER( MED ) .EQ. 'ELASTIC' ) TUFLUK = .TRUE.
      END DO

C     ------ Extract the component specified by 'COMP'

      IF ( TUFLUK ) CALL EXTRACT( PHI, N, MATER, NMEDIA, COMP )

C     *** Extract values at receiver depths ***

      GAMT = 0.0
      GAMB = 0.0

C     --- n.b. should be using real( ck(mode)) for KRAKEN
      IF ( BCTOP(1:1) .EQ. 'A' ) THEN
         GAMMA2 = CK( MODE ) ** 2 - KTOP2
         GAMT = PEKRT( GAMMA2 )
      END IF

      IF ( BCBOT(1:1) .EQ. 'A' ) THEN
         GAMMA2 = CK( MODE ) ** 2 - KBOT2
         GAMB = PEKRT( GAMMA2 )
      END IF

      DO IR = 1, NRD

         IF ( RD( IR ) .LT. DEPTHT ) THEN
C           ------ Rcvr in upper halfspace
            PHIR( IR ) = PHI( 1    ) *
     &                     EXP( -GAMT * ( DEPTHT - RD( IR  ) ) )
         ELSE IF ( RD( IR ) .GT. DEPTHB ) THEN
C           ------ Rcvr in lower halfspace
            PHIR( IR ) = PHI( NTOT ) *
     &                     EXP( -GAMB * ( RD( IR ) - DEPTHB ) )
         ELSE IF ( NTOT .GT. 1 ) THEN
            IZ = IRD( IR )
            PHIR( IR ) = PHI( IZ ) +
     &                     W( IR ) * ( PHI( IZ + 1 ) - PHI( IZ ) )
         ELSE   ! case where mode is tabulated at only one depth
            IZ = IRD( IR )
            PHIR( IR ) = PHI( IZ )
         ENDIF

      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE EXTRACT( PHI, N, MATER, NMEDIA, COMP )

C     For elastic problems where a stress-displacement vector is output,
C     extracts the desired component

      INTEGER   N( * )
      COMPLEX   PHI( * )
      CHARACTER MATER( * )*8, COMP*( *)

      J = 1
      K = 1

      DO MED = 1, NMEDIA

         DO I = 1, N( MED ) + 1
            IF ( MATER( MED ) .EQ. 'ACOUSTIC' ) THEN
               PHI( J ) = PHI( K )
               K = K + 1
            ELSE
               IF ( COMP .EQ. 'H' ) PHI( J ) = PHI( K     )
               IF ( COMP .EQ. 'V' ) PHI( J ) = PHI( K + 1 )
               IF ( COMP .EQ. 'T' ) PHI( J ) = PHI( K + 2 )
               IF ( COMP .EQ. 'N' ) PHI( J ) = PHI( K + 3 )
               K = K + 4
            ENDIF
            J = J + 1
         END DO

      END DO

      RETURN
      END

      SUBROUTINE RDHEAD( SHDFIL, FILNAM, MAXNR, MAXNSD, MAXNRD,
     &   FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &   SD, NSD, RD, NRD, TITLE )

      INTEGER SHDFIL
      REAL    R( * ), RD( * ), SD( * )
      CHARACTER TITLE*80, FILNAM*80, PLTTYP*10

C     *** Open file, read header ***

C     Note that for UNIX file must be opened a second time with
C     the correct record length

      IF ( SHDFIL .EQ. 0 ) SHDFIL = 25

      IF ( FILNAM(1:1) .EQ. ' ' ) THEN
         OPEN( FILE = 'SHDFIL', UNIT = SHDFIL, STATUS = 'OLD',
     &         RECL = 20, ACCESS = 'DIRECT', FORM = 'UNFORMATTED' )
         READ( SHDFIL, REC = 1 ) LRECL
         CLOSE( SHDFIL )

         OPEN( FILE = 'SHDFIL', UNIT = SHDFIL, STATUS = 'OLD',
     &      RECL = 4 * LRECL, ACCESS = 'DIRECT', FORM = 'UNFORMATTED' )
      ELSE
         OPEN( UNIT = SHDFIL, FILE = FILNAM, STATUS = 'OLD',
     &       RECL = 20, ACCESS = 'DIRECT', FORM = 'UNFORMATTED' )
         READ( SHDFIL, REC = 1 ) LRECL
         CLOSE( SHDFIL )

         OPEN( UNIT = SHDFIL, FILE = FILNAM, STATUS = 'OLD',
     &      RECL = 4 * LRECL, ACCESS = 'DIRECT', FORM = 'UNFORMATTED' )
      ENDIF

      READ( SHDFIL, REC = 1 ) LRECL, TITLE
      READ( SHDFIL, REC = 2 ) PLTTYP, XS, YS, THETA
      READ( SHDFIL, REC = 3 ) FREQ, NSD, NRD, NR

      XS = XS / 1000.0
      YS = YS / 1000.0

C     *** Intercept cases where program dimensions are inadequate ***

      IF ( NR .GT. MAXNR ) THEN
         WRITE( *, * ) 'FATAL ERROR: Too many range points'
         WRITE( *, * ) 'NR = ', NR, ' MAXNR = ', MAXNR
         STOP
      ENDIF

      IF ( NSD .GT. MAXNSD ) THEN
         WRITE( *, * ) 'FATAL ERROR: Too many source points'
         WRITE( *, * ) 'NSD = ', NSD, ' MAXNSD = ', MAXNSD
         STOP
      ENDIF

      IF ( NRD .GT. MAXNRD ) THEN
         WRITE( *, * ) 'FATAL ERROR: Too many receiver points'
         WRITE( *, * ) 'NRD = ', NRD, ' MAXNRD = ', MAXNRD
         STOP
      ENDIF

      READ( SHDFIL, REC = 4 ) ( SD( I ), I = 1, NSD )
      READ( SHDFIL, REC = 5 ) ( RD( I ), I = 1, NRD )
      READ( SHDFIL, REC = 6 ) ( R(  I ), I = 1, NR  )

      DELTAR = R( NR ) - R( NR - 1 )

      RETURN
      END

      SUBROUTINE EVAL( C, PHI, NZ, R, NR, RR,
     &   CK, M, OPTION, P )

C     Given modes and wavenumbers, compute pressure field
C     Normalized to pressure of point source at 1 meter
C     OPTION = X     Cartesian   (x, z) coordinates
C     OPTION = R     Cylindrical (r, z) coordinates

      COMPLEX CI
      PARAMETER ( MAXM = 1500, CI = (0.0, 1.0), PI = 3.1415926, 
     &   MAXNZ = 251, MINEXP = -37 )

      REAL RR( * ), R( * )
      COMPLEX C( * ), PHI( MAXM, * ), P( NZ, * ), T, HANK( MAXM ),
     &   CICK( MAXM ), CONST( MAXM ), CMAT( MAXM, MAXNZ ), CK( * ),
     &   FACTOR
      COMPLEX*16 PHASE
      CHARACTER OPTION*(*)

C     *** If no modes, return vanishing pressure ***

      IF ( M .LE. 0 ) THEN
         DO IR = 1, NR
            DO IZ = 1, NZ
               P( IZ, IR ) = 0.0
            END DO
         END DO
         RETURN
      END IF

C     Initialization

      FACTOR = CI * SQRT( 2.0 * PI ) * EXP( CI * PI / 4.0 )

      DO MODE = 1, M

         IF ( OPTION(1:1) .EQ. 'X' ) THEN
            CONST( MODE ) = FACTOR * C( MODE ) / CK( MODE )
         ELSE
            CONST( MODE ) = FACTOR * C( MODE ) / SQRT( CK( MODE ) )
         ENDIF

         CICK( MODE ) = -CI * CK( MODE )   ! use e{i(wt-kr)} form
         IF ( OPTION(4:4) .EQ. 'I' ) CICK( MODE ) = REAL( CICK( MODE ) )   ! Incoherent case

      END DO

      DO IZ = 1, NZ

         DO MODE = 1, M
            CMAT( MODE, IZ ) = CONST( MODE ) * 
     &         PHI( MODE, IZ ) * EXP( CICK( MODE ) * RR( IZ ) )
         END DO

      END DO

C     *** Loop over range ***

      DO IR = 1, NR

         DO MODE = 1, M

C           --- eliminate underflows (can raise CPU time)
            IF ( REAL( CICK( MODE ) * R( IR ) ) .LT. MINEXP ) THEN
               HANK( MODE ) = 0.0
            ELSE
C              HANK( MODE ) = EXP( CICK( MODE ) * R( IR ) )
C              handle an SGI bug in sin( large number )
               PHASE = CICK( MODE ) * R( IR )
               HANK( MODE ) = EXP( PHASE )
            ENDIF
         END DO

C        *** Loop over depth ***

         DO IZ = 1, NZ
            T = 0.0
            IF ( OPTION(4:4) .NE. 'I' )  THEN   ! coherent case
               DO MODE = 1, M
                  T = T + CMAT( MODE, IZ ) * HANK( MODE )
               END DO
            ELSE                                ! incoherent case
               DO MODE = 1, M
                  T = T + ABS(  CMAT( MODE, IZ ) * HANK( MODE ) ) ** 2
               END DO
               T = SQRT( T )
            ENDIF

C           ------ Cylindrical or cartesian coordinates?
            IF ( OPTION(1:1) .EQ. 'R' )
     &         T = T / SQRT( R( IR ) + RR( IZ ) )
            P( IZ, IR ) = T
         END DO

      END DO   ! next range step

      RETURN
      END

      SUBROUTINE BCIMPZ( X, BCTYPE, BOTTOP, CPHS, CSHS, RHOHS,
     &   F, G, IPOW, CENT )

C     Compute Boundary Condition IMPedance

      INCLUDE 'comc1.f'

      COMPLEX*16 X, F, G, KX, KZ, TWERSK,
     &   GAMS2, GAMP2, GAMS, GAMP, RMU, YV( 5 ),
     &   PEKRTZ, RCMPLX
      COMPLEX*16 CPHS, CSHS, CINS
      REAL*8 RSX, RKS, RKP, OMEGA, CENT
      CHARACTER BCTYPE*1, BOTTOP*3

      IPOW = 0
      OMEGA = SQRT( OMEGA2 )

C     *** Get RHO, C just INSide the boundary ***

      IF ( BOTTOP(1:3) .EQ. 'TOP' ) THEN
         I = LOC( NFACT ) + N( NFACT ) + 1
         RHOINS = RHO( I )
         CINS = PEKRT( OMEGA2 * H( NFACT ) **2 / ( 2.0 + B1( NFACT )))
      ELSE
         I = LOC( NLACT ) + N( NLACT ) + 1
         RHOINS = RHO( I )
         CINS = PEKRT( OMEGA2 * H( NLACT ) **2 / ( 2.0 + B1( NLACT )))
      ENDIF

C     *** Vacuum ***

      IF ( BCTYPE(1:1) .EQ. 'V' ) THEN
         F = 1.0
C         G = -CI * PEKRT( OMEGA2 / CINS ** 2 - X ) * SIGMA( 1 ) ** 2
         G = 0.0
      ENDIF

C     *** Vacuum with Twersky scatter model ***

      IF ( BCTYPE(1:1) .EQ. 'S' .OR. BCTYPE(1:1) .EQ. 'H' .OR.
     &     BCTYPE(1:1) .EQ. 'T' .OR. BCTYPE(1:1) .EQ. 'I' ) THEN

         OMEGA = SQRT( OMEGA2 )
         KX = SQRT( X )
         F = 1.0
         G = TWERSK( BCTYPE, OMEGA, BUMDEN, XI, ETA, KX, RHOINS, CINS )
         G = G / ( CI * OMEGA * RHOINS )
      ENDIF

C     *** Rigid ***
      IF ( BCTYPE(1:1) .EQ. 'R' ) THEN
         F = 0.0
         G = 1.0
      ENDIF

      YV( 1 ) = F
      YV( 2 ) = G
      YV( 3 ) = 0.0
      YV( 4 ) = 0.0
      YV( 5 ) = 0.0

C     *** Acousto-elastic half-space ***

      IF ( BCTYPE(1:1) .EQ. 'A' ) THEN
         RSX = DREAL( SQRT( X ) )
         IF ( REAL( CSHS ) .GT. 0.0 ) THEN
            RKS = OMEGA * DREAL( CSHS ) / CSHS / DCONJG( CSHS )
            RKP = OMEGA * DREAL( CPHS ) / CPHS / DCONJG( CPHS )
            GAMS2 = X - OMEGA2 / CSHS ** 2
            GAMP2 = X - OMEGA2 / CPHS ** 2

            GAMS = PEKRTZ( GAMS2, CENT, RKS )
           GAMP = PEKRTZ( GAMP2, CENT, RKP )
c            GAMS = PEKRT( GAMS2 )
c            GAMP = PEKRT( GAMP2 )
            
            RMU = RHOHS * CSHS ** 2

            YV( 1 ) = ( GAMS*GAMP - X ) / RMU
            YV( 2 ) = ( ( GAMS2 + X ) ** 2 - 4.0*GAMS * GAMP * X ) * RMU
            YV( 3 ) = 2.0 * GAMS * GAMP - GAMS2 - X
            YV( 4 ) = GAMP * ( X - GAMS2 )
            YV( 5 ) = GAMS * ( GAMS2 - X )

            F = OMEGA2 * YV( 4 )
            G = YV( 2 )
         ELSE
            RKP = OMEGA * DREAL( CPHS ) / CPHS / DCONJG( CPHS )
c            write(*,*) ' RKP : ', RKP
            GAMP2 = X - OMEGA2 / CPHS ** 2
           GAMP = PEKRTZ( GAMP2, CENT, RKP )
c            GAMP = PEKRT( GAMP2 )        
              F = 1.0
              G = RHOHS / GAMP             
         ENDIF
      ENDIF

C     *** Tabulated reflection coefficient ***

      IF ( BCTYPE(1:1) .EQ. 'F' ) THEN
C        ------ Compute the grazing angle THETA
         KX = SQRT( X )
         KZ = SQRT( OMEGA2 / CINS ** 2 - KX ** 2 )
         RADDEG = 360.0 / ( 2.0 * PI )
         THEINT = RADDEG * DATAN2( DBLE( KZ ), DBLE( KX ) )

C        ------ Evaluate R(THEINT)
         IF ( BOTTOP(1:3) .EQ. 'TOP' ) THEN
            CALL REFCO( THEINT, RINT, PHIINT, THETAT, RT, PHIT, NTPTS )
         ELSE
            CALL REFCO( THEINT, RINT, PHIINT, THETAB, RB, PHIB, NBPTS )
         ENDIF

C        ------ Convert R(THETA) to (f,g) in Robin BC
         RCMPLX = RINT * EXP( -CI * PHIINT )
         F = 1.0
         G = ( 1.0 + RCMPLX ) / ( CI * KZ * ( 1.0 - RCMPLX ) )
      ENDIF

C     *** A top BC has the sign flipped relative to a bottom BC ***

      IF ( BOTTOP(1:3) .EQ. 'TOP' ) G = -G

C     *** Precalculated reflection coef ***

      IF ( BCTYPE(1:1) .EQ. 'P' ) THEN
         CALL IRCINT( X, F, G, IPOW, XTAB, FTAB, GTAB, ITAB, NKPTS )
      ENDIF

C     *** Shoot through elastic layers ***

      IF ( BOTTOP(1:3) .EQ. 'TOP' ) THEN

C        ------ Shoot down from top
         IF ( NFACT. GT. 1 ) THEN

            DO MED = 1, NFACT - 1
               CALL ELASDN( X, YV, IPOW, MED )
            END DO

            F = OMEGA2 * YV( 4 )
            G = YV( 2 )
         ENDIF
      ELSE

C        ------ Shoot up from bottom
         IF ( NLACT. LT. NMEDIA ) THEN

            DO MED = NMEDIA, NLACT + 1, -1
               CALL ELASUP( X, YV, IPOW, MED )
            END DO

            F = OMEGA2 * YV( 4 )
            G = YV( 2 )
         ENDIF
      ENDIF

      RETURN
      END
      

      SUBROUTINE EVALCM( RPROF, NPROF, PHIS, PHI, RD, NRD, 
     &   R, NR, CK, M, OPT, P )

C     Computes pressure field using coupled mode theory
C     Normalized to pressure of point source at 1 meter

C     OPT = X     Cartesian   (X, Z) coordinates
C     OPT = R     Cylindrical (R, Z) coordinates

C     Note number of propagating modes is reset after first segment.
C     Thus M restricts the number of modes in the source field but
C     thereafter energy is allowed to couple into higher-order modes.

C     Note flaws:
C        should half-space contribution include imaginary part?
C        Then we need to handle the growing part of leaky waves.

      COMPLEX CI
      PARAMETER ( MAXM = 1500, CI = ( 0.0, 1.0 ), PI = 3.1415926 )

      LOGICAL FIRST
      REAL      RD( * ), RPROF( * ), R( * )
      COMPLEX   PHIS( * ), PHI( MAXM, * ), A( MAXM ), SUM,
     &          P( NRD, * ), CK( * )
      CHARACTER OPT*( * ), TITLE*80
      SAVE FIRST
      DATA FIRST /.TRUE./

C     *** Compute ranges (in meters) where new profiles are used ***

      IF ( FIRST ) THEN
         IF ( RPROF( 1 ) .NE. 0.0 )
     &      STOP 'FATAL ERROR: First profile must start at zero range'

         DO IPROF = NPROF, 2, -1
            RPROF( IPROF ) = 500.0*( RPROF( IPROF ) + RPROF( IPROF-1 ) )
         END DO

         RPROF(  NPROF + 1 ) = 1.0E9
         FIRST = .FALSE.
      ENDIF

C     *** Evaluate mode excitation coefficients, A(mode) ***

      IPROF = 1

C     THIS HAS ALREADY BEEN READ IN PLOTTLR!

      CALL GETMOD( IPROF, ' ', MAXM, RD, NRD, 'N',
     &                         CK, PHI,  M1, FREQ, TITLE )

      M = MIN( M, M1 )

      DO MODE = 1, M
         IF ( OPT(1:1) .EQ. 'X' ) THEN
            A( MODE ) = SQRT( 2.0*PI ) * EXP( CI * PI / 4.0 ) *
     &                  PHIS( MODE ) / CK( MODE )
         ELSE
C           ------ 'R' Cylindrical coordinates
            A( MODE ) = CI * SQRT( 2.0*PI ) * EXP( CI * PI / 4.0 ) *
     &                  PHIS( MODE ) / SQRT( CK(MODE) )
         ENDIF
      END DO

C     *** March forward in range ***

      DO IR = 1, NR
C        WRITE( *, * ) 'Range = ', R( IR )

C        *** Crossing into new range segment? ***

         IF ( R( IR ) .GT. RPROF( IPROF + 1 ) ) THEN

            IPROF = IPROF + 1

C           ------ Advance to interface
            IF ( IR .EQ. 1 ) THEN
               CALL ADVPHA( RPROF( IPROF )              , A, CK, M )
            ELSE
               CALL ADVPHA( RPROF( IPROF ) - R( IR - 1 ), A, CK, M )
            ENDIF

C           ------ Here's where we cross over
            IF ( IPROF  .LE. NPROF ) THEN
               CALL NEWPRO( IPROF, CK, PHI, M, RD, NRD, A )
               WRITE( *, * ) 'New profile read', R(I R ), IPROF,
     &                       ' #modes = ', M
            ENDIF

C           ------ Are there other segments to cross?
   50       CONTINUE
            IF ( R( IR ) .GT. RPROF( IPROF + 1 ) ) THEN
               IPROF = IPROF + 1
               CALL ADVPHA( RPROF( IPROF ) - RPROF( IPROF - 1 ),
     &                                                   A, CK, M )
               IF ( IPROF  .LE. NPROF )
     &            CALL NEWPRO( IPROF, CK, PHI, M, RD, NRD, A )

               GOTO 50       ! Check again
            ENDIF

C           ------ Advance the remaining distance
            CALL ADVPHA( R( IR ) - RPROF( IPROF ), A, CK, M )

         ELSE

            IF ( IR .EQ. 1 ) THEN
               CALL ADVPHA( R( IR )              , A, CK, M )
            ELSE
               CALL ADVPHA( R( IR ) - R( IR - 1 ), A, CK, M )
            ENDIF

         ENDIF

C        *** For each rcvr add up modal contributions ***

         DO IRD = 1, NRD

            SUM = 0.0
            DO MODE = 1, M
               SUM = SUM + A( MODE ) * PHI( MODE, IRD )
            END DO

            IF ( OPT(1:1) .EQ. 'R' .AND. R( IR ) .NE. 0.0 ) THEN
               P( IRD, IR ) = SUM / SQRT( R( IR ) )
            ELSE
               P( IRD, IR ) = SUM
            ENDIF

         END DO

C        ------ Next range step
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE ADVPHA( DELTAR, A, CK, M )

C     *** ADVance the PHAse of the coefficients ***

      COMPLEX CI
      PARAMETER ( CI = ( 0.0, 1.0 ) )

      COMPLEX A( * ), CK( * )

      DO L = 1, M
         A( L ) = A( L ) * EXP( -CI * CK( L ) * DELTAR )
      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE NEWPRO( IPROF, CK, PHIR, MR, RD, NRD, A )

C     For a given profil number:
C         read in modes for current segment
C         project the pressure field onto the new modes
C         extract values of the modes at rcvr depths

      PARAMETER ( MAXN = 16001, MAXM = 1500, MAXNRD = 201 )

      INTEGER    IRD( MAXNRD )
      REAL       Z( MAXN ), RD( * ), W( MAXNRD )
      COMPLEX    CK( * ), PHI( MAXN ), PHIR( MAXM, * ),
     &           P( MAXN ), A( * ), SUM,
     &           GAMTL( MAXM ), GAMBL( MAXM ),
     &           PHITL( MAXM ), PHIBL( MAXM ),
     &           GAMTR, GAMBR, PHITR, PHIBR,
     &           KTOP2R, KBOT2R, TAIL, PHITMP
      COMPLEX*16 PEKRT, GAMMA2
      CHARACTER  BCBOTR * 1, BCTOPR * 1

      IF ( NRD. GT. MAXNRD )
     &   STOP 'NRD > MAXNRD in routine NEWPRO'

C     *** Compute pressure along the left of the interface ***

      CALL PLEFT( IPROF, A, CK, Z, PHI, MR, P, NR, NTOT,
     &   BCTOPR, RHOTR, KTOP2R, DEPTHTR,
     &   BCBOTR, RHOBR, KBOT2R, DEPTHBR,
     &   GAMTL, GAMBL, DEPTHTL, DEPTHBL, PHITL, PHIBL, ML, MAXM )

C     ***  Read in eigenfunctions and extract receiver values ***

C     Compute weights for mode interpolation at rcvr depths

      CALL WEIGHT( Z, NTOT, RD, NRD, W, IRD )

      sum2 = 0.0
      MODFIL = 29 + IPROF

      DO MODE = 1, MR
         READ( MODFIL, REC = 6 + MODE ) ( PHI( IZ ), IZ = 1, NR )

         IF ( BCTOPR .EQ. 'A' ) THEN
            PHITR = PHI( 1 )
            GAMMA2 = CK( MODE ) ** 2 - KTOP2R
            GAMTR = PEKRT( GAMMA2 )
         ENDIF

         IF ( BCBOTR .EQ. 'A' ) THEN
            PHIBR = PHI( NR )
            GAMMA2 = CK( MODE ) ** 2 - KBOT2R
            GAMBR = PEKRT( GAMMA2 )
         ENDIF

C        --- Compute new amplitudes:
C           A = Integral[ P( z ) * PHI( z ) dz ]
C           (Repeat for each mode PHI to produce excitation coef. A)
C           Integral is done using trapezoidal rule

         SUM = 0.0

         DO IZ = 1, NTOT

C           ------ Calculate PHI at that depth

            PHITMP = 0.0
            ZT = Z( IZ )

            IF ( ZT .GT. DEPTHBR ) THEN
               IF ( BCBOTR .EQ. 'A' ) PHITMP = PHIBR *
     &                          EXP( -GAMBR * ( ZT - DEPTHBR ) )
            ELSE IF ( ZT .LT. DEPTHTR ) THEN
               IF ( BCTOPR .EQ. 'A' ) PHITMP = PHITR *
     &                          EXP( -GAMTR * ( DEPTHTR - ZT ) )
            ELSE
               PHITMP = PHI( IZ )
            ENDIF

            SUM = SUM + P( IZ ) * PHITMP

         END DO

C        *** Compute the contribution from tails in the halfspaces ***

         IF ( BCTOPR .EQ. 'A' ) THEN
            SUM   = SUM + TAIL( Z( 1    ), PHITL, GAMTL, DEPTHTL, ML,
     &                             PHITR / RHOTR, GAMTR, DEPTHTR )
         ENDIF

         IF ( BCBOTR .EQ. 'A' ) THEN
            SUM   = SUM + TAIL( Z( NTOT ), PHIBL, GAMBL, DEPTHBL, ML,
     &                             PHIBR / RHOBR, GAMBR, DEPTHBR )
         ENDIF

         IF ( MODE .GT. ML ) A( MODE ) = 0.0
         WRITE( *, * ) MODE, ABS( A( MODE ) ), ABS( SUM )

         A( MODE ) = SUM
         sum2 = sum2 + abs( sum )**2

C        *** Subtabulate modes at receiver depths ***

         DO IR = 1, NRD

            PHIR( MODE, IR ) = 0.0
            IF      ( RD( IR ) .LT. DEPTHTR ) THEN
C              ------ Rcvr in upper halfspace
               IF ( BCTOPR .EQ. 'A' ) PHIR( MODE, IR ) = PHITR *
     &                     EXP( -GAMTR * ( DEPTHTR   - RD( IR  ) ) )
            ELSE IF ( RD( IR ) .GT. DEPTHBR ) THEN
C              ------ Rcvr in lower halfspace
               IF ( BCBOTR .EQ. 'A' ) PHIR( MODE, IR ) = PHIBR *
     &                     EXP( -GAMBR * ( RD( IR ) - DEPTHBR ) )
            ELSE
               IZ = IRD( IR )
               PHIR( MODE, IR ) = PHI( IZ ) +
     &                     W( IR ) * ( PHI( IZ + 1 ) - PHI( IZ ) )
            ENDIF

         END DO

      END DO   ! next mode

      CLOSE( MODFIL )

      WRITE( *, * ) 'sum2**', sum2

      RETURN
      END
C**********************************************************************C
      SUBROUTINE PLEFT( IPROF, A, CK, Z, PHI, M, P, NR, NTOT,
     &   BCTOP, RHOT, KTOP2, DEPTHT,
     &   BCBOT, RHOB, KBOT2, DEPTHB,
     &   GAMTL, GAMBL, DEPTHTL, DEPTHBL, PHITL, PHIBL, ML, MAXM )

C     Computes the pressure field along the interface.
C     Also returns information needed for the tails in the halfspaces

      PARAMETER ( MAXN = 16001, MAXMED = 50 )

      INTEGER    N( MAXMED )
      REAL       ZL( MAXN ), Z( * ), RHOL( MAXMED ), RHO( MAXMED ),
     &           DEPTHL( MAXMED ), DEPTH( MAXMED )
      COMPLEX    CK( * ), PHI( * ), PL( MAXN ), P( * ), A( * ),
     &           GAMTL( * ), GAMBL( * ), PHITL( * ), PHIBL( * ),
     &           KTOP2, KBOT2
      COMPLEX*16 PEKRT
      CHARACTER  TITLE * 80, MATER( MAXMED ) * 8, BCBOT * 1, BCTOP * 1,
     &           FILNAM * 8

C     *** Read modal info at end of last segment ***

      CALL MODHDR( IPROF - 1, FILNAM,
     &   TITLE, FREQ, NMEDIA, NL, NMAT,
     &   N, MATER, DEPTHL, RHOL,
     &   BCTOP, RHOT, DEPTHTL,
     &   BCBOT, RHOB, DEPTHBL,
     &   ML, MAXM, ZL, CK, KTOP2, KBOT2, MODFIL )

      ML = M   ! we only know M amplitudes

C     *** Compute pressure at the interface ***

      DO IZ = 1, NL
         PL( IZ ) = 0.0
      END DO

      DO MODE = 1, ML
         READ( MODFIL, REC = 6 + MODE ) ( PHI( IZ ), IZ = 1, NL )

         DO IZ = 1, NL
            PL( IZ ) = PL( IZ ) + A( MODE ) * PHI( IZ )
         END DO

C        ------ Halfspace information ------

         PHITL( MODE ) = A( MODE ) * PHI( 1  )
         PHIBL( MODE ) = A( MODE ) * PHI( NL )

         GAMTL( MODE ) = 0.0
         GAMBL( MODE ) = 0.0

C        we take the real part, GAMMA2, since leaky modes grow in depth
         IF ( BCTOP .EQ. 'A' ) THEN
            GAMMA2 = CK( MODE ) ** 2 - KTOP2
            GAMTL( MODE ) = PEKRT( GAMMA2 )
         END IF

         IF ( BCBOT .EQ. 'A' ) THEN
            GAMMA2 = CK( MODE ) ** 2 - KBOT2
            GAMBL( MODE ) = PEKRT( GAMMA2 )
         END IF

      END DO

      CLOSE( MODFIL )

C     *** Read modal data in new segment ***

      CALL MODHDR( IPROF, FILNAM,
     &   TITLE, FREQ, NMEDIA, NR, NMAT,
     &   N, MATER, DEPTH, RHO,
     &   BCTOP, RHOT, DEPTHT,
     &   BCBOT, RHOB, DEPTHB,
     &   M, MAXM, Z, CK, KTOP2, KBOT2, MODFIL )

C     *** Upslope? Extend the Z vector with data from ZL ***

      NTOT = NR

      DO IZL = 1, NL
         IF ( ZL( IZL ) .GT. Z( NTOT ) ) THEN
            NTOT  = NTOT + 1
            Z( NTOT ) = ZL( IZL )
         ENDIF
      END DO

C     *** Retabulate the pressure on the new grid ***

      IZL = 1
      MED = 1
      RHOMED = RHO( 1 )

C     --- Depth of next interface below this one
      IF ( MED .LT. NMEDIA ) THEN
         DBELOW = DEPTH( MED + 1 )
         RHOBEL = RHO( MED + 1 )
      ELSE
         DBELOW = DEPTHB
         RHOBEL = RHOB
      ENDIF

      DO IZ = 1, NTOT
         ZT = Z( IZ )

C        ------ Get medium density
         IF      ( ZT .LT. DEPTHT ) THEN
            RHOMED = RHOT
         ELSE IF ( ZT .GT. DEPTHB ) THEN
            RHOMED = RHOB
         ELSE IF ( MED .LT. NMEDIA ) THEN
            IF   ( ZT .GT. DBELOW ) THEN
               MED    = MED + 1
               RHOMED = RHO( MED )
            ENDIF
         ENDIF

C        --- DEPTH of next interface BELow this one
         IF ( MED .LT. NMEDIA ) THEN
            DBELOW = DEPTH( MED + 1 )
            RHOBEL = RHO( MED + 1 )
         ELSE
            DBELOW = DEPTHB
            RHOBEL = RHOB
         ENDIF

 4000    IF ( ZT .GT. ZL( IZL + 1 ) .AND. IZL .LT. NL - 1 ) THEN
            IZL = IZL + 1
            GOTO 4000
         ENDIF

C        ------ Calculate P at that depth

         IF      ( ZT .GT. DEPTHBL ) THEN   ! lower halfspace
            IF ( BCBOT .EQ. 'A' ) THEN
               P( IZ ) = 0.0
               DO MODE = 1, ML
                  P( IZ ) = P( IZ ) + PHIBL( MODE ) *
     &                 EXP( -GAMBL( MODE ) * ( ZT - DEPTHBL ) )
               END DO
            ENDIF
         ELSE IF ( ZT .LT. DEPTHTL ) THEN   ! upper halfpace
            IF ( BCTOP .EQ. 'A' ) THEN
               P( IZ ) = 0.0
               DO MODE = 1, ML
                  P( IZ ) = P( IZ ) + PHITL( MODE ) *
     &                 EXP( -GAMTL( MODE ) * ( DEPTHTL - ZT ) )
               END DO
            ENDIF
         ELSE
            P( IZ ) = PL( IZL ) +
     &         ( ZT - ZL( IZL ) ) / ( ZL( IZL + 1 ) - ZL( IZL ) ) *
     &                              ( PL( IZL + 1 ) - PL( IZL ) )
         ENDIF

C        *** compute mesh width, h ***

         IF ( IZ .EQ. 1 ) THEN
C           ------ First point
            H = 0.5 * ( Z(  2   ) - Z(   1      ) ) / RHOMED
         ELSE IF ( IZ .EQ. NTOT ) THEN
C           ------ Last point
            H = 0.5 * ( Z( NTOT ) - Z( NTOT - 1 ) ) / RHOMED
         ELSE
            IF ( Z( IZ - 1 ) .LT. DBELOW .AND.
     &           Z( IZ + 1 ) .GT. DBELOW ) THEN
C              ------ Point just above or below the interface
               H = 0.5 * ( Z( IZ + 1 ) / RHOBEL
     &                   - Z( IZ - 1 ) / RHOMED
     &                   - DBELOW / RHOBEL
     &                   + DBELOW / RHOMED )
            ELSE
               H = 0.5 * ( Z( IZ + 1 ) - Z( IZ   - 1 ) ) / RHOMED
            ENDIF
         ENDIF

         P( IZ ) = H * P( IZ )

      END DO   ! next depth IZ

      RETURN
      END
C**********************************************************************C
      COMPLEX FUNCTION TAIL( D, PHIL, GAML, DL, ML, PHIR, GAMR, DR )

      COMPLEX GAML( * ), PHIL( * ), GAMR, PHIR, FR

      TAIL = 0.0
      FR =  PHIR         * EXP( -GAMR         * ( D - DR ) )

      DO MODE = 1, ML

         IF ( D .EQ. DL ) THEN
            TAIL = TAIL + FR * PHIL( MODE ) / ( GAML( MODE ) + GAMR )
         ELSE
            TAIL = TAIL + FR * 
     &         PHIL( MODE ) * EXP( -GAML( MODE ) * ( D - DL ) )
     &               / ( GAML( MODE ) + GAMR )
         ENDIF

      END DO

      RETURN
      END

      SUBROUTINE CSPLINE (TAU, C, N, IBCBEG, IBCEND, NDIM)

C  TAKEN FROM "A PRACTICAL GUIDE TO SPLINES", BY CARL DE BOOR. 1978.
C  SPRINGER-VERLAG.  THE INPUT PARAMETER "NDIM" HAS BEEN ADDED TO
C  ALLOW FOR MULTIPLE CALLS WITH DIFFERENT VALUES OF N. - DENNIS DUNDORE
C
C  SUBSTANTIAL MODIFICATIONS MADE BY STEVE WALES, APRIL 1983, 
C  PRINCIPALLY TO HANDLE COMPLEX NUMBERS (C) & UPDATE THE FORTRAN.
C
C *****************************  I N P U T  ****************************
C
C  N = NUMBER OF DATA POINTS.  ASSUMED TO BE .GE. 2.
C
C  (TAU(I), C(1,I),I=1,...,N) = ABSCISSAE AND ORDINATES OF THE DATA
C      POINTS.  TAU IS ASSUMED TO BE STRICTLY INCREASING.
C
C  IBCBEG, IBCEND = BOUNDARY CONDITION INDICATORS, AND
C  C(2,1), C(2,N) = BOUNDARY CONDITION INFORMATION.  SPECIFICALLY,
C      IBCBEG = 0 IMPLIES NO BOUNDARY CONDITION AT TAU(1) IS GIVEN.
C            IN THIS CASE, THE "NOT-A-KNOT" CONDITION IS USED, IE THE
C            JUMP IN THE 3-RD DERIVATIVE ACROSS TAU(2) IS FORCED TO 0.,
C            THUS THE 1-ST AND 2-ND POLYNOMIAL PIECES ARE MADE TO
C            COINCIDE.
C      IBCBEG = 1 IMPLIES THAT THE SLOPE AT TAU(1) IS SET EQUAL TO C(2,1)
C            INPUT BY USER.
C      IBCBEG = 2 IMPLIES THAT THE 2-ND DERIVATIVE AT TAU(1) IS SET EQUAL
C            TO C(2,1), SUPPLIED BY INPUT.
C      IBCEND = 0, 1, OR 2 HAS ANALOGOUS MEANING CONCERNING THE BOUNDARY
C            CONDITION AT TAU(N), WITH INFORMATION SUPPLIED BY C(2,N).
C
C  NDIM = ROW DIMENSION OF C MATRIX:  C(4,NDIM)
C
C **************************  O U T P U T  ****************************
C
C  C(J,I), J=1,...,4;  I=1,...,L=N-1  =  THE POLY COEFFS OF THE CUBIC 
C      SPLINE WITH INTERIOR KNOTS TAU(2),...,TAU(N-1).  PRECISELY, IN THE
C      INTERVAL (TAU(I), TAU(I+1)), THE SPLINE F IS GIVEN BY
C
C       F(X) = C(1,I) + H*(C(2,I) + H*(C(3,I)/2. + H*C(4,I)/6.))
C
C      WHERE H = X - TAU(I).
C
C     THE COEFFICIENTS CALCULATED ARE, 1) THE VALUE, 2) THE SLOPE, AND
C     3) THE CURVATURE AT EACH OF THE KNOTS 1 TO N-1, AND 4) THE RATE OF 
C     CHANGE OF THE CURVATURE OVER THE FOLLOWING INTERVAL.  IN ADDITION,
C     WE HAVE THE VALUE AND THE SLOPE AT THE LAST POINT. THE LAST TWO
C     POSTIONS AT THE LAST POINT ARE THEN SET TO THE CURVATURE AT THAT
C     POINT (IN C(3,N)) AND THE MEAN VALUE OVER THE ENTIRE INTERVAL,
C     CALCULATED AS THE INTEGRAL OVER THE INTERVAL DIVIDED BY THE LENGTH
C     OF THE INTERVAL (IN C(4,N)).
C
C **********************************************************************

      IMPLICIT REAL*4 (A-H,O-Z)
      REAL*4     TAU(N)
      REAL*4 C(4,NDIM), G, DTAU, DIVDF1, DIVDF3

      L = N - 1

      DO 10 M = 2,N
          C(3,M) = TAU(M) - TAU(M-1)
          C(4,M) = (C(1,M) - C(1,M-1)) / C(3,M)
   10 CONTINUE

C   * BEGINNING BOUNDARY CONDITION SECTION *

      IF (IBCBEG.EQ.0)  THEN				! IBCBEG = 0
          IF (N.GT.2)  THEN				!     N > 2
              C(4,1) = C(3,3)
              C(3,1) = C(3,2) + C(3,3)
              C(2,1) = ((C(3,2) + 2.0*C(3,1))*C(4,2)*C(3,3) + 
     1                       C(3,2)**2 * C(4,3)) / C(3,1)
            ELSE                                        !     N = 2
              C(4,1) = (1.0,0.0)
              C(3,1) = (1.0,0.0)
              C(2,1) = 2.0 * C(4,2)
          END IF

      ELSE IF (IBCBEG.EQ.1)  THEN			! IBCBEG = 1
          C(4,1) = (1.0,0.0)
          C(3,1) = (0.0,0.0)

      ELSE IF (IBCBEG.EQ.2)  THEN			! IBCBEG = 2
          C(4,1) = (2.0,0.0)
          C(3,1) = (1.0,0.0)
          C(2,1) = 3.0*C(4,2) - C(2,1)*C(3,2)/2.0
      END IF

C   * RUNNING CALCULATIONS TO N-1 - LOOP IS NOT EXECUTED IF N = 2 *

      DO 20 M = 2,L
          G = -C(3,M+1) / C(4,M-1)
          C(2,M) = G*C(2,M-1) + 3.0*(C(3,M)*C(4,M+1)
     1                                               + C(3,M+1)*C(4,M))
          C(4,M) = G*C(3,M-1) + 2.0*(C(3,M) + C(3,M+1))
   20 CONTINUE

C   * ENDING BOUNDARY CONDITION SECTION *

      IF (IBCEND.NE.1)  THEN
          IF (IBCEND.EQ.0)  THEN
                IF (N.EQ.2 .AND. IBCBEG.EQ.0)  THEN
                  C(2,N) = C(4,N)
              ELSE IF ((N.EQ.3 .AND. IBCBEG.EQ.0) .OR. N.EQ.2)  THEN
                  C(2,N) = 2.0 * C(4,N)
                  C(4,N) = (1.,0.)
                  G = -1.0 / C(4,N-1)
              ELSE
                  G = C(3,N-1) + C(3,N)
                  C(2,N) = ((C(3,N) + 2.0*G) * C(4,N)*C(3,N-1) +
     1                  C(3,N)**2 * (C(1,N-1)-C(1,N-2)) / C(3,N-1)) / G
                  G = -G / C(4,N-1)
                  C(4,N) = C(3,N-1)
              END IF

          ELSE IF (IBCEND.EQ.2)  THEN
              C(2,N) = 3.0 * C(4,N) + C(2,N)*C(3,N)/2.0
              C(4,N) = (2.0,0.0)
              G = -1.0 / C(4,N-1)
          END IF

          IF ( IBCBEG.GT.0 .OR. N.GT.2)  THEN
              C(4,N) = G*C(3,N-1) + C(4,N)
              C(2,N) = (G*C(2,N-1) + C(2,N)) / C(4,N)
          END IF
      END IF

C   * RUN THE ENDING BOUNDARY EFFECT BACK THROUGH THE EQUATIONS *

      DO 40 J = L,1,-1
          C(2,J) = (C(2,J) - C(3,J)*C(2,J+1)) / C(4,J)
   40 CONTINUE

C   * FINAL CALCULATIONS *

      DO 50 I = 2,N
          DTAU = C(3,I)
          DIVDF1 = (C(1,I)-C(1,I-1)) / DTAU
          DIVDF3 = C(2,I-1) + C(2,I) - 2.0*DIVDF1
          C(3,I-1) = 2.0 * (DIVDF1-C(2,I-1)-DIVDF3) / DTAU
          C(4,I-1) = (DIVDF3/DTAU) * (6.0/DTAU)
   50 CONTINUE

C     * ADD THE CURVATURE AT THE LAST POINT IN THE THIRD POSITION OF THE 
C       LAST NODE *

      C(3,N) = C(3,L) + (TAU(N)-TAU(L)) * C(4,L)


C     * ADD THE MEAN VALUE OF THE ENTIRE INTERVAL IN THE FOURTH POSITION OF 
C       THE LAST NODE.  MEAN VALUE IS CALCULATED AS THE INTEGRAL OVER THE 
C       INTERVAL DIVIDED BY THE LENGTH OF THE INTERVAL. *

      C(4,N) = (0.0,0.0)
      DO 60 I = 1,L				! INTEGRATE OVER THE INTERVAL
          DTAU = TAU(I+1) - TAU(I)
          C(4,N) = C(4,N) + DTAU*(C(1,I) + DTAU*(C(2,I)/2.0 + 
     1                      DTAU*(C(3,I)/6.0 + DTAU*C(4,I)/24.0)))
   60 CONTINUE
      C(4,N) = C(4,N) / (TAU(N)-TAU(1))		! DIVIDE BY LENGTH OF INTERVAL

      RETURN
      END



      SUBROUTINE VSPLINE (TAU, C, M, MDIM, F, N)

C     VSPLINE CALCULATES THE CUBIC SPLINE VALUES FOR A SET OF N POINTS  
C     IN F FROM THE M-POINT CUBIC SPLINE FIT IN C AND THE NODES IN TAU.
C     THE POINTS ARE RETURNED IN F.  ALL OF THE POINTS IN F MUST LIE 
C     BETWEEN TAU(1) AND TAU(M).

C     * * * * * * * * * * * * *   WARNINGS   * * * * * * * * * * * * *
C
C     POINTS OUTSIDE OF THE SPLINE FIT REGION ARE EXTRAPOLATED FROM THE END
C     INTERVALS.  THIS CAN RESULT IN WILD VALUES IF EXTRAPOLATED TOO FAR.
C     ALSO THE POINTS MUST BE IN STRICTLY ASCENDING ORDER, IF NOT THE 
C     POINTS WHICH ARE OUT OF ORDER WILL BE EXTRAPOLATED FROM THE CURRENT
C     INTERVAL AGAIN RESULTING IN WILD VALUES.

      IMPLICIT REAL*4 (A-H,O-Z)
      REAL*4     TAU(M)
      REAL*4 C(4,MDIM), F(N), SPLINE

      J = 1
      DO 20 I = 1,N
   10 J1 = J + 1
      IF (TAU(J1).LT.REAL(F(I)) .AND. J1.LT.M) THEN ! CHECK TO MAKE SURE
           J = J + 1				      ! THIS POINT IS NOT
           GO TO 10				      ! IN THE NEXT INTERVAL.
      END IF
      H = DBLE (F(I)) - TAU(J)			! DISTANCE FROM START OF INTERVAL
      F(I) = SPLINE (C(1,J), H)
   20 CONTINUE
      RETURN
      END
C**********************************************************************C
      FUNCTION SPLINE ( C, H )

C     THIS FUNCTION EVALUATES THE SPLINE AT THE POINT H

      IMPLICIT REAL*4 ( A-H, O-Z )
      REAL*4 C(4), SPLINE

      SPLINE = C(1) + H * ( C(2) + H * ( C(3) / 2.0 + H * C(4) / 6.0 ) )
      RETURN
      END

      FUNCTION SPLINEX ( C, H )

C     THIS FUNCTION EVALUATES THE SPLINE DERIVATIVE AT THE POINT H

      IMPLICIT REAL*4 ( A-H, O-Z )
      REAL*4 C(4), SPLINEX

      SPLINEX = C(2) + H * ( C(3) + H * C(4) / 2.0 )
      RETURN
      END

      FUNCTION SPLINEXX ( C, H )

C     THIS FUNCTION EVALUATES THE SPLINE 2ND DERIVATIVE AT THE POINT H

      IMPLICIT REAL*4 ( A-H, O-Z )
      REAL*4 C(4), SPLINEXX

      SPLINEXX = C(3) + H * C(4)
      RETURN
      END
C**********************************************************************C
      SUBROUTINE SPLINEALL ( C, H, F, FX, FXX )

C     THIS ROUTINE EVALUATES THE SPLINE,
C                                SPLINE DERIVATIVE, AND
C                                SPLINE 2ND DERIVATIVE AT THE POINT H

      IMPLICIT REAL*4 ( A-H, O-Z )
      PARAMETER ( HALF = 0.5, SIXTH = 1.0 / 6.0 )
      REAL*4 C(4), F, FX, FXX

      F   = C(1) + H * ( C(2) + H * ( HALF * C(3) + SIXTH * H * C(4) ) )
      FX  = C(2) + H * ( C(3) + H * HALF * C(4) )
      FXX = C(3) + H * C(4)

      RETURN
      END

      PROGRAM ANGLES

C     Given two sound speed values, computes the maximum
C     angle at the first which turns at the second
C     angle measured wrt horizontal axis

C     Snell says, C2 * COS( ) = C1 * COS( 0.0 )

      PI = 3.14159265358979

      WRITE( *, * )
      WRITE( *, * )
      WRITE( *, * )
     &   'This routine calculates the take-off angle of the ray'
      WRITE( *, * )
     &   'which will turn (go horizontal) at a particular depth'
      WRITE( *, * )
      WRITE( *, * ) 'This angle depends only on the sound speed at the'
      WRITE( *, * ) 'source depth and at the turning depth.'
      WRITE( *, * )

 1000 WRITE( *, * ) 'Type the two sound speed values:'
      READ( *, * ) C1, C2

      IF ( C1 .GE. C2 ) THEN
         WRITE( *, * )
         WRITE( *, * ) 'FATAL ERROR: Must have C1 < C2 otherwise the'
         WRITE( *, * ) 'ray is not refracted back'
         WRITE( *, * )
         GO TO 1000
      ENDIF

      WRITE( *, * )
      WRITE( *, * )
      WRITE( *, * ) 'The take-off angle in degrees is = ',
     &                              180.0 / PI * ACOS( C1 / C2 )

      STOP
      END

      SUBROUTINE CLTIME

C     Clear the timer

      REAL TARRAY( 2 ), F

C     If you don't know what to use, set F=0.0 in place of:
      F = DTIME( TARRAY )

      RETURN
      END

C**********************************************************************C

      SUBROUTINE RDTIME( T1 )

C     Read the time

      REAL TARRAY( 2 ), F
      REAL*8 T1

C     If you don't know what to use, set F, T1 = 0.0 in place of:

      F = DTIME( TARRAY )
      T1 = TARRAY( 1 )

      RETURN
      END

      PROGRAM PLOTTS

C     Plot the source time series

      INTEGER PLPFIL
      PARAMETER ( PLPFIL = 1, MAXNT = 500000, MAXNSD = 51,
     &            MAXNST = 500000, PI = 3.141592 )

      REAL TV( MAXNT ), SVR( MAXNST ), SVI( MAXNST ), SD( MAXNSD )
      COMPLEX SV( MAXNST )
      CHARACTER PULSE*4, PULSTITL*80

C     *** Read in data ***

      NT = 3126

      OPEN( FILE = 'PLPFIL', UNIT = PLPFIL, STATUS = 'OLD' )
      READ( PLPFIL, * ) FREQ, FMIN, FMAX, PULSE

      IF ( PULSE(4:4) .EQ. 'H' .OR. PULSE(4:4) .EQ. 'N' )
     &   FMIN = 0.0   ! no low-cut filtering

      IF ( PULSE(4:4) .EQ. 'L' .OR. PULSE(4:4) .EQ. 'N' )
     &   FMAX = 1.0E9 ! no high-cut filtering

      READ( PLPFIL, * ) TMIN, TMAX

      OMEGA  = 2.0 * PI * FREQ
      DELTAT = (TMAX - TMIN) / ( NT - 1 )

C     *** Construct the time series ***

      DO IT = 1, NT
         TV( IT ) = TMIN + ( IT - 1 ) * DELTAT
      END DO

      CALL SOURCE( TV, SV, SD, NSD, NT, OMEGA, FMIN, FMAX, PULSE,
     &      PULSTITL )

      CALL SCALETS( TV, SV, SD, NSD, NT, PULSTITL, SVR, SVI,
     &   TMIN, TMAX, TINC, TAXL )

      STOP
      END

C**********************************************************************C

      SUBROUTINE SCALETS( TV, SV, SD, NSD, NT, PULSTITL, SVR, SVI,
     &   TMIN, TMAX, TINC, TAXL )

C     Scale and plot the time series data

      REAL TV( * ), SVR( NT, * ), SVI( NT, * ), SD( * )
      COMPLEX SV( NSD, * )
      CHARACTER TITLEY*80, PULSTITL*80

C     *** Write data ***

      IF ( NSD .EQ. 1 ) THEN
         TITLEY = 'Amplitude$'   ! Single curve
      ELSE
         TITLEY = 'Depth (m)$'   ! Multiple curves
      ENDIF

      LAST = INDEX( PULSTITL, '    ' ) - 1
      WRITE( *, 1000 ) PULSTITL(1:LAST)
 1000 FORMAT( '@ title "', A, '"' )

C     WRITE( *, 2000 ) NINT( FREQ ), NINT( SRCD ), NINT( RCVRD )
 2000 FORMAT(  '@ subtitle "',
     &         'F  =', I4, ' Hz, ',
     &         'Sd =', I4, ' m,  ',
     &         'Rd =', I4, ' m"' )

C     *** compute maximum ***

      SMAX = 1.0E-20

      DO IT = 1, NT
         DO IS = 1, NSD
            SVR( IT, IS ) =  REAL( SV( IS, IT ) )
            SVI( IT, IS ) = AIMAG( SV( IS, IT ) )

C           --- we do this in steps to avoid SGI compiler error:
            SRABS = ABS( SVR( IT, IS ) )
            SIABS = ABS( SVI( IT, IS ) )
            SMAX  = MAX( SRABS, SIABS, SMAX )
         END DO
      END DO

C     --- avoid scaling problems for vanishing time series
      IF ( SMAX .EQ. 0.0 ) SMAX = 1.0

      DO IT = 1, NT
         DO IS = 1, NSD
            SVR( IT, IS ) = SVR( IT, IS )
            SVI( IT, IS ) = SVI( IT, IS )
         END DO
      END DO

C     *** Plot ***

      DO IS = 1, NSD

         WRITE( *, 3000 ) NSD - IS, NSD - IS
 3000    FORMAT( '@WITH G', I1.1, /,
     &           '@G', I1.1, ' ON', /,
     &           '@TYPE xy' )

C        --- real part
         DO IT = 1, NT
            WRITE( *, * ) TV( IT ), SVR( IT, IS )
         END DO
         WRITE( *, * ) '&'

C        --- imaginary part
         DO IT = 1, NT
            WRITE( *, * ) TV( IT ), SVI( IT, IS )
         END DO
         WRITE( *, * ) '&'
      END DO

      RETURN
      END

      SUBROUTINE EVALAD( RPROF, NPROF, PHIS, PHIR, RD, NRD, 
     &   R, NR, M, OPT, P )

C     Computes pressure field using adiabatic mode theory
C     Normalized to pressure at 1 meter

C     OPT
C
C     X     Cartesian   (x, z) coordinates
C     T     Translationally invariant ocean
C     R     Cylindrical (r, z) coordinates
C     S     Scaled cylindrical coordinates ( 1/r fall-off removed )

      COMPLEX CI
      PARAMETER ( MAXM = 1500, MAXNRD = 101,
     &    CI = ( 0.0, 1.0 ), PI = 3.1415926 )

      REAL RD( * ), RPROF( * ), R( * )
      COMPLEX PHIS( * ), PHIL( MAXM, MAXNRD ), PHIR( MAXM, * ), 
     &   CONST( MAXM ), HANK( MAXM ),
     &   SUM, CKINT, PHIINT, 
     &   P( NRD, * ), CKL( MAXM ), CKR( MAXM ), CKMID

      COMPLEX*16 SUMK( MAXM ), SUMKINV( MAXM )
      CHARACTER OPT*( * ), TITLE*80

      IF ( NRD. GT. MAXNRD )
     &   STOP 'FATAL ERROR: NRD > MAXNRD in routine EVALAD'

C     *** Initialization ***

      RPROF( NPROF + 1 ) = 1.0E9
      IPROF = 1

C     ------ Receiver depths at left  of segment
      CALL GETMOD( IPROF, ' ', MAXM, RD, NRD, 'N',
     &                       CKL, PHIL, M1, FREQ, TITLE )
      M = MIN( M, M1 )
C     ------ Receiver depths at right of segment
      CALL GETMOD( IPROF+1, ' ', MAXM, RD, NRD, 'N',
     &                       CKR, PHIR, M1, FREQ, TITLE )
      M = MIN( M, M1 )

      DO MODE = 1, M
         CONST( MODE ) = CI * SQRT( 2.0 * PI ) * EXP( CI * PI / 4.0 )
     &                   * PHIS( MODE )
         SUMK(    MODE ) = 0.0
         SUMKINV( MODE ) = 0.0
         IF ( OPT(1:1) .EQ. 'T' )
     &      CONST( MODE ) = CONST( MODE ) / SQRT( CKL( MODE ) )
      END DO

C     *** March forward in range ***

      DO IR = 1, NR

C        ------ Crossing into new range segment?

   50    CONTINUE
         IF ( R( IR ) .GT. 1000.0 * RPROF( IPROF + 1 ) ) THEN

            CALL NEWSEG( R, IR, RPROF, IPROF, NPROF,
     &         CKL, CKR, PHIL, PHIR, M, RD, NRD, SUMK, SUMKINV )

            GO TO 50   ! Check again
         ENDIF

C        ------ Compute proportional distance W and interpolate

         IF ( IR .GT. 1 ) THEN
            RLEFT = MAX( R( IR - 1 ), 1000.0 * RPROF( IPROF ) )
         ELSE
            RLEFT = 1000.0 * RPROF( IPROF )
         ENDIF
         RMID = 0.5 * ( R( IR ) + RLEFT )

         W    = ( R( IR ) / 1000.0 - RPROF( IPROF ) ) /
     &                  ( RPROF( IPROF + 1 ) - RPROF( IPROF ) )
         WMID = ( RMID    / 1000.0 - RPROF( IPROF ) ) /
     &                  ( RPROF( IPROF + 1 ) - RPROF( IPROF ) )

         DO L = 1, M

            CKINT = CKL( L ) + W    * ( CKR( L ) - CKL( L ) )
            CKMID = CKL( L ) + WMID * ( CKR( L ) - CKL( L ) )
            SUMK(    L ) = SUMK(    L ) + CKMID * ( R( IR ) - RLEFT )
            SUMKINV( L ) = SUMKINV( L ) + ( R( IR ) - RLEFT ) / CKMID

            IF ( OPT(4:4) .NE. 'I' ) THEN   ! coherent case
               HANK( L ) = CONST( L ) *       EXP( -CI * SUMK( L ) )
            ELSE
               HANK( L ) = CONST( L ) * EXP( REAL( -CI * SUMK( L ) ) ) ! inc. case
            ENDIF

            IF ( OPT(1:1) .EQ. 'R' ) THEN             ! Cylindrical coords.
               HANK( L ) = HANK( L ) / SQRT( CKINT * R( IR ) )
            ELSE IF ( OPT(1:1) .EQ. 'X' ) THEN        ! Cartesian coords.
               HANK( L ) = HANK( L ) / CKINT
            ELSE IF ( OPT(1:1) .EQ. 'T' ) THEN        ! Translationally invariant
               HANK( L ) = HANK( L ) / SQRT( CKINT * SUMKINV( L ) )
            ELSE                                      ! Scaled cylindrical coords.
               HANK( L ) = HANK( L ) / SQRT( CKINT )
            ENDIF

         END DO

C        *** For each rcvr, add up modal contributions ***

         DO I = 1, NRD
            SUM = 0.0

            IF ( OPT(4:4) .NE. 'I' )  THEN   ! coherent case
               DO MODE = 1, M
                  PHIINT = PHIL( MODE, I ) +
     &                      W * ( PHIR( MODE, I ) - PHIL( MODE, I ) )
                  SUM = SUM + PHIINT * HANK( MODE )
               END DO
            ELSE                                ! incoherent case
               DO MODE = 1, M
                  PHIINT = PHIL( MODE, I ) +
     &                      W * ( PHIR( MODE, I ) - PHIL( MODE, I ) )
                  SUM = SUM + ABS(  PHIINT * HANK( MODE ) ) ** 2
               END DO
               SUM = SQRT( SUM )
            ENDIF

            P( I, IR ) = SUM
         END DO

      END DO   ! Next range step

      RETURN
      END
C**********************************************************************C
      SUBROUTINE NEWSEG( R, IR, RPROF, IPROF, NPROF,
     &   CKL, CKR, PHIL, PHIR, M, RD, NRD, SUMK, SUMKINV )

C     Treats the crossing into a new range segment

      PARAMETER ( MAXM = 1500 )

      REAL RD( * ), RPROF( * ), R( * )
      COMPLEX PHIL( MAXM, * ), PHIR( MAXM, * ), 
     &   CKL( * ), CKR( * ), CKMID
      COMPLEX*16 SUMK( * ), SUMKINV( * )
      CHARACTER TITLE*80

C     *** Do phase integral up to the new range ***

      IF ( IR .GT. 1 ) THEN
         RLEFT = MAX( R( IR - 1 ), 1000.0 * RPROF( IPROF ) )
      ELSE
         RLEFT = 1000.0 * RPROF( IPROF )
      ENDIF

      RMID = 0.5 * ( 1000.0 * RPROF( IPROF + 1 ) + RLEFT )
      WMID = ( RMID / 1000.0 - RPROF( IPROF ) ) /
     &                  ( RPROF( IPROF + 1 ) - RPROF( IPROF ) )

      DO L = 1, M
         CKMID     = CKL(  L ) + WMID  * ( CKR( L ) - CKL( L ) )
         SUMK( L ) = SUMK( L ) +
     &           CKMID * ( 1000.0 * RPROF( IPROF + 1 ) - RLEFT )
         SUMKINV( L ) = SUMKINV( L ) +
     &       ( 1000.0 * RPROF( IPROF + 1 ) - RLEFT ) / ckmid
      END DO

C     ***  Copy right modes to left ***

      DO MODE = 1, M
         CKL( MODE ) = CKR( MODE )
         DO J = 1, NRD
            PHIL( MODE, J ) = PHIR( MODE, J )
         END DO
      END DO

C     *** Read in the new right mode set ***

      IPROF = IPROF + 1

      IF ( IPROF + 1  .LE. NPROF ) THEN
         CALL GETMOD( IPROF+1, ' ', MAXM, RD, NRD, 'N',
     &                           CKR, PHIR, M1, FREQ, TITLE )
         M = MIN( M, M1 )
         WRITE( *, * ) 'New profile read',
     &       R(IR), IPROF+1, RPROF(IPROF+1), ' #modes=', M
      ENDIF


      RETURN
      END

      FUNCTION TWERSK( OPT, OMEGA, BUMDEN, XI, ETA, KX, RHO0, C0 )

C     Dummy version

      IMPLICIT REAL*8  (A-H, O-Z)

      COMPLEX*16 TWERSK, KX
      CHARACTER*1 OPT

      TWERSK = 0.0

      RETURN
      END

      FUNCTION PR(X0, X, F, N, ERRMSG)

C     Polynomial approximant at X0
C     Limited to N = 10

      PARAMETER ( MAXN = 10 )
      REAL X0, X(N), F(N), FT(MAXN), H(MAXN)
      CHARACTER*80 ERRMSG

      ERRMSG = ' '

C     ------ Initialize arrays
      DO 1000 K = 1, N
         H(  K ) = X( K ) - X0
         FT( K ) = F( K )
 1000 CONTINUE

C     ------ Recursion for solution
      IF ( N .GE. 2) THEN
         DO 3000 I = 1, N - 1
            DO 2000 J = 1, N - I
               FT(J) = ( H( J + I ) * FT( J ) - H( J ) * FT( J + 1 ) ) /
     &                           ( H( J + I ) - H( J ) )
 2000       CONTINUE
 3000    CONTINUE
      ENDIF

      PR = FT( 1 )

      RETURN
      END

      SUBROUTINE CANS( T, OMEGA, PULSE, SF, NSD, IT, PULSTITL )

C     Computes the source time series

C     T      is the time
C     OMEGA  is some frequency characterizing the pulse
C     PULSE  is the letter indicating which pulse
C     S      is the time series

      PARAMETER ( PI = 3.141592 )

      REAL S
      COMPLEX SF( NSD, * )
      CHARACTER PULSE*( * ), PULSTITL*( * )

      S = 0.0
      F = OMEGA / ( 2.0 * PI )

      IF ( T .GT. 0.0 ) THEN

C     EVALUATE SELECTED PULSE

      IF ( PULSE(1:1) .EQ. 'P' ) THEN
C        ------ Pseudo gaussian
C        (peak at 0, support [0, 3F]
         IF ( T .LE. 1.0 / F )
     &   S = 0.75 - COS( OMEGA * T ) + 0.25*COS( 2.0 * OMEGA * T )
         PULSTITL = 'Pseudo gaussian'

      ELSE IF ( PULSE(1:1) .EQ. 'R' ) THEN
C        ------ Ricker wavelet
C        (peak at F, support [0, 2F]
         U = OMEGA * T - 5.0
         S = 0.5 * ( 0.25*U*U - 0.5 ) * SQRT( PI ) * EXP( -0.25*U*U )
         PULSTITL = 'Ricker wavelet'

      ELSE IF ( PULSE(1:1) .EQ. 'A' ) THEN
C        ------ Approximate Ricker wavelet
C        (peak at F, support [0, 2.5F]
         TC = 1.55 / F
         IF ( T .LE. TC )
     &   S = 0.48829 *    COS( 2.0 * PI * T / TC )
     &         -0.14128 * 4* COS( 4.0 * PI * T / TC )
     &         +0.01168 * 9* COS( 6.0 * PI * T / TC )
         PULSTITL = 'Approximate Ricker wavelet'

      ELSE IF ( PULSE(1:1) .EQ. 'S' ) THEN
C        ------ Single sine
C        (peak at F, support [0, infinity], nulls at nF
         IF ( T .LE. 1.0 / F ) S = SIN( OMEGA * T )
         PULSTITL = 'Single sine'

      ELSE IF ( PULSE(1:1) .EQ. 'H' ) THEN
C        ------ Hanning weighted four sine
C        (peak at F, support [0, infinity], first null at about 1.5F
         IF ( T .LE. 4.0 / F )
     &   S = 0.5 * SIN( OMEGA * T ) * ( 1 - COS( OMEGA * T / 4.0 ) )
         PULSTITL = 'Hanning weighted four sine'

      ELSE IF ( PULSE(1:1) .EQ. 'N' ) THEN
C        ------ N-wave
C        (peak at 1 F, support [0, 4F], [0,3F] OK
         IF ( T .LE. 1.0 / F )
     &   S = SIN( OMEGA * T ) - 0.5 * SIN( 2.0 * OMEGA * T )
         PULSTITL = 'N-wave'

      ELSE IF ( PULSE(1:1) .EQ. 'M' ) THEN
C        ------ Miracle wave (has a Hilbert transform?)
C        (peak at 0, support [0, infinity]
         A = 1.0 / ( 6.0 * F )
         T0 = 6.0 * A
         TS = ( T - T0 ) / A
         S = 1.0 / ( 1.0 + TS * TS )
C        HS is the Hilbert transform of the time series
C        HS = TS / ( 1.0 + TS * TS )
         PULSTITL = 'Miracle wave'

      ELSE IF ( PULSE(1:1) .EQ. 'G' ) THEN
C        ------ Gaussian
C        (peak at 0, support [0, infinity]
C        T0 is the peak time
C        A is the 3dB down time
C        NOTE S(0) = EXP( -NSIG ** 2 )

         NSIG = 3
         A = 1.0 / F / ( 2.0 * NSIG )
         T0 = NSIG * A
         S = EXP( -( ( T - T0 ) / A ) ** 2 )
         PULSTITL = 'Gaussian'
      ELSE IF ( PULSE(1:1) .EQ. 'T' ) THEN
C        ------ Tone
C        (peak at F, support [0, infinity]

         IF ( T .LE. 0.4 ) S = SIN( OMEGA * T )
         PULSTITL = 'Tone'
      ELSE IF ( PULSE(1:1) .EQ. 'C' ) THEN
C        ------ Sinc
C        ( uniform spectrum from [0, F]

         S = SIN( OMEGA * T ) / ( OMEGA * T )
         PULSTITL = 'Sinc'
      END IF
      END IF

C     *** Copy into source vector ***

      DO IS = 1, NSD
         SF( IS, IT ) = S
      END DO

      RETURN
      END

      PROGRAM STACKER

C     Produces time series by Fourier synthesis

      INTEGER PRTFIL, SHDFIL, FFTFIL
      PARAMETER (
     &   PRTFIL = 6, FFTFIL = 10, SHDFIL = 26,
     &   MXNSD = 500, MXNRD = 51, MXNR = 6001, MXNF = 1000,
     &   MXNT = 50000, MXN2 = 2000000,
C    &   FREQMOD = 280.0 )
     &   FREQMOD =   0.0 )

      REAL    R( MXNR ), SD( MXNSD ), RD( MXNRD ),
     &        TOUT( MXNT ), RTS( MXN2 )
      COMPLEX P( MXNR ), SNAP( MXN2 ), S( MXNF )
      CHARACTER TITLE*80, PLTTYP*10, FILNAM*80, FILEROOT*80,
     &   FILEEXT*16, PLOTTYPE*1

      EQUIVALENCE ( RTS, SNAP )

C     --- read root file name and length of name

      READ( *, * ) FILEROOT
      LAST = INDEX( FILEROOT, ' ' ) - 1

      READ( *, * ) PLOTTYPE

C     *** Read in the output times ***

      TOUT( 3 ) = -999.9
      READ( *, * ) NTOUT, ( TOUT( ITOUT ), ITOUT = 1, NTOUT )

      IF ( NTOUT .GT. MXNT ) THEN
         WRITE( PRTFIL, * ) 'NTOUT, MXNT = ', NTOUT, MXNT
         CALL ERROUT( PRTFIL, 'F', 'GETPAR',
     &      'Too many output times'  )
      ENDIF

      CALL SUBTAB( TOUT, NTOUT )
      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Number of output times = ', NTOUT
      WRITE( PRTFIL, * ) ( TOUT( ITOUT ), ITOUT = 1, MIN( NTOUT, 51 ) )

C     *** set up source spectrum ***

      OPEN( FILE = 'FFTFIL', UNIT = FFTFIL, STATUS = 'OLD' )

      NFREQ = 0

      DO IFREQ = 1, MXNF
         READ( FFTFIL, *, END = 1000 ) F, SR, SI
         WRITE( *, * ) F, SR, SI
         S( IFREQ ) = CMPLX( SR, SI )
         NFREQ = IFREQ
      END DO

 1000 CONTINUE

      FILNAM = 'work/' // FILEROOT(1:LAST) // '1.shd'

      CALL OPENFILES( FILNAM, PLOTTYPE, SD, NSD, MXNSD,
     &    RD, NRD, MXNRD, R, NR, MXNR, TOUT, NTOUT )

      NSTORE = NTOUT * NRD * NR
      IF ( NSTORE .GT. MXN2 ) THEN
         WRITE( PRTFIL, * ) 'NSTORE, MXN2 = ', NSTORE, MXN2
         CALL ERROUT( PRTFIL, 'F', 'GETPAR',
     &      'Too much field data'  )
      ENDIF

C     *** Main loop ***

      DO ISD = 1, NSD

C        --- zero out the matrices
         DO I = 1, NTOUT * NRD * NR
            SNAP( I ) = 0.0
         END DO

         DO I = 1, NTOUT * NRD
            RTS( I ) = 0.0
         END DO

C        *** frequency loop ***

         DO IFREQ = 1, NFREQ

            IF      ( IFREQ .LE. 9   ) THEN
               WRITE( FILEEXT, 2000 ) IFREQ
 2000          FORMAT( I1.1, '.shd' )
            ELSE IF ( IFREQ .LE. 99  ) THEN
               WRITE( FILEEXT, 3000 ) IFREQ
 3000          FORMAT( I2.2, '.shd' )
            ELSE IF ( IFREQ .LE. 999 ) THEN
               WRITE( FILEEXT, 4000 ) IFREQ
 4000          FORMAT( I3.3, '.shd' )
            ELSE
               WRITE( FILEEXT, 5000 ) IFREQ
 5000          FORMAT( I4.4, '.shd' )
            END IF

            FILNAM = 'work/' // FILEROOT(1:LAST) // FILEEXT
            WRITE( *, * ) FILNAM(1:40)

C           *** Read header ***

            CALL RDHEAD( SHDFIL, FILNAM, MXNR, MXNSD, MXNRD,
     &         FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &         SD, NSD, RD, NRD, TITLE )

            FREQ = FREQ - FREQMOD   ! frequency downshift (demodulation)

C           *** read in a single frequency frame ***

            DO IRD = 1, NRD
               IREC =  6 + NRD * ( ISD - 1 ) + IRD

               READ( SHDFIL, REC = IREC ) ( P( IR ), IR = 1, NR )

C              --- add spectral component to matrix 

               CALL ADDIN( IRD, FREQ, S( IFREQ ), P, RTS, SNAP,
     &                   NRD, NR, TOUT, NTOUT, PLOTTYPE )

            END DO   ! next receiver depth IRD

            CLOSE( SHDFIL )

         END DO   ! next frequency IFREQ

C        *** write results ***

         CALL WRTDAT( RTS, SNAP, TOUT, RD, NTOUT, NRD, NR, PLOTTYPE )

      END DO   ! next ISD

      STOP
      END

C**********************************************************************C

      SUBROUTINE OPENFILES( FILNAM, PLOTTYPE, SD, NSD, MXNSD,
     &   RD, NRD, MXNRD, R, NR, MXNR, TOUT, NTOUT )

C     Opens up the output files and writes header data

      INTEGER SHDFIL, RTSFIL
      PARAMETER ( SHDFIL = 26, RTSFIL = 35 )

      REAL      R( * ), SD( * ), RD( * ), TOUT( * )
      CHARACTER TITLE*80, PLTTYP*10, FILNAM*80, PLOTTYPE*1

C     *** Read in header info from first frequency file ***

      CALL RDHEAD( SHDFIL, FILNAM, MXNR, MXNSD, MXNRD,
     &      FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &      SD, NSD, RD, NRD, TITLE )

      CLOSE( SHDFIL )

C    *** Open output file ***

      IF ( PLOTTYPE .EQ. 'D' ) THEN   ! *** depth stack ***
         OPEN ( FILE = 'RTSFIL', UNIT = RTSFIL, STATUS = 'NEW',
     &          FORM = 'FORMATTED' )

         WRITE( RTSFIL, * ) '''' // TITLE(1:75) // ''''
         WRITE( RTSFIL, * ) NRD, ( RD( IR ), IR = 1, NRD )

      ELSE IF ( PLOTTYPE .EQ. 'R' ) THEN   ! *** range stack ***
         OPEN ( FILE = 'RTSFIL', UNIT = RTSFIL, STATUS = 'NEW',
     &          FORM = 'FORMATTED' )

         WRITE( RTSFIL, * ) '''' // TITLE(1:75) // ''''
         WRITE( RTSFIL, * ) NR, ( R( IR ), IR = 1, NR )

      ELSE   ! *** snapshot ***

         CALL HEADER( TITLE, TOUT, NTOUT, RD, NRD,
     &      R, NR, FREQ, ATTEN, PLTTYP, XS, YS, THETA )

      END IF

      RETURN
      END

C**********************************************************************C

      SUBROUTINE ADDIN( IRD, FREQ, S, P, RTS, SNAP, NRD, NR,
     &    TOUT, NTOUT, PLOTTYPE )

      COMPLEX CI
      PARAMETER ( CI = ( 0.0, 1.0 ), TWOPI = 2.0 * 3.141592 )

      REAL    TOUT( * ), RTS( NTOUT, * )
      COMPLEX P( * ), SNAP( NR, NTOUT, NRD ), S, W
      CHARACTER PLOTTYPE*1

C     Add in the spectral component
C     Note optimal loop order is debatable
C     Since RTS is real, we are taking the real part of the transform ...

      IF ( PLOTTYPE .EQ. 'D' ) THEN   ! * depth stack *
         DO ITOUT = 1, NTOUT
             RTS( ITOUT, IRD ) = RTS( ITOUT, IRD ) +
     &          S * P( 1 ) * EXP( CI * TWOPI * FREQ * TOUT( ITOUT ) )
         END DO

      ELSE IF ( PLOTTYPE .EQ. 'R') THEN   ! * range stack *
         DO ITOUT = 1, NTOUT
            W = S * EXP( CI * TWOPI * FREQ * TOUT( ITOUT ) )
            DO IR = 1, NR
               RTS( ITOUT, IR ) = RTS( ITOUT, IR ) + W * P( IR )
            END DO
         END DO

      ELSE   ! * snapshot *
         DO ITOUT = 1, NTOUT
            W = S * EXP( CI * TWOPI * FREQ * TOUT( ITOUT ) )
            DO IR = 1, NR
               SNAP( IR, ITOUT, IRD ) = SNAP( IR, ITOUT, IRD ) +
     &           W * P( IR )
            END DO
         END DO
      END IF

      RETURN
      END

C**********************************************************************C

      SUBROUTINE WRTDAT( RTS, SNAP, TOUT, RD, NTOUT, NRD, NR, PLOTTYPE )

C     Writes data to disk

      INTEGER SNAFIL, RTSFIL
      PARAMETER ( SNAFIL = 25, RTSFIL = 35 )

      REAL      TOUT( * ), RTS( NTOUT, * ), RD( * )
      COMPLEX   SNAP( NR, NTOUT, NRD )
      CHARACTER PLOTTYPE*1

      IF ( PLOTTYPE .EQ. 'D' ) THEN   ! depth stack
         DO ITOUT = 1, NTOUT
            WRITE( RTSFIL, * ) TOUT( ITOUT ),
     &         ( RTS( ITOUT, IRD ), IRD = 1, NRD )
         END DO

      ELSE IF ( PLOTTYPE .EQ. 'R') THEN   ! range stack
         DO ITOUT = 1, NTOUT
            WRITE( RTSFIL, * ) TOUT( ITOUT ),
     &         ( RTS( ITOUT, IR ), IR = 1, NR )
         END DO

      ELSE   ! snapshot
         DO ITOUT = 1, NTOUT
            DO IRD = 1, NRD
               IREC =  6 + NRD * ( ITOUT - 1 ) + IRD
               WRITE( SNAFIL, REC = IREC )
     &                 ( SNAP( IR, ITOUT, IRD ), IR = 1, NR )
            END DO
         END DO
      END IF

      RETURN
      END

      PROGRAM FILTER

C     Low-pass filter of a time series
C     Time series must be evenly sampled!

      INTEGER INFIL, OUTFIL
      PARAMETER ( INFIL = 10, OUTFIL = 11, MAXNT = 10000,
     &   PI = 3.141592, ALPHA = 0.54 )
      REAL TF( MAXNT ), SF( MAXNT, 51 ), SD( 51 )
      REAL TFIN( MAXNT ), SFIN( MAXNT, 51 )

C     *** Read in time series ***

      WRITE( *, * ) 'FCUT = '
      READ ( 5, * ) FCUT
      READ( INFIL, * ) NSD, ( SD( IS ), IS = 1, NSD )
      NT = 0
      DELTAT = 1.0E6
      DO IT = 1, 10000
         READ( INFIL, *, END = 1500 )
     &      TF( IT ), ( SF( IT, IS ), IS = 1, NSD )
         IF ( IT .GE. 2 )
     &      DELTAT = MIN( TF( IT ) - TF( IT - 1 ), DELTAT )
         NT = NT + 1
      END DO
 1500 DELTAF = 1.0 / ( TF( NT ) - TF( 1 ) )

C     *** Forward transform ***

C     ------ Obtain an N which is a power of 2
      N = ( TF( NT ) - TF( 1 ) ) / DELTAT
      N = 2**( INT( LOG10( REAL( N ) ) / 0.301 ) +1 )

      IF ( N .GT. 4096 ) THEN
         N = 4096
         DELTAT = ( TF( NT ) - TF( 1 ) ) / N
      ENDIF

      LMIN = FCUT / DELTAF
      LMIN = MIN( LMIN, N )
      WRITE( *, * ) LMIN, N

      DO IS = 1, NSD
         CALL INTERP( TF, DELTAT, SF(1,IS), NT, TFIN, SFIN(1,IS), N )

         CALL RFFT(   SFIN( 1, IS ), N, 1 )
C        ------ Scale
         CALL RFFTSC( SFIN( 1, IS ), N, 0, 1 )
C        ------ Unpack
         CALL RFFTSC( SFIN( 1, IS ), N, 3, 0 )

C        Zero out high-freq components

         DO I = 1, N + 1

            IF ( I .LE. LMIN ) THEN
               WEIGHT = ALPHA + ( 1.0 - ALPHA )*COS(PI*(I-1)/(LMIN-1))
            ELSE
               WEIGHT = 0.0
            ENDIF

            SFIN( 2 * I - 1, IS ) = WEIGHT * SFIN( 2 * I - 1, IS )
            SFIN( 2 * I,     IS ) = WEIGHT * SFIN( 2 * I,     IS )
         END DO

C        *** Transform back ***

C        ------ Pack
         CALL RFFTSC( SFIN( 1, IS ), N, -3, 0 )
         CALL RFFT(   SFIN( 1, IS ), N, -1 )
      END DO

C     *** Write out time series ***

      WRITE( OUTFIL, * ) NSD, ( SD( IS ), IS = 1, NSD )
      DO IT = 1, N
         WRITE( OUTFIL, * )
     &      TFIN( IT ), ( SFIN( IT, IS ), IS = 1, NSD )
      END DO

      STOP
      END
C**********************************************************************C
      SUBROUTINE INTERP( WNO, DELWNO, G, NWNO, WNOIN, GIN, NT )

C     Produces an evenly sampled kernel from input G

      REAL WNO( NWNO ), WNOIN( NT ), G( NWNO ), GIN( NT )

C     *** Take steps of DELWNO along the k-axis ***

      II = 1

      DO I = 1, NT
         WNOIN(I) = WNO( 1 ) + ( I - 1 ) * DELWNO

C        ------ Desirable/possible to advance interpolation window?
 5000    IF ( WNOIN( I ) .GT. WNO( II + 1 ) ) THEN
            II = II + 1
            IF ( II .LT. NWNO - 1 ) GO TO 5000
         ENDIF

C        *** Linear interpolation ***

         IF ( WNOIN( I ) .LT. WNO( NWNO ) ) THEN
            T = ( WNOIN( I )    - WNO( II ) )
     &        / ( WNO( II + 1 ) - WNO( II ) )
            GIN( I ) = G( II ) + T * ( G( II + 1 ) - G( II ) )
         ELSE
            GIN( I ) = 0.0
         ENDIF
      END DO

      RETURN
      END

      SUBROUTINE FACTOR( N, D, E, IERR, RV1, RV2, RV3, RV4 )
C
C     MICHAEL B. PORTER 7/1/85
C
C     THIS SUBROUTINE IS BASED ON TINVIT IN EISPACK
C     USES GAUSSIAN ELIMINATION WITH PIVOTING TO FACTOR A
C        SYMMETRIC TRIDIAGONAL LINEAR SYSTEM
C     
C     ON INPUT
C
C        N IS THE ORDER OF THE MATRIX.
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX.
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE INPUT MATRIX
C          IN ITS LAST N-1 POSITIONS.  E(1) IS ARBITRARY.
C
C
C     ON OUTPUT
C
C        RV1, RV2, RV3 AND RV4 CONTAIN THE FACTORED MATRIX
C
      COMPLEX U, V, XU, D(N), E(N), RV1(N), RV2(N), RV3(N), RV4(N)

C     LU DECOMPOSITION WITHOUT INTERCHANGES

      U = D(1)
      V = E(2)

      DO I = 2, N-1
         XU = E( I ) / U
         RV4( I   ) = XU
         RV1( I-1 ) = 1.0 / U
         RV2( I-1 ) = V
         U = D(I) - XU * V
         V = E(I+1)
      END DO

      XU       = E( N ) / U
      RV4(N)   = XU
      RV1(N-1) = 1.0 / U
      RV2(N-1) = V
      U        = D(N) - XU * V

      IF( U .EQ. 0.0 ) WRITE( *, * ) 'SINGULAR MATRIX'
      RV1(N) = 1.0 / U
      RV2(N) = 0.0

      RETURN
      END

      SUBROUTINE BACKSB(N,D,E,IERR,RV1,RV2,RV3,RV4,B)
C
C     MICHAEL B. PORTER 7/1/85
C
C     THIS SUBROUTINE IS BASED ON TINVIT IN EISPACK
C     PERFORMS BACK-SUBSTITUTION FOR A
C        SYMMETRIC TRIDIAGONAL LINEAR SYSTEM
C     
C     ON INPUT
C
C        N IS THE ORDER OF THE MATRIX.
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX.
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE INPUT MATRIX
C          IN ITS LAST N-1 POSITIONS.  E(1) IS ARBITRARY.
C        B CONTAINS THE RIGHT HAND SIDE (AX=B)
C
C     ON OUTPUT
C
C        ALL INPUT ARRAYS ARE UNALTERED EXCEPT
C        B WHICH CONTAINS THE SOLUTION
C
C     RV1, RV2, RV3 AND RV4 ARE TEMPORARY STORAGE ARRAYS.

      COMPLEX D(N),E(N),RV1(N),RV2(N),RV3(N),RV4(N),B(N)
      DATA SMALL / 1.0E-37 /   ! smallest pos. machine constant

C     *** FORWARD ELIMINATION ***

      DO I = 2, N

         B( I ) = B( I ) - RV4( I ) * B( I - 1 )

C        --- prevent underflows from propagating:
         IF ( ABS(  REAL( B( I ) ) ) .LE. SMALL .AND.
     &        ABS( AIMAG( B( I ) ) ) .LE. SMALL ) B( I ) = 0.0
      END DO

C     *** BACK SUBSTITUTION (RESULT IN B) ***

      B( N ) = B( N ) * RV1( N )

      IF ( N .GE. 2 ) THEN
      DO I = N - 1, 1, -1
         B( I ) = ( B( I ) - B( I + 1 ) * RV2( I ) ) * RV1( I )
      END DO
      END IF

      RETURN
      END

      PROGRAM TOBIN

C     Converts ASCII format to binary format

      INTEGER SHDFIL, ASCFIL
      PARAMETER ( SHDFIL = 25, ASCFIL = 5, 
     &   MAXNRD = 500, MAXNR = 4094 )

      REAL R( MAXNR ), RD( MAXNRD ), SD( MAXNRD )
      COMPLEX P( MAXNR )
      CHARACTER TITLE*80, PLTTYP*10

C     *** Read the header data ***

C     OPEN ( FILE = 'ASCFIL', UNIT = ASCFIL, STATUS = 'OLD',
C    &       FORM = 'FORMATTED' )

      READ( ASCFIL, 3000 ) TITLE
 3000 FORMAT( A80 )

      READ( ASCFIL, * ) PLTTYP, XS, YS, THETA
      READ( ASCFIL, * ) FREQ, NSD, NRD, NR

      READ( ASCFIL, 1000 ) ( SD( I ), I = 1, NSD )
      READ( ASCFIL, 1000 ) ( RD( I ), I = 1, NRD )
      READ( ASCFIL, 1000 ) ( R(  I ), I = 1, NR )
 1000 FORMAT( 6E13.5 )

C     *** Write the header to the SHDFIL ***

      CALL HEADER( TITLE, SD, NSD, RD, NRD,
     &   R, NR, FREQ, ATTEN, PLTTYP, XS, YS, THETA )

C     *** Main loop: convert pressure surfaces for each S/R combo ***

      DO ISD = 1, NSD
         IREC = 6 + ( ISD - 1 ) * NRD

         DO IRD = 1, NRD
            IREC = IREC + 1
            READ( ASCFIL, 7000 ) ( P( J ), J = 1, NR )
 7000       FORMAT( 6E13.5 )
            WRITE( *, * ) ISD, IRD, SD( ISD ), RD( IRD )
            WRITE( SHDFIL, REC = IREC ) ( P( J ), J = 1, NR )
         END DO

      END DO

      STOP
      END

      SUBROUTINE EVALGB( CK, PHI, PHIR, M, MAXM, IELTSC, ADJELT, ISET,
     &   X, Y, NNODES, NODE, NELTS, XS, YS, THETA, NTHETA,
     &   RMINM, RMAXM, NR, MACT, OPTION, P )

C     Computes 3-D pressure field using adiabatic mode theory

C     Uses gaussian beam tracing for horizontal refraction
C     Note beam curvature change at interfaces still needed
C     Phase may be off by e(i pi / 4 ) but TL is correct.

      INTEGER FLPFIL, RAYFIL
      COMPLEX CI
      PARAMETER ( FLPFIL = 5, RAYFIL = 21,
     &   PI = 3.141592, DEGRAD = PI / 180.0, CI = ( 0.0, 1.0 ) )

      LOGICAL EXITED
      INTEGER M( * ), NODE( 3, * ), ADJELT( 3, * ), ISET( * )
      REAL X( * ), Y( * ), THETA( * ), RADVEC( 2, 81 ),
     &   XV( 50000 ), YV( 50000 )
      COMPLEX CK(MAXM, *), PHI(MAXM, *), PHIR(MAXM, 3), P(NTHETA, *), 
     &   CONST, PHIA, PHIB, PA, PB, QA, QB, TAUA, TAUB, CA, CB, 
     &   EPS, EPSOPT, CX, CY
      CHARACTER OPTION*( * )

      OPEN( FILE = 'RAYFIL', UNIT = RAYFIL )

      READ( FLPFIL, * ) ALPHA1, ALPHA2, NALPHA
      READ( FLPFIL, * ) STEPG, NSTEPS
      READ( FLPFIL, * ) EPMULT
      ALPHA1 = DEGRAD * ALPHA1
      ALPHA2 = DEGRAD * ALPHA2

C     *** Initialization ***

      IBWIN2 = 25
      DALPHA = ( ALPHA2 - ALPHA1 ) / ( NALPHA - 1 )

      DO ITHETA = 1, NTHETA
         TH = DEGRAD * THETA( ITHETA )
         RADVEC( 1, ITHETA ) = COS( TH )
         RADVEC( 2, ITHETA ) = SIN( TH )
         DO IR = 1, NR
            P( ITHETA, IR ) = 0.0
         ENDDO
      ENDDO

C     *** Loop over beam takeoff angle ***

      DO IALPHA = 1, NALPHA
C         if ( ialpha .eq. 112 ) then
         ALPHA = ALPHA1 + ( IALPHA - 1 ) * DALPHA
         TSX = COS( ALPHA )
         TSY = SIN( ALPHA )
         WRITE( *, * ) 'IALPHA, TSX, TSY', IALPHA, TSX, TSY

C        *** Loop over modes ***

         DO MODE = 1, MACT

C           --- Get mode excitation coef and initialize

            IELT = IELTSC

            CALL NEWELT( IELT, NODE, X, Y, CK, MODE, M, MAXM, ISET,
     &         ISET1, ISET2, ISET3, X1, Y1, X2, Y2, X3, Y3,
     &         D12, D13, D23, DELTA, CX, CY, MPROP )

            IF ( MPROP .LT. MODE ) GOTO 9000

C           --- Evaluate modes at source depth
            DB1 = XS * Y1 - YS * X1
            DB2 = XS * Y2 - YS * X2
            DB3 = XS * Y3 - YS * X3

C           --- Compute areas of triangles
            A1 = (  D23 - DB3 + DB2 ) / DELTA
            A2 = (  DB3 - D13 - DB1 ) / DELTA
            A3 = ( -DB2 + DB1 + D12 ) / DELTA
            CA = A1 / CK(MODE, ISET1) + A2 / CK(MODE, ISET2)
     &                                + A3 / CK(MODE, ISET3)
            PHIA = A1 * PHIR(MODE, 1) + A2 * PHIR(MODE, 2)
     &                                + A3 * PHIR(MODE, 3)

C           --- Space filling in far field:

            IF ( OPTION(5:5) .EQ. 'F' ) THEN
               HWIDTH = 2.0 / ( ( 1.0 / CA ) * DALPHA )
               EPSOPT = 0.5 * HWIDTH ** 2
            ENDIF

C           --- Minimum width at RMAXM

            IF ( OPTION(5:5) .EQ. 'M' ) THEN
               HWIDTH = SQRT( 2.0 * CA * RMAXM )
               EPSOPT = 0.5 * HWIDTH ** 2
            ENDIF

            EPS = EPMULT * CI * EPSOPT

            CONST = PHIA * SQRT( EPS / CA ) * DALPHA
            XA    = XS
            YA    = YS
            XIA   = TSX / CA
            ETAA  = TSY / CA
            PA    = 1.0
            QA    = EPS
            TAUA  = 0.0
            KMAHA = 1

C           --- Evaluate modes at rcvr depth
            PHIA = A1 * PHI(MODE, ISET1) + A2 * PHI(MODE, ISET2)
     &                                   + A3 * PHI(MODE, ISET3)

C           *** March forward in range ***

            EXITED = .FALSE.
            STEP = STEPG

            DO ISTEP = 1, NSTEPS
               XB   = XA   + STEP * CA * XIA
               YB   = YA   + STEP * CA * ETAA
               XIB  = XIA  - STEP * CX / ( CA * CA )
               ETAB = ETAA - STEP * CY / ( CA * CA )
               PB   = PA
               QB   = QA   + STEP * CA * PA
               TAUB = TAUA + STEP / CA

               STEP = STEPG   ! Update step size

               IF ( OPTION(6:6) .EQ. 'R' ) THEN
                  XV( ISTEP ) = XA
                  YV( ISTEP ) = YA
               ENDIF

C              --- Compute KMAH index
               KMAHB = KMAHA
               IF ( REAL( QB ) .LT. 0.0 ) THEN
                  QAT = AIMAG( QA )
                  QBT = AIMAG( QB )
                  IF ( ( QAT .LT. 0.0 .AND .QBT .GE. 0.0 ) 
     &            .OR. ( QAT .GT. 0.0 .AND. QBT .LE. 0.0 ) )
     &                          KMAHB = -KMAHA
               ENDIF

C              --- Mode interpolation coefs

               IF ( .NOT. EXITED ) THEN
                  DB1 = XB * Y1 - YB * X1
                  DB2 = XB * Y2 - YB * X2
                  DB3 = XB * Y3 - YB * X3
C                 --- Compute areas of triangles
                  A1 = (  D23 - DB3 + DB2 ) / DELTA
                  A2 = (  DB3 - D13 - DB1 ) / DELTA
                  A3 = ( -DB2 + DB1 + D12 ) / DELTA

C                 Crossing into new element?

C                 SHOULD CHECK FOR A STEP WHICH CROSSES TWO ELTS!

                  IF ( ABS(A1)+ABS(A2)+ABS(A3) .GT. 1.00001 ) THEN

C                    --- Identify the side through which exitting
                     IF ( A1 .LT. 0.0 ) ISIDE = 2
                     IF ( A2 .LT. 0.0 ) ISIDE = 3
                     IF ( A3 .LT. 0.0 ) ISIDE = 1 
                     IELT = ADJELT(ISIDE, IELT)
C                    IF ( MODE .EQ. 1 ) THEN
C                       WRITE( *, * ) '   NEW ELEMENT', IELT
C                    ENDIF

C                    --- Normal elt transition or exit into free space?

                     IF ( IELT .EQ. 0 ) THEN
                        EXITED = .TRUE.
                        CX = 0.0
                        CY = 0.0
                     ELSE
                        CALL NEWELT(IELT, NODE, X, Y, CK, MODE, M, MAXM,
     &                     ISET, ISET1, ISET2, ISET3,
     &                     X1, Y1, X2, Y2, X3, Y3,
     &                     D12, D13, D23, DELTA, CX, CY, MPROP )

C                       --- If mode cuts off, skip to next mode
                        IF ( MPROP .LT. MODE ) GOTO 5000
                     ENDIF
                  ENDIF

C                 --- Evaluate modes at the rcvr depth
                  CB = A1/CK(MODE, ISET1) + A2/CK(MODE, ISET2)
     &                                    + A3/CK(MODE, ISET3)
                  PHIB = A1*PHI(MODE, ISET1) + A2*PHI(MODE, ISET2)
     &                                       + A3*PHI(MODE, ISET3)
               ENDIF

C              *** Compute beam influence ***

               CALL INFLU( XA-XS, YA-YS, XIA, ETAA, PA, QA, TAUA, CA, 
     &            KMAHA, PHIA, XB-XS, YB-YS, XIB, ETAB, PB, QB, 
     &            TAUB, CB, KMAHB, PHIB, RADVEC, NTHETA, 
     &            RMINM, RMAXM, NR, IBWIN2, CONST, P )

               XA    = XB
               YA    = YB
               XIA   = XIB
               ETAA  = ETAB
               PA    = PB
               QA    = QB
               TAUA  = TAUB
               CA    = CB
               KMAHA = KMAHB
               PHIA  = PHIB
            ENDDO   ! Next step

C           --- Optionally dump rays to disk

 5000       IF ( OPTION(6:6) .EQ. 'R' ) THEN
               WRITE( RAYFIL, * ) ISTEP - 1
               DO ISTEP = 1, ISTEP - 1
                 WRITE( RAYFIL, * ) XV( ISTEP ), YV( ISTEP )
               ENDDO
            ENDIF

         ENDDO   ! next mode
C        endif
 9000 ENDDO   ! next beam take-off angle

      RETURN
      END
C**********************************************************************C
      SUBROUTINE NEWELT( IELT, NODE, X, Y, CK, MODE, M, MAXM, ISET,
     &   ISET1, ISET2, ISET3, X1, Y1, X2, Y2, X3, Y3,
     &   D12, D13, D23, DELTA, CX, CY, MPROP )

C     Given elt number, returns info which is constant in elt

      INTEGER M( * ), NODE( 3, * ), ISET( * )
      REAL X( * ), Y( * )
      COMPLEX CK( MAXM, * ), CX, CY

      NODE1 = NODE( 1, IELT )
      NODE2 = NODE( 2, IELT )
      NODE3 = NODE( 3, IELT )

      ISET1 = ISET( NODE1 )
      ISET2 = ISET( NODE2 )
      ISET3 = ISET( NODE3 )

C     --- If mode cuts off, return to origin and do next mode
      MPROP = MIN( M(ISET1), M(ISET2), M(ISET3) )
      IF ( MPROP .LT. MODE ) RETURN

      X1 = X( NODE1 )
      Y1 = Y( NODE1 )
      X2 = X( NODE2 )
      Y2 = Y( NODE2 )
      X3 = X( NODE3 )
      Y3 = Y( NODE3 )

      D12 = X1 * Y2 - Y1 * X2
      D13 = X1 * Y3 - Y1 * X3
      D23 = X2 * Y3 - Y2 * X3
      DELTA = D23 - D13 + D12

C     --- Gradient
      A1X = -Y3 + Y2
      A2X =  Y3 - Y1
      A3X = -Y2 + Y1 
      A1Y =  X3 - X2
      A2Y = -X3 + X1
      A3Y =  X2 - X1

      CX = ( A1X/CK(MODE, ISET1) + A2X/CK(MODE, ISET2)
     &                           + A3X/CK(MODE, ISET3) ) / DELTA
      CY = ( A1Y/CK(MODE, ISET1) + A2Y/CK(MODE, ISET2)
     &                           + A3Y/CK(MODE, ISET3) ) / DELTA

      RETURN
      END
C**********************************************************************C
      SUBROUTINE INFLU(XA, YA, XIA, ETAA, PA, QA, TAUA, CA, KMAHA, PHIA,
     &   XB, YB, XIB, ETAB, PB, QB, TAUB, CB, KMAHB, PHIB, 
     &   RADVEC, NTHETA, RMINM, RMAXM, NR, IBWIN2, CONST, P )

C     Computes contribution to receivers assuming beam cannot
C     contribute to a radial in an incoming sense

      COMPLEX CI
      PARAMETER ( CI = (0.0, 1.0) )

      REAL RADVEC( 2, * ), NA, NB, NSQ
      COMPLEX P( NTHETA, * ), CONST, PHIA, PHIB, PA, PB, QA, QB, 
     &   TAUA, TAUB, CA, CB, PHIMID, PMID, QMID, TAUMID, CMID, CONTRIB

C     *** Loop over radials of receiver line and compute contribution ***

      DELTAR = ( RMAXM - RMINM ) / ( NR - 1 )

      DO ITHETA = 1, NTHETA

C        --- Compute intercept range, ra & index preceding rcvr

         DELTAA = RADVEC(1, ITHETA)*XIA + RADVEC(2, ITHETA)*ETAA
         IF ( ABS( DELTAA ) .LT. 1.0E-5 ) GOTO 5000
         RA = ( YA * ETAA + XA * XIA ) / DELTAA

         IF ( RA .GE. RMAXM ) GOTO 5000
         IF ( RA .LE. RMINM ) IR1 = 0
         IF ( RA .LT. RMAXM .AND. RA .GT. RMINM )
     &      IR1 = IFIX( REAL( ( RA - RMINM ) / DELTAR ) ) + 1

C        --- Compute intercept range, rb & index preceding rcvr
         DELTAB = RADVEC(1, ITHETA)*XIB + RADVEC(2, ITHETA)*ETAB
         IF ( ABS( DELTAB ) .LT. 1.0E-5 ) GOTO 5000
         RB = ( YB * ETAB + XB * XIB ) / DELTAB

         IF ( RB .GE. RMAXM+DELTAR ) IR2 = NR
         IF ( RB .LE. RMINM ) GOTO 5000
         IF ( RB .LT. RMAXM+DELTAR .AND. RB .GT. RMINM )
     &      IR2 = IFIX( REAL((RB-RMINM)/DELTAR) ) + 1

C        *** If a receiver is bracketted compute influence ***

         IF ( IR2 .GT. IR1 .AND. DELTAA*DELTAB .GT. 0 ) THEN
C           --- Normal distance
            NA = ( XA*RADVEC(2, ITHETA) - YA*RADVEC(1, ITHETA) )
     &                                            / ( CA * DELTAA )
            NB = ( XB*RADVEC(2, ITHETA) - YB*RADVEC(1, ITHETA) )
     &                                            / ( CB * DELTAB )

            DO IR = IR1+1, IR2
               R = RMINM + (IR-1)*DELTAR
               W = (R-RA)/(RB-RA)
               PMID = PA + W*(PB-PA)
               QMID = QA + W*(QB-QA)
               NSQ = (NA + W*(NB-NA))**2

C              --- Within beam window?
               IF ( -0.5*AIMAG(PMID/QMID)*NSQ .LT. IBWIN2 ) THEN
                  CMID = CA + W*(CB-CA)
                  TAUMID = TAUA + W*(TAUB-TAUA)
                  PHIMID = PHIA + W*(PHIB-PHIA)

C                 --- Compute KMAH index
                  KMAH = KMAHA
                  IF ( REAL(QMID) .LT. 0.0 ) THEN
                     QAT = AIMAG( QA )
                     QBT = AIMAG( QMID )
                     IF ( ( QAT .LT. 0.0 .AND .QBT .GE. 0.0 ) 
     &               .OR. ( QAT .GT. 0.0 .AND. QBT .LE. 0.0 ) )
     &                                      KMAH = -KMAH
                  ENDIF

                  CONTRIB = CONST*PHIMID*SQRT(CMID/QMID)*
     &               EXP(-CI*( TAUMID + 0.5*PMID/QMID*NSQ ) )

                  IF ( KMAH .LT. 0 ) CONTRIB = -CONTRIB
                  P(ITHETA, IR) = P(ITHETA, IR) + CONTRIB
               ENDIF

            ENDDO   ! Next receiver on radial
         ENDIF

 5000    ENDDO   ! Next radial

         RETURN
         END

      SUBROUTINE SDRD( ENVFIL, PRTFIL, ZMIN, ZMAX,
     &   MAXNSD, NSD, SD,
     &   MAXNRD, NRD, RD )

      IMPLICIT NONE
      INTEGER ENVFIL, PRTFIL, MAXNSD, NSD, MAXNRD, NRD, IS, IR
      REAL SD( * ), RD( * ), ZMIN, ZMAX

C     *** Read source depths ***

      NSD = 0
      SD( 2 ) = 0.0
      SD( 3 ) = -999.9
      READ( ENVFIL, * ) NSD, ( SD( IS ), IS = 1, NSD )

      IF ( NSD .GT. MAXNSD ) THEN
         WRITE( PRTFIL, * ) 'NSD, MAXNSD = ', NSD, MAXNSD
         CALL ERROUT( PRTFIL, 'F', 'SDRD', 'Too many sources'  )
      ELSE IF ( NSD .LE. 0 ) THEN
         WRITE( PRTFIL, * ) ' NSD = ', NSD
         CALL ERROUT( PRTFIL, 'F', 'SDRD',
     &      'Number of sources must be positive'  )
      ENDIF

      CALL SUBTAB( SD, NSD )
      CALL SORT(   SD, NSD )

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Number of sources   = ', NSD
      IF ( NSD .GE. 1 )
     &   WRITE( PRTFIL, * ) ( SD( IS ), IS = 1, MIN( NSD, 51 ) )
      IF ( NSD .GT. 51 ) WRITE( PRTFIL, * ) ' ... ', SD( NSD )

C     *** Read receiver depths ***

      NRD = 0
      RD( 2 ) = 0.0
      RD( 3 ) = -999.9
      READ( ENVFIL, * ) NRD, ( RD( IR ), IR = 1, NRD )

      IF ( NRD .GT. MAXNRD ) THEN
         WRITE( PRTFIL, * ) 'NRD, MAXNRD = ', NRD, MAXNRD
         CALL ERROUT( PRTFIL, 'F', 'SDRD', 'Too many receivers'  )
      ELSE IF ( NRD .LE. 0 ) THEN
         WRITE( PRTFIL, * ) ' NRD = ', NRD
         CALL ERROUT( PRTFIL, 'F', 'SDRD',
     &      'Number of receivers must be positive'  )
      ENDIF

      CALL SUBTAB( RD, NRD )
      CALL SORT(   RD, NRD )

      WRITE( PRTFIL, * )
      WRITE( PRTFIL, * ) 'Number of receivers = ', NRD
      IF ( NRD .GE. 1 )
     &   WRITE( PRTFIL, * ) ( RD( IR ), IR = 1, MIN( NRD, 51 ) )
      IF ( NRD .GT. 51 ) WRITE( PRTFIL, * ) ' ... ', RD( NRD )

C     *** Check for SD/RD in upper or lower halfspace ***

      DO IS = 1, NSD
         IF      ( SD( IS ) .LT. ZMIN ) THEN
            SD( IS ) = ZMIN
            CALL ERROUT( PRTFIL, 'W', 'SDRD',
     &         'Source in upper halfspace shifted to interface' )
         ELSE IF ( SD( IS ) .GT. ZMAX ) THEN
            SD( IS ) = ZMAX
            CALL ERROUT( PRTFIL, 'W', 'SDRD',
     &         'Source in lower halfspace shifted to interface' )
         ENDIF
      END DO

      DO IR = 1, NRD
         IF      ( RD( IR ) .LT. ZMIN ) THEN
            RD( IR ) = ZMIN
            CALL ERROUT( PRTFIL, 'W', 'SDRD',
     &         'Receiver in upper halfspace shifted to interface' )
         ELSE IF ( RD( IR ) .GT. ZMAX ) THEN
            RD( IR ) = ZMAX
            CALL ERROUT( PRTFIL, 'W', 'SDRD',
     &         'Receiver in lower halfspace shifted to interface' )
         ENDIF
      END DO

      RETURN
      END

      PROGRAM PLOTGRP

C     Plot the group velocity curves

      INTEGER PRTFIL, FFTFIL
      PARAMETER ( PRTFIL = 6, FFTFIL = 5, PI = 3.141592,
     &    MAXM = 1500, MAXMED = 51, MAXNF = 1000, MAXN = 16001 )


      INTEGER N( MAXMED ), M( MAXNF )
      REAL FREQ( MAXNF ), Z( MAXN ), DEPTH( MAXMED ), RHO( MAXMED )
      COMPLEX CK( MAXM, MAXNF ), KTOP2, KBOT2
      CHARACTER TITLE*80, MATER( MAXMED )*8, BCTOP*1, BCBOT*1

C     *** Get modal values ***

      MACT  = 0
      NFREQ = 0

      DO IF = 1, MAXNF
         READ( FFTFIL, *, END = 9000 ) F
         NFREQ = IF

         CALL MODHDR( IF, ' ',
     &      TITLE, FREQ( IF ), NMEDIA, NTOT, NMAT,
     &      N, MATER, DEPTH, RHO,
     &      BCTOP, RHOT, DEPTHT,
     &      BCBOT, RHOB, DEPTHB,
     &      M( IF ), MAXM, Z, CK( 1, IF), KTOP2, KBOT2, MODFIL )

         CLOSE( 29 + IF )

         MACT = MAX( M( IF ), MACT )

      END DO   ! next frequency
 9000 CONTINUE

      LAST = INDEX( TITLE, '    ' ) - 1
      WRITE( PRTFIL, 4000 ) TITLE(1:LAST)
 4000 FORMAT( '@ title "', A, '"' )

      WRITE( PRTFIL, 100 )
  100 FORMAT( '@   legend on' )

C     *** Compute group velocity using a centered difference ***

      WRITE( *, 5000 )
 5000 FORMAT( '@WITH G1', /,
     &        '@G1 ON', /,
     &        '@TYPE xy' )
 
       DO MODE = 1, MACT
          WRITE( PRTFIL, 600 ) MODE - 1, MODE
  600     FORMAT( '@   legend string ', I2, ' "Mode ', I2, '"' ) 

          DO IF = 2, NFREQ - 1

C            --- do we have a mode at this frequency?
             IF ( M( IF - 1 ) .GE. MODE .AND.
     &            M( IF + 1 ) .GE. MODE ) THEN

                DELTAF =     FREQ( IF + 1 ) -     FREQ( IF - 1 )
                DELTAK = CK( MODE, IF + 1 ) - CK( MODE, IF - 1 )

                VEL = 0.0
                IF ( DELTAK .NE. 0.0 ) VEL = 2.0 * PI * DELTAF / DELTAK
                WRITE( *, * ) FREQ( IF ), VEL
             ENDIF

         END DO   ! next frequency

         WRITE( *, * ) '&'

      END DO   ! next mode

C     *** Compute phase velocity ***

      WRITE( *, 6000 )
 6000 FORMAT( '@WITH G0', /,
     &        '@G0 ON', /,
     &        '@TYPE xy' )
 
C      WRITE( *, * ) '   linestyle 2'
      DO MODE = 1, MACT
         DO IF = 1, NFREQ

C           --- do we have a mode at this frequency?
            IF ( M( IF ) .GE. MODE ) THEN
               VEL = 2.0 * PI * FREQ( IF ) / CK( MODE, IF )
               WRITE( *, * ) FREQ( IF ), VEL
            ENDIF

         END DO   ! next frequency

         WRITE( *, * ) '&'

      END DO   ! next mode

      STOP
      END

      PROGRAM MODBIN

C     Converts asciii mode file to binary format

      INTEGER BINFIL, ASCFIL
      PARAMETER ( BINFIL = 20, ASCFIL = 5, MAXM = 1500, MAXMED = 51,
     &   MAXN = 16000 )

      INTEGER   N( MAXMED )
      REAL      DEPTH( MAXMED ), Z( MAXN ), RHO( MAXMED )
      COMPLEX   PHI( MAXN ), CK( MAXM ), CPT, CST, CPB, CSB
      CHARACTER TITLE*( 80 ), MATER( MAXMED )*8, BCTOP*1, BCBOT*1

C     *** Read header ***

      READ( ASCFIL, * ) LRECL
      READ( ASCFIL, * ) TITLE
      READ( ASCFIL, * ) FREQ, NMEDIA, NTOT, NMAT, M

      DO MED = 1, NMEDIA
         READ( ASCFIL, * ) N( MED ), DEPTH( MED ),
     &                     RHO( MED ), MATER( MED )
      ENDDO

      READ( ASCFIL, * ) BCTOP(1:1), CPT, CST, RHOT, DEPTHT
      READ( ASCFIL, * ) BCBOT(1:1), CPB, CSB, RHOB, DEPTHB

      DO IZ = 1, NTOT
         READ( ASCFIL, * ) Z( IZ )
      END DO

C     *** Write header ***

      OPEN ( FILE = 'MODFIL', UNIT = BINFIL, STATUS = 'NEW', 
     &   ACCESS = 'DIRECT', RECL = 4 * LRECL, FORM = 'UNFORMATTED' )

      WRITE( BINFIL, REC = 1 ) LRECL, TITLE(1:80),
     &                        FREQ, NMEDIA, NTOT, NMAT
      WRITE( BINFIL, REC = 2 )
     &        ( N( MED ), MATER( MED ), MED = 1, NMEDIA)
      WRITE( BINFIL, REC = 3 ) BCTOP(1:1), CPT, CST, RHOT, DEPTHT,
     &                        BCBOT(1:1), CPB, CSB, RHOB, DEPTHB
      WRITE( BINFIL, REC = 4 )
     &      ( DEPTH( MED ), RHO( MED ), MED = 1, NMEDIA )
      WRITE( BINFIL, REC = 5 ) M, LRECL
      WRITE( BINFIL, REC = 6 ) ( Z(   IZ ), IZ = 1, NTOT )

C     *** Read in eigenvalues, CK( I ) ***

      READ( ASCFIL, * )
      DO MODE = 1, M
         READ( ASCFIL, * ) CKR, CKI
         CK( MODE ) = CMPLX( CKR, CKI )
      ENDDO

C     *** Write out eigenvalues ***

      IFIRST = 1
      DO IREC = 1, 1 + ( 2 * M - 1 ) / LRECL
         ILAST  = MIN( M, IFIRST + LRECL / 2 - 1 )

         WRITE( BINFIL, REC = 6 + M + IREC )
     &                        ( CK( MODE ), MODE = IFIRST, ILAST )

         IFIRST = ILAST + 1
      END DO

c     *** Loop to read and write the modes ***

      DO MODE = 1, M
         READ( ASCFIL, * )
         DO IZ = 1, NTOT
            READ(  ASCFIL, * ) PHIR, PHII
            PHI( IZ ) = CMPLX( PHIR, PHII )
         ENDDO
         WRITE( BINFIL, REC = 6 + MODE ) ( PHI( IZ ), IZ = 1, NTOT )
      END DO

      STOP
      END

      SUBROUTINE SINVIT(N,D,E,W,Z,IERR,RV1,RV2,RV3,RV4,RV6)

C     Michael B. Porter 7/1/85

C     This subroutine is a modified version of TINVIT in EISPACK
     
C     Employs FORTRAN 77 features in order to improve readability.
C     Also has been specialized to the case when
C     we only want a single vector.

C     WARNING: The modifications have not been done extremely
C     carefully.  Very probably this routine will fail for
C     certain difficult cases for which the original tinvit would
C     not.  For instance, problems with nearly degenerate eigenvectors
C     or separable problems.

C     Refer to the ALGOL procedure TRISTURM by Peters and Wilkinson.
C     Handbook for Auto. Comp., VOL.II-Linear Algebra, 418-439(1971).

C     This subroutine finds the eigenvector of a tridiagonal
C     symmetric matrix corresponding to a specified eigenvalue,
C     using inverse iteration.

C     On input

C        N is the order of the matrix.
C        D contains the diagonal elements of the input matrix.
C        E contains the subdiagonal elements of the input matrix
C          in its last N-1 positions.  E(1) is arbitrary.
C        W contains the eigenvalue

C     On output

C        All input arrays are unaltered.
C        Z contains the eigenvector.
C          Any vector which fails to converge is set to zero.
C        IERR is set to
C           0       For normal return,
C          -1       If the eigenvector fails to converge in 5 iterations.

C        RV1, RV2, RV3, RV4, and RV6 are temporary storage arrays.

      REAL*8 MACHEP
      PARAMETER ( MACHEP = 1.0D-10 )

      INTEGER I, IERR, N
      REAL*8 EPS3,EPS4,NORM,UK
      COMPLEX*16 U,V, XU,D(N),E(N),
     +       RV1(N),RV2(N),RV3(N),RV4(N),RV6(N),W,Z(N)
      COMPLEX*16 ZTEMP

C     --- use DIMAG in f77, AIMAG in f90 below
      RLEN( ZTEMP ) = ABS( DBLE( ZTEMP ) ) + ABS( DIMAG( ZTEMP ) )

C     --- Compute (infinity) norm of matrix

      NORM = RLEN( D(1) )

      DO I = 2, N
         NORM = NORM + RLEN( D(I) ) + RLEN( E(I) )
      END DO

C     EPS3 Replaces zero pivots
C     EPS4 a very small number used in scaling down the iterates

      EPS3 = MACHEP * NORM
      UK   = N
      EPS4 = UK * EPS3
      UK   = EPS4 / DSQRT( UK )

C     *** Elimination with interchanges ***

      XU = 1.0
      U  = D( 1 ) - W
      V  = E( 2 )
      DO I = 2, N

         IF ( RLEN( E(I) ) .GE. RLEN( U ) ) THEN
            XU = U / E(I)
            RV4( I   ) = XU
            RV1( I-1 ) = E( I )
            RV2( I-1 ) = D( I ) - W
            RV3( I-1 ) = 0.0
            IF ( I .NE. N ) RV3( I-1 ) = E( I+1 )
            U = V - XU * RV2( I-1 )
            V =   - XU * RV3( I-1 )
         ELSE
            XU = E(I) / U
            RV4( I   ) = XU
            RV1( I-1 ) = U
            RV2( I-1 ) = V
            RV3( I-1 ) = 0.0
            U = D( I ) - W - XU * V
            IF ( I .NE. N ) V = E( I+1 )
         ENDIF

      END DO

      IF ( U .EQ. 0.0 ) U = EPS3
      RV1( N ) = U
      RV2( N ) = 0.0
      RV3( N ) = 0.0

C     *** Main loop of inverse iteration ***

C     --- Set initial vector to all UK

      DO I = 1, N
         RV6( I ) = UK
      END DO

      DO ITER = 1, 5

C        ---  Back substitution
         DO I = N, 1, -1
            RV6( I ) = ( RV6(I) - U * RV2(I) - V * RV3(I) ) / RV1(I)
            V = U
            U = RV6( I )
         END DO

C        --- Compute norm of vector
         NORM = 0.0
         DO I = 1, N
            NORM = NORM + RLEN( RV6( I ) )
         END DO

C        --- Convergence?
         IF ( NORM .LT. 1.0 ) THEN

C           --- Scale the vector down
            XU = EPS4 / NORM
            DO I = 1, N
               RV6( I ) = RV6( I ) * XU
            END DO

C           --- Forward elimination
            DO I = 2, N
               U = RV6( I )

C              IF RV1(I-1) = E(I), a row interchange
C              was performed earlier in the triangularization process

               IF ( RV1( I-1 ) .EQ. E( I ) ) THEN
                  U          = RV6( I-1 )
                  RV6( I-1 ) = RV6( I   )
               ENDIF
               RV6( I ) = U - RV4( I ) * RV6( I-1 )
            END DO
         ELSE

C           --- Convergence: Set norm to unity and return

            IERR = 0
            XU = 1.0 / NORM

            DO I = 1, N
               Z( I ) = XU * RV6( I )
            END DO

            RETURN

         ENDIF
      END DO   ! next iteration

C     Fall through the loop means failure to converge

      IERR = -1

      RETURN
      END

      PROGRAM TOSAC

C     Converts NRL format to SACLANT format

      INTEGER PLPFIL, PRTFIL, SHDFIL, CDRFIL, BDRFIL
      PARAMETER ( PLPFIL = 5, PRTFIL = 6, SHDFIL = 25,
     &   CDRFIL = 28, BDRFIL = 29,
     &   MAXNSD = 500, MAXNRD = 500, MAXNR = 4094, MAXNRZ = 110000 )

      REAL    R( MAXNR ), SD( MAXNSD ), RD( MAXNRD ),
     &   TL( MAXNRZ ), TLRAW( MAXNR ), TLSM( MAXNR )
      COMPLEX P( MAXNRZ )
      CHARACTER TITLE*80, OPTION*80, PLTTYP*10

C     *** Read header ***

      CALL RDHEAD( SHDFIL, ' ', MAXNR, MAXNSD, MAXNRD,
     &   FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &   SD, NSD, RD, NRD, TITLE )

      DO 2000 J = 1, NR
         R(J) = R(J) / 1000.0
 2000 CONTINUE

      READ( PLPFIL, * ) OPTION
      READ( PLPFIL, * ) SRCD
      READ( PLPFIL, * ) DR3DB

      TLMIN = 200.0
      TLMAX = 0.0
      IREC  = 6

C     ------ Reduce NRD to fit in window
      NRDACT = NRD
      READ( PLPFIL, * ) DEPTH
      DO IRCVR = 1, NRD
         IF ( RD( IRCVR ) .LE. DEPTH ) IHOLD = IRCVR
      END DO
      NRD = IHOLD

C     *** Calculate source depth index ***

      ISD = NEIGH( SRCD, SD, NSD )

C     --- Check to see if within tolerance

      IF ( FREQ .EQ. 0.0 ) THEN
         TOL = 0.001
      ELSE
         TOL = 1500.0 / ( 6.0 * FREQ )  ! one wavelength
      ENDIF

      IF ( ABS( SD( ISD ) - SRCD ) .GT. TOL ) THEN
         WRITE( PRTFIL, * ) 'Sources exist at the following depths:'
         WRITE( PRTFIL, * ) ( SD( I ), I = 1, NSD )
         CALL ERROUT( PRTFIL, 'F', 'PLOTFIELD',
     &                'No source at specified depth' )
      ENDIF

C     *** Output header ***

      OPEN( FILE = 'CDRFIL', UNIT = CDRFIL )
      OPEN( FILE = 'BDRFIL', UNIT = BDRFIL )

      RMIN = R( 1  )
      RMAX = R( NR )
      NPX  = NR
      NPY  = NRD
      NX   = NR
      NY   = NRD

      XLEN   = 18.0
      XLEFT  = RMIN
      XRIGHT = RMAX
      XSCALE = ( RMAX-RMIN ) / XLEN
      XINC   = ( RMAX-RMIN ) / 5.0
      X1     = XLEFT
      XL     = XRIGHT

      YLEN   = 12.0
      YUP    = RD( 1  )
      YDOWN  = RD( NRD )
      YSCALE = ( YDOWN - YUP ) / YLEN
      YINC   = ( YDOWN - YUP ) / 5.0

      RECUP = YUP
      RECLO = YDOWN

      READ( PLPFIL, * ) TLMIN, TLMAX, TLINT
      ZMIN  = TLMIN
      ZMAX  = TLMAX
      ZSTEP = TLINT
      SDEP  = SD( ISD )

      CALL CONDRW( TITLE,NPX,NPY,NX,NY,XLEFT,XRIGHT
     &   ,XSCALE,XINC,YUP,YDOWN,YSCALE,YINC,ZMIN
     &   ,ZMAX,ZSTEP,FREQ,SDEP,RECUP,RECLO,X1,XL,TLSM )

C     Loop over receivers

      IREC = 6 + ( ISD - 1 ) * NRDACT

      DO 1000 I = 1, NRD
         IREC = IREC + 1
         WRITE( *, * ) IREC
         READ( SHDFIL, REC = IREC )
     &      ( P( ( I - 1 ) * NR + J ), J = 1, NR )

         DO 7000 J = 1, NR
            JJ = ( I - 1 ) * NR + J
            IF ( OPTION(1:2) .EQ. 'DB' ) THEN
               PSQ = P( JJ ) * CONJG( P( JJ ) )
               TLRAW( J ) = 200.0
               IF ( PSQ .GT. 1.0E-20 ) TLRAW(J) = -10.0 * ALOG10( PSQ )
            ELSE
               TLRAW( J ) = REAL( P( JJ ) )
            ENDIF
 7000    CONTINUE

C        *** Smooth ***

         NROWS = 1
         CALL SMOOTH( TLRAW, TLSM, NROWS, 1, NR, DELTAR, DR3DB )
         WRITE( 29, 444 ) ( TLSM( L ), L = 1, NR )
 444     FORMAT( ' ',6E13.4 )

         DO 7500 J = 1, NR
            JJ = ( I - 1 ) * NR + J
            TL( JJ ) = TLSM( J )
            TLMAX = MAX( TL( JJ ), TLMAX)
            TLMIN = MIN( TL( JJ ), TLMIN)
 7500    CONTINUE
 1000 CONTINUE

      STOP
      END

C**********************************************************************C

      SUBROUTINE CONDRW(TITLE,NPX,NPY,NX,NY,XLEFT,XRIGHT
     $,XSCALE,XINC,YUP,YDOWN,YSCALE,YINC,ZMIN
     $,ZMAX,ZSTEP,FREQ,SD,RECUP,RECLO,X1,XL,PX)
      DIMENSION SECTOR(28),PX(1)
      CHARACTER*50 FILENM
      CHARACTER*4 TITLE(20),TITLEX(20),TITLEY(20)
      DATA X1PL,Y1PL/2.,2.0/,HGTPT,HGTC,LABPT,NDIV,
     *NARC/0.1,0.14,-3,1,5/,LABC,LWGT/-1,-1/,NSM/0/
      DATA DUMMY /0./
      DATA TITLEX /'Rang','e (k','m)  ',17*'    '/
      DATA TITLEY /'Dept','h (m',')   ',17*'    '/
C
C   FORMATS
 401  FORMAT(' ',F15.4,3X,'  NUMBER OF DATA POINTS ALONG THE X AXIS')
 402  FORMAT(' ',F15.4,3X,'  NUMBER OF DATA POINTS ALONG THE Y AXIS')
403   FORMAT(' ',F15.4,3X,'  DIVX ' )
404   FORMAT(' ',F15.4,3X,'  DIVY ' )
405   FORMAT(' ',F15.4,3X,'  FLAGRC ' )
406   FORMAT(' ',F15.4,3X,'  RDUP ' )
407   FORMAT(' ',F15.4,3X,'  RDLO ' )
408   FORMAT(' ',F15.4,3X,'  SOURCE DEPTH (M) ' )
 409  FORMAT(' ',F15.4,3X,'  NUMBER OF GRID POINTS ALONG THE X AXIS ' )
 410  FORMAT(' ',F15.4,3X,'  NUMBER OF GRID POINTS ALONG THE Y AXIS ' )
  411 FORMAT(' ',F15.4,3X,'  FREQUENCY (HZ)' )
  412 FORMAT(' ',F15.4,3X,'  DUMMY ' )
  413 FORMAT(' ',F15.4,3X,'  CAY ' )
  414 FORMAT(' ',F15.4,3X,'  NRNG ' )
  415 FORMAT(' ',F15.4,3X,'  ZMIN ' )
  416 FORMAT(' ',F15.4,3X,'  ZMAX ' )
  417 FORMAT(' ',F15.4,3X,'  ZINC ' )
  418 FORMAT(' ',F15.4,3X,'  X ORIGIN OF PLOT IN INCHES ' )
  419 FORMAT(' ',F15.4,3X,'  DUMMY ' )
  420 FORMAT(' ',F15.4,3X,'  Y ORIGIN OF PLOT IN INCHES ' )
  421 FORMAT(' ',F15.4,3X,'  NSM   ' )
  422 FORMAT(' ',F15.4,3X,'  HGTPT ' )
  423 FORMAT(' ',F15.4,3X,'  HGTC ' )
  424 FORMAT(' ',F15.4,3X,'  LABPT ' )
  425 FORMAT(' ',F15.4,3X,'  NDIV ' )
  426 FORMAT(' ',F15.4,3X,'  NARC ' )
  427 FORMAT(' ',F15.4,3X,'  LABC ' )
  428 FORMAT(' ',F15.4,3X,'  LWGT ' )
  800 FORMAT('CONDR,FIP,FMT,CPX,COL,VTT')
 801  FORMAT(A50)
  850 FORMAT(20A4)
  900 FORMAT(1X,F15.4,3X,'  XLEFT',/,F15.4,4X,'  XRIGHT',/,F15.4,3X,
     *'   XSCALE',/,F15.4,4X,'  XINC')
  901 FORMAT(1X,F15.4,3X,'  YUP',/,F15.4,4X,'  YDOWN',/,F15.4,3X,
     *'   YSCALE',/,F15.4,4X,'  YINC')
  950 FORMAT(' ',F15.4,1X,'    RMIN',/,F15.4,2X,'    RMAX')

      WRITE(28,800)
      WRITE(28,850)TITLE

      DO 1000 I = 1, 28
         SECTOR( I ) = 0.0
 1000 CONTINUE

      SECTOR(1)=NPX
C
C   SECTOR(4) IS A FLAG WHICH IS SET TO ZERO IN THE RANGE
C   DEPENDENT VERSION OF SNAP FOR ALL SECTORS EXCEPT THE LAST
C   ONE. HERE IS USED TO INDICATE THAT THIS IS THE LAST SECTOR

      SECTOR(4)=1.0

      WRITE(29,444) (SECTOR(L),L=1,28)
 444  FORMAT(' ',6E13.4)

      INQUIRE(UNIT=29,NAME=FILENM)
      WRITE(28,801) FILENM

      IF (ABS(XL-X1).LT.1.0) THEN
      TITLEX(2)='e (m'
      TITLEX(3)=')   '
      DIVX=1E0
      ELSE
      TITLEX(2)='e (k'
      TITLEX(3)='m)  '
      DIVX=1E-3
      END IF
      DIVY=1E0
      CAY=5.
      NRNG=5
      FLAGRC=0.
      WRITE(28,850)TITLEX

      R1=X1*1.0E3
      R2=XL*1.0E3
      WRITE(28,950)R1,R2

      AX1=XLEFT*1.0E3
      AX2=XRIGHT*1.0E3
      AX3=XSCALE*1.0E3
      AX4=XINC*1.0E3

      WRITE(28,900)AX1,AX2,AX3,AX4
      WRITE(28,850)TITLEY
      WRITE(28,901)YUP,YDOWN,YSCALE,YINC
      WRITE(28,401)FLOAT(NPX)
      WRITE(28,402)FLOAT(NPY)
      WRITE(28,403)DIVX
      WRITE(28,404)DIVY
      WRITE(28,405)FLAGRC
      WRITE(28,406)RECUP
      WRITE(28,407)RECLO
      WRITE(28,408)SD
C   NUMBER OF GRID POINTS ALONG THE X AXIS
      WRITE(28,409)FLOAT(NX)
C   NUMBER OF GRID POINTS ALONG THE Y AXIS
      WRITE(28,410)FLOAT(NY)
      WRITE(28,411)FREQ
      WRITE(28,412)DUMMY
      WRITE(28,413)CAY
      WRITE(28,414)FLOAT(NRNG)
      WRITE(28,415)ZMIN
      WRITE(28,416)ZMAX
      WRITE(28,417)ZSTEP
C X ORIGIN  OF PLOT IN INCHES
      WRITE(28,418)X1PL
      WRITE(28,419)DUMMY
C Y ORIGIN  OF PLOT IN INCHES
      WRITE(28,420)Y1PL
      WRITE(28,421)FLOAT(NSM)
      WRITE(28,422)HGTPT
      WRITE(28,423)HGTC
      WRITE(28,424)FLOAT(LABPT)
      WRITE(28,425)FLOAT(NDIV)
      WRITE(28,426)FLOAT(NARC)
      WRITE(28,427)FLOAT(LABC)
      WRITE(28,428)FLOAT(LWGT)

      RETURN
      END
C**********************************************************************C
       SUBROUTINE CONDRB(NP1,NP2,NPX,PX)
       DIMENSION PX(1)

       DO 1000 I=NP1,NP2
       PX(I-NP1+1)=PX(I)
1000   CONTINUE
       WRITE(29,444) (PX(L),L=1,NPX)
 444  FORMAT(' ',6E13.4)

       RETURN
       END

      SUBROUTINE XERROR( MESSG, NMESSG, NERR, LEVEL )

C     Copper penny fuse

C     The original xerror optionally prints a warning message
C     Depending on severity, previous occurence, ...

C     This is a dumb version which always prints the error message
C     Michael B. Porter 4/27/86

      CHARACTER*72 MESSG
      INTEGER NMESSG, NERR, LEVEL

      WRITE( 6, 1000 ) MESSG
 1000 FORMAT(' ',A72)

      RETURN
      END

      PROGRAM OUTBACK

C     Multiply the transfer functions to produce the monostatic echo

C     PROJFIL contains the projector transfer function (projector to target)
C     TARGFIL contains the target transfer function (target to array)
C     ECHOFIL contains the product of the two (this is the output file)

      INTEGER PROJFIL, TARGFIL, ECHOFIL 
      PARAMETER ( PROJFIL = 26, TARGFIL = 27, ECHOFIL = 25,
     &   MAXNSD = 4094, MAXNRD = 4094, MAXNR = 4094 )

      REAL    R( MAXNR ), SD( MAXNSD ), RD( MAXNRD ), RDPROJ( MAXNRD )
      COMPLEX PROJ( 51, MAXNR ), P( MAXNR )
      CHARACTER TITLE*80, PLTTYP*10

C     *** Read projector file headers and data ***

      CALL RDHEAD( PROJFIL, 'PROJFIL', MAXNR, MAXNSD, MAXNRD,
     &      FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &      SD, NSD, RDPROJ, NRDPROJ, TITLE )

      DO IRD = 1, NRDPROJ
C        --- read in the transfer function
         IRECIN = 6 + IRD
         WRITE( *, * ) IRD
         READ ( PROJFIL, REC = IRECIN ) ( PROJ( IRD, IR ), IR = 1, NR )
      END DO

C     *** Read target file headers ***

      CALL RDHEAD( TARGFIL, 'TARGFIL', MAXNR, MAXNSD, MAXNRD,
     &      FREQ, R, NR, DELTAR, PLTTYP, XS, YS, THETA,
     &      SD, NSD, RD, NRD, TITLE )

C     *** Write new header ***

      CALL HEADER( TITLE, SD, NSD, RD, NRD,
     &   R, NR, FREQ, ATTEN, PLTTYP, XS, YS, THETA )

C     *** Loop to read successive slices ***

      DO ISD = 1, NSD

         DO IRD = 1, NRD
C           --- read in pressure for a particular source/rcvr
            IREC  = 6 + NRD * ( ISD - 1 ) + IRD

            WRITE( *, * ) ISD, IRD
            READ( TARGFIL, REC = IREC ) ( P( IR ), IR = 1, NR )

C           --- Write out the product
            WRITE( ECHOFIL, REC = IREC )
     &         ( PROJ( ISD, IR ) * P( IR ), IR = 1, NR )

         END DO   ! next receiver depth, IRD

      END DO   ! next source depth, ISD

      STOP
      END

      SUBROUTINE ZBRENTX(X,A,B,T,ERRMSG)

C MICHAEL B. PORTER  8/84

C FORTRAN CONVERSION OF ALGOL PROGRAM PUBLISHED IN
C    THE COMPUTER JOURNAL 14(4):422-425 (1971)
C    BY R. P. BRENT

C RETURNS A ZERO X OF THE FUNCTION F IN THE GIVEN INTERVAL
C    [A,B], TO WITHIN A TOLERANCE 6*MACHEP*ABS(X)+2*T, WHERE
C    MACHEP IS THE RELATIVE MACHINE PRECISION AND T IS A POSITIVE
C    TOLERANCE.  THE PROCEDURE ASSUMES THAT FUNCT(A) AND FUNCT(B) HAVE
C    DIFFERENT SIGNS.

C    THIS IS THE EXTENDED RANGE VERSION WHICH EXPECT THE FUNCTION
C    TO HAVE THE FORM
C         SUBROUTINE FUNCT(X,G,IPOW)
C    WHERE G*10**IPOW GIVES FUNCT(X)

      IMPLICIT REAL*8 (A-H, O-Z)
      REAL*8 MACHEP,M
      CHARACTER*80 ERRMSG

      ERRMSG = ' '
      MACHEP = 1.0E-16
      TEN = 10.0

      CALL FUNCT(A,FA,IEXPA)
      CALL FUNCT(B,FB,IEXPB)

      IF ( ( (FA .GT. 0.0) .AND. (FB .GT. 0.0) ) .OR.
     &     ( (FA .LT. 0.0) .AND. (FB .LT. 0.0) ) ) THEN
         ERRMSG = ' *** ZBRENT ERROR: FUNCT SGN SAME AT INTRVL ENDPTS'
         RETURN
      ENDIF

C     INTERNAL ROOT

 2000 C = A
      FC = FA
      IEXPC = IEXPA
      E = B-A
      D = E

C     EXTERNAL ROOT

      IF (IEXPA .LT. IEXPB) THEN
         F1 = FC*TEN**(IEXPC-IEXPB)
         F2 = FB
      ELSE
         F1 = FC
         F2 = FB*TEN**(IEXPB-IEXPC)
      ENDIF
 3000 IF (ABS(F1) .LT. ABS(F2)) THEN
         A = B
         B = C
         C = A
         FA = FB
         IEXPA = IEXPB
         FB = FC
         IEXPB = IEXPC
         FC = FA
         IEXPC = IEXPA
      ENDIF
      TOL = 2.0*MACHEP*ABS(B)+T
      M = 0.5*(C-B)
      IF ((ABS(M) .GT. TOL) .AND. (FB .NE. 0.0)) THEN

C     ------ SEE IF A BISECTION IS FORCED
      IF (IEXPA .LT. IEXPB) THEN
         F1 = FA*TEN**(IEXPA-IEXPB)
         F2 = FB
      ELSE
         F1 = FA
         F2 = FB*TEN**(IEXPB-IEXPA)
      ENDIF

         IF ( (ABS(E) .LT. TOL) .OR. 
     &       (ABS( F1 ) .LE. ABS(F2)) ) THEN
            E = M
            D = E
         ELSE
            S = FB/FA*TEN**(IEXPB-IEXPA)
            IF (A .EQ. C) THEN
C              ------ LINEAR INTERPOLATION
               P = 2.0*M*S
               Q = 1.0-S
            ELSE
C              ------ INVERSE QUADRATIC INTERPOLATION
               Q = FA/FC*TEN**(IEXPA-IEXPC)
               R = FB/FC*TEN**(IEXPB-IEXPC)
               P = S*(2.0*M*Q*(Q-R)-(B-A)*(R-1.0))
               Q = (Q-1.0)*(R-1.0)*(S-1.0)
            ENDIF
            IF (P .GT. 0.0) THEN
               Q = -Q
            ELSE
               P = -P
            ENDIF
            S = E
            E = D
            IF ((2.0*P .LT. 3.0*M*Q-ABS(TOL*Q)) .AND.
     &          (P .LT. ABS(0.5*S*Q))) THEN
               D = P/Q
            ELSE
               E = M
               D = E
            ENDIF
         ENDIF

         A = B
         FA = FB
         IEXPA = IEXPB

         IF (ABS(D) .GT. TOL) THEN
            B = B+D
         ELSE
            IF (M .GT. 0.0) THEN
               B = B+TOL
            ELSE
               B = B-TOL
            ENDIF
         ENDIF

         CALL FUNCT(B,FB,IEXPB)
         IF ((FB .GT. 0.0) .EQV. (FC .GT. 0.0)) GOTO 2000
         GOTO 3000
      ENDIF

      X = B

      RETURN
      END

      PROGRAM FIELD3D

C     Generate file of replica vectors

C     Multiple receivers depths are handled inefficiently.

      INTEGER PRTFIL
      PARAMETER ( PRTFIL = 6,
     &   MXNR  = 5001, MXNRT  = 102000,  MXNT = 201,  MXNRD = 51,
     &   MXELT = 20000, MXNODE = 9000,   MAXM = 200, MXSET = 9000,
     &   MXNSD = 5 )

C     Some of the above parameters also occur in readin below
C     if you change MAXM, change it in eval3d.f, evalpdq.f too!

      INTEGER   NODE( 3, MXELT ), ADJELT( 3, MXELT ), M( MXSET ),
     &          ISET( MXNODE )
      REAL      R( MXNR ), THETA( MXNT ), SD( MXNSD ), RD( MXNRD ), 
     &          X( MXNODE ), Y( MXNODE )
      COMPLEX   CK( MAXM, MXSET ), P( MXNRT ), PHIS( MAXM, MXNSD, 3),
     &          PHIR( MAXM, MXSET ), PHIST( MAXM, 3 )
      CHARACTER OPT*50, TITLE*80, FILNAM( MXNODE )*50, TITENV*80

C     *** Read in all the user input ***

      CALL READIN( TITLE, OPT, MLIMIT, XS, YS, SD, NSD, RD, NRD,
     &   RMIN, RMAX, DELTAR, NR, R, THETA, NTHETA,
     &   X, Y, FILNAM, NNODES, NODE, NELTS )

C     *** Build ADJELT and identify the source element ***

      CALL GETADJ( NODE, NELTS, ADJELT )
      IELTSC = ISCELT( XS, YS, NODE, NELTS, X, Y )

C     Read modes at the source depths

      MSRC = MAXM
      DO ICOR = 1, 3
         INODE = NODE( ICOR, IELTSC )

         CALL GETMOD( 0, FILNAM( INODE ), MAXM, SD, NSD, 'N',
     &      CK( 1, ICOR ), PHIS( 1, 1, ICOR ), M( ICOR ), FREQ, TITENV )
         MSRC = MIN( MSRC, M( ICOR ) )
      END DO

C     *** Write header ***

      IF ( NRD .EQ. 1 ) THEN
         CALL HEADER( TITLE, SD, NSD, THETA, NTHETA,
     &      R, NR, FREQ, ATTEN, 'POLAR', XS, YS, RD(1)    )
      ELSE IF ( NSD .EQ. 1 ) THEN
         CALL HEADER( TITLE, RD, NRD, THETA, NTHETA,
     &      R, NR, FREQ, ATTEN, 'POLAR', XS, YS, SD(1)    )
      ELSE IF ( NTHETA .EQ. 1 ) THEN
         CALL HEADER( TITLE, SD, NSD, RD,    NRD,
     &      R, NR, FREQ, ATTEN, 'CARTE', XS, YS, THETA(1) )
      ENDIF

C     ****** MAIN Loop: over receiver depth ******

      DO IRD = 1, NRD
         WRITE( *, * ) 'IRD, RD( IRD ) = ', IRD, RD( IRD )

C        --- Get modes at the receiver depth
         CALL SLURP( NNODES, FILNAM, MXSET, MAXM, RD( IRD ),
     &      ISET, NSETS, M, CK, PHIR )

C        *** Loop over source depth ***

         DO ISD = 1, NSD
            WRITE( *, * ) 'ISD, SD( ISD ) = ', ISD, SD( ISD )

C           --- Get modes at the source depth
            DO ICOR = 1, 3
               DO MODE = 1, MSRC
                  PHIST( MODE, ICOR ) = PHIS( MODE, ISD, ICOR )
               END DO
            END DO

C           Call the appropriate routine to evaluate the field

            IF ( OPT(1:3) .EQ. 'STD' ) THEN
C              --- STANDARD (ignores hor. refraction)
               CALL EVAL3D( CK, PHIR, PHIST, M, IELTSC, ADJELT, 
     &            ISET, X, Y, NNODES, NODE, NELTS, XS, YS, 
     &            THETA, NTHETA, RMIN, RMAX, NR, MLIMIT, OPT, P )
            ELSE IF ( OPT(1:3) .EQ. 'PDQ' ) THEN
C              --- Quick (ignores and ignores)
               CALL EVALPDQ( CK, PHIR, PHIST, M, IELTSC, ADJELT, 
     &            ISET, X, Y, NNODES, NODE, NELTS, XS, YS, 
     &            THETA, NTHETA, RMIN, RMAX, NR, MLIMIT, OPT, P )
            ELSE IF ( OPT(1:3) .EQ. 'GBT' ) THEN
C              --- GAUSSIAN BEAM (include hor. refraction)
               CALL EVALGB( CK, PHIR, PHIST, M, MAXM, IELTSC, ADJELT, 
     &            ISET, X, Y, NNODES, NODE, NELTS, XS, YS, 
     &            THETA, NTHETA, RMIN, RMAX, NR, MLIMIT, OPT, P )
            ELSE
               CALL ERROUT( PRTFIL, 'F', 'FIELD3D', 'Unknown option' )
            ENDIF

C           Write out the field

            IF ( NRD .EQ. 1 ) THEN
               IREC = 6 + ( ISD - 1 ) * NTHETA
               CALL WRTFLD( P, NTHETA, NR, IREC )
            ELSE IF ( NSD .EQ. 1 ) THEN
               IREC = 6 + ( IRD - 1 ) * NTHETA
               CALL WRTFLD( P, NTHETA, NR, IREC )
            ELSE IF ( NTHETA .EQ. 1 ) THEN
               IREC = 6 + ( ISD - 1 ) * NRD + (IRD-1)
               CALL WRTFLD( P,  1, NR, IREC )
            ENDIF

         END DO     ! Next source   depth
      END DO     ! Next receiver depth

      STOP
      END
C**********************************************************************C
      SUBROUTINE READIN( TITLE, OPT, MLIMIT, XS, YS, SD, NSD, RD, NRD,
     &   RMIN, RMAX, DELTAR, NR, R, THETA, NTHETA, X, Y, FILNAM, NNODES,
     &   NODE, NELTS )

C     Reads in all the user input

      INTEGER PRTFIL, FLPFIL
      PARAMETER ( FLPFIL = 5, PRTFIL = 6,
     &   MXNR  = 5001, MXNRT  = 102000,  MXNT = 201,  MXNRD = 51,
     &   MXNODE = 9000,   MAXM = 200, MXNSD = 5 )

      INTEGER   NODE( 3, * )
      REAL      R( * ), THETA( * ), SD( * ), RD( * ), X( * ), Y( * )
      CHARACTER OPT*50, TITLE*80, FILNAM( * )*50

C     *** TITLE, OPT, MLIMIT ***

      READ(  FLPFIL, * ) TITLE
      WRITE( PRTFIL, * ) TITLE

      READ(  FLPFIL, * ) OPT
      WRITE( PRTFIL, * ) 'OPT = ', OPT
C      CALL STR$UPCASE( OPT, OPT )

      READ(  FLPFIL, * ) MLIMIT
      WRITE( PRTFIL, * ) 'Number of modes = ', MLIMIT
      MLIMIT = MIN( MLIMIT, MAXM )

C     *** Read source/receiver information ***

      READ(  FLPFIL, * ) XS, YS
      WRITE( PRTFIL, * ) 'Coords. of source = ', XS, YS

      XS = 1000.0 * XS
      YS = 1000.0 * YS

C     --- Read source/rcvr depths
      CALL SDRD( FLPFIL, PRTFIL, 0.0, 1.0E6,
     &   MXNSD, NSD, SD,
     &   MXNRD, NRD, RD )

C     --- Radii of receivers
      READ(  FLPFIL, * )  RMIN, RMAX, NR
      WRITE( PRTFIL, * ) 'RMIN, RMAX, NR = ', RMIN, RMAX, NR

      IF ( NR .GT. MXNR ) THEN
         WRITE( PRTFIL, * ) 'MXNR = ', MXNR
         CALL ERROUT( PRTFIL, 'F', 'FIELD3D-READIN', 'Too many ranges' )
      ENDIF

      RMIN   = 1000.0 * RMIN
      RMAX   = 1000.0 * RMAX
      DELTAR = ( RMAX - RMIN ) / ( NR - 1 )

      DO J = 1, NR
         R( J ) = RMIN + ( J - 1 ) * DELTAR
      END DO

C     --- Read angles for radials
      THETA( 3 ) = -999.9
      READ( FLPFIL, * ) NTHETA, ( THETA( ITH ), ITH = 1, NTHETA )
      CALL SUBTAB( THETA, NTHETA )

      IF ( NTHETA .GT. MXNT ) THEN
         WRITE( PRTFIL, * ) 'MXNT = ', MXNT
         CALL ERROUT( PRTFIL, 'F', 'FIELD3D-READIN', 'Too many radials')
      ENDIF

      IF ( NR * NTHETA .GT. MXNRT ) THEN
         WRITE( PRTFIL, * ) 'MXNRT = ', MXNRT
         CALL ERROUT( PRTFIL, 'F', 'FIELD3D-READIN',
     &                                      'Too many receiver points' )
      ENDIF

      IF ( NSD .NE. 1 .AND. NRD .NE. 1 .AND. NTHETA .NE. 1 ) THEN
         CALL ERROUT( PRTFIL, 'F', 'FIELD3D-READIN',
     &      'Multiple sources, rcvrs, and bearings in a single run' )
      END IF

C     *** Read nodal coordinates ***

      READ(  FLPFIL, * ) NNODES
      WRITE( PRTFIL, * ) 'NNODES = ', NNODES

      IF ( NNODES .GT. MXNODE ) THEN
         WRITE( PRTFIL, * ) 'MXNODE = ', MXNODE
         CALL ERROUT( PRTFIL, 'F', 'FIELD3D-READIN', 'Too many nodes' )
      ENDIF

      DO I = 1, NNODES

         READ( FLPFIL, * ) X( I ), Y( I ), FILNAM( I )

         X( I ) = 1000.0 * X( I )
         Y( I ) = 1000.0 * Y( I )

C         CALL STR$UPCASE( FILNAM( I ), FILNAM( I ) )

C        --- Append the extension '.MOD' to FILNAM
         JJ = INDEX( FILNAM( I ), ' ' )
         FILNAM( I )( JJ:JJ+3 ) = '.mod'

      END DO

C     *** Read in element definitions ***

      READ(  FLPFIL, * ) NELTS
      WRITE( PRTFIL, * ) 'NELTS  = ', NELTS

      DO IELT = 1, NELTS
         READ( FLPFIL, * ) ( NODE( ICOR, IELT ), ICOR=1, 3 )
      END DO

      IF ( OPT(4:4) .EQ. 'T' ) THEN
         WRITE( PRTFIL, * ) 'Performing a Tesselation check'
         CALL TESCHK( X, Y, NODE, NELTS, PRTFIL )
         WRITE( PRTFIL, * ) 'Passed the Tesselation check'
      ENDIF

      RETURN
      END
C**********************************************************************C
      SUBROUTINE GETADJ( NODE, NELTS, ADJELT )

C     Constructs a table ADJELT(IELT, ISIDE) which gives the
C     element number which shares ISIDE with element number IELT

      INTEGER NODE( 3, * ), ADJELT( 3, * ), ICOR( 3, 2 )
      DATA ((ICOR(ISIDE, J), ISIDE=1, 3), J=1, 2) /1, 2, 3, 2, 3, 1/

C     ICOR maps a side (1, 2 or 3) and a local node (1 or 2) to a
C     corner (1, 2, OR 3) of the triangle

      DO IELT = 1, NELTS
         DO ISIDE = 1, 3
            ADJELT( ISIDE, IELT ) = 0
         END DO
      END DO

C     *** Loop over each triangle ***

      DO IELT = 1, NELTS

C        *** Loop over triangle sides ***

         DO ISIDE = 1, 3

            IF ( ADJELT( ISIDE, IELT ) .EQ. 0 ) THEN

            NODE1 = NODE( ICOR( ISIDE, 1 ), IELT )
            NODE2 = NODE( ICOR( ISIDE, 2 ), IELT )

C           --- Search through other elements to find common side
            DO IELTT = 1, NELTS
               IF ( IELTT .NE. IELT ) THEN
                  DO ISIDET = 1, 3
                     NODE1T = NODE( ICOR( ISIDET, 1 ), IELTT )
                     NODE2T = NODE( ICOR( ISIDET, 2 ), IELTT )

C                    --- Do IELT and IELTT share this side?
                     IF ( ( NODE1 .EQ. NODE1T .AND.
     &                             NODE2 .EQ. NODE2T ) .OR.
     &                    ( NODE1 .EQ. NODE2T .AND.
     &                             NODE2 .EQ. NODE1T ) ) THEN
                         ADJELT( ISIDE,  IELT  ) = IELTT
                         ADJELT( ISIDET, IELTT ) = IELT
                         GOTO 5000
                     ENDIF

                  END DO  ! next side
               ENDIF
            END DO   ! next element
            ENDIF
 5000    ENDDO   ! next side

      END DO   ! next element

      RETURN
      END
C**********************************************************************C
      FUNCTION ISCELT( XS, YS, NODE, NELTS, X, Y )

C     Identifies the element containing the source at (XS, YS)

C     We define a function ENCL( XS, YS ) which is 1 when (XS , YS)
C     is inside a given triangle and decreases from 1 the further the
C     source moves away from the triangle.

C     The element with the highest value of ENCL is identified as the source
C     element.

C     If several elements enclose, the highest numbered
C     element is given posession

      INTEGER NODE( 3, * )
      REAL    X( * ), Y( * )

      ENCLMX = 0.0

      DO IELT = 1, NELTS
         NODE1 = NODE( 1, IELT )
         NODE2 = NODE( 2, IELT )
         NODE3 = NODE( 3, IELT )

         X1 = X( NODE1 )
         Y1 = Y( NODE1 )
         X2 = X( NODE2 )
         Y2 = Y( NODE2 )
         X3 = X( NODE3 )
         Y3 = Y( NODE3 )

C        --- Compute areas of triangles
         DELTA =
     &        ( X2*Y3 - Y2*X3 ) - ( X1*Y3 - Y1*X3 ) + ( X1*Y2 - Y1*X2 )

         A1 = ( X2*Y3 - Y2*X3 ) - ( XS*Y3 - YS*X3 ) + ( XS*Y2 - YS*X2 )
         A2 = ( XS*Y3 - YS*X3 ) - ( X1*Y3 - Y1*X3 ) + ( X1*YS - Y1*XS )
         A3 = ( X2*YS - Y2*XS ) - ( X1*YS - Y1*XS ) + ( X1*Y2 - Y1*X2 )

         ENCL = ABS( DELTA ) / ( ABS( A1 ) + ABS( A2 ) + ABS( A3 ) )

         IF ( ENCL .GT. ENCLMX ) THEN
            ISCELT = IELT
            ENCLMX = ENCL
         ENDIF

      END DO

      RETURN
      END
C**********************************************************************C
      SUBROUTINE TESCHK( X, Y, NODE, NELTS, PRTFIL )

C     Checks to see that triangulation is a tesselation
C     that is, that there are no overlapping triangles
C     (holes or triangles inside triangles are still possible)

      INTEGER NODE( 3, * ), ICOR( 3, 2 ), PRTFIL
      REAL    X( * ), Y( * )

      DATA ((ICOR(ISIDE, J), ISIDE=1, 3), J=1, 2) /1, 2, 3, 2, 3, 1/

C     ICOR maps a side (1, 2 or 3) and a local node (1 or 2) to a
C     corner (1, 2, OR 3) of the triangle

      DO IELT1 = 1, NELTS-1
         DO ISIDE1 = 1, 3
            X1 = X( NODE( ICOR( ISIDE1, 1 ), IELT1 ) )
            Y1 = Y( NODE( ICOR( ISIDE1, 1 ), IELT1 ) ) 
            X2 = X( NODE( ICOR( ISIDE1, 2 ), IELT1 ) )
            Y2 = Y( NODE( ICOR( ISIDE1, 2 ), IELT1 ) ) 
            UX = X2 - X1
            UY = Y2 - Y1

            DO IELT2 = IELT1 + 1, NELTS
               DO ISIDE2 = 1, 3
                  X3 = X( NODE( ICOR( ISIDE2, 1 ), IELT2 ) )
                  Y3 = Y( NODE( ICOR( ISIDE2, 1 ), IELT2 ) ) 
                  X4 = X( NODE( ICOR( ISIDE2, 2 ), IELT2 ) )
                  Y4 = Y( NODE( ICOR( ISIDE2, 2 ), IELT2 ) )
                  VX = X4 - X3
                  VY = Y4 - Y3
                  WX = X4 - X2
                  WY = Y4 - Y2
                  DEL = UX * VY - UY * VX

                  IF ( ABS( DEL ) .GT.
     &               MAX( ABS( UX*UY ), ABS( VX*VY ) ) / 10000.0 ) THEN
                     S1 = ( UX * WY - UY * WX ) / DEL
                     S2 = ( VX * WY - VY * WX ) / DEL
                     IF ( 0.001 .LT. S1 .AND. S1 .LT. 0.999 .AND.
     &                    0.001 .LT. S2 .AND. S2 .LT. 0.999 ) THEN
                        WRITE( PRTFIL, * )
     &                     'Sides cross for elts = ', IELT1, IELT2
                        WRITE( PRTFIL, * ) 'SIDE 1:'
                        WRITE( PRTFIL, * ) '   (', X1, Y1, ')'
                        WRITE( PRTFIL, * ) '   (', X2, Y2, ')'
                        WRITE( PRTFIL, * ) '   S = ', S1

                        WRITE( PRTFIL, * ) 'SIDE 2:'
                        WRITE( PRTFIL, * ) '   (', X3, Y3, ')'
                        WRITE( PRTFIL, * ) '   (', X4, Y4, ')'
                        WRITE( PRTFIL, * ) '   S = ', S2
                        STOP
                     ENDIF
                  ENDIF

               END DO
            END DO

         END DO
      END DO

      RETURN
      END                   
C**********************************************************************C
      SUBROUTINE SLURP( NNODES, FILNAM, MXSET, MAXM, RD,
     &   ISET, NSETS, M, CK, PHIR )

C     Reads in the values of the modes at the given receiver depth
C     for every node in the triangulation

      INTEGER PRTFIL
      PARAMETER ( PRTFIL = 6 )

      INTEGER   M( * ), ISET( * )
      COMPLEX   CK( MAXM, * ), PHIR( MAXM, * )
      CHARACTER FILNAM( * )*50, TITENV*80

      NSETS = 0

      DO 2000 INODE = 1, NNODES

C        --- Check if the modes have already been read
         IF ( INODE .GE. 2 ) THEN
            DO JNODE = 1, INODE-1
               IF ( FILNAM( INODE ) .EQ. FILNAM( JNODE ) ) THEN
C                 --- Copy previously read modes
                  ISET( INODE ) = ISET( JNODE )
                  GOTO 2000   ! process next node
               ENDIF
            END DO
         ENDIF

         NSETS = NSETS + 1
         IF ( NSETS .GT. MXSET ) THEN
         WRITE( PRTFIL, * ) 'MXSET = ', MXSET
            CALL ERROUT( PRTFIL, 'F', 'FIELD3D-SLURP',
     &                             'Too many mode sets' )
         ENDIF
         ISET( INODE ) = NSETS

C        --- Check for 'DUMMY' elts (acoustic absorbers)
         IF ( FILNAM( INODE )(1:5) .EQ. 'DUMMY' ) THEN
            M( NSETS ) = 0
         ELSE
C           --- Necessary to read in modes
            WRITE( *, * ) 'Reading INODE', INODE
            CALL GETMOD( 0, FILNAM( INODE ), MAXM, RD, 1, 'N',
     &         CK( 1, NSETS ), PHIR( 1, NSETS ), M( NSETS ),
     &         FREQ, TITENV )
         ENDIF
 2000 ENDDO   ! next node

      RETURN
      END

      PROGRAM TONRL

C     Converts SACLANT (CDR, BDR) format to NRL (SHD) format

      INTEGER CDRFIL, BDRFIL
      PARAMETER ( CDRFIL = 28, BDRFIL = 29,
     &   MAXNZ = 500, MAXNR = 4094, MAXNRZ = 300000 )

      REAL R( MAXNR ), RD( MAXNZ ), SD( MAXNZ ), TL( MAXNR )
      COMPLEX P( MAXNRZ )
      CHARACTER TITLE*80

C     Read in CDR header

      OPEN( FILE = 'CDRFIL', UNIT = CDRFIL, STATUS = 'OLD' )
      OPEN( FILE = 'BDRFIL', UNIT = BDRFIL, STATUS = 'OLD' )

      READ( CDRFIL, * )

      READ( CDRFIL, 500 ) TITLE
  500 FORMAT( A80 )
      WRITE( *, * ) TITLE

      READ( CDRFIL, * )
      READ( CDRFIL, * )
      READ( CDRFIL, * ) R(1)
      READ( CDRFIL, * ) R(2)
      WRITE( *, * ) 'RMIN = ', R(1), ' RMAX = ', R(2)

      READ( CDRFIL, * )
      READ( CDRFIL, * )
      READ( CDRFIL, * )
      READ( CDRFIL, * )
      READ( CDRFIL, * )

      READ( CDRFIL, * ) RD(1)
      READ( CDRFIL, * ) RD(2)
      WRITE( *, * ) 'ZMIN = ', RD(1), ' ZMAX = ', RD(2)

      READ( CDRFIL, * )
      READ( CDRFIL, * )

      READ( CDRFIL, * ) NR
      READ( CDRFIL, * ) NRD
      WRITE( *, * ) 'NR = ', NR, ' NRD = ', NRD

      READ( CDRFIL, * )
      READ( CDRFIL, * )
      READ( CDRFIL, * ) FLAGRC
      READ( CDRFIL, * )
      READ( CDRFIL, * )

      READ( CDRFIL, * ) SD(1)
      READ( CDRFIL, * )
      READ( CDRFIL, * )
      READ( CDRFIL, * ) FREQ
      WRITE( *, * ) 'FREQ = ', FREQ, ' SD = ', SD( 1 )

      NSD = 1
      RD( 3 ) = -999.9
      CALL SUBTAB( RD, NRD )

      R( 3 ) = -999.9
      CALL SUBTAB( R,  NR )

      CALL HEADER( TITLE, SD, NSD, RD, NRD,
     &   R, NR, FREQ, ATTEN, ' ', 0.0, 0.0, 0.0 )

C     ------ Some header junk
      READ( BDRFIL, * ) ( TL( J ), J = 1, 28 )

C     ***** Read by row or by column *****

      IF ( FLAGRC .EQ. 0.0 ) THEN

C     *** Read in TL data ***

         IREC = 6
         DO I = 1, NRD
            WRITE( *, * ) I
            READ( BDRFIL, * ) ( TL( J ), J = 1, NR )

            DO J = 1, NR
               K = J
               P( K ) = 0.0
               IF ( TL(J) .LE. 200.0 )
     &            P( K ) = CMPLX( SQRT( 10.0**( -TL(J) / 10.0 ) ), 0.0 )
            END DO

C           ------ Write it out
            CALL WRTFLD( P, 1, NR, IREC )
         END DO

      ELSE

C        *** Read in TL data ***

         DO J = 1, NR
            WRITE( *, * ) J
            READ( BDRFIL, * ) ( TL(I), I = 1, NRD )

            DO I = 1, NRD
               K = ( J - 1 ) *  NRD + I
               P( K ) = 0.0
               IF ( TL( I ) .LE. 200.0 )
     &            P( K ) = CMPLX( SQRT( 10.0**( -TL(I) / 10.0 ) ), 0.0 )
            END DO

         END DO

C        *** Write it out ***

         IREC = 5
         CALL WRTFLD( P, NRD, NR, IREC )

      ENDIF

      STOP
      END

      SUBROUTINE WEIGHT( X, NX, XTAB, NXTAB, W, IX )

C     Given 
C        X(*)    abscissas
C        XTAB(*) points for tabulation
C        NX      number of x points

C     Compute
C        W(*)    weights for linear interpolation
C        IX(*)   indices for    "         "

      INTEGER IX(*)
      REAL X(*), XTAB(*), W(*)

C     *** Is there just one X value for interpolation? ***

      IF ( NX .EQ. 1 ) THEN
         W(  1 ) = 0.0
         IX( 1 ) = 1
         RETURN
      ENDIF

C     *** Locate indices, compute weights ***

      L = 1
      DO 2000 IXTAB = 1, NXTAB

C        Does [X(L), X(L+1)] bracket rcvr depth?

 1000    IF ( X( L+1 ) .GE. XTAB( IXTAB ) .OR. L .GE. NX-1 ) THEN
C           ------ Yes: make note of L and weight for interpolation
            IX( IXTAB ) = L
            W(  IXTAB ) = ( XTAB(IXTAB) - X(L) ) / ( X(L+1) - X(L) )
            GOTO 2000
         ELSE
C           ------ No: advance to next depth
            IF ( L .LT. NX - 1 ) L = L + 1
            GOTO 1000
         ENDIF

 2000 CONTINUE

      RETURN
      END

      PROGRAM PLOTSSP

C     PLOT THE SSP FOR A GIVEN ENVIRONMENT

      INTEGER ENVFIL, PRTFIL, PRTFIL2
      PARAMETER ( ENVFIL = 5, PRTFIL = 6, PRTFIL2 = 99,
     &   MAXMED = 51 )

      INTEGER NG( MAXMED )
      REAL    ZV( 5000 ), CV( 5000 )
      REAL*8  DEPTH( MAXMED ), RHO( 2000 ), FREQ, RHOT, RHOB,
     &   SIGMA( MAXMED ), BUMDEN, ETA, XI
      COMPLEX*16 CP( 2000 ), CS( 2000 ), CPT, CST, CPB, CSB
      CHARACTER TOPOPT*8, BOTOPT*8, PLTITL*80

C     *** Read in environmental info ***

      PLTITL = 'PLOTSSP- '

      CALL READIN( PLTITL, FREQ, MAXMED, NMEDIA,
     &   TOPOPT, CPT, CST, RHOT, BUMDEN, ETA, XI, NG, SIGMA, DEPTH, 
     &   BOTOPT, CPB, CSB, RHOB,
     &   ENVFIL, PRTFIL2 )

      CLOSE( ENVFIL )

C      DEPTH( NMEDIA + 2 ) = DEPTH( NMEDIA + 1 ) + 100.0

C     Generate vector of Z, CP, CS, RHO points

      CMIN = +1.0E9
      CMAX = -1.0E9
      IZ = 0

      DO MED = 1, NMEDIA
         N  = 200
         N1 = N + 1
         CALL PROFIL( DEPTH( MED ), CP, CS, RHO, MED, N1, FREQ,
     &      TOPOPT(1:1), TOPOPT(3:3), 'TAB', ENVFIL, PRTFIL )

         H = ( DEPTH( MED + 1 ) - DEPTH( MED ) ) / N

         DO J = 1, N1
            IZ = IZ + 1
            ZV( IZ ) = DEPTH( MED ) + ( J - 1 ) * H
            CV( IZ ) = REAL( CP( J ) )
            CMIN = MIN( CMIN, CV( IZ ) )
            CMAX = MAX( CMAX, CV( IZ ) )
         END DO

      END DO   ! next medium

      NZ = IZ
      ZMIN = DEPTH( 1 )
      ZMAX = DEPTH( NMEDIA + 1 )

C     Begin plotting

      LAST = INDEX( PLTITL, '    ' ) - 1
      WRITE( PRTFIL, 1000 ) PLTITL(1:LAST)
 1000 FORMAT( '@ title "', A, '"' )

      WRITE( PRTFIL, 2000 ) INT( ZMIN ), INT( ZMAX ),
     &    10 * INT( CMIN / 10.0 ), 10 * INT( CMAX / 10.0 + 1 )
 2000 FORMAT( '@ world xmin ', I5, /,
     &        '@ world xmax ', I5, /,
     &        '@ world ymin ', I5, /,
     &        '@ world ymax ', I5 )

      DO IZ = 1, NZ
         WRITE( PRTFIL, * ) ZV( IZ ), CV( IZ )
      END DO

      STOP
      END

      SUBROUTINE EVAL3D( CK, PHIR, PHIS, M, IELTSC, ADJELT, ISET,
     &   X, Y, NNODES, NODE, NELTS, XS, YS, THETA, NTHETA,
     &   RMINM, RMAXM, NR, MACT, OPT, P )

C     Computes 3-D pressure field using adiabatic mode theory
C     Normalized to pressure of point source at 1 meter

C     Note RMINM must be zero

      INTEGER ZBARFIL
      COMPLEX CI
      PARAMETER ( KBARFIL = 55, ZBARFIL = 56,
     &   PI = 3.141592, DEGRAD = PI/180.0,
     &   CI = ( 0.0, 1.0 ), MAXM = 200 )

      INTEGER   M( * ), NODE( 3, * ), ADJELT( 3, * ), ISET( * ), OUTSIDE
      REAL      X( * ), Y( * ), THETA( * )
      COMPLEX   PHIR( MAXM, * ), PHIIN( MAXM ), PHIOUT( MAXM ),
     &          PHIS( MAXM, * ), CONST( MAXM ),
     &          CK(   MAXM, * ),  CKIN( MAXM ),  CKOUT( MAXM ),
     &          P( NTHETA, * ), T, CKINT, PHIINT
      COMPLEX*16 SUMK( MAXM )
      CHARACTER OPT*( * )

C     --- Open file for eigenfunctions
      OPEN ( FILE = 'ZBARFIL', UNIT = ZBARFIL, STATUS = 'UNKNOWN' )

C     *** Loop over angle ***

      DELTAR = ( RMAXM - RMINM ) / ( NR - 1 )

      DO ITHETA = 1, NTHETA
         TSX = COS( DEGRAD * THETA( ITHETA ) )
         TSY = SIN( DEGRAD * THETA( ITHETA ) )

C        --- Get modal values
         IELT = IELTSC
         WRITE( *, * )
         WRITE( *, * ) 'ITHETA, TSX, TSY', ITHETA, TSX, TSY

         CALL FIRST( IELT, OUTSIDE, RIN, ROUT, XS, YS, TSX, TSY,
     &      X, Y, MPROP, M, MAXM, CK, PHIR, PHIS, CONST, NODE,
     &      ISET, CKIN, PHIIN, CKOUT, PHIOUT )

         MPROP = MIN( MACT, MPROP )

C        --- write modes at first range
         IF ( ITHETA .EQ. 1 ) THEN
            WRITE( ZBARFIL, * ) MPROP
            WRITE( ZBARFIL, * ) ( CONST( L ), L = 1, MPROP )
         END IF

         DO MODE = 1, MPROP
            CONST( MODE ) = CI * SQRT( 2.0 * PI ) *
     &                 EXP( CI * PI / 4.0 ) * CONST( MODE )
            SUMK(  MODE ) = 0.0
         END DO

C        *** March forward in range ***

         DO IR = 1, NR
            RM = RMINM + ( IR - 1 ) * DELTAR
            IF ( RM .EQ. 0.0 ) RM = MIN( 1.0, DELTAR )

C           Crossing into new element?

  100       CONTINUE
            IF ( RM .GT. ROUT ) THEN

C              --- Copy outside info to inside
               NEWELT = ADJELT( OUTSIDE, IELT )
               RIN = ROUT

               DO MODE = 1, MPROP
                  CKIN(  MODE ) =  CKOUT( MODE )
                  PHIIN( MODE ) = PHIOUT( MODE )
               END DO

C              --- Get new outside info
               CALL OUT( IELT, NEWELT, OUTSIDE, ROUT, ADJELT, ISET,
     &            XS, YS, TSX, TSY, X, Y, NODE,
     &            MPROP, M, MAXM, CK, PHIR, CKOUT, PHIOUT )
               IELT = NEWELT

               GOTO 100   ! Check again

            ENDIF

C           *** Compute modal contribution at this range ***

            T = 0.0

            IF ( RIN .NE. ROUT ) THEN
               ALPHA = ( RM - RIN ) / ( ROUT - RIN )
               ALPHA = MIN( MAX( ALPHA,  0.0 ), 1.0 )
            ELSE
               ALPHA = 0.0
            ENDIF

            IF ( IR .EQ. NR ) WRITE( ZBARFIL, * ) MPROP
            DO L = 1, MPROP
               CKINT     =  CKIN( L ) + ALPHA * (  CKOUT(L) -  CKIN(L) )
               PHIINT    = PHIIN( L ) + ALPHA * ( PHIOUT(L) - PHIIN(L) )
               SUMK( L ) =  SUMK( L ) + DELTAR * CKINT
               T         = T + PHIINT * CONST( L )
     &                            * EXP( -CI*SUMK( L ) ) / SQRT( CKINT )

C              --- write mode at last range
               IF ( IR .EQ. NR ) WRITE( ZBARFIL, * ) PHIINT
            END DO

            P( ITHETA, IR ) = T / SQRT( RM )

         END DO   ! Next range

C        --- Write average wavenumber to file
         OPEN ( FILE = 'KBARFIL', UNIT = KBARFIL, STATUS = 'UNKNOWN' )
         WRITE( KBARFIL, * ) MPROP, RM
         WRITE( KBARFIL, * ) ( SUMK( L ) / RM , L = 1, MPROP )

      END DO   ! Next bearing

      RETURN
      END
C**********************************************************************C
      SUBROUTINE FIRST( IELT, OUTSIDE, RIN, ROUT, XS, YS, TSX, TSY,
     &   X, Y, MPROP, M, MAXM, CK, PHIR, PHIS, CONST, NODE,
     &   ISET, CKIN, PHIIN, CKOUT, PHIOUT )

C     Given an element number for the source
C     Computes 
C        OUTSIDE    the side through which path exits
C        ROUT       the range at which path exits
C        Mode values at entrance and exit
C        Interpolated mode excitation coeffs

      INTEGER NODE( 3, * ), OUTSIDE, M( * ), ICOR( 3, 2 ), ISET( * )
      REAL    X( * ), Y( * ), RV( 3 ), SV( 3 ), RVC( 3 )
      COMPLEX PHIS( MAXM, * ), PHIIN( * ), PHIOUT( * ), PHIR( MAXM, * ),
     &        CONST( * ), CKIN( * ), CKOUT( * ), CK( MAXM, * )

      DATA ( (ICOR( IS, J), IS = 1, 3), J = 1, 2) /1, 2, 3, 2, 3, 1/

C     ICOR maps a side (1, 2 OR 3) and a local node (1 OR 2) to a
C            corner (1, 2, or 3) of the triangle

      WRITE( *, * ) 'IELT = ', IELT
      MPROP = 9999

C     Coordinates of the centroid of the source element

      XCEN = 0.0
      YCEN = 0.0
      DO ICORN = 1, 3
         XCEN = XCEN + X( NODE( ICORN, IELT ) ) / 3.0
         YCEN = YCEN + Y( NODE( ICORN, IELT ) ) / 3.0
      END DO

      DO ISIDE = 1, 3

         NODE1 = NODE( ICOR( ISIDE, 1 ), IELT )
         NODE2 = NODE( ICOR( ISIDE, 2 ), IELT )

         ISET1 = ISET( NODE1 )
         ISET2 = ISET( NODE2 )
         MPROP = MIN( MPROP, M( ISET1 ), M( ISET2 ) )

         X1S = X( NODE1 ) - XS
         Y1S = Y( NODE1 ) - YS

         TXC = X( NODE1 ) - XCEN
         TYC = Y( NODE1 ) - YCEN

         TX  = X( NODE2 ) - X( NODE1 )
         TY  = Y( NODE2 ) - Y( NODE1 )

         DELTA = TSX * TY - TSY * TX

C        *** Radial parallel to side? ***

         IF ( DELTA .EQ. 0.0 ) THEN
            SV(  ISIDE )    = 999.0
         ELSE
            RVC( ISIDE ) = ( TXC * TY  - TYC * TX  ) / DELTA
            RV(  ISIDE ) = ( X1S * TY  - Y1S * TX  ) / DELTA
            SV(  ISIDE ) = ( X1S * TSY - Y1S * TSX ) / DELTA
         ENDIF
      END DO

C     Identify two good sides and one bad side based on the intercept point

      IBAD = 1
      IF ( ABS( SV( 2 ) - 0.5 ) .GT. ABS( SV( IBAD ) - 0.5 ) )
     &   IBAD = 2
      IF ( ABS( SV( 3 ) - 0.5 ) .GT. ABS( SV( IBAD ) - 0.5 ) )
     &   IBAD = 3

      IGOOD1 = 1
      IGOOD2 = 2
      IF ( IBAD .EQ. 1 ) THEN
         IGOOD1 = 3
      ELSE IF ( IBAD .EQ. 2 ) THEN
         IGOOD2 = 3
      ENDIF

C     --- The side with the lesser RVC is the inside

      IF ( RVC( IGOOD1 ) .LT. RVC( IGOOD2 ) ) THEN
         INSIDE  = IGOOD1
         OUTSIDE = IGOOD2
      ELSE
         INSIDE  = IGOOD2
         OUTSIDE = IGOOD1
      ENDIF

      SIN      = SV( INSIDE )
      SIN      = MIN( MAX( SIN,  0.0 ), 1.0 )
      RIN      = RV( INSIDE )

      SOUT     = SV( OUTSIDE )
      SOUT     = MIN( MAX( SOUT, 0.0 ), 1.0 )
      ROUT     = RV( OUTSIDE )

C     --- Get values of modes at Z = SD and (X, Y) = intercept points

      ICOR1 = ICOR(  INSIDE, 1 )
      ICOR2 = ICOR(  INSIDE, 2 )
      ICOR3 = ICOR( OUTSIDE, 1 )
      ICOR4 = ICOR( OUTSIDE, 2 )

C     --- Interpolate to get modal values at source
      R = 0.0

      IF ( RIN .NE. ROUT ) THEN
         ALPHA = ( R - RIN ) / ( ROUT - RIN )
         ALPHA = MIN( MAX( ALPHA,  0.0 ), 1.0 )
      ELSE
         ALPHA = 0.0
      ENDIF

      DO L = 1, MPROP
         PHIIN(  L ) = PHIS( L, ICOR1 ) +
     &                 SIN  * ( PHIS( L, ICOR2 ) - PHIS( L, ICOR1 ) )
         PHIOUT( L ) = PHIS( L, ICOR3 ) +
     &                 SOUT * ( PHIS( L, ICOR4 ) - PHIS( L, ICOR3 ) )
         CONST( L )  = PHIIN(L) + ALPHA * ( PHIOUT(L) - PHIIN(L) )
      END DO

C     Obtain values of modes at z = Rd and (x, y)=intercept points

      CALL INTER1( IELT, INSIDE,  SIN, 
     &   MPROP, M, MAXM, CK, PHIR, NODE, ISET, CKIN,  PHIIN  )
      CALL INTER1( IELT, OUTSIDE, SOUT, 
     &   MPROP, M, MAXM, CK, PHIR, NODE, ISET, CKOUT, PHIOUT )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE OUT( IELT, NEWELT, OUTSIDE, ROUT, ADJELT, ISET, XS, YS,
     &   TSX, TSY, X, Y, NODE, MPROP, M, MAXM,
     &   CK, PHIR, CKOUT, PHIOUT)

C     Given an element number and a side through which prop path enters 
C     Computes 
C        OUTSIDE    the side through which path exits
C        ROUT       the range at which path exits
C        Mode values

      INTEGER NODE( 3, * ), ADJELT( 3, * ), OUTSIDE, M( * ),
     &        ICOR( 3, 2 )
      REAL    X( * ), Y( * )
      COMPLEX PHIOUT( * ), PHIR( MAXM, * ), CKOUT( * ), CK( MAXM, * )

      DATA ( (ICOR( IS, J), IS = 1, 3), J = 1, 2) /1, 2, 3, 2, 3, 1/

C     ICOR maps a side (1, 2 OR 3) and a local node (1 OR 2) to a
C            corner (1, 2, or 3) of the triangle
C     WRITE( *, * ) '   Crossing into new element = ', NEWELT

C     If no adj elt then exit. Previous values of KOUT, PHIOUT retained

      IF ( NEWELT .EQ. 0 ) THEN
         ROUT = 9.9999E9
         RETURN
      ENDIF

C     *** Loop over sides to find outside ***

      SOUT = 999.0

      DO ISIDE = 1, 3

C        ------ Don't try an outside the same as the inside
         IF ( ADJELT( ISIDE, NEWELT ) .NE. IELT ) THEN

            NODE1 = NODE( ICOR( ISIDE, 1 ), NEWELT )
            NODE2 = NODE( ICOR( ISIDE, 2 ), NEWELT )

            X1S = X( NODE1 ) - XS
            Y1S = Y( NODE1 ) - YS

            TX  = X( NODE2 ) - X( NODE1 )
            TY  = Y( NODE2 ) - Y( NODE1 )

            DELTA = TSX * TY - TSY * TX

C           *** Radial parallel to side? ***

            IF ( DELTA .EQ. 0.0 ) THEN
               ST    = 999.0
            ELSE
               ROUTT = ( X1S * TY  - Y1S * TX  ) / DELTA
               ST    = ( X1S * TSY - Y1S * TSX ) / DELTA
            ENDIF
C           ------ If intercept is in segment, store the side number
            IF ( ABS( ST - 0.5 ) .LT. ABS( SOUT - 0.5) ) THEN
                  OUTSIDE = ISIDE
                  SOUT    = ST
                  ROUT    = ROUTT
            ENDIF
         ENDIF
      END DO

C     Obtain values of modes at intercept points

      CALL INTER1( NEWELT, OUTSIDE, SOUT, 
     &   MPROP, M, MAXM, CK, PHIR, NODE, ISET, CKOUT, PHIOUT )

      RETURN
      END
C**********************************************************************C
      SUBROUTINE INTER1( IELT, ISIDE, S,
     &   MPROP, M, MAXM, CK, PHIR, NODE, ISET, CKINT, PHIINT )

C     Given
C        IELT         the element
C        ISIDE        the side
C        S            the proportional distance along the side

C     Returns
C        CKINT, PHIINT  interpolated modal values
C        MPROP          number of propagating modes

      INTEGER NODE( 3, * ), M( * ), ICOR( 3, 2 ), ISET( * )
      COMPLEX PHIINT( * ), PHIR( MAXM, * ), CKINT( * ), CK( MAXM, * )

      DATA ( (ICOR( IS, J), IS = 1, 3), J = 1, 2) /1, 2, 3, 2, 3, 1/

C     ICOR maps a side (1, 2 OR 3) and a local node (1 OR 2) to a
C            corner (1, 2, or 3) of the triangle

      NODE1 = NODE( ICOR( ISIDE, 1 ), IELT )
      NODE2 = NODE( ICOR( ISIDE, 2 ), IELT )

      ISET1 = ISET( NODE1 )
      ISET2 = ISET( NODE2 )
      MPROP = MIN( MPROP, M( ISET1 ), M( ISET2 ) )

C     --- Extrapolation prohibitted:

      S = MIN( MAX( S, 0.0 ), 1.0 )

      DO I = 1, MPROP
         CKINT(  I ) =   CK( I, ISET1 ) +
     &                     S * (   CK( I, ISET2 ) -   CK( I, ISET1 ) )
         PHIINT( I ) = PHIR( I, ISET1 ) +
     &                     S * ( PHIR( I, ISET2 ) - PHIR( I, ISET1 ) )
      END DO

      RETURN
      END

C**********************************************************************C
      SUBROUTINE SOLVECZR

C     Provides roots by integration on a contour in the complex plane
C     Use of a circle new version for the number of modes
C     rectangles are used as contours
C     Can split intervals if there is too many modes
    
      INCLUDE 'comc1.f'

      PARAMETER ( MXCER = 20000, MAXSSP = 2001, MXINT = 100 )

      INTEGER*4 NINTER, MXINTMOD, NVITINT, NVBP, NT, NCER, NCERM
      REAL*8 CWAT, CMINI, HEAU, HENS, CIMX, TAILLCER, CSMIN
      REAL*8 KBP( MXINT ), VBP( MXINT ), CBP( MXINT ), OMEGA, CMAXI
      REAL*8 BPC( 5 ), U, V, DR( 2 ), ALPHAM, CL, CH
      REAL*8 VITINT( MAXM ), TMN, TMX, DTM, RAY, CREF
      REAL*8 ALPHAMAX, CENTR, ANG( MXCER ), KBPINC, KBP1, KBP2
      COMPLEX*16 CENT, SOL( MAXM )
      COMPLEX*16 ALP( MAXSSP ), BET( MAXSSP ), RH( MAXSSP )
      COMPLEX*16 POINT( MXINT ), PT, SOL2
      INTEGER*4 NBZ( MXINT ), NBZP, J, I, IPOW, IPOWM, IPOW1, NMODE
      INTEGER*4 REP( 5 ), NRECT, NMP, NCER1, MLT, KK, NCIR, ZINT
      INTEGER NCEL, NBPC
      LOGICAL FLAGRES
      CHARACTER*80 ERRMSG
      
      COMMON /DONNEES/ ALP, BET, RH
      
      NCEL = 2 * NMEDIA
      OMEGA = 2.0 * PI * FREQ
   
      CALL  GETMINFO( CWAT, CMINI, HEAU, HENS, CIMX, CSMIN, CMAXI)   
   
C     Number of points taken to discretize the contour
C     minimum for one side of the rectangle

      NCER = 500
      
C     Number of points taken to discretize a circle

      NCIR = 500

C     Maximum number of modes allowed

      MXINTMOD = 6

      DO K = 1, NCIR  
         ANG( K ) = 2.0D0 * PI * DBLE( K ) / DBLE( NCIR )
      END DO

C     Look for the total number of modes
C     and split all the intervals

C     First check for the branch points

      BPC( 1 ) = CICR( CPB )
      BPC( 2 ) = CICR( CSB )
      BPC( 3 ) = CWAT
      BPC( 4 ) = CICR( CPT )
      BPC( 5 ) = CICR( CST )
      NBPC = 5
      
      CL = MIN( CMINI * 0.9, CLOW )
      CH = MAX( CMAXI * 1.1, CHIGH )
      
c      write(*,*) 'Cmini, Cmaxi :', CMINI, CMAXI
                       
      CALL PKSORT( NBPC, BPC )

C     Check for the number of roots inside the specified 
C     interval CLOW CHIGH

       VBP( 1 ) = MIN( CMINI * 0.9, CLOW )
       VBP( 2 ) = CWAT
       VBP( 3 ) = MAX( CMAXI * 1.1, CHIGH )
       NVBP = 3
       
C     Loop to get an approximation of the number of modes
C     between intermediate points defined by vector VBP

      DO K = 1, NVBP - 1

         NBZ( K ) = 1

         IF ( ( VBP(K) .LT. CWAT ) .AND. ( NMEDIA .GE. 2 ) 
     &      .AND. ( CMINI .NE. CSB )  .AND. ( CSMIN .GT. 0.0 ))  THEN
           NBZ( K ) = INT( 2 * ( HENS - HEAU ) * FREQ / CMINI *
     &       SQRT( 1 - CMINI * CMINI / VBP( K + 1 ) / VBP( K + 1 ) ) )
         ENDIF

         IF ( VBP( K ) .GE. CWAT ) THEN
           NBZ( K ) = INT( 2 * HEAU * FREQ / CWAT *
     &       SQRT( 1 - CWAT * CWAT / VBP( K + 1 ) / VBP( K + 1 ) ) )
         ENDIF
c         write(*,*) NBZ( K )
      END DO 

C     If there is too many modes inside one contour split
C     intervals to get less modes inside

      NVITINT = 0

      DO I = 1, NVBP - 1
 
         IF ( NBZ( I ) .GT. MXINTMOD )  THEN
            IF ( VBP( I ) .GE. CWAT ) CREF = CWAT
            IF ( VBP( I ) .LT. CWAT ) CREF = CMINI

            NINTER = NINT( REAL( NBZ( I ) ) / MXINTMOD )
            IF ( NINTER .EQ. 1 ) NINTER = 2
c            write(*,*) 'Ninter:', NINTER
            TMN = ASIN( CREF / VBP( I + 1 ) )
c            write(*,*) 'Tmn :', TMN
            IF ( VBP( I ) .LE. CREF ) THEN
               TMX = PI / 2.0D0
            ELSE
               TMX = ASIN( CREF / VBP( I     ) )
            END IF
c     write(*,*) 'Tmx :', TMX   
            DTM = ( TMX - TMN ) / NINTER
            DO J = 1, NINTER - 1    
               NVITINT = NVITINT + 1
               VITINT( NVITINT ) = CREF / SIN(TMX - DTM*J)
c     write(*,*) 'vint:', VITINT(NVITINT)
            END DO
         ENDIF
      END DO
       
      VITINT( NVITINT +  1 ) = CICR( CPB )
      VITINT( NVITINT +  2 ) = CICR( CSB )
      VITINT( NVITINT +  3 ) = CICR( CPT ) 
      VITINT( NVITINT +  4 ) = CICR( CST ) 
      VITINT( NVITINT +  5 ) = CWAT 
      VITINT( NVITINT +  6 ) = CWAT * 0.99

      NT = NVITINT + 6
       
C     Now get all the intervalls where we are going to use a contour
C     between CLOW and CHIGH

      CBP( 1 ) = CLOW
      J = 1
      DO I = 1, NT
         IF ( ( VITINT( I ) .GT. CLOW ) .AND.
     &        ( VITINT( I ) .LT. CHIGH ) ) THEN
            J = J + 1
            CBP( J ) = VITINT( I )
         ENDIF
      END DO
      CBP( J + 1 ) = CHIGH
      
      NT = J + 1
       
      CALL PKSORT( NT, CBP )

      DO K = 1, NT
         KBP( K ) = OMEGA / CBP( K )
      END DO  


C      End for the process of initialization for the first mesh

       
C      Maximum value for the attenuation of a mode
        
       ALPHAM = 40.0 / 8.69 / RMIN / 1000.0
c        write(*,*) ' CIMX, ALPHAM :', CIMX, ALPHAM

C      Initialization of the total number of modes

       NMODE = 0

       DO K = 1, NT - 1

c         write(*,*) '************************************************'
         
         KBP1 = KBP( K )
         KBP2 = KBP( K + 1 )

         CALL ZONE( RAY, CENT, KBP1, KBP2, ALPHAM, MLT, OMEGA, U )

         CALL RESZONE( MLT, CENT, RAY, U, NCER, NCIR, ANG, FLAGRES,
     &        NBZP, SOL, NMODE, MXCER, MAXM )

         IF ( FLAGRES ) THEN
            
            ZINT = INT( NBZP / MXINTMOD )
c            write(*,*) 'Zint :', ZINT
            KBPINC = ( KBP( K + 1 ) - KBP( K ) ) / DBLE( ZINT )

            DO KK = 1, ZINT
c               write(*,*) '****************************************'
               KBP1 = KBP( K ) +  DBLE( KK - 1 ) * KBPINC
               KBP2 = KBP( K ) +  DBLE( KK ) * KBPINC
               CALL ZONE( RAY, CENT, KBP1, KBP2, ALPHAM, MLT, OMEGA, U )
               CALL RESZONE( MLT, CENT, RAY, U, NCER, NCIR, ANG,
     &              FLAGRES, NBZP, SOL, NMODE, MXCER, MAXM )
            END DO
         ENDIF         
      END DO
        
      M = NMODE

      CALL ZPKSORT( M, SOL )
         
      NMP = 0 
      DO I = 1, M
         IF (SOL( I ) .NE. (0.0,0.0)) THEN
            NMP = NMP + 1
            EVMAT( ISET, NMP ) = SOL( I )           
         ENDIF
c         write(*,*)'Sol:', I, OMEGA/REAL(SQRT(SOL(I)))  
      END DO
      M = NMP
c     write(*,*) 'Total number of modes : ', M                  
      
      RETURN
      END 
      
C**********************************************************************
      SUBROUTINE ZONE( RAY, CENT, KBP1, KBP2, ALPHAM, MLT, OMEGA, U )

      INTEGER*4 MLT
      REAL*8 RAY, RAY1, RAY2, C1, C2, OMEGA, TAILLCER
      REAL*8 KBP1, KBP2, ALPHAM, U
      COMPLEX*16 CENT

      TAILLCER = 0.9999999D0
 
      CENT = KBP1 - ( KBP1 - KBP2 ) / 2.0D0
      RAY  = ( KBP1 - KBP2 ) / 2.0D0 * TAILLCER

      RAY1 = CENT + RAY
      RAY2 = CENT - RAY

      C1 = OMEGA / RAY1
      C2 = OMEGA / RAY2

      U = 2.0D0 * RAY
         
      IF ( ALPHAM .GE. U ) THEN
         MLT = INT( ALPHAM / U )
c         write(*,*) 'MLt * : ', MLT
      ELSE
         MLT = 1
c         write(*,*) 'MLt \ : ', MLT
      ENDIF

c      write(*,*) 'Vit ex:', C1, C2
        
      RETURN
      END         
C************************************************************************
      SUBROUTINE RESZONE( MLT, CENT, RAY, U, NCER, NCIR, ANG, FLAGRES,
     &     NBZP, SOL, NMODE, MXCER, MAXM )
       
      PARAMETER( MXCER = 20000 )
      INTEGER*4 MLT, NCER, NCIR, IRECT, NBZP, NMODE, NRECT
      INTEGER*4 REP( 5 ), IPOW, NBZPC, NPM
      REAL*8 U, ANG( MXCER ), DR( 2 ), RAY
      COMPLEX*16 SOL( MAXM ), T( MXCER ), FY( MXCER ), FYC( MXCER )
      COMPLEX*16 DELTA, X, CENT, SOLP( 30 ), CI
      LOGICAL FLAGRES        
       
      FLAGRES = .FALSE.

      CI = (0.0D0, 1.0D0 )
       
      DO IRECT = 1, MLT
         
         IF ( IRECT .GT. 1 ) THEN         
            CENT = CENT - CI * U
         ENDIF

         CALL RECT( T, REP, DR, CENT, U, U, NCER )

C        Total number of points used to discretize the rectangle

         NRECT  = REP( 5 )
c         write(*,*) 'NRECT : ',NRECT
c         write(*,*)'Nmode2 :',NMODE

C        Determination of the values of the function along the contour

         DO I = 1, NRECT
            X = T( I ) * T( I )
            CALL FUNCTZ( X , DELTA, IPOW, CENT )
            FY( I ) = DELTA * 10.0D0**IPOW
         END DO

         CALL FNBZEROS( NBZP, FY, NRECT)

c         write(*,*) 'Nbzp : ', NBZP
         
         IF ( NBZP .EQ. 0 ) RETURN

         IF ( NBZP .GT. 15 ) THEN
            FLAGRES = .TRUE.
            RETURN
         ENDIF

         DO I = 1, NCIR
            X = EXP( CI * ANG( I ) ) * RAY + CENT
c            write(*,*)'X : ',X
            X = X * X
            CALL FUNCTZ( X, DELTA, IPOW, CENT )
            FYC( I ) = DELTA * 10.0D0**IPOW
c            write(*,*)'FYC :',FYC(I)
         END DO 
                       
         CALL FNBZEROSC( NBZPC, FYC, NCIR)
           
c             write(*,*) 'CENT : ', CENT
c         write(*,*) 'Nbzp, Nbzpc : ', NBZP,NBZPC
          
         IF ( NBZPC .EQ. NBZP ) THEN
c            write(*,*) 'Cercle'
            CALL FSOLANA( SOLP, ANG, FYC, RAY, CENT, NBZPC, NCIR )
         ELSE
c            write(*,*) 'Rectangle'
            CALL FSOLREC( SOLP, T, FY, REP, CENT, NBZP, NRECT, DR )
         ENDIF

         DO NPM = 1, NBZP
            NMODE = NMODE + 1
            SOL( NMODE ) = SOLP( NPM ) ** 2
c               PIM = ABS( DIMAG( CDSQRT( SOL( NMODE ) ) ) )
c               ALPHAMAX = MAX( ALPHAMAX, PIM )
c            write(*,*) 'Mode:', CDSQRT( SOL( NMODE ) )       
         END DO
           
      END DO
      RETURN
      END
        
       

      SUBROUTINE IRCINT( X, F, G, IPOW, XTAB, FTAB, GTAB, ITAB, NKPTS )

C     Internal reflection coefficient interpolator

C     Returns F,G,IPOW for given X using tabulated values

C     Uses polynomial interpolation using the two nearest abscissas

      PARAMETER ( MAXN = 10 )

      IMPLICIT REAL*8 (A-H, O-Z)

      INTEGER ITAB(*)
      REAL*8 XTAB(*)
      COMPLEX*16 FTAB(*), GTAB(*), XT(MAXN), FT(MAXN), GT(MAXN),
     &   PZ, X, F, G

      TEN = 10.0
      XR = DBLE( X )
      ILEFT = 1
      IRIGHT = NKPTS

C     Three cases: X left, in, or right of tabulated interval

      IF ( XR .LT. XTAB( ILEFT ) ) THEN
         F    = FTAB( ILEFT )
         G    = GTAB( ILEFT )
         IPOW = ITAB( ILEFT )
      ELSE IF( XR .GT. XTAB( IRIGHT ) ) THEN
         F    = FTAB( IRIGHT )
         G    = GTAB( IRIGHT )
         IPOW = ITAB( IRIGHT )
      ELSE 

C        Search for bracketting abscissas:
C        Log base 2 (NPTS) stabs required for a bracket

C        ------ DO WHILE ...
 1000    IF ( ILEFT .NE. IRIGHT-1 ) THEN
            IMID = ( ILEFT + IRIGHT )/2
            IF ( XTAB( IMID ) .GT. XR ) THEN
               IRIGHT = IMID
            ELSE
               ILEFT = IMID
            ENDIF
         GOTO 1000
         ENDIF

C        Extract the subset for interpolation and scale

         N = 3
         ILEFT = MAX( ILEFT - (N-2)/2, 1 )
         IRIGHT = MIN( IRIGHT + (N-1)/2, NKPTS )

         N = IRIGHT - ILEFT + 1
         DO 2000 I = 1, N
            J = I + ILEFT-1
            IDEL = ITAB( J ) - ITAB( ILEFT )
            XT( I ) = XTAB( J )
            FT( I ) = FTAB( J )*TEN**IDEL
            GT( I ) = GTAB( J )*TEN**IDEL
 2000    CONTINUE

C        Construct the interpolate

         F    = PZ( X, XT, FT, N )
         G    = PZ( X, XT, GT, N )
         IPOW = ITAB( ILEFT )
      ENDIF

      RETURN
      END

      SUBROUTINE CHOLESKI( A, NACT, N )

C     Factors A= L L* using Choleski's method
C     This only works if A is positive definite and hermitian

C     MICHAEL B. PORTER 12/25/92

C     NACT = ACTUAL ROW DIMENSION OF A
C     N    = SIZE OF THE SYSTEM

C     This implementation is not the most efficient
C     Some loops should be rearranged

      IMPLICIT NONE
      INTEGER I, J, K, NACT, N
      COMPLEX A( NACT, N ), T

C ******************************************************
C FORWARD ELIMINATION
C ******************************************************

      DO K = 1, N - 1

C        *** SUBTRACT MULTIPLE OF ROW K FROM ROWS K+1 TO N ***

         DO I = K + 1, N

            DO J = I, N
               A( I, J ) = A( I, J ) -
     &         CONJG( A( K, I ) ) * A( K, J ) / A( K, K )
            END DO

         END DO

C        *** Divide row K by sqrt of diagonal elt ***

         IF ( AIMAG( A( K, K ) ) .NE. 0.0 .OR. 
     &         REAL( A( K, K ) ) .LE. 0.0 ) THEN

              WRITE( *, * )
     &           'Matrix not positive definite: Choleski fails'
              STOP
         ENDIF

         T = 1.0 / SQRT( A( K, K ) )

         DO J = K, N
            A( K, J ) = T * A( K, J )
         END DO
      END DO

C     -----------------------------

      IF ( AIMAG( A( N, N ) ) .NE. 0.0 .OR. 
     &      REAL( A( N, N ) ) .LE. 0.0 ) THEN
           WRITE( *, * )
     &        'Matrix not suitable for Choleski decompostion'
C           STOP
      ENDIF

      A( N, N ) = SQRT( A( N, N ) )

      RETURN
      END

C----------------------------------------------------------------------C

      SUBROUTINE BACKSUB( A, B, NACT, N )

      IMPLICIT NONE
      INTEGER I, J, NACT, N
      COMPLEX A( NACT, N ), B( N ), T

C ******************************************************
C FORWARD-SUBSTITUTION
C ******************************************************

      B( 1 ) = B( 1 ) / A( 1, 1 )

      DO I = 2, N
         T = 0.0
         DO J = 1, I - 1
            T = T + CONJG( A( J, I ) ) * B( J )  ! a(i,j)=a(j,i)*
         END DO
         B( I  ) = ( B( I ) - T ) / A( I, I )
      END DO

C *******************************************
C BACK-SUBSTITUTION
C *******************************************

      B( N ) = B( N ) / A( N, N )

      DO I = N - 1, 1, -1
         T = 0.0
         DO J = I + 1, N
            T = T + A( I, J ) * B( J )
         END DO
         B( I )=( B( I ) - T ) / A( I, I )
      END DO

      RETURN
      END

      PROGRAM PLTTLD

C     Plot transmission loss versus depth

C     This module should be modified to use less storage
C     Specifically, there is no need for PHIR(MAXM, MAXNZ)

      INTEGER PLPFIL, PRTFIL, STAFIL
      PARAMETER ( PLPFIL = 1, PRTFIL = 6, STAFIL = 10,
     &   MAXNZ = 251, MAXM = 1500 )

      REAL RD( MAXNZ ), RR( MAXNZ), TL( MAXNZ )
      COMPLEX CK( MAXM ), PHIS( MAXM ), PHIR( MAXM, MAXNZ ), P( MAXNZ )
      CHARACTER OPT*50, TITLE*80, COMP*1

C     Read in user parameters

      OPEN( FILE = 'PLPFIL', UNIT = PLPFIL, STATUS = 'OLD' )
      READ( PLPFIL, * ) OPT
      READ( PLPFIL, * ) M
      READ( PLPFIL, * ) SD
      READ( PLPFIL, * ) R

C     Read receiver depths

      RD( 3 ) = -999.9
      READ( PLPFIL, * ) NRD, ( RD( IR ), IR = 1, NRD )

      IF ( NRD .GT. MAXNZ ) THEN
         WRITE( PRTFIL, * ) 'NRD, MAXNZ = ', NRD, MAXNZ
         CALL ERROUT( PRTFIL, 'F', 'PLOTTLR', 'Too many receivers'  )
      ENDIF

      CALL SUBTAB( RD, NRD )

C     Set receiver displacements to zero

      RR( 1 ) = 0.0
      RR( 2 ) = 0.0
      RR( 3 ) = -999.9
      CALL SUBTAB( RR, NRD )

C     *** Read in modes ***

      COMP  = OPT(3:3)
      IPROF = 1
      NSD   = 1

      CALL GETMOD( IPROF, ' ', MAXM, SD, NSD,  'N',
     &   CK, PHIS, M1, FREQ, TITLE )

      CALL GETMOD( IPROF, ' ', MAXM, RD, NRD, COMP,
     &   CK, PHIR, M1, FREQ, TITLE )

      M = MIN( M, M1 )

C     *** Compute the field ***

      RM = 1000.0 * R
      NR = 1
      CALL EVAL( PHIS, PHIR, NRD, RM, NR, RR, CK, M, OPT, P )

C     Write pressure to STAFIL

      WRITE( STAFIL, * ) ( P( IR ), IR = 1, NRD )

      DO IR = 1, NRD
         PSQ = P( IR ) * CONJG( P( IR ) )
         TL( IR ) = 200.0
         IF ( PSQ .GT. 1.0E-20 ) TL( IR ) = -10.0 * ALOG10( PSQ )
      END DO

C     *** Write data ***

      LAST = INDEX( TITLE, '    ' ) - 1
      WRITE( PRTFIL, 1000 ) TITLE(1:LAST)
 1000 FORMAT( '@ title "', A, '"' )

      WRITE( PRTFIL, 2000 ) NINT( FREQ ), NINT( SD ), NINT( R )
 2000 FORMAT(  '@ subtitle "',
     &         'F  =', I4, ' Hz, ',
     &         'Sd =', I4, ' m,  ',
     &         'Rd =', I4, ' m"' )
 
      DO IRD = 1, NRD
         WRITE( PRTFIL, * ) RD( IRD ), TL( IRD ) 
      END DO

      STOP
      END
